#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "2e7432b299d4ba499027a17319654f4bcd9372c2";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "parser";
Object module_standardGrace_init();
static char *originalSourceLines[] = {
  "#pragma ExtendedLineups",
  "import \"io\" as io",
  "import \"ast\" as ast",
  "import \"util\" as util",
  "import \"errormessages\" as errormessages",
  "",
  "var blankLocation := 0",
  "var lastLine := 0",
  "var lastIndent := 0",
  "var indentFreePass := false",
  "var minIndentLevel := 0",
  "var statementIndent := 0",
  "var tokens := false",
  "var values := [ ]",
  "var moduleObject",
  "var comments := emptyList   // so we can request `removeAt`",
  "var auto_count := 0",
  "def noBlocks = false",
  "def blocksOK = true",
  "var braceIsType := false",
  "",
  "// sym is a module-level field containing the current token",
  "var sym := object {",
  "    def kind is public = \"start\"",
  "    def line is public = 0",
  "    def linePos is public = 0",
  "    def indent is public = 0",
  "    def value is public = \"\"",
  "    def size is public = 0",
  "}",
  "",
  "var lastToken := sym",
  "var previousCommentToken := lastToken",
  "var statementToken := lastToken     // the token starting the current statement",
  "var comment := false",
  "",
  "method noteBlank {",
  "    blankLocation := sym.line - 1",
  "}",
  "",
  "var firstCallOfNext := true",
  "",
  "method next {",
  "    // Advance to the next token in the stream, assigning it to sym.",
  "    // Put the position in the input into util module variables.",
  "",
  "    if (tokens.size > 0) then {",
  "        lastToken := sym",
  "        lastLine := lastToken.line",
  "        lastIndent := lastToken.indent",
  "        sym := tokens.poll",
  "        if (sym.line > (lastLine + 1)) then { noteBlank }",
  "        pushComments",
  "        util.setPosition(sym.line, sym.linePos)",
  "    } else {",
  "        errormessages.syntaxError(\"unexpectedly found the end of the input. \" ",
  "            ++ \"This is often caused by a missing '\\}'\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "    }",
  "}",
  "",
  "",
  "method findNextToken(tokenMatcher) {",
  "    // Search for the next token for which the given block returns true.",
  "    // Used for generating suggestions.",
  "",
  "    if (tokenMatcher.apply(sym)) then {",
  "        return sym",
  "    }",
  "    var nextTok := false",
  "    var n := sym",
  "    while {(false != n) && { false == nextTok } && { n.indent >= lastToken.indent }} do {",
  "        if(tokenMatcher.apply(n)) then {",
  "            nextTok := n",
  "        }",
  "        n := n.next",
  "    }",
  "    nextTok",
  "}",
  "",
  "method findNextTokenIndentedAt(tok) {",
  "    if(((sym.line > tok.line) && (sym.indent <= tok.indent)) || (sym.kind == \"eof\")) then {",
  "        return sym",
  "    }",
  "    var nextTok := false",
  "    var n := sym",
  "    while {(false != n) && { false == nextTok }} do {",
  "        if(((n.line > tok.line) && (n.indent <= tok.indent)) || (sym.kind == \"eof\")) then {",
  "            nextTok := n",
  "        }",
  "        n := n.next",
  "    }",
  "    nextTok",
  "}",
  "",
  "method findNextValidToken(validFollowTokens) {",
  "    // Tokens that cannot start an expression.",
  "    def invalidTokens = set [\"dot\", \"comma\", \"colon\", \"rparen\",",
  "            \"rbrace\", \"rsquare\", \"arrow\", \"bind\"];",
  "    var validToken := sym",
  "    while {validToken.kind != \"eof\"} do {",
  "        // If the token is a valid follow token, then return that token.",
  "        if(validFollowTokens.contains(validToken.kind)) then {",
  "            return validToken",
  "        }",
  "        // If the token is not an invalid token for starting an expression, return that token.",
  "        if(!invalidTokens.contains(validToken.kind)) then {",
  "            return validToken",
  "        }",
  "        // The token is invalid, go to the next one.",
  "        validToken := validToken.next",
  "    }",
  "    return validToken",
  "}",
  "",
  "// Finds the closing brace for token (that is the beginning of a control",
  "// structure) -- an opening brace. Returns an object with two fields: found",
  "// and tok. If a closing brace is found, found is set to true, and tok is set to",
  "// the closing brace. Otherwise found is set to false, and tok is set to the",
  "// token that the closing brace should appear after.",
  "method findClosingBrace(token, inserted) {",
  "    var n := sym",
  "    var numOpening := if(inserted) then {1} else {0}",
  "    var numClosing := 0",
  "    def result = object {",
  "        var found is public",
  "        var tok is public",
  "    }",
  "    // Skip all tokens on the same line first.",
  "    while {(n.kind != \"eof\") && (n.line == token.line)} do {",
  "        if(n.kind == \"lbrace\") then { numOpening := numOpening + 1 }",
  "        elseif { n.kind == \"rbrace\" } then { numClosing := numClosing + 1 }",
  "        n := n.next",
  "    }",
  "    // Skip all tokens that have greater indent than the target closing brace.",
  "    while {(n.kind != \"eof\") && (n.indent > token.indent)} do {",
  "        if (n.kind == \"lbrace\") then {",
  "            numOpening := numOpening + 1",
  "        } elseif { n.kind == \"rbrace\" } then {",
  "            numClosing := numClosing + 1 ",
  "        }",
  "        n := n.next",
  "    }",
  "    if (n.kind == \"rbrace\") then {",
  "        result.found := true",
  "        result.tok := n",
  "    } elseif {(n.prev.kind == \"rbrace\") && (numOpening == numClosing)} then {",
  "        // Check that the number of opening and closing braces matches.",
  "        result.found := true",
  "        result.tok := n.prev",
  "    } else {",
  "        result.found := false",
  "        result.tok := n.prev",
  "    }",
  "    result",
  "}",
  "",
  "",
  "method accept(t) {",
  "    // True if the current token has kind t, where",
  "    // t is \"num\", \"string\", \"method\", etc.",
  "    sym.kind == t",
  "}",
  "",
  "method acceptKeyword (kw) {",
  "    if (sym.kind != \"keyword\") then { return false }",
  "    return sym.value == kw",
  "}",
  "",
  "method acceptSameLine (t) {",
  "    // True if the current token is a t, and it is on the same logical",
  "    // line (either because it's on the same physical line, or because",
  "    // it's on an indented continuation line).",
  "",
  "    (sym.kind == t) && ",
  "        ((lastLine == sym.line) || (sym.indent > lastIndent))",
  "}",
  "method acceptWithoutSpaces (t) {",
  "    // True if the current token is a t, and follows the previous token",
  "    // without any intervening spaces or continuation lines.",
  "",
  "    (sym.kind == t) && ",
  "        (lastLine == sym.line) && (sym.linePos == (lastToken.linePos + lastToken.size))",
  "}",
  "method acceptAfterSpaces (t) {",
  "    // True if the current token is a t, and is separated from the previous token",
  "    // by one or more spaces, or a continuation line.",
  "",
  "    if (sym.kind != t) then { return false }",
  "    if (lastLine == sym.line) then {",
  "        return sym.linePos != (lastToken.linePos + lastToken.size)",
  "    }",
  "    return sym.linePos == (sym.indent + 1)",
  "}",
  "method accept (t) onLineOf (other) {",
  "    // True if the current token is a t, and it is on the same logical",
  "    // line as other (either because it's on the same physical",
  "    // line, or because it's on an indented continuation line).",
  "    (sym.kind == t) && ((other.line == sym.line) ||",
  "        (sym.indent > other.indent))",
  "}",
  "method acceptAfterSpaces (t) onLineOf (other) {",
  "    // True if the current token is a t, is on the same logical line as other,",
  "    // and is separated from the previous token by one or more spaces, ",
  "    // or a continuation line.",
  "",
  "    if (sym.kind != t) then { return false }",
  "    if (sym.line == other.line) then {",
  "        return sym.linePos != (lastToken.linePos + lastToken.size)",
  "    } else {",
  "        return sym.linePos == (sym.indent + 1)",
  "    }",
  "}",
  "method accept (t) onLineOfLastOr (other) {",
  "    // True if the current token is a t, and it is on the same logical",
  "    // line as the last token, or the other token.",
  "    (sym.kind == t) && (((other.line == sym.line) ||",
  "        (sym.indent > other.indent)) || (lastToken.line == sym.line))",
  "}",
  "method acceptArgumentOnLineOf(tok) {",
  "    // True if the current token can start an argument to a request",
  "    if (accept \"string\" onLineOf(tok)) then { return true }",
  "    if (accept \"num\" onLineOf(tok)) then { return true }",
  "    if (accept \"lbrace\" onLineOf(tok)) then { return true }",
  "    if (acceptAfterSpaces \"lsquare\" onLineOf(tok)) then { return true }",
  "    if (accept \"identifier\" onLineOf(tok)) then { ",
  "        return (sym.value == \"true\") || (sym.value == \"false\")",
  "    }",
  "    return false",
  "}",
  "method tokenOnSameLine {",
  "    // True if there is a token on the current logical line",
  "    (lastLine == sym.line) || (sym.indent > lastIndent)",
  "}",
  "method didConsume(aParsingBlock) {",
  "    // True if executing aParsingBlock consumes at least one token.",
  "    var sz := tokens.size",
  "    aParsingBlock.apply",
  "    tokens.size != sz",
  "}",
  "method ifConsume(ablock)then(tblock) {",
  "    // If ablock consumes at least one token, execute tblock.",
  "    var sz := tokens.size",
  "    ablock.apply",
  "    if (tokens.size != sz) then {",
  "        tblock.apply",
  "    }",
  "}",
  "",
  "// Push the current token onto the output stack as a number",
  "method pushnum {",
  "    var o := ast.numNode.new(sym.value)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "// Push the current token onto the output stack as a string",
  "method pushstring {",
  "    var o := ast.stringNode.new(sym.value)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "// Push the current token onto the output stack as an identifier.",
  "// false means that this identifier has not been assigned a dtype (yet).",
  "method pushidentifier {",
  "    util.setPosition(sym.line, sym.linePos)",
  "    var o := ast.identifierNode.new(sym.value, false)",
  "    if (o.value == \"_\") then {",
  "        o.value := \"__\" ++ auto_count",
  "        o.wildcard := true",
  "        auto_count := auto_count + 1",
  "    }",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "method checkAnnotation(ann) {",
  "    if (ann.kind == \"call\") then {",
  "        for (ann.with) do {p->",
  "            for (p.args) do {a->",
  "                if ((a.kind == \"identifier\") && {false != a.dtype}) then {",
  "                    var tok := sym",
  "                    // Look back from the current token to try and find the tokens that cause this error.",
  "                    while {tok.value != \":\"} do { tok := tok.prev }",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(tok, tok.next)leading(true)trailing(false)",
  "                    errormessages.syntaxError(\"an argument to an annotation cannot have a type.\")atRange(",
  "                        tok.line, tok.linePos, tok.next.linePos + tok.next.size - 1)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "    }",
  "    ann",
  "}",
  "method doannotation {",
  "    if (acceptKeyword \"is\" .not) then {",
  "        return false",
  "    }",
  "    next",
  "    def anns = [ ]",
  "    if(didConsume({expression(noBlocks)}).not) then {",
  "        def suggestions = [ ]",
  "        var suggestion := errormessages.suggestion.new",
  "        def nextTok = findNextValidToken( [\"bind\"] )",
  "        if(nextTok == sym) then {",
  "            suggestion.insert(\" «annotation»\")afterToken(lastToken)",
  "        } else {",
  "            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «annotation»\")",
  "        }",
  "        suggestions.push(suggestion)",
  "        suggestion := errormessages.suggestion.new",
  "        suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "        suggestions.push(suggestion)",
  "        errormessages.syntaxError(\"one or more annotations separated by commas must follow 'is'.\")",
  "            atRange(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "            withSuggestions(suggestions)",
  "    }",
  "    while {accept(\"comma\")} do {",
  "        anns.push(checkAnnotation(values.pop))",
  "        next",
  "        if(didConsume({expression(noBlocks)}).not) then {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"bind\"] )",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\" «annotation»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «annotation»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"one or more annotations separated by commas must follow 'is'.\")",
  "                atRange(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                withSuggestions(suggestions)",
  "        }",
  "    }",
  "    anns.push(checkAnnotation(values.pop))",
  "    anns",
  "}",
  "",
  "method blank {",
  "    if (blankLocation == 0) then {",
  "        if ( sym.line <= (lastToken.line + 1) ) then { return }",
  "        if ( sym.line <= (previousCommentToken.line + 1) ) then { return }",
  "    }",
  "    pushComments",
  "    if ((values.size == 0) || ",
  "            ((values.size > 0) && { values.last.kind != \"blank\" })) then {",
  "        if (blankLocation > 0) then {",
  "            util.setPosition(blankLocation, 0)",
  "            blankLocation := 0",
  "        } else {",
  "            util.setPosition(sym.line - 1, 0)",
  "        }",
  "        values.push(ast.blankNode.new)",
  "    }",
  "}",
  "",
  "method dotypeterm {",
  "    if (accept \"identifier\") then {",
  "        pushidentifier",
  "        generic",
  "        dotrest(noBlocks)",
  "    } else {",
  "        if (acceptKeyword \"type\") then {",
  "            dotypeLiteral",
  "        }",
  "    }",
  "}",
  "",
  "method typeexpression {",
  "    var sz := values.size",
  "    if (accept \"lparen\") then {",
  "        def prevStatementToken = statementToken",
  "        statementToken := sym",
  "        next",
  "        if(didConsume({typeexpression}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rparen\"] )",
  "            if (nextTok == sym) then {",
  "                suggestion.insert(\"«type expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev) leading (true)",
  "                    trailing(false) with \"«type expression»\"",
  "            }",
  "            errormessages.syntaxError \"parentheses must contain a valid type expression.\"",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError \"a type expression beginning with a '(' must end with a ')'.\"",
  "                atRange(lastToken.line, lastToken.linePos + lastToken.size)",
  "                withSuggestion(suggestion)",
  "        }",
  "        statementToken := prevStatementToken",
  "        next",
  "    } else {",
  "        dotypeterm",
  "    }",
  "    if (values.size > sz) then {",
  "        dotrest(noBlocks)",
  "        typeexpressionrest",
  "    }",
  "    // TODO: check that the expression doesn't contain requests or var references.",
  "    // This has to happen in the identifier resolution phase.",
  "}",
  "",
  "method newIf(cond, thenList, elseList) {",
  "    def thenBlock = ast.blockNode.new(emptySequence, thenList)",
  "    def elseBlock = ast.blockNode.new(emptySequence, elseList)",
  "    ast.ifNode.new(cond, thenBlock, elseBlock)",
  "}",
  "",
  "method block {",
  "    // parse a block",
  "    if (accept \"lbrace\") then {",
  "        def btok = sym",
  "        next",
  "        var minInd := statementIndent + 2",
  "        var startIndent := statementIndent",
  "        var expr1",
  "        var s := sym",
  "        var tmp",
  "        var params := [ ]",
  "        var body := [ ]",
  "        var havearrow := true",
  "        var found := false",
  "        var i := 0",
  "        var isMatchingBlock := false",
  "        statementToken := sym",
  "        if (sym.kind == \"lparen\") then {",
  "            isMatchingBlock := true",
  "        }",
  "        // Parsing the expression ‹(a)› will return an identifierNode‹a› .",
  "        // The paren lets us distinguish parameter ‹a› from pattern ‹(a)› .",
  "        ifConsume {expression(blocksOK)} then {",
  "            if (accept(\"comma\") || accept(\"arrow\") || accept(\"colon\")) then {",
  "                // This block has parameters or patterns",
  "                expr1 := values.pop",
  "                if (accept \"colon\") then {",
  "                    // We allow an expression here for the case of v : T",
  "                    // patterns, where T may be \"Pair(hd, tl)\" or similar.",
  "                    next",
  "                    braceIsType := true",
  "                    if(didConsume({expression(blocksOK)}).not) then {",
  "                        def suggestions = [ ]",
  "                        var suggestion := errormessages.suggestion.new",
  "                        def nextTok = findNextValidToken( [\"arrow\", \"rbrace\"] )",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                        }",
  "                        suggestions.push(suggestion)",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                        suggestions.push(suggestion)",
  "                        errormessages.syntaxError(\"a block must have an expression after the ':'.\")",
  "                            atPosition(sym.line, sym.linePos)",
  "                            withSuggestions(suggestions)",
  "                    }",
  "                    braceIsType := false",
  "                    expr1.dtype := values.pop",
  "                }",
  "                params.push(expr1)",
  "                if (isMatchingBlock.not && expr1.isIdentifier) then {",
  "                    expr1.isBindingOccurrence := true",
  "                } else {",
  "                    isMatchingBlock := true",
  "                }",
  "                if (isMatchingBlock && {accept(\"comma\")}) then {",
  "                    def suggestions = [ ]",
  "                    var suggestion",
  "                    def arrow = findNextToken({ t -> t.kind == \"arrow\" })",
  "                    if(false != arrow) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(sym, arrow.prev)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.replaceToken(sym)leading(true)trailing(false)with(\" |\")",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a matching block may only have one parameter.\")atRange(",
  "                        sym.line, sym.linePos, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                while {accept(\"comma\")} do {",
  "                    // Keep doing the above for the rest of the parameters.",
  "                    next",
  "                    pushidentifier",
  "                    expr1 := values.pop",
  "                    expr1.isBindingOccurrence := true",
  "                    expr1.dtype := optionalTypeAnnotation",
  "                    params.push(expr1)",
  "                }",
  "                if ((accept(\"arrow\")).not) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if((sym.kind == \"bind\") || (sym.value == \"=\")) then {",
  "                        suggestion.replaceToken(sym)with(\"->\")",
  "                    } else {",
  "                        suggestion.insert(\" ->\")afterToken(lastToken)",
  "                    }",
  "                    errormessages.syntaxError(\"a block must have one or more parameters followed by '->' and an expression.\")",
  "                        atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "                }",
  "                next",
  "            } elseif { accept \"semicolon\" } then {",
  "                body.push(values.pop)",
  "                next",
  "                if (accept \"semicolon\") then {",
  "                    next",
  "                    if (sym.line == lastToken.line) then {",
  "                        indentFreePass := true",
  "                    }",
  "                }",
  "            } elseif { ((values.last.kind == \"member\")",
  "                        || (values.last.kind == \"identifier\")",
  "                        || (values.last.kind == \"index\"))",
  "                        && accept(\"bind\") } then {",
  "                var lhs := values.pop",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = [ ]",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rbrace\"] )",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a valid expression must follow ':='.\")",
  "                        atPosition(sym.line, sym.linePos) withSuggestions(suggestions)",
  "                }",
  "                var rhs := values.pop",
  "                util.setPosition(btok.line, btok.linePos)",
  "                body.push(ast.bindNode.new(lhs, rhs))",
  "                if (accept \"semicolon\") then {",
  "                    next",
  "                    if (sym.line == lastToken.line) then {",
  "                        indentFreePass := true",
  "                    }",
  "                }",
  "            } else {",
  "                checkUnexpectedTokenAfterStatement",
  "                body.push(values.pop)",
  "            }",
  "        }",
  "        if (accept \"arrow\") then {",
  "            next",
  "        }",
  "        if (sym.line == lastToken.line) then {",
  "            minIndentLevel := sym.linePos - 1",
  "        } else {",
  "            minIndentLevel := minInd",
  "        }",
  "        while {(accept(\"rbrace\")).not} do {",
  "            // Take the body of the block",
  "            if(didConsume({statement}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\"}\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"a block must end with a '}'.\")",
  "                    atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "            }",
  "            tmp := values.pop",
  "            body.push(tmp)",
  "        }",
  "        minIndentLevel := minInd - 2",
  "        statementIndent := startIndent",
  "        next",
  "        util.setPosition(btok.line, btok.linePos)",
  "        var o := ast.blockNode.new(params, body)",
  "        if (isMatchingBlock) then {",
  "            if (params.size > 0) then {",
  "                o.matchingPattern := params.first",
  "            }",
  "        }",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "// Accept an \"if\" statement. This is a special syntactic case, rather",
  "// than just a call with a multi-part method name - it might be possible",
  "// to change that and compensate later on.",
  "method doif {",
  "    if (accept(\"identifier\") && (sym.value == \"if\")) then {",
  "        def btok = sym",
  "        next",
  "        def opener = if ((sym.kind == \"lparen\") || {sym.kind == \"lbrace\"})",
  "                        then { sym.value } else { \"-missing-\" }",
  "        def closer = if (opener == \"(\") then { \")\" }",
  "                        else { if (opener == \"\\{\") then { \"\\}\" } else { \"-nothing-\" } }",
  "        if (opener == \"-missing-\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rparen or then.",
  "            def nextTok = findNextToken({ t -> (t.line == btok.line)",
  "                && ((t.kind == \"rparen\") || (t.kind == \"rbrace\") || (t.kind == \"lbrace\")",
  "                || ((t.kind == \"identifier\") && (t.value == \"then\"))) })",
  "            if (false == nextTok) then {",
  "                suggestion.insert(\" («condition») then \\{\")afterToken(btok)",
  "            } elseif { nextTok.kind == \"rparen\" } then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«condition»\")beforeToken(sym)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                }",
  "            } elseif { nextTok.kind == \"lbrace\" } then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" («condition») then\")afterToken(btok)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                    suggestion.insert(\") then\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                }",
  "            } elseif { nextTok.kind == \"identifier\" } then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«condition») \")beforeToken(sym)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                    suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                }",
  "            }",
  "            errormessages.syntaxError(\"an if statement must have a condition \" ++",
  "                \"in parentheses or braces after the 'if'.\")",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if (didConsume({expression(blocksOK)}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rparen.",
  "            var nextTok := findNextToken({ t -> (t.line == lastToken.line) && (t.kind == \"rparen\") })",
  "            if (false == nextTok) then {",
  "                nextTok := findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression») then \\{\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                          leading(true)trailing(false)with(\"«expression») then \\{\")",
  "                }",
  "                errormessages.syntaxError(\"an if statement must have a \" ++",
  "                      \"condition in parentheses or braces after the 'if'.\")",
  "                      atPosition(sym.line, sym.linePos)",
  "                      withSuggestion(suggestion)",
  "            } else {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"an if statement must have a \" ++",
  "                        \"condition in parentheses or braces after the 'if'.\")",
  "                        atPosition(sym.line, sym.linePos)",
  "                        withSuggestion(suggestion)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                        leading(false)trailing(true)with(\"«expression»\")",
  "                    errormessages.syntaxError(\"an if statement must have a \" ++",
  "                        \"condition in parentheses or braces after the 'if'.\")",
  "                        atRange(sym.line, sym.linePos, nextTok.linePos - 1)",
  "                        withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        if (sym.value != closer) then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"an expression beginning with a \"++",
  "                  \"'{opener}' must end with a '{closer}'.\")",
  "                  atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                  withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var cond := values.pop",
  "        var body := []",
  "",
  "        // These two are for else/elseif handling. elseif is turned into",
  "        // nested if statements for the AST, so curelse points to the",
  "        // most deeply-nested of those (where any eventual \"else\" block's",
  "        // statements will go). elseblock contains the statements of the",
  "        // top-level \"else\" block - if there are any elseifs, that",
  "        // consists of only one statement, another if.",
  "        var elseblock := []",
  "        var curelse := elseblock",
  "        var v",
  "        def localMin = minIndentLevel",
  "        def localStatementIndent = statementIndent",
  "        var minInd := statementIndent + 2",
  "        if (accept(\"identifier\") && (sym.value == \"then\")) then {",
  "            next",
  "            if(sym.kind != \"lbrace\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def closingBrace = findClosingBrace(btok, true)",
  "                if (closingBrace.found.not) then {",
  "                    if(closingBrace.tok == lastToken) then {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{}\")",
  "                    } else {",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                    }",
  "                } else {",
  "                    suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                }",
  "                errormessages.syntaxError(\"an if statement must have a '\\{' after the 'then'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "            if (sym.line == lastToken.line) then {",
  "                minIndentLevel := sym.linePos - 1",
  "            } else {",
  "                minIndentLevel := minInd",
  "            }",
  "            while {(accept(\"rbrace\")).not} do {",
  "                if(didConsume({statement}).not) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, false)",
  "                    if (closingBrace.found.not) then {",
  "                        if(closingBrace.tok == lastToken) then {",
  "                            suggestion.insert(\"}\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                        }",
  "                    }",
  "                    suggestion.deleteToken(sym)",
  "                    errormessages.syntaxError(\"an if statement must end with a '}'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                v := values.pop",
  "                body.push(v)",
  "            }",
  "            next",
  "            var econd",
  "            var eif",
  "            var newelse",
  "            var ebody",
  "            while {accept(\"identifier\") && (sym.value == \"elseif\")} do {",
  "                // Currently, the parser just accepts arbitrarily many",
  "                // \"elseifs\", turning them into ifs inside the else.",
  "                // TODO: allow blocks after elseif to contain a sequence of expressions.",
  "                statementToken := sym",
  "                next",
  "                if(sym.kind != \"lbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    // Look ahead for a rbrace or then.",
  "                    def nextTok = findNextToken({ t -> (t.line == statementToken.line)",
  "                        && ((t.kind == \"rbrace\") || (t.kind == \"lbrace\")",
  "                        || ((t.kind == \"identifier\") && (t.value == \"then\"))) })",
  "                    if(false == nextTok) then {",
  "                        suggestion.insert(\" \\{ «expression» \\} then \\{\")afterToken(statementToken)",
  "                    } elseif { nextTok.kind == \"rbrace\" } then {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"\\{ «expression» \\}\")beforeToken(sym)",
  "                        } else {",
  "                            suggestion.insert(\"\\{ \")beforeToken(sym)",
  "                        }",
  "                    } elseif { nextTok.kind == \"lbrace\" } then {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\" \\{ «expression» \\} then\")afterToken(statementToken)",
  "                        } else {",
  "                            suggestion.insert(\"\\{ \")beforeToken(sym)",
  "                            suggestion.insert(\" \\} then\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                        }",
  "                    } elseif { nextTok.kind == \"identifier\" } then {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"\\{ «expression» \\} \")beforeToken(sym)",
  "                        } else {",
  "                            suggestion.insert(\"\\{ \")beforeToken(sym)",
  "                            suggestion.insert(\" \\}\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                        }",
  "                    }",
  "                    errormessages.syntaxError(\"an elseif statement must have a \" ++",
  "                          \"condition in braces after the 'elseif'.\")",
  "                          atPosition(sym.line, sym.linePos)",
  "                          withSuggestion(suggestion)",
  "                }",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    // Look ahead for a rbrace or then.",
  "                    var nextTok := findNextToken({ t -> (t.line == lastToken.line) && ",
  "                        (t.kind == \"rbrace\")})",
  "                    if(false == nextTok) then {",
  "                        nextTok := findNextValidToken( [\"rbrace\"] )",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"«expression» \\} then \\{\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression» \\} then \\{\")",
  "                        }",
  "                        errormessages.syntaxError(\"an elseif statement must have an expression in braces after the 'elseif'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    } else {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                            errormessages.syntaxError(\"an elseif statement must have an expression in braces after the 'elseif'.\")atPosition(",
  "                                sym.line, sym.linePos)withSuggestion(suggestion)",
  "                        } else {",
  "                            //checkInvalidExpression",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(false)trailing(true)with(\"«expression»\")",
  "                            errormessages.syntaxError(\"4: An elseif statement must have an expression in braces after the 'elseif'.\")atRange(",
  "                                sym.line, sym.linePos, nextTok.linePos - 1)withSuggestion(suggestion)",
  "                        }",
  "                    }",
  "                }",
  "                if(sym.value != \"\\}\") then {",
  "                    checkBadOperators",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"a condition beginning with a \" ++",
  "                        \"'\\{' must end with a '\\}'.\")",
  "                        atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                        withSuggestion(suggestion)",
  "                }",
  "                next",
  "                econd := values.pop",
  "                if ((accept(\"identifier\") &&",
  "                    (sym.value == \"then\"))) then {",
  "                    next",
  "                    ebody := []",
  "                } else {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if(sym.kind == \"lbrace\") then {",
  "                        def closingBrace = findClosingBrace(statementToken, false)",
  "                        if(closingBrace.found.not) then {",
  "                            if(closingBrace.tok == sym) then {",
  "                                suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{}\")",
  "                            } else {",
  "                                suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        } else {",
  "                            suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                        }",
  "                    } else {",
  "                        def closingBrace = findClosingBrace(statementToken, true)",
  "                        if(closingBrace.found.not) then {",
  "                            if(closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\" then \\{}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        } else {",
  "                            suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                        }",
  "                    }",
  "                    errormessages.syntaxError(\"an elseif statement must have 'then' after the expression in braces.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                if(sym.kind != \"lbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, true)",
  "                    if(closingBrace.found.not) then {",
  "                        if(closingBrace.tok == lastToken) then {",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{}\")",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                        }",
  "                    } else {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                    }",
  "                    errormessages.syntaxError(\"an elseif statement must have a '\\{' after the 'then'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                if (sym.line == lastToken.line) then {",
  "                    minIndentLevel := sym.linePos - 1",
  "                } else {",
  "                    minIndentLevel := minInd",
  "                }",
  "                while {(accept(\"rbrace\")).not} do {",
  "                    if(didConsume({statement}).not) then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        def closingBrace = findClosingBrace(btok, false)",
  "                        if(closingBrace.found.not) then {",
  "                            if(closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\"}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        }",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"an elseif statement must end with a '}'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                    v := values.pop",
  "                    ebody.push(v)",
  "                }",
  "                next",
  "                newelse := []",
  "                eif := newIf(econd, ebody, newelse)",
  "                // Construct the inner \"if\" AST node, and then push it",
  "                // inside the current \"else\" block.",
  "                curelse.push(eif)",
  "                // Update curelse to point to the new, empty, nested",
  "                // else block.",
  "                curelse := newelse",
  "            }",
  "            if (accept(\"identifier\") && (sym.value == \"else\")) then {",
  "                next",
  "                if(sym.kind != \"lbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, true)",
  "                    if(closingBrace.found.not) then {",
  "                        if(closingBrace.tok == lastToken) then {",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{}\")",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{\")",
  "                        }",
  "                    } else {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{\")",
  "                    }",
  "                    errormessages.syntaxError(\"an else statement must have a '\\{' after the 'else'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                // Just take all the statements and put them into",
  "                // curelse.",
  "                if (sym.line == lastToken.line) then {",
  "                    minIndentLevel := sym.linePos - 1",
  "                } else {",
  "                    minIndentLevel := minInd",
  "                }",
  "                while {(accept(\"rbrace\")).not} do {",
  "                    if(didConsume({statement}).not) then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        def closingBrace = findClosingBrace(btok, false)",
  "                        if(closingBrace.found.not) then {",
  "                            if(closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\"}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        }",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"an else statement must end with a '}'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                    v := values.pop",
  "                    curelse.push(v)",
  "                }",
  "                next",
  "            }",
  "            util.setPosition(btok.line, btok.linePos)",
  "            var o := newIf(cond, body, elseblock)",
  "            values.push(o)",
  "        } else {",
  "            // Raise an error here, or it will spin nastily forever.",
  "            def suggestion = errormessages.suggestion.new",
  "            if(sym.kind == \"lbrace\") then {",
  "                def closingBrace = findClosingBrace(btok, false)",
  "                if(closingBrace.found.not) then {",
  "                    if(closingBrace.tok == sym) then {",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{}\")",
  "                    } else {",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                } else {",
  "                    suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                }",
  "            } else {",
  "                def closingBrace = findClosingBrace(btok, true)",
  "                if(closingBrace.found.not) then {",
  "                    if(closingBrace.tok == lastToken) then {",
  "                        suggestion.insert(\" then \\{}\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                } else {",
  "                    suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                }",
  "            }",
  "            errormessages.syntaxError(\"an if statement must have 'then' after \" ++",
  "                  \"the condition in parentheses.\")",
  "                  atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        minIndentLevel := localMin",
  "        statementIndent := localStatementIndent",
  "    }",
  "}",
  "",
  "// Accept an identifier. Handle \"if\" specially by",
  "// passing it to the method above.",
  "method identifier {",
  "    if (accept \"identifier\") then {",
  "        if (sym.value == \"if\") then {",
  "            doif",
  "        } else {",
  "            pushidentifier",
  "        }",
  "    }",
  "}",
  "",
  "method prefixop {",
  "    if (accept \"op\") then {",
  "        var op := sym.value",
  "        next",
  "        if (accept \"lparen\") then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"parentheses must contain a valid expression.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            if(didConsume({term}).not) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                if(lastToken.prev.kind == \"bind\") then {",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestion.deleteToken(lastToken.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                }",
  "                errormessages.syntaxError(\"a prefix operator must be followed by an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "        }",
  "        dotrest(blocksOK)",
  "        callrest(blocksOK)",
  "        postfixsquare",
  "        def rcvr = values.pop",
  "        def call = ast.callNode.new(rcvr,",
  "            [ ast.requestPart.request(\"prefix\" ++ op) withArgs( [] ) ] )",
  "        values.push(call)",
  "    }",
  "}",
  "",
  "method generic {",
  "    if (accept \"lgeneric\") then {",
  "        def id = values.pop",
  "        def gens = [ ]",
  "        def startToken = sym",
  "        next",
  "        while {accept(\"identifier\")} do {",
  "            identifier",
  "            while {accept(\"dot\")} do {",
  "                next",
  "                def memberIn = values.pop",
  "                if(sym.kind != \"identifier\") then {",
  "                    def suggestions = [ ]",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\"«type name»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a type name must follow the '.'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + 1)withSuggestions(suggestions)",
  "                }",
  "                identifier",
  "                def memberName = values.pop",
  "                def memberNd = ast.memberNode.new(memberName.value, memberIn)",
  "                memberNd.line := memberName.line",
  "                memberNd.linePos := memberName.linePos",
  "                values.push(memberNd)",
  "            }",
  "            generic",
  "            gens.push(values.pop)",
  "            if (accept \"comma\") then {",
  "                next",
  "            } else {",
  "                if(sym.kind != \"rgeneric\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\">\")afterToken(lastToken)",
  "                    def suggestion2 = errormessages.suggestion.new",
  "                    suggestion2.insert(\" \")beforeToken(startToken)",
  "                    def suggestions = [suggestion, suggestion2]",
  "                    errormessages.syntaxError(\"a type containing a '<' must end with a '>', or the '<' operator must have a space before it.\")atPosition(",
  "                            lastToken.line, lastToken.linePos + lastToken.size)",
  "                        withSuggestions(suggestions)",
  "                }",
  "            }",
  "        }",
  "        if(sym.kind != \"rgeneric\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\">\")afterToken(lastToken)",
  "            def suggestion2 = errormessages.suggestion.new",
  "            suggestion2.insert(\" \")beforeToken(startToken)",
  "            def suggestions = [suggestion, suggestion2]",
  "            errormessages.syntaxError(\"a type containing a '<' must end with a '>', or the '<' operator must have a space before it.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)",
  "                withSuggestions(suggestions)",
  "        }",
  "        next",
  "        values.push(ast.genericNode.new(id, gens))",
  "    }",
  "}",
  "method trycatch {",
  "    if (!(accept(\"identifier\") && (sym.value == \"try\"))) then {",
  "        return 0",
  "    }",
  "    def localmin = minIndentLevel",
  "    def catchTok = sym",
  "    next",
  "    if (accept \"lbrace\") then {",
  "        block",
  "    } else {",
  "        if(sym.kind != \"lparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rbrace, rparen, or catch.",
  "            def nextTok = findNextToken({ t -> (t.kind == \"rbrace\")",
  "                || ((t.kind == \"rparen\") && (t.line == catchTok.line))",
  "                || ((t.kind == \"identifier\") && (t.value == \"catch\")) })",
  "            if(false == nextTok) then {",
  "                suggestion.insert(\" \\{}\")afterToken(catchTok)",
  "            } elseif { nextTok.kind == \"rbrace\" } then {",
  "                suggestion.insert(\" \\{\")afterToken(catchTok)",
  "            } elseif { nextTok.kind == \"rparen\" } then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«expression»\")afterToken(lastToken)andTrailingSpace(true)",
  "                } else {",
  "                    suggestion.insert(\"(\")afterToken(lastToken)andTrailingSpace(true)",
  "                }",
  "            } elseif { nextTok.kind == \"identifier\" } then {",
  "                suggestion.insert(\" \\{\")afterToken(catchTok)",
  "                suggestion.insert(\"\\} \")beforeToken(nextTok)",
  "            }",
  "            errormessages.syntaxError(\"a catch statement must have either a block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                catchTok.line, catchTok.linePos + catchTok.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if(didConsume({expression(blocksOK)}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rparen\"] )",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "            }",
  "            errormessages.syntaxError(\"a catch statement must have either a block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "    }",
  "    def mainblock = values.pop",
  "    def cases = []",
  "    var finally := false",
  "    while {accept(\"identifier\") && (sym.value == \"catch\")} do {",
  "        next",
  "        if (accept \"lbrace\") then {",
  "            block",
  "        } elseif { accept \"lparen\" } then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"a try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = [ ]",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(false == nextTok) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.last)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif { nextTok == sym } then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «match expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"a try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        cases.push(values.pop)",
  "    }",
  "    if (accept(\"identifier\")onLineOf(catchTok) && (sym.value == \"case\")) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.replaceToken(sym)with(\"catch\")",
  "        errormessages.syntaxError(\"a try-catch statement starts with a \"",
  "                ++ \"'try' and then zero or more 'catch' blocks; there \"",
  "                ++ \"are no 'case' blocks.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos + 3)",
  "            withSuggestion(suggestion)",
  "    }",
  "    if (accept(\"identifier\") && (sym.value == \"finally\")) then {",
  "        next",
  "        if (accept \"lbrace\") then {",
  "            block",
  "        } elseif { accept \"lparen\" } then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"a catch statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = [ ]",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(false == nextTok) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.first)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif { nextTok == sym } then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"a try-finally statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        finally := values.pop",
  "    }",
  "    util.setPosition(catchTok.line, catchTok.linePos)",
  "    values.push(ast.tryCatchNode.new(mainblock, cases, finally))",
  "    minIndentLevel := localmin",
  "}",
  "method matchcase {",
  "    if (!(accept(\"identifier\") && (sym.value == \"match\"))) then {",
  "        return 0",
  "    }",
  "    def localmin = minIndentLevel",
  "    def matchTok = sym",
  "    next",
  "    if(sym.kind != \"lparen\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        // Look ahead for a rparen or case.",
  "        def nextTok = findNextToken({ t -> ((t.kind == \"rparen\") && (t.line == matchTok.line))",
  "            || ((t.kind == \"identifier\") && (t.value == \"case\")) })",
  "        if(false == nextTok) then {",
  "            suggestion.insert(\"(«expression»)\")afterToken(matchTok)",
  "        } elseif { nextTok.kind == \"rparen\" } then {",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"(«expression»\")beforeToken(sym)",
  "            } else {",
  "                suggestion.insert(\"(\")beforeToken(sym)",
  "            }",
  "        } elseif { nextTok.kind == \"identifier\" } then {",
  "            suggestion.insert(\"(\")beforeToken(sym)",
  "            suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "        }",
  "        errormessages.syntaxError(\"a match statement must have an expression in parentheses after the 'match'.\")atPosition(",
  "            matchTok.line, matchTok.linePos + matchTok.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    if(didConsume({expression(blocksOK)}).not) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        def nextTok = findNextValidToken( [\"rparen\"] )",
  "        if(nextTok == sym) then {",
  "            suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "        } else {",
  "            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "        }",
  "        errormessages.syntaxError(\"a match statement must have an expression in parentheses after the 'match'.\")atPosition(",
  "            sym.line, sym.linePos)withSuggestion(suggestion)",
  "    }",
  "    def matchee = values.pop",
  "    if(sym.kind != \"rparen\") then {",
  "        checkBadOperators",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\")\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    def cases = []",
  "    var elsecase := false",
  "    while {accept(\"identifier\") && (sym.value == \"case\")} do {",
  "        next",
  "        if (accept \"lbrace\") then {",
  "            block",
  "        } elseif { accept \"lparen\" } then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"a match statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = [ ]",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(false == nextTok) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.last)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif { nextTok == sym } then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «match expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"a match statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        cases.push(values.pop)",
  "    }",
  "    util.setPosition(matchTok.line, matchTok.linePos)",
  "    values.push(ast.matchCaseNode.new(matchee, cases, elsecase))",
  "    minIndentLevel := localmin",
  "}",
  "// Accept a term. Terms consist only of single syntactic units and",
  "// do not contain any operators or parentheses, unlike expression.",
  "method term {",
  "    util.setPosition(sym.line, sym.linePos)",
  "    if (accept \"num\") then {",
  "        pushnum",
  "    } elseif { accept \"string\" } then {",
  "        pushstring",
  "    } elseif { accept \"identifier\" && (sym.value == \"match\") } then {",
  "        matchcase",
  "    } elseif { accept(\"identifier\") && (sym.value == \"try\") } then {",
  "        trycatch",
  "    } elseif { accept \"identifier\" } then {",
  "        identifier",
  "    } elseif { acceptKeyword \"object\" } then {",
  "        doobject",
  "    } elseif { acceptKeyword \"type\" } then {",
  "        dotypeLiteral",
  "    } elseif { accept \"lbrace\" } then {",
  "        block",
  "    } elseif { acceptAfterSpaces \"lsquare\" } then {",
  "        doarray",
  "    } elseif { (lastToken.kind != \"identifier\") && (accept \"lsquare\") } then {",
  "        doarray",
  "    } elseif { accept \"op\" } then {",
  "        // Prefix operator",
  "        prefixop",
  "    }",
  "}",
  "",
  "// Accept an expression. Expressions may consist of parenthesised",
  "// subexpressions or terms, which may be followed by method invocations",
  "// (dotrest), postcircumfix square brackets, the rest of a method call,",
  "// or an operator expression.",
  "method expression(acceptBlocks) {",
  "    var sz := values.size",
  "    util.setPosition(sym.line, sym.linePos)",
  "    if (accept \"lparen\") then {",
  "        def tmpStatementToken = statementToken",
  "        statementToken := sym",
  "        util.setPosition(sym.line, sym.linePos)",
  "        next",
  "        if (didConsume{expression(acceptBlocks)}.not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rparen\"] )",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                      leading(true)trailing(false)with(\"«expression»\")",
  "            }",
  "            errormessages.syntaxError(\"parentheses must contain a valid expression.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")",
  "                  atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                  withSuggestion(suggestion)",
  "        }",
  "        statementToken := tmpStatementToken",
  "        next",
  "    } else {",
  "        term",
  "    }",
  "    if (values.size > sz) then {",
  "        dotrest(acceptBlocks)",
  "        callrest(acceptBlocks)",
  "        postfixsquare",
  "        valueexpressionrest",
  "    }",
  "}",
  "",
  "// Accept postcircumfix square brackets (as in x[y]) and replace the",
  "// preceding expression with an index node into itself.",
  "method postfixsquare {",
  "    if (acceptWithoutSpaces(\"lsquare\")) then {",
  "        def opening = sym",
  "        next",
  "        def expr = values.pop",
  "        if(didConsume({expression(blocksOK)}).not) then {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rsquare\"] )",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«index»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«index»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            if(nextTok.kind == \"rsquare\") then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"a '[' in an expression must be followed by another expression and a ']'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        if(sym.kind != \"rsquare\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"]\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"a '[' in an expression must be followed by another expression and a ']'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        errormessages.syntaxError(\"'[ ... ]' without preceeding space is no longer part of Grace. \" ++",
  "            \"For a Lineup, add a space.  For an indexing operation, use `at(_)` or `at(_)put(_)`.\")",
  "                atPosition(opening.line, opening.linePos)",
  "    }",
  "}",
  "",
  "// Calculate the precedence of an operator. In this case, only",
  "// multiplication and division have nontrivial precedence. Used in",
  "// expressionrest.",
  "method oprec(o) {",
  "    if (o == \"*\") then {",
  "        return 10",
  "    } elseif { o == \"/\" } then {",
  "        return 10",
  "    }",
  "    return 5",
  "}",
  "",
  "// Return the precedence of the operator at the top of the \"ops\" stack.",
  "method toprec(ops) {",
  "    if (ops.size > 0) then {",
  "        var o := ops.last",
  "        return oprec(o)",
  "    }",
  "    0",
  "}",
  "",
  "",
  "method typeexpressionrest {",
  "    if (acceptSameLine(\"op\")) then {",
  "        expressionrest \"type expression\" recursingWith {typeexpression} blocks (noBlocks)",
  "    }",
  "}",
  "",
  "method valueexpressionrest {",
  "    if (accept \"op\") then {",
  "        expressionrest \"expression\" recursingWith {expression(blocksOK)} blocks (blocksOK)",
  "    }",
  "}",
  "",
  "method expressionrest(name) recursingWith (recurse) blocks (acceptBlocks) {",
  "    // Process the rest of an operator expression using the shunting-yard",
  "    // algorithm. This method uses the oprec and toprec methods above to",
  "    // ensure the correct precedence, and treats all operators as",
  "    // left-associative.  It is parametrised so that it",
  "    // can be used for both type- and value- expressions.",
  "    var terms := [] // List of operands yet to be used",
  "    var ops := [] // Operator stack",
  "    var o",
  "    var o2",
  "    var tmp2",
  "    var tmp := values.pop",
  "    terms.push(tmp)",
  "    var prec",
  "    var allarith := true // Consists only of arithmetic operators",
  "    var opcount := 0",
  "    var opdtype := \"\" // The single operator being used in this expression",
  "    while {accept(\"op\")onLineOfLastOr(statementToken) && ",
  "            {sym.value != \"=\"}} do {",
  "        opcount := opcount + 1",
  "        o := sym.value",
  "        next",
  "        prec := oprec(o)",
  "        if ((o != \"*\") && (o != \"/\") && (o != \"+\") && (o != \"-\")) then {",
  "            allarith := false",
  "        }",
  "        if ((opdtype != \"\") && (opdtype != o) && (allarith.not)) then {",
  "            // If: this is not the first operator, it is not the same",
  "            // as the last operator, and the expression has not been",
  "            // entirely arithmetic, raise a syntax error.",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(sym)",
  "            suggestion.insert(\"(\")beforeToken(lastToken.prev)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken.prev)",
  "            suggestion.insert(\"(\")beforeToken(lastToken.prev.prev.prev)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"an expression containing both arithmetic and non-arithmetic operators requires parentheses.\")atPosition(",
  "                lastToken.prev.line, lastToken.prev.linePos)withSuggestions(suggestions)",
  "        }",
  "        opdtype := o",
  "        while {(ops.size > 0) && (prec <= toprec(ops))} do {",
  "            // Do the shunting: for as long as the current operator",
  "            // has lesser or equal precedence than the one on the",
  "            // top of the stack, take the operator off the stack and",
  "            // replace its two operands with the combined operator node.",
  "            // This corresponds to left-associative operators only.",
  "            o2 := ops.pop",
  "            tmp2 := terms.pop",
  "            tmp := terms.pop",
  "            util.setPosition(tmp.line, tmp.linePos)",
  "            tmp := ast.opNode.new(o2, tmp, tmp2)",
  "            terms.push(tmp)",
  "        }",
  "        ops.push(o)",
  "        if (accept \"lparen\") then {",
  "            // When a parenthesis is found, take an expression from",
  "            // *within* the parentheses and add it to the stack. Do",
  "            // not delegate entirely to expression, because it will",
  "            // then consume all the following operators and break",
  "            // precedence. Possibly parenthesised expressions could",
  "            // be allowed in term above?",
  "            next",
  "            if(didConsume(recurse).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«{name}»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«{name}»\")",
  "                }",
  "                errormessages.syntaxError(\"parentheses must contain a valid {name}.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            if (!tokenOnSameLine) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.deleteToken(lastToken)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" «{name}»\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \" ++ util.lines.at(sym.line))afterToken(lastToken)",
  "                suggestion.deleteLine(sym.line)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a valid expression must follow '{lastToken.value}'. This is often caused by a new line in the middle of an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "            if(didConsume({term}).not) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"comma\", \"rparen\", \"rsquare\", \"rbrace\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «{name}»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «{name}»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a valid {name} must follow '{lastToken.value}'. This is often caused by a new line in the middle of an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "        }",
  "",
  "        // Regardless of where the last value came from, it may have",
  "        // method invocations, indexes, or method call happening to it,",
  "        // which should be applied and the result put into the operands",
  "        // list.",
  "        dotrest(acceptBlocks)",
  "        callrest(acceptBlocks)",
  "        postfixsquare",
  "        tmp := values.pop",
  "        terms.push(tmp)",
  "    }",
  "    while {ops.size > 0} do {",
  "        // Shunt off any remaining operators at the end",
  "        o := ops.pop",
  "        tmp2 := terms.pop",
  "        tmp := terms.pop",
  "        util.setPosition(tmp.line, tmp.linePos)",
  "        tmp := ast.opNode.new(o, tmp, tmp2)",
  "        terms.push(tmp)",
  "    }",
  "    tmp := terms.pop",
  "    values.push(tmp)",
  "    if (terms.size > 0) then {",
  "        errormessages.syntaxError(\"values left on term stack.\")atPosition(sym.line, sym.linePos)",
  "    }",
  "}",
  "",
  "// Accept a member lookup with \".\". This consumes the dot and",
  "// a following identifier, and will pass along to further lookups or",
  "// method calls on the result.",
  "method dotrest(acceptBlocks) {",
  "    if (acceptSameLine(\"dot\")) then {",
  "        util.setPosition(sym.line, sym.linePos)",
  "        var lookuptarget := values.pop",
  "        next",
  "        if (accept \"identifier\") then {",
  "            util.setPosition(sym.line, sym.linePos)",
  "            var dro := ast.memberNode.new(sym.value, lookuptarget)",
  "            values.push(dro)",
  "            next",
  "            if (accept \"dot\") then {",
  "                dotrest(acceptBlocks)",
  "            } elseif { accept \"lparen\" || (acceptBlocks && accept \"lbrace\")",
  "                  || accept(\"num\") || accept(\"string\") || accept(\"lsquare\")",
  "                  || accept(\"lgeneric\") } then {",
  "                callrest(acceptBlocks)",
  "            }",
  "        } else {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.deleteToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\"«method name»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"a field or method name must follow a '.'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    }",
  "}",
  "",
  "// Accept a method invocation indicated by parentheses. Unparenthesised",
  "// method calls are left as \"member\" AST nodes and processed correctly at",
  "// a later stage.",
  "method callrest(acceptBlocks) {",
  "    if (values.size == 0) then {",
  "        return 0",
  "    }",
  "    var meth := values.pop",
  "    if (meth.kind != \"identifier\") then {",
  "        if (meth.kind != \"member\") then {",
  "            values.push(meth)",
  "            return 0",
  "        }",
  "    }",
  "    def lnum = meth.line",
  "    def lpos = meth.linePos",
  "    var methn := meth.nameString",
  "    def btok = sym",
  "    util.setPosition(sym.line, sym.linePos)",
  "    var signature := []",
  "    var part := ast.requestPart.new",
  "    signature.push(part)",
  "    var hadcall := false",
  "    var tok := lastToken",
  "    var startInd := minIndentLevel",
  "    var genericIdents := false",
  "    if (acceptSameLine \"lgeneric\") then {",
  "        genericIdents := typeArgs",
  "    }",
  "    if (acceptSameLine(\"lparen\")) then {",
  "        part.line := sym.line",
  "        part.linePos := sym.linePos",
  "        part.name := methn",
  "        tok := sym",
  "        hadcall := true",
  "        parenthesizedArg(part)",
  "    } elseif { acceptBlocks.not && {accept(\"lbrace\")onLineOf(tok)} } then {",
  "        values.push(meth)",
  "    } elseif { acceptArgumentOnLineOf(tok) } then {",
  "        tok := sym",
  "        hadcall := true",
  "        part.name := methn",
  "        term",
  "        var ar := values.pop",
  "        part.args.push(ar)",
  "    } elseif { meth.kind == \"identifier\" } then {",
  "        values.push(meth)",
  "    } elseif { meth.kind == \"member\" } then {",
  "        var root := meth.receiver",
  "        var outroot := meth",
  "        while {root.kind == \"member\"} do {",
  "            outroot := root",
  "            root := root.receiver",
  "        }",
  "        if (root.kind == \"identifier\") then {",
  "            values.push(meth)",
  "        } else {",
  "            meth.generics := genericIdents",
  "            values.push(meth)",
  "        }",
  "    }",
  "    if (hadcall) then {",
  "        if (accept(\"identifier\")onLineOfLastOr(tok)) then {",
  "            // Multi-part method name",
  "            def meth' = ast.identifierNode.new(methn, false)",
  "            meth'.line := lnum",
  "            meth'.linePos := lpos",
  "            methn := callmprest(meth', signature, tok)",
  "            if (meth.kind == \"member\") then {",
  "                // callmprest loses this information, so restore",
  "                // the member lookup (for x.between(3)and(10)-type",
  "                // calls).",
  "                meth := ast.memberNode.new(methn.value, meth.receiver)",
  "                meth.line := methn.line",
  "                meth.linePos := methn.linePos",
  "            } else {",
  "                meth := methn",
  "            }",
  "        }",
  "        util.setline(lnum)",
  "        if (meth.isIdentifier) then {",
  "            meth := ast.implicit",
  "        } else {",
  "            meth := meth.receiver     // because the final \"with\" part duplicates",
  "                                // first part of the method name",
  "        }",
  "        def call = ast.callNode.new(meth, signature)",
  "        call.generics := genericIdents",
  "        values.push(call)",
  "    } elseif {false != genericIdents} then {",
  "        meth.generics := genericIdents",
  "    }",
  "    minIndentLevel := startInd",
  "    dotrest(acceptBlocks)",
  "}",
  "",
  "method parenthesizedArg(part) {",
  "    next",
  "    ifConsume {expression(blocksOK)} then {",
  "        // For matching blocks - same as below",
  "        if (accept \"colon\") then {",
  "            def expr = values.pop",
  "            if (expr.kind != \"identifier\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                if(sym.next.kind == \"identifier\") then {",
  "                    suggestion.deleteTokenRange(sym, sym.next)leading(true)trailing(false)",
  "                    errormessages.syntaxError(\"only variables and constants may be followed by a ':' and a type.\")atRange(",
  "                        sym.line, sym.linePos, sym.next.linePos + sym.next.size - 1)withSuggestion(suggestion)",
  "                } else {",
  "                    suggestion.deleteToken(sym)leading(true)trailing(false)",
  "                    errormessages.syntaxError(\"only variables and constants may be followed by a ':' and a type.\")atRange(",
  "                        sym.line, sym.linePos, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "            }",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                checkBadTypeLiteral",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «type name»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a type name or type expression must follow ':'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestions(suggestions)",
  "            }",
  "            expr.dtype := values.pop",
  "            values.push(expr)",
  "        }",
  "        while {accept(\"comma\")} do {",
  "            part.args.push(values.pop)",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a method request must have an expression after a ','.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestions(suggestions)",
  "            }",
  "            // For matching blocks - same as above",
  "            if (accept \"colon\") then {",
  "                def arg = values.pop",
  "                if (arg.kind != \"identifier\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if(sym.next.kind == \"identifier\") then {",
  "                        suggestion.deleteTokenRange(sym, sym.next)leading(true)trailing(false)",
  "                        errormessages.syntaxError(\"only declarations may be followed by a ':' and a type.\")atRange(",
  "                            sym.line, sym.linePos, sym.next.linePos + sym.next.size - 1)withSuggestion(suggestion)",
  "                    } else {",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"only declarations may be followed by a ':' and a type.\")atRange(",
  "                            sym.line, sym.linePos, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                }",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    checkBadTypeLiteral",
  "                    def suggestions = [ ]",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rparen\"] )",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «type name»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a type name or type expression must follow ':'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                arg.dtype := values.pop",
  "                values.push(arg)",
  "            }",
  "        }",
  "        part.args.push(values.pop)",
  "    }",
  "    if(sym.kind != \"rparen\") then {",
  "        checkBadOperators",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\")\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"a method request beginning with a '(' must end with a ')'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    if (sym.line == part.line) then {",
  "        part.lineLength := sym.linePos - part.linePos",
  "    }",
  "    next",
  "}",
  "",
  "method typeArgs {",
  "    // Parse one or more type arguments, if present, and answer them as a list.",
  "    def startToken = sym",
  "    def args = [ ]",
  "    if (sym.kind != \"lgeneric\") then { return args }",
  "    next",
  "    while {didConsume{typeArg}} do {",
  "        args.add(values.pop)",
  "        if (sym.kind == \"comma\") then { next }",
  "    }",
  "    if(sym.kind != \"rgeneric\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\">\")afterToken(lastToken)",
  "        def suggestion2 = errormessages.suggestion.new",
  "        suggestion2.insert(\" \")beforeToken(startToken)",
  "        def suggestions = [suggestion, suggestion2]",
  "        errormessages.syntaxError(\"a method request containing a '<' must have a matching '>'. \"",
  "            ++ \"If '<' is intended as an operator, precede it by a space.\")",
  "            atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "            withSuggestions(suggestions)",
  "    }",
  "    next",
  "    return args",
  "}",
  "",
  "method typeArg {",
  "    // Parses a single type argument, and leave it on the values stack.",
  "    // TODO: 'identifier' could be a dotted identifier, ",
  "    //        or perhaps a type expression?",
  "    if (accept \"identifier\") then {",
  "        identifier",
  "        if (sym.kind == \"lgeneric\") then {",
  "            values.push(ast.genericNode.new(values.pop, typeArgs))",
  "        } else {",
  "            // values.push(values.pop)",
  "        }",
  "    } elseif {didConsume{dotypeLiteral}} then {",
  "        // values.push(values.pop)",
  "    }",
  "}",
  "",
  "method callmprest(meth, signature, tok) {",
  "    // Parses the rest of a multi-part method name.",
  "    // meth is an identifierNode representing the first part of the name.",
  "    // Returns a new identifierNode, representing the full method name,",
  "    // and updates signature.params with the parsed arguments.",
  "    var methname := meth.value",
  "    var nxt",
  "    var lp := meth.linePos",
  "    var part",
  "    while {accept(\"identifier\")onLineOf(tok)",
  "           || accept(\"identifier\")onLineOf(lastToken)} do {",
  "        // Each word must start on the same line as the preceding parameter",
  "        // ended.",
  "        part := ast.requestPart.new",
  "        signature.push(part)",
  "        methname := methname ++ \"()\"",
  "        pushidentifier",
  "        nxt := values.pop",
  "        methname := methname ++ nxt.value",
  "        part.name := nxt.value",
  "        var isTerm := false",
  "        if (accept \"lparen\") then {",
  "            next    // skip over the `(`",
  "        } elseif { acceptArgumentOnLineOf(lastToken) } then {",
  "            isTerm := true",
  "        } else {",
  "            def suggestion = errormessages.suggestion.new",
  "            if(sym.kind == \"identifier\") then {",
  "                suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value})\")",
  "                if(methname == \"while()do\") then {",
  "                    errormessages.syntaxError(\"a while loop must have either a loop body in braces, or a block in parentheses.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } elseif { methname == \"for()do\" } then {",
  "                    errormessages.syntaxError(\"a for loop must have either a loop body in braces, or a block in parentheses.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                errormessages.syntaxError(\"each argument list in a multi-part method request must be parenthesized, unless it is self-delimiting.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            } else {",
  "                if (methname == \"while()do\") then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"a while loop must have a body.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } elseif { methname == \"for()do\" } then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"a for loop must have a body.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } else {",
  "                    suggestion.insert(\"()\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"a multi-part method request must end with '()'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        def isEmpty = accept \"rparen\"",
  "        if (isTerm) then {",
  "            term",
  "        } else {",
  "            if(sym.kind != \"rparen\") then {",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = [ ]",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rparen\"] )",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                        suggestions.push(suggestion)",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a method request must have an expression or a ')' after a '('.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "            }",
  "            while {accept(\"comma\")} do {",
  "                nxt := values.pop",
  "                part.args.push(nxt)",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = [ ]",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rparen\"] )",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a method request must have an expression after a ','.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "            }",
  "        }",
  "        if (!isEmpty) then {",
  "            nxt := values.pop",
  "            part.args.push(nxt)",
  "        }",
  "        if (isTerm.not) then {",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"a part of a multi-part method request beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "        }",
  "        if (accept(\"rparen\") && isTerm.not) then {",
  "            next",
  "        }",
  "    }",
  "    def meth' = ast.identifierNode.new(methname, false)",
  "    meth'.line := meth.line",
  "    meth'.linePos := meth.linePos",
  "    meth'",
  "}",
  "",
  "// Accept a const declaration",
  "method defdec {",
  "    if (acceptKeyword \"def\") then {",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        def defTok = sym",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextToken = findNextToken({ t -> (t.kind == \"op\")",
  "                && (t.value == \"=\") && (t.line == sym.line)})",
  "            if (false == nextToken) then {",
  "                suggestion.insert(\" «name» =\")afterToken(lastToken)",
  "            } elseif { nextToken == sym } then {",
  "                suggestion.insert(\" «name»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextToken.prev)",
  "                      leading(false)trailing(true)with(\"«name» \")",
  "            }",
  "            errormessages.syntaxError(\"a definition must have a name, '=', \" ++",
  "                  \"and a value after the 'def'.\") atPosition(sym.line, sym.linePos)",
  "                  withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        var val := false",
  "        var name := values.pop",
  "        name.isBindingOccurrence := true",
  "        var dtype := optionalTypeAnnotation",
  "        def anns = doannotation",
  "        if (accept(\"op\") && (sym.value == \"=\")) then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [ ] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                          leading(true)trailing(false)with(\" «expression»\")",
  "                }",
  "                errormessages.syntaxError(\"a definition must have a value after the '='.\")",
  "                      atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                      withSuggestion(suggestion)",
  "            }",
  "            val := values.pop",
  "        } elseif { accept \"bind\" } then {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(sym)with(\"=\")",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(defTok)with(\"var\")",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"a definition must use '=' instead of ':='. \" ++",
  "                \"A variable declaration uses 'var' and ':='.\")atRange(",
  "                sym.line, sym.linePos, sym.linePos + 1) withSuggestions(suggestions)",
  "        } else {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\" = «expression»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(defTok)with(\"var\")",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"a definition must have '=' and a value after the name. \"",
  "                ++ \"A variable declaration does not require a value but uses 'var', not 'def'.\")",
  "                atPosition(sym.line, sym.linePos) withSuggestions(suggestions)",
  "        }",
  "        util.setPosition(defTok.line, defTok.linePos)",
  "        var o := ast.defDecNode.new(name, val, dtype)",
  "        if (false != anns) then { o.annotations.addAll(anns) }",
  "        o.startToken := defTok",
  "        values.push(o)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "// Accept a var declaration",
  "method vardec {",
  "    if (acceptKeyword \"var\") then {",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        def varTok = sym",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextToken = findNextToken({ t -> (t.kind == \"bind\")",
  "                && (t.line == sym.line)})",
  "            if ((false == nextToken) || {nextToken == sym}) then {",
  "                suggestion.insert(\" «name»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextToken.prev)",
  "                      leading(false)trailing(true)with(\"«name» \")",
  "            }",
  "            errormessages.syntaxError \"a variable declaration must have a name after the 'var'.\"",
  "                  atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        var val := false",
  "        var name := values.pop",
  "        name.isBindingOccurrence := true",
  "        def dtype = optionalTypeAnnotation",
  "        def anns = doannotation",
  "        if (accept \"bind\") then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [ ] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                          leading(true)trailing(false)with(\" «expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a variable declaration must have a value after the ':='. \"",
  "                    ++ \"A variable without a value can be declared with 'var' followed only by the variable name.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "            val := values.pop",
  "        } else {",
  "            if (accept(\"op\") && (sym.value == \"=\")) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(sym)with(\":=\")",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(varTok)with(\"def\")",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a variable declaration must use ':=' instead of '='. A definition uses 'def' and '='.\")",
  "                    atRange(sym.line, sym.linePos, sym.linePos)",
  "                    withSuggestions(suggestions)",
  "            }",
  "        }",
  "        util.setPosition(line, pos)",
  "        def o = ast.varDecNode.new(name, val, dtype)",
  "        if (false != anns) then { o.annotations.addAll(anns) }",
  "        values.push(o)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "// Accept a square-bracketed list literal like [1,2,3].",
  "method doarray {",
  "    if (accept \"lsquare\") then {",
  "        next",
  "        var tmp",
  "        var params := []",
  "        ifConsume {expression(blocksOK)} then {",
  "            while {accept(\"comma\")} do {",
  "                tmp := values.pop",
  "                params.push(tmp)",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = [ ]",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rsquare\"] )",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a Lineup must contain zero or more expressions separated by commas.\")",
  "                        atPosition(sym.line, sym.linePos) withSuggestions(suggestions)",
  "                }",
  "            }",
  "            tmp := values.pop",
  "            params.push(tmp)",
  "        }",
  "        if(sym.kind != \"rsquare\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"]\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"a Lineup beginning with a '[' must end with a ']'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        var o := ast.arrayNode.new(params)",
  "        values.push(o)",
  "        next",
  "    }",
  "}",
  "",
  "// Accept \"dialect \"X\"\"",
  "method dodialect {",
  "    if (acceptKeyword \"dialect\") then {",
  "        next",
  "        if(sym.kind != \"string\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            var errorPos",
  "            if((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"\\\"{sym.value}\\\"\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" \\\"«dialect name»\\\"\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"a dialect statement must have the name of the dialect in quotes after the 'dialect'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        values.push(ast.dialectNode.new(sym.value))",
  "        next",
  "    }",
  "}",
  "",
  "method inheritsOrUses {",
  "    // Parses \"inherit «object expression»\"",
  "",
  "    if (! accept \"keyword\") then { return }",
  "    if ((sym.value == \"inherits\") || (sym.value == \"inherit\") || (sym.value == \"use\")) then {",
  "        def btok = sym",
  "        checkIndent",
  "        next",
  "        if(didConsume({expression(noBlocks)}).not) then {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rsquare\"] )",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\" «parent»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «parent»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            var msg := \"The {btok.value} keyword must be followed by an expression that creates \"",
  "            if (btok.value == \"use\") then {",
  "                msg := msg ++ \"the trait being used.\"",
  "            } else {",
  "                msg := msg ++ \"the object being inherited.\"",
  "            }",
  "            errormessages.syntaxError(msg)",
  "                atPosition(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                withSuggestions(suggestions)",
  "        }",
  "        util.setPosition(btok.line, btok.linePos)",
  "        def inhNode = ast.inheritsNode.new(values.pop)",
  "        if (btok.value == \"use\") then {",
  "            inhNode.isUse := true",
  "        }",
  "        while { inheritsModifier(inhNode) onLineOf(btok) } do { }",
  "        values.push(inhNode)",
  "    }",
  "}",
  "",
  "method inheritsModifier(node) onLineOf(startToken) {",
  "    // parse an alias or excludes modifier on an `inherits` clause",
  "    if (! accept \"keyword\" onLineOf(startToken) ) then { ",
  "        return false",
  "    }",
  "    if (sym.value == \"alias\") then { ",
  "        parseAlias(node) ",
  "    } elseif {sym.value == \"exclude\"} then {",
  "        parseExclude(node)",
  "    } else {",
  "        false",
  "    }",
  "}",
  "",
  "method parseAlias(node) {",
  "    next    // skip the alias keyword",
  "    def newMeth = methodsignature(true)",
  "    if (accept \"op\" && (sym.value == \"=\")) then {",
  "        next",
  "        def oldMeth = methodsignature(true).appliedOccurence",
  "        if (newMeth.numParams ≠ oldMeth.numParams) then {",
  "            errormessages.syntaxError \"a method and its alias must have the same number of parameters\"",
  "                atRange (newMeth.line, newMeth.linePos, oldMeth.endPos)",
  "        }",
  "        node.addAlias (newMeth.asIdentifier) for (oldMeth.asIdentifier)",
  "    } else {",
  "        errormessages.syntaxError (\"an alias modifier must take the form \" ++",
  "            \"'‹newMethodName› = ‹oldMethodName›'\")",
  "            atPosition (lastToken.line, lastToken.linePos + lastToken.size)",
  "    }",
  "    return true",
  "}",
  "method parseExclude(node) {",
  "    next    // skip the exclude keyword",
  "    def excludedMeth = methodsignature(true).appliedOccurence",
  "    node.addExclusion (excludedMeth.asIdentifier)",
  "    return true",
  "}",
  "",
  "method doobject {",
  "    // Parse an object constructor.",
  "    // this method is called doobject because \"object\" is a keyword",
  "",
  "    if (acceptKeyword \"object\") then {",
  "        next",
  "        parseObjectConstructorBody \"an object constructor\" ",
  "            startingWith (lastToken) after \"'object'\"",
  "    }",
  "}",
  "",
  "method parseObjectConstructorBody(constructName) startingWith (btok) after (prev) {",
  "    // Parse the body of an object constructor, leaving the node on the",
  "    // values stack.  Common code for parsing object, class, and factory method",
  "    // bodies; constructName says which, so that error messages are correct.",
  "    // btok is the keyword token that started the construct: class, object, or trait.",
  "    def localMinIndentLevel = minIndentLevel",
  "    def anns = doannotation",
  "    if (sym.kind != \"lbrace\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        def nextTok = findNextToken { t -> t.kind == \"rbrace\" }",
  "        if (false == nextTok) then {",
  "            suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "        } else {",
  "            suggestion.insert(\" \\{\")afterToken(lastToken)",
  "        }",
  "        errormessages.syntaxError \"{constructName} must have a '\\{' after the {prev}.\"",
  "            atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "            withSuggestion(suggestion)",
  "    }",
  "    next",
  "    if (sym.line == statementToken.line) then {",
  "        minIndentLevel := sym.linePos - 2",
  "    } else {",
  "        minIndentLevel := statementToken.indent + 2",
  "    }",
  "    def body = []",
  "    var superObject := false",
  "    def usedTraits = []",
  "    var inPreamble := true  // => processing inherit and use statements",
  "    while {(accept(\"rbrace\")).not && {sym.kind != \"eof\"}} do {",
  "        if (didConsume {inheritsOrUses}) then {",
  "            def parentNode = values.pop",
  "            if (inPreamble) then {",
  "                if (parentNode.isUse) then {",
  "                    usedTraits.add(parentNode)",
  "                } elseif { usedTraits.isEmpty } then {",
  "                    superObject := parentNode",
  "                } else {",
  "                    errormessages.syntaxError(\"'inherit' must come \" ++",
  "                        \"before 'use' in {constructName}\")",
  "                        atRange(parentNode.line, parentNode.linePos,",
  "                        parentNode.linePos + 7)",
  "                }",
  "            } else {",
  "                errormessages.syntaxError(\"'{parentNode.statementName}' must \" ++",
  "                    \"come at the start of {constructName}\")",
  "                    atRange(parentNode.line, parentNode.linePos,",
  "                            parentNode.linePos + parentNode.statementName.size)",
  "            }",
  "        } elseif { didConsume {methoddec} } then {",
  "            inPreamble := false",
  "            body.push(values.pop)",
  "        } elseif { didConsume {statement} } then {",
  "            inPreamble := false",
  "            body.push(values.pop)",
  "        } else {",
  "            errormessages.syntaxError(\"unexpected symbol '{sym.value}' in body \" ++",
  "                \"of of {constructName}\")",
  "                atRange(sym.line, sym.linePos, sym.linePos + sym.value.size - 1)",
  "        }",
  "    }",
  "    next",
  "    util.setPosition(btok.line, btok.linePos)",
  "    def objNode = ast.objectNode.new(body, superObject)",
  "    if (false != anns) then { objNode.annotations.addAll(anns) }",
  "    objNode.usedTraits := usedTraits",
  "    values.push(objNode)",
  "    minIndentLevel := localMinIndentLevel",
  "}",
  "",
  "method doclass {",
  "    // Accepts a class declaration with or without a `dot`",
  "    // Class declarations were formerly of the form:",
  "    //",
  "    //   class objName.methodName (param1, param2) {",
  "    //     inherits <expr>",
  "    //     var x",
  "    //     method y(z) { ... }",
  "    // }",
  "    // Now they are of the form:",
  "    //",
  "    // class methodName (param1, param2) {",
  "    //     inherits <expr>",
  "    //     var x",
  "    //     method y(z) { ... }",
  "    // }",
  "    // The old \"dotted\" form is compiled into a defDecNode that contains",
  "    // an objectNode that contains the class method and an asString method.",
  "    // The current form is compiled into a methodNode that contains",
  "    // an objectNode, i.e., it is treated as syntactic sugar for",
  "    //",
  "    // method methodName (param1, param2) {",
  "    //     object {",
  "    //         inherits <expr>",
  "    //         var x",
  "    //         method y(z) { ... }",
  "    //     }",
  "    // }",
  "",
  "    def btok = sym",
  "    next",
  "    def localMinIndentLevel = minIndentLevel",
  "    if(sym.kind != \"identifier\") then {",
  "        def suggestions = [ ]",
  "        if(sym.kind == \"lbrace\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\" «class name».new\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(lastToken)with(\"object\")",
  "            suggestions.push(suggestion)",
  "        } else {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\" «class name».new \\{}\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "        }",
  "        errormessages.syntaxError(\"a class must have a name after the 'class'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "    }",
  "    var objName := false",
  "    if (tokens.first.kind == \"dot\") then {",
  "        pushidentifier // the name of the class object",
  "        objName := values.pop",
  "        objName.isBindingOccurrence := true",
  "        next    // skip over the dot",
  "    }",
  "    def meth = methodsignature(false)",
  "    meth.setPositionFrom(btok)",
  "    parseObjectConstructorBody \"a class\" startingWith (btok) after \"method header\"",
  "    def objNode = values.pop",
  "    meth.body := [objNode]",
  "    meth.usesClassSyntax := true",
  "    meth.annotations.addAll(objNode.annotations)  // TODO: sort this out!",
  "    // see comment in dofactoryMethod",
  "    if (false != objName) then {   // deal with (deprecated) dotted class",
  "        objNode.name := objName.nameString ++ \".\" ++ meth.canonicalName",
  "        def asStringBody = [ ast.stringNode.new(\"class {objName.nameString}\") ]",
  "        def signature = [ ast.signaturePart.partName \"asString\" ]",
  "        def asStringMeth = ast.methodNode.new(signature, asStringBody, false)",
  "        def metaBody = [meth, asStringMeth]",
  "        def metaObj = ast.objectNode.body (metaBody) named \"class {objName.nameString}\"",
  "        def defDec = ast.defDecNode.new(objName, metaObj, ast.unknownType)",
  "        defDec.startToken := btok",
  "        defDec.annotations.add(ast.identifierNode.new(\"public\", false))",
  "        values.push(defDec)",
  "    } else {",
  "        objNode.name := meth.canonicalName",
  "        if (btok.value == \"class\") then {",
  "            objNode.inClass := true",
  "        } elseif { btok.value == \"trait\" } then {",
  "            objNode.inTrait := true",
  "        }",
  "        values.push(meth)",
  "    }",
  "    reconcileComments",
  "    minIndentLevel := localMinIndentLevel",
  "}",
  "",
  "method dofactoryMethod {",
  "    // Accept a factory method declaration",
  "    if ((acceptKeyword \"factory\") && {",
  "            tokens.first.kind == \"keyword\"} && {",
  "            tokens.first.value == \"method\"}) then {",
  "        def btok = sym",
  "        next",
  "        next",
  "        def localMinIndentLevel = minIndentLevel",
  "        if (sym.kind != \"identifier\") then {",
  "            def suggestions = [ ]",
  "            if(sym.kind == \"lbrace\") then {",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" «method name»\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(lastToken)with(\"object\")",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\" «method name» \\{}\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError \"a factory method must have a name after the 'method'.\"",
  "                atPosition (lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                withSuggestions (suggestions)",
  "        }",
  "        var meth := methodsignature(false)",
  "        parseObjectConstructorBody \"a factory method\" startingWith (btok) after \"method header\"",
  "        def objNode = values.pop",
  "        objNode.name := meth.nameString",
  "        util.setPosition(btok.line, btok.linePos)",
  "        meth.body := [objNode]",
  "        meth.annotations.addAll(objNode.annotations)  // TODO: sort this out!",
  "        // In a class or factory method declaration, there is just one place",
  "        // for annotations.  These might include annotations on the method (such",
  "        // as confidential), and annotations on the object (such as imutable)",
  "        values.push(meth)",
  "        reconcileComments",
  "        minIndentLevel := localMinIndentLevel",
  "    }",
  "}",
  "",
  "method methoddec {",
  "    // Parse a method declaration",
  "",
  "    if (acceptKeyword \"method\") then {",
  "        def btok = sym",
  "        checkIndent",
  "        statementToken := sym",
  "        var stok := sym",
  "        next",
  "        def methNode = methodsignature(false).setPositionFrom(btok)",
  "        def body = []",
  "        var localMin",
  "        def anns = doannotation",
  "        if (accept \"lbrace\") then {",
  "            next",
  "            localMin := minIndentLevel",
  "            if (sym.line == stok.line) then {",
  "                minIndentLevel := sym.linePos - 1",
  "            } else {",
  "                minIndentLevel := stok.indent + 1",
  "            }",
  "            values.push(object {",
  "                def kind is public = \"lbrace\"",
  "                var register is public := \"\"",
  "            })  // a dummy token to mark the position in the values stack",
  "            statement",
  "            var s := values.pop",
  "            while {s.kind != \"lbrace\"} do {",
  "                // The body is a sequence of statements, and",
  "                // the method ends when no further statement",
  "                // is found.",
  "                body.push(s)",
  "                statement",
  "                s := values.pop",
  "            }",
  "            if(sym.kind != \"rbrace\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def closingBrace = findClosingBrace(btok, false)",
  "                if(closingBrace.found.not) then {",
  "                    if(closingBrace.tok == sym) then {",
  "                        suggestion.insert(\"}\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                }",
  "                suggestion.deleteToken(sym)",
  "                errormessages.syntaxError(\"a method must end with a '}'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            next",
  "            minIndentLevel := localMin",
  "        } else {",
  "            def suggestion = errormessages.suggestion.new",
  "            def closingBrace = findClosingBrace(btok, true)",
  "            if(closingBrace.found.not) then {",
  "                if(closingBrace.tok == lastToken) then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)andTrailingSpace(true)",
  "                } else {",
  "                    suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    suggestion.insert(\" \\{\")afterToken(lastToken)andTrailingSpace(true)",
  "                }",
  "            } else {",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)andTrailingSpace(true)",
  "            }",
  "            errormessages.syntaxError(\"a method must have a '\\{' after the name.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        methNode.body := body",
  "        util.setline(btok.line)",
  "        if (false != anns) then { methNode.annotations.addAll(anns) }",
  "        values.push(methNode)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "",
  "method methodDecRest(tm, sameline) {",
  "    // Process the remainder of a method header. These follow",
  "    // mostly the same rules as calls, but aren't strictly enforced to be on",
  "    // a single line (because they are ended by \"{\"). ",
  "    //",
  "    // tm is a methodNode.  This method modifies tm.params in place.",
  "",
  "    var signature := tm.signature",
  "    while {(!sameline && accept(\"identifier\")) || acceptSameLine(\"identifier\")} do {",
  "        pushidentifier",
  "        def part = ast.signaturePart.partName(values.pop.nameString)",
  "        if ((accept(\"lparen\")).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"()\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"the declaration of a method with multiple \" ++",
  "                  \"parameter lists must have parentheses around each parameter list.\")",
  "                  atPosition(sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var comma := false",
  "        while {accept(\"identifier\")",
  "                || (accept(\"op\") && (sym.value == \"*\"))} do {",
  "            if (accept \"op\") then {",
  "                next",
  "                errormessages.syntaxError(\"variable length parameters (parameters prefixed by '*') are no longer part of Grace.  Consider making {sym.value} an Iterable.\")",
  "                    atPosition(lastToken.line, lastToken.linePos)",
  "            }",
  "            pushidentifier",
  "            def nxt = values.pop",
  "            nxt.isBindingOccurrence := true",
  "            nxt.dtype := optionalTypeAnnotation",
  "            part.params.push(nxt)",
  "            if (accept \"comma\") then {",
  "                comma := sym",
  "                next",
  "            }",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"a part of a multi-part method beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        signature.push(part)",
  "    }",
  "}",
  "",
  "method optionalTypeAnnotation {",
  "    // Accept a type annotation if present.",
  "    // Returns the type, or false if there is no annotation",
  "    if (accept \"colon\") then {",
  "        next",
  "        if (didConsume { typeexpression }) then {",
  "            values.pop",
  "        } else {",
  "            checkBadTypeLiteral",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteToken(lastToken)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"a type name or type expression must follow ':'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    } else {",
  "        false",
  "    }",
  "}",
  "",
  "method methodsignature(sameline) {",
  "    // Accept a method signature",
  "    if((sym.kind != \"identifier\") && (sym.kind != \"op\") && (sym.kind != \"lsquare\")) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\" «method name»\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"a method name must start with an identifier, or be an operator.\")",
  "            atPosition(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                withSuggestion(suggestion)",
  "    }",
  "    def startToken = sym",
  "    def part = ast.signaturePart.partName(startToken.value)",
  "    next",
  "    def result = ast.methodNode.new( [ part ], [], false)",
  "    if ((startToken.value == \"[\") && {sym.kind == \"rsquare\"}) then {",
  "        errormessages.syntaxError(\"methods named '[]' and '[]:=' are no longer part of Grace.\")",
  "            atRange(lastToken.line, lastToken.linePos, sym.linePos)",
  "    }",
  "    if (accept \"lgeneric\") then { result.typeParams := typeparameters }",
  "    if (accept \"bind\") then {",
  "        part.name := part.name ++ \":=\"",
  "        next",
  "    } elseif { accept \"op\"  && (startToken.value == \"prefix\") } then {",
  "        part.name := part.name ++ sym.value",
  "        next",
  "    }",
  "    if (accept \"lparen\") then {",
  "        def lparen = sym",
  "        next",
  "        var id",
  "        var comma := false",
  "        while {accept(\"identifier\") ||",
  "                (accept(\"op\") && (sym.value == \"*\"))} do {",
  "            // Parse the parameter list, including optional dtype",
  "            // annotations.",
  "            if (accept \"op\") then {",
  "                next",
  "                errormessages.syntaxError(\"variable length parameters (parameters prefixed by '*') are no longer part of Grace.  Consider making {sym.value} an Iterable.\")",
  "                    atPosition(lastToken.line, lastToken.linePos)",
  "            }",
  "            pushidentifier",
  "            id := values.pop",
  "            id.isBindingOccurrence := true",
  "            id.dtype := optionalTypeAnnotation",
  "            part.params.push(id)",
  "            if (accept \"comma\") then {",
  "                comma := sym",
  "                next",
  "            } elseif { sym.kind != \"rparen\" } then {",
  "                if(sym.kind != \"rparen\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"a part of a method beginning with a '(' must end with a ')'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def rparen = findNextToken({ t -> (t.kind == \"rparen\") && (t.line == lastToken.line) })",
  "            if(false == rparen) then {",
  "                suggestion.replaceToken(lastToken)with(\")\")",
  "            } else {",
  "                suggestion.deleteToken(sym)",
  "            }",
  "            errormessages.syntaxError(\"a part of a method beginning with a '(' must end with a ')'.\")atRange(",
  "                lastToken.line, lastToken.linePos, lastToken.linePos)withSuggestion(suggestion)",
  "        }",
  "        if (sym.line == part.line) then {",
  "            part.lineLength := sym.linePos - part.linePos",
  "        }",
  "        next",
  "        if ((!sameline && accept(\"identifier\")) ||",
  "            acceptSameLine(\"identifier\")) then {",
  "            // The presence of an identifier here means",
  "            // a multi-part method name.",
  "            methodDecRest(result, sameline)",
  "        }",
  "    }",
  "    if (accept \"arrow\") then {",
  "        // Return dtype",
  "        next",
  "        typeexpression",
  "        result.dtype := values.pop",
  "    }",
  "    result",
  "}",
  "",
  "method typeparameters {",
  "    next",
  "    def typeIds = [ ]",
  "    while {accept(\"identifier\")} do {",
  "        identifier",
  "        def id = values.pop",
  "        id.isBindingOccurrence := true",
  "        typeIds.push(id)",
  "        if (accept \"comma\") then {",
  "            next",
  "        }",
  "    }",
  "    typeIds.do { each -> each.isBindingOccurrence := true }",
  "    def result = ast.typeParametersNode.new(typeIds)",
  "    if(sym.kind != \"rgeneric\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\">\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"a list of type parameters starting with '<' must end with '>'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    result",
  "}",
  "",
  "method doimport {",
  "    // Accept an import statement, which has the form",
  "    //      import ‹string› as ‹identifier›:‹type expression› is ‹annotation›",
  "    if (acceptKeyword \"import\") then {",
  "        def importline = sym.line",
  "        next",
  "        if(sym.kind != \"string\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            var errorPos",
  "            if((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"\\\"{sym.value}\\\"\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" \\\"«module name»\\\"\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"an import statement must have the name of the module in quotes, 'as', and an identifier after 'import'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        pushstring",
  "        def p = values.pop",
  "        if((sym.kind != \"identifier\") || (sym.value != \"as\")) then {",
  "            var suggestion := errormessages.suggestion.new",
  "            if((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.insert(\" as\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.insert(\" as {p.value}\")afterToken(lastToken)",
  "            }",
  "            errormessages.syntaxError(\"an import statement must have 'as', and an identifier after the name of the module in quotes.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            var errorPos",
  "            if((sym.kind == \"string\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"{sym.value}\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" {p.value}\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"an import statement must have an identifier after 'as'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        def name = values.pop",
  "        name.isBindingOccurrence := true",
  "        def dtype = optionalTypeAnnotation",
  "        util.setline(importline)",
  "        def o = ast.importNode.new(p.value, name, dtype)",
  "        def anns = doannotation",
  "        if (false != anns) then { o.annotations.addAll(anns) }",
  "        values.push(o)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "method doreturn {",
  "    // Accept a return statement; 'return' is followed by an optional expression.",
  "    if (acceptKeyword \"return\") then {",
  "        def retTok = sym",
  "        next",
  "        var retval",
  "        if ((tokenOnSameLine) && {accept(\"rbrace\").not}) then {",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rbrace\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteToken(sym)leading(true)trailing(false)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                }",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a return statement must have either an expression or a new-line after 'return'.\")atRange(",
  "                    sym.line, sym.linePos, sym.linePos + sym.size - 1)withSuggestions(suggestions)",
  "            }",
  "            retval := values.pop",
  "        } else {",
  "            retval := ast.identifierNode.new(\"done\", false)",
  "        }",
  "        util.setPosition(retTok.line, retTok.linePos)",
  "        var o := ast.returnNode.new(retval)",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "method domethodtype {",
  "    // parses a method in a type literal",
  "    def methodTypeTok = sym",
  "    var methNode := methodsignature(true)",
  "    var dtype := methNode.dtype",
  "    if (false == methNode.dtype) then {",
  "        dtype := ast.identifierNode.new(\"Done\", false)",
  "    }",
  "    def o = ast.methodTypeNode.new(methNode.signature, dtype)",
  "                                            .setPositionFrom(methodTypeTok)",
  "    o.typeParams := methNode.typeParams",
  "    values.push(o)",
  "    reconcileComments",
  "    if (accept \"semicolon\") then {",
  "        next",
  "    } else {",
  "        if (!accept(\"rbrace\")) then {",
  "            if (lastToken.line == sym.line) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def newLine = util.lines.at(sym.line).substringFrom(1)to(lastToken.linePos - 1) ++ sym.value",
  "                suggestion.addLine(sym.line + 0.1, newLine)",
  "                suggestion.deleteToken(sym)leading(true)trailing(true)",
  "                errormessages.syntaxError(\"methods in a type literal must be on separate lines, or separated by semicolons.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "method dotypeLiteral {",
  "    // parses a type literal between braces, with optional leading 'type' keyword.",
  "    def typeLiteralTok = sym",
  "    if (acceptKeyword \"type\") then {",
  "        next",
  "        if (!accept(\"lbrace\")) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.replaceToken(sym) with(\"\\{\")",
  "            errormessages.syntaxError \"type literals must open with a brace.\"",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "            return",
  "        }",
  "    }",
  "    if (accept \"lbrace\") then {",
  "        def meths = []",
  "        def types = []",
  "        def mc = auto_count",
  "        auto_count := auto_count + 1",
  "        next",
  "        while {accept(\"rbrace\").not} do {",
  "            if (acceptKeyword \"type\") then {",
  "                typedec",
  "                types.push(values.pop)",
  "            } else {",
  "                domethodtype",
  "                meths.push(values.pop)",
  "            }",
  "        }",
  "        next",
  "        util.setPosition(typeLiteralTok.line, typeLiteralTok.linePos)",
  "        def t = ast.typeLiteralNode.new(meths, types)",
  "        values.push(t)",
  "    }",
  "}",
  "",
  "method typedec {",
  "    // Accept a declaration: 'type = <type expression>'",
  "    if (acceptKeyword \"type\") then {",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"a type declaration must have a name after the 'type'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        util.setPosition(line, pos)",
  "        def nt = ast.typeDecNode.new(values.pop, false)",
  "        if (accept \"lgeneric\") then { nt.typeParams := typeparameters }",
  "        nt.name.isBindingOccurrence := true",
  "        def anns = doannotation",
  "        if((sym.kind != \"op\") || (sym.value != \"=\")) then {",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextToken({ t -> t.kind == \"lbrace\" })",
  "            if ((false == nextTok) || {nextTok == sym}) then {",
  "                suggestion.insert(\" =\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)with(\"=\")",
  "            }",
  "            errormessages.syntaxError \"a type declaration must have an '=' after the type name.\"",
  "                  atPosition(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                  withSuggestion(suggestion)",
  "        }",
  "        next",
  "        // Special case for type Literals without leading 'type' keyword.",
  "        if (accept \"lbrace\") then {",
  "            dotypeLiteral",
  "        } else {",
  "            expression(noBlocks)",
  "        }",
  "        nt.value := values.pop",
  "        if (false != anns) then {",
  "            nt.annotations.addAll(anns)",
  "        }",
  "        values.push(nt)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "method checkIndent {",
  "    if (indentFreePass) then {",
  "        indentFreePass := false",
  "    } elseif { sym.kind == \"semicolon\" } then {",
  "        // pass",
  "    } elseif {(sym.kind == \"rbrace\") || (sym.kind == \"rparen\")",
  "          || (sym.kind == \"rsquare\")} then {",
  "        // pass",
  "    } elseif { sym.kind == \"eof\" } then {",
  "    } elseif { sym.indent < minIndentLevel } then {",
  "        if ((sym.linePos - 1) != minIndentLevel) then {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            for(1..(minIndentLevel - (sym.linePos - 1))) do { _ ->",
  "                suggestion.insert \" \" atPosition 1 onLine(sym.line)",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            // Find the indent level for the opening brace.",
  "            var tok := lastToken",
  "            while {(tok.linePos != (tok.indent + 1)) || (tok.indent >= minIndentLevel)} do { ",
  "                tok := tok.prev ",
  "            }",
  "            var line := \"\"",
  "            for(1..(tok.indent)) do { _ ->",
  "                line := line ++ \" \"",
  "            }",
  "            line := line ++ \"}\"",
  "            suggestion.addLine(sym.line - 0.9, line)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"the indentation for this line must be \" ++",
  "                  \"at least {minIndentLevel}. This is often caused by a missing '}'.\")",
  "                  atPosition(sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    } elseif { sym.indent > (minIndentLevel + 1) } then {",
  "        minIndentLevel := sym.indent",
  "    } elseif { (sym.indent - lastIndent).abs == 1 } then {",
  "        def m1 = \"the indentation for this line can't differ \"",
  "        def m2 = \"from that of the previous line by 1.\\n  To start a block, or \"",
  "        def m3 = \"to signal a continuation line, increase the indent by 2 or more. \"",
  "        def m4 = \"To end a block, or end the continuation, decrease the indent \"",
  "        def m5 = \"to the prior level. Otherwise, use the same indent as the previous line.\"",
  "        def msg = m1 ++ m2 ++ m3 ++ m4 ++ m5",
  "        errormessages.syntaxError(msg) atPosition(sym.line, sym.linePos)",
  "    }",
  "}",
  "",
  "method statement {",
  "    // Accept a statement. A statement is any of the above that may exist",
  "    // at the top level, and includes expressions.",
  "    // A statement may also be a bind statement x := y, which creates a",
  "    // bind AST node out of the expressions on either side (which at this point",
  "    // can be any arbitrary expression).",
  "",
  "    statementIndent := sym.indent",
  "    statementToken := sym",
  "    def btok = sym",
  "    checkIndent",
  "    if (accept \"keyword\") then {",
  "        if (sym.value == \"var\") then {",
  "            vardec",
  "        } elseif { sym.value == \"def\" } then {",
  "            defdec",
  "        } elseif { sym.value == \"import\" } then {",
  "            doimport",
  "        } elseif { sym.value == \"dialect\" } then {",
  "            dodialect",
  "        } elseif { sym.value == \"type\" } then {",
  "            typedec",
  "        } elseif { sym.value == \"class\" } then {",
  "            doclass",
  "        } elseif { sym.value == \"trait\" } then {",
  "            doclass",
  "        } elseif { sym.value == \"factory\" } then {",
  "            dofactoryMethod",
  "        } elseif { sym.value == \"return\" } then {",
  "            doreturn",
  "        } else {",
  "            expression(blocksOK)",
  "        }",
  "    } else {",
  "        ifConsume {expression(blocksOK)} then {",
  "            if (((values.last.kind == \"identifier\")",
  "                || (values.last.kind == \"member\")",
  "                || (values.last.kind == \"index\"))",
  "                && accept(\"bind\")) then {",
  "                var dest := values.pop",
  "                if (dest.kind == \"lbrace\") then {",
  "                    print \"sym = {sym}, sym.line = {sym.line}\"",
  "                    ProgrammingError.raise \"popped lbrace token while parsing statement\"",
  "                }",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = [ ]",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rbrace\"] )",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a valid expression must follow ':='.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                var val := values.pop",
  "                util.setPosition(btok.line, btok.linePos)",
  "                var o := ast.bindNode.new(dest, val)",
  "                values.push(o)",
  "            }",
  "        }",
  "    }",
  "    reconcileComments",
  "    if (accept \"eof\") then {",
  "        return true",
  "    }",
  "    if (accept \"semicolon\") then {",
  "        def oldLine = sym.line",
  "        next",
  "        if (sym.line == oldLine) then {",
  "            indentFreePass := true",
  "        }",
  "    } else {",
  "        checkUnexpectedTokenAfterStatement",
  "    }",
  "}",
  "",
  "method pushComments {",
  "    // Push a comment onto the comments stack as a commentNode. If",
  "    // there are consecutive comments following, deal with them all.",
  "    // Adjacent comments extend the first; a break of a blank line",
  "    // starts a new comment node.",
  "",
  "    if ( ! accept \"comment\" ) then { return }",
  "    util.setPosition(sym.line, sym.linePos)",
  "    var o := ast.commentNode.new(sym.value)",
  "    if ((lastToken.line == sym.line) && (lastToken.kind != \"comment\")) then {",
  "        o.isPartialLine := true",
  "    } elseif { lastToken.line < (sym.line - 1) } then {",
  "        o.isPreceededByBlankLine := true",
  "    }",
  "    comments.push(o)",
  "    while { ",
  "        previousCommentToken := sym",
  "        sym := tokens.poll",
  "        if (sym.line > (previousCommentToken.line + 1)) then { noteBlank }",
  "        accept \"comment\"",
  "    } do {",
  "        util.setPosition(sym.line, sym.linePos)",
  "        o := ast.commentNode.new(sym.value)",
  "        if ( comments.last.endLine == (sym.line - 1) ) then {",
  "            comments.last.extendCommentUsing(o)",
  "        } else {",
  "            comments.push(o)",
  "            if ( lastToken.line < (sym.line - 1) ) then {",
  "                o.isPreceededByBlankLine := true",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "method reconcileComments {",
  "    // Should be requested after a new node that represents a \"syntactic unit\"",
  "    // to which comments can be attached is pushed onto `values`",
  "    // Finds comments associated with that node, remove thems from comments",
  "    // stack, and puts them in that node's comments attribute.",
  "",
  "    pushComments",
  "    def node = if (values.isEmpty) then {",
  "        moduleObject ",
  "    } else {",
  "        values.last",
  "    }",
  "    if (node.kind == \"lbrace\") then {",
  "        // lbrace nodes are not AST nodes.  They are used to mark the stack for",
  "        // nested expressions.  Hence, no comments should be attached to them.",
  "        return",
  "    }",
  "    def oLine = node.line",
  "    def preComments = emptyList",
  "    def postComments = emptyList",
  "",
  "    var ix := comments.size",
  "    while { ix > 0 } do {",
  "        def each = comments.at(ix)",
  "        def isPostComment = (each.line == oLine) || (each.line == (oLine+1))",
  "        def isPreComment = each.isPreceededByBlankLine && (each.endLine == (oLine-1))",
  "        if (isPostComment) then {",
  "            postComments.push(comments.removeAt(ix))",
  "        } elseif { isPreComment } then {",
  "            preComments.addFirst(comments.removeAt(ix))",
  "        } elseif { each.endLine < (oLine-1) } then {",
  "            ix := 0     // exit from while",
  "        }",
  "        ix := ix - 1",
  "    }",
  "",
  "    def postSz = postComments.size",
  "    def preSz = preComments.size",
  "",
  "    if ((postSz > 1) && (preSz > 1)) then {",
  "        preComments.last.value := preComments.last.value ++ \"\\n\"",
  "    }",
  "    node.addComments(preComments)",
  "    node.addComments(postComments)",
  "}",
  "",
  "method checkBadOperators {",
  "    if (sym.value == \"=\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\"=\")afterToken(sym)",
  "        errormessages.syntaxError(\"use '==' to test equality, not '='.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "    if (sym.kind == \"rgeneric\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\" \")beforeToken(sym)",
  "        errormessages.syntaxError(\"the '>' operator must be preceded by a space.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "}",
  "",
  "method checkBadTypeLiteral {",
  "    if (sym.kind == \"lbrace\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\"type \") beforeToken(sym)",
  "        errormessages.syntaxError(\"type literals must start with the keyword 'type'.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "}",
  "",
  "method checkUnexpectedTokenAfterStatement {",
  "    if (sym.line == lastToken.line) then {",
  "        if ((sym.kind == \"op\") && (sym.value == \"=\")",
  "            && (lastToken.kind == \"identifier\")) then {",
  "            def sugg = errormessages.suggestion.new",
  "            def suggestions = [ ]",
  "            sugg.replaceToken(sym)leading(false)trailing(false)with(\":=\")",
  "            suggestions.push(sugg)",
  "            def sugg2 = errormessages.suggestion.new",
  "            sugg2.replaceToken(sym)leading(false)trailing(false)with \"==\"",
  "            suggestions.push(sugg2)",
  "            errormessages.syntaxError(\"assignment uses ':=', not '='.\")",
  "                atRange(sym.line, sym.linePos, sym.linePos)",
  "                withSuggestions (suggestions)",
  "        }",
  "        if (sym.kind == \"rgeneric\") then {",
  "            def sugg = errormessages.suggestion.new",
  "            sugg.insert(\" \")atPosition(sym.linePos)onLine(sym.line)",
  "            errormessages.syntaxError(",
  "                    \"The '>' operator must have a space before it.\")",
  "                atRange(sym.line, sym.linePos, sym.linePos)",
  "                withSuggestion(sugg)",
  "        }",
  "        if (sym.kind != \"rbrace\") then {",
  "            def suggestions = [ ]",
  "            var suggestion",
  "            if ( (values.size > 0) && { (values.last.kind == \"identifier\") || { values.last.kind == \"member\" }} && { sym.kind == \"identifier\" } ) then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value})\")",
  "                suggestions.push(suggestion)",
  "                if (false != sym.next) then {",
  "                    def n = sym.next",
  "                    if (n.line == sym.line) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value}\")",
  "                        suggestion.append \")\" onLine(sym.line)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                }",
  "                if (values.last.kind == \"identifier\") then {",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.replaceToken(sym)leading(false)trailing(false)with(\"\\\"{sym.value}\\\"\")",
  "                    suggestions.push(suggestion)",
  "                }",
  "            }",
  "            def nextTok = findNextValidToken( [\"rbrace\"] )",
  "            if(nextTok == sym) then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.addLine(lastToken.line, util.lines.at(lastToken.line).substringFrom(1)to(lastToken.linePos + lastToken.size - 1))",
  "                def newLine = util.lines.at(sym.line).substringFrom(sym.linePos)to(util.lines.at(sym.line).size)",
  "                suggestion.addLine(lastToken.line + 0.1, newLine)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"multiple statements must be separated by a newline or a semicolon. This is often caused by missing parentheses.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    }",
  "}",
  "",
  "",
  "method parse(toks) {",
  "    // Parse the given list of tokens, toks, returning an AST moduleNode",
  "    // corresponding to it.",
  "",
  "    util.log_verbose \"parsing.\"",
  "    moduleObject := ast.moduleNode.body(values) named (util.modname)",
  "",
  "    if (toks.size == 0) then {",
  "        return moduleObject",
  "    }",
  "    tokens := toks",
  "    next",
  "    if (sym.indent > 0) then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.deleteRange(1, sym.indent) onLine(sym.line)",
  "        errormessages.syntaxError \"the first line must not be indented.\"",
  "            atRange(sym.line, 1, sym.indent)",
  "            withSuggestion(sugg)",
  "    }",
  "    var oldlength := tokens.size",
  "    while {tokens.size > 0} do {",
  "        blank",
  "        methoddec",
  "        blank",
  "        ifConsume { inheritsOrUses } then {",
  "            def parentNode = values.pop",
  "            if (parentNode.isUse) then {",
  "                moduleObject.usedTraits.add(parentNode)",
  "            } elseif { moduleObject.usedTraits.isEmpty } then {",
  "                moduleObject.superclass := parentNode",
  "            } else {",
  "                errormessages.syntaxError(\"'inherit' must come \" ++",
  "                    \"before 'use' in a module.\")",
  "                    atRange(parentNode.line, parentNode.linePos,",
  "                    parentNode.linePos + 7)",
  "            }",
  "        }",
  "        blank",
  "        statement",
  "        blank",
  "        if (tokens.size == oldlength) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.deleteToken(sym)",
  "            errormessages.syntaxError(\"invalid statement. This is often \" ++",
  "                \"caused by an extra '}', ')', or ']'.\")",
  "                atRange(sym.line, sym.linePos, sym.linePos + sym.size - 1)",
  "                withSuggestion(suggestion)",
  "        }",
  "        oldlength := tokens.size",
  "    }",
  "    blank",
  "    statement",
  "    blank",
  "    return moduleObject",
  "}",
  NULL
};
Object reader_parser_outer_236(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_found_237(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_found_237(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_tok_238(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_tok_238(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_outer_8187(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_8188(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_parser_register_8189(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_register_8189(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_outer_11048(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_11049(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_parser_line_11050(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_parser_linePos_11051(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_parser_indent_11052(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_parser_value_11053(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_parser_size_11054(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
static Object strlit49;
static Object strlit51;
static Object strlit111;
static Object strlit159;
static Object strlit192;
static Object strlit193;
static Object strlit194;
static Object strlit195;
static Object strlit196;
static Object strlit197;
static Object strlit198;
static Object strlit199;
static Object strlit205;
static ClassData objclass235;
static Object strlit252;
static Object strlit263;
static Object strlit275;
static Object strlit303;
static Object strlit314;
static Object strlit326;
static Object strlit343;
static Object strlit360;
static Object strlit391;
static Object strlit594;
static Object strlit599;
static Object strlit604;
static Object strlit609;
static Object strlit614;
static Object strlit618;
static Object strlit625;
static Object strlit707;
static Object strlit715;
static Object strlit733;
static Object strlit761;
static Object strlit771;
static Object strlit795;
static Object strlit824;
static Object strlit848;
static Object strlit855;
static Object strlit862;
static Object strlit880;
static Object strlit899;
static Object strlit929;
static Object strlit936;
static Object strlit943;
static Object strlit961;
static Object strlit1022;
static Object strlit1074;
static Object strlit1084;
static Object strlit1093;
static Object strlit1114;
static Object strlit1121;
static Object strlit1128;
static Object strlit1131;
static Object strlit1139;
static Object strlit1151;
static Object strlit1154;
static Object strlit1200;
static Object strlit1217;
static Object strlit1235;
static Object strlit1240;
static Object strlit1244;
static Object strlit1253;
static Object strlit1276;
static Object strlit1277;
static Object strlit1284;
static Object strlit1291;
static Object strlit1309;
static Object strlit1341;
static Object strlit1351;
static Object strlit1382;
static Object strlit1387;
static Object strlit1399;
static Object strlit1425;
static Object strlit1435;
static Object strlit1442;
static Object strlit1449;
static Object strlit1452;
static Object strlit1455;
static Object strlit1465;
static Object strlit1475;
static Object strlit1492;
static Object strlit1497;
static Object strlit1507;
static Object strlit1516;
static Object strlit1547;
static Object strlit1554;
static Object strlit1561;
static Object strlit1579;
static Object strlit1601;
static Object strlit1625;
static Object strlit1650;
static Object strlit1671;
static Object strlit1674;
static Object strlit1723;
static Object strlit1730;
static Object strlit1740;
static Object strlit1748;
static Object strlit1756;
static Object strlit1759;
static Object strlit1762;
static Object strlit1765;
static Object strlit1768;
static Object strlit1769;
static Object strlit1772;
static Object strlit1786;
static Object strlit1793;
static Object strlit1802;
static Object strlit1810;
static Object strlit1817;
static Object strlit1842;
static Object strlit1846;
static Object strlit1856;
static Object strlit1859;
static Object strlit1863;
static Object strlit1873;
static Object strlit1876;
static Object strlit1879;
static Object strlit1886;
static Object strlit1896;
static Object strlit1899;
static Object strlit1902;
static Object strlit1909;
static Object strlit1911;
static Object strlit1939;
static Object strlit1962;
static Object strlit1970;
static Object strlit1977;
static Object strlit1981;
static Object strlit1983;
static Object strlit1995;
static Object strlit1999;
static Object strlit2001;
static Object strlit2013;
static Object strlit2017;
static Object strlit2019;
static Object strlit2045;
static Object strlit2050;
static Object strlit2055;
static Object strlit2059;
static Object strlit2065;
static Object strlit2090;
static Object strlit2097;
static Object strlit2104;
static Object strlit2130;
static Object strlit2141;
static Object strlit2146;
static Object strlit2151;
static Object strlit2154;
static Object strlit2188;
static Object strlit2223;
static Object strlit2234;
static Object strlit2239;
static Object strlit2259;
static Object strlit2266;
static Object strlit2277;
static Object strlit2293;
static Object strlit2300;
static Object strlit2309;
static Object strlit2316;
static Object strlit2340;
static Object strlit2344;
static Object strlit2354;
static Object strlit2357;
static Object strlit2361;
static Object strlit2371;
static Object strlit2374;
static Object strlit2377;
static Object strlit2384;
static Object strlit2394;
static Object strlit2397;
static Object strlit2400;
static Object strlit2407;
static Object strlit2409;
static Object strlit2437;
static Object strlit2460;
static Object strlit2468;
static Object strlit2475;
static Object strlit2478;
static Object strlit2489;
static Object strlit2492;
static Object strlit2503;
static Object strlit2506;
static Object strlit2520;
static Object strlit2532;
static Object strlit2536;
static Object strlit2538;
static Object strlit2558;
static Object strlit2565;
static Object strlit2578;
static Object strlit2600;
static Object strlit2605;
static Object strlit2616;
static Object strlit2621;
static Object strlit2638;
static Object strlit2641;
static Object strlit2652;
static Object strlit2655;
static Object strlit2658;
static Object strlit2666;
static Object strlit2692;
static Object strlit2703;
static Object strlit2708;
static Object strlit2713;
static Object strlit2716;
static Object strlit2750;
static Object strlit2785;
static Object strlit2796;
static Object strlit2801;
static Object strlit2829;
static Object strlit2836;
static Object strlit2843;
static Object strlit2869;
static Object strlit2880;
static Object strlit2885;
static Object strlit2890;
static Object strlit2893;
static Object strlit2927;
static Object strlit2962;
static Object strlit2973;
static Object strlit2978;
static Object strlit3009;
static Object strlit3031;
static Object strlit3036;
static Object strlit3047;
static Object strlit3052;
static Object strlit3069;
static Object strlit3072;
static Object strlit3083;
static Object strlit3086;
static Object strlit3090;
static Object strlit3092;
static Object strlit3104;
static Object strlit3108;
static Object strlit3120;
static Object strlit3128;
static Object strlit3148;
static Object strlit3155;
static Object strlit3162;
static Object strlit3165;
static Object strlit3173;
static Object strlit3185;
static Object strlit3188;
static Object strlit3218;
static Object strlit3225;
static Object strlit3232;
static Object strlit3238;
static Object strlit3265;
static Object strlit3289;
static Object strlit3303;
static Object strlit3314;
static Object strlit3325;
static Object strlit3336;
static Object strlit3347;
static Object strlit3361;
static Object strlit3401;
static Object strlit3407;
static Object strlit3417;
static Object strlit3424;
static Object strlit3428;
static Object strlit3443;
static Object strlit3453;
static Object strlit3460;
static Object strlit3464;
static Object strlit3488;
static Object strlit3495;
static Object strlit3504;
static Object strlit3510;
static Object strlit3525;
static Object strlit3532;
static Object strlit3550;
static Object strlit3558;
static Object strlit3573;
static Object strlit3577;
static Object strlit3583;
static Object strlit3587;
static Object strlit3597;
static Object strlit3601;
static Object strlit3606;
static Object strlit3612;
static Object strlit3615;
static Object strlit3618;
static Object strlit3651;
static Object strlit3658;
static Object strlit3665;
static Object strlit3668;
static Object strlit3676;
static Object strlit3688;
static Object strlit3691;
static Object strlit3713;
static Object strlit3720;
static Object strlit3730;
static Object strlit3736;
static Object strlit3756;
static Object strlit3763;
static Object strlit3770;
static Object strlit3773;
static Object strlit3781;
static Object strlit3793;
static Object strlit3796;
static Object strlit3822;
static Object strlit3827;
static Object strlit3836;
static Object strlit3846;
static Object strlit3851;
static Object strlit3856;
static Object strlit3861;
static Object strlit3876;
static Object strlit3883;
static Object strlit3891;
static Object strlit3895;
static Object strlit3898;
static Object strlit3900;
static Object strlit3917;
static Object strlit3924;
static Object strlit3931;
static Object strlit3937;
static Object strlit3957;
static Object strlit3964;
static Object strlit3971;
static Object strlit3974;
static Object strlit3982;
static Object strlit3994;
static Object strlit3997;
static Object strlit4023;
static Object strlit4028;
static Object strlit4037;
static Object strlit4047;
static Object strlit4052;
static Object strlit4057;
static Object strlit4062;
static Object strlit4089;
static Object strlit4096;
static Object strlit4105;
static Object strlit4120;
static Object strlit4127;
static Object strlit4144;
static Object strlit4159;
static Object strlit4163;
static Object strlit4173;
static Object strlit4176;
static Object strlit4180;
static Object strlit4186;
static Object strlit4189;
static Object strlit4195;
static Object strlit4224;
static Object strlit4231;
static Object strlit4238;
static Object strlit4241;
static Object strlit4251;
static Object strlit4263;
static Object strlit4266;
static Object strlit4286;
static Object strlit4293;
static Object strlit4303;
static Object strlit4309;
static Object strlit4329;
static Object strlit4336;
static Object strlit4343;
static Object strlit4346;
static Object strlit4354;
static Object strlit4366;
static Object strlit4369;
static Object strlit4395;
static Object strlit4400;
static Object strlit4409;
static Object strlit4419;
static Object strlit4424;
static Object strlit4429;
static Object strlit4434;
static Object strlit4468;
static Object strlit4474;
static Object strlit4481;
static Object strlit4488;
static Object strlit4496;
static Object strlit4503;
static Object strlit4510;
static Object strlit4516;
static Object strlit4522;
static Object strlit4528;
static Object strlit4534;
static Object strlit4541;
static Object strlit4545;
static Object strlit4555;
static Object strlit4570;
static Object strlit4597;
static Object strlit4604;
static Object strlit4611;
static Object strlit4614;
static Object strlit4622;
static Object strlit4634;
static Object strlit4637;
static Object strlit4670;
static Object strlit4693;
static Object strlit4700;
static Object strlit4707;
static Object strlit4713;
static Object strlit4730;
static Object strlit4738;
static Object strlit4748;
static Object strlit4751;
static Object strlit4764;
static Object strlit4766;
static Object strlit4776;
static Object strlit4782;
static Object strlit4803;
static Object strlit4806;
static Object strlit4816;
static Object strlit4819;
static Object strlit4835;
static Object strlit4843;
static Object strlit4851;
static Object strlit4873;
static Object strlit4879;
static Object strlit4885;
static Object strlit4890;
static Object strlit4909;
static Object strlit4920;
static Object strlit4923;
static Object strlit4935;
static Object strlit4940;
static Object strlit4951;
static Object strlit5010;
static Object strlit5025;
static Object strlit5033;
static Object strlit5037;
static Object strlit5047;
static Object strlit5051;
static Object strlit5057;
static Object strlit5061;
static Object strlit5071;
static Object strlit5083;
static Object strlit5086;
static Object strlit5122;
static Object strlit5126;
static Object strlit5146;
static Object strlit5157;
static Object strlit5163;
static Object strlit5193;
static Object strlit5194;
static Object strlit5195;
static Object strlit5196;
static Object strlit5204;
static Object strlit5208;
static Object strlit5218;
static Object strlit5222;
static Object strlit5243;
static Object strlit5250;
static Object strlit5254;
static Object strlit5331;
static Object strlit5340;
static Object strlit5354;
static Object strlit5374;
static Object strlit5381;
static Object strlit5386;
static Object strlit5391;
static Object strlit5396;
static Object strlit5402;
static Object strlit5408;
static Object strlit5432;
static Object strlit5437;
static Object strlit5456;
static Object strlit5463;
static Object strlit5494;
static Object strlit5501;
static Object strlit5523;
static Object strlit5550;
static Object strlit5559;
static Object strlit5570;
static Object strlit5586;
static Object strlit5600;
static Object strlit5616;
static Object strlit5681;
static Object strlit5687;
static Object strlit5698;
static Object strlit5712;
static Object strlit5738;
static Object strlit5767;
static Object strlit5774;
static Object strlit5781;
static Object strlit5799;
static Object strlit5815;
static Object strlit5845;
static Object strlit5852;
static Object strlit5859;
static Object strlit5877;
static Object strlit5885;
static Object strlit5891;
static Object strlit5902;
static Object strlit5916;
static Object strlit5940;
static Object strlit5969;
static Object strlit5976;
static Object strlit5983;
static Object strlit6001;
static Object strlit6025;
static Object strlit6037;
static Object strlit6040;
static Object strlit6074;
static Object strlit6100;
static Object strlit6111;
static Object strlit6121;
static Object strlit6128;
static Object strlit6133;
static Object strlit6135;
static Object strlit6152;
static Object strlit6158;
static Object strlit6191;
static Object strlit6195;
static Object strlit6209;
static Object strlit6231;
static Object strlit6246;
static Object strlit6255;
static Object strlit6261;
static Object strlit6267;
static Object strlit6271;
static Object strlit6279;
static Object strlit6283;
static Object strlit6290;
static Object strlit6298;
static Object strlit6302;
static Object strlit6305;
static Object strlit6313;
static Object strlit6317;
static Object strlit6320;
static Object strlit6327;
static Object strlit6330;
static Object strlit6337;
static Object strlit6344;
static Object strlit6366;
static Object strlit6373;
static Object strlit6380;
static Object strlit6398;
static Object strlit6408;
static Object strlit6439;
static Object strlit6446;
static Object strlit6453;
static Object strlit6471;
static Object strlit6494;
static Object strlit6506;
static Object strlit6509;
static Object strlit6526;
static Object strlit6549;
static Object strlit6559;
static Object strlit6582;
static Object strlit6589;
static Object strlit6604;
static Object strlit6611;
static Object strlit6618;
static Object strlit6622;
static Object strlit6624;
static Object strlit6646;
static Object strlit6653;
static Object strlit6680;
static Object strlit6687;
static Object strlit6690;
static Object strlit6706;
static Object strlit6714;
static Object strlit6724;
static Object strlit6730;
static Object strlit6732;
static Object strlit6751;
static Object strlit6761;
static Object strlit6767;
static Object strlit6769;
static Object strlit6804;
static Object strlit6814;
static Object strlit6836;
static Object strlit6859;
static Object strlit6866;
static Object strlit6869;
static Object strlit6889;
static Object strlit6916;
static Object strlit6923;
static Object strlit6942;
static Object strlit6944;
static Object strlit6962;
static Object strlit6969;
static Object strlit6978;
static Object strlit6988;
static Object strlit6993;
static Object strlit7023;
static Object strlit7040;
static Object strlit7069;
static Object strlit7076;
static Object strlit7083;
static Object strlit7101;
static Object strlit7118;
static Object strlit7128;
static Object strlit7131;
static Object strlit7153;
static Object strlit7159;
static Object strlit7179;
static Object strlit7187;
static Object strlit7193;
static Object strlit7201;
static Object strlit7216;
static Object strlit7234;
static Object strlit7240;
static Object strlit7248;
static Object strlit7255;
static Object strlit7283;
static Object strlit7290;
static Object strlit7297;
static Object strlit7315;
static Object strlit7321;
static Object strlit7326;
static Object strlit7332;
static Object strlit7337;
static Object strlit7370;
static Object strlit7394;
static Object strlit7400;
static Object strlit7409;
static Object strlit7426;
static Object strlit7433;
static Object strlit7452;
static Object strlit7468;
static Object strlit7470;
static Object strlit7499;
static Object strlit7504;
static Object strlit7505;
static Object strlit7512;
static Object strlit7525;
static Object strlit7538;
static Object strlit7541;
static Object strlit7545;
static Object strlit7550;
static Object strlit7554;
static Object strlit7604;
static Object strlit7613;
static Object strlit7643;
static Object strlit7647;
static Object strlit7651;
static Object strlit7667;
static Object strlit7671;
static Object strlit7676;
static Object strlit7682;
static Object strlit7731;
static Object strlit7735;
static Object strlit7740;
static Object strlit7746;
static Object strlit7801;
static Object strlit7809;
static Object strlit7819;
static Object strlit7829;
static Object strlit7838;
static Object strlit7843;
static Object strlit7861;
static Object strlit7884;
static Object strlit7885;
static Object strlit7912;
static Object strlit7922;
static Object strlit7928;
static Object strlit7936;
static Object strlit7948;
static Object strlit7954;
static Object strlit7970;
static Object strlit7986;
static Object strlit7996;
static Object strlit8015;
static Object strlit8028;
static Object strlit8038;
static Object strlit8048;
static Object strlit8056;
static Object strlit8066;
static Object strlit8076;
static Object strlit8085;
static Object strlit8090;
static Object strlit8109;
static Object strlit8110;
static Object strlit8141;
static Object strlit8158;
static ClassData objclass8186;
static Object strlit8190;
static Object strlit8191;
static Object strlit8201;
static Object strlit8220;
static Object strlit8244;
static Object strlit8255;
static Object strlit8260;
static Object strlit8288;
static Object strlit8300;
static Object strlit8303;
static Object strlit8307;
static Object strlit8311;
static Object strlit8349;
static Object strlit8354;
static Object strlit8377;
static Object strlit8385;
static Object strlit8389;
static Object strlit8391;
static Object strlit8407;
static Object strlit8414;
static Object strlit8419;
static Object strlit8427;
static Object strlit8433;
static Object strlit8439;
static Object strlit8464;
static Object strlit8473;
static Object strlit8483;
static Object strlit8486;
static Object strlit8506;
static Object strlit8528;
static Object strlit8544;
static Object strlit8555;
static Object strlit8563;
static Object strlit8570;
static Object strlit8582;
static Object strlit8585;
static Object strlit8620;
static Object strlit8628;
static Object strlit8635;
static Object strlit8645;
static Object strlit8653;
static Object strlit8657;
static Object strlit8668;
static Object strlit8675;
static Object strlit8691;
static Object strlit8702;
static Object strlit8709;
static Object strlit8714;
static Object strlit8722;
static Object strlit8728;
static Object strlit8734;
static Object strlit8760;
static Object strlit8767;
static Object strlit8774;
static Object strlit8784;
static Object strlit8787;
static Object strlit8802;
static Object strlit8824;
static Object strlit8838;
static Object strlit8843;
static Object strlit8873;
static Object strlit8878;
static Object strlit8889;
static Object strlit8907;
static Object strlit8923;
static Object strlit8943;
static Object strlit8953;
static Object strlit8956;
static Object strlit8972;
static Object strlit8980;
static Object strlit9000;
static Object strlit9008;
static Object strlit9014;
static Object strlit9022;
static Object strlit9037;
static Object strlit9048;
static Object strlit9055;
static Object strlit9076;
static Object strlit9083;
static Object strlit9087;
static Object strlit9093;
static Object strlit9098;
static Object strlit9117;
static Object strlit9137;
static Object strlit9145;
static Object strlit9151;
static Object strlit9160;
static Object strlit9166;
static Object strlit9183;
static Object strlit9222;
static Object strlit9232;
static Object strlit9257;
static Object strlit9264;
static Object strlit9282;
static Object strlit9300;
static Object strlit9321;
static Object strlit9353;
static Object strlit9377;
static Object strlit9384;
static Object strlit9432;
static Object strlit9441;
static Object strlit9448;
static Object strlit9456;
static Object strlit9459;
static Object strlit9467;
static Object strlit9483;
static Object strlit9491;
static Object strlit9524;
static Object strlit9534;
static Object strlit9544;
static Object strlit9547;
static Object strlit9575;
static Object strlit9591;
static Object strlit9598;
static Object strlit9612;
static Object strlit9634;
static Object strlit9639;
static Object strlit9642;
static Object strlit9661;
static Object strlit9690;
static Object strlit9698;
static Object strlit9706;
static Object strlit9713;
static Object strlit9722;
static Object strlit9765;
static Object strlit9809;
static Object strlit9820;
static Object strlit9827;
static Object strlit9844;
static Object strlit9848;
static Object strlit9852;
static Object strlit9884;
static Object strlit9885;
static Object strlit9886;
static Object strlit9887;
static Object strlit9888;
static Object strlit9916;
static Object strlit9920;
static Object strlit9929;
static Object strlit9938;
static Object strlit9947;
static Object strlit9956;
static Object strlit9965;
static Object strlit9974;
static Object strlit9983;
static Object strlit9992;
static Object strlit10012;
static Object strlit10017;
static Object strlit10027;
static Object strlit10036;
static Object strlit10050;
static Object strlit10056;
static Object strlit10063;
static Object strlit10067;
static Object strlit10074;
static Object strlit10097;
static Object strlit10104;
static Object strlit10111;
static Object strlit10129;
static Object strlit10155;
static Object strlit10160;
static Object strlit10180;
static Object strlit10198;
static Object strlit10254;
static Object strlit10319;
static Object strlit10422;
static Object strlit10439;
static Object strlit10449;
static Object strlit10452;
static Object strlit10462;
static Object strlit10472;
static Object strlit10475;
static Object strlit10486;
static Object strlit10496;
static Object strlit10499;
static Object strlit10519;
static Object strlit10527;
static Object strlit10534;
static Object strlit10549;
static Object strlit10560;
static Object strlit10565;
static Object strlit10575;
static Object strlit10585;
static Object strlit10592;
static Object strlit10602;
static Object strlit10613;
static Object strlit10627;
static Object strlit10637;
static Object strlit10664;
static Object strlit10670;
static Object strlit10702;
static Object strlit10708;
static Object strlit10713;
static Object strlit10721;
static Object strlit10737;
static Object strlit10743;
static Object strlit10751;
static Object strlit10828;
static Object strlit10836;
static Object strlit10874;
static Object strlit10927;
static Object strlit10929;
static Object strlit10964;
static Object strlit10966;
Object module_io;
Object module_io_init();
Object module_ast;
Object module_ast_init();
Object module_util;
Object module_util_init();
Object module_errormessages;
Object module_errormessages_init();
static ClassData objclass11047;
static Object strlit11055;
static Object strlit11059;
Object meth_parser_noteBlank1(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "noteBlank");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_blankLocation = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3 = alloc_Float64(1);
// compiled num node returning num3 (depth = 4)
  int op_slot_right_2 = gc_frame_newslot(num3);
// starting to compile member node (depth = 4)
  int callframe5 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call6 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5);
// compiled member node returning call6 (depth = 4)
  int op_slot_left_2 = gc_frame_newslot(call6);
  params[0] = num3;
  partcv[0] = 1;
  Object diff7 = callmethod(call6, "-(1)", 1, partcv, params);
// compiled op node returning diff7 (depth = 3)
  *var_blankLocation = diff7;
  if (diff7 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_next9(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[2];
  Object *var_tokens = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_lastLine = getfromclosure(closure, 3);
  Object *var_lastIndent = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num12 = alloc_Float64(0);
// compiled num node returning num12 (depth = 4)
  int op_slot_right_11 = gc_frame_newslot(num12);
// starting to compile member node (depth = 4)
  int callframe14 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  Object call15 = callmethodflags(*var_tokens, "size", 0, partcv, params, 0);
  gc_frame_end(callframe14);
// compiled member node returning call15 (depth = 4)
  int op_slot_left_11 = gc_frame_newslot(call15);
  params[0] = num12;
  partcv[0] = 1;
  Object opresult16 = callmethod(call15, ">(1)", 1, partcv, params);
// compiled op node returning opresult16 (depth = 3)
  Object if10 = done;
  if (istrue(opresult16)) {
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_lastToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe18 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call19 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe18);
// compiled member node returning call19 (depth = 4)
  *var_lastLine = call19;
  if (call19 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe21 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call22 = callmethodflags(*var_lastToken, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe21);
// compiled member node returning call22 (depth = 4)
  *var_lastIndent = call22;
  if (call22 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe24 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  Object call25 = callmethodflags(*var_tokens, "poll", 0, partcv, params, 0);
  gc_frame_end(callframe24);
// compiled member node returning call25 (depth = 4)
  *var_sym = call25;
  if (call25 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num30 = alloc_Float64(1);
// compiled num node returning num30 (depth = 6)
  int op_slot_right_29 = gc_frame_newslot(num30);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastLine (depth = 6)
  int op_slot_left_29 = gc_frame_newslot(*var_lastLine);
  params[0] = num30;
  partcv[0] = 1;
  Object sum32 = callmethod(*var_lastLine, "+(1)", 1, partcv, params);
// compiled op node returning sum32 (depth = 5)
  int op_slot_right_28 = gc_frame_newslot(sum32);
// starting to compile member node (depth = 5)
  int callframe34 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call35 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe34);
// compiled member node returning call35 (depth = 5)
  int op_slot_left_28 = gc_frame_newslot(call35);
  params[0] = sum32;
  partcv[0] = 1;
  Object opresult36 = callmethod(call35, ">(1)", 1, partcv, params);
// compiled op node returning opresult36 (depth = 4)
  Object if27 = done;
  if (istrue(opresult36)) {
// starting to compile member node (depth = 4)
  int callframe37 = gc_frame_new();
// call case 4: self request
  Object call38 = callmethodflags(self, "noteBlank", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe37);
// compiled member node returning call38 (depth = 4)
    gc_frame_newslot(call38);
    if27 = call38;
  } else {
  }
// compiled if node returning if27 (depth = 3)
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe39 = gc_frame_new();
// call case 4: self request
  Object call40 = callmethodflags(self, "pushComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe39);
// compiled member node returning call40 (depth = 3)
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe41 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe42 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call43 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe42);
// compiled member node returning call43 (depth = 4)
  gc_frame_newslot(call43);
// starting to compile member node (depth = 4)
  int callframe44 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call45 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe44);
// compiled member node returning call45 (depth = 4)
  gc_frame_newslot(call45);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call43;
  params[1] = call45;
  partcv[0] = 2;
  Object call46 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe41);
// compiled call node returning call46 (depth = 3)
    gc_frame_newslot(call46);
    if10 = call46;
  } else {
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe47 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit49 == NULL) {
    strlit49 = alloc_String("This is often caused by a missing '}'");
    gc_root(strlit49);
  }
// compiled string node returning strlit49 (depth = 5)
  int op_slot_right_48 = gc_frame_newslot(strlit49);
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit51 == NULL) {
    strlit51 = alloc_String("unexpectedly found the end of the input. ");
    gc_root(strlit51);
  }
// compiled string node returning strlit51 (depth = 5)
  int op_slot_left_48 = gc_frame_newslot(strlit51);
  params[0] = strlit49;
  partcv[0] = 1;
  Object opresult52 = callmethod(strlit51, "++(1)", 1, partcv, params);
// compiled op node returning opresult52 (depth = 4)
  gc_frame_newslot(opresult52);
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe53 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call54 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe53);
// compiled member node returning call54 (depth = 4)
  gc_frame_newslot(call54);
// starting to compile member node (depth = 4)
  int callframe55 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call56 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe55);
// compiled member node returning call56 (depth = 4)
  gc_frame_newslot(call56);
// starting to compile member node (depth = 4)
  int callframe57 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call58 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe57);
// compiled member node returning call58 (depth = 4)
  gc_frame_newslot(call58);
// call case 6: other requests
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult52;
  params[1] = call54;
  params[2] = call56;
  params[3] = call58;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call59 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe47);
// compiled call node returning call59 (depth = 3)
    gc_frame_newslot(call59);
    if10 = call59;
  }
// compiled if node returning if10 (depth = 2)
  gc_frame_end(frame);
  return if10;
}
Object meth_parser__apply70(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe72 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call73 = callmethodflags(*var_lastToken, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe72);
// compiled member node returning call73 (depth = 7)
  int op_slot_right_71 = gc_frame_newslot(call73);
// starting to compile member node (depth = 7)
  int callframe75 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  Object call76 = callmethodflags(*var_n, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe75);
// compiled member node returning call76 (depth = 7)
  int op_slot_left_71 = gc_frame_newslot(call76);
  params[0] = call73;
  partcv[0] = 1;
  Object opresult77 = callmethod(call76, "≥(1)", 1, partcv, params);
// compiled op node returning opresult77 (depth = 6)
  gc_frame_end(frame);
  return opresult77;
}
Object meth_parser__apply82(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_right_83 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 8)
  Object bool85 = alloc_Boolean(0);
// compiled identifier node returning bool85 (depth = 8)
  int op_slot_left_83 = gc_frame_newslot(bool85);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult86 = callmethod(bool85, "==(1)", 1, partcv, params);
// compiled op node returning opresult86 (depth = 7)
  gc_frame_end(frame);
  return opresult86;
}
Object meth_parser__apply67(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object *var_nextTok = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block69 = alloc_Block(NULL, NULL, "parser", 72);
  gc_frame_newslot(block69);
// method "_apply"
  block_savedest(block69);
  Object closure70 = createclosure(3, "_apply");
  setclosureframe(closure70, stackframe);
  addtoclosure(closure70, var_lastToken);
  addtoclosure(closure70, var_n);
  addtoclosure(closure70, selfslot);
  struct UserObject *uo70 = (struct UserObject*)block69;
  uo70->data[0] = (Object)closure70;
  Method *meth_meth_parser__apply70 = addmethod2pos(block69, "_apply", &meth_parser__apply70, 0);
  int argcv_meth_parser__apply70[] = {0};
  meth_meth_parser__apply70->type = alloc_MethodType(1, argcv_meth_parser__apply70);
  meth_meth_parser__apply70->definitionModule = modulename;
  meth_meth_parser__apply70->definitionLine = 3399;
// compiled block node returning block69 (depth = 5)
  int op_slot_right_68 = gc_frame_newslot(block69);
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block81 = alloc_Block(NULL, NULL, "parser", 72);
  gc_frame_newslot(block81);
// method "_apply"
  block_savedest(block81);
  Object closure82 = createclosure(2, "_apply");
  setclosureframe(closure82, stackframe);
  addtoclosure(closure82, var_nextTok);
  addtoclosure(closure82, selfslot);
  struct UserObject *uo82 = (struct UserObject*)block81;
  uo82->data[0] = (Object)closure82;
  Method *meth_meth_parser__apply82 = addmethod2pos(block81, "_apply", &meth_parser__apply82, 0);
  int argcv_meth_parser__apply82[] = {0};
  meth_meth_parser__apply82->type = alloc_MethodType(1, argcv_meth_parser__apply82);
  meth_meth_parser__apply82->definitionModule = modulename;
  meth_meth_parser__apply82->definitionLine = 3399;
// compiled block node returning block81 (depth = 6)
  int op_slot_right_80 = gc_frame_newslot(block81);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  int op_slot_right_89 = gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 7)
  Object bool91 = alloc_Boolean(0);
// compiled identifier node returning bool91 (depth = 7)
  int op_slot_left_89 = gc_frame_newslot(bool91);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult92 = callmethod(bool91, "≠(1)", 1, partcv, params);
// compiled op node returning opresult92 (depth = 6)
  int op_slot_left_80 = gc_frame_newslot(opresult92);
  params[0] = block81;
  partcv[0] = 1;
  Object opresult93 = callmethod(opresult92, "&&(1)", 1, partcv, params);
// compiled op node returning opresult93 (depth = 5)
  int op_slot_left_68 = gc_frame_newslot(opresult93);
  params[0] = block69;
  partcv[0] = 1;
  Object opresult94 = callmethod(opresult93, "&&(1)", 1, partcv, params);
// compiled op node returning opresult94 (depth = 4)
  gc_frame_end(frame);
  return opresult94;
}
Object meth_parser__apply97(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_tokenMatcher = getfromclosure(closure, 1);
  Object *var_nextTok = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe99 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokenMatcher (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call100 = callmethodflags(*var_tokenMatcher, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe99);
// compiled call node returning call100 (depth = 5)
  Object if98 = done;
  if (istrue(call100)) {
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  *var_nextTok = *var_n;
  if (*var_n == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if98 = done;
  } else {
  }
// compiled if node returning if98 (depth = 4)
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe102 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  Object call103 = callmethodflags(*var_n, "next", 0, partcv, params, 0);
  gc_frame_end(callframe102);
// compiled member node returning call103 (depth = 5)
  *var_n = call103;
  if (call103 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findNextToken_40_1_41_60(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextToken(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findNextToken(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findNextToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tokenMatcher = &(stackframe->slots[0]);
  *var_tokenMatcher = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findNextToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe62 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokenMatcher (depth = 4)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call63 = callmethodflags(*var_tokenMatcher, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe62);
// compiled call node returning call63 (depth = 3)
  Object if61 = done;
  if (istrue(call63)) {
// Begin line 68
  setline(68);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  return *var_sym;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if61 = undefined;
  } else {
  }
// compiled if node returning if61 (depth = 2)
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool64 = alloc_Boolean(0);
// compiled identifier node returning bool64 (depth = 3)
  *var_nextTok = bool64;
  if (bool64 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 71
  setline(71);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe65 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block66 = alloc_Block(NULL, NULL, "parser", 72);
  gc_frame_newslot(block66);
// method "_apply"
  block_savedest(block66);
  Object closure67 = createclosure(4, "_apply");
  setclosureframe(closure67, stackframe);
  addtoclosure(closure67, var_lastToken);
  addtoclosure(closure67, var_n);
  addtoclosure(closure67, var_nextTok);
  addtoclosure(closure67, selfslot);
  struct UserObject *uo67 = (struct UserObject*)block66;
  uo67->data[0] = (Object)closure67;
  Method *meth_meth_parser__apply67 = addmethod2pos(block66, "_apply", &meth_parser__apply67, 0);
  int argcv_meth_parser__apply67[] = {0};
  meth_meth_parser__apply67->type = alloc_MethodType(1, argcv_meth_parser__apply67);
  meth_meth_parser__apply67->definitionModule = modulename;
  meth_meth_parser__apply67->definitionLine = 3399;
// compiled block node returning block66 (depth = 3)
  gc_frame_newslot(block66);
// starting to compile block node (depth = 3)
  Object block96 = alloc_Block(NULL, NULL, "parser", 72);
  gc_frame_newslot(block96);
// method "_apply"
  block_savedest(block96);
  Object closure97 = createclosure(4, "_apply");
  setclosureframe(closure97, stackframe);
  addtoclosure(closure97, var_n);
  addtoclosure(closure97, var_tokenMatcher);
  addtoclosure(closure97, var_nextTok);
  addtoclosure(closure97, selfslot);
  struct UserObject *uo97 = (struct UserObject*)block96;
  uo97->data[0] = (Object)closure97;
  Method *meth_meth_parser__apply97 = addmethod2pos(block96, "_apply", &meth_parser__apply97, 0);
  int argcv_meth_parser__apply97[] = {0};
  meth_meth_parser__apply97->type = alloc_MethodType(1, argcv_meth_parser__apply97);
  meth_meth_parser__apply97->definitionModule = modulename;
  meth_meth_parser__apply97->definitionLine = 3399;
// compiled block node returning block96 (depth = 3)
  gc_frame_newslot(block96);
// call case 5: prelude request
  params[0] = block66;
  params[1] = block96;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call106 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe65);
// compiled call node returning call106 (depth = 2)
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_nextTok (depth = 2)
  gc_frame_end(frame);
  return *var_nextTok;
}
Object meth_parser__apply141(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_right_142 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 7)
  Object bool144 = alloc_Boolean(0);
// compiled identifier node returning bool144 (depth = 7)
  int op_slot_left_142 = gc_frame_newslot(bool144);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult145 = callmethod(bool144, "==(1)", 1, partcv, params);
// compiled op node returning opresult145 (depth = 6)
  gc_frame_end(frame);
  return opresult145;
}
Object meth_parser__apply138(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block140 = alloc_Block(NULL, NULL, "parser", 87);
  gc_frame_newslot(block140);
// method "_apply"
  block_savedest(block140);
  Object closure141 = createclosure(2, "_apply");
  setclosureframe(closure141, stackframe);
  addtoclosure(closure141, var_nextTok);
  addtoclosure(closure141, selfslot);
  struct UserObject *uo141 = (struct UserObject*)block140;
  uo141->data[0] = (Object)closure141;
  Method *meth_meth_parser__apply141 = addmethod2pos(block140, "_apply", &meth_parser__apply141, 0);
  int argcv_meth_parser__apply141[] = {0};
  meth_meth_parser__apply141->type = alloc_MethodType(1, argcv_meth_parser__apply141);
  meth_meth_parser__apply141->definitionModule = modulename;
  meth_meth_parser__apply141->definitionLine = 3399;
// compiled block node returning block140 (depth = 5)
  int op_slot_right_139 = gc_frame_newslot(block140);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_right_148 = gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 6)
  Object bool150 = alloc_Boolean(0);
// compiled identifier node returning bool150 (depth = 6)
  int op_slot_left_148 = gc_frame_newslot(bool150);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult151 = callmethod(bool150, "≠(1)", 1, partcv, params);
// compiled op node returning opresult151 (depth = 5)
  int op_slot_left_139 = gc_frame_newslot(opresult151);
  params[0] = block140;
  partcv[0] = 1;
  Object opresult152 = callmethod(opresult151, "&&(1)", 1, partcv, params);
// compiled op node returning opresult152 (depth = 4)
  gc_frame_end(frame);
  return opresult152;
}
Object meth_parser__apply155(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object *var_n = getfromclosure(closure, 2);
  Object *var_nextTok = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit159 == NULL) {
    strlit159 = alloc_String("eof");
    gc_root(strlit159);
  }
// compiled string node returning strlit159 (depth = 7)
  int op_slot_right_158 = gc_frame_newslot(strlit159);
// starting to compile member node (depth = 7)
  int callframe161 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call162 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe161);
// compiled member node returning call162 (depth = 7)
  int op_slot_left_158 = gc_frame_newslot(call162);
  params[0] = strlit159;
  partcv[0] = 1;
  Object opresult163 = callmethod(call162, "==(1)", 1, partcv, params);
// compiled op node returning opresult163 (depth = 6)
  int op_slot_right_157 = gc_frame_newslot(opresult163);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe167 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  Object call168 = callmethodflags(*var_tok, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe167);
// compiled member node returning call168 (depth = 8)
  int op_slot_right_166 = gc_frame_newslot(call168);
// starting to compile member node (depth = 8)
  int callframe170 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  Object call171 = callmethodflags(*var_n, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe170);
// compiled member node returning call171 (depth = 8)
  int op_slot_left_166 = gc_frame_newslot(call171);
  params[0] = call168;
  partcv[0] = 1;
  Object opresult172 = callmethod(call171, "≤(1)", 1, partcv, params);
// compiled op node returning opresult172 (depth = 7)
  int op_slot_right_165 = gc_frame_newslot(opresult172);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe175 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  Object call176 = callmethodflags(*var_tok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe175);
// compiled member node returning call176 (depth = 8)
  int op_slot_right_174 = gc_frame_newslot(call176);
// starting to compile member node (depth = 8)
  int callframe178 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  Object call179 = callmethodflags(*var_n, "line", 0, partcv, params, 0);
  gc_frame_end(callframe178);
// compiled member node returning call179 (depth = 8)
  int op_slot_left_174 = gc_frame_newslot(call179);
  params[0] = call176;
  partcv[0] = 1;
  Object opresult180 = callmethod(call179, ">(1)", 1, partcv, params);
// compiled op node returning opresult180 (depth = 7)
  int op_slot_left_165 = gc_frame_newslot(opresult180);
  params[0] = opresult172;
  partcv[0] = 1;
  Object opresult181 = callmethod(opresult180, "&&(1)", 1, partcv, params);
// compiled op node returning opresult181 (depth = 6)
  int op_slot_left_157 = gc_frame_newslot(opresult181);
  params[0] = opresult163;
  partcv[0] = 1;
  Object opresult182 = callmethod(opresult181, "||(1)", 1, partcv, params);
// compiled op node returning opresult182 (depth = 5)
  Object if156 = done;
  if (istrue(opresult182)) {
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  *var_nextTok = *var_n;
  if (*var_n == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if156 = done;
  } else {
  }
// compiled if node returning if156 (depth = 4)
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe184 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  Object call185 = callmethodflags(*var_n, "next", 0, partcv, params, 0);
  gc_frame_end(callframe184);
// compiled member node returning call185 (depth = 5)
  *var_n = call185;
  if (call185 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findNextTokenIndentedAt_40_1_41_107(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextTokenIndentedAt(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findNextTokenIndentedAt(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findNextTokenIndentedAt(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tok = &(stackframe->slots[0]);
  *var_tok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findNextTokenIndentedAt(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit111 == NULL) {
    strlit111 = alloc_String("eof");
    gc_root(strlit111);
  }
// compiled string node returning strlit111 (depth = 5)
  int op_slot_right_110 = gc_frame_newslot(strlit111);
// starting to compile member node (depth = 5)
  int callframe113 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call114 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe113);
// compiled member node returning call114 (depth = 5)
  int op_slot_left_110 = gc_frame_newslot(call114);
  params[0] = strlit111;
  partcv[0] = 1;
  Object opresult115 = callmethod(call114, "==(1)", 1, partcv, params);
// compiled op node returning opresult115 (depth = 4)
  int op_slot_right_109 = gc_frame_newslot(opresult115);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe119 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  Object call120 = callmethodflags(*var_tok, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe119);
// compiled member node returning call120 (depth = 6)
  int op_slot_right_118 = gc_frame_newslot(call120);
// starting to compile member node (depth = 6)
  int callframe122 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call123 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe122);
// compiled member node returning call123 (depth = 6)
  int op_slot_left_118 = gc_frame_newslot(call123);
  params[0] = call120;
  partcv[0] = 1;
  Object opresult124 = callmethod(call123, "≤(1)", 1, partcv, params);
// compiled op node returning opresult124 (depth = 5)
  int op_slot_right_117 = gc_frame_newslot(opresult124);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe127 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  Object call128 = callmethodflags(*var_tok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe127);
// compiled member node returning call128 (depth = 6)
  int op_slot_right_126 = gc_frame_newslot(call128);
// starting to compile member node (depth = 6)
  int callframe130 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call131 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe130);
// compiled member node returning call131 (depth = 6)
  int op_slot_left_126 = gc_frame_newslot(call131);
  params[0] = call128;
  partcv[0] = 1;
  Object opresult132 = callmethod(call131, ">(1)", 1, partcv, params);
// compiled op node returning opresult132 (depth = 5)
  int op_slot_left_117 = gc_frame_newslot(opresult132);
  params[0] = opresult124;
  partcv[0] = 1;
  Object opresult133 = callmethod(opresult132, "&&(1)", 1, partcv, params);
// compiled op node returning opresult133 (depth = 4)
  int op_slot_left_109 = gc_frame_newslot(opresult133);
  params[0] = opresult115;
  partcv[0] = 1;
  Object opresult134 = callmethod(opresult133, "||(1)", 1, partcv, params);
// compiled op node returning opresult134 (depth = 3)
  Object if108 = done;
  if (istrue(opresult134)) {
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  return *var_sym;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if108 = undefined;
  } else {
  }
// compiled if node returning if108 (depth = 2)
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool135 = alloc_Boolean(0);
// compiled identifier node returning bool135 (depth = 3)
  *var_nextTok = bool135;
  if (bool135 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe136 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block137 = alloc_Block(NULL, NULL, "parser", 87);
  gc_frame_newslot(block137);
// method "_apply"
  block_savedest(block137);
  Object closure138 = createclosure(3, "_apply");
  setclosureframe(closure138, stackframe);
  addtoclosure(closure138, var_nextTok);
  addtoclosure(closure138, var_n);
  addtoclosure(closure138, selfslot);
  struct UserObject *uo138 = (struct UserObject*)block137;
  uo138->data[0] = (Object)closure138;
  Method *meth_meth_parser__apply138 = addmethod2pos(block137, "_apply", &meth_parser__apply138, 0);
  int argcv_meth_parser__apply138[] = {0};
  meth_meth_parser__apply138->type = alloc_MethodType(1, argcv_meth_parser__apply138);
  meth_meth_parser__apply138->definitionModule = modulename;
  meth_meth_parser__apply138->definitionLine = 3399;
// compiled block node returning block137 (depth = 3)
  gc_frame_newslot(block137);
// starting to compile block node (depth = 3)
  Object block154 = alloc_Block(NULL, NULL, "parser", 87);
  gc_frame_newslot(block154);
// method "_apply"
  block_savedest(block154);
  Object closure155 = createclosure(5, "_apply");
  setclosureframe(closure155, stackframe);
  addtoclosure(closure155, var_sym);
  addtoclosure(closure155, var_tok);
  addtoclosure(closure155, var_n);
  addtoclosure(closure155, var_nextTok);
  addtoclosure(closure155, selfslot);
  struct UserObject *uo155 = (struct UserObject*)block154;
  uo155->data[0] = (Object)closure155;
  Method *meth_meth_parser__apply155 = addmethod2pos(block154, "_apply", &meth_parser__apply155, 0);
  int argcv_meth_parser__apply155[] = {0};
  meth_meth_parser__apply155->type = alloc_MethodType(1, argcv_meth_parser__apply155);
  meth_meth_parser__apply155->definitionModule = modulename;
  meth_meth_parser__apply155->definitionLine = 3399;
// compiled block node returning block154 (depth = 3)
  gc_frame_newslot(block154);
// call case 5: prelude request
  params[0] = block137;
  params[1] = block154;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call188 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe136);
// compiled call node returning call188 (depth = 2)
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_nextTok (depth = 2)
  gc_frame_end(frame);
  return *var_nextTok;
}
Object meth_parser__apply203(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_validToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit205 == NULL) {
    strlit205 = alloc_String("eof");
    gc_root(strlit205);
  }
// compiled string node returning strlit205 (depth = 5)
  int op_slot_right_204 = gc_frame_newslot(strlit205);
// starting to compile member node (depth = 5)
  int callframe207 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  Object call208 = callmethodflags(*var_validToken, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe207);
// compiled member node returning call208 (depth = 5)
  int op_slot_left_204 = gc_frame_newslot(call208);
  params[0] = strlit205;
  partcv[0] = 1;
  Object opresult209 = callmethod(call208, "≠(1)", 1, partcv, params);
// compiled op node returning opresult209 (depth = 4)
  gc_frame_end(frame);
  return opresult209;
}
Object meth_parser__apply212(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_validToken = getfromclosure(closure, 0);
  Object *var_validFollowTokens = getfromclosure(closure, 1);
  Object *var_invalidTokens = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe214 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe215 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_validToken (depth = 7)
  Object call216 = callmethodflags(*var_validToken, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe215);
// compiled member node returning call216 (depth = 6)
  gc_frame_newslot(call216);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validFollowTokens (depth = 6)
  params[0] = call216;
  partcv[0] = 1;
  Object call217 = callmethodflags(*var_validFollowTokens, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe214);
// compiled call node returning call217 (depth = 5)
  Object if213 = done;
  if (istrue(call217)) {
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  block_return(realself, *var_validToken);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if213 = undefined;
  } else {
  }
// compiled if node returning if213 (depth = 4)
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe219 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe220 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe221 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_validToken (depth = 8)
  Object call222 = callmethodflags(*var_validToken, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe221);
// compiled member node returning call222 (depth = 7)
  gc_frame_newslot(call222);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_invalidTokens (depth = 7)
  params[0] = call222;
  partcv[0] = 1;
  Object call223 = callmethodflags(*var_invalidTokens, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe220);
// compiled call node returning call223 (depth = 6)
  partcv[0] = 0;
  Object call224 = callmethodflags(call223, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe219);
// compiled call node returning call224 (depth = 5)
  Object if218 = done;
  if (istrue(call224)) {
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  block_return(realself, *var_validToken);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if218 = undefined;
  } else {
  }
// compiled if node returning if218 (depth = 4)
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe225 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  Object call226 = callmethodflags(*var_validToken, "next", 0, partcv, params, 0);
  gc_frame_end(callframe225);
// compiled member node returning call226 (depth = 5)
  *var_validToken = call226;
  if (call226 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findNextValidToken_40_1_41_189(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextValidToken(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findNextValidToken(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findNextValidToken(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_validFollowTokens = &(stackframe->slots[0]);
  *var_validFollowTokens = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findNextValidToken(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_invalidTokens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "invalidTokens");
  Object *var_validToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "validToken");
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe190 = gc_frame_new();
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array191 = alloc_BuiltinList();
  gc_pause();
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit192 == NULL) {
    strlit192 = alloc_String("dot");
    gc_root(strlit192);
  }
// compiled string node returning strlit192 (depth = 5)
  params[0] = strlit192;
  partcv[0] = 1;
  callmethodflags(array191, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit193 == NULL) {
    strlit193 = alloc_String("comma");
    gc_root(strlit193);
  }
// compiled string node returning strlit193 (depth = 5)
  params[0] = strlit193;
  partcv[0] = 1;
  callmethodflags(array191, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit194 == NULL) {
    strlit194 = alloc_String("colon");
    gc_root(strlit194);
  }
// compiled string node returning strlit194 (depth = 5)
  params[0] = strlit194;
  partcv[0] = 1;
  callmethodflags(array191, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit195 == NULL) {
    strlit195 = alloc_String("rparen");
    gc_root(strlit195);
  }
// compiled string node returning strlit195 (depth = 5)
  params[0] = strlit195;
  partcv[0] = 1;
  callmethodflags(array191, "push(1)", 1, partcv, params, CFLAG_SELF);
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit196 == NULL) {
    strlit196 = alloc_String("rbrace");
    gc_root(strlit196);
  }
// compiled string node returning strlit196 (depth = 5)
  params[0] = strlit196;
  partcv[0] = 1;
  callmethodflags(array191, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit197 == NULL) {
    strlit197 = alloc_String("rsquare");
    gc_root(strlit197);
  }
// compiled string node returning strlit197 (depth = 5)
  params[0] = strlit197;
  partcv[0] = 1;
  callmethodflags(array191, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit198 == NULL) {
    strlit198 = alloc_String("arrow");
    gc_root(strlit198);
  }
// compiled string node returning strlit198 (depth = 5)
  params[0] = strlit198;
  partcv[0] = 1;
  callmethodflags(array191, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit199 == NULL) {
    strlit199 = alloc_String("bind");
    gc_root(strlit199);
  }
// compiled string node returning strlit199 (depth = 5)
  params[0] = strlit199;
  partcv[0] = 1;
  callmethodflags(array191, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array191 (depth = 4)
  gc_frame_newslot(array191);
// call case 5: prelude request
  params[0] = array191;
  partcv[0] = 1;
  Object call200 = callmethodflags(prelude, "set(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe190);
// compiled call node returning call200 (depth = 3)
  *var_invalidTokens = call200;
  if (call200 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_validToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe201 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block202 = alloc_Block(NULL, NULL, "parser", 101);
  gc_frame_newslot(block202);
// method "_apply"
  block_savedest(block202);
  Object closure203 = createclosure(2, "_apply");
  setclosureframe(closure203, stackframe);
  addtoclosure(closure203, var_validToken);
  addtoclosure(closure203, selfslot);
  struct UserObject *uo203 = (struct UserObject*)block202;
  uo203->data[0] = (Object)closure203;
  Method *meth_meth_parser__apply203 = addmethod2pos(block202, "_apply", &meth_parser__apply203, 0);
  int argcv_meth_parser__apply203[] = {0};
  meth_meth_parser__apply203->type = alloc_MethodType(1, argcv_meth_parser__apply203);
  meth_meth_parser__apply203->definitionModule = modulename;
  meth_meth_parser__apply203->definitionLine = 3399;
// compiled block node returning block202 (depth = 3)
  gc_frame_newslot(block202);
// starting to compile block node (depth = 3)
  Object block211 = alloc_Block(NULL, NULL, "parser", 101);
  gc_frame_newslot(block211);
// method "_apply"
  block_savedest(block211);
  Object closure212 = createclosure(4, "_apply");
  setclosureframe(closure212, stackframe);
  addtoclosure(closure212, var_validToken);
  addtoclosure(closure212, var_validFollowTokens);
  addtoclosure(closure212, var_invalidTokens);
  addtoclosure(closure212, selfslot);
  struct UserObject *uo212 = (struct UserObject*)block211;
  uo212->data[0] = (Object)closure212;
  Method *meth_meth_parser__apply212 = addmethod2pos(block211, "_apply", &meth_parser__apply212, 0);
  int argcv_meth_parser__apply212[] = {0};
  meth_meth_parser__apply212->type = alloc_MethodType(1, argcv_meth_parser__apply212);
  meth_meth_parser__apply212->definitionModule = modulename;
  meth_meth_parser__apply212->definitionLine = 3399;
// compiled block node returning block211 (depth = 3)
  gc_frame_newslot(block211);
// call case 5: prelude request
  params[0] = block202;
  params[1] = block211;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call229 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe201);
// compiled call node returning call229 (depth = 2)
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_validToken (depth = 3)
  return *var_validToken;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser__apply241(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe244 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_token (depth = 7)
  Object call245 = callmethodflags(*var_token, "line", 0, partcv, params, 0);
  gc_frame_end(callframe244);
// compiled member node returning call245 (depth = 6)
  int op_slot_right_243 = gc_frame_newslot(call245);
// starting to compile member node (depth = 6)
  int callframe247 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  Object call248 = callmethodflags(*var_n, "line", 0, partcv, params, 0);
  gc_frame_end(callframe247);
// compiled member node returning call248 (depth = 6)
  int op_slot_left_243 = gc_frame_newslot(call248);
  params[0] = call245;
  partcv[0] = 1;
  Object opresult249 = callmethod(call248, "==(1)", 1, partcv, params);
// compiled op node returning opresult249 (depth = 5)
  int op_slot_right_242 = gc_frame_newslot(opresult249);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit252 == NULL) {
    strlit252 = alloc_String("eof");
    gc_root(strlit252);
  }
// compiled string node returning strlit252 (depth = 6)
  int op_slot_right_251 = gc_frame_newslot(strlit252);
// starting to compile member node (depth = 6)
  int callframe254 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  Object call255 = callmethodflags(*var_n, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe254);
// compiled member node returning call255 (depth = 6)
  int op_slot_left_251 = gc_frame_newslot(call255);
  params[0] = strlit252;
  partcv[0] = 1;
  Object opresult256 = callmethod(call255, "≠(1)", 1, partcv, params);
// compiled op node returning opresult256 (depth = 5)
  int op_slot_left_242 = gc_frame_newslot(opresult256);
  params[0] = opresult249;
  partcv[0] = 1;
  Object opresult257 = callmethod(opresult256, "&&(1)", 1, partcv, params);
// compiled op node returning opresult257 (depth = 4)
  gc_frame_end(frame);
  return opresult257;
}
Object meth_parser__apply260(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_numOpening = getfromclosure(closure, 1);
  Object *var_numClosing = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit263 == NULL) {
    strlit263 = alloc_String("lbrace");
    gc_root(strlit263);
  }
// compiled string node returning strlit263 (depth = 6)
  int op_slot_right_262 = gc_frame_newslot(strlit263);
// starting to compile member node (depth = 6)
  int callframe265 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  Object call266 = callmethodflags(*var_n, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe265);
// compiled member node returning call266 (depth = 6)
  int op_slot_left_262 = gc_frame_newslot(call266);
  params[0] = strlit263;
  partcv[0] = 1;
  Object opresult267 = callmethod(call266, "==(1)", 1, partcv, params);
// compiled op node returning opresult267 (depth = 5)
  Object if261 = done;
  if (istrue(opresult267)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num269 = alloc_Float64(1);
// compiled num node returning num269 (depth = 7)
  int op_slot_right_268 = gc_frame_newslot(num269);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_numOpening (depth = 7)
  int op_slot_left_268 = gc_frame_newslot(*var_numOpening);
  params[0] = num269;
  partcv[0] = 1;
  Object sum271 = callmethod(*var_numOpening, "+(1)", 1, partcv, params);
// compiled op node returning sum271 (depth = 6)
  *var_numOpening = sum271;
  if (sum271 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if261 = done;
  } else {
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit275 == NULL) {
    strlit275 = alloc_String("rbrace");
    gc_root(strlit275);
  }
// compiled string node returning strlit275 (depth = 7)
  int op_slot_right_274 = gc_frame_newslot(strlit275);
// starting to compile member node (depth = 7)
  int callframe277 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  Object call278 = callmethodflags(*var_n, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe277);
// compiled member node returning call278 (depth = 7)
  int op_slot_left_274 = gc_frame_newslot(call278);
  params[0] = strlit275;
  partcv[0] = 1;
  Object opresult279 = callmethod(call278, "==(1)", 1, partcv, params);
// compiled op node returning opresult279 (depth = 6)
  Object if273 = done;
  if (istrue(opresult279)) {
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num281 = alloc_Float64(1);
// compiled num node returning num281 (depth = 8)
  int op_slot_right_280 = gc_frame_newslot(num281);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_numClosing (depth = 8)
  int op_slot_left_280 = gc_frame_newslot(*var_numClosing);
  params[0] = num281;
  partcv[0] = 1;
  Object sum283 = callmethod(*var_numClosing, "+(1)", 1, partcv, params);
// compiled op node returning sum283 (depth = 7)
  *var_numClosing = sum283;
  if (sum283 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if273 = done;
  } else {
  }
// compiled if node returning if273 (depth = 5)
    gc_frame_newslot(if273);
    if261 = if273;
  }
// compiled if node returning if261 (depth = 4)
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe285 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  Object call286 = callmethodflags(*var_n, "next", 0, partcv, params, 0);
  gc_frame_end(callframe285);
// compiled member node returning call286 (depth = 5)
  *var_n = call286;
  if (call286 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply292(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe295 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_token (depth = 7)
  Object call296 = callmethodflags(*var_token, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe295);
// compiled member node returning call296 (depth = 6)
  int op_slot_right_294 = gc_frame_newslot(call296);
// starting to compile member node (depth = 6)
  int callframe298 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  Object call299 = callmethodflags(*var_n, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe298);
// compiled member node returning call299 (depth = 6)
  int op_slot_left_294 = gc_frame_newslot(call299);
  params[0] = call296;
  partcv[0] = 1;
  Object opresult300 = callmethod(call299, ">(1)", 1, partcv, params);
// compiled op node returning opresult300 (depth = 5)
  int op_slot_right_293 = gc_frame_newslot(opresult300);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit303 == NULL) {
    strlit303 = alloc_String("eof");
    gc_root(strlit303);
  }
// compiled string node returning strlit303 (depth = 6)
  int op_slot_right_302 = gc_frame_newslot(strlit303);
// starting to compile member node (depth = 6)
  int callframe305 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  Object call306 = callmethodflags(*var_n, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe305);
// compiled member node returning call306 (depth = 6)
  int op_slot_left_302 = gc_frame_newslot(call306);
  params[0] = strlit303;
  partcv[0] = 1;
  Object opresult307 = callmethod(call306, "≠(1)", 1, partcv, params);
// compiled op node returning opresult307 (depth = 5)
  int op_slot_left_293 = gc_frame_newslot(opresult307);
  params[0] = opresult300;
  partcv[0] = 1;
  Object opresult308 = callmethod(opresult307, "&&(1)", 1, partcv, params);
// compiled op node returning opresult308 (depth = 4)
  gc_frame_end(frame);
  return opresult308;
}
Object meth_parser__apply311(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_numOpening = getfromclosure(closure, 1);
  Object *var_numClosing = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit314 == NULL) {
    strlit314 = alloc_String("lbrace");
    gc_root(strlit314);
  }
// compiled string node returning strlit314 (depth = 6)
  int op_slot_right_313 = gc_frame_newslot(strlit314);
// starting to compile member node (depth = 6)
  int callframe316 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  Object call317 = callmethodflags(*var_n, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe316);
// compiled member node returning call317 (depth = 6)
  int op_slot_left_313 = gc_frame_newslot(call317);
  params[0] = strlit314;
  partcv[0] = 1;
  Object opresult318 = callmethod(call317, "==(1)", 1, partcv, params);
// compiled op node returning opresult318 (depth = 5)
  Object if312 = done;
  if (istrue(opresult318)) {
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num320 = alloc_Float64(1);
// compiled num node returning num320 (depth = 7)
  int op_slot_right_319 = gc_frame_newslot(num320);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_numOpening (depth = 7)
  int op_slot_left_319 = gc_frame_newslot(*var_numOpening);
  params[0] = num320;
  partcv[0] = 1;
  Object sum322 = callmethod(*var_numOpening, "+(1)", 1, partcv, params);
// compiled op node returning sum322 (depth = 6)
  *var_numOpening = sum322;
  if (sum322 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if312 = done;
  } else {
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit326 == NULL) {
    strlit326 = alloc_String("rbrace");
    gc_root(strlit326);
  }
// compiled string node returning strlit326 (depth = 7)
  int op_slot_right_325 = gc_frame_newslot(strlit326);
// starting to compile member node (depth = 7)
  int callframe328 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  Object call329 = callmethodflags(*var_n, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe328);
// compiled member node returning call329 (depth = 7)
  int op_slot_left_325 = gc_frame_newslot(call329);
  params[0] = strlit326;
  partcv[0] = 1;
  Object opresult330 = callmethod(call329, "==(1)", 1, partcv, params);
// compiled op node returning opresult330 (depth = 6)
  Object if324 = done;
  if (istrue(opresult330)) {
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num332 = alloc_Float64(1);
// compiled num node returning num332 (depth = 8)
  int op_slot_right_331 = gc_frame_newslot(num332);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_numClosing (depth = 8)
  int op_slot_left_331 = gc_frame_newslot(*var_numClosing);
  params[0] = num332;
  partcv[0] = 1;
  Object sum334 = callmethod(*var_numClosing, "+(1)", 1, partcv, params);
// compiled op node returning sum334 (depth = 7)
  *var_numClosing = sum334;
  if (sum334 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if324 = done;
  } else {
  }
// compiled if node returning if324 (depth = 5)
    gc_frame_newslot(if324);
    if312 = if324;
  }
// compiled if node returning if312 (depth = 4)
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe336 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  Object call337 = callmethodflags(*var_n, "next", 0, partcv, params, 0);
  gc_frame_end(callframe336);
// compiled member node returning call337 (depth = 5)
  *var_n = call337;
  if (call337 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findClosingBrace_40_2_41_230(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findClosingBrace(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method findClosingBrace(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findClosingBrace(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  Object *var_inserted = &(stackframe->slots[1]);
  *var_inserted = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part findClosingBrace(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_numOpening = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "numOpening");
  Object *var_numClosing = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "numClosing");
  Object *var_result = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "result");
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_inserted (depth = 4)
  Object if231 = done;
struct StackFrameObject *iftmpstackframe231 = stackframe;
  if (istrue(*var_inserted)) {
stackframe = alloc_StackFrame(0, iftmpstackframe231);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 4)
  Object num232 = alloc_Float64(1);
// compiled num node returning num232 (depth = 4)
    gc_frame_newslot(num232);
    if231 = num232;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe231);
  gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 4)
  Object num233 = alloc_Float64(0);
// compiled num node returning num233 (depth = 4)
    gc_frame_newslot(num233);
    if231 = num233;
  }
stackframe = iftmpstackframe231;
// compiled if node returning if231 (depth = 3)
  *var_numOpening = if231;
  if (if231 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num234 = alloc_Float64(0);
// compiled num node returning num234 (depth = 3)
  *var_numClosing = num234;
  if (num234 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject235 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj235 = alloc_userobj2(4,4, objclass235);
  gc_frame_newslot(obj235);
if (objclass235 == NULL) {
  glfree(obj235->class->name);
  obj235->class->name = "result";
}
// OBJECT OUTER DEC outer
  adddatum2(obj235, self, 0);
  addmethodreal(obj235,"outer", &reader_parser_outer_236);
  Object oldself235 = self;
  struct StackFrameObject *oldstackframe235 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe235);
  gc_frame_newslot((Object)stackframe);
  self = obj235;
  Object *oldselfslot235 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter235 = (*(struct UserObject *)self).data[0], lowerouter235 = thisouter235;
  if (inheritingObject235) {
    struct UserObject *inho235 = (struct UserObject *)inheritingObject235;
    while (inho235->super != GraceDefaultObject) inho235 = (struct UserObject *)inho235->super;
    inho235->super = obj235;
    self = inheritingObject235;
    *selfslot = self;
    lowerouter235 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter235;
  }
if (objclass235 == NULL) {
  Method *reader237 = addmethodrealflags(obj235, "found", &reader_parser_found_237, 0);
  Method *writer237 = addmethodrealflags(obj235, "found:=(1)", &writer_parser_found_237, 0);
  reader237->definitionModule = modulename;
  writer237->definitionModule = modulename;
  reader237->definitionLine = 126;
  writer237->definitionLine = 126;
}
obj235->flags |= OFLAG_MUTABLE;
adddatum2(obj235, alloc_Undefined(), 1);
if (objclass235 == NULL) {
  Method *reader238 = addmethodrealflags(obj235, "tok", &reader_parser_tok_238, 0);
  Method *writer238 = addmethodrealflags(obj235, "tok:=(1)", &writer_parser_tok_238, 0);
  reader238->definitionModule = modulename;
  writer238->definitionModule = modulename;
  reader238->definitionLine = 127;
  writer238->definitionLine = 127;
}
obj235->flags |= OFLAG_MUTABLE;
adddatum2(obj235, alloc_Undefined(), 2);
  sourceObject = obj235;
  adddatum2(obj235, undefined, 1);
  sourceObject = obj235;
  adddatum2(obj235, undefined, 2);
  objclass235 = obj235->class;
  objclass235->definitionModule = modulename;
  objclass235->definitionLine = 125;
  (*(struct UserObject *)self).data[0] = lowerouter235;
  self = oldself235;
  selfslot = oldselfslot235;
  stackframe = oldstackframe235;
// compiled object node returning obj235 (depth = 3)
  *var_result = obj235;
  if (obj235 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe239 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block240 = alloc_Block(NULL, NULL, "parser", 130);
  gc_frame_newslot(block240);
// method "_apply"
  block_savedest(block240);
  Object closure241 = createclosure(3, "_apply");
  setclosureframe(closure241, stackframe);
  addtoclosure(closure241, var_token);
  addtoclosure(closure241, var_n);
  addtoclosure(closure241, selfslot);
  struct UserObject *uo241 = (struct UserObject*)block240;
  uo241->data[0] = (Object)closure241;
  Method *meth_meth_parser__apply241 = addmethod2pos(block240, "_apply", &meth_parser__apply241, 0);
  int argcv_meth_parser__apply241[] = {0};
  meth_meth_parser__apply241->type = alloc_MethodType(1, argcv_meth_parser__apply241);
  meth_meth_parser__apply241->definitionModule = modulename;
  meth_meth_parser__apply241->definitionLine = 3399;
// compiled block node returning block240 (depth = 3)
  gc_frame_newslot(block240);
// starting to compile block node (depth = 3)
  Object block259 = alloc_Block(NULL, NULL, "parser", 130);
  gc_frame_newslot(block259);
// method "_apply"
  block_savedest(block259);
  Object closure260 = createclosure(4, "_apply");
  setclosureframe(closure260, stackframe);
  addtoclosure(closure260, var_n);
  addtoclosure(closure260, var_numOpening);
  addtoclosure(closure260, var_numClosing);
  addtoclosure(closure260, selfslot);
  struct UserObject *uo260 = (struct UserObject*)block259;
  uo260->data[0] = (Object)closure260;
  Method *meth_meth_parser__apply260 = addmethod2pos(block259, "_apply", &meth_parser__apply260, 0);
  int argcv_meth_parser__apply260[] = {0};
  meth_meth_parser__apply260->type = alloc_MethodType(1, argcv_meth_parser__apply260);
  meth_meth_parser__apply260->definitionModule = modulename;
  meth_meth_parser__apply260->definitionLine = 3399;
// compiled block node returning block259 (depth = 3)
  gc_frame_newslot(block259);
// call case 5: prelude request
  params[0] = block240;
  params[1] = block259;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call289 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe239);
// compiled call node returning call289 (depth = 2)
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe290 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block291 = alloc_Block(NULL, NULL, "parser", 136);
  gc_frame_newslot(block291);
// method "_apply"
  block_savedest(block291);
  Object closure292 = createclosure(3, "_apply");
  setclosureframe(closure292, stackframe);
  addtoclosure(closure292, var_token);
  addtoclosure(closure292, var_n);
  addtoclosure(closure292, selfslot);
  struct UserObject *uo292 = (struct UserObject*)block291;
  uo292->data[0] = (Object)closure292;
  Method *meth_meth_parser__apply292 = addmethod2pos(block291, "_apply", &meth_parser__apply292, 0);
  int argcv_meth_parser__apply292[] = {0};
  meth_meth_parser__apply292->type = alloc_MethodType(1, argcv_meth_parser__apply292);
  meth_meth_parser__apply292->definitionModule = modulename;
  meth_meth_parser__apply292->definitionLine = 3399;
// compiled block node returning block291 (depth = 3)
  gc_frame_newslot(block291);
// starting to compile block node (depth = 3)
  Object block310 = alloc_Block(NULL, NULL, "parser", 136);
  gc_frame_newslot(block310);
// method "_apply"
  block_savedest(block310);
  Object closure311 = createclosure(4, "_apply");
  setclosureframe(closure311, stackframe);
  addtoclosure(closure311, var_n);
  addtoclosure(closure311, var_numOpening);
  addtoclosure(closure311, var_numClosing);
  addtoclosure(closure311, selfslot);
  struct UserObject *uo311 = (struct UserObject*)block310;
  uo311->data[0] = (Object)closure311;
  Method *meth_meth_parser__apply311 = addmethod2pos(block310, "_apply", &meth_parser__apply311, 0);
  int argcv_meth_parser__apply311[] = {0};
  meth_meth_parser__apply311->type = alloc_MethodType(1, argcv_meth_parser__apply311);
  meth_meth_parser__apply311->definitionModule = modulename;
  meth_meth_parser__apply311->definitionLine = 3399;
// compiled block node returning block310 (depth = 3)
  gc_frame_newslot(block310);
// call case 5: prelude request
  params[0] = block291;
  params[1] = block310;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call340 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe290);
// compiled call node returning call340 (depth = 2)
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit343 == NULL) {
    strlit343 = alloc_String("rbrace");
    gc_root(strlit343);
  }
// compiled string node returning strlit343 (depth = 4)
  int op_slot_right_342 = gc_frame_newslot(strlit343);
// starting to compile member node (depth = 4)
  int callframe345 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  Object call346 = callmethodflags(*var_n, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe345);
// compiled member node returning call346 (depth = 4)
  int op_slot_left_342 = gc_frame_newslot(call346);
  params[0] = strlit343;
  partcv[0] = 1;
  Object opresult347 = callmethod(call346, "==(1)", 1, partcv, params);
// compiled op node returning opresult347 (depth = 3)
  Object if341 = done;
  if (istrue(opresult347)) {
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe348 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool349 = alloc_Boolean(1);
// compiled identifier node returning bool349 (depth = 4)
  gc_frame_newslot(bool349);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = bool349;
  partcv[0] = 1;
  Object call350 = callmethodflags(*var_result, "found:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe348);
// compiled call node returning call350 (depth = 3)
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe351 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call352 = callmethodflags(*var_result, "tok:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe351);
// compiled call node returning call352 (depth = 3)
    gc_frame_newslot(call352);
    if341 = call352;
  } else {
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 147
  setline(147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_numClosing (depth = 6)
  int op_slot_right_355 = gc_frame_newslot(*var_numClosing);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_numOpening (depth = 6)
  int op_slot_left_355 = gc_frame_newslot(*var_numOpening);
  params[0] = *var_numClosing;
  partcv[0] = 1;
  Object opresult357 = callmethod(*var_numOpening, "==(1)", 1, partcv, params);
// compiled op node returning opresult357 (depth = 5)
  int op_slot_right_354 = gc_frame_newslot(opresult357);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit360 == NULL) {
    strlit360 = alloc_String("rbrace");
    gc_root(strlit360);
  }
// compiled string node returning strlit360 (depth = 6)
  int op_slot_right_359 = gc_frame_newslot(strlit360);
// starting to compile member node (depth = 6)
  int callframe362 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe363 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  Object call364 = callmethodflags(*var_n, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe363);
// compiled member node returning call364 (depth = 7)
  Object call365 = callmethodflags(call364, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe362);
// compiled member node returning call365 (depth = 6)
  int op_slot_left_359 = gc_frame_newslot(call365);
  params[0] = strlit360;
  partcv[0] = 1;
  Object opresult366 = callmethod(call365, "==(1)", 1, partcv, params);
// compiled op node returning opresult366 (depth = 5)
  int op_slot_left_354 = gc_frame_newslot(opresult366);
  params[0] = opresult357;
  partcv[0] = 1;
  Object opresult367 = callmethod(opresult366, "&&(1)", 1, partcv, params);
// compiled op node returning opresult367 (depth = 4)
  Object if353 = done;
  if (istrue(opresult367)) {
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe368 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool369 = alloc_Boolean(1);
// compiled identifier node returning bool369 (depth = 5)
  gc_frame_newslot(bool369);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = bool369;
  partcv[0] = 1;
  Object call370 = callmethodflags(*var_result, "found:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe368);
// compiled call node returning call370 (depth = 4)
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe371 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe372 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  Object call373 = callmethodflags(*var_n, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe372);
// compiled member node returning call373 (depth = 5)
  gc_frame_newslot(call373);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = call373;
  partcv[0] = 1;
  Object call374 = callmethodflags(*var_result, "tok:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe371);
// compiled call node returning call374 (depth = 4)
    gc_frame_newslot(call374);
    if353 = call374;
  } else {
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe375 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool376 = alloc_Boolean(0);
// compiled identifier node returning bool376 (depth = 5)
  gc_frame_newslot(bool376);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = bool376;
  partcv[0] = 1;
  Object call377 = callmethodflags(*var_result, "found:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe375);
// compiled call node returning call377 (depth = 4)
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe378 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe379 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  Object call380 = callmethodflags(*var_n, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe379);
// compiled member node returning call380 (depth = 5)
  gc_frame_newslot(call380);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = call380;
  partcv[0] = 1;
  Object call381 = callmethodflags(*var_result, "tok:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe378);
// compiled call node returning call381 (depth = 4)
    gc_frame_newslot(call381);
    if353 = call381;
  }
// compiled if node returning if353 (depth = 3)
    gc_frame_newslot(if353);
    if341 = if353;
  }
// compiled if node returning if341 (depth = 2)
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_parser_accept_40_1_41_382(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for accept(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  int op_slot_right_383 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 3)
  int callframe385 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call386 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe385);
// compiled member node returning call386 (depth = 3)
  int op_slot_left_383 = gc_frame_newslot(call386);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult387 = callmethod(call386, "==(1)", 1, partcv, params);
// compiled op node returning opresult387 (depth = 2)
  gc_frame_end(frame);
  return opresult387;
}
Object meth_parser_acceptKeyword_40_1_41_388(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptKeyword(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptKeyword(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptKeyword(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_kw = &(stackframe->slots[0]);
  *var_kw = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part acceptKeyword(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit391 == NULL) {
    strlit391 = alloc_String("keyword");
    gc_root(strlit391);
  }
// compiled string node returning strlit391 (depth = 4)
  int op_slot_right_390 = gc_frame_newslot(strlit391);
// starting to compile member node (depth = 4)
  int callframe393 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call394 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe393);
// compiled member node returning call394 (depth = 4)
  int op_slot_left_390 = gc_frame_newslot(call394);
  params[0] = strlit391;
  partcv[0] = 1;
  Object opresult395 = callmethod(call394, "≠(1)", 1, partcv, params);
// compiled op node returning opresult395 (depth = 3)
  Object if389 = done;
  if (istrue(opresult395)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool396 = alloc_Boolean(0);
// compiled identifier node returning bool396 (depth = 4)
  return bool396;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if389 = undefined;
  } else {
  }
// compiled if node returning if389 (depth = 2)
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_kw (depth = 4)
  int op_slot_right_397 = gc_frame_newslot(*var_kw);
// starting to compile member node (depth = 4)
  int callframe399 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call400 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe399);
// compiled member node returning call400 (depth = 4)
  int op_slot_left_397 = gc_frame_newslot(call400);
  params[0] = *var_kw;
  partcv[0] = 1;
  Object opresult401 = callmethod(call400, "==(1)", 1, partcv, params);
// compiled op node returning opresult401 (depth = 3)
  return opresult401;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_acceptSameLine_40_1_41_402(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptSameLine(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptSameLine(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastLine = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptSameLine(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part acceptSameLine(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastIndent (depth = 5)
  int op_slot_right_405 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 5)
  int callframe407 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call408 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe407);
// compiled member node returning call408 (depth = 5)
  int op_slot_left_405 = gc_frame_newslot(call408);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult409 = callmethod(call408, ">(1)", 1, partcv, params);
// compiled op node returning opresult409 (depth = 4)
  int op_slot_right_404 = gc_frame_newslot(opresult409);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe412 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call413 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe412);
// compiled member node returning call413 (depth = 5)
  int op_slot_right_411 = gc_frame_newslot(call413);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastLine (depth = 5)
  int op_slot_left_411 = gc_frame_newslot(*var_lastLine);
  params[0] = call413;
  partcv[0] = 1;
  Object opresult415 = callmethod(*var_lastLine, "==(1)", 1, partcv, params);
// compiled op node returning opresult415 (depth = 4)
  int op_slot_left_404 = gc_frame_newslot(opresult415);
  params[0] = opresult409;
  partcv[0] = 1;
  Object opresult416 = callmethod(opresult415, "||(1)", 1, partcv, params);
// compiled op node returning opresult416 (depth = 3)
  int op_slot_right_403 = gc_frame_newslot(opresult416);
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_418 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
  int callframe420 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call421 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe420);
// compiled member node returning call421 (depth = 4)
  int op_slot_left_418 = gc_frame_newslot(call421);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult422 = callmethod(call421, "==(1)", 1, partcv, params);
// compiled op node returning opresult422 (depth = 3)
  int op_slot_left_403 = gc_frame_newslot(opresult422);
  params[0] = opresult416;
  partcv[0] = 1;
  Object opresult423 = callmethod(opresult422, "&&(1)", 1, partcv, params);
// compiled op node returning opresult423 (depth = 2)
  gc_frame_end(frame);
  return opresult423;
}
Object meth_parser_acceptWithoutSpaces_40_1_41_424(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptWithoutSpaces(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptWithoutSpaces(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastLine = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptWithoutSpaces(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part acceptWithoutSpaces(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe428 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call429 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe428);
// compiled member node returning call429 (depth = 5)
  int op_slot_right_427 = gc_frame_newslot(call429);
// starting to compile member node (depth = 5)
  int callframe431 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call432 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe431);
// compiled member node returning call432 (depth = 5)
  int op_slot_left_427 = gc_frame_newslot(call432);
  params[0] = call429;
  partcv[0] = 1;
  Object sum433 = callmethod(call432, "+(1)", 1, partcv, params);
// compiled op node returning sum433 (depth = 4)
  int op_slot_right_426 = gc_frame_newslot(sum433);
// starting to compile member node (depth = 4)
  int callframe435 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call436 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe435);
// compiled member node returning call436 (depth = 4)
  int op_slot_left_426 = gc_frame_newslot(call436);
  params[0] = sum433;
  partcv[0] = 1;
  Object opresult437 = callmethod(call436, "==(1)", 1, partcv, params);
// compiled op node returning opresult437 (depth = 3)
  int op_slot_right_425 = gc_frame_newslot(opresult437);
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe441 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call442 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe441);
// compiled member node returning call442 (depth = 5)
  int op_slot_right_440 = gc_frame_newslot(call442);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastLine (depth = 5)
  int op_slot_left_440 = gc_frame_newslot(*var_lastLine);
  params[0] = call442;
  partcv[0] = 1;
  Object opresult444 = callmethod(*var_lastLine, "==(1)", 1, partcv, params);
// compiled op node returning opresult444 (depth = 4)
  int op_slot_right_439 = gc_frame_newslot(opresult444);
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_t (depth = 5)
  int op_slot_right_446 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 5)
  int callframe448 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call449 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe448);
// compiled member node returning call449 (depth = 5)
  int op_slot_left_446 = gc_frame_newslot(call449);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult450 = callmethod(call449, "==(1)", 1, partcv, params);
// compiled op node returning opresult450 (depth = 4)
  int op_slot_left_439 = gc_frame_newslot(opresult450);
  params[0] = opresult444;
  partcv[0] = 1;
  Object opresult451 = callmethod(opresult450, "&&(1)", 1, partcv, params);
// compiled op node returning opresult451 (depth = 3)
  int op_slot_left_425 = gc_frame_newslot(opresult451);
  params[0] = opresult437;
  partcv[0] = 1;
  Object opresult452 = callmethod(opresult451, "&&(1)", 1, partcv, params);
// compiled op node returning opresult452 (depth = 2)
  gc_frame_end(frame);
  return opresult452;
}
Object meth_parser_acceptAfterSpaces_40_1_41_453(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptAfterSpaces(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptAfterSpaces(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastLine = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptAfterSpaces(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part acceptAfterSpaces(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_455 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
  int callframe457 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call458 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe457);
// compiled member node returning call458 (depth = 4)
  int op_slot_left_455 = gc_frame_newslot(call458);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult459 = callmethod(call458, "≠(1)", 1, partcv, params);
// compiled op node returning opresult459 (depth = 3)
  Object if454 = done;
  if (istrue(opresult459)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool460 = alloc_Boolean(0);
// compiled identifier node returning bool460 (depth = 4)
  return bool460;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if454 = undefined;
  } else {
  }
// compiled if node returning if454 (depth = 2)
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe463 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call464 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe463);
// compiled member node returning call464 (depth = 4)
  int op_slot_right_462 = gc_frame_newslot(call464);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastLine (depth = 4)
  int op_slot_left_462 = gc_frame_newslot(*var_lastLine);
  params[0] = call464;
  partcv[0] = 1;
  Object opresult466 = callmethod(*var_lastLine, "==(1)", 1, partcv, params);
// compiled op node returning opresult466 (depth = 3)
  Object if461 = done;
  if (istrue(opresult466)) {
// Begin line 191
  setline(191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe469 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call470 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe469);
// compiled member node returning call470 (depth = 6)
  int op_slot_right_468 = gc_frame_newslot(call470);
// starting to compile member node (depth = 6)
  int callframe472 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call473 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe472);
// compiled member node returning call473 (depth = 6)
  int op_slot_left_468 = gc_frame_newslot(call473);
  params[0] = call470;
  partcv[0] = 1;
  Object sum474 = callmethod(call473, "+(1)", 1, partcv, params);
// compiled op node returning sum474 (depth = 5)
  int op_slot_right_467 = gc_frame_newslot(sum474);
// starting to compile member node (depth = 5)
  int callframe476 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call477 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe476);
// compiled member node returning call477 (depth = 5)
  int op_slot_left_467 = gc_frame_newslot(call477);
  params[0] = sum474;
  partcv[0] = 1;
  Object opresult478 = callmethod(call477, "≠(1)", 1, partcv, params);
// compiled op node returning opresult478 (depth = 4)
  return opresult478;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if461 = undefined;
  } else {
  }
// compiled if node returning if461 (depth = 2)
// Begin line 193
  setline(193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num481 = alloc_Float64(1);
// compiled num node returning num481 (depth = 5)
  int op_slot_right_480 = gc_frame_newslot(num481);
// starting to compile member node (depth = 5)
  int callframe483 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call484 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe483);
// compiled member node returning call484 (depth = 5)
  int op_slot_left_480 = gc_frame_newslot(call484);
  params[0] = num481;
  partcv[0] = 1;
  Object sum485 = callmethod(call484, "+(1)", 1, partcv, params);
// compiled op node returning sum485 (depth = 4)
  int op_slot_right_479 = gc_frame_newslot(sum485);
// starting to compile member node (depth = 4)
  int callframe487 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call488 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe487);
// compiled member node returning call488 (depth = 4)
  int op_slot_left_479 = gc_frame_newslot(call488);
  params[0] = sum485;
  partcv[0] = 1;
  Object opresult489 = callmethod(call488, "==(1)", 1, partcv, params);
// compiled op node returning opresult489 (depth = 3)
  return opresult489;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_accept_40_1_41_onLineOf_40_1_41_490(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept(1)onLineOf(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)onLineOf(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)onLineOf(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)onLineOf(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_other = &(stackframe->slots[1]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLineOf(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 200
  setline(200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe494 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  Object call495 = callmethodflags(*var_other, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe494);
// compiled member node returning call495 (depth = 5)
  int op_slot_right_493 = gc_frame_newslot(call495);
// starting to compile member node (depth = 5)
  int callframe497 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call498 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe497);
// compiled member node returning call498 (depth = 5)
  int op_slot_left_493 = gc_frame_newslot(call498);
  params[0] = call495;
  partcv[0] = 1;
  Object opresult499 = callmethod(call498, ">(1)", 1, partcv, params);
// compiled op node returning opresult499 (depth = 4)
  int op_slot_right_492 = gc_frame_newslot(opresult499);
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe502 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call503 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe502);
// compiled member node returning call503 (depth = 5)
  int op_slot_right_501 = gc_frame_newslot(call503);
// starting to compile member node (depth = 5)
  int callframe505 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  Object call506 = callmethodflags(*var_other, "line", 0, partcv, params, 0);
  gc_frame_end(callframe505);
// compiled member node returning call506 (depth = 5)
  int op_slot_left_501 = gc_frame_newslot(call506);
  params[0] = call503;
  partcv[0] = 1;
  Object opresult507 = callmethod(call506, "==(1)", 1, partcv, params);
// compiled op node returning opresult507 (depth = 4)
  int op_slot_left_492 = gc_frame_newslot(opresult507);
  params[0] = opresult499;
  partcv[0] = 1;
  Object opresult508 = callmethod(opresult507, "||(1)", 1, partcv, params);
// compiled op node returning opresult508 (depth = 3)
  int op_slot_right_491 = gc_frame_newslot(opresult508);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_510 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
  int callframe512 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call513 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe512);
// compiled member node returning call513 (depth = 4)
  int op_slot_left_510 = gc_frame_newslot(call513);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult514 = callmethod(call513, "==(1)", 1, partcv, params);
// compiled op node returning opresult514 (depth = 3)
  int op_slot_left_491 = gc_frame_newslot(opresult514);
  params[0] = opresult508;
  partcv[0] = 1;
  Object opresult515 = callmethod(opresult514, "&&(1)", 1, partcv, params);
// compiled op node returning opresult515 (depth = 2)
  gc_frame_end(frame);
  return opresult515;
}
Object meth_parser_acceptAfterSpaces_40_1_41_onLineOf_40_1_41_516(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptAfterSpaces(1)onLineOf(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptAfterSpaces(_)onLineOf(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptAfterSpaces(_)onLineOf(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for acceptAfterSpaces(_)onLineOf(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part acceptAfterSpaces(_)");
  Object *var_other = &(stackframe->slots[1]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLineOf(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_518 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
  int callframe520 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call521 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe520);
// compiled member node returning call521 (depth = 4)
  int op_slot_left_518 = gc_frame_newslot(call521);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult522 = callmethod(call521, "≠(1)", 1, partcv, params);
// compiled op node returning opresult522 (depth = 3)
  Object if517 = done;
  if (istrue(opresult522)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool523 = alloc_Boolean(0);
// compiled identifier node returning bool523 (depth = 4)
  return bool523;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if517 = undefined;
  } else {
  }
// compiled if node returning if517 (depth = 2)
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe526 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call527 = callmethodflags(*var_other, "line", 0, partcv, params, 0);
  gc_frame_end(callframe526);
// compiled member node returning call527 (depth = 4)
  int op_slot_right_525 = gc_frame_newslot(call527);
// starting to compile member node (depth = 4)
  int callframe529 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call530 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe529);
// compiled member node returning call530 (depth = 4)
  int op_slot_left_525 = gc_frame_newslot(call530);
  params[0] = call527;
  partcv[0] = 1;
  Object opresult531 = callmethod(call530, "==(1)", 1, partcv, params);
// compiled op node returning opresult531 (depth = 3)
  Object if524 = done;
  if (istrue(opresult531)) {
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe534 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call535 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe534);
// compiled member node returning call535 (depth = 6)
  int op_slot_right_533 = gc_frame_newslot(call535);
// starting to compile member node (depth = 6)
  int callframe537 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call538 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe537);
// compiled member node returning call538 (depth = 6)
  int op_slot_left_533 = gc_frame_newslot(call538);
  params[0] = call535;
  partcv[0] = 1;
  Object sum539 = callmethod(call538, "+(1)", 1, partcv, params);
// compiled op node returning sum539 (depth = 5)
  int op_slot_right_532 = gc_frame_newslot(sum539);
// starting to compile member node (depth = 5)
  int callframe541 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call542 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe541);
// compiled member node returning call542 (depth = 5)
  int op_slot_left_532 = gc_frame_newslot(call542);
  params[0] = sum539;
  partcv[0] = 1;
  Object opresult543 = callmethod(call542, "≠(1)", 1, partcv, params);
// compiled op node returning opresult543 (depth = 4)
  return opresult543;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if524 = undefined;
  } else {
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num546 = alloc_Float64(1);
// compiled num node returning num546 (depth = 6)
  int op_slot_right_545 = gc_frame_newslot(num546);
// starting to compile member node (depth = 6)
  int callframe548 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call549 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe548);
// compiled member node returning call549 (depth = 6)
  int op_slot_left_545 = gc_frame_newslot(call549);
  params[0] = num546;
  partcv[0] = 1;
  Object sum550 = callmethod(call549, "+(1)", 1, partcv, params);
// compiled op node returning sum550 (depth = 5)
  int op_slot_right_544 = gc_frame_newslot(sum550);
// starting to compile member node (depth = 5)
  int callframe552 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call553 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe552);
// compiled member node returning call553 (depth = 5)
  int op_slot_left_544 = gc_frame_newslot(call553);
  params[0] = sum550;
  partcv[0] = 1;
  Object opresult554 = callmethod(call553, "==(1)", 1, partcv, params);
// compiled op node returning opresult554 (depth = 4)
  return opresult554;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if524 = undefined;
  }
// compiled if node returning if524 (depth = 2)
  gc_frame_end(frame);
  return if524;
}
Object meth_parser_accept_40_1_41_onLineOfLastOr_40_1_41_555(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept(1)onLineOfLastOr(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)onLineOfLastOr(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)onLineOfLastOr(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)onLineOfLastOr(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_other = &(stackframe->slots[1]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLineOfLastOr(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe559 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call560 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe559);
// compiled member node returning call560 (depth = 5)
  int op_slot_right_558 = gc_frame_newslot(call560);
// starting to compile member node (depth = 5)
  int callframe562 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call563 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe562);
// compiled member node returning call563 (depth = 5)
  int op_slot_left_558 = gc_frame_newslot(call563);
  params[0] = call560;
  partcv[0] = 1;
  Object opresult564 = callmethod(call563, "==(1)", 1, partcv, params);
// compiled op node returning opresult564 (depth = 4)
  int op_slot_right_557 = gc_frame_newslot(opresult564);
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe568 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  Object call569 = callmethodflags(*var_other, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe568);
// compiled member node returning call569 (depth = 6)
  int op_slot_right_567 = gc_frame_newslot(call569);
// starting to compile member node (depth = 6)
  int callframe571 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call572 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe571);
// compiled member node returning call572 (depth = 6)
  int op_slot_left_567 = gc_frame_newslot(call572);
  params[0] = call569;
  partcv[0] = 1;
  Object opresult573 = callmethod(call572, ">(1)", 1, partcv, params);
// compiled op node returning opresult573 (depth = 5)
  int op_slot_right_566 = gc_frame_newslot(opresult573);
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe576 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call577 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe576);
// compiled member node returning call577 (depth = 6)
  int op_slot_right_575 = gc_frame_newslot(call577);
// starting to compile member node (depth = 6)
  int callframe579 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  Object call580 = callmethodflags(*var_other, "line", 0, partcv, params, 0);
  gc_frame_end(callframe579);
// compiled member node returning call580 (depth = 6)
  int op_slot_left_575 = gc_frame_newslot(call580);
  params[0] = call577;
  partcv[0] = 1;
  Object opresult581 = callmethod(call580, "==(1)", 1, partcv, params);
// compiled op node returning opresult581 (depth = 5)
  int op_slot_left_566 = gc_frame_newslot(opresult581);
  params[0] = opresult573;
  partcv[0] = 1;
  Object opresult582 = callmethod(opresult581, "||(1)", 1, partcv, params);
// compiled op node returning opresult582 (depth = 4)
  int op_slot_left_557 = gc_frame_newslot(opresult582);
  params[0] = opresult564;
  partcv[0] = 1;
  Object opresult583 = callmethod(opresult582, "||(1)", 1, partcv, params);
// compiled op node returning opresult583 (depth = 3)
  int op_slot_right_556 = gc_frame_newslot(opresult583);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_585 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
  int callframe587 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call588 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe587);
// compiled member node returning call588 (depth = 4)
  int op_slot_left_585 = gc_frame_newslot(call588);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult589 = callmethod(call588, "==(1)", 1, partcv, params);
// compiled op node returning opresult589 (depth = 3)
  int op_slot_left_556 = gc_frame_newslot(opresult589);
  params[0] = opresult583;
  partcv[0] = 1;
  Object opresult590 = callmethod(opresult589, "&&(1)", 1, partcv, params);
// compiled op node returning opresult590 (depth = 2)
  gc_frame_end(frame);
  return opresult590;
}
Object meth_parser_acceptArgumentOnLineOf_40_1_41_591(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptArgumentOnLineOf(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptArgumentOnLineOf(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptArgumentOnLineOf(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tok = &(stackframe->slots[0]);
  *var_tok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part acceptArgumentOnLineOf(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe593 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit594 == NULL) {
    strlit594 = alloc_String("string");
    gc_root(strlit594);
  }
// compiled string node returning strlit594 (depth = 4)
  gc_frame_newslot(strlit594);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit594;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call595 = callmethodflags(self, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe593);
// compiled call node returning call595 (depth = 3)
  Object if592 = done;
  if (istrue(call595)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool596 = alloc_Boolean(1);
// compiled identifier node returning bool596 (depth = 4)
  return bool596;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if592 = undefined;
  } else {
  }
// compiled if node returning if592 (depth = 2)
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe598 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit599 == NULL) {
    strlit599 = alloc_String("num");
    gc_root(strlit599);
  }
// compiled string node returning strlit599 (depth = 4)
  gc_frame_newslot(strlit599);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit599;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call600 = callmethodflags(self, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe598);
// compiled call node returning call600 (depth = 3)
  Object if597 = done;
  if (istrue(call600)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool601 = alloc_Boolean(1);
// compiled identifier node returning bool601 (depth = 4)
  return bool601;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if597 = undefined;
  } else {
  }
// compiled if node returning if597 (depth = 2)
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe603 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit604 == NULL) {
    strlit604 = alloc_String("lbrace");
    gc_root(strlit604);
  }
// compiled string node returning strlit604 (depth = 4)
  gc_frame_newslot(strlit604);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit604;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call605 = callmethodflags(self, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe603);
// compiled call node returning call605 (depth = 3)
  Object if602 = done;
  if (istrue(call605)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool606 = alloc_Boolean(1);
// compiled identifier node returning bool606 (depth = 4)
  return bool606;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if602 = undefined;
  } else {
  }
// compiled if node returning if602 (depth = 2)
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe608 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit609 == NULL) {
    strlit609 = alloc_String("lsquare");
    gc_root(strlit609);
  }
// compiled string node returning strlit609 (depth = 4)
  gc_frame_newslot(strlit609);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit609;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call610 = callmethodflags(self, "acceptAfterSpaces(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe608);
// compiled call node returning call610 (depth = 3)
  Object if607 = done;
  if (istrue(call610)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool611 = alloc_Boolean(1);
// compiled identifier node returning bool611 (depth = 4)
  return bool611;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if607 = undefined;
  } else {
  }
// compiled if node returning if607 (depth = 2)
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe613 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit614 == NULL) {
    strlit614 = alloc_String("identifier");
    gc_root(strlit614);
  }
// compiled string node returning strlit614 (depth = 4)
  gc_frame_newslot(strlit614);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit614;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call615 = callmethodflags(self, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe613);
// compiled call node returning call615 (depth = 3)
  Object if612 = done;
  if (istrue(call615)) {
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit618 == NULL) {
    strlit618 = alloc_String("false");
    gc_root(strlit618);
  }
// compiled string node returning strlit618 (depth = 6)
  int op_slot_right_617 = gc_frame_newslot(strlit618);
// starting to compile member node (depth = 6)
  int callframe620 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call621 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe620);
// compiled member node returning call621 (depth = 6)
  int op_slot_left_617 = gc_frame_newslot(call621);
  params[0] = strlit618;
  partcv[0] = 1;
  Object opresult622 = callmethod(call621, "==(1)", 1, partcv, params);
// compiled op node returning opresult622 (depth = 5)
  int op_slot_right_616 = gc_frame_newslot(opresult622);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit625 == NULL) {
    strlit625 = alloc_String("true");
    gc_root(strlit625);
  }
// compiled string node returning strlit625 (depth = 6)
  int op_slot_right_624 = gc_frame_newslot(strlit625);
// starting to compile member node (depth = 6)
  int callframe627 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call628 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe627);
// compiled member node returning call628 (depth = 6)
  int op_slot_left_624 = gc_frame_newslot(call628);
  params[0] = strlit625;
  partcv[0] = 1;
  Object opresult629 = callmethod(call628, "==(1)", 1, partcv, params);
// compiled op node returning opresult629 (depth = 5)
  int op_slot_left_616 = gc_frame_newslot(opresult629);
  params[0] = opresult622;
  partcv[0] = 1;
  Object opresult630 = callmethod(opresult629, "||(1)", 1, partcv, params);
// compiled op node returning opresult630 (depth = 4)
  return opresult630;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if612 = undefined;
  } else {
  }
// compiled if node returning if612 (depth = 2)
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool631 = alloc_Boolean(0);
// compiled identifier node returning bool631 (depth = 3)
  return bool631;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_tokenOnSameLine632(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokenOnSameLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastLine = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastIndent (depth = 4)
  int op_slot_right_634 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 4)
  int callframe636 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call637 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe636);
// compiled member node returning call637 (depth = 4)
  int op_slot_left_634 = gc_frame_newslot(call637);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult638 = callmethod(call637, ">(1)", 1, partcv, params);
// compiled op node returning opresult638 (depth = 3)
  int op_slot_right_633 = gc_frame_newslot(opresult638);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe641 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call642 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe641);
// compiled member node returning call642 (depth = 4)
  int op_slot_right_640 = gc_frame_newslot(call642);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastLine (depth = 4)
  int op_slot_left_640 = gc_frame_newslot(*var_lastLine);
  params[0] = call642;
  partcv[0] = 1;
  Object opresult644 = callmethod(*var_lastLine, "==(1)", 1, partcv, params);
// compiled op node returning opresult644 (depth = 3)
  int op_slot_left_633 = gc_frame_newslot(opresult644);
  params[0] = opresult638;
  partcv[0] = 1;
  Object opresult645 = callmethod(opresult644, "||(1)", 1, partcv, params);
// compiled op node returning opresult645 (depth = 2)
  gc_frame_end(frame);
  return opresult645;
}
Object meth_parser_didConsume_40_1_41_646(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "didConsume(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method didConsume(_)");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for didConsume(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aParsingBlock = &(stackframe->slots[0]);
  *var_aParsingBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part didConsume(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sz");
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe647 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokens (depth = 4)
  Object call648 = callmethodflags(*var_tokens, "size", 0, partcv, params, 0);
  gc_frame_end(callframe647);
// compiled member node returning call648 (depth = 3)
  *var_sz = call648;
  if (call648 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe649 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_aParsingBlock (depth = 3)
  Object call650 = callmethodflags(*var_aParsingBlock, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe649);
// compiled member node returning call650 (depth = 2)
// Begin line 239
  setline(239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sz (depth = 3)
  int op_slot_right_651 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 3)
  int callframe653 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokens (depth = 4)
  Object call654 = callmethodflags(*var_tokens, "size", 0, partcv, params, 0);
  gc_frame_end(callframe653);
// compiled member node returning call654 (depth = 3)
  int op_slot_left_651 = gc_frame_newslot(call654);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult655 = callmethod(call654, "≠(1)", 1, partcv, params);
// compiled op node returning opresult655 (depth = 2)
  gc_frame_end(frame);
  return opresult655;
}
Object meth_parser_ifConsume_40_1_41_then_40_1_41_656(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ifConsume(1)then(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ifConsume(_)then(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ifConsume(_)then(_)");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for ifConsume(_)then(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_ablock = &(stackframe->slots[0]);
  *var_ablock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifConsume(_)");
  Object *var_tblock = &(stackframe->slots[1]);
  *var_tblock = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part then(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "sz");
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe657 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokens (depth = 4)
  Object call658 = callmethodflags(*var_tokens, "size", 0, partcv, params, 0);
  gc_frame_end(callframe657);
// compiled member node returning call658 (depth = 3)
  *var_sz = call658;
  if (call658 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe659 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ablock (depth = 3)
  Object call660 = callmethodflags(*var_ablock, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe659);
// compiled member node returning call660 (depth = 2)
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_662 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
  int callframe664 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  Object call665 = callmethodflags(*var_tokens, "size", 0, partcv, params, 0);
  gc_frame_end(callframe664);
// compiled member node returning call665 (depth = 4)
  int op_slot_left_662 = gc_frame_newslot(call665);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult666 = callmethod(call665, "≠(1)", 1, partcv, params);
// compiled op node returning opresult666 (depth = 3)
  Object if661 = done;
  if (istrue(opresult666)) {
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe667 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tblock (depth = 4)
  Object call668 = callmethodflags(*var_tblock, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe667);
// compiled member node returning call668 (depth = 3)
    gc_frame_newslot(call668);
    if661 = call668;
  } else {
  }
// compiled if node returning if661 (depth = 2)
  gc_frame_end(frame);
  return if661;
}
Object meth_parser_pushnum669(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushnum");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe670 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe671 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call672 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe671);
// compiled member node returning call672 (depth = 4)
  gc_frame_newslot(call672);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe673 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call674 = callmethodflags(*var_ast, "numNode", 0, partcv, params, 0);
  gc_frame_end(callframe673);
// compiled member node returning call674 (depth = 4)
  params[0] = call672;
  partcv[0] = 1;
  Object call675 = callmethodflags(call674, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe670);
// compiled call node returning call675 (depth = 3)
  *var_o = call675;
  if (call675 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe676 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call677 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe676);
// compiled call node returning call677 (depth = 2)
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe678 = gc_frame_new();
// call case 4: self request
  Object call679 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe678);
// compiled member node returning call679 (depth = 2)
  gc_frame_end(frame);
  return call679;
}
Object meth_parser_pushstring680(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushstring");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe681 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe682 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call683 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe682);
// compiled member node returning call683 (depth = 4)
  gc_frame_newslot(call683);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe684 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call685 = callmethodflags(*var_ast, "stringNode", 0, partcv, params, 0);
  gc_frame_end(callframe684);
// compiled member node returning call685 (depth = 4)
  params[0] = call683;
  partcv[0] = 1;
  Object call686 = callmethodflags(call685, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe681);
// compiled call node returning call686 (depth = 3)
  *var_o = call686;
  if (call686 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe687 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call688 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe687);
// compiled call node returning call688 (depth = 2)
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe689 = gc_frame_new();
// call case 4: self request
  Object call690 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe689);
// compiled member node returning call690 (depth = 2)
  gc_frame_end(frame);
  return call690;
}
Object meth_parser_pushidentifier691(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushidentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_auto_count = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 267
  setline(267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe692 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe693 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call694 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe693);
// compiled member node returning call694 (depth = 3)
  gc_frame_newslot(call694);
// starting to compile member node (depth = 3)
  int callframe695 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call696 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe695);
// compiled member node returning call696 (depth = 3)
  gc_frame_newslot(call696);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call694;
  params[1] = call696;
  partcv[0] = 2;
  Object call697 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe692);
// compiled call node returning call697 (depth = 2)
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe698 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe699 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call700 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe699);
// compiled member node returning call700 (depth = 4)
  gc_frame_newslot(call700);
// starting to compile identifier node (depth = 4)
  Object bool701 = alloc_Boolean(0);
// compiled identifier node returning bool701 (depth = 4)
  gc_frame_newslot(bool701);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe702 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call703 = callmethodflags(*var_ast, "identifierNode", 0, partcv, params, 0);
  gc_frame_end(callframe702);
// compiled member node returning call703 (depth = 4)
  params[0] = call700;
  params[1] = bool701;
  partcv[0] = 2;
  Object call704 = callmethodflags(call703, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe698);
// compiled call node returning call704 (depth = 3)
  *var_o = call704;
  if (call704 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit707 == NULL) {
    strlit707 = alloc_String("_");
    gc_root(strlit707);
  }
// compiled string node returning strlit707 (depth = 4)
  int op_slot_right_706 = gc_frame_newslot(strlit707);
// starting to compile member node (depth = 4)
  int callframe709 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  Object call710 = callmethodflags(*var_o, "value", 0, partcv, params, 0);
  gc_frame_end(callframe709);
// compiled member node returning call710 (depth = 4)
  int op_slot_left_706 = gc_frame_newslot(call710);
  params[0] = strlit707;
  partcv[0] = 1;
  Object opresult711 = callmethod(call710, "==(1)", 1, partcv, params);
// compiled op node returning opresult711 (depth = 3)
  Object if705 = done;
  if (istrue(opresult711)) {
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe712 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_auto_count (depth = 5)
  int op_slot_right_713 = gc_frame_newslot(*var_auto_count);
// starting to compile string node (depth = 5)
  if (strlit715 == NULL) {
    strlit715 = alloc_String("__");
    gc_root(strlit715);
  }
// compiled string node returning strlit715 (depth = 5)
  int op_slot_left_713 = gc_frame_newslot(strlit715);
  params[0] = *var_auto_count;
  partcv[0] = 1;
  Object opresult716 = callmethod(strlit715, "++(1)", 1, partcv, params);
// compiled op node returning opresult716 (depth = 4)
  gc_frame_newslot(opresult716);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = opresult716;
  partcv[0] = 1;
  Object call717 = callmethodflags(*var_o, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe712);
// compiled call node returning call717 (depth = 3)
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe718 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool719 = alloc_Boolean(1);
// compiled identifier node returning bool719 (depth = 4)
  gc_frame_newslot(bool719);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = bool719;
  partcv[0] = 1;
  Object call720 = callmethodflags(*var_o, "wildcard:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe718);
// compiled call node returning call720 (depth = 3)
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num722 = alloc_Float64(1);
// compiled num node returning num722 (depth = 5)
  int op_slot_right_721 = gc_frame_newslot(num722);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_auto_count (depth = 5)
  int op_slot_left_721 = gc_frame_newslot(*var_auto_count);
  params[0] = num722;
  partcv[0] = 1;
  Object sum724 = callmethod(*var_auto_count, "+(1)", 1, partcv, params);
// compiled op node returning sum724 (depth = 4)
  *var_auto_count = sum724;
  if (sum724 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if705 = done;
  } else {
  }
// compiled if node returning if705 (depth = 2)
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe726 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call727 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe726);
// compiled call node returning call727 (depth = 2)
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe728 = gc_frame_new();
// call case 4: self request
  Object call729 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe728);
// compiled member node returning call729 (depth = 2)
  gc_frame_end(frame);
  return call729;
}
Object meth_parser__apply751(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe753 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  Object call754 = callmethodflags(*var_a, "dtype", 0, partcv, params, 0);
  gc_frame_end(callframe753);
// compiled member node returning call754 (depth = 11)
  int op_slot_right_752 = gc_frame_newslot(call754);
// starting to compile identifier node (depth = 11)
  Object bool756 = alloc_Boolean(0);
// compiled identifier node returning bool756 (depth = 11)
  int op_slot_left_752 = gc_frame_newslot(bool756);
  params[0] = call754;
  partcv[0] = 1;
  Object opresult757 = callmethod(bool756, "≠(1)", 1, partcv, params);
// compiled op node returning opresult757 (depth = 10)
  gc_frame_end(frame);
  return opresult757;
}
Object meth_parser__apply769(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit771 == NULL) {
    strlit771 = alloc_String(":");
    gc_root(strlit771);
  }
// compiled string node returning strlit771 (depth = 11)
  int op_slot_right_770 = gc_frame_newslot(strlit771);
// starting to compile member node (depth = 11)
  int callframe773 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tok (depth = 12)
  Object call774 = callmethodflags(*var_tok, "value", 0, partcv, params, 0);
  gc_frame_end(callframe773);
// compiled member node returning call774 (depth = 11)
  int op_slot_left_770 = gc_frame_newslot(call774);
  params[0] = strlit771;
  partcv[0] = 1;
  Object opresult775 = callmethod(call774, "≠(1)", 1, partcv, params);
// compiled op node returning opresult775 (depth = 10)
  gc_frame_end(frame);
  return opresult775;
}
Object meth_parser__apply778(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe779 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tok (depth = 12)
  Object call780 = callmethodflags(*var_tok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe779);
// compiled member node returning call780 (depth = 11)
  *var_tok = call780;
  if (call780 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply_40_1_41_747(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_tok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "tok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile block node (depth = 9)
  Object block750 = alloc_Block(NULL, NULL, "parser", 282);
  gc_frame_newslot(block750);
// method "_apply"
  block_savedest(block750);
  Object closure751 = createclosure(2, "_apply");
  setclosureframe(closure751, stackframe);
  addtoclosure(closure751, var_a);
  addtoclosure(closure751, selfslot);
  struct UserObject *uo751 = (struct UserObject*)block750;
  uo751->data[0] = (Object)closure751;
  Method *meth_meth_parser__apply751 = addmethod2pos(block750, "_apply", &meth_parser__apply751, 0);
  int argcv_meth_parser__apply751[] = {0};
  meth_meth_parser__apply751->type = alloc_MethodType(1, argcv_meth_parser__apply751);
  meth_meth_parser__apply751->definitionModule = modulename;
  meth_meth_parser__apply751->definitionLine = 3399;
// compiled block node returning block750 (depth = 9)
  int op_slot_right_749 = gc_frame_newslot(block750);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit761 == NULL) {
    strlit761 = alloc_String("identifier");
    gc_root(strlit761);
  }
// compiled string node returning strlit761 (depth = 10)
  int op_slot_right_760 = gc_frame_newslot(strlit761);
// starting to compile member node (depth = 10)
  int callframe763 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  Object call764 = callmethodflags(*var_a, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe763);
// compiled member node returning call764 (depth = 10)
  int op_slot_left_760 = gc_frame_newslot(call764);
  params[0] = strlit761;
  partcv[0] = 1;
  Object opresult765 = callmethod(call764, "==(1)", 1, partcv, params);
// compiled op node returning opresult765 (depth = 9)
  int op_slot_left_749 = gc_frame_newslot(opresult765);
  params[0] = block750;
  partcv[0] = 1;
  Object opresult766 = callmethod(opresult765, "&&(1)", 1, partcv, params);
// compiled op node returning opresult766 (depth = 8)
  Object if748 = done;
  if (istrue(opresult766)) {
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe767 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block768 = alloc_Block(NULL, NULL, "parser", 285);
  gc_frame_newslot(block768);
// method "_apply"
  block_savedest(block768);
  Object closure769 = createclosure(2, "_apply");
  setclosureframe(closure769, stackframe);
  addtoclosure(closure769, var_tok);
  addtoclosure(closure769, selfslot);
  struct UserObject *uo769 = (struct UserObject*)block768;
  uo769->data[0] = (Object)closure769;
  Method *meth_meth_parser__apply769 = addmethod2pos(block768, "_apply", &meth_parser__apply769, 0);
  int argcv_meth_parser__apply769[] = {0};
  meth_meth_parser__apply769->type = alloc_MethodType(1, argcv_meth_parser__apply769);
  meth_meth_parser__apply769->definitionModule = modulename;
  meth_meth_parser__apply769->definitionLine = 3399;
// compiled block node returning block768 (depth = 9)
  gc_frame_newslot(block768);
// starting to compile block node (depth = 9)
  Object block777 = alloc_Block(NULL, NULL, "parser", 285);
  gc_frame_newslot(block777);
// method "_apply"
  block_savedest(block777);
  Object closure778 = createclosure(2, "_apply");
  setclosureframe(closure778, stackframe);
  addtoclosure(closure778, var_tok);
  addtoclosure(closure778, selfslot);
  struct UserObject *uo778 = (struct UserObject*)block777;
  uo778->data[0] = (Object)closure778;
  Method *meth_meth_parser__apply778 = addmethod2pos(block777, "_apply", &meth_parser__apply778, 0);
  int argcv_meth_parser__apply778[] = {0};
  meth_meth_parser__apply778->type = alloc_MethodType(1, argcv_meth_parser__apply778);
  meth_meth_parser__apply778->definitionModule = modulename;
  meth_meth_parser__apply778->definitionLine = 3399;
// compiled block node returning block777 (depth = 9)
  gc_frame_newslot(block777);
// call case 5: prelude request
  params[0] = block768;
  params[1] = block777;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call783 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe767);
// compiled call node returning call783 (depth = 8)
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe784 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe785 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call786 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe785);
// compiled member node returning call786 (depth = 10)
  Object call787 = callmethodflags(call786, "new", 0, partcv, params, 0);
  gc_frame_end(callframe784);
// compiled member node returning call787 (depth = 9)
  *var_suggestion = call787;
  if (call787 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe788 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// starting to compile member node (depth = 9)
  int callframe789 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  Object call790 = callmethodflags(*var_tok, "next", 0, partcv, params, 0);
  gc_frame_end(callframe789);
// compiled member node returning call790 (depth = 9)
  gc_frame_newslot(call790);
// starting to compile identifier node (depth = 9)
  Object bool791 = alloc_Boolean(1);
// compiled identifier node returning bool791 (depth = 9)
  gc_frame_newslot(bool791);
// starting to compile identifier node (depth = 9)
  Object bool792 = alloc_Boolean(0);
// compiled identifier node returning bool792 (depth = 9)
  gc_frame_newslot(bool792);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_tok;
  params[1] = call790;
  params[2] = bool791;
  params[3] = bool792;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call793 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe788);
// compiled call node returning call793 (depth = 8)
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe794 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit795 == NULL) {
    strlit795 = alloc_String("an argument to an annotation cannot have a type.");
    gc_root(strlit795);
  }
// compiled string node returning strlit795 (depth = 9)
  gc_frame_newslot(strlit795);
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe796 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  Object call797 = callmethodflags(*var_tok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe796);
// compiled member node returning call797 (depth = 9)
  gc_frame_newslot(call797);
// starting to compile member node (depth = 9)
  int callframe798 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  Object call799 = callmethodflags(*var_tok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe798);
// compiled member node returning call799 (depth = 9)
  gc_frame_newslot(call799);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num801 = alloc_Float64(1);
// compiled num node returning num801 (depth = 10)
  int op_slot_right_800 = gc_frame_newslot(num801);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe804 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe805 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  Object call806 = callmethodflags(*var_tok, "next", 0, partcv, params, 0);
  gc_frame_end(callframe805);
// compiled member node returning call806 (depth = 12)
  Object call807 = callmethodflags(call806, "size", 0, partcv, params, 0);
  gc_frame_end(callframe804);
// compiled member node returning call807 (depth = 11)
  int op_slot_right_803 = gc_frame_newslot(call807);
// starting to compile member node (depth = 11)
  int callframe809 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe810 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  Object call811 = callmethodflags(*var_tok, "next", 0, partcv, params, 0);
  gc_frame_end(callframe810);
// compiled member node returning call811 (depth = 12)
  Object call812 = callmethodflags(call811, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe809);
// compiled member node returning call812 (depth = 11)
  int op_slot_left_803 = gc_frame_newslot(call812);
  params[0] = call807;
  partcv[0] = 1;
  Object sum813 = callmethod(call812, "+(1)", 1, partcv, params);
// compiled op node returning sum813 (depth = 10)
  int op_slot_left_800 = gc_frame_newslot(sum813);
  params[0] = num801;
  partcv[0] = 1;
  Object diff814 = callmethod(sum813, "-(1)", 1, partcv, params);
// compiled op node returning diff814 (depth = 9)
  gc_frame_newslot(diff814);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit795;
  params[1] = call797;
  params[2] = call799;
  params[3] = diff814;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call815 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe794);
// compiled call node returning call815 (depth = 8)
    gc_frame_newslot(call815);
    if748 = call815;
  } else {
  }
// compiled if node returning if748 (depth = 7)
  gc_frame_end(frame);
  return if748;
}
Object meth_parser__apply_40_1_41_742(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe743 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe744 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  Object call745 = callmethodflags(*var_p, "args", 0, partcv, params, 0);
  gc_frame_end(callframe744);
// compiled member node returning call745 (depth = 6)
  gc_frame_newslot(call745);
// starting to compile block node (depth = 6)
  Object block746 = alloc_Block(NULL, NULL, "parser", 281);
  gc_frame_newslot(block746);
// method "_apply(_)"
  block_savedest(block746);
  Object closure747 = createclosure(3, "_apply(1)");
  setclosureframe(closure747, stackframe);
  addtoclosure(closure747, var_sym);
  addtoclosure(closure747, var_errormessages);
  addtoclosure(closure747, selfslot);
  struct UserObject *uo747 = (struct UserObject*)block746;
  uo747->data[0] = (Object)closure747;
  Method *meth_meth_parser__apply_40_1_41_747 = addmethod2pos(block746, "_apply(1)", &meth_parser__apply_40_1_41_747, 0);
  int argcv_meth_parser__apply_40_1_41_747[] = {1};
  meth_meth_parser__apply_40_1_41_747->type = alloc_MethodType(1, argcv_meth_parser__apply_40_1_41_747);
  meth_meth_parser__apply_40_1_41_747->definitionModule = modulename;
  meth_meth_parser__apply_40_1_41_747->definitionLine = 3399;
// compiled block node returning block746 (depth = 6)
  gc_frame_newslot(block746);
// call case 5: prelude request
  params[0] = call745;
  params[1] = block746;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call817 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe743);
// compiled call node returning call817 (depth = 5)
  gc_frame_end(frame);
  return call817;
}
Object meth_parser_checkAnnotation_40_1_41_730(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkAnnotation(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method checkAnnotation(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for checkAnnotation(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part checkAnnotation(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit733 == NULL) {
    strlit733 = alloc_String("call");
    gc_root(strlit733);
  }
// compiled string node returning strlit733 (depth = 4)
  int op_slot_right_732 = gc_frame_newslot(strlit733);
// starting to compile member node (depth = 4)
  int callframe735 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ann (depth = 5)
  Object call736 = callmethodflags(*var_ann, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe735);
// compiled member node returning call736 (depth = 4)
  int op_slot_left_732 = gc_frame_newslot(call736);
  params[0] = strlit733;
  partcv[0] = 1;
  Object opresult737 = callmethod(call736, "==(1)", 1, partcv, params);
// compiled op node returning opresult737 (depth = 3)
  Object if731 = done;
  if (istrue(opresult737)) {
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe738 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe739 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ann (depth = 5)
  Object call740 = callmethodflags(*var_ann, "with", 0, partcv, params, 0);
  gc_frame_end(callframe739);
// compiled member node returning call740 (depth = 4)
  gc_frame_newslot(call740);
// starting to compile block node (depth = 4)
  Object block741 = alloc_Block(NULL, NULL, "parser", 280);
  gc_frame_newslot(block741);
// method "_apply(_)"
  block_savedest(block741);
  Object closure742 = createclosure(3, "_apply(1)");
  setclosureframe(closure742, stackframe);
  addtoclosure(closure742, var_sym);
  addtoclosure(closure742, var_errormessages);
  addtoclosure(closure742, selfslot);
  struct UserObject *uo742 = (struct UserObject*)block741;
  uo742->data[0] = (Object)closure742;
  Method *meth_meth_parser__apply_40_1_41_742 = addmethod2pos(block741, "_apply(1)", &meth_parser__apply_40_1_41_742, 0);
  int argcv_meth_parser__apply_40_1_41_742[] = {1};
  meth_meth_parser__apply_40_1_41_742->type = alloc_MethodType(1, argcv_meth_parser__apply_40_1_41_742);
  meth_meth_parser__apply_40_1_41_742->definitionModule = modulename;
  meth_meth_parser__apply_40_1_41_742->definitionLine = 3399;
// compiled block node returning block741 (depth = 4)
  gc_frame_newslot(block741);
// call case 5: prelude request
  params[0] = call740;
  params[1] = block741;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call819 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe738);
// compiled call node returning call819 (depth = 3)
    gc_frame_newslot(call819);
    if731 = call819;
  } else {
  }
// compiled if node returning if731 (depth = 2)
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_ann (depth = 2)
  gc_frame_end(frame);
  return *var_ann;
}
Object meth_parser__apply835(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe836 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_noBlocks (depth = 7)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call837 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe836);
// compiled call node returning call837 (depth = 6)
  gc_frame_end(frame);
  return call837;
}
Object meth_parser__apply897(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe898 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit899 == NULL) {
    strlit899 = alloc_String("comma");
    gc_root(strlit899);
  }
// compiled string node returning strlit899 (depth = 5)
  gc_frame_newslot(strlit899);
// call case 4: self request
  params[0] = strlit899;
  partcv[0] = 1;
  Object call900 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe898);
// compiled call node returning call900 (depth = 4)
  gc_frame_end(frame);
  return call900;
}
Object meth_parser__apply916(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe917 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_noBlocks (depth = 9)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call918 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe917);
// compiled call node returning call918 (depth = 8)
  gc_frame_end(frame);
  return call918;
}
Object meth_parser__apply903(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_anns = getfromclosure(closure, 1);
  Object *var_noBlocks = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe904 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe905 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe906 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call907 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe906);
// compiled member node returning call907 (depth = 6)
  gc_frame_newslot(call907);
// call case 4: self request
  params[0] = call907;
  partcv[0] = 1;
  Object call908 = callmethodflags(self, "checkAnnotation(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe905);
// compiled call node returning call908 (depth = 5)
  gc_frame_newslot(call908);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  params[0] = call908;
  partcv[0] = 1;
  Object call909 = callmethodflags(*var_anns, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe904);
// compiled call node returning call909 (depth = 4)
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe910 = gc_frame_new();
// call case 4: self request
  Object call911 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe910);
// compiled member node returning call911 (depth = 4)
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe913 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe914 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block915 = alloc_Block(NULL, NULL, "parser", 322);
  gc_frame_newslot(block915);
// method "_apply"
  block_savedest(block915);
  Object closure916 = createclosure(2, "_apply");
  setclosureframe(closure916, stackframe);
  addtoclosure(closure916, var_noBlocks);
  addtoclosure(closure916, selfslot);
  struct UserObject *uo916 = (struct UserObject*)block915;
  uo916->data[0] = (Object)closure916;
  Method *meth_meth_parser__apply916 = addmethod2pos(block915, "_apply", &meth_parser__apply916, 0);
  int argcv_meth_parser__apply916[] = {0};
  meth_meth_parser__apply916->type = alloc_MethodType(1, argcv_meth_parser__apply916);
  meth_meth_parser__apply916->definitionModule = modulename;
  meth_meth_parser__apply916->definitionLine = 3399;
// compiled block node returning block915 (depth = 7)
  gc_frame_newslot(block915);
// call case 4: self request
  params[0] = block915;
  partcv[0] = 1;
  Object call920 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe914);
// compiled call node returning call920 (depth = 6)
  Object call921 = callmethodflags(call920, "not", 0, partcv, params, 0);
  gc_frame_end(callframe913);
// compiled member node returning call921 (depth = 5)
  Object if912 = done;
  if (istrue(call921)) {
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array922 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array922 (depth = 6)
  *var_suggestions = array922;
  if (array922 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe923 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe924 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call925 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe924);
// compiled member node returning call925 (depth = 7)
  Object call926 = callmethodflags(call925, "new", 0, partcv, params, 0);
  gc_frame_end(callframe923);
// compiled member node returning call926 (depth = 6)
  *var_suggestion = call926;
  if (call926 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe927 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array928 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit929 == NULL) {
    strlit929 = alloc_String("bind");
    gc_root(strlit929);
  }
// compiled string node returning strlit929 (depth = 8)
  params[0] = strlit929;
  partcv[0] = 1;
  callmethodflags(array928, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array928 (depth = 7)
  gc_frame_newslot(array928);
// call case 4: self request
  params[0] = array928;
  partcv[0] = 1;
  Object call930 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe927);
// compiled call node returning call930 (depth = 6)
  *var_nextTok = call930;
  if (call930 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_932 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_932 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult934 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult934 (depth = 6)
  Object if931 = done;
  if (istrue(opresult934)) {
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe935 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit936 == NULL) {
    strlit936 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit936);
  }
// compiled string node returning strlit936 (depth = 7)
  gc_frame_newslot(strlit936);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit936;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call937 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe935);
// compiled call node returning call937 (depth = 6)
    gc_frame_newslot(call937);
    if931 = call937;
  } else {
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe938 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe939 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call940 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe939);
// compiled member node returning call940 (depth = 7)
  gc_frame_newslot(call940);
// starting to compile identifier node (depth = 7)
  Object bool941 = alloc_Boolean(1);
// compiled identifier node returning bool941 (depth = 7)
  gc_frame_newslot(bool941);
// starting to compile identifier node (depth = 7)
  Object bool942 = alloc_Boolean(0);
// compiled identifier node returning bool942 (depth = 7)
  gc_frame_newslot(bool942);
// starting to compile string node (depth = 7)
  if (strlit943 == NULL) {
    strlit943 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit943);
  }
// compiled string node returning strlit943 (depth = 7)
  gc_frame_newslot(strlit943);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call940;
  params[2] = bool941;
  params[3] = bool942;
  params[4] = strlit943;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call944 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe938);
// compiled call node returning call944 (depth = 6)
    gc_frame_newslot(call944);
    if931 = call944;
  }
// compiled if node returning if931 (depth = 5)
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe945 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call946 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe945);
// compiled call node returning call946 (depth = 5)
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe947 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe948 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call949 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe948);
// compiled member node returning call949 (depth = 7)
  Object call950 = callmethodflags(call949, "new", 0, partcv, params, 0);
  gc_frame_end(callframe947);
// compiled member node returning call950 (depth = 6)
  *var_suggestion = call950;
  if (call950 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe952 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 6)
  int callframe953 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  Object call954 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe953);
// compiled member node returning call954 (depth = 6)
  gc_frame_newslot(call954);
// starting to compile identifier node (depth = 6)
  Object bool955 = alloc_Boolean(1);
// compiled identifier node returning bool955 (depth = 6)
  gc_frame_newslot(bool955);
// starting to compile identifier node (depth = 6)
  Object bool956 = alloc_Boolean(0);
// compiled identifier node returning bool956 (depth = 6)
  gc_frame_newslot(bool956);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = call954;
  params[2] = bool955;
  params[3] = bool956;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call957 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe952);
// compiled call node returning call957 (depth = 5)
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe958 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call959 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe958);
// compiled call node returning call959 (depth = 5)
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe960 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit961 == NULL) {
    strlit961 = alloc_String("one or more annotations separated by commas must follow 'is'.");
    gc_root(strlit961);
  }
// compiled string node returning strlit961 (depth = 6)
  gc_frame_newslot(strlit961);
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe962 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call963 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe962);
// compiled member node returning call963 (depth = 6)
  gc_frame_newslot(call963);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num965 = alloc_Float64(1);
// compiled num node returning num965 (depth = 7)
  int op_slot_right_964 = gc_frame_newslot(num965);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe968 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call969 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe968);
// compiled member node returning call969 (depth = 8)
  int op_slot_right_967 = gc_frame_newslot(call969);
// starting to compile member node (depth = 8)
  int callframe971 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call972 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe971);
// compiled member node returning call972 (depth = 8)
  int op_slot_left_967 = gc_frame_newslot(call972);
  params[0] = call969;
  partcv[0] = 1;
  Object sum973 = callmethod(call972, "+(1)", 1, partcv, params);
// compiled op node returning sum973 (depth = 7)
  int op_slot_left_964 = gc_frame_newslot(sum973);
  params[0] = num965;
  partcv[0] = 1;
  Object sum974 = callmethod(sum973, "+(1)", 1, partcv, params);
// compiled op node returning sum974 (depth = 6)
  gc_frame_newslot(sum974);
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit961;
  params[1] = call963;
  params[2] = sum974;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call975 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe960);
// compiled call node returning call975 (depth = 5)
    gc_frame_newslot(call975);
    if912 = call975;
  } else {
  }
// compiled if node returning if912 (depth = 4)
  gc_frame_end(frame);
  return if912;
}
Object meth_parser_doannotation820(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doannotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_anns = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "anns");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// Begin line 297
  setline(297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe822 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe823 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit824 == NULL) {
    strlit824 = alloc_String("is");
    gc_root(strlit824);
  }
// compiled string node returning strlit824 (depth = 5)
  gc_frame_newslot(strlit824);
// call case 4: self request
  params[0] = strlit824;
  partcv[0] = 1;
  Object call825 = callmethodflags(self, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe823);
// compiled call node returning call825 (depth = 4)
  Object call826 = callmethodflags(call825, "not", 0, partcv, params, 0);
  gc_frame_end(callframe822);
// compiled member node returning call826 (depth = 3)
  Object if821 = done;
  if (istrue(call826)) {
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool827 = alloc_Boolean(0);
// compiled identifier node returning bool827 (depth = 4)
  return bool827;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if821 = undefined;
  } else {
  }
// compiled if node returning if821 (depth = 2)
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe828 = gc_frame_new();
// call case 4: self request
  Object call829 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe828);
// compiled member node returning call829 (depth = 2)
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array830 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array830 (depth = 3)
  *var_anns = array830;
  if (array830 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe832 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe833 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block834 = alloc_Block(NULL, NULL, "parser", 302);
  gc_frame_newslot(block834);
// method "_apply"
  block_savedest(block834);
  Object closure835 = createclosure(2, "_apply");
  setclosureframe(closure835, stackframe);
  addtoclosure(closure835, var_noBlocks);
  addtoclosure(closure835, selfslot);
  struct UserObject *uo835 = (struct UserObject*)block834;
  uo835->data[0] = (Object)closure835;
  Method *meth_meth_parser__apply835 = addmethod2pos(block834, "_apply", &meth_parser__apply835, 0);
  int argcv_meth_parser__apply835[] = {0};
  meth_meth_parser__apply835->type = alloc_MethodType(1, argcv_meth_parser__apply835);
  meth_meth_parser__apply835->definitionModule = modulename;
  meth_meth_parser__apply835->definitionLine = 3399;
// compiled block node returning block834 (depth = 5)
  gc_frame_newslot(block834);
// call case 4: self request
  params[0] = block834;
  partcv[0] = 1;
  Object call839 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe833);
// compiled call node returning call839 (depth = 4)
  Object call840 = callmethodflags(call839, "not", 0, partcv, params, 0);
  gc_frame_end(callframe832);
// compiled member node returning call840 (depth = 3)
  Object if831 = done;
  if (istrue(call840)) {
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array841 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array841 (depth = 4)
  *var_suggestions = array841;
  if (array841 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe842 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe843 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call844 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe843);
// compiled member node returning call844 (depth = 5)
  Object call845 = callmethodflags(call844, "new", 0, partcv, params, 0);
  gc_frame_end(callframe842);
// compiled member node returning call845 (depth = 4)
  *var_suggestion = call845;
  if (call845 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe846 = gc_frame_new();
// starting to compile array node (depth = 5)
  Object array847 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 6)
  if (strlit848 == NULL) {
    strlit848 = alloc_String("bind");
    gc_root(strlit848);
  }
// compiled string node returning strlit848 (depth = 6)
  params[0] = strlit848;
  partcv[0] = 1;
  callmethodflags(array847, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array847 (depth = 5)
  gc_frame_newslot(array847);
// call case 4: self request
  params[0] = array847;
  partcv[0] = 1;
  Object call849 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe846);
// compiled call node returning call849 (depth = 4)
  *var_nextTok = call849;
  if (call849 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 306
  setline(306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  int op_slot_right_851 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_left_851 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult853 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult853 (depth = 4)
  Object if850 = done;
  if (istrue(opresult853)) {
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe854 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit855 == NULL) {
    strlit855 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit855);
  }
// compiled string node returning strlit855 (depth = 5)
  gc_frame_newslot(strlit855);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit855;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call856 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe854);
// compiled call node returning call856 (depth = 4)
    gc_frame_newslot(call856);
    if850 = call856;
  } else {
// Begin line 309
  setline(309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe857 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 5)
  int callframe858 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  Object call859 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe858);
// compiled member node returning call859 (depth = 5)
  gc_frame_newslot(call859);
// starting to compile identifier node (depth = 5)
  Object bool860 = alloc_Boolean(1);
// compiled identifier node returning bool860 (depth = 5)
  gc_frame_newslot(bool860);
// starting to compile identifier node (depth = 5)
  Object bool861 = alloc_Boolean(0);
// compiled identifier node returning bool861 (depth = 5)
  gc_frame_newslot(bool861);
// starting to compile string node (depth = 5)
  if (strlit862 == NULL) {
    strlit862 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit862);
  }
// compiled string node returning strlit862 (depth = 5)
  gc_frame_newslot(strlit862);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = call859;
  params[2] = bool860;
  params[3] = bool861;
  params[4] = strlit862;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call863 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe857);
// compiled call node returning call863 (depth = 4)
    gc_frame_newslot(call863);
    if850 = call863;
  }
// compiled if node returning if850 (depth = 3)
// Begin line 311
  setline(311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe864 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call865 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe864);
// compiled call node returning call865 (depth = 3)
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe866 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe867 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call868 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe867);
// compiled member node returning call868 (depth = 5)
  Object call869 = callmethodflags(call868, "new", 0, partcv, params, 0);
  gc_frame_end(callframe866);
// compiled member node returning call869 (depth = 4)
  *var_suggestion = call869;
  if (call869 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe871 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 4)
  int callframe872 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  Object call873 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe872);
// compiled member node returning call873 (depth = 4)
  gc_frame_newslot(call873);
// starting to compile identifier node (depth = 4)
  Object bool874 = alloc_Boolean(1);
// compiled identifier node returning bool874 (depth = 4)
  gc_frame_newslot(bool874);
// starting to compile identifier node (depth = 4)
  Object bool875 = alloc_Boolean(0);
// compiled identifier node returning bool875 (depth = 4)
  gc_frame_newslot(bool875);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_lastToken;
  params[1] = call873;
  params[2] = bool874;
  params[3] = bool875;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call876 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe871);
// compiled call node returning call876 (depth = 3)
// Begin line 314
  setline(314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe877 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call878 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe877);
// compiled call node returning call878 (depth = 3)
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe879 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit880 == NULL) {
    strlit880 = alloc_String("one or more annotations separated by commas must follow 'is'.");
    gc_root(strlit880);
  }
// compiled string node returning strlit880 (depth = 4)
  gc_frame_newslot(strlit880);
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe881 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call882 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe881);
// compiled member node returning call882 (depth = 4)
  gc_frame_newslot(call882);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num884 = alloc_Float64(1);
// compiled num node returning num884 (depth = 5)
  int op_slot_right_883 = gc_frame_newslot(num884);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe887 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call888 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe887);
// compiled member node returning call888 (depth = 6)
  int op_slot_right_886 = gc_frame_newslot(call888);
// starting to compile member node (depth = 6)
  int callframe890 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call891 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe890);
// compiled member node returning call891 (depth = 6)
  int op_slot_left_886 = gc_frame_newslot(call891);
  params[0] = call888;
  partcv[0] = 1;
  Object sum892 = callmethod(call891, "+(1)", 1, partcv, params);
// compiled op node returning sum892 (depth = 5)
  int op_slot_left_883 = gc_frame_newslot(sum892);
  params[0] = num884;
  partcv[0] = 1;
  Object sum893 = callmethod(sum892, "+(1)", 1, partcv, params);
// compiled op node returning sum893 (depth = 4)
  gc_frame_newslot(sum893);
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit880;
  params[1] = call882;
  params[2] = sum893;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call894 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe879);
// compiled call node returning call894 (depth = 3)
    gc_frame_newslot(call894);
    if831 = call894;
  } else {
  }
// compiled if node returning if831 (depth = 2)
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe895 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block896 = alloc_Block(NULL, NULL, "parser", 319);
  gc_frame_newslot(block896);
// method "_apply"
  block_savedest(block896);
  Object closure897 = createclosure(1, "_apply");
  setclosureframe(closure897, stackframe);
  addtoclosure(closure897, selfslot);
  struct UserObject *uo897 = (struct UserObject*)block896;
  uo897->data[0] = (Object)closure897;
  Method *meth_meth_parser__apply897 = addmethod2pos(block896, "_apply", &meth_parser__apply897, 0);
  int argcv_meth_parser__apply897[] = {0};
  meth_meth_parser__apply897->type = alloc_MethodType(1, argcv_meth_parser__apply897);
  meth_meth_parser__apply897->definitionModule = modulename;
  meth_meth_parser__apply897->definitionLine = 3399;
// compiled block node returning block896 (depth = 3)
  gc_frame_newslot(block896);
// starting to compile block node (depth = 3)
  Object block902 = alloc_Block(NULL, NULL, "parser", 319);
  gc_frame_newslot(block902);
// method "_apply"
  block_savedest(block902);
  Object closure903 = createclosure(7, "_apply");
  setclosureframe(closure903, stackframe);
  addtoclosure(closure903, var_values);
  addtoclosure(closure903, var_anns);
  addtoclosure(closure903, var_noBlocks);
  addtoclosure(closure903, var_errormessages);
  addtoclosure(closure903, var_sym);
  addtoclosure(closure903, var_lastToken);
  addtoclosure(closure903, selfslot);
  struct UserObject *uo903 = (struct UserObject*)block902;
  uo903->data[0] = (Object)closure903;
  Method *meth_meth_parser__apply903 = addmethod2pos(block902, "_apply", &meth_parser__apply903, 0);
  int argcv_meth_parser__apply903[] = {0};
  meth_meth_parser__apply903->type = alloc_MethodType(1, argcv_meth_parser__apply903);
  meth_meth_parser__apply903->definitionModule = modulename;
  meth_meth_parser__apply903->definitionLine = 3399;
// compiled block node returning block902 (depth = 3)
  gc_frame_newslot(block902);
// call case 5: prelude request
  params[0] = block896;
  params[1] = block902;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call977 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe895);
// compiled call node returning call977 (depth = 2)
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe978 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe979 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe980 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call981 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe980);
// compiled member node returning call981 (depth = 4)
  gc_frame_newslot(call981);
// call case 4: self request
  params[0] = call981;
  partcv[0] = 1;
  Object call982 = callmethodflags(self, "checkAnnotation(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe979);
// compiled call node returning call982 (depth = 3)
  gc_frame_newslot(call982);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_anns (depth = 3)
  params[0] = call982;
  partcv[0] = 1;
  Object call983 = callmethodflags(*var_anns, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe978);
// compiled call node returning call983 (depth = 2)
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_anns (depth = 2)
  gc_frame_end(frame);
  return *var_anns;
}
Object meth_parser__apply1020(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1022 == NULL) {
    strlit1022 = alloc_String("blank");
    gc_root(strlit1022);
  }
// compiled string node returning strlit1022 (depth = 7)
  int op_slot_right_1021 = gc_frame_newslot(strlit1022);
// starting to compile member node (depth = 7)
  int callframe1024 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1025 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  Object call1026 = callmethodflags(*var_values, "last", 0, partcv, params, 0);
  gc_frame_end(callframe1025);
// compiled member node returning call1026 (depth = 8)
  Object call1027 = callmethodflags(call1026, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1024);
// compiled member node returning call1027 (depth = 7)
  int op_slot_left_1021 = gc_frame_newslot(call1027);
  params[0] = strlit1022;
  partcv[0] = 1;
  Object opresult1028 = callmethod(call1027, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1028 (depth = 6)
  gc_frame_end(frame);
  return opresult1028;
}
Object meth_parser_blank984(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blank");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_blankLocation = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_done = getfromclosure(closure, 3);
  Object *var_previousCommentToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num987 = alloc_Float64(0);
// compiled num node returning num987 (depth = 4)
  int op_slot_right_986 = gc_frame_newslot(num987);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blankLocation (depth = 4)
  int op_slot_left_986 = gc_frame_newslot(*var_blankLocation);
  params[0] = num987;
  partcv[0] = 1;
  Object opresult989 = callmethod(*var_blankLocation, "==(1)", 1, partcv, params);
// compiled op node returning opresult989 (depth = 3)
  Object if985 = done;
  if (istrue(opresult989)) {
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num993 = alloc_Float64(1);
// compiled num node returning num993 (depth = 6)
  int op_slot_right_992 = gc_frame_newslot(num993);
// starting to compile member node (depth = 6)
  int callframe995 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call996 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe995);
// compiled member node returning call996 (depth = 6)
  int op_slot_left_992 = gc_frame_newslot(call996);
  params[0] = num993;
  partcv[0] = 1;
  Object sum997 = callmethod(call996, "+(1)", 1, partcv, params);
// compiled op node returning sum997 (depth = 5)
  int op_slot_right_991 = gc_frame_newslot(sum997);
// starting to compile member node (depth = 5)
  int callframe999 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1000 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe999);
// compiled member node returning call1000 (depth = 5)
  int op_slot_left_991 = gc_frame_newslot(call1000);
  params[0] = sum997;
  partcv[0] = 1;
  Object opresult1001 = callmethod(call1000, "≤(1)", 1, partcv, params);
// compiled op node returning opresult1001 (depth = 4)
  Object if990 = done;
  if (istrue(opresult1001)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_done (depth = 5)
  return *var_done;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if990 = undefined;
  } else {
  }
// compiled if node returning if990 (depth = 3)
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1005 = alloc_Float64(1);
// compiled num node returning num1005 (depth = 6)
  int op_slot_right_1004 = gc_frame_newslot(num1005);
// starting to compile member node (depth = 6)
  int callframe1007 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_previousCommentToken (depth = 7)
  Object call1008 = callmethodflags(*var_previousCommentToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1007);
// compiled member node returning call1008 (depth = 6)
  int op_slot_left_1004 = gc_frame_newslot(call1008);
  params[0] = num1005;
  partcv[0] = 1;
  Object sum1009 = callmethod(call1008, "+(1)", 1, partcv, params);
// compiled op node returning sum1009 (depth = 5)
  int op_slot_right_1003 = gc_frame_newslot(sum1009);
// starting to compile member node (depth = 5)
  int callframe1011 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1012 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1011);
// compiled member node returning call1012 (depth = 5)
  int op_slot_left_1003 = gc_frame_newslot(call1012);
  params[0] = sum1009;
  partcv[0] = 1;
  Object opresult1013 = callmethod(call1012, "≤(1)", 1, partcv, params);
// compiled op node returning opresult1013 (depth = 4)
  Object if1002 = done;
  if (istrue(opresult1013)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_done (depth = 5)
  return *var_done;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if1002 = undefined;
  } else {
  }
// compiled if node returning if1002 (depth = 3)
    gc_frame_newslot(if1002);
    if985 = if1002;
  } else {
  }
// compiled if node returning if985 (depth = 2)
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe1014 = gc_frame_new();
// call case 4: self request
  Object call1015 = callmethodflags(self, "pushComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1014);
// compiled member node returning call1015 (depth = 2)
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block1019 = alloc_Block(NULL, NULL, "parser", 351);
  gc_frame_newslot(block1019);
// method "_apply"
  block_savedest(block1019);
  Object closure1020 = createclosure(2, "_apply");
  setclosureframe(closure1020, stackframe);
  addtoclosure(closure1020, var_values);
  addtoclosure(closure1020, selfslot);
  struct UserObject *uo1020 = (struct UserObject*)block1019;
  uo1020->data[0] = (Object)closure1020;
  Method *meth_meth_parser__apply1020 = addmethod2pos(block1019, "_apply", &meth_parser__apply1020, 0);
  int argcv_meth_parser__apply1020[] = {0};
  meth_meth_parser__apply1020->type = alloc_MethodType(1, argcv_meth_parser__apply1020);
  meth_meth_parser__apply1020->definitionModule = modulename;
  meth_meth_parser__apply1020->definitionLine = 3399;
// compiled block node returning block1019 (depth = 5)
  int op_slot_right_1018 = gc_frame_newslot(block1019);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1032 = alloc_Float64(0);
// compiled num node returning num1032 (depth = 6)
  int op_slot_right_1031 = gc_frame_newslot(num1032);
// starting to compile member node (depth = 6)
  int callframe1034 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call1035 = callmethodflags(*var_values, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1034);
// compiled member node returning call1035 (depth = 6)
  int op_slot_left_1031 = gc_frame_newslot(call1035);
  params[0] = num1032;
  partcv[0] = 1;
  Object opresult1036 = callmethod(call1035, ">(1)", 1, partcv, params);
// compiled op node returning opresult1036 (depth = 5)
  int op_slot_left_1018 = gc_frame_newslot(opresult1036);
  params[0] = block1019;
  partcv[0] = 1;
  Object opresult1037 = callmethod(opresult1036, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1037 (depth = 4)
  int op_slot_right_1017 = gc_frame_newslot(opresult1037);
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1040 = alloc_Float64(0);
// compiled num node returning num1040 (depth = 5)
  int op_slot_right_1039 = gc_frame_newslot(num1040);
// starting to compile member node (depth = 5)
  int callframe1042 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call1043 = callmethodflags(*var_values, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1042);
// compiled member node returning call1043 (depth = 5)
  int op_slot_left_1039 = gc_frame_newslot(call1043);
  params[0] = num1040;
  partcv[0] = 1;
  Object opresult1044 = callmethod(call1043, "==(1)", 1, partcv, params);
// compiled op node returning opresult1044 (depth = 4)
  int op_slot_left_1017 = gc_frame_newslot(opresult1044);
  params[0] = opresult1037;
  partcv[0] = 1;
  Object opresult1045 = callmethod(opresult1044, "||(1)", 1, partcv, params);
// compiled op node returning opresult1045 (depth = 3)
  Object if1016 = done;
  if (istrue(opresult1045)) {
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1048 = alloc_Float64(0);
// compiled num node returning num1048 (depth = 5)
  int op_slot_right_1047 = gc_frame_newslot(num1048);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blankLocation (depth = 5)
  int op_slot_left_1047 = gc_frame_newslot(*var_blankLocation);
  params[0] = num1048;
  partcv[0] = 1;
  Object opresult1050 = callmethod(*var_blankLocation, ">(1)", 1, partcv, params);
// compiled op node returning opresult1050 (depth = 4)
  Object if1046 = done;
  if (istrue(opresult1050)) {
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1051 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blankLocation (depth = 5)
  gc_frame_newslot(*var_blankLocation);
// starting to compile num node (depth = 5)
  Object num1052 = alloc_Float64(0);
// compiled num node returning num1052 (depth = 5)
  gc_frame_newslot(num1052);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = *var_blankLocation;
  params[1] = num1052;
  partcv[0] = 2;
  Object call1053 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1051);
// compiled call node returning call1053 (depth = 4)
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1054 = alloc_Float64(0);
// compiled num node returning num1054 (depth = 5)
  *var_blankLocation = num1054;
  if (num1054 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1046 = done;
  } else {
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1056 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1058 = alloc_Float64(1);
// compiled num node returning num1058 (depth = 6)
  int op_slot_right_1057 = gc_frame_newslot(num1058);
// starting to compile member node (depth = 6)
  int callframe1060 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call1061 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1060);
// compiled member node returning call1061 (depth = 6)
  int op_slot_left_1057 = gc_frame_newslot(call1061);
  params[0] = num1058;
  partcv[0] = 1;
  Object diff1062 = callmethod(call1061, "-(1)", 1, partcv, params);
// compiled op node returning diff1062 (depth = 5)
  gc_frame_newslot(diff1062);
// starting to compile num node (depth = 5)
  Object num1063 = alloc_Float64(0);
// compiled num node returning num1063 (depth = 5)
  gc_frame_newslot(num1063);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = diff1062;
  params[1] = num1063;
  partcv[0] = 2;
  Object call1064 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1056);
// compiled call node returning call1064 (depth = 4)
    gc_frame_newslot(call1064);
    if1046 = call1064;
  }
// compiled if node returning if1046 (depth = 3)
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1065 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1066 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1067 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call1068 = callmethodflags(*var_ast, "blankNode", 0, partcv, params, 0);
  gc_frame_end(callframe1067);
// compiled member node returning call1068 (depth = 5)
  Object call1069 = callmethodflags(call1068, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1066);
// compiled member node returning call1069 (depth = 4)
  gc_frame_newslot(call1069);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = call1069;
  partcv[0] = 1;
  Object call1070 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1065);
// compiled call node returning call1070 (depth = 3)
    gc_frame_newslot(call1070);
    if1016 = call1070;
  } else {
  }
// compiled if node returning if1016 (depth = 2)
  gc_frame_end(frame);
  return if1016;
}
Object meth_parser_dotypeterm1071(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotypeterm");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1073 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1074 == NULL) {
    strlit1074 = alloc_String("identifier");
    gc_root(strlit1074);
  }
// compiled string node returning strlit1074 (depth = 4)
  gc_frame_newslot(strlit1074);
// call case 4: self request
  params[0] = strlit1074;
  partcv[0] = 1;
  Object call1075 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1073);
// compiled call node returning call1075 (depth = 3)
  Object if1072 = done;
  if (istrue(call1075)) {
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1076 = gc_frame_new();
// call case 4: self request
  Object call1077 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1076);
// compiled member node returning call1077 (depth = 3)
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1078 = gc_frame_new();
// call case 4: self request
  Object call1079 = callmethodflags(self, "generic", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1078);
// compiled member node returning call1079 (depth = 3)
// Begin line 366
  setline(366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1080 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call1081 = callmethodflags(self, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1080);
// compiled call node returning call1081 (depth = 3)
    gc_frame_newslot(call1081);
    if1072 = call1081;
  } else {
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1083 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1084 == NULL) {
    strlit1084 = alloc_String("type");
    gc_root(strlit1084);
  }
// compiled string node returning strlit1084 (depth = 5)
  gc_frame_newslot(strlit1084);
// call case 4: self request
  params[0] = strlit1084;
  partcv[0] = 1;
  Object call1085 = callmethodflags(self, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1083);
// compiled call node returning call1085 (depth = 4)
  Object if1082 = done;
  if (istrue(call1085)) {
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe1086 = gc_frame_new();
// call case 4: self request
  Object call1087 = callmethodflags(self, "dotypeLiteral", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1086);
// compiled member node returning call1087 (depth = 4)
    gc_frame_newslot(call1087);
    if1082 = call1087;
  } else {
  }
// compiled if node returning if1082 (depth = 3)
    gc_frame_newslot(if1082);
    if1072 = if1082;
  }
// compiled if node returning if1072 (depth = 2)
  gc_frame_end(frame);
  return if1072;
}
Object meth_parser__apply1102(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
  int callframe1103 = gc_frame_new();
// call case 4: self request
  Object call1104 = callmethodflags(self, "typeexpression", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1103);
// compiled member node returning call1104 (depth = 7)
  gc_frame_end(frame);
  return call1104;
}
Object meth_parser_typeexpression1088(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeexpression");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_noBlocks = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sz");
  Object *var_prevStatementToken = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "prevStatementToken");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1089 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  Object call1090 = callmethodflags(*var_values, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1089);
// compiled member node returning call1090 (depth = 3)
  *var_sz = call1090;
  if (call1090 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1092 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1093 == NULL) {
    strlit1093 = alloc_String("lparen");
    gc_root(strlit1093);
  }
// compiled string node returning strlit1093 (depth = 4)
  gc_frame_newslot(strlit1093);
// call case 4: self request
  params[0] = strlit1093;
  partcv[0] = 1;
  Object call1094 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1092);
// compiled call node returning call1094 (depth = 3)
  Object if1091 = done;
  if (istrue(call1094)) {
// Begin line 377
  setline(377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementToken (depth = 4)
  *var_prevStatementToken = *var_statementToken;
  if (*var_statementToken == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1096 = gc_frame_new();
// call case 4: self request
  Object call1097 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1096);
// compiled member node returning call1097 (depth = 3)
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1099 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe1100 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1101 = alloc_Block(NULL, NULL, "parser", 380);
  gc_frame_newslot(block1101);
// method "_apply"
  block_savedest(block1101);
  Object closure1102 = createclosure(1, "_apply");
  setclosureframe(closure1102, stackframe);
  addtoclosure(closure1102, selfslot);
  struct UserObject *uo1102 = (struct UserObject*)block1101;
  uo1102->data[0] = (Object)closure1102;
  Method *meth_meth_parser__apply1102 = addmethod2pos(block1101, "_apply", &meth_parser__apply1102, 0);
  int argcv_meth_parser__apply1102[] = {0};
  meth_meth_parser__apply1102->type = alloc_MethodType(1, argcv_meth_parser__apply1102);
  meth_meth_parser__apply1102->definitionModule = modulename;
  meth_meth_parser__apply1102->definitionLine = 3399;
// compiled block node returning block1101 (depth = 6)
  gc_frame_newslot(block1101);
// call case 4: self request
  params[0] = block1101;
  partcv[0] = 1;
  Object call1106 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1100);
// compiled call node returning call1106 (depth = 5)
  Object call1107 = callmethodflags(call1106, "not", 0, partcv, params, 0);
  gc_frame_end(callframe1099);
// compiled member node returning call1107 (depth = 4)
  Object if1098 = done;
  if (istrue(call1107)) {
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1108 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1109 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call1110 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1109);
// compiled member node returning call1110 (depth = 6)
  Object call1111 = callmethodflags(call1110, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1108);
// compiled member node returning call1111 (depth = 5)
  *var_suggestion = call1111;
  if (call1111 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1112 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array1113 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit1114 == NULL) {
    strlit1114 = alloc_String("rparen");
    gc_root(strlit1114);
  }
// compiled string node returning strlit1114 (depth = 7)
  params[0] = strlit1114;
  partcv[0] = 1;
  callmethodflags(array1113, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array1113 (depth = 6)
  gc_frame_newslot(array1113);
// call case 4: self request
  params[0] = array1113;
  partcv[0] = 1;
  Object call1115 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1112);
// compiled call node returning call1115 (depth = 5)
  *var_nextTok = call1115;
  if (call1115 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_1117 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_1117 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1119 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1119 (depth = 5)
  Object if1116 = done;
  if (istrue(opresult1119)) {
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1120 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1121 == NULL) {
    strlit1121 = alloc_String("""\xc2""""\xab""type expression""\xc2""""\xbb""");
    gc_root(strlit1121);
  }
// compiled string node returning strlit1121 (depth = 6)
  gc_frame_newslot(strlit1121);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit1121;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1122 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1120);
// compiled call node returning call1122 (depth = 5)
    gc_frame_newslot(call1122);
    if1116 = call1122;
  } else {
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1123 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe1124 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  Object call1125 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe1124);
// compiled member node returning call1125 (depth = 6)
  gc_frame_newslot(call1125);
// starting to compile identifier node (depth = 6)
  Object bool1126 = alloc_Boolean(1);
// compiled identifier node returning bool1126 (depth = 6)
  gc_frame_newslot(bool1126);
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool1127 = alloc_Boolean(0);
// compiled identifier node returning bool1127 (depth = 6)
  gc_frame_newslot(bool1127);
// starting to compile string node (depth = 6)
  if (strlit1128 == NULL) {
    strlit1128 = alloc_String("""\xc2""""\xab""type expression""\xc2""""\xbb""");
    gc_root(strlit1128);
  }
// compiled string node returning strlit1128 (depth = 6)
  gc_frame_newslot(strlit1128);
// call case 6: other requests
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call1125;
  params[2] = bool1126;
  params[3] = bool1127;
  params[4] = strlit1128;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1129 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1123);
// compiled call node returning call1129 (depth = 5)
    gc_frame_newslot(call1129);
    if1116 = call1129;
  }
// compiled if node returning if1116 (depth = 4)
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1130 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1131 == NULL) {
    strlit1131 = alloc_String("parentheses must contain a valid type expression.");
    gc_root(strlit1131);
  }
// compiled string node returning strlit1131 (depth = 5)
  gc_frame_newslot(strlit1131);
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1132 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1133 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1132);
// compiled member node returning call1133 (depth = 5)
  gc_frame_newslot(call1133);
// starting to compile member node (depth = 5)
  int callframe1134 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1135 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1134);
// compiled member node returning call1135 (depth = 5)
  gc_frame_newslot(call1135);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1131;
  params[1] = call1133;
  params[2] = call1135;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1136 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1130);
// compiled call node returning call1136 (depth = 4)
    gc_frame_newslot(call1136);
    if1098 = call1136;
  } else {
  }
// compiled if node returning if1098 (depth = 3)
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1139 == NULL) {
    strlit1139 = alloc_String("rparen");
    gc_root(strlit1139);
  }
// compiled string node returning strlit1139 (depth = 5)
  int op_slot_right_1138 = gc_frame_newslot(strlit1139);
// starting to compile member node (depth = 5)
  int callframe1141 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1142 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1141);
// compiled member node returning call1142 (depth = 5)
  int op_slot_left_1138 = gc_frame_newslot(call1142);
  params[0] = strlit1139;
  partcv[0] = 1;
  Object opresult1143 = callmethod(call1142, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1143 (depth = 4)
  Object if1137 = done;
  if (istrue(opresult1143)) {
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe1144 = gc_frame_new();
// call case 4: self request
  Object call1145 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1144);
// compiled member node returning call1145 (depth = 4)
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1146 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1147 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call1148 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1147);
// compiled member node returning call1148 (depth = 6)
  Object call1149 = callmethodflags(call1148, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1146);
// compiled member node returning call1149 (depth = 5)
  *var_suggestion = call1149;
  if (call1149 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1150 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1151 == NULL) {
    strlit1151 = alloc_String(")");
    gc_root(strlit1151);
  }
// compiled string node returning strlit1151 (depth = 5)
  gc_frame_newslot(strlit1151);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit1151;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1152 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1150);
// compiled call node returning call1152 (depth = 4)
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1153 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1154 == NULL) {
    strlit1154 = alloc_String("a type expression beginning with a '(' must end with a ')'.");
    gc_root(strlit1154);
  }
// compiled string node returning strlit1154 (depth = 5)
  gc_frame_newslot(strlit1154);
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1155 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call1156 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1155);
// compiled member node returning call1156 (depth = 5)
  gc_frame_newslot(call1156);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1158 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call1159 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1158);
// compiled member node returning call1159 (depth = 6)
  int op_slot_right_1157 = gc_frame_newslot(call1159);
// starting to compile member node (depth = 6)
  int callframe1161 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call1162 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1161);
// compiled member node returning call1162 (depth = 6)
  int op_slot_left_1157 = gc_frame_newslot(call1162);
  params[0] = call1159;
  partcv[0] = 1;
  Object sum1163 = callmethod(call1162, "+(1)", 1, partcv, params);
// compiled op node returning sum1163 (depth = 5)
  gc_frame_newslot(sum1163);
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1154;
  params[1] = call1156;
  params[2] = sum1163;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1164 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1153);
// compiled call node returning call1164 (depth = 4)
    gc_frame_newslot(call1164);
    if1137 = call1164;
  } else {
  }
// compiled if node returning if1137 (depth = 3)
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_prevStatementToken (depth = 4)
  *var_statementToken = *var_prevStatementToken;
  if (*var_prevStatementToken == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 401
  setline(401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1166 = gc_frame_new();
// call case 4: self request
  Object call1167 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1166);
// compiled member node returning call1167 (depth = 3)
    gc_frame_newslot(call1167);
    if1091 = call1167;
  } else {
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1168 = gc_frame_new();
// call case 4: self request
  Object call1169 = callmethodflags(self, "dotypeterm", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1168);
// compiled member node returning call1169 (depth = 3)
    gc_frame_newslot(call1169);
    if1091 = call1169;
  }
// compiled if node returning if1091 (depth = 2)
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_1171 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
  int callframe1173 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call1174 = callmethodflags(*var_values, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1173);
// compiled member node returning call1174 (depth = 4)
  int op_slot_left_1171 = gc_frame_newslot(call1174);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult1175 = callmethod(call1174, ">(1)", 1, partcv, params);
// compiled op node returning opresult1175 (depth = 3)
  Object if1170 = done;
  if (istrue(opresult1175)) {
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1176 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call1177 = callmethodflags(self, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1176);
// compiled call node returning call1177 (depth = 3)
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1178 = gc_frame_new();
// call case 4: self request
  Object call1179 = callmethodflags(self, "typeexpressionrest", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1178);
// compiled member node returning call1179 (depth = 3)
    gc_frame_newslot(call1179);
    if1170 = call1179;
  } else {
  }
// compiled if node returning if1170 (depth = 2)
  gc_frame_end(frame);
  return if1170;
}
Object meth_parser_newIf_40_3_41_1180(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "newIf(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method newIf(_,_,_)");
  Object params[3];
  int partcv[1];
  Object *var_ast = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for newIf(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenList = &(stackframe->slots[1]);
  *var_thenList = args[curarg];
  curarg++;
  Object *var_elseList = &(stackframe->slots[2]);
  *var_elseList = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part newIf(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_thenBlock = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "thenBlock");
  Object *var_elseBlock = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "elseBlock");
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1181 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1182 = gc_frame_new();
// call case 5: prelude request
  Object call1183 = callmethodflags(prelude, "emptySequence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1182);
// compiled member node returning call1183 (depth = 4)
  gc_frame_newslot(call1183);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_thenList (depth = 4)
  gc_frame_newslot(*var_thenList);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1184 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call1185 = callmethodflags(*var_ast, "blockNode", 0, partcv, params, 0);
  gc_frame_end(callframe1184);
// compiled member node returning call1185 (depth = 4)
  params[0] = call1183;
  params[1] = *var_thenList;
  partcv[0] = 2;
  Object call1186 = callmethodflags(call1185, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1181);
// compiled call node returning call1186 (depth = 3)
  *var_thenBlock = call1186;
  if (call1186 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1187 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1188 = gc_frame_new();
// call case 5: prelude request
  Object call1189 = callmethodflags(prelude, "emptySequence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1188);
// compiled member node returning call1189 (depth = 4)
  gc_frame_newslot(call1189);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elseList (depth = 4)
  gc_frame_newslot(*var_elseList);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1190 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call1191 = callmethodflags(*var_ast, "blockNode", 0, partcv, params, 0);
  gc_frame_end(callframe1190);
// compiled member node returning call1191 (depth = 4)
  params[0] = call1189;
  params[1] = *var_elseList;
  partcv[0] = 2;
  Object call1192 = callmethodflags(call1191, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1187);
// compiled call node returning call1192 (depth = 3)
  *var_elseBlock = call1192;
  if (call1192 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1193 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cond (depth = 3)
  gc_frame_newslot(*var_cond);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_thenBlock (depth = 3)
  gc_frame_newslot(*var_thenBlock);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elseBlock (depth = 3)
  gc_frame_newslot(*var_elseBlock);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1194 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ast (depth = 4)
  Object call1195 = callmethodflags(*var_ast, "ifNode", 0, partcv, params, 0);
  gc_frame_end(callframe1194);
// compiled member node returning call1195 (depth = 3)
  params[0] = *var_cond;
  params[1] = *var_thenBlock;
  params[2] = *var_elseBlock;
  partcv[0] = 3;
  Object call1196 = callmethodflags(call1195, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe1193);
// compiled call node returning call1196 (depth = 2)
  gc_frame_end(frame);
  return call1196;
}
Object meth_parser__apply1226(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe1227 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1228 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1227);
// compiled call node returning call1228 (depth = 5)
  gc_frame_end(frame);
  return call1228;
}
Object meth_parser__apply1263(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe1264 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1265 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1264);
// compiled call node returning call1265 (depth = 11)
  gc_frame_end(frame);
  return call1265;
}
Object meth_parser__apply1339(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe1340 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1341 == NULL) {
    strlit1341 = alloc_String("comma");
    gc_root(strlit1341);
  }
// compiled string node returning strlit1341 (depth = 10)
  gc_frame_newslot(strlit1341);
// call case 4: self request
  params[0] = strlit1341;
  partcv[0] = 1;
  Object call1342 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1340);
// compiled call node returning call1342 (depth = 9)
  gc_frame_end(frame);
  return call1342;
}
Object meth_parser__apply_40_1_41_1349(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1351 == NULL) {
    strlit1351 = alloc_String("arrow");
    gc_root(strlit1351);
  }
// compiled string node returning strlit1351 (depth = 11)
  int op_slot_right_1350 = gc_frame_newslot(strlit1351);
// starting to compile member node (depth = 11)
  int callframe1353 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  Object call1354 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1353);
// compiled member node returning call1354 (depth = 11)
  int op_slot_left_1350 = gc_frame_newslot(call1354);
  params[0] = strlit1351;
  partcv[0] = 1;
  Object opresult1355 = callmethod(call1354, "==(1)", 1, partcv, params);
// compiled op node returning opresult1355 (depth = 10)
  gc_frame_end(frame);
  return opresult1355;
}
Object meth_parser__apply1397(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe1398 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1399 == NULL) {
    strlit1399 = alloc_String("comma");
    gc_root(strlit1399);
  }
// compiled string node returning strlit1399 (depth = 9)
  gc_frame_newslot(strlit1399);
// call case 4: self request
  params[0] = strlit1399;
  partcv[0] = 1;
  Object call1400 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1398);
// compiled call node returning call1400 (depth = 8)
  gc_frame_end(frame);
  return call1400;
}
Object meth_parser__apply1403(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_expr1 = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe1404 = gc_frame_new();
// call case 4: self request
  Object call1405 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1404);
// compiled member node returning call1405 (depth = 8)
// Begin line 494
  setline(494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe1406 = gc_frame_new();
// call case 4: self request
  Object call1407 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1406);
// compiled member node returning call1407 (depth = 8)
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe1408 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  Object call1409 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe1408);
// compiled member node returning call1409 (depth = 9)
  *var_expr1 = call1409;
  if (call1409 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 496
  setline(496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1411 = gc_frame_new();
// starting to compile identifier node (depth = 9)
  Object bool1412 = alloc_Boolean(1);
// compiled identifier node returning bool1412 (depth = 9)
  gc_frame_newslot(bool1412);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr1 (depth = 9)
  params[0] = bool1412;
  partcv[0] = 1;
  Object call1413 = callmethodflags(*var_expr1, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1411);
// compiled call node returning call1413 (depth = 8)
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1414 = gc_frame_new();
// starting to compile member node (depth = 9)
  int callframe1415 = gc_frame_new();
// call case 4: self request
  Object call1416 = callmethodflags(self, "optionalTypeAnnotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1415);
// compiled member node returning call1416 (depth = 9)
  gc_frame_newslot(call1416);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr1 (depth = 9)
  params[0] = call1416;
  partcv[0] = 1;
  Object call1417 = callmethodflags(*var_expr1, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1414);
// compiled call node returning call1417 (depth = 8)
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1418 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr1 (depth = 9)
  gc_frame_newslot(*var_expr1);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_params (depth = 9)
  params[0] = *var_expr1;
  partcv[0] = 1;
  Object call1419 = callmethodflags(*var_params, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1418);
// compiled call node returning call1419 (depth = 8)
  gc_frame_end(frame);
  return call1419;
}
Object meth_parser__apply1534(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 12)
  int callframe1535 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1536 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1535);
// compiled call node returning call1536 (depth = 12)
  gc_frame_end(frame);
  return call1536;
}
Object meth_parser__apply1231(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(13, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_expr1 = getfromclosure(closure, 1);
  Object *var_braceIsType = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object *var_params = getfromclosure(closure, 7);
  Object *var_isMatchingBlock = getfromclosure(closure, 8);
  Object *var_body = getfromclosure(closure, 9);
  Object *var_indentFreePass = getfromclosure(closure, 10);
  Object *var_btok = getfromclosure(closure, 11);
  Object *var_util = getfromclosure(closure, 12);
  Object *var_ast = getfromclosure(closure, 13);
  Object self = *(getfromclosure(closure, 14));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
  Object *var_arrow = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "arrow");
  Object *var_lhs = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "lhs");
  Object *var_rhs = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "rhs");
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1234 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1235 == NULL) {
    strlit1235 = alloc_String("colon");
    gc_root(strlit1235);
  }
// compiled string node returning strlit1235 (depth = 8)
  gc_frame_newslot(strlit1235);
// call case 4: self request
  params[0] = strlit1235;
  partcv[0] = 1;
  Object call1236 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1234);
// compiled call node returning call1236 (depth = 7)
  int op_slot_right_1233 = gc_frame_newslot(call1236);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1239 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1240 == NULL) {
    strlit1240 = alloc_String("arrow");
    gc_root(strlit1240);
  }
// compiled string node returning strlit1240 (depth = 9)
  gc_frame_newslot(strlit1240);
// call case 4: self request
  params[0] = strlit1240;
  partcv[0] = 1;
  Object call1241 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1239);
// compiled call node returning call1241 (depth = 8)
  int op_slot_right_1238 = gc_frame_newslot(call1241);
// starting to compile call node (depth = 8)
  int callframe1243 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1244 == NULL) {
    strlit1244 = alloc_String("comma");
    gc_root(strlit1244);
  }
// compiled string node returning strlit1244 (depth = 9)
  gc_frame_newslot(strlit1244);
// call case 4: self request
  params[0] = strlit1244;
  partcv[0] = 1;
  Object call1245 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1243);
// compiled call node returning call1245 (depth = 8)
  int op_slot_left_1238 = gc_frame_newslot(call1245);
  params[0] = call1241;
  partcv[0] = 1;
  Object opresult1246 = callmethod(call1245, "||(1)", 1, partcv, params);
// compiled op node returning opresult1246 (depth = 7)
  int op_slot_left_1233 = gc_frame_newslot(opresult1246);
  params[0] = call1236;
  partcv[0] = 1;
  Object opresult1247 = callmethod(opresult1246, "||(1)", 1, partcv, params);
// compiled op node returning opresult1247 (depth = 6)
  Object if1232 = done;
  if (istrue(opresult1247)) {
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1248 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call1249 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe1248);
// compiled member node returning call1249 (depth = 7)
  *var_expr1 = call1249;
  if (call1249 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1252 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1253 == NULL) {
    strlit1253 = alloc_String("colon");
    gc_root(strlit1253);
  }
// compiled string node returning strlit1253 (depth = 8)
  gc_frame_newslot(strlit1253);
// call case 4: self request
  params[0] = strlit1253;
  partcv[0] = 1;
  Object call1254 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1252);
// compiled call node returning call1254 (depth = 7)
  Object if1251 = done;
  if (istrue(call1254)) {
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe1255 = gc_frame_new();
// call case 4: self request
  Object call1256 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1255);
// compiled member node returning call1256 (depth = 7)
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1257 = alloc_Boolean(1);
// compiled identifier node returning bool1257 (depth = 8)
  *var_braceIsType = bool1257;
  if (bool1257 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1260 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 9)
  int callframe1261 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block1262 = alloc_Block(NULL, NULL, "parser", 450);
  gc_frame_newslot(block1262);
// method "_apply"
  block_savedest(block1262);
  Object closure1263 = createclosure(2, "_apply");
  setclosureframe(closure1263, stackframe);
  addtoclosure(closure1263, var_blocksOK);
  addtoclosure(closure1263, selfslot);
  struct UserObject *uo1263 = (struct UserObject*)block1262;
  uo1263->data[0] = (Object)closure1263;
  Method *meth_meth_parser__apply1263 = addmethod2pos(block1262, "_apply", &meth_parser__apply1263, 0);
  int argcv_meth_parser__apply1263[] = {0};
  meth_meth_parser__apply1263->type = alloc_MethodType(1, argcv_meth_parser__apply1263);
  meth_meth_parser__apply1263->definitionModule = modulename;
  meth_meth_parser__apply1263->definitionLine = 3399;
// compiled block node returning block1262 (depth = 10)
  gc_frame_newslot(block1262);
// call case 4: self request
  params[0] = block1262;
  partcv[0] = 1;
  Object call1267 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1261);
// compiled call node returning call1267 (depth = 9)
  Object call1268 = callmethodflags(call1267, "not", 0, partcv, params, 0);
  gc_frame_end(callframe1260);
// compiled member node returning call1268 (depth = 8)
  Object if1259 = done;
  if (istrue(call1268)) {
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile array node (depth = 9)
  Object array1269 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1269 (depth = 9)
  *var_suggestions = array1269;
  if (array1269 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe1270 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe1271 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call1272 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1271);
// compiled member node returning call1272 (depth = 10)
  Object call1273 = callmethodflags(call1272, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1270);
// compiled member node returning call1273 (depth = 9)
  *var_suggestion = call1273;
  if (call1273 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1274 = gc_frame_new();
// starting to compile array node (depth = 10)
  Object array1275 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 11)
  if (strlit1276 == NULL) {
    strlit1276 = alloc_String("arrow");
    gc_root(strlit1276);
  }
// compiled string node returning strlit1276 (depth = 11)
  params[0] = strlit1276;
  partcv[0] = 1;
  callmethodflags(array1275, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 11)
  if (strlit1277 == NULL) {
    strlit1277 = alloc_String("rbrace");
    gc_root(strlit1277);
  }
// compiled string node returning strlit1277 (depth = 11)
  params[0] = strlit1277;
  partcv[0] = 1;
  callmethodflags(array1275, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array1275 (depth = 10)
  gc_frame_newslot(array1275);
// call case 4: self request
  params[0] = array1275;
  partcv[0] = 1;
  Object call1278 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1274);
// compiled call node returning call1278 (depth = 9)
  *var_nextTok = call1278;
  if (call1278 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_1280 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_1280 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1282 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1282 (depth = 9)
  Object if1279 = done;
  if (istrue(opresult1282)) {
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1283 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1284 == NULL) {
    strlit1284 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1284);
  }
// compiled string node returning strlit1284 (depth = 10)
  gc_frame_newslot(strlit1284);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1284;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1285 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1283);
// compiled call node returning call1285 (depth = 9)
    gc_frame_newslot(call1285);
    if1279 = call1285;
  } else {
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1286 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
  int callframe1287 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  Object call1288 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe1287);
// compiled member node returning call1288 (depth = 10)
  gc_frame_newslot(call1288);
// starting to compile identifier node (depth = 10)
  Object bool1289 = alloc_Boolean(1);
// compiled identifier node returning bool1289 (depth = 10)
  gc_frame_newslot(bool1289);
// starting to compile identifier node (depth = 10)
  Object bool1290 = alloc_Boolean(0);
// compiled identifier node returning bool1290 (depth = 10)
  gc_frame_newslot(bool1290);
// starting to compile string node (depth = 10)
  if (strlit1291 == NULL) {
    strlit1291 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1291);
  }
// compiled string node returning strlit1291 (depth = 10)
  gc_frame_newslot(strlit1291);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call1288;
  params[2] = bool1289;
  params[3] = bool1290;
  params[4] = strlit1291;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1292 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1286);
// compiled call node returning call1292 (depth = 9)
    gc_frame_newslot(call1292);
    if1279 = call1292;
  }
// compiled if node returning if1279 (depth = 8)
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1293 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1294 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1293);
// compiled call node returning call1294 (depth = 8)
// Begin line 460
  setline(460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe1295 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe1296 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call1297 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1296);
// compiled member node returning call1297 (depth = 10)
  Object call1298 = callmethodflags(call1297, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1295);
// compiled member node returning call1298 (depth = 9)
  *var_suggestion = call1298;
  if (call1298 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1300 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
  int callframe1301 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call1302 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe1301);
// compiled member node returning call1302 (depth = 9)
  gc_frame_newslot(call1302);
// starting to compile identifier node (depth = 9)
  Object bool1303 = alloc_Boolean(1);
// compiled identifier node returning bool1303 (depth = 9)
  gc_frame_newslot(bool1303);
// starting to compile identifier node (depth = 9)
  Object bool1304 = alloc_Boolean(0);
// compiled identifier node returning bool1304 (depth = 9)
  gc_frame_newslot(bool1304);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call1302;
  params[2] = bool1303;
  params[3] = bool1304;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1305 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1300);
// compiled call node returning call1305 (depth = 8)
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1306 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1307 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1306);
// compiled call node returning call1307 (depth = 8)
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1308 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1309 == NULL) {
    strlit1309 = alloc_String("a block must have an expression after the ':'.");
    gc_root(strlit1309);
  }
// compiled string node returning strlit1309 (depth = 9)
  gc_frame_newslot(strlit1309);
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe1310 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call1311 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1310);
// compiled member node returning call1311 (depth = 9)
  gc_frame_newslot(call1311);
// starting to compile member node (depth = 9)
  int callframe1312 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call1313 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1312);
// compiled member node returning call1313 (depth = 9)
  gc_frame_newslot(call1313);
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit1309;
  params[1] = call1311;
  params[2] = call1313;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1314 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1308);
// compiled call node returning call1314 (depth = 8)
    gc_frame_newslot(call1314);
    if1259 = call1314;
  } else {
  }
// compiled if node returning if1259 (depth = 7)
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1315 = alloc_Boolean(0);
// compiled identifier node returning bool1315 (depth = 8)
  *var_braceIsType = bool1315;
  if (bool1315 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1317 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe1318 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  Object call1319 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe1318);
// compiled member node returning call1319 (depth = 8)
  gc_frame_newslot(call1319);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_expr1 (depth = 8)
  params[0] = call1319;
  partcv[0] = 1;
  Object call1320 = callmethodflags(*var_expr1, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1317);
// compiled call node returning call1320 (depth = 7)
    gc_frame_newslot(call1320);
    if1251 = call1320;
  } else {
  }
// compiled if node returning if1251 (depth = 6)
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1321 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_expr1 (depth = 7)
  gc_frame_newslot(*var_expr1);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_params (depth = 7)
  params[0] = *var_expr1;
  partcv[0] = 1;
  Object call1322 = callmethodflags(*var_params, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1321);
// compiled call node returning call1322 (depth = 6)
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1325 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr1 (depth = 9)
  Object call1326 = callmethodflags(*var_expr1, "isIdentifier", 0, partcv, params, 0);
  gc_frame_end(callframe1325);
// compiled member node returning call1326 (depth = 8)
  int op_slot_right_1324 = gc_frame_newslot(call1326);
// starting to compile member node (depth = 8)
  int callframe1328 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_isMatchingBlock (depth = 9)
  Object call1329 = callmethodflags(*var_isMatchingBlock, "not", 0, partcv, params, 0);
  gc_frame_end(callframe1328);
// compiled member node returning call1329 (depth = 8)
  int op_slot_left_1324 = gc_frame_newslot(call1329);
  params[0] = call1326;
  partcv[0] = 1;
  Object opresult1330 = callmethod(call1329, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1330 (depth = 7)
  Object if1323 = done;
  if (istrue(opresult1330)) {
// Begin line 472
  setline(472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1331 = gc_frame_new();
// starting to compile identifier node (depth = 8)
  Object bool1332 = alloc_Boolean(1);
// compiled identifier node returning bool1332 (depth = 8)
  gc_frame_newslot(bool1332);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_expr1 (depth = 8)
  params[0] = bool1332;
  partcv[0] = 1;
  Object call1333 = callmethodflags(*var_expr1, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1331);
// compiled call node returning call1333 (depth = 7)
    gc_frame_newslot(call1333);
    if1323 = call1333;
  } else {
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1334 = alloc_Boolean(1);
// compiled identifier node returning bool1334 (depth = 8)
  *var_isMatchingBlock = bool1334;
  if (bool1334 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1323 = done;
  }
// compiled if node returning if1323 (depth = 6)
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile block node (depth = 8)
  Object block1338 = alloc_Block(NULL, NULL, "parser", 476);
  gc_frame_newslot(block1338);
// method "_apply"
  block_savedest(block1338);
  Object closure1339 = createclosure(1, "_apply");
  setclosureframe(closure1339, stackframe);
  addtoclosure(closure1339, selfslot);
  struct UserObject *uo1339 = (struct UserObject*)block1338;
  uo1339->data[0] = (Object)closure1339;
  Method *meth_meth_parser__apply1339 = addmethod2pos(block1338, "_apply", &meth_parser__apply1339, 0);
  int argcv_meth_parser__apply1339[] = {0};
  meth_meth_parser__apply1339->type = alloc_MethodType(1, argcv_meth_parser__apply1339);
  meth_meth_parser__apply1339->definitionModule = modulename;
  meth_meth_parser__apply1339->definitionLine = 3399;
// compiled block node returning block1338 (depth = 8)
  int op_slot_right_1337 = gc_frame_newslot(block1338);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_isMatchingBlock (depth = 8)
  int op_slot_left_1337 = gc_frame_newslot(*var_isMatchingBlock);
  params[0] = block1338;
  partcv[0] = 1;
  Object opresult1345 = callmethod(*var_isMatchingBlock, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1345 (depth = 7)
  Object if1336 = done;
  if (istrue(opresult1345)) {
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile array node (depth = 8)
  Object array1346 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1346 (depth = 8)
  *var_suggestions = array1346;
  if (array1346 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 478
  setline(478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
  *var_suggestion = undefined;
// compiled vardec node returning done (depth = 7)
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1347 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block1348 = alloc_Block(NULL, NULL, "parser", 479);
  gc_frame_newslot(block1348);
// method "_apply(_)"
  block_savedest(block1348);
  Object closure1349 = createclosure(1, "_apply(1)");
  setclosureframe(closure1349, stackframe);
  addtoclosure(closure1349, selfslot);
  struct UserObject *uo1349 = (struct UserObject*)block1348;
  uo1349->data[0] = (Object)closure1349;
  Method *meth_meth_parser__apply_40_1_41_1349 = addmethod2pos(block1348, "_apply(1)", &meth_parser__apply_40_1_41_1349, 0);
  int argcv_meth_parser__apply_40_1_41_1349[] = {1};
  meth_meth_parser__apply_40_1_41_1349->type = alloc_MethodType(1, argcv_meth_parser__apply_40_1_41_1349);
  meth_meth_parser__apply_40_1_41_1349->definitionModule = modulename;
  meth_meth_parser__apply_40_1_41_1349->definitionLine = 3399;
// compiled block node returning block1348 (depth = 9)
  gc_frame_newslot(block1348);
// call case 4: self request
  params[0] = block1348;
  partcv[0] = 1;
  Object call1357 = callmethodflags(self, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1347);
// compiled call node returning call1357 (depth = 8)
  *var_arrow = call1357;
  if (call1357 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_arrow (depth = 9)
  int op_slot_right_1359 = gc_frame_newslot(*var_arrow);
// starting to compile identifier node (depth = 9)
  Object bool1361 = alloc_Boolean(0);
// compiled identifier node returning bool1361 (depth = 9)
  int op_slot_left_1359 = gc_frame_newslot(bool1361);
  params[0] = *var_arrow;
  partcv[0] = 1;
  Object opresult1362 = callmethod(bool1361, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1362 (depth = 8)
  Object if1358 = done;
  if (istrue(opresult1362)) {
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe1363 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe1364 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call1365 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1364);
// compiled member node returning call1365 (depth = 10)
  Object call1366 = callmethodflags(call1365, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1363);
// compiled member node returning call1366 (depth = 9)
  *var_suggestion = call1366;
  if (call1366 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1368 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
  int callframe1369 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_arrow (depth = 10)
  Object call1370 = callmethodflags(*var_arrow, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe1369);
// compiled member node returning call1370 (depth = 9)
  gc_frame_newslot(call1370);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call1370;
  partcv[0] = 2;
  Object call1371 = callmethodflags(*var_suggestion, "deleteTokenRange(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1368);
// compiled call node returning call1371 (depth = 8)
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1372 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1373 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1372);
// compiled call node returning call1373 (depth = 8)
    gc_frame_newslot(call1373);
    if1358 = call1373;
  } else {
  }
// compiled if node returning if1358 (depth = 7)
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1374 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1375 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call1376 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1375);
// compiled member node returning call1376 (depth = 9)
  Object call1377 = callmethodflags(call1376, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1374);
// compiled member node returning call1377 (depth = 8)
  *var_suggestion = call1377;
  if (call1377 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1379 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool1380 = alloc_Boolean(1);
// compiled identifier node returning bool1380 (depth = 8)
  gc_frame_newslot(bool1380);
// starting to compile identifier node (depth = 8)
  Object bool1381 = alloc_Boolean(0);
// compiled identifier node returning bool1381 (depth = 8)
  gc_frame_newslot(bool1381);
// starting to compile string node (depth = 8)
  if (strlit1382 == NULL) {
    strlit1382 = alloc_String(" |");
    gc_root(strlit1382);
  }
// compiled string node returning strlit1382 (depth = 8)
  gc_frame_newslot(strlit1382);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool1380;
  params[2] = bool1381;
  params[3] = strlit1382;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1383 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1379);
// compiled call node returning call1383 (depth = 7)
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1384 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1385 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1384);
// compiled call node returning call1385 (depth = 7)
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1386 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1387 == NULL) {
    strlit1387 = alloc_String("a matching block may only have one parameter.");
    gc_root(strlit1387);
  }
// compiled string node returning strlit1387 (depth = 8)
  gc_frame_newslot(strlit1387);
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe1388 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call1389 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1388);
// compiled member node returning call1389 (depth = 8)
  gc_frame_newslot(call1389);
// starting to compile member node (depth = 8)
  int callframe1390 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call1391 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1390);
// compiled member node returning call1391 (depth = 8)
  gc_frame_newslot(call1391);
// starting to compile member node (depth = 8)
  int callframe1392 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call1393 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1392);
// compiled member node returning call1393 (depth = 8)
  gc_frame_newslot(call1393);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit1387;
  params[1] = call1389;
  params[2] = call1391;
  params[3] = call1393;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1394 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1386);
// compiled call node returning call1394 (depth = 7)
    gc_frame_newslot(call1394);
    if1336 = call1394;
  } else {
  }
// compiled if node returning if1336 (depth = 6)
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1395 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1396 = alloc_Block(NULL, NULL, "parser", 491);
  gc_frame_newslot(block1396);
// method "_apply"
  block_savedest(block1396);
  Object closure1397 = createclosure(1, "_apply");
  setclosureframe(closure1397, stackframe);
  addtoclosure(closure1397, selfslot);
  struct UserObject *uo1397 = (struct UserObject*)block1396;
  uo1397->data[0] = (Object)closure1397;
  Method *meth_meth_parser__apply1397 = addmethod2pos(block1396, "_apply", &meth_parser__apply1397, 0);
  int argcv_meth_parser__apply1397[] = {0};
  meth_meth_parser__apply1397->type = alloc_MethodType(1, argcv_meth_parser__apply1397);
  meth_meth_parser__apply1397->definitionModule = modulename;
  meth_meth_parser__apply1397->definitionLine = 3399;
// compiled block node returning block1396 (depth = 7)
  gc_frame_newslot(block1396);
// starting to compile block node (depth = 7)
  Object block1402 = alloc_Block(NULL, NULL, "parser", 491);
  gc_frame_newslot(block1402);
// method "_apply"
  block_savedest(block1402);
  Object closure1403 = createclosure(4, "_apply");
  setclosureframe(closure1403, stackframe);
  addtoclosure(closure1403, var_values);
  addtoclosure(closure1403, var_expr1);
  addtoclosure(closure1403, var_params);
  addtoclosure(closure1403, selfslot);
  struct UserObject *uo1403 = (struct UserObject*)block1402;
  uo1403->data[0] = (Object)closure1403;
  Method *meth_meth_parser__apply1403 = addmethod2pos(block1402, "_apply", &meth_parser__apply1403, 0);
  int argcv_meth_parser__apply1403[] = {0};
  meth_meth_parser__apply1403->type = alloc_MethodType(1, argcv_meth_parser__apply1403);
  meth_meth_parser__apply1403->definitionModule = modulename;
  meth_meth_parser__apply1403->definitionLine = 3399;
// compiled block node returning block1402 (depth = 7)
  gc_frame_newslot(block1402);
// call case 5: prelude request
  params[0] = block1396;
  params[1] = block1402;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1421 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1395);
// compiled call node returning call1421 (depth = 6)
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1423 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe1424 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1425 == NULL) {
    strlit1425 = alloc_String("arrow");
    gc_root(strlit1425);
  }
// compiled string node returning strlit1425 (depth = 9)
  gc_frame_newslot(strlit1425);
// call case 4: self request
  params[0] = strlit1425;
  partcv[0] = 1;
  Object call1426 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1424);
// compiled call node returning call1426 (depth = 8)
  Object call1427 = callmethodflags(call1426, "not", 0, partcv, params, 0);
  gc_frame_end(callframe1423);
// compiled member node returning call1427 (depth = 7)
  Object if1422 = done;
  if (istrue(call1427)) {
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1428 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1429 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call1430 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1429);
// compiled member node returning call1430 (depth = 9)
  Object call1431 = callmethodflags(call1430, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1428);
// compiled member node returning call1431 (depth = 8)
  *var_suggestion = call1431;
  if (call1431 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1435 == NULL) {
    strlit1435 = alloc_String("=");
    gc_root(strlit1435);
  }
// compiled string node returning strlit1435 (depth = 10)
  int op_slot_right_1434 = gc_frame_newslot(strlit1435);
// starting to compile member node (depth = 10)
  int callframe1437 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call1438 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe1437);
// compiled member node returning call1438 (depth = 10)
  int op_slot_left_1434 = gc_frame_newslot(call1438);
  params[0] = strlit1435;
  partcv[0] = 1;
  Object opresult1439 = callmethod(call1438, "==(1)", 1, partcv, params);
// compiled op node returning opresult1439 (depth = 9)
  int op_slot_right_1433 = gc_frame_newslot(opresult1439);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1442 == NULL) {
    strlit1442 = alloc_String("bind");
    gc_root(strlit1442);
  }
// compiled string node returning strlit1442 (depth = 10)
  int op_slot_right_1441 = gc_frame_newslot(strlit1442);
// starting to compile member node (depth = 10)
  int callframe1444 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call1445 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1444);
// compiled member node returning call1445 (depth = 10)
  int op_slot_left_1441 = gc_frame_newslot(call1445);
  params[0] = strlit1442;
  partcv[0] = 1;
  Object opresult1446 = callmethod(call1445, "==(1)", 1, partcv, params);
// compiled op node returning opresult1446 (depth = 9)
  int op_slot_left_1433 = gc_frame_newslot(opresult1446);
  params[0] = opresult1439;
  partcv[0] = 1;
  Object opresult1447 = callmethod(opresult1446, "||(1)", 1, partcv, params);
// compiled op node returning opresult1447 (depth = 8)
  Object if1432 = done;
  if (istrue(opresult1447)) {
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1448 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 9)
  if (strlit1449 == NULL) {
    strlit1449 = alloc_String("->");
    gc_root(strlit1449);
  }
// compiled string node returning strlit1449 (depth = 9)
  gc_frame_newslot(strlit1449);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = strlit1449;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1450 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1448);
// compiled call node returning call1450 (depth = 8)
    gc_frame_newslot(call1450);
    if1432 = call1450;
  } else {
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1451 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1452 == NULL) {
    strlit1452 = alloc_String(" ->");
    gc_root(strlit1452);
  }
// compiled string node returning strlit1452 (depth = 9)
  gc_frame_newslot(strlit1452);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1452;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1453 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1451);
// compiled call node returning call1453 (depth = 8)
    gc_frame_newslot(call1453);
    if1432 = call1453;
  }
// compiled if node returning if1432 (depth = 7)
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1454 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1455 == NULL) {
    strlit1455 = alloc_String("a block must have one or more parameters followed by '->' and an expression.");
    gc_root(strlit1455);
  }
// compiled string node returning strlit1455 (depth = 8)
  gc_frame_newslot(strlit1455);
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe1456 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call1457 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1456);
// compiled member node returning call1457 (depth = 8)
  gc_frame_newslot(call1457);
// starting to compile member node (depth = 8)
  int callframe1458 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call1459 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1458);
// compiled member node returning call1459 (depth = 8)
  gc_frame_newslot(call1459);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit1455;
  params[1] = call1457;
  params[2] = call1459;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1460 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1454);
// compiled call node returning call1460 (depth = 7)
    gc_frame_newslot(call1460);
    if1422 = call1460;
  } else {
  }
// compiled if node returning if1422 (depth = 6)
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe1461 = gc_frame_new();
// call case 4: self request
  Object call1462 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1461);
// compiled member node returning call1462 (depth = 6)
    gc_frame_newslot(call1462);
    if1232 = call1462;
  } else {
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1464 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1465 == NULL) {
    strlit1465 = alloc_String("semicolon");
    gc_root(strlit1465);
  }
// compiled string node returning strlit1465 (depth = 8)
  gc_frame_newslot(strlit1465);
// call case 4: self request
  params[0] = strlit1465;
  partcv[0] = 1;
  Object call1466 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1464);
// compiled call node returning call1466 (depth = 7)
  Object if1463 = done;
  if (istrue(call1466)) {
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1467 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe1468 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  Object call1469 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe1468);
// compiled member node returning call1469 (depth = 8)
  gc_frame_newslot(call1469);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call1469;
  partcv[0] = 1;
  Object call1470 = callmethodflags(*var_body, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1467);
// compiled call node returning call1470 (depth = 7)
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe1471 = gc_frame_new();
// call case 4: self request
  Object call1472 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1471);
// compiled member node returning call1472 (depth = 7)
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1474 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1475 == NULL) {
    strlit1475 = alloc_String("semicolon");
    gc_root(strlit1475);
  }
// compiled string node returning strlit1475 (depth = 9)
  gc_frame_newslot(strlit1475);
// call case 4: self request
  params[0] = strlit1475;
  partcv[0] = 1;
  Object call1476 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1474);
// compiled call node returning call1476 (depth = 8)
  Object if1473 = done;
  if (istrue(call1476)) {
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe1477 = gc_frame_new();
// call case 4: self request
  Object call1478 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1477);
// compiled member node returning call1478 (depth = 8)
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe1481 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  Object call1482 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1481);
// compiled member node returning call1482 (depth = 10)
  int op_slot_right_1480 = gc_frame_newslot(call1482);
// starting to compile member node (depth = 10)
  int callframe1484 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call1485 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1484);
// compiled member node returning call1485 (depth = 10)
  int op_slot_left_1480 = gc_frame_newslot(call1485);
  params[0] = call1482;
  partcv[0] = 1;
  Object opresult1486 = callmethod(call1485, "==(1)", 1, partcv, params);
// compiled op node returning opresult1486 (depth = 9)
  Object if1479 = done;
  if (istrue(opresult1486)) {
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool1487 = alloc_Boolean(1);
// compiled identifier node returning bool1487 (depth = 10)
  *var_indentFreePass = bool1487;
  if (bool1487 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if1479 = done;
  } else {
  }
// compiled if node returning if1479 (depth = 8)
    gc_frame_newslot(if1479);
    if1473 = if1479;
  } else {
  }
// compiled if node returning if1473 (depth = 7)
    gc_frame_newslot(if1473);
    if1463 = if1473;
  } else {
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1491 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1492 == NULL) {
    strlit1492 = alloc_String("bind");
    gc_root(strlit1492);
  }
// compiled string node returning strlit1492 (depth = 10)
  gc_frame_newslot(strlit1492);
// call case 4: self request
  params[0] = strlit1492;
  partcv[0] = 1;
  Object call1493 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1491);
// compiled call node returning call1493 (depth = 9)
  int op_slot_right_1490 = gc_frame_newslot(call1493);
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// Begin line 522
  setline(522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1497 == NULL) {
    strlit1497 = alloc_String("index");
    gc_root(strlit1497);
  }
// compiled string node returning strlit1497 (depth = 11)
  int op_slot_right_1496 = gc_frame_newslot(strlit1497);
// starting to compile member node (depth = 11)
  int callframe1499 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe1500 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_values (depth = 13)
  Object call1501 = callmethodflags(*var_values, "last", 0, partcv, params, 0);
  gc_frame_end(callframe1500);
// compiled member node returning call1501 (depth = 12)
  Object call1502 = callmethodflags(call1501, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1499);
// compiled member node returning call1502 (depth = 11)
  int op_slot_left_1496 = gc_frame_newslot(call1502);
  params[0] = strlit1497;
  partcv[0] = 1;
  Object opresult1503 = callmethod(call1502, "==(1)", 1, partcv, params);
// compiled op node returning opresult1503 (depth = 10)
  int op_slot_right_1495 = gc_frame_newslot(opresult1503);
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// Begin line 521
  setline(521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1507 == NULL) {
    strlit1507 = alloc_String("identifier");
    gc_root(strlit1507);
  }
// compiled string node returning strlit1507 (depth = 12)
  int op_slot_right_1506 = gc_frame_newslot(strlit1507);
// starting to compile member node (depth = 12)
  int callframe1509 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe1510 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_values (depth = 14)
  Object call1511 = callmethodflags(*var_values, "last", 0, partcv, params, 0);
  gc_frame_end(callframe1510);
// compiled member node returning call1511 (depth = 13)
  Object call1512 = callmethodflags(call1511, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1509);
// compiled member node returning call1512 (depth = 12)
  int op_slot_left_1506 = gc_frame_newslot(call1512);
  params[0] = strlit1507;
  partcv[0] = 1;
  Object opresult1513 = callmethod(call1512, "==(1)", 1, partcv, params);
// compiled op node returning opresult1513 (depth = 11)
  int op_slot_right_1505 = gc_frame_newslot(opresult1513);
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1516 == NULL) {
    strlit1516 = alloc_String("member");
    gc_root(strlit1516);
  }
// compiled string node returning strlit1516 (depth = 12)
  int op_slot_right_1515 = gc_frame_newslot(strlit1516);
// starting to compile member node (depth = 12)
  int callframe1518 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe1519 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_values (depth = 14)
  Object call1520 = callmethodflags(*var_values, "last", 0, partcv, params, 0);
  gc_frame_end(callframe1519);
// compiled member node returning call1520 (depth = 13)
  Object call1521 = callmethodflags(call1520, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1518);
// compiled member node returning call1521 (depth = 12)
  int op_slot_left_1515 = gc_frame_newslot(call1521);
  params[0] = strlit1516;
  partcv[0] = 1;
  Object opresult1522 = callmethod(call1521, "==(1)", 1, partcv, params);
// compiled op node returning opresult1522 (depth = 11)
  int op_slot_left_1505 = gc_frame_newslot(opresult1522);
  params[0] = opresult1513;
  partcv[0] = 1;
  Object opresult1523 = callmethod(opresult1522, "||(1)", 1, partcv, params);
// compiled op node returning opresult1523 (depth = 10)
  int op_slot_left_1495 = gc_frame_newslot(opresult1523);
  params[0] = opresult1503;
  partcv[0] = 1;
  Object opresult1524 = callmethod(opresult1523, "||(1)", 1, partcv, params);
// compiled op node returning opresult1524 (depth = 9)
  int op_slot_left_1490 = gc_frame_newslot(opresult1524);
  params[0] = call1493;
  partcv[0] = 1;
  Object opresult1525 = callmethod(opresult1524, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1525 (depth = 8)
  Object if1489 = done;
  if (istrue(opresult1525)) {
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe1526 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  Object call1527 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe1526);
// compiled member node returning call1527 (depth = 9)
  *var_lhs = call1527;
  if (call1527 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 525
  setline(525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe1528 = gc_frame_new();
// call case 4: self request
  Object call1529 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1528);
// compiled member node returning call1529 (depth = 8)
// Begin line 526
  setline(526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe1531 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 10)
  int callframe1532 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block1533 = alloc_Block(NULL, NULL, "parser", 526);
  gc_frame_newslot(block1533);
// method "_apply"
  block_savedest(block1533);
  Object closure1534 = createclosure(2, "_apply");
  setclosureframe(closure1534, stackframe);
  addtoclosure(closure1534, var_blocksOK);
  addtoclosure(closure1534, selfslot);
  struct UserObject *uo1534 = (struct UserObject*)block1533;
  uo1534->data[0] = (Object)closure1534;
  Method *meth_meth_parser__apply1534 = addmethod2pos(block1533, "_apply", &meth_parser__apply1534, 0);
  int argcv_meth_parser__apply1534[] = {0};
  meth_meth_parser__apply1534->type = alloc_MethodType(1, argcv_meth_parser__apply1534);
  meth_meth_parser__apply1534->definitionModule = modulename;
  meth_meth_parser__apply1534->definitionLine = 3399;
// compiled block node returning block1533 (depth = 11)
  gc_frame_newslot(block1533);
// call case 4: self request
  params[0] = block1533;
  partcv[0] = 1;
  Object call1538 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1532);
// compiled call node returning call1538 (depth = 10)
  Object call1539 = callmethodflags(call1538, "not", 0, partcv, params, 0);
  gc_frame_end(callframe1531);
// compiled member node returning call1539 (depth = 9)
  Object if1530 = done;
  if (istrue(call1539)) {
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile array node (depth = 10)
  Object array1540 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1540 (depth = 10)
  *var_suggestions = array1540;
  if (array1540 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 9)
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe1541 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe1542 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  Object call1543 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1542);
// compiled member node returning call1543 (depth = 11)
  Object call1544 = callmethodflags(call1543, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1541);
// compiled member node returning call1544 (depth = 10)
  *var_suggestion = call1544;
  if (call1544 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1545 = gc_frame_new();
// starting to compile array node (depth = 11)
  Object array1546 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 12)
  if (strlit1547 == NULL) {
    strlit1547 = alloc_String("rbrace");
    gc_root(strlit1547);
  }
// compiled string node returning strlit1547 (depth = 12)
  params[0] = strlit1547;
  partcv[0] = 1;
  callmethodflags(array1546, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array1546 (depth = 11)
  gc_frame_newslot(array1546);
// call case 4: self request
  params[0] = array1546;
  partcv[0] = 1;
  Object call1548 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1545);
// compiled call node returning call1548 (depth = 10)
  *var_nextTok = call1548;
  if (call1548 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 9)
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_1550 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  int op_slot_left_1550 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1552 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1552 (depth = 10)
  Object if1549 = done;
  if (istrue(opresult1552)) {
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe1553 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit1554 == NULL) {
    strlit1554 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1554);
  }
// compiled string node returning strlit1554 (depth = 11)
  gc_frame_newslot(strlit1554);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit1554;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1555 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1553);
// compiled call node returning call1555 (depth = 10)
    gc_frame_newslot(call1555);
    if1549 = call1555;
  } else {
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe1556 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 11)
  int callframe1557 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  Object call1558 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe1557);
// compiled member node returning call1558 (depth = 11)
  gc_frame_newslot(call1558);
// starting to compile identifier node (depth = 11)
  Object bool1559 = alloc_Boolean(1);
// compiled identifier node returning bool1559 (depth = 11)
  gc_frame_newslot(bool1559);
// starting to compile identifier node (depth = 11)
  Object bool1560 = alloc_Boolean(0);
// compiled identifier node returning bool1560 (depth = 11)
  gc_frame_newslot(bool1560);
// starting to compile string node (depth = 11)
  if (strlit1561 == NULL) {
    strlit1561 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1561);
  }
// compiled string node returning strlit1561 (depth = 11)
  gc_frame_newslot(strlit1561);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_sym;
  params[1] = call1558;
  params[2] = bool1559;
  params[3] = bool1560;
  params[4] = strlit1561;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1562 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1556);
// compiled call node returning call1562 (depth = 10)
    gc_frame_newslot(call1562);
    if1549 = call1562;
  }
// compiled if node returning if1549 (depth = 9)
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1563 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1564 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1563);
// compiled call node returning call1564 (depth = 9)
// Begin line 536
  setline(536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe1565 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe1566 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  Object call1567 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1566);
// compiled member node returning call1567 (depth = 11)
  Object call1568 = callmethodflags(call1567, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1565);
// compiled member node returning call1568 (depth = 10)
  *var_suggestion = call1568;
  if (call1568 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 9)
// Begin line 537
  setline(537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1570 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 10)
  int callframe1571 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  Object call1572 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe1571);
// compiled member node returning call1572 (depth = 10)
  gc_frame_newslot(call1572);
// starting to compile identifier node (depth = 10)
  Object bool1573 = alloc_Boolean(1);
// compiled identifier node returning bool1573 (depth = 10)
  gc_frame_newslot(bool1573);
// starting to compile identifier node (depth = 10)
  Object bool1574 = alloc_Boolean(0);
// compiled identifier node returning bool1574 (depth = 10)
  gc_frame_newslot(bool1574);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  params[1] = call1572;
  params[2] = bool1573;
  params[3] = bool1574;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1575 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1570);
// compiled call node returning call1575 (depth = 9)
// Begin line 538
  setline(538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1576 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1577 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1576);
// compiled call node returning call1577 (depth = 9)
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1578 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1579 == NULL) {
    strlit1579 = alloc_String("a valid expression must follow ':='.");
    gc_root(strlit1579);
  }
// compiled string node returning strlit1579 (depth = 10)
  gc_frame_newslot(strlit1579);
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe1580 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call1581 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1580);
// compiled member node returning call1581 (depth = 10)
  gc_frame_newslot(call1581);
// starting to compile member node (depth = 10)
  int callframe1582 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call1583 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1582);
// compiled member node returning call1583 (depth = 10)
  gc_frame_newslot(call1583);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit1579;
  params[1] = call1581;
  params[2] = call1583;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1584 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1578);
// compiled call node returning call1584 (depth = 9)
    gc_frame_newslot(call1584);
    if1530 = call1584;
  } else {
  }
// compiled if node returning if1530 (depth = 8)
// Begin line 542
  setline(542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe1585 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  Object call1586 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe1585);
// compiled member node returning call1586 (depth = 9)
  *var_rhs = call1586;
  if (call1586 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1587 = gc_frame_new();
// starting to compile member node (depth = 9)
  int callframe1588 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_btok (depth = 10)
  Object call1589 = callmethodflags(*var_btok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1588);
// compiled member node returning call1589 (depth = 9)
  gc_frame_newslot(call1589);
// starting to compile member node (depth = 9)
  int callframe1590 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_btok (depth = 10)
  Object call1591 = callmethodflags(*var_btok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1590);
// compiled member node returning call1591 (depth = 9)
  gc_frame_newslot(call1591);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_util (depth = 9)
  params[0] = call1589;
  params[1] = call1591;
  partcv[0] = 2;
  Object call1592 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1587);
// compiled call node returning call1592 (depth = 8)
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1593 = gc_frame_new();
// starting to compile call node (depth = 9)
  int callframe1594 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lhs (depth = 10)
  gc_frame_newslot(*var_lhs);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_rhs (depth = 10)
  gc_frame_newslot(*var_rhs);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe1595 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_ast (depth = 11)
  Object call1596 = callmethodflags(*var_ast, "bindNode", 0, partcv, params, 0);
  gc_frame_end(callframe1595);
// compiled member node returning call1596 (depth = 10)
  params[0] = *var_lhs;
  params[1] = *var_rhs;
  partcv[0] = 2;
  Object call1597 = callmethodflags(call1596, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1594);
// compiled call node returning call1597 (depth = 9)
  gc_frame_newslot(call1597);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_body (depth = 9)
  params[0] = call1597;
  partcv[0] = 1;
  Object call1598 = callmethodflags(*var_body, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1593);
// compiled call node returning call1598 (depth = 8)
// Begin line 545
  setline(545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1600 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1601 == NULL) {
    strlit1601 = alloc_String("semicolon");
    gc_root(strlit1601);
  }
// compiled string node returning strlit1601 (depth = 10)
  gc_frame_newslot(strlit1601);
// call case 4: self request
  params[0] = strlit1601;
  partcv[0] = 1;
  Object call1602 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1600);
// compiled call node returning call1602 (depth = 9)
  Object if1599 = done;
  if (istrue(call1602)) {
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe1603 = gc_frame_new();
// call case 4: self request
  Object call1604 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1603);
// compiled member node returning call1604 (depth = 9)
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe1607 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  Object call1608 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1607);
// compiled member node returning call1608 (depth = 11)
  int op_slot_right_1606 = gc_frame_newslot(call1608);
// starting to compile member node (depth = 11)
  int callframe1610 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  Object call1611 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1610);
// compiled member node returning call1611 (depth = 11)
  int op_slot_left_1606 = gc_frame_newslot(call1611);
  params[0] = call1608;
  partcv[0] = 1;
  Object opresult1612 = callmethod(call1611, "==(1)", 1, partcv, params);
// compiled op node returning opresult1612 (depth = 10)
  Object if1605 = done;
  if (istrue(opresult1612)) {
// Begin line 548
  setline(548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool1613 = alloc_Boolean(1);
// compiled identifier node returning bool1613 (depth = 11)
  *var_indentFreePass = bool1613;
  if (bool1613 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if1605 = done;
  } else {
  }
// compiled if node returning if1605 (depth = 9)
    gc_frame_newslot(if1605);
    if1599 = if1605;
  } else {
  }
// compiled if node returning if1599 (depth = 8)
    gc_frame_newslot(if1599);
    if1489 = if1599;
  } else {
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe1615 = gc_frame_new();
// call case 4: self request
  Object call1616 = callmethodflags(self, "checkUnexpectedTokenAfterStatement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1615);
// compiled member node returning call1616 (depth = 8)
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1617 = gc_frame_new();
// starting to compile member node (depth = 9)
  int callframe1618 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  Object call1619 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe1618);
// compiled member node returning call1619 (depth = 9)
  gc_frame_newslot(call1619);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_body (depth = 9)
  params[0] = call1619;
  partcv[0] = 1;
  Object call1620 = callmethodflags(*var_body, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1617);
// compiled call node returning call1620 (depth = 8)
    gc_frame_newslot(call1620);
    if1489 = call1620;
  }
// compiled if node returning if1489 (depth = 7)
    gc_frame_newslot(if1489);
    if1463 = if1489;
  }
// compiled if node returning if1463 (depth = 6)
    gc_frame_newslot(if1463);
    if1232 = if1463;
  }
// compiled if node returning if1232 (depth = 5)
  gc_frame_end(frame);
  return if1232;
}
Object meth_parser__apply1647(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
  int callframe1648 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe1649 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1650 == NULL) {
    strlit1650 = alloc_String("rbrace");
    gc_root(strlit1650);
  }
// compiled string node returning strlit1650 (depth = 7)
  gc_frame_newslot(strlit1650);
// call case 4: self request
  params[0] = strlit1650;
  partcv[0] = 1;
  Object call1651 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1649);
// compiled call node returning call1651 (depth = 6)
  Object call1652 = callmethodflags(call1651, "not", 0, partcv, params, 0);
  gc_frame_end(callframe1648);
// compiled member node returning call1652 (depth = 5)
  gc_frame_end(frame);
  return call1652;
}
Object meth_parser__apply1660(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 9)
  int callframe1661 = gc_frame_new();
// call case 4: self request
  Object call1662 = callmethodflags(self, "statement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1661);
// compiled member node returning call1662 (depth = 9)
  gc_frame_end(frame);
  return call1662;
}
Object meth_parser__apply1655(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_body = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1657 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe1658 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block1659 = alloc_Block(NULL, NULL, "parser", 566);
  gc_frame_newslot(block1659);
// method "_apply"
  block_savedest(block1659);
  Object closure1660 = createclosure(1, "_apply");
  setclosureframe(closure1660, stackframe);
  addtoclosure(closure1660, selfslot);
  struct UserObject *uo1660 = (struct UserObject*)block1659;
  uo1660->data[0] = (Object)closure1660;
  Method *meth_meth_parser__apply1660 = addmethod2pos(block1659, "_apply", &meth_parser__apply1660, 0);
  int argcv_meth_parser__apply1660[] = {0};
  meth_meth_parser__apply1660->type = alloc_MethodType(1, argcv_meth_parser__apply1660);
  meth_meth_parser__apply1660->definitionModule = modulename;
  meth_meth_parser__apply1660->definitionLine = 3399;
// compiled block node returning block1659 (depth = 8)
  gc_frame_newslot(block1659);
// call case 4: self request
  params[0] = block1659;
  partcv[0] = 1;
  Object call1664 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1658);
// compiled call node returning call1664 (depth = 7)
  Object call1665 = callmethodflags(call1664, "not", 0, partcv, params, 0);
  gc_frame_end(callframe1657);
// compiled member node returning call1665 (depth = 6)
  Object if1656 = done;
  if (istrue(call1665)) {
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1666 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1667 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call1668 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1667);
// compiled member node returning call1668 (depth = 8)
  Object call1669 = callmethodflags(call1668, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1666);
// compiled member node returning call1669 (depth = 7)
  *var_suggestion = call1669;
  if (call1669 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 568
  setline(568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1670 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1671 == NULL) {
    strlit1671 = alloc_String("}");
    gc_root(strlit1671);
  }
// compiled string node returning strlit1671 (depth = 7)
  gc_frame_newslot(strlit1671);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1671;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1672 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1670);
// compiled call node returning call1672 (depth = 6)
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1673 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1674 == NULL) {
    strlit1674 = alloc_String("a block must end with a '}'.");
    gc_root(strlit1674);
  }
// compiled string node returning strlit1674 (depth = 7)
  gc_frame_newslot(strlit1674);
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe1675 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call1676 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1675);
// compiled member node returning call1676 (depth = 7)
  gc_frame_newslot(call1676);
// starting to compile member node (depth = 7)
  int callframe1677 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call1678 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1677);
// compiled member node returning call1678 (depth = 7)
  gc_frame_newslot(call1678);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit1674;
  params[1] = call1676;
  params[2] = call1678;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1679 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1673);
// compiled call node returning call1679 (depth = 6)
    gc_frame_newslot(call1679);
    if1656 = call1679;
  } else {
  }
// compiled if node returning if1656 (depth = 5)
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1680 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call1681 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe1680);
// compiled member node returning call1681 (depth = 6)
  *var_tmp = call1681;
  if (call1681 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1683 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_body (depth = 6)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call1684 = callmethodflags(*var_body, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1683);
// compiled call node returning call1684 (depth = 5)
  gc_frame_end(frame);
  return call1684;
}
Object meth_parser_block1197(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(14, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "block");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementIndent = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_braceIsType = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  Object *var_lastToken = getfromclosure(closure, 7);
  Object *var_indentFreePass = getfromclosure(closure, 8);
  Object *var_util = getfromclosure(closure, 9);
  Object *var_ast = getfromclosure(closure, 10);
  Object *var_minIndentLevel = getfromclosure(closure, 11);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_minInd = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "minInd");
  Object *var_startIndent = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startIndent");
  Object *var_expr1 = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "expr1");
  Object *var_s = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "s");
  Object *var_tmp = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "tmp");
  Object *var_params = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "params");
  Object *var_body = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "body");
  Object *var_havearrow = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "havearrow");
  Object *var_found = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "found");
  Object *var_i = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "i");
  Object *var_isMatchingBlock = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "isMatchingBlock");
  Object *var_o = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "o");
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1199 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1200 == NULL) {
    strlit1200 = alloc_String("lbrace");
    gc_root(strlit1200);
  }
// compiled string node returning strlit1200 (depth = 4)
  gc_frame_newslot(strlit1200);
// call case 4: self request
  params[0] = strlit1200;
  partcv[0] = 1;
  Object call1201 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1199);
// compiled call node returning call1201 (depth = 3)
  Object if1198 = done;
  if (istrue(call1201)) {
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1202 = gc_frame_new();
// call case 4: self request
  Object call1203 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1202);
// compiled member node returning call1203 (depth = 3)
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1205 = alloc_Float64(2);
// compiled num node returning num1205 (depth = 5)
  int op_slot_right_1204 = gc_frame_newslot(num1205);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_statementIndent (depth = 5)
  int op_slot_left_1204 = gc_frame_newslot(*var_statementIndent);
  params[0] = num1205;
  partcv[0] = 1;
  Object sum1207 = callmethod(*var_statementIndent, "+(1)", 1, partcv, params);
// compiled op node returning sum1207 (depth = 4)
  *var_minInd = sum1207;
  if (sum1207 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementIndent (depth = 4)
  *var_startIndent = *var_statementIndent;
  if (*var_statementIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_expr1 = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_s = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_tmp = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array1208 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1208 (depth = 4)
  *var_params = array1208;
  if (array1208 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array1209 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1209 (depth = 4)
  *var_body = array1209;
  if (array1209 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1210 = alloc_Boolean(1);
// compiled identifier node returning bool1210 (depth = 4)
  *var_havearrow = bool1210;
  if (bool1210 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1211 = alloc_Boolean(0);
// compiled identifier node returning bool1211 (depth = 4)
  *var_found = bool1211;
  if (bool1211 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1212 = alloc_Float64(0);
// compiled num node returning num1212 (depth = 4)
  *var_i = num1212;
  if (num1212 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1213 = alloc_Boolean(0);
// compiled identifier node returning bool1213 (depth = 4)
  *var_isMatchingBlock = bool1213;
  if (bool1213 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1217 == NULL) {
    strlit1217 = alloc_String("lparen");
    gc_root(strlit1217);
  }
// compiled string node returning strlit1217 (depth = 5)
  int op_slot_right_1216 = gc_frame_newslot(strlit1217);
// starting to compile member node (depth = 5)
  int callframe1219 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1220 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1219);
// compiled member node returning call1220 (depth = 5)
  int op_slot_left_1216 = gc_frame_newslot(call1220);
  params[0] = strlit1217;
  partcv[0] = 1;
  Object opresult1221 = callmethod(call1220, "==(1)", 1, partcv, params);
// compiled op node returning opresult1221 (depth = 4)
  Object if1215 = done;
  if (istrue(opresult1221)) {
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool1222 = alloc_Boolean(1);
// compiled identifier node returning bool1222 (depth = 5)
  *var_isMatchingBlock = bool1222;
  if (bool1222 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1215 = done;
  } else {
  }
// compiled if node returning if1215 (depth = 3)
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1224 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block1225 = alloc_Block(NULL, NULL, "parser", 441);
  gc_frame_newslot(block1225);
// method "_apply"
  block_savedest(block1225);
  Object closure1226 = createclosure(2, "_apply");
  setclosureframe(closure1226, stackframe);
  addtoclosure(closure1226, var_blocksOK);
  addtoclosure(closure1226, selfslot);
  struct UserObject *uo1226 = (struct UserObject*)block1225;
  uo1226->data[0] = (Object)closure1226;
  Method *meth_meth_parser__apply1226 = addmethod2pos(block1225, "_apply", &meth_parser__apply1226, 0);
  int argcv_meth_parser__apply1226[] = {0};
  meth_meth_parser__apply1226->type = alloc_MethodType(1, argcv_meth_parser__apply1226);
  meth_meth_parser__apply1226->definitionModule = modulename;
  meth_meth_parser__apply1226->definitionLine = 3399;
// compiled block node returning block1225 (depth = 4)
  gc_frame_newslot(block1225);
// starting to compile block node (depth = 4)
  Object block1230 = alloc_Block(NULL, NULL, "parser", 441);
  gc_frame_newslot(block1230);
// method "_apply"
  block_savedest(block1230);
  Object closure1231 = createclosure(15, "_apply");
  setclosureframe(closure1231, stackframe);
  addtoclosure(closure1231, var_values);
  addtoclosure(closure1231, var_expr1);
  addtoclosure(closure1231, var_braceIsType);
  addtoclosure(closure1231, var_blocksOK);
  addtoclosure(closure1231, var_errormessages);
  addtoclosure(closure1231, var_sym);
  addtoclosure(closure1231, var_lastToken);
  addtoclosure(closure1231, var_params);
  addtoclosure(closure1231, var_isMatchingBlock);
  addtoclosure(closure1231, var_body);
  addtoclosure(closure1231, var_indentFreePass);
  addtoclosure(closure1231, var_btok);
  addtoclosure(closure1231, var_util);
  addtoclosure(closure1231, var_ast);
  addtoclosure(closure1231, selfslot);
  struct UserObject *uo1231 = (struct UserObject*)block1230;
  uo1231->data[0] = (Object)closure1231;
  Method *meth_meth_parser__apply1231 = addmethod2pos(block1230, "_apply", &meth_parser__apply1231, 0);
  int argcv_meth_parser__apply1231[] = {0};
  meth_meth_parser__apply1231->type = alloc_MethodType(1, argcv_meth_parser__apply1231);
  meth_meth_parser__apply1231->definitionModule = modulename;
  meth_meth_parser__apply1231->definitionLine = 3399;
// compiled block node returning block1230 (depth = 4)
  gc_frame_newslot(block1230);
// call case 4: self request
  params[0] = block1225;
  params[1] = block1230;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1622 = callmethodflags(self, "ifConsume(1)then(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1224);
// compiled call node returning call1622 (depth = 3)
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1624 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1625 == NULL) {
    strlit1625 = alloc_String("arrow");
    gc_root(strlit1625);
  }
// compiled string node returning strlit1625 (depth = 5)
  gc_frame_newslot(strlit1625);
// call case 4: self request
  params[0] = strlit1625;
  partcv[0] = 1;
  Object call1626 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1624);
// compiled call node returning call1626 (depth = 4)
  Object if1623 = done;
  if (istrue(call1626)) {
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe1627 = gc_frame_new();
// call case 4: self request
  Object call1628 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1627);
// compiled member node returning call1628 (depth = 4)
    gc_frame_newslot(call1628);
    if1623 = call1628;
  } else {
  }
// compiled if node returning if1623 (depth = 3)
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1631 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call1632 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1631);
// compiled member node returning call1632 (depth = 5)
  int op_slot_right_1630 = gc_frame_newslot(call1632);
// starting to compile member node (depth = 5)
  int callframe1634 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1635 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1634);
// compiled member node returning call1635 (depth = 5)
  int op_slot_left_1630 = gc_frame_newslot(call1635);
  params[0] = call1632;
  partcv[0] = 1;
  Object opresult1636 = callmethod(call1635, "==(1)", 1, partcv, params);
// compiled op node returning opresult1636 (depth = 4)
  Object if1629 = done;
  if (istrue(opresult1636)) {
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1638 = alloc_Float64(1);
// compiled num node returning num1638 (depth = 6)
  int op_slot_right_1637 = gc_frame_newslot(num1638);
// starting to compile member node (depth = 6)
  int callframe1640 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call1641 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1640);
// compiled member node returning call1641 (depth = 6)
  int op_slot_left_1637 = gc_frame_newslot(call1641);
  params[0] = num1638;
  partcv[0] = 1;
  Object diff1642 = callmethod(call1641, "-(1)", 1, partcv, params);
// compiled op node returning diff1642 (depth = 5)
  *var_minIndentLevel = diff1642;
  if (diff1642 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1629 = done;
  } else {
// Begin line 562
  setline(562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_minInd (depth = 5)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1629 = done;
  }
// compiled if node returning if1629 (depth = 3)
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1645 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block1646 = alloc_Block(NULL, NULL, "parser", 564);
  gc_frame_newslot(block1646);
// method "_apply"
  block_savedest(block1646);
  Object closure1647 = createclosure(1, "_apply");
  setclosureframe(closure1647, stackframe);
  addtoclosure(closure1647, selfslot);
  struct UserObject *uo1647 = (struct UserObject*)block1646;
  uo1647->data[0] = (Object)closure1647;
  Method *meth_meth_parser__apply1647 = addmethod2pos(block1646, "_apply", &meth_parser__apply1647, 0);
  int argcv_meth_parser__apply1647[] = {0};
  meth_meth_parser__apply1647->type = alloc_MethodType(1, argcv_meth_parser__apply1647);
  meth_meth_parser__apply1647->definitionModule = modulename;
  meth_meth_parser__apply1647->definitionLine = 3399;
// compiled block node returning block1646 (depth = 4)
  gc_frame_newslot(block1646);
// starting to compile block node (depth = 4)
  Object block1654 = alloc_Block(NULL, NULL, "parser", 564);
  gc_frame_newslot(block1654);
// method "_apply"
  block_savedest(block1654);
  Object closure1655 = createclosure(7, "_apply");
  setclosureframe(closure1655, stackframe);
  addtoclosure(closure1655, var_errormessages);
  addtoclosure(closure1655, var_lastToken);
  addtoclosure(closure1655, var_sym);
  addtoclosure(closure1655, var_values);
  addtoclosure(closure1655, var_tmp);
  addtoclosure(closure1655, var_body);
  addtoclosure(closure1655, selfslot);
  struct UserObject *uo1655 = (struct UserObject*)block1654;
  uo1655->data[0] = (Object)closure1655;
  Method *meth_meth_parser__apply1655 = addmethod2pos(block1654, "_apply", &meth_parser__apply1655, 0);
  int argcv_meth_parser__apply1655[] = {0};
  meth_meth_parser__apply1655->type = alloc_MethodType(1, argcv_meth_parser__apply1655);
  meth_meth_parser__apply1655->definitionModule = modulename;
  meth_meth_parser__apply1655->definitionLine = 3399;
// compiled block node returning block1654 (depth = 4)
  gc_frame_newslot(block1654);
// call case 5: prelude request
  params[0] = block1646;
  params[1] = block1654;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1686 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1645);
// compiled call node returning call1686 (depth = 3)
// Begin line 575
  setline(575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1688 = alloc_Float64(2);
// compiled num node returning num1688 (depth = 5)
  int op_slot_right_1687 = gc_frame_newslot(num1688);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_minInd (depth = 5)
  int op_slot_left_1687 = gc_frame_newslot(*var_minInd);
  params[0] = num1688;
  partcv[0] = 1;
  Object diff1690 = callmethod(*var_minInd, "-(1)", 1, partcv, params);
// compiled op node returning diff1690 (depth = 4)
  *var_minIndentLevel = diff1690;
  if (diff1690 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 576
  setline(576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startIndent (depth = 4)
  *var_statementIndent = *var_startIndent;
  if (*var_startIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1693 = gc_frame_new();
// call case 4: self request
  Object call1694 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1693);
// compiled member node returning call1694 (depth = 3)
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1695 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1696 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  Object call1697 = callmethodflags(*var_btok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1696);
// compiled member node returning call1697 (depth = 4)
  gc_frame_newslot(call1697);
// starting to compile member node (depth = 4)
  int callframe1698 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  Object call1699 = callmethodflags(*var_btok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1698);
// compiled member node returning call1699 (depth = 4)
  gc_frame_newslot(call1699);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call1697;
  params[1] = call1699;
  partcv[0] = 2;
  Object call1700 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1695);
// compiled call node returning call1700 (depth = 3)
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1701 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  gc_frame_newslot(*var_params);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1702 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call1703 = callmethodflags(*var_ast, "blockNode", 0, partcv, params, 0);
  gc_frame_end(callframe1702);
// compiled member node returning call1703 (depth = 5)
  params[0] = *var_params;
  params[1] = *var_body;
  partcv[0] = 2;
  Object call1704 = callmethodflags(call1703, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1701);
// compiled call node returning call1704 (depth = 4)
  *var_o = call1704;
  if (call1704 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_isMatchingBlock (depth = 4)
  Object if1705 = done;
  if (istrue(*var_isMatchingBlock)) {
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1708 = alloc_Float64(0);
// compiled num node returning num1708 (depth = 6)
  int op_slot_right_1707 = gc_frame_newslot(num1708);
// starting to compile member node (depth = 6)
  int callframe1710 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_params (depth = 7)
  Object call1711 = callmethodflags(*var_params, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1710);
// compiled member node returning call1711 (depth = 6)
  int op_slot_left_1707 = gc_frame_newslot(call1711);
  params[0] = num1708;
  partcv[0] = 1;
  Object opresult1712 = callmethod(call1711, ">(1)", 1, partcv, params);
// compiled op node returning opresult1712 (depth = 5)
  Object if1706 = done;
  if (istrue(opresult1712)) {
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1713 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe1714 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_params (depth = 7)
  Object call1715 = callmethodflags(*var_params, "first", 0, partcv, params, 0);
  gc_frame_end(callframe1714);
// compiled member node returning call1715 (depth = 6)
  gc_frame_newslot(call1715);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  params[0] = call1715;
  partcv[0] = 1;
  Object call1716 = callmethodflags(*var_o, "matchingPattern:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1713);
// compiled call node returning call1716 (depth = 5)
    gc_frame_newslot(call1716);
    if1706 = call1716;
  } else {
  }
// compiled if node returning if1706 (depth = 4)
    gc_frame_newslot(if1706);
    if1705 = if1706;
  } else {
  }
// compiled if node returning if1705 (depth = 3)
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1717 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1718 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1717);
// compiled call node returning call1718 (depth = 3)
    gc_frame_newslot(call1718);
    if1198 = call1718;
  } else {
  }
// compiled if node returning if1198 (depth = 2)
  gc_frame_end(frame);
  return if1198;
}
Object meth_parser__apply1738(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1740 == NULL) {
    strlit1740 = alloc_String("lbrace");
    gc_root(strlit1740);
  }
// compiled string node returning strlit1740 (depth = 8)
  int op_slot_right_1739 = gc_frame_newslot(strlit1740);
// starting to compile member node (depth = 8)
  int callframe1742 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call1743 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1742);
// compiled member node returning call1743 (depth = 8)
  int op_slot_left_1739 = gc_frame_newslot(call1743);
  params[0] = strlit1740;
  partcv[0] = 1;
  Object opresult1744 = callmethod(call1743, "==(1)", 1, partcv, params);
// compiled op node returning opresult1744 (depth = 7)
  gc_frame_end(frame);
  return opresult1744;
}
Object meth_parser__apply_40_1_41_1781(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_btok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// Begin line 604
  setline(604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1786 == NULL) {
    strlit1786 = alloc_String("then");
    gc_root(strlit1786);
  }
// compiled string node returning strlit1786 (depth = 11)
  int op_slot_right_1785 = gc_frame_newslot(strlit1786);
// starting to compile member node (depth = 11)
  int callframe1788 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  Object call1789 = callmethodflags(*var_t, "value", 0, partcv, params, 0);
  gc_frame_end(callframe1788);
// compiled member node returning call1789 (depth = 11)
  int op_slot_left_1785 = gc_frame_newslot(call1789);
  params[0] = strlit1786;
  partcv[0] = 1;
  Object opresult1790 = callmethod(call1789, "==(1)", 1, partcv, params);
// compiled op node returning opresult1790 (depth = 10)
  int op_slot_right_1784 = gc_frame_newslot(opresult1790);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1793 == NULL) {
    strlit1793 = alloc_String("identifier");
    gc_root(strlit1793);
  }
// compiled string node returning strlit1793 (depth = 11)
  int op_slot_right_1792 = gc_frame_newslot(strlit1793);
// starting to compile member node (depth = 11)
  int callframe1795 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  Object call1796 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1795);
// compiled member node returning call1796 (depth = 11)
  int op_slot_left_1792 = gc_frame_newslot(call1796);
  params[0] = strlit1793;
  partcv[0] = 1;
  Object opresult1797 = callmethod(call1796, "==(1)", 1, partcv, params);
// compiled op node returning opresult1797 (depth = 10)
  int op_slot_left_1784 = gc_frame_newslot(opresult1797);
  params[0] = opresult1790;
  partcv[0] = 1;
  Object opresult1798 = callmethod(opresult1797, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1798 (depth = 9)
  int op_slot_right_1783 = gc_frame_newslot(opresult1798);
// Begin line 604
  setline(604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1802 == NULL) {
    strlit1802 = alloc_String("lbrace");
    gc_root(strlit1802);
  }
// compiled string node returning strlit1802 (depth = 11)
  int op_slot_right_1801 = gc_frame_newslot(strlit1802);
// starting to compile member node (depth = 11)
  int callframe1804 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  Object call1805 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1804);
// compiled member node returning call1805 (depth = 11)
  int op_slot_left_1801 = gc_frame_newslot(call1805);
  params[0] = strlit1802;
  partcv[0] = 1;
  Object opresult1806 = callmethod(call1805, "==(1)", 1, partcv, params);
// compiled op node returning opresult1806 (depth = 10)
  int op_slot_right_1800 = gc_frame_newslot(opresult1806);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1810 == NULL) {
    strlit1810 = alloc_String("rbrace");
    gc_root(strlit1810);
  }
// compiled string node returning strlit1810 (depth = 12)
  int op_slot_right_1809 = gc_frame_newslot(strlit1810);
// starting to compile member node (depth = 12)
  int callframe1812 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  Object call1813 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1812);
// compiled member node returning call1813 (depth = 12)
  int op_slot_left_1809 = gc_frame_newslot(call1813);
  params[0] = strlit1810;
  partcv[0] = 1;
  Object opresult1814 = callmethod(call1813, "==(1)", 1, partcv, params);
// compiled op node returning opresult1814 (depth = 11)
  int op_slot_right_1808 = gc_frame_newslot(opresult1814);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1817 == NULL) {
    strlit1817 = alloc_String("rparen");
    gc_root(strlit1817);
  }
// compiled string node returning strlit1817 (depth = 12)
  int op_slot_right_1816 = gc_frame_newslot(strlit1817);
// starting to compile member node (depth = 12)
  int callframe1819 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  Object call1820 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1819);
// compiled member node returning call1820 (depth = 12)
  int op_slot_left_1816 = gc_frame_newslot(call1820);
  params[0] = strlit1817;
  partcv[0] = 1;
  Object opresult1821 = callmethod(call1820, "==(1)", 1, partcv, params);
// compiled op node returning opresult1821 (depth = 11)
  int op_slot_left_1808 = gc_frame_newslot(opresult1821);
  params[0] = opresult1814;
  partcv[0] = 1;
  Object opresult1822 = callmethod(opresult1821, "||(1)", 1, partcv, params);
// compiled op node returning opresult1822 (depth = 10)
  int op_slot_left_1800 = gc_frame_newslot(opresult1822);
  params[0] = opresult1806;
  partcv[0] = 1;
  Object opresult1823 = callmethod(opresult1822, "||(1)", 1, partcv, params);
// compiled op node returning opresult1823 (depth = 9)
  int op_slot_left_1783 = gc_frame_newslot(opresult1823);
  params[0] = opresult1798;
  partcv[0] = 1;
  Object opresult1824 = callmethod(opresult1823, "||(1)", 1, partcv, params);
// compiled op node returning opresult1824 (depth = 8)
  int op_slot_right_1782 = gc_frame_newslot(opresult1824);
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe1827 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_btok (depth = 10)
  Object call1828 = callmethodflags(*var_btok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1827);
// compiled member node returning call1828 (depth = 9)
  int op_slot_right_1826 = gc_frame_newslot(call1828);
// starting to compile member node (depth = 9)
  int callframe1830 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call1831 = callmethodflags(*var_t, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1830);
// compiled member node returning call1831 (depth = 9)
  int op_slot_left_1826 = gc_frame_newslot(call1831);
  params[0] = call1828;
  partcv[0] = 1;
  Object opresult1832 = callmethod(call1831, "==(1)", 1, partcv, params);
// compiled op node returning opresult1832 (depth = 8)
  int op_slot_left_1782 = gc_frame_newslot(opresult1832);
  params[0] = opresult1824;
  partcv[0] = 1;
  Object opresult1833 = callmethod(opresult1832, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1833 (depth = 7)
  gc_frame_end(frame);
  return opresult1833;
}
Object meth_parser__apply1924(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe1925 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_blocksOK (depth = 8)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1926 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1925);
// compiled call node returning call1926 (depth = 7)
  gc_frame_end(frame);
  return call1926;
}
Object meth_parser__apply_40_1_41_1936(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1939 == NULL) {
    strlit1939 = alloc_String("rparen");
    gc_root(strlit1939);
  }
// compiled string node returning strlit1939 (depth = 9)
  int op_slot_right_1938 = gc_frame_newslot(strlit1939);
// starting to compile member node (depth = 9)
  int callframe1941 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call1942 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1941);
// compiled member node returning call1942 (depth = 9)
  int op_slot_left_1938 = gc_frame_newslot(call1942);
  params[0] = strlit1939;
  partcv[0] = 1;
  Object opresult1943 = callmethod(call1942, "==(1)", 1, partcv, params);
// compiled op node returning opresult1943 (depth = 8)
  int op_slot_right_1937 = gc_frame_newslot(opresult1943);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe1946 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call1947 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1946);
// compiled member node returning call1947 (depth = 9)
  int op_slot_right_1945 = gc_frame_newslot(call1947);
// starting to compile member node (depth = 9)
  int callframe1949 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call1950 = callmethodflags(*var_t, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1949);
// compiled member node returning call1950 (depth = 9)
  int op_slot_left_1945 = gc_frame_newslot(call1950);
  params[0] = call1947;
  partcv[0] = 1;
  Object opresult1951 = callmethod(call1950, "==(1)", 1, partcv, params);
// compiled op node returning opresult1951 (depth = 8)
  int op_slot_left_1937 = gc_frame_newslot(opresult1951);
  params[0] = opresult1943;
  partcv[0] = 1;
  Object opresult1952 = callmethod(opresult1951, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1952 (depth = 7)
  gc_frame_end(frame);
  return opresult1952;
}
Object meth_parser__apply2185(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
  int callframe2186 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe2187 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2188 == NULL) {
    strlit2188 = alloc_String("rbrace");
    gc_root(strlit2188);
  }
// compiled string node returning strlit2188 (depth = 8)
  gc_frame_newslot(strlit2188);
// call case 4: self request
  params[0] = strlit2188;
  partcv[0] = 1;
  Object call2189 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2187);
// compiled call node returning call2189 (depth = 7)
  Object call2190 = callmethodflags(call2189, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2186);
// compiled member node returning call2190 (depth = 6)
  gc_frame_end(frame);
  return call2190;
}
Object meth_parser__apply2198(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 10)
  int callframe2199 = gc_frame_new();
// call case 4: self request
  Object call2200 = callmethodflags(self, "statement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2199);
// compiled member node returning call2200 (depth = 10)
  gc_frame_end(frame);
  return call2200;
}
Object meth_parser__apply2193(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_body = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// Begin line 717
  setline(717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2195 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe2196 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2197 = alloc_Block(NULL, NULL, "parser", 717);
  gc_frame_newslot(block2197);
// method "_apply"
  block_savedest(block2197);
  Object closure2198 = createclosure(1, "_apply");
  setclosureframe(closure2198, stackframe);
  addtoclosure(closure2198, selfslot);
  struct UserObject *uo2198 = (struct UserObject*)block2197;
  uo2198->data[0] = (Object)closure2198;
  Method *meth_meth_parser__apply2198 = addmethod2pos(block2197, "_apply", &meth_parser__apply2198, 0);
  int argcv_meth_parser__apply2198[] = {0};
  meth_meth_parser__apply2198->type = alloc_MethodType(1, argcv_meth_parser__apply2198);
  meth_meth_parser__apply2198->definitionModule = modulename;
  meth_meth_parser__apply2198->definitionLine = 3399;
// compiled block node returning block2197 (depth = 9)
  gc_frame_newslot(block2197);
// call case 4: self request
  params[0] = block2197;
  partcv[0] = 1;
  Object call2202 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2196);
// compiled call node returning call2202 (depth = 8)
  Object call2203 = callmethodflags(call2202, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2195);
// compiled member node returning call2203 (depth = 7)
  Object if2194 = done;
  if (istrue(call2203)) {
// Begin line 718
  setline(718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2204 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2205 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call2206 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2205);
// compiled member node returning call2206 (depth = 9)
  Object call2207 = callmethodflags(call2206, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2204);
// compiled member node returning call2207 (depth = 8)
  *var_suggestion = call2207;
  if (call2207 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2208 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 9)
  Object bool2209 = alloc_Boolean(0);
// compiled identifier node returning bool2209 (depth = 9)
  gc_frame_newslot(bool2209);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2209;
  partcv[0] = 2;
  Object call2210 = callmethodflags(self, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2208);
// compiled call node returning call2210 (depth = 8)
  *var_closingBrace = call2210;
  if (call2210 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2212 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2213 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  Object call2214 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe2213);
// compiled member node returning call2214 (depth = 9)
  Object call2215 = callmethodflags(call2214, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2212);
// compiled member node returning call2215 (depth = 8)
  Object if2211 = done;
  if (istrue(call2215)) {
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  int op_slot_right_2217 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 10)
  int callframe2219 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  Object call2220 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2219);
// compiled member node returning call2220 (depth = 10)
  int op_slot_left_2217 = gc_frame_newslot(call2220);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2221 = callmethod(call2220, "==(1)", 1, partcv, params);
// compiled op node returning opresult2221 (depth = 9)
  Object if2216 = done;
  if (istrue(opresult2221)) {
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2222 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2223 == NULL) {
    strlit2223 = alloc_String("}");
    gc_root(strlit2223);
  }
// compiled string node returning strlit2223 (depth = 10)
  gc_frame_newslot(strlit2223);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2223;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2224 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2222);
// compiled call node returning call2224 (depth = 9)
    gc_frame_newslot(call2224);
    if2216 = call2224;
  } else {
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2225 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2227 = alloc_Float64(0.1);
// compiled num node returning num2227 (depth = 11)
  int op_slot_right_2226 = gc_frame_newslot(num2227);
// starting to compile member node (depth = 11)
  int callframe2229 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe2230 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  Object call2231 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2230);
// compiled member node returning call2231 (depth = 12)
  Object call2232 = callmethodflags(call2231, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2229);
// compiled member node returning call2232 (depth = 11)
  int op_slot_left_2226 = gc_frame_newslot(call2232);
  params[0] = num2227;
  partcv[0] = 1;
  Object sum2233 = callmethod(call2232, "+(1)", 1, partcv, params);
// compiled op node returning sum2233 (depth = 10)
  gc_frame_newslot(sum2233);
// starting to compile string node (depth = 10)
  if (strlit2234 == NULL) {
    strlit2234 = alloc_String("}");
    gc_root(strlit2234);
  }
// compiled string node returning strlit2234 (depth = 10)
  gc_frame_newslot(strlit2234);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = sum2233;
  params[1] = strlit2234;
  partcv[0] = 2;
  Object call2235 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2225);
// compiled call node returning call2235 (depth = 9)
    gc_frame_newslot(call2235);
    if2216 = call2235;
  }
// compiled if node returning if2216 (depth = 8)
    gc_frame_newslot(if2216);
    if2211 = if2216;
  } else {
  }
// compiled if node returning if2211 (depth = 7)
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2236 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call2237 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2236);
// compiled call node returning call2237 (depth = 7)
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2238 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2239 == NULL) {
    strlit2239 = alloc_String("an if statement must end with a '}'.");
    gc_root(strlit2239);
  }
// compiled string node returning strlit2239 (depth = 8)
  gc_frame_newslot(strlit2239);
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe2240 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2241 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2240);
// compiled member node returning call2241 (depth = 8)
  gc_frame_newslot(call2241);
// starting to compile member node (depth = 8)
  int callframe2242 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2243 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2242);
// compiled member node returning call2243 (depth = 8)
  gc_frame_newslot(call2243);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2239;
  params[1] = call2241;
  params[2] = call2243;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2244 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2238);
// compiled call node returning call2244 (depth = 7)
    gc_frame_newslot(call2244);
    if2194 = call2244;
  } else {
  }
// compiled if node returning if2194 (depth = 6)
// Begin line 731
  setline(731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2245 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call2246 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe2245);
// compiled member node returning call2246 (depth = 7)
  *var_v = call2246;
  if (call2246 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 732
  setline(732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2248 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_body (depth = 7)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2249 = callmethodflags(*var_body, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2248);
// compiled call node returning call2249 (depth = 6)
  gc_frame_end(frame);
  return call2249;
}
Object meth_parser__apply2256(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2259 == NULL) {
    strlit2259 = alloc_String("elseif");
    gc_root(strlit2259);
  }
// compiled string node returning strlit2259 (depth = 8)
  int op_slot_right_2258 = gc_frame_newslot(strlit2259);
// starting to compile member node (depth = 8)
  int callframe2261 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2262 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe2261);
// compiled member node returning call2262 (depth = 8)
  int op_slot_left_2258 = gc_frame_newslot(call2262);
  params[0] = strlit2259;
  partcv[0] = 1;
  Object opresult2263 = callmethod(call2262, "==(1)", 1, partcv, params);
// compiled op node returning opresult2263 (depth = 7)
  int op_slot_right_2257 = gc_frame_newslot(opresult2263);
// starting to compile call node (depth = 7)
  int callframe2265 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2266 == NULL) {
    strlit2266 = alloc_String("identifier");
    gc_root(strlit2266);
  }
// compiled string node returning strlit2266 (depth = 8)
  gc_frame_newslot(strlit2266);
// call case 4: self request
  params[0] = strlit2266;
  partcv[0] = 1;
  Object call2267 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2265);
// compiled call node returning call2267 (depth = 7)
  int op_slot_left_2257 = gc_frame_newslot(call2267);
  params[0] = opresult2263;
  partcv[0] = 1;
  Object opresult2268 = callmethod(call2267, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2268 (depth = 6)
  gc_frame_end(frame);
  return opresult2268;
}
Object meth_parser__apply_40_1_41_2288(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2293 == NULL) {
    strlit2293 = alloc_String("then");
    gc_root(strlit2293);
  }
// compiled string node returning strlit2293 (depth = 14)
  int op_slot_right_2292 = gc_frame_newslot(strlit2293);
// starting to compile member node (depth = 14)
  int callframe2295 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  Object call2296 = callmethodflags(*var_t, "value", 0, partcv, params, 0);
  gc_frame_end(callframe2295);
// compiled member node returning call2296 (depth = 14)
  int op_slot_left_2292 = gc_frame_newslot(call2296);
  params[0] = strlit2293;
  partcv[0] = 1;
  Object opresult2297 = callmethod(call2296, "==(1)", 1, partcv, params);
// compiled op node returning opresult2297 (depth = 13)
  int op_slot_right_2291 = gc_frame_newslot(opresult2297);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2300 == NULL) {
    strlit2300 = alloc_String("identifier");
    gc_root(strlit2300);
  }
// compiled string node returning strlit2300 (depth = 14)
  int op_slot_right_2299 = gc_frame_newslot(strlit2300);
// starting to compile member node (depth = 14)
  int callframe2302 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  Object call2303 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2302);
// compiled member node returning call2303 (depth = 14)
  int op_slot_left_2299 = gc_frame_newslot(call2303);
  params[0] = strlit2300;
  partcv[0] = 1;
  Object opresult2304 = callmethod(call2303, "==(1)", 1, partcv, params);
// compiled op node returning opresult2304 (depth = 13)
  int op_slot_left_2291 = gc_frame_newslot(opresult2304);
  params[0] = opresult2297;
  partcv[0] = 1;
  Object opresult2305 = callmethod(opresult2304, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2305 (depth = 12)
  int op_slot_right_2290 = gc_frame_newslot(opresult2305);
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2309 == NULL) {
    strlit2309 = alloc_String("lbrace");
    gc_root(strlit2309);
  }
// compiled string node returning strlit2309 (depth = 14)
  int op_slot_right_2308 = gc_frame_newslot(strlit2309);
// starting to compile member node (depth = 14)
  int callframe2311 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  Object call2312 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2311);
// compiled member node returning call2312 (depth = 14)
  int op_slot_left_2308 = gc_frame_newslot(call2312);
  params[0] = strlit2309;
  partcv[0] = 1;
  Object opresult2313 = callmethod(call2312, "==(1)", 1, partcv, params);
// compiled op node returning opresult2313 (depth = 13)
  int op_slot_right_2307 = gc_frame_newslot(opresult2313);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2316 == NULL) {
    strlit2316 = alloc_String("rbrace");
    gc_root(strlit2316);
  }
// compiled string node returning strlit2316 (depth = 14)
  int op_slot_right_2315 = gc_frame_newslot(strlit2316);
// starting to compile member node (depth = 14)
  int callframe2318 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  Object call2319 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2318);
// compiled member node returning call2319 (depth = 14)
  int op_slot_left_2315 = gc_frame_newslot(call2319);
  params[0] = strlit2316;
  partcv[0] = 1;
  Object opresult2320 = callmethod(call2319, "==(1)", 1, partcv, params);
// compiled op node returning opresult2320 (depth = 13)
  int op_slot_left_2307 = gc_frame_newslot(opresult2320);
  params[0] = opresult2313;
  partcv[0] = 1;
  Object opresult2321 = callmethod(opresult2320, "||(1)", 1, partcv, params);
// compiled op node returning opresult2321 (depth = 12)
  int op_slot_left_2290 = gc_frame_newslot(opresult2321);
  params[0] = opresult2305;
  partcv[0] = 1;
  Object opresult2322 = callmethod(opresult2321, "||(1)", 1, partcv, params);
// compiled op node returning opresult2322 (depth = 11)
  int op_slot_right_2289 = gc_frame_newslot(opresult2322);
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
  int callframe2325 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_statementToken (depth = 13)
  Object call2326 = callmethodflags(*var_statementToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2325);
// compiled member node returning call2326 (depth = 12)
  int op_slot_right_2324 = gc_frame_newslot(call2326);
// starting to compile member node (depth = 12)
  int callframe2328 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  Object call2329 = callmethodflags(*var_t, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2328);
// compiled member node returning call2329 (depth = 12)
  int op_slot_left_2324 = gc_frame_newslot(call2329);
  params[0] = call2326;
  partcv[0] = 1;
  Object opresult2330 = callmethod(call2329, "==(1)", 1, partcv, params);
// compiled op node returning opresult2330 (depth = 11)
  int op_slot_left_2289 = gc_frame_newslot(opresult2330);
  params[0] = opresult2322;
  partcv[0] = 1;
  Object opresult2331 = callmethod(opresult2330, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2331 (depth = 10)
  gc_frame_end(frame);
  return opresult2331;
}
Object meth_parser__apply2422(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 10)
  int callframe2423 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_blocksOK (depth = 11)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call2424 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2423);
// compiled call node returning call2424 (depth = 10)
  gc_frame_end(frame);
  return call2424;
}
Object meth_parser__apply_40_1_41_2434(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2437 == NULL) {
    strlit2437 = alloc_String("rbrace");
    gc_root(strlit2437);
  }
// compiled string node returning strlit2437 (depth = 12)
  int op_slot_right_2436 = gc_frame_newslot(strlit2437);
// starting to compile member node (depth = 12)
  int callframe2439 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  Object call2440 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2439);
// compiled member node returning call2440 (depth = 12)
  int op_slot_left_2436 = gc_frame_newslot(call2440);
  params[0] = strlit2437;
  partcv[0] = 1;
  Object opresult2441 = callmethod(call2440, "==(1)", 1, partcv, params);
// compiled op node returning opresult2441 (depth = 11)
  int op_slot_right_2435 = gc_frame_newslot(opresult2441);
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
  int callframe2444 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lastToken (depth = 13)
  Object call2445 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2444);
// compiled member node returning call2445 (depth = 12)
  int op_slot_right_2443 = gc_frame_newslot(call2445);
// starting to compile member node (depth = 12)
  int callframe2447 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  Object call2448 = callmethodflags(*var_t, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2447);
// compiled member node returning call2448 (depth = 12)
  int op_slot_left_2443 = gc_frame_newslot(call2448);
  params[0] = call2445;
  partcv[0] = 1;
  Object opresult2449 = callmethod(call2448, "==(1)", 1, partcv, params);
// compiled op node returning opresult2449 (depth = 11)
  int op_slot_left_2435 = gc_frame_newslot(opresult2449);
  params[0] = opresult2441;
  partcv[0] = 1;
  Object opresult2450 = callmethod(opresult2449, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2450 (depth = 10)
  gc_frame_end(frame);
  return opresult2450;
}
Object meth_parser__apply2747(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 8)
  int callframe2748 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 9)
  int callframe2749 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2750 == NULL) {
    strlit2750 = alloc_String("rbrace");
    gc_root(strlit2750);
  }
// compiled string node returning strlit2750 (depth = 10)
  gc_frame_newslot(strlit2750);
// call case 4: self request
  params[0] = strlit2750;
  partcv[0] = 1;
  Object call2751 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2749);
// compiled call node returning call2751 (depth = 9)
  Object call2752 = callmethodflags(call2751, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2748);
// compiled member node returning call2752 (depth = 8)
  gc_frame_end(frame);
  return call2752;
}
Object meth_parser__apply2760(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 12)
  int callframe2761 = gc_frame_new();
// call case 4: self request
  Object call2762 = callmethodflags(self, "statement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2761);
// compiled member node returning call2762 (depth = 12)
  gc_frame_end(frame);
  return call2762;
}
Object meth_parser__apply2755(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_ebody = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// Begin line 875
  setline(875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2757 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 10)
  int callframe2758 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block2759 = alloc_Block(NULL, NULL, "parser", 875);
  gc_frame_newslot(block2759);
// method "_apply"
  block_savedest(block2759);
  Object closure2760 = createclosure(1, "_apply");
  setclosureframe(closure2760, stackframe);
  addtoclosure(closure2760, selfslot);
  struct UserObject *uo2760 = (struct UserObject*)block2759;
  uo2760->data[0] = (Object)closure2760;
  Method *meth_meth_parser__apply2760 = addmethod2pos(block2759, "_apply", &meth_parser__apply2760, 0);
  int argcv_meth_parser__apply2760[] = {0};
  meth_meth_parser__apply2760->type = alloc_MethodType(1, argcv_meth_parser__apply2760);
  meth_meth_parser__apply2760->definitionModule = modulename;
  meth_meth_parser__apply2760->definitionLine = 3399;
// compiled block node returning block2759 (depth = 11)
  gc_frame_newslot(block2759);
// call case 4: self request
  params[0] = block2759;
  partcv[0] = 1;
  Object call2764 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2758);
// compiled call node returning call2764 (depth = 10)
  Object call2765 = callmethodflags(call2764, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2757);
// compiled member node returning call2765 (depth = 9)
  Object if2756 = done;
  if (istrue(call2765)) {
// Begin line 876
  setline(876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe2766 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe2767 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  Object call2768 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2767);
// compiled member node returning call2768 (depth = 11)
  Object call2769 = callmethodflags(call2768, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2766);
// compiled member node returning call2769 (depth = 10)
  *var_suggestion = call2769;
  if (call2769 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 9)
// Begin line 877
  setline(877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2770 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_btok (depth = 11)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 11)
  Object bool2771 = alloc_Boolean(0);
// compiled identifier node returning bool2771 (depth = 11)
  gc_frame_newslot(bool2771);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2771;
  partcv[0] = 2;
  Object call2772 = callmethodflags(self, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2770);
// compiled call node returning call2772 (depth = 10)
  *var_closingBrace = call2772;
  if (call2772 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 9)
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe2774 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe2775 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  Object call2776 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe2775);
// compiled member node returning call2776 (depth = 11)
  Object call2777 = callmethodflags(call2776, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2774);
// compiled member node returning call2777 (depth = 10)
  Object if2773 = done;
  if (istrue(call2777)) {
// Begin line 879
  setline(879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  int op_slot_right_2779 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 12)
  int callframe2781 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  Object call2782 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2781);
// compiled member node returning call2782 (depth = 12)
  int op_slot_left_2779 = gc_frame_newslot(call2782);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2783 = callmethod(call2782, "==(1)", 1, partcv, params);
// compiled op node returning opresult2783 (depth = 11)
  Object if2778 = done;
  if (istrue(opresult2783)) {
// Begin line 880
  setline(880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2784 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2785 == NULL) {
    strlit2785 = alloc_String("}");
    gc_root(strlit2785);
  }
// compiled string node returning strlit2785 (depth = 12)
  gc_frame_newslot(strlit2785);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2785;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2786 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2784);
// compiled call node returning call2786 (depth = 11)
    gc_frame_newslot(call2786);
    if2778 = call2786;
  } else {
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2787 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num2789 = alloc_Float64(0.1);
// compiled num node returning num2789 (depth = 13)
  int op_slot_right_2788 = gc_frame_newslot(num2789);
// starting to compile member node (depth = 13)
  int callframe2791 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 14)
  int callframe2792 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_closingBrace (depth = 15)
  Object call2793 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2792);
// compiled member node returning call2793 (depth = 14)
  Object call2794 = callmethodflags(call2793, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2791);
// compiled member node returning call2794 (depth = 13)
  int op_slot_left_2788 = gc_frame_newslot(call2794);
  params[0] = num2789;
  partcv[0] = 1;
  Object sum2795 = callmethod(call2794, "+(1)", 1, partcv, params);
// compiled op node returning sum2795 (depth = 12)
  gc_frame_newslot(sum2795);
// starting to compile string node (depth = 12)
  if (strlit2796 == NULL) {
    strlit2796 = alloc_String("}");
    gc_root(strlit2796);
  }
// compiled string node returning strlit2796 (depth = 12)
  gc_frame_newslot(strlit2796);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = sum2795;
  params[1] = strlit2796;
  partcv[0] = 2;
  Object call2797 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2787);
// compiled call node returning call2797 (depth = 11)
    gc_frame_newslot(call2797);
    if2778 = call2797;
  }
// compiled if node returning if2778 (depth = 10)
    gc_frame_newslot(if2778);
    if2773 = if2778;
  } else {
  }
// compiled if node returning if2773 (depth = 9)
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2798 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call2799 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2798);
// compiled call node returning call2799 (depth = 9)
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2800 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2801 == NULL) {
    strlit2801 = alloc_String("an elseif statement must end with a '}'.");
    gc_root(strlit2801);
  }
// compiled string node returning strlit2801 (depth = 10)
  gc_frame_newslot(strlit2801);
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe2802 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call2803 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2802);
// compiled member node returning call2803 (depth = 10)
  gc_frame_newslot(call2803);
// starting to compile member node (depth = 10)
  int callframe2804 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call2805 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2804);
// compiled member node returning call2805 (depth = 10)
  gc_frame_newslot(call2805);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2801;
  params[1] = call2803;
  params[2] = call2805;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2806 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2800);
// compiled call node returning call2806 (depth = 9)
    gc_frame_newslot(call2806);
    if2756 = call2806;
  } else {
  }
// compiled if node returning if2756 (depth = 8)
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2807 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  Object call2808 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe2807);
// compiled member node returning call2808 (depth = 9)
  *var_v = call2808;
  if (call2808 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2810 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_v (depth = 9)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ebody (depth = 9)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2811 = callmethodflags(*var_ebody, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2810);
// compiled call node returning call2811 (depth = 8)
  gc_frame_end(frame);
  return call2811;
}
Object meth_parser__apply2271(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_econd = getfromclosure(closure, 6);
  Object *var_ebody = getfromclosure(closure, 7);
  Object *var_btok = getfromclosure(closure, 8);
  Object *var_minIndentLevel = getfromclosure(closure, 9);
  Object *var_minInd = getfromclosure(closure, 10);
  Object *var_v = getfromclosure(closure, 11);
  Object *var_newelse = getfromclosure(closure, 12);
  Object *var_eif = getfromclosure(closure, 13);
  Object *var_curelse = getfromclosure(closure, 14);
  Object self = *(getfromclosure(closure, 15));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_closingBrace = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "closingBrace");
// starting to compile bind node (depth = 6)
// Begin line 743
  setline(743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 744
  setline(744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2273 = gc_frame_new();
// call case 4: self request
  Object call2274 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2273);
// compiled member node returning call2274 (depth = 6)
// Begin line 745
  setline(745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2277 == NULL) {
    strlit2277 = alloc_String("lbrace");
    gc_root(strlit2277);
  }
// compiled string node returning strlit2277 (depth = 8)
  int op_slot_right_2276 = gc_frame_newslot(strlit2277);
// starting to compile member node (depth = 8)
  int callframe2279 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2280 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2279);
// compiled member node returning call2280 (depth = 8)
  int op_slot_left_2276 = gc_frame_newslot(call2280);
  params[0] = strlit2277;
  partcv[0] = 1;
  Object opresult2281 = callmethod(call2280, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2281 (depth = 7)
  Object if2275 = done;
  if (istrue(opresult2281)) {
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2282 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2283 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call2284 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2283);
// compiled member node returning call2284 (depth = 9)
  Object call2285 = callmethodflags(call2284, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2282);
// compiled member node returning call2285 (depth = 8)
  *var_suggestion = call2285;
  if (call2285 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2286 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2287 = alloc_Block(NULL, NULL, "parser", 748);
  gc_frame_newslot(block2287);
// method "_apply(_)"
  block_savedest(block2287);
  Object closure2288 = createclosure(2, "_apply(1)");
  setclosureframe(closure2288, stackframe);
  addtoclosure(closure2288, var_statementToken);
  addtoclosure(closure2288, selfslot);
  struct UserObject *uo2288 = (struct UserObject*)block2287;
  uo2288->data[0] = (Object)closure2288;
  Method *meth_meth_parser__apply_40_1_41_2288 = addmethod2pos(block2287, "_apply(1)", &meth_parser__apply_40_1_41_2288, 0);
  int argcv_meth_parser__apply_40_1_41_2288[] = {1};
  meth_meth_parser__apply_40_1_41_2288->type = alloc_MethodType(1, argcv_meth_parser__apply_40_1_41_2288);
  meth_meth_parser__apply_40_1_41_2288->definitionModule = modulename;
  meth_meth_parser__apply_40_1_41_2288->definitionLine = 3399;
// compiled block node returning block2287 (depth = 9)
  gc_frame_newslot(block2287);
// call case 4: self request
  params[0] = block2287;
  partcv[0] = 1;
  Object call2333 = callmethodflags(self, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2286);
// compiled call node returning call2333 (depth = 8)
  *var_nextTok = call2333;
  if (call2333 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 751
  setline(751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_right_2335 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 9)
  Object bool2337 = alloc_Boolean(0);
// compiled identifier node returning bool2337 (depth = 9)
  int op_slot_left_2335 = gc_frame_newslot(bool2337);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult2338 = callmethod(bool2337, "==(1)", 1, partcv, params);
// compiled op node returning opresult2338 (depth = 8)
  Object if2334 = done;
  if (istrue(opresult2338)) {
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2339 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2340 == NULL) {
    strlit2340 = alloc_String(" { ""\xc2""""\xab""expression""\xc2""""\xbb"" } then {");
    gc_root(strlit2340);
  }
// compiled string node returning strlit2340 (depth = 9)
  gc_frame_newslot(strlit2340);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_statementToken (depth = 9)
  gc_frame_newslot(*var_statementToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit2340;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2341 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2339);
// compiled call node returning call2341 (depth = 8)
    gc_frame_newslot(call2341);
    if2334 = call2341;
  } else {
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2344 == NULL) {
    strlit2344 = alloc_String("rbrace");
    gc_root(strlit2344);
  }
// compiled string node returning strlit2344 (depth = 10)
  int op_slot_right_2343 = gc_frame_newslot(strlit2344);
// starting to compile member node (depth = 10)
  int callframe2346 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  Object call2347 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2346);
// compiled member node returning call2347 (depth = 10)
  int op_slot_left_2343 = gc_frame_newslot(call2347);
  params[0] = strlit2344;
  partcv[0] = 1;
  Object opresult2348 = callmethod(call2347, "==(1)", 1, partcv, params);
// compiled op node returning opresult2348 (depth = 9)
  Object if2342 = done;
  if (istrue(opresult2348)) {
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_2350 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  int op_slot_left_2350 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2352 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult2352 (depth = 10)
  Object if2349 = done;
  if (istrue(opresult2352)) {
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2353 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2354 == NULL) {
    strlit2354 = alloc_String("{ ""\xc2""""\xab""expression""\xc2""""\xbb"" }");
    gc_root(strlit2354);
  }
// compiled string node returning strlit2354 (depth = 11)
  gc_frame_newslot(strlit2354);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2354;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2355 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2353);
// compiled call node returning call2355 (depth = 10)
    gc_frame_newslot(call2355);
    if2349 = call2355;
  } else {
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2356 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2357 == NULL) {
    strlit2357 = alloc_String("{ ");
    gc_root(strlit2357);
  }
// compiled string node returning strlit2357 (depth = 11)
  gc_frame_newslot(strlit2357);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2357;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2358 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2356);
// compiled call node returning call2358 (depth = 10)
    gc_frame_newslot(call2358);
    if2349 = call2358;
  }
// compiled if node returning if2349 (depth = 9)
    gc_frame_newslot(if2349);
    if2342 = if2349;
  } else {
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2361 == NULL) {
    strlit2361 = alloc_String("lbrace");
    gc_root(strlit2361);
  }
// compiled string node returning strlit2361 (depth = 11)
  int op_slot_right_2360 = gc_frame_newslot(strlit2361);
// starting to compile member node (depth = 11)
  int callframe2363 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  Object call2364 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2363);
// compiled member node returning call2364 (depth = 11)
  int op_slot_left_2360 = gc_frame_newslot(call2364);
  params[0] = strlit2361;
  partcv[0] = 1;
  Object opresult2365 = callmethod(call2364, "==(1)", 1, partcv, params);
// compiled op node returning opresult2365 (depth = 10)
  Object if2359 = done;
  if (istrue(opresult2365)) {
// Begin line 760
  setline(760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  int op_slot_right_2367 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  int op_slot_left_2367 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2369 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult2369 (depth = 11)
  Object if2366 = done;
  if (istrue(opresult2369)) {
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2370 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2371 == NULL) {
    strlit2371 = alloc_String(" { ""\xc2""""\xab""expression""\xc2""""\xbb"" } then");
    gc_root(strlit2371);
  }
// compiled string node returning strlit2371 (depth = 12)
  gc_frame_newslot(strlit2371);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_statementToken (depth = 12)
  gc_frame_newslot(*var_statementToken);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2371;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2372 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2370);
// compiled call node returning call2372 (depth = 11)
    gc_frame_newslot(call2372);
    if2366 = call2372;
  } else {
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2373 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2374 == NULL) {
    strlit2374 = alloc_String("{ ");
    gc_root(strlit2374);
  }
// compiled string node returning strlit2374 (depth = 12)
  gc_frame_newslot(strlit2374);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2374;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2375 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2373);
// compiled call node returning call2375 (depth = 11)
// Begin line 764
  setline(764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2376 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2377 == NULL) {
    strlit2377 = alloc_String(" } then");
    gc_root(strlit2377);
  }
// compiled string node returning strlit2377 (depth = 12)
  gc_frame_newslot(strlit2377);
// starting to compile member node (depth = 12)
  int callframe2378 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  Object call2379 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe2378);
// compiled member node returning call2379 (depth = 12)
  gc_frame_newslot(call2379);
// starting to compile identifier node (depth = 12)
  Object bool2380 = alloc_Boolean(1);
// compiled identifier node returning bool2380 (depth = 12)
  gc_frame_newslot(bool2380);
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2377;
  params[1] = call2379;
  params[2] = bool2380;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2381 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2376);
// compiled call node returning call2381 (depth = 11)
    gc_frame_newslot(call2381);
    if2366 = call2381;
  }
// compiled if node returning if2366 (depth = 10)
    gc_frame_newslot(if2366);
    if2359 = if2366;
  } else {
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2384 == NULL) {
    strlit2384 = alloc_String("identifier");
    gc_root(strlit2384);
  }
// compiled string node returning strlit2384 (depth = 12)
  int op_slot_right_2383 = gc_frame_newslot(strlit2384);
// starting to compile member node (depth = 12)
  int callframe2386 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  Object call2387 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2386);
// compiled member node returning call2387 (depth = 12)
  int op_slot_left_2383 = gc_frame_newslot(call2387);
  params[0] = strlit2384;
  partcv[0] = 1;
  Object opresult2388 = callmethod(call2387, "==(1)", 1, partcv, params);
// compiled op node returning opresult2388 (depth = 11)
  Object if2382 = done;
  if (istrue(opresult2388)) {
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  int op_slot_right_2390 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  int op_slot_left_2390 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2392 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult2392 (depth = 12)
  Object if2389 = done;
  if (istrue(opresult2392)) {
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2393 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2394 == NULL) {
    strlit2394 = alloc_String("{ ""\xc2""""\xab""expression""\xc2""""\xbb"" } ");
    gc_root(strlit2394);
  }
// compiled string node returning strlit2394 (depth = 13)
  gc_frame_newslot(strlit2394);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2394;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2395 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2393);
// compiled call node returning call2395 (depth = 12)
    gc_frame_newslot(call2395);
    if2389 = call2395;
  } else {
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2396 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2397 == NULL) {
    strlit2397 = alloc_String("{ ");
    gc_root(strlit2397);
  }
// compiled string node returning strlit2397 (depth = 13)
  gc_frame_newslot(strlit2397);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2397;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2398 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2396);
// compiled call node returning call2398 (depth = 12)
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2399 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2400 == NULL) {
    strlit2400 = alloc_String(" }");
    gc_root(strlit2400);
  }
// compiled string node returning strlit2400 (depth = 13)
  gc_frame_newslot(strlit2400);
// starting to compile member node (depth = 13)
  int callframe2401 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_nextTok (depth = 14)
  Object call2402 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe2401);
// compiled member node returning call2402 (depth = 13)
  gc_frame_newslot(call2402);
// starting to compile identifier node (depth = 13)
  Object bool2403 = alloc_Boolean(1);
// compiled identifier node returning bool2403 (depth = 13)
  gc_frame_newslot(bool2403);
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2400;
  params[1] = call2402;
  params[2] = bool2403;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2404 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2399);
// compiled call node returning call2404 (depth = 12)
    gc_frame_newslot(call2404);
    if2389 = call2404;
  }
// compiled if node returning if2389 (depth = 11)
    gc_frame_newslot(if2389);
    if2382 = if2389;
  } else {
  }
// compiled if node returning if2382 (depth = 10)
    gc_frame_newslot(if2382);
    if2359 = if2382;
  }
// compiled if node returning if2359 (depth = 9)
    gc_frame_newslot(if2359);
    if2342 = if2359;
  }
// compiled if node returning if2342 (depth = 8)
    gc_frame_newslot(if2342);
    if2334 = if2342;
  }
// compiled if node returning if2334 (depth = 7)
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2405 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2407 == NULL) {
    strlit2407 = alloc_String("condition in braces after the 'elseif'.");
    gc_root(strlit2407);
  }
// compiled string node returning strlit2407 (depth = 9)
  int op_slot_right_2406 = gc_frame_newslot(strlit2407);
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2409 == NULL) {
    strlit2409 = alloc_String("an elseif statement must have a ");
    gc_root(strlit2409);
  }
// compiled string node returning strlit2409 (depth = 9)
  int op_slot_left_2406 = gc_frame_newslot(strlit2409);
  params[0] = strlit2407;
  partcv[0] = 1;
  Object opresult2410 = callmethod(strlit2409, "++(1)", 1, partcv, params);
// compiled op node returning opresult2410 (depth = 8)
  gc_frame_newslot(opresult2410);
// Begin line 776
  setline(776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe2411 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2412 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2411);
// compiled member node returning call2412 (depth = 8)
  gc_frame_newslot(call2412);
// starting to compile member node (depth = 8)
  int callframe2413 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2414 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2413);
// compiled member node returning call2414 (depth = 8)
  gc_frame_newslot(call2414);
// Begin line 777
  setline(777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2410;
  params[1] = call2412;
  params[2] = call2414;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2415 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2405);
// compiled call node returning call2415 (depth = 7)
    gc_frame_newslot(call2415);
    if2275 = call2415;
  } else {
  }
// compiled if node returning if2275 (depth = 6)
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2416 = gc_frame_new();
// call case 4: self request
  Object call2417 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2416);
// compiled member node returning call2417 (depth = 6)
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2419 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe2420 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2421 = alloc_Block(NULL, NULL, "parser", 780);
  gc_frame_newslot(block2421);
// method "_apply"
  block_savedest(block2421);
  Object closure2422 = createclosure(2, "_apply");
  setclosureframe(closure2422, stackframe);
  addtoclosure(closure2422, var_blocksOK);
  addtoclosure(closure2422, selfslot);
  struct UserObject *uo2422 = (struct UserObject*)block2421;
  uo2422->data[0] = (Object)closure2422;
  Method *meth_meth_parser__apply2422 = addmethod2pos(block2421, "_apply", &meth_parser__apply2422, 0);
  int argcv_meth_parser__apply2422[] = {0};
  meth_meth_parser__apply2422->type = alloc_MethodType(1, argcv_meth_parser__apply2422);
  meth_meth_parser__apply2422->definitionModule = modulename;
  meth_meth_parser__apply2422->definitionLine = 3399;
// compiled block node returning block2421 (depth = 9)
  gc_frame_newslot(block2421);
// call case 4: self request
  params[0] = block2421;
  partcv[0] = 1;
  Object call2426 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2420);
// compiled call node returning call2426 (depth = 8)
  Object call2427 = callmethodflags(call2426, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2419);
// compiled member node returning call2427 (depth = 7)
  Object if2418 = done;
  if (istrue(call2427)) {
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2428 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2429 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call2430 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2429);
// compiled member node returning call2430 (depth = 9)
  Object call2431 = callmethodflags(call2430, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2428);
// compiled member node returning call2431 (depth = 8)
  *var_suggestion = call2431;
  if (call2431 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2432 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2433 = alloc_Block(NULL, NULL, "parser", 783);
  gc_frame_newslot(block2433);
// method "_apply(_)"
  block_savedest(block2433);
  Object closure2434 = createclosure(2, "_apply(1)");
  setclosureframe(closure2434, stackframe);
  addtoclosure(closure2434, var_lastToken);
  addtoclosure(closure2434, selfslot);
  struct UserObject *uo2434 = (struct UserObject*)block2433;
  uo2434->data[0] = (Object)closure2434;
  Method *meth_meth_parser__apply_40_1_41_2434 = addmethod2pos(block2433, "_apply(1)", &meth_parser__apply_40_1_41_2434, 0);
  int argcv_meth_parser__apply_40_1_41_2434[] = {1};
  meth_meth_parser__apply_40_1_41_2434->type = alloc_MethodType(1, argcv_meth_parser__apply_40_1_41_2434);
  meth_meth_parser__apply_40_1_41_2434->definitionModule = modulename;
  meth_meth_parser__apply_40_1_41_2434->definitionLine = 3399;
// compiled block node returning block2433 (depth = 9)
  gc_frame_newslot(block2433);
// call case 4: self request
  params[0] = block2433;
  partcv[0] = 1;
  Object call2452 = callmethodflags(self, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2432);
// compiled call node returning call2452 (depth = 8)
  *var_nextTok = call2452;
  if (call2452 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_right_2454 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 9)
  Object bool2456 = alloc_Boolean(0);
// compiled identifier node returning bool2456 (depth = 9)
  int op_slot_left_2454 = gc_frame_newslot(bool2456);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult2457 = callmethod(bool2456, "==(1)", 1, partcv, params);
// compiled op node returning opresult2457 (depth = 8)
  Object if2453 = done;
  if (istrue(opresult2457)) {
// Begin line 786
  setline(786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2458 = gc_frame_new();
// starting to compile array node (depth = 10)
  Object array2459 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 11)
  if (strlit2460 == NULL) {
    strlit2460 = alloc_String("rbrace");
    gc_root(strlit2460);
  }
// compiled string node returning strlit2460 (depth = 11)
  params[0] = strlit2460;
  partcv[0] = 1;
  callmethodflags(array2459, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array2459 (depth = 10)
  gc_frame_newslot(array2459);
// call case 4: self request
  params[0] = array2459;
  partcv[0] = 1;
  Object call2461 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2458);
// compiled call node returning call2461 (depth = 9)
  *var_nextTok = call2461;
  if (call2461 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_2464 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_2464 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2466 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult2466 (depth = 9)
  Object if2463 = done;
  if (istrue(opresult2466)) {
// Begin line 788
  setline(788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2467 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2468 == NULL) {
    strlit2468 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"" } then {");
    gc_root(strlit2468);
  }
// compiled string node returning strlit2468 (depth = 10)
  gc_frame_newslot(strlit2468);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2468;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2469 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2467);
// compiled call node returning call2469 (depth = 9)
    gc_frame_newslot(call2469);
    if2463 = call2469;
  } else {
// Begin line 790
  setline(790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2470 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
  int callframe2471 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  Object call2472 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe2471);
// compiled member node returning call2472 (depth = 10)
  gc_frame_newslot(call2472);
// starting to compile identifier node (depth = 10)
  Object bool2473 = alloc_Boolean(1);
// compiled identifier node returning bool2473 (depth = 10)
  gc_frame_newslot(bool2473);
// starting to compile identifier node (depth = 10)
  Object bool2474 = alloc_Boolean(0);
// compiled identifier node returning bool2474 (depth = 10)
  gc_frame_newslot(bool2474);
// starting to compile string node (depth = 10)
  if (strlit2475 == NULL) {
    strlit2475 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"" } then {");
    gc_root(strlit2475);
  }
// compiled string node returning strlit2475 (depth = 10)
  gc_frame_newslot(strlit2475);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call2472;
  params[2] = bool2473;
  params[3] = bool2474;
  params[4] = strlit2475;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2476 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2470);
// compiled call node returning call2476 (depth = 9)
    gc_frame_newslot(call2476);
    if2463 = call2476;
  }
// compiled if node returning if2463 (depth = 8)
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2477 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2478 == NULL) {
    strlit2478 = alloc_String("an elseif statement must have an expression in braces after the 'elseif'.");
    gc_root(strlit2478);
  }
// compiled string node returning strlit2478 (depth = 9)
  gc_frame_newslot(strlit2478);
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe2479 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call2480 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2479);
// compiled member node returning call2480 (depth = 9)
  gc_frame_newslot(call2480);
// starting to compile member node (depth = 9)
  int callframe2481 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call2482 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2481);
// compiled member node returning call2482 (depth = 9)
  gc_frame_newslot(call2482);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit2478;
  params[1] = call2480;
  params[2] = call2482;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2483 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2477);
// compiled call node returning call2483 (depth = 8)
    gc_frame_newslot(call2483);
    if2453 = call2483;
  } else {
// Begin line 795
  setline(795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_2485 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_2485 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2487 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult2487 (depth = 9)
  Object if2484 = done;
  if (istrue(opresult2487)) {
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2488 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2489 == NULL) {
    strlit2489 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2489);
  }
// compiled string node returning strlit2489 (depth = 10)
  gc_frame_newslot(strlit2489);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2489;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2490 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2488);
// compiled call node returning call2490 (depth = 9)
// Begin line 797
  setline(797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2491 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2492 == NULL) {
    strlit2492 = alloc_String("an elseif statement must have an expression in braces after the 'elseif'.");
    gc_root(strlit2492);
  }
// compiled string node returning strlit2492 (depth = 10)
  gc_frame_newslot(strlit2492);
// Begin line 798
  setline(798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe2493 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call2494 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2493);
// compiled member node returning call2494 (depth = 10)
  gc_frame_newslot(call2494);
// starting to compile member node (depth = 10)
  int callframe2495 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call2496 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2495);
// compiled member node returning call2496 (depth = 10)
  gc_frame_newslot(call2496);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 797
  setline(797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2492;
  params[1] = call2494;
  params[2] = call2496;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2497 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2491);
// compiled call node returning call2497 (depth = 9)
    gc_frame_newslot(call2497);
    if2484 = call2497;
  } else {
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2498 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
  int callframe2499 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  Object call2500 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe2499);
// compiled member node returning call2500 (depth = 10)
  gc_frame_newslot(call2500);
// starting to compile identifier node (depth = 10)
  Object bool2501 = alloc_Boolean(0);
// compiled identifier node returning bool2501 (depth = 10)
  gc_frame_newslot(bool2501);
// starting to compile identifier node (depth = 10)
  Object bool2502 = alloc_Boolean(1);
// compiled identifier node returning bool2502 (depth = 10)
  gc_frame_newslot(bool2502);
// starting to compile string node (depth = 10)
  if (strlit2503 == NULL) {
    strlit2503 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2503);
  }
// compiled string node returning strlit2503 (depth = 10)
  gc_frame_newslot(strlit2503);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call2500;
  params[2] = bool2501;
  params[3] = bool2502;
  params[4] = strlit2503;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2504 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2498);
// compiled call node returning call2504 (depth = 9)
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2505 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2506 == NULL) {
    strlit2506 = alloc_String("4: An elseif statement must have an expression in braces after the 'elseif'.");
    gc_root(strlit2506);
  }
// compiled string node returning strlit2506 (depth = 10)
  gc_frame_newslot(strlit2506);
// Begin line 803
  setline(803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe2507 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call2508 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2507);
// compiled member node returning call2508 (depth = 10)
  gc_frame_newslot(call2508);
// starting to compile member node (depth = 10)
  int callframe2509 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call2510 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2509);
// compiled member node returning call2510 (depth = 10)
  gc_frame_newslot(call2510);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2512 = alloc_Float64(1);
// compiled num node returning num2512 (depth = 11)
  int op_slot_right_2511 = gc_frame_newslot(num2512);
// starting to compile member node (depth = 11)
  int callframe2514 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  Object call2515 = callmethodflags(*var_nextTok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2514);
// compiled member node returning call2515 (depth = 11)
  int op_slot_left_2511 = gc_frame_newslot(call2515);
  params[0] = num2512;
  partcv[0] = 1;
  Object diff2516 = callmethod(call2515, "-(1)", 1, partcv, params);
// compiled op node returning diff2516 (depth = 10)
  gc_frame_newslot(diff2516);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2506;
  params[1] = call2508;
  params[2] = call2510;
  params[3] = diff2516;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2517 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2505);
// compiled call node returning call2517 (depth = 9)
    gc_frame_newslot(call2517);
    if2484 = call2517;
  }
// compiled if node returning if2484 (depth = 8)
    gc_frame_newslot(if2484);
    if2453 = if2484;
  }
// compiled if node returning if2453 (depth = 7)
    gc_frame_newslot(if2453);
    if2418 = if2453;
  } else {
  }
// compiled if node returning if2418 (depth = 6)
// Begin line 807
  setline(807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2520 == NULL) {
    strlit2520 = alloc_String("}");
    gc_root(strlit2520);
  }
// compiled string node returning strlit2520 (depth = 8)
  int op_slot_right_2519 = gc_frame_newslot(strlit2520);
// starting to compile member node (depth = 8)
  int callframe2522 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2523 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe2522);
// compiled member node returning call2523 (depth = 8)
  int op_slot_left_2519 = gc_frame_newslot(call2523);
  params[0] = strlit2520;
  partcv[0] = 1;
  Object opresult2524 = callmethod(call2523, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2524 (depth = 7)
  Object if2518 = done;
  if (istrue(opresult2524)) {
// Begin line 808
  setline(808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe2525 = gc_frame_new();
// call case 4: self request
  Object call2526 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2525);
// compiled member node returning call2526 (depth = 7)
// Begin line 809
  setline(809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2527 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2528 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call2529 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2528);
// compiled member node returning call2529 (depth = 9)
  Object call2530 = callmethodflags(call2529, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2527);
// compiled member node returning call2530 (depth = 8)
  *var_suggestion = call2530;
  if (call2530 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 810
  setline(810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2531 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2532 == NULL) {
    strlit2532 = alloc_String(")");
    gc_root(strlit2532);
  }
// compiled string node returning strlit2532 (depth = 8)
  gc_frame_newslot(strlit2532);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit2532;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2533 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2531);
// compiled call node returning call2533 (depth = 7)
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2534 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 812
  setline(812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2536 == NULL) {
    strlit2536 = alloc_String("'{' must end with a '}'.");
    gc_root(strlit2536);
  }
// compiled string node returning strlit2536 (depth = 9)
  int op_slot_right_2535 = gc_frame_newslot(strlit2536);
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2538 == NULL) {
    strlit2538 = alloc_String("a condition beginning with a ");
    gc_root(strlit2538);
  }
// compiled string node returning strlit2538 (depth = 9)
  int op_slot_left_2535 = gc_frame_newslot(strlit2538);
  params[0] = strlit2536;
  partcv[0] = 1;
  Object opresult2539 = callmethod(strlit2538, "++(1)", 1, partcv, params);
// compiled op node returning opresult2539 (depth = 8)
  gc_frame_newslot(opresult2539);
// Begin line 813
  setline(813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe2540 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call2541 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2540);
// compiled member node returning call2541 (depth = 8)
  gc_frame_newslot(call2541);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2543 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call2544 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2543);
// compiled member node returning call2544 (depth = 9)
  int op_slot_right_2542 = gc_frame_newslot(call2544);
// starting to compile member node (depth = 9)
  int callframe2546 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call2547 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2546);
// compiled member node returning call2547 (depth = 9)
  int op_slot_left_2542 = gc_frame_newslot(call2547);
  params[0] = call2544;
  partcv[0] = 1;
  Object sum2548 = callmethod(call2547, "+(1)", 1, partcv, params);
// compiled op node returning sum2548 (depth = 8)
  gc_frame_newslot(sum2548);
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2539;
  params[1] = call2541;
  params[2] = sum2548;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2549 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2534);
// compiled call node returning call2549 (depth = 7)
    gc_frame_newslot(call2549);
    if2518 = call2549;
  } else {
  }
// compiled if node returning if2518 (depth = 6)
// Begin line 816
  setline(816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2550 = gc_frame_new();
// call case 4: self request
  Object call2551 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2550);
// compiled member node returning call2551 (depth = 6)
// Begin line 817
  setline(817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2552 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call2553 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe2552);
// compiled member node returning call2553 (depth = 7)
  *var_econd = call2553;
  if (call2553 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2558 == NULL) {
    strlit2558 = alloc_String("then");
    gc_root(strlit2558);
  }
// compiled string node returning strlit2558 (depth = 9)
  int op_slot_right_2557 = gc_frame_newslot(strlit2558);
// starting to compile member node (depth = 9)
  int callframe2560 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call2561 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe2560);
// compiled member node returning call2561 (depth = 9)
  int op_slot_left_2557 = gc_frame_newslot(call2561);
  params[0] = strlit2558;
  partcv[0] = 1;
  Object opresult2562 = callmethod(call2561, "==(1)", 1, partcv, params);
// compiled op node returning opresult2562 (depth = 8)
  int op_slot_right_2556 = gc_frame_newslot(opresult2562);
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2564 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2565 == NULL) {
    strlit2565 = alloc_String("identifier");
    gc_root(strlit2565);
  }
// compiled string node returning strlit2565 (depth = 9)
  gc_frame_newslot(strlit2565);
// call case 4: self request
  params[0] = strlit2565;
  partcv[0] = 1;
  Object call2566 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2564);
// compiled call node returning call2566 (depth = 8)
  int op_slot_left_2556 = gc_frame_newslot(call2566);
  params[0] = opresult2562;
  partcv[0] = 1;
  Object opresult2567 = callmethod(call2566, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2567 (depth = 7)
  Object if2555 = done;
  if (istrue(opresult2567)) {
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe2568 = gc_frame_new();
// call case 4: self request
  Object call2569 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2568);
// compiled member node returning call2569 (depth = 7)
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile array node (depth = 8)
  Object array2570 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2570 (depth = 8)
  *var_ebody = array2570;
  if (array2570 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2555 = done;
  } else {
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2572 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2573 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call2574 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2573);
// compiled member node returning call2574 (depth = 9)
  Object call2575 = callmethodflags(call2574, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2572);
// compiled member node returning call2575 (depth = 8)
  *var_suggestion = call2575;
  if (call2575 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2578 == NULL) {
    strlit2578 = alloc_String("lbrace");
    gc_root(strlit2578);
  }
// compiled string node returning strlit2578 (depth = 9)
  int op_slot_right_2577 = gc_frame_newslot(strlit2578);
// starting to compile member node (depth = 9)
  int callframe2580 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call2581 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2580);
// compiled member node returning call2581 (depth = 9)
  int op_slot_left_2577 = gc_frame_newslot(call2581);
  params[0] = strlit2578;
  partcv[0] = 1;
  Object opresult2582 = callmethod(call2581, "==(1)", 1, partcv, params);
// compiled op node returning opresult2582 (depth = 8)
  Object if2576 = done;
  if (istrue(opresult2582)) {
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2583 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_statementToken (depth = 10)
  gc_frame_newslot(*var_statementToken);
// starting to compile identifier node (depth = 10)
  Object bool2584 = alloc_Boolean(0);
// compiled identifier node returning bool2584 (depth = 10)
  gc_frame_newslot(bool2584);
// call case 4: self request
  params[0] = *var_statementToken;
  params[1] = bool2584;
  partcv[0] = 2;
  Object call2585 = callmethodflags(self, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2583);
// compiled call node returning call2585 (depth = 9)
  *var_closingBrace = call2585;
  if (call2585 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 826
  setline(826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2587 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2588 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  Object call2589 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe2588);
// compiled member node returning call2589 (depth = 10)
  Object call2590 = callmethodflags(call2589, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2587);
// compiled member node returning call2590 (depth = 9)
  Object if2586 = done;
  if (istrue(call2590)) {
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_2592 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 11)
  int callframe2594 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  Object call2595 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2594);
// compiled member node returning call2595 (depth = 11)
  int op_slot_left_2592 = gc_frame_newslot(call2595);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2596 = callmethod(call2595, "==(1)", 1, partcv, params);
// compiled op node returning opresult2596 (depth = 10)
  Object if2591 = done;
  if (istrue(opresult2596)) {
// Begin line 828
  setline(828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2597 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
  Object bool2598 = alloc_Boolean(1);
// compiled identifier node returning bool2598 (depth = 11)
  gc_frame_newslot(bool2598);
// starting to compile identifier node (depth = 11)
  Object bool2599 = alloc_Boolean(0);
// compiled identifier node returning bool2599 (depth = 11)
  gc_frame_newslot(bool2599);
// starting to compile string node (depth = 11)
  if (strlit2600 == NULL) {
    strlit2600 = alloc_String(" then {}");
    gc_root(strlit2600);
  }
// compiled string node returning strlit2600 (depth = 11)
  gc_frame_newslot(strlit2600);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_sym;
  params[1] = bool2598;
  params[2] = bool2599;
  params[3] = strlit2600;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2601 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2597);
// compiled call node returning call2601 (depth = 10)
    gc_frame_newslot(call2601);
    if2591 = call2601;
  } else {
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2602 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
  Object bool2603 = alloc_Boolean(1);
// compiled identifier node returning bool2603 (depth = 11)
  gc_frame_newslot(bool2603);
// starting to compile identifier node (depth = 11)
  Object bool2604 = alloc_Boolean(0);
// compiled identifier node returning bool2604 (depth = 11)
  gc_frame_newslot(bool2604);
// starting to compile string node (depth = 11)
  if (strlit2605 == NULL) {
    strlit2605 = alloc_String(" then {");
    gc_root(strlit2605);
  }
// compiled string node returning strlit2605 (depth = 11)
  gc_frame_newslot(strlit2605);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_sym;
  params[1] = bool2603;
  params[2] = bool2604;
  params[3] = strlit2605;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2606 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2602);
// compiled call node returning call2606 (depth = 10)
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2607 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2609 = alloc_Float64(0.1);
// compiled num node returning num2609 (depth = 12)
  int op_slot_right_2608 = gc_frame_newslot(num2609);
// starting to compile member node (depth = 12)
  int callframe2611 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe2612 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_closingBrace (depth = 14)
  Object call2613 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2612);
// compiled member node returning call2613 (depth = 13)
  Object call2614 = callmethodflags(call2613, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2611);
// compiled member node returning call2614 (depth = 12)
  int op_slot_left_2608 = gc_frame_newslot(call2614);
  params[0] = num2609;
  partcv[0] = 1;
  Object sum2615 = callmethod(call2614, "+(1)", 1, partcv, params);
// compiled op node returning sum2615 (depth = 11)
  gc_frame_newslot(sum2615);
// starting to compile string node (depth = 11)
  if (strlit2616 == NULL) {
    strlit2616 = alloc_String("}");
    gc_root(strlit2616);
  }
// compiled string node returning strlit2616 (depth = 11)
  gc_frame_newslot(strlit2616);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum2615;
  params[1] = strlit2616;
  partcv[0] = 2;
  Object call2617 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2607);
// compiled call node returning call2617 (depth = 10)
    gc_frame_newslot(call2617);
    if2591 = call2617;
  }
// compiled if node returning if2591 (depth = 9)
    gc_frame_newslot(if2591);
    if2586 = if2591;
  } else {
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2618 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
  Object bool2619 = alloc_Boolean(1);
// compiled identifier node returning bool2619 (depth = 10)
  gc_frame_newslot(bool2619);
// starting to compile identifier node (depth = 10)
  Object bool2620 = alloc_Boolean(0);
// compiled identifier node returning bool2620 (depth = 10)
  gc_frame_newslot(bool2620);
// starting to compile string node (depth = 10)
  if (strlit2621 == NULL) {
    strlit2621 = alloc_String(" then {");
    gc_root(strlit2621);
  }
// compiled string node returning strlit2621 (depth = 10)
  gc_frame_newslot(strlit2621);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = bool2619;
  params[2] = bool2620;
  params[3] = strlit2621;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2622 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2618);
// compiled call node returning call2622 (depth = 9)
    gc_frame_newslot(call2622);
    if2586 = call2622;
  }
// compiled if node returning if2586 (depth = 8)
    gc_frame_newslot(if2586);
    if2576 = if2586;
  } else {
// Begin line 837
  setline(837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2623 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_statementToken (depth = 10)
  gc_frame_newslot(*var_statementToken);
// starting to compile identifier node (depth = 10)
  Object bool2624 = alloc_Boolean(1);
// compiled identifier node returning bool2624 (depth = 10)
  gc_frame_newslot(bool2624);
// call case 4: self request
  params[0] = *var_statementToken;
  params[1] = bool2624;
  partcv[0] = 2;
  Object call2625 = callmethodflags(self, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2623);
// compiled call node returning call2625 (depth = 9)
  *var_closingBrace = call2625;
  if (call2625 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2627 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2628 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  Object call2629 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe2628);
// compiled member node returning call2629 (depth = 10)
  Object call2630 = callmethodflags(call2629, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2627);
// compiled member node returning call2630 (depth = 9)
  Object if2626 = done;
  if (istrue(call2630)) {
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  int op_slot_right_2632 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 11)
  int callframe2634 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  Object call2635 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2634);
// compiled member node returning call2635 (depth = 11)
  int op_slot_left_2632 = gc_frame_newslot(call2635);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2636 = callmethod(call2635, "==(1)", 1, partcv, params);
// compiled op node returning opresult2636 (depth = 10)
  Object if2631 = done;
  if (istrue(opresult2636)) {
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2637 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2638 == NULL) {
    strlit2638 = alloc_String(" then {}");
    gc_root(strlit2638);
  }
// compiled string node returning strlit2638 (depth = 11)
  gc_frame_newslot(strlit2638);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2638;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2639 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2637);
// compiled call node returning call2639 (depth = 10)
    gc_frame_newslot(call2639);
    if2631 = call2639;
  } else {
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2640 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2641 == NULL) {
    strlit2641 = alloc_String(" then {");
    gc_root(strlit2641);
  }
// compiled string node returning strlit2641 (depth = 11)
  gc_frame_newslot(strlit2641);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2641;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2642 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2640);
// compiled call node returning call2642 (depth = 10)
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2643 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2645 = alloc_Float64(0.1);
// compiled num node returning num2645 (depth = 12)
  int op_slot_right_2644 = gc_frame_newslot(num2645);
// starting to compile member node (depth = 12)
  int callframe2647 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe2648 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_closingBrace (depth = 14)
  Object call2649 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2648);
// compiled member node returning call2649 (depth = 13)
  Object call2650 = callmethodflags(call2649, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2647);
// compiled member node returning call2650 (depth = 12)
  int op_slot_left_2644 = gc_frame_newslot(call2650);
  params[0] = num2645;
  partcv[0] = 1;
  Object sum2651 = callmethod(call2650, "+(1)", 1, partcv, params);
// compiled op node returning sum2651 (depth = 11)
  gc_frame_newslot(sum2651);
// starting to compile string node (depth = 11)
  if (strlit2652 == NULL) {
    strlit2652 = alloc_String("}");
    gc_root(strlit2652);
  }
// compiled string node returning strlit2652 (depth = 11)
  gc_frame_newslot(strlit2652);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum2651;
  params[1] = strlit2652;
  partcv[0] = 2;
  Object call2653 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2643);
// compiled call node returning call2653 (depth = 10)
    gc_frame_newslot(call2653);
    if2631 = call2653;
  }
// compiled if node returning if2631 (depth = 9)
    gc_frame_newslot(if2631);
    if2626 = if2631;
  } else {
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2654 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2655 == NULL) {
    strlit2655 = alloc_String(" then {");
    gc_root(strlit2655);
  }
// compiled string node returning strlit2655 (depth = 10)
  gc_frame_newslot(strlit2655);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2655;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2656 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2654);
// compiled call node returning call2656 (depth = 9)
    gc_frame_newslot(call2656);
    if2626 = call2656;
  }
// compiled if node returning if2626 (depth = 8)
    gc_frame_newslot(if2626);
    if2576 = if2626;
  }
// compiled if node returning if2576 (depth = 7)
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2657 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2658 == NULL) {
    strlit2658 = alloc_String("an elseif statement must have 'then' after the expression in braces.");
    gc_root(strlit2658);
  }
// compiled string node returning strlit2658 (depth = 8)
  gc_frame_newslot(strlit2658);
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe2659 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2660 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2659);
// compiled member node returning call2660 (depth = 8)
  gc_frame_newslot(call2660);
// starting to compile member node (depth = 8)
  int callframe2661 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2662 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2661);
// compiled member node returning call2662 (depth = 8)
  gc_frame_newslot(call2662);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2658;
  params[1] = call2660;
  params[2] = call2662;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2663 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2657);
// compiled call node returning call2663 (depth = 7)
    gc_frame_newslot(call2663);
    if2555 = call2663;
  }
// compiled if node returning if2555 (depth = 6)
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2666 == NULL) {
    strlit2666 = alloc_String("lbrace");
    gc_root(strlit2666);
  }
// compiled string node returning strlit2666 (depth = 8)
  int op_slot_right_2665 = gc_frame_newslot(strlit2666);
// starting to compile member node (depth = 8)
  int callframe2668 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2669 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2668);
// compiled member node returning call2669 (depth = 8)
  int op_slot_left_2665 = gc_frame_newslot(call2669);
  params[0] = strlit2666;
  partcv[0] = 1;
  Object opresult2670 = callmethod(call2669, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2670 (depth = 7)
  Object if2664 = done;
  if (istrue(opresult2670)) {
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2671 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2672 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call2673 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2672);
// compiled member node returning call2673 (depth = 9)
  Object call2674 = callmethodflags(call2673, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2671);
// compiled member node returning call2674 (depth = 8)
  *var_suggestion = call2674;
  if (call2674 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2675 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 9)
  Object bool2676 = alloc_Boolean(1);
// compiled identifier node returning bool2676 (depth = 9)
  gc_frame_newslot(bool2676);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2676;
  partcv[0] = 2;
  Object call2677 = callmethodflags(self, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2675);
// compiled call node returning call2677 (depth = 8)
  *var_closingBrace = call2677;
  if (call2677 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2679 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2680 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  Object call2681 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe2680);
// compiled member node returning call2681 (depth = 9)
  Object call2682 = callmethodflags(call2681, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2679);
// compiled member node returning call2682 (depth = 8)
  Object if2678 = done;
  if (istrue(call2682)) {
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  int op_slot_right_2684 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 10)
  int callframe2686 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  Object call2687 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2686);
// compiled member node returning call2687 (depth = 10)
  int op_slot_left_2684 = gc_frame_newslot(call2687);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2688 = callmethod(call2687, "==(1)", 1, partcv, params);
// compiled op node returning opresult2688 (depth = 9)
  Object if2683 = done;
  if (istrue(opresult2688)) {
// Begin line 857
  setline(857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2689 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 10)
  Object bool2690 = alloc_Boolean(0);
// compiled identifier node returning bool2690 (depth = 10)
  gc_frame_newslot(bool2690);
// starting to compile identifier node (depth = 10)
  Object bool2691 = alloc_Boolean(1);
// compiled identifier node returning bool2691 (depth = 10)
  gc_frame_newslot(bool2691);
// starting to compile string node (depth = 10)
  if (strlit2692 == NULL) {
    strlit2692 = alloc_String("then {}");
    gc_root(strlit2692);
  }
// compiled string node returning strlit2692 (depth = 10)
  gc_frame_newslot(strlit2692);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  params[1] = bool2690;
  params[2] = bool2691;
  params[3] = strlit2692;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2693 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2689);
// compiled call node returning call2693 (depth = 9)
    gc_frame_newslot(call2693);
    if2683 = call2693;
  } else {
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2694 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2696 = alloc_Float64(0.1);
// compiled num node returning num2696 (depth = 11)
  int op_slot_right_2695 = gc_frame_newslot(num2696);
// starting to compile member node (depth = 11)
  int callframe2698 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe2699 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  Object call2700 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2699);
// compiled member node returning call2700 (depth = 12)
  Object call2701 = callmethodflags(call2700, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2698);
// compiled member node returning call2701 (depth = 11)
  int op_slot_left_2695 = gc_frame_newslot(call2701);
  params[0] = num2696;
  partcv[0] = 1;
  Object sum2702 = callmethod(call2701, "+(1)", 1, partcv, params);
// compiled op node returning sum2702 (depth = 10)
  gc_frame_newslot(sum2702);
// starting to compile string node (depth = 10)
  if (strlit2703 == NULL) {
    strlit2703 = alloc_String("}");
    gc_root(strlit2703);
  }
// compiled string node returning strlit2703 (depth = 10)
  gc_frame_newslot(strlit2703);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = sum2702;
  params[1] = strlit2703;
  partcv[0] = 2;
  Object call2704 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2694);
// compiled call node returning call2704 (depth = 9)
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2705 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 10)
  Object bool2706 = alloc_Boolean(0);
// compiled identifier node returning bool2706 (depth = 10)
  gc_frame_newslot(bool2706);
// starting to compile identifier node (depth = 10)
  Object bool2707 = alloc_Boolean(1);
// compiled identifier node returning bool2707 (depth = 10)
  gc_frame_newslot(bool2707);
// starting to compile string node (depth = 10)
  if (strlit2708 == NULL) {
    strlit2708 = alloc_String("then {");
    gc_root(strlit2708);
  }
// compiled string node returning strlit2708 (depth = 10)
  gc_frame_newslot(strlit2708);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  params[1] = bool2706;
  params[2] = bool2707;
  params[3] = strlit2708;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2709 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2705);
// compiled call node returning call2709 (depth = 9)
    gc_frame_newslot(call2709);
    if2683 = call2709;
  }
// compiled if node returning if2683 (depth = 8)
    gc_frame_newslot(if2683);
    if2678 = if2683;
  } else {
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2710 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool2711 = alloc_Boolean(0);
// compiled identifier node returning bool2711 (depth = 9)
  gc_frame_newslot(bool2711);
// starting to compile identifier node (depth = 9)
  Object bool2712 = alloc_Boolean(1);
// compiled identifier node returning bool2712 (depth = 9)
  gc_frame_newslot(bool2712);
// starting to compile string node (depth = 9)
  if (strlit2713 == NULL) {
    strlit2713 = alloc_String("then {");
    gc_root(strlit2713);
  }
// compiled string node returning strlit2713 (depth = 9)
  gc_frame_newslot(strlit2713);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool2711;
  params[2] = bool2712;
  params[3] = strlit2713;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2714 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2710);
// compiled call node returning call2714 (depth = 8)
    gc_frame_newslot(call2714);
    if2678 = call2714;
  }
// compiled if node returning if2678 (depth = 7)
// Begin line 865
  setline(865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2715 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2716 == NULL) {
    strlit2716 = alloc_String("an elseif statement must have a '{' after the 'then'.");
    gc_root(strlit2716);
  }
// compiled string node returning strlit2716 (depth = 8)
  gc_frame_newslot(strlit2716);
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe2717 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call2718 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2717);
// compiled member node returning call2718 (depth = 8)
  gc_frame_newslot(call2718);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2720 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call2721 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2720);
// compiled member node returning call2721 (depth = 9)
  int op_slot_right_2719 = gc_frame_newslot(call2721);
// starting to compile member node (depth = 9)
  int callframe2723 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call2724 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2723);
// compiled member node returning call2724 (depth = 9)
  int op_slot_left_2719 = gc_frame_newslot(call2724);
  params[0] = call2721;
  partcv[0] = 1;
  Object sum2725 = callmethod(call2724, "+(1)", 1, partcv, params);
// compiled op node returning sum2725 (depth = 8)
  gc_frame_newslot(sum2725);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 865
  setline(865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2716;
  params[1] = call2718;
  params[2] = sum2725;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2726 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2715);
// compiled call node returning call2726 (depth = 7)
    gc_frame_newslot(call2726);
    if2664 = call2726;
  } else {
  }
// compiled if node returning if2664 (depth = 6)
// Begin line 868
  setline(868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2727 = gc_frame_new();
// call case 4: self request
  Object call2728 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2727);
// compiled member node returning call2728 (depth = 6)
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2731 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call2732 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2731);
// compiled member node returning call2732 (depth = 8)
  int op_slot_right_2730 = gc_frame_newslot(call2732);
// starting to compile member node (depth = 8)
  int callframe2734 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2735 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2734);
// compiled member node returning call2735 (depth = 8)
  int op_slot_left_2730 = gc_frame_newslot(call2735);
  params[0] = call2732;
  partcv[0] = 1;
  Object opresult2736 = callmethod(call2735, "==(1)", 1, partcv, params);
// compiled op node returning opresult2736 (depth = 7)
  Object if2729 = done;
  if (istrue(opresult2736)) {
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2738 = alloc_Float64(1);
// compiled num node returning num2738 (depth = 9)
  int op_slot_right_2737 = gc_frame_newslot(num2738);
// starting to compile member node (depth = 9)
  int callframe2740 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call2741 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2740);
// compiled member node returning call2741 (depth = 9)
  int op_slot_left_2737 = gc_frame_newslot(call2741);
  params[0] = num2738;
  partcv[0] = 1;
  Object diff2742 = callmethod(call2741, "-(1)", 1, partcv, params);
// compiled op node returning diff2742 (depth = 8)
  *var_minIndentLevel = diff2742;
  if (diff2742 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2729 = done;
  } else {
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_minInd (depth = 8)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2729 = done;
  }
// compiled if node returning if2729 (depth = 6)
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2745 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block2746 = alloc_Block(NULL, NULL, "parser", 874);
  gc_frame_newslot(block2746);
// method "_apply"
  block_savedest(block2746);
  Object closure2747 = createclosure(1, "_apply");
  setclosureframe(closure2747, stackframe);
  addtoclosure(closure2747, selfslot);
  struct UserObject *uo2747 = (struct UserObject*)block2746;
  uo2747->data[0] = (Object)closure2747;
  Method *meth_meth_parser__apply2747 = addmethod2pos(block2746, "_apply", &meth_parser__apply2747, 0);
  int argcv_meth_parser__apply2747[] = {0};
  meth_meth_parser__apply2747->type = alloc_MethodType(1, argcv_meth_parser__apply2747);
  meth_meth_parser__apply2747->definitionModule = modulename;
  meth_meth_parser__apply2747->definitionLine = 3399;
// compiled block node returning block2746 (depth = 7)
  gc_frame_newslot(block2746);
// starting to compile block node (depth = 7)
  Object block2754 = alloc_Block(NULL, NULL, "parser", 874);
  gc_frame_newslot(block2754);
// method "_apply"
  block_savedest(block2754);
  Object closure2755 = createclosure(8, "_apply");
  setclosureframe(closure2755, stackframe);
  addtoclosure(closure2755, var_errormessages);
  addtoclosure(closure2755, var_btok);
  addtoclosure(closure2755, var_lastToken);
  addtoclosure(closure2755, var_sym);
  addtoclosure(closure2755, var_values);
  addtoclosure(closure2755, var_v);
  addtoclosure(closure2755, var_ebody);
  addtoclosure(closure2755, selfslot);
  struct UserObject *uo2755 = (struct UserObject*)block2754;
  uo2755->data[0] = (Object)closure2755;
  Method *meth_meth_parser__apply2755 = addmethod2pos(block2754, "_apply", &meth_parser__apply2755, 0);
  int argcv_meth_parser__apply2755[] = {0};
  meth_meth_parser__apply2755->type = alloc_MethodType(1, argcv_meth_parser__apply2755);
  meth_meth_parser__apply2755->definitionModule = modulename;
  meth_meth_parser__apply2755->definitionLine = 3399;
// compiled block node returning block2754 (depth = 7)
  gc_frame_newslot(block2754);
// call case 5: prelude request
  params[0] = block2746;
  params[1] = block2754;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2813 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2745);
// compiled call node returning call2813 (depth = 6)
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2814 = gc_frame_new();
// call case 4: self request
  Object call2815 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2814);
// compiled member node returning call2815 (depth = 6)
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile array node (depth = 7)
  Object array2816 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2816 (depth = 7)
  *var_newelse = array2816;
  if (array2816 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2818 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_econd (depth = 8)
  gc_frame_newslot(*var_econd);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ebody (depth = 8)
  gc_frame_newslot(*var_ebody);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newelse (depth = 8)
  gc_frame_newslot(*var_newelse);
// call case 4: self request
  params[0] = *var_econd;
  params[1] = *var_ebody;
  params[2] = *var_newelse;
  partcv[0] = 3;
  Object call2819 = callmethodflags(self, "newIf(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2818);
// compiled call node returning call2819 (depth = 7)
  *var_eif = call2819;
  if (call2819 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2821 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_eif (depth = 7)
  gc_frame_newslot(*var_eif);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_curelse (depth = 7)
  params[0] = *var_eif;
  partcv[0] = 1;
  Object call2822 = callmethodflags(*var_curelse, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2821);
// compiled call node returning call2822 (depth = 6)
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newelse (depth = 7)
  *var_curelse = *var_newelse;
  if (*var_newelse == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply2924(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
  int callframe2925 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe2926 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2927 == NULL) {
    strlit2927 = alloc_String("rbrace");
    gc_root(strlit2927);
  }
// compiled string node returning strlit2927 (depth = 9)
  gc_frame_newslot(strlit2927);
// call case 4: self request
  params[0] = strlit2927;
  partcv[0] = 1;
  Object call2928 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2926);
// compiled call node returning call2928 (depth = 8)
  Object call2929 = callmethodflags(call2928, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2925);
// compiled member node returning call2929 (depth = 7)
  gc_frame_end(frame);
  return call2929;
}
Object meth_parser__apply2937(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 11)
  int callframe2938 = gc_frame_new();
// call case 4: self request
  Object call2939 = callmethodflags(self, "statement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2938);
// compiled member node returning call2939 (depth = 11)
  gc_frame_end(frame);
  return call2939;
}
Object meth_parser__apply2932(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_curelse = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// Begin line 929
  setline(929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2934 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 9)
  int callframe2935 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block2936 = alloc_Block(NULL, NULL, "parser", 929);
  gc_frame_newslot(block2936);
// method "_apply"
  block_savedest(block2936);
  Object closure2937 = createclosure(1, "_apply");
  setclosureframe(closure2937, stackframe);
  addtoclosure(closure2937, selfslot);
  struct UserObject *uo2937 = (struct UserObject*)block2936;
  uo2937->data[0] = (Object)closure2937;
  Method *meth_meth_parser__apply2937 = addmethod2pos(block2936, "_apply", &meth_parser__apply2937, 0);
  int argcv_meth_parser__apply2937[] = {0};
  meth_meth_parser__apply2937->type = alloc_MethodType(1, argcv_meth_parser__apply2937);
  meth_meth_parser__apply2937->definitionModule = modulename;
  meth_meth_parser__apply2937->definitionLine = 3399;
// compiled block node returning block2936 (depth = 10)
  gc_frame_newslot(block2936);
// call case 4: self request
  params[0] = block2936;
  partcv[0] = 1;
  Object call2941 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2935);
// compiled call node returning call2941 (depth = 9)
  Object call2942 = callmethodflags(call2941, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2934);
// compiled member node returning call2942 (depth = 8)
  Object if2933 = done;
  if (istrue(call2942)) {
// Begin line 930
  setline(930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2943 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2944 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call2945 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2944);
// compiled member node returning call2945 (depth = 10)
  Object call2946 = callmethodflags(call2945, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2943);
// compiled member node returning call2946 (depth = 9)
  *var_suggestion = call2946;
  if (call2946 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2947 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_btok (depth = 10)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 10)
  Object bool2948 = alloc_Boolean(0);
// compiled identifier node returning bool2948 (depth = 10)
  gc_frame_newslot(bool2948);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2948;
  partcv[0] = 2;
  Object call2949 = callmethodflags(self, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2947);
// compiled call node returning call2949 (depth = 9)
  *var_closingBrace = call2949;
  if (call2949 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe2951 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2952 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  Object call2953 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe2952);
// compiled member node returning call2953 (depth = 10)
  Object call2954 = callmethodflags(call2953, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2951);
// compiled member node returning call2954 (depth = 9)
  Object if2950 = done;
  if (istrue(call2954)) {
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  int op_slot_right_2956 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 11)
  int callframe2958 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  Object call2959 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2958);
// compiled member node returning call2959 (depth = 11)
  int op_slot_left_2956 = gc_frame_newslot(call2959);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2960 = callmethod(call2959, "==(1)", 1, partcv, params);
// compiled op node returning opresult2960 (depth = 10)
  Object if2955 = done;
  if (istrue(opresult2960)) {
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2961 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2962 == NULL) {
    strlit2962 = alloc_String("}");
    gc_root(strlit2962);
  }
// compiled string node returning strlit2962 (depth = 11)
  gc_frame_newslot(strlit2962);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2962;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2963 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2961);
// compiled call node returning call2963 (depth = 10)
    gc_frame_newslot(call2963);
    if2955 = call2963;
  } else {
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2964 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2966 = alloc_Float64(0.1);
// compiled num node returning num2966 (depth = 12)
  int op_slot_right_2965 = gc_frame_newslot(num2966);
// starting to compile member node (depth = 12)
  int callframe2968 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe2969 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_closingBrace (depth = 14)
  Object call2970 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2969);
// compiled member node returning call2970 (depth = 13)
  Object call2971 = callmethodflags(call2970, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2968);
// compiled member node returning call2971 (depth = 12)
  int op_slot_left_2965 = gc_frame_newslot(call2971);
  params[0] = num2966;
  partcv[0] = 1;
  Object sum2972 = callmethod(call2971, "+(1)", 1, partcv, params);
// compiled op node returning sum2972 (depth = 11)
  gc_frame_newslot(sum2972);
// starting to compile string node (depth = 11)
  if (strlit2973 == NULL) {
    strlit2973 = alloc_String("}");
    gc_root(strlit2973);
  }
// compiled string node returning strlit2973 (depth = 11)
  gc_frame_newslot(strlit2973);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum2972;
  params[1] = strlit2973;
  partcv[0] = 2;
  Object call2974 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2964);
// compiled call node returning call2974 (depth = 10)
    gc_frame_newslot(call2974);
    if2955 = call2974;
  }
// compiled if node returning if2955 (depth = 9)
    gc_frame_newslot(if2955);
    if2950 = if2955;
  } else {
  }
// compiled if node returning if2950 (depth = 8)
// Begin line 939
  setline(939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2975 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call2976 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2975);
// compiled call node returning call2976 (depth = 8)
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2977 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2978 == NULL) {
    strlit2978 = alloc_String("an else statement must end with a '}'.");
    gc_root(strlit2978);
  }
// compiled string node returning strlit2978 (depth = 9)
  gc_frame_newslot(strlit2978);
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe2979 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call2980 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2979);
// compiled member node returning call2980 (depth = 9)
  gc_frame_newslot(call2980);
// starting to compile member node (depth = 9)
  int callframe2981 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call2982 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2981);
// compiled member node returning call2982 (depth = 9)
  gc_frame_newslot(call2982);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit2978;
  params[1] = call2980;
  params[2] = call2982;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2983 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2977);
// compiled call node returning call2983 (depth = 8)
    gc_frame_newslot(call2983);
    if2933 = call2983;
  } else {
  }
// compiled if node returning if2933 (depth = 7)
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2984 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  Object call2985 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe2984);
// compiled member node returning call2985 (depth = 8)
  *var_v = call2985;
  if (call2985 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2987 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_curelse (depth = 8)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2988 = callmethodflags(*var_curelse, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2987);
// compiled call node returning call2988 (depth = 7)
  gc_frame_end(frame);
  return call2988;
}
Object meth_parser_doif1719(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(29, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doif");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_minIndentLevel = getfromclosure(closure, 5);
  Object *var_statementIndent = getfromclosure(closure, 6);
  Object *var_statementToken = getfromclosure(closure, 7);
  Object *var_util = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_opener = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "opener");
  Object *var_closer = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "closer");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
  Object *var_cond = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cond");
  Object *var_body = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "body");
  Object *var_elseblock = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "elseblock");
  Object *var_curelse = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "curelse");
  Object *var_v = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "v");
  Object *var_localMin = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "localMin");
  Object *var_localStatementIndent = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "localStatementIndent");
  Object *var_minInd = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "minInd");
  Object *var_closingBrace = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "closingBrace");
  Object *var_econd = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "econd");
  Object *var_eif = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "eif");
  Object *var_newelse = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "newelse");
  Object *var_ebody = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "ebody");
  Object *var_o = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "o");
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1723 == NULL) {
    strlit1723 = alloc_String("if");
    gc_root(strlit1723);
  }
// compiled string node returning strlit1723 (depth = 5)
  int op_slot_right_1722 = gc_frame_newslot(strlit1723);
// starting to compile member node (depth = 5)
  int callframe1725 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1726 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe1725);
// compiled member node returning call1726 (depth = 5)
  int op_slot_left_1722 = gc_frame_newslot(call1726);
  params[0] = strlit1723;
  partcv[0] = 1;
  Object opresult1727 = callmethod(call1726, "==(1)", 1, partcv, params);
// compiled op node returning opresult1727 (depth = 4)
  int op_slot_right_1721 = gc_frame_newslot(opresult1727);
// starting to compile call node (depth = 4)
  int callframe1729 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1730 == NULL) {
    strlit1730 = alloc_String("identifier");
    gc_root(strlit1730);
  }
// compiled string node returning strlit1730 (depth = 5)
  gc_frame_newslot(strlit1730);
// call case 4: self request
  params[0] = strlit1730;
  partcv[0] = 1;
  Object call1731 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1729);
// compiled call node returning call1731 (depth = 4)
  int op_slot_left_1721 = gc_frame_newslot(call1731);
  params[0] = opresult1727;
  partcv[0] = 1;
  Object opresult1732 = callmethod(call1731, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1732 (depth = 3)
  Object if1720 = done;
  if (istrue(opresult1732)) {
// Begin line 594
  setline(594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1733 = gc_frame_new();
// call case 4: self request
  Object call1734 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1733);
// compiled member node returning call1734 (depth = 3)
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block1737 = alloc_Block(NULL, NULL, "parser", 596);
  gc_frame_newslot(block1737);
// method "_apply"
  block_savedest(block1737);
  Object closure1738 = createclosure(2, "_apply");
  setclosureframe(closure1738, stackframe);
  addtoclosure(closure1738, var_sym);
  addtoclosure(closure1738, selfslot);
  struct UserObject *uo1738 = (struct UserObject*)block1737;
  uo1738->data[0] = (Object)closure1738;
  Method *meth_meth_parser__apply1738 = addmethod2pos(block1737, "_apply", &meth_parser__apply1738, 0);
  int argcv_meth_parser__apply1738[] = {0};
  meth_meth_parser__apply1738->type = alloc_MethodType(1, argcv_meth_parser__apply1738);
  meth_meth_parser__apply1738->definitionModule = modulename;
  meth_meth_parser__apply1738->definitionLine = 3399;
// compiled block node returning block1737 (depth = 6)
  int op_slot_right_1736 = gc_frame_newslot(block1737);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1748 == NULL) {
    strlit1748 = alloc_String("lparen");
    gc_root(strlit1748);
  }
// compiled string node returning strlit1748 (depth = 7)
  int op_slot_right_1747 = gc_frame_newslot(strlit1748);
// starting to compile member node (depth = 7)
  int callframe1750 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call1751 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1750);
// compiled member node returning call1751 (depth = 7)
  int op_slot_left_1747 = gc_frame_newslot(call1751);
  params[0] = strlit1748;
  partcv[0] = 1;
  Object opresult1752 = callmethod(call1751, "==(1)", 1, partcv, params);
// compiled op node returning opresult1752 (depth = 6)
  int op_slot_left_1736 = gc_frame_newslot(opresult1752);
  params[0] = block1737;
  partcv[0] = 1;
  Object opresult1753 = callmethod(opresult1752, "||(1)", 1, partcv, params);
// compiled op node returning opresult1753 (depth = 5)
  Object if1735 = done;
struct StackFrameObject *iftmpstackframe1735 = stackframe;
  if (istrue(opresult1753)) {
stackframe = alloc_StackFrame(0, iftmpstackframe1735);
gc_frame_newslot((Object)stackframe);
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1754 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1755 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe1754);
// compiled member node returning call1755 (depth = 5)
    gc_frame_newslot(call1755);
    if1735 = call1755;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe1735);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit1756 == NULL) {
    strlit1756 = alloc_String("-missing-");
    gc_root(strlit1756);
  }
// compiled string node returning strlit1756 (depth = 5)
    gc_frame_newslot(strlit1756);
    if1735 = strlit1756;
  }
stackframe = iftmpstackframe1735;
// compiled if node returning if1735 (depth = 4)
  *var_opener = if1735;
  if (if1735 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 598
  setline(598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1759 == NULL) {
    strlit1759 = alloc_String("(");
    gc_root(strlit1759);
  }
// compiled string node returning strlit1759 (depth = 6)
  int op_slot_right_1758 = gc_frame_newslot(strlit1759);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_opener (depth = 6)
  int op_slot_left_1758 = gc_frame_newslot(*var_opener);
  params[0] = strlit1759;
  partcv[0] = 1;
  Object opresult1761 = callmethod(*var_opener, "==(1)", 1, partcv, params);
// compiled op node returning opresult1761 (depth = 5)
  Object if1757 = done;
struct StackFrameObject *iftmpstackframe1757 = stackframe;
  if (istrue(opresult1761)) {
stackframe = alloc_StackFrame(0, iftmpstackframe1757);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit1762 == NULL) {
    strlit1762 = alloc_String(")");
    gc_root(strlit1762);
  }
// compiled string node returning strlit1762 (depth = 5)
    gc_frame_newslot(strlit1762);
    if1757 = strlit1762;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe1757);
  gc_frame_newslot((Object)stackframe);
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1765 == NULL) {
    strlit1765 = alloc_String("{");
    gc_root(strlit1765);
  }
// compiled string node returning strlit1765 (depth = 7)
  int op_slot_right_1764 = gc_frame_newslot(strlit1765);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_opener (depth = 7)
  int op_slot_left_1764 = gc_frame_newslot(*var_opener);
  params[0] = strlit1765;
  partcv[0] = 1;
  Object opresult1767 = callmethod(*var_opener, "==(1)", 1, partcv, params);
// compiled op node returning opresult1767 (depth = 6)
  Object if1763 = done;
  if (istrue(opresult1767)) {
// starting to compile string node (depth = 6)
  if (strlit1768 == NULL) {
    strlit1768 = alloc_String("}");
    gc_root(strlit1768);
  }
// compiled string node returning strlit1768 (depth = 6)
    gc_frame_newslot(strlit1768);
    if1763 = strlit1768;
  } else {
// starting to compile string node (depth = 6)
  if (strlit1769 == NULL) {
    strlit1769 = alloc_String("-nothing-");
    gc_root(strlit1769);
  }
// compiled string node returning strlit1769 (depth = 6)
    gc_frame_newslot(strlit1769);
    if1763 = strlit1769;
  }
// compiled if node returning if1763 (depth = 5)
    gc_frame_newslot(if1763);
    if1757 = if1763;
  }
stackframe = iftmpstackframe1757;
// compiled if node returning if1757 (depth = 4)
  *var_closer = if1757;
  if (if1757 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1772 == NULL) {
    strlit1772 = alloc_String("-missing-");
    gc_root(strlit1772);
  }
// compiled string node returning strlit1772 (depth = 5)
  int op_slot_right_1771 = gc_frame_newslot(strlit1772);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_opener (depth = 5)
  int op_slot_left_1771 = gc_frame_newslot(*var_opener);
  params[0] = strlit1772;
  partcv[0] = 1;
  Object opresult1774 = callmethod(*var_opener, "==(1)", 1, partcv, params);
// compiled op node returning opresult1774 (depth = 4)
  Object if1770 = done;
  if (istrue(opresult1774)) {
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1775 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1776 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call1777 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1776);
// compiled member node returning call1777 (depth = 6)
  Object call1778 = callmethodflags(call1777, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1775);
// compiled member node returning call1778 (depth = 5)
  *var_suggestion = call1778;
  if (call1778 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1779 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1780 = alloc_Block(NULL, NULL, "parser", 603);
  gc_frame_newslot(block1780);
// method "_apply(_)"
  block_savedest(block1780);
  Object closure1781 = createclosure(2, "_apply(1)");
  setclosureframe(closure1781, stackframe);
  addtoclosure(closure1781, var_btok);
  addtoclosure(closure1781, selfslot);
  struct UserObject *uo1781 = (struct UserObject*)block1780;
  uo1781->data[0] = (Object)closure1781;
  Method *meth_meth_parser__apply_40_1_41_1781 = addmethod2pos(block1780, "_apply(1)", &meth_parser__apply_40_1_41_1781, 0);
  int argcv_meth_parser__apply_40_1_41_1781[] = {1};
  meth_meth_parser__apply_40_1_41_1781->type = alloc_MethodType(1, argcv_meth_parser__apply_40_1_41_1781);
  meth_meth_parser__apply_40_1_41_1781->definitionModule = modulename;
  meth_meth_parser__apply_40_1_41_1781->definitionLine = 3399;
// compiled block node returning block1780 (depth = 6)
  gc_frame_newslot(block1780);
// call case 4: self request
  params[0] = block1780;
  partcv[0] = 1;
  Object call1835 = callmethodflags(self, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1779);
// compiled call node returning call1835 (depth = 5)
  *var_nextTok = call1835;
  if (call1835 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 606
  setline(606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_right_1837 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 6)
  Object bool1839 = alloc_Boolean(0);
// compiled identifier node returning bool1839 (depth = 6)
  int op_slot_left_1837 = gc_frame_newslot(bool1839);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult1840 = callmethod(bool1839, "==(1)", 1, partcv, params);
// compiled op node returning opresult1840 (depth = 5)
  Object if1836 = done;
  if (istrue(opresult1840)) {
// Begin line 607
  setline(607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1841 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1842 == NULL) {
    strlit1842 = alloc_String(" (""\xc2""""\xab""condition""\xc2""""\xbb"") then {");
    gc_root(strlit1842);
  }
// compiled string node returning strlit1842 (depth = 6)
  gc_frame_newslot(strlit1842);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit1842;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1843 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1841);
// compiled call node returning call1843 (depth = 5)
    gc_frame_newslot(call1843);
    if1836 = call1843;
  } else {
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1846 == NULL) {
    strlit1846 = alloc_String("rparen");
    gc_root(strlit1846);
  }
// compiled string node returning strlit1846 (depth = 7)
  int op_slot_right_1845 = gc_frame_newslot(strlit1846);
// starting to compile member node (depth = 7)
  int callframe1848 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call1849 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1848);
// compiled member node returning call1849 (depth = 7)
  int op_slot_left_1845 = gc_frame_newslot(call1849);
  params[0] = strlit1846;
  partcv[0] = 1;
  Object opresult1850 = callmethod(call1849, "==(1)", 1, partcv, params);
// compiled op node returning opresult1850 (depth = 6)
  Object if1844 = done;
  if (istrue(opresult1850)) {
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_1852 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_1852 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1854 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1854 (depth = 7)
  Object if1851 = done;
  if (istrue(opresult1854)) {
// Begin line 610
  setline(610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1855 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1856 == NULL) {
    strlit1856 = alloc_String("(""\xc2""""\xab""condition""\xc2""""\xbb""");
    gc_root(strlit1856);
  }
// compiled string node returning strlit1856 (depth = 8)
  gc_frame_newslot(strlit1856);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit1856;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1857 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1855);
// compiled call node returning call1857 (depth = 7)
    gc_frame_newslot(call1857);
    if1851 = call1857;
  } else {
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1858 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1859 == NULL) {
    strlit1859 = alloc_String("(");
    gc_root(strlit1859);
  }
// compiled string node returning strlit1859 (depth = 8)
  gc_frame_newslot(strlit1859);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit1859;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1860 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1858);
// compiled call node returning call1860 (depth = 7)
    gc_frame_newslot(call1860);
    if1851 = call1860;
  }
// compiled if node returning if1851 (depth = 6)
    gc_frame_newslot(if1851);
    if1844 = if1851;
  } else {
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1863 == NULL) {
    strlit1863 = alloc_String("lbrace");
    gc_root(strlit1863);
  }
// compiled string node returning strlit1863 (depth = 8)
  int op_slot_right_1862 = gc_frame_newslot(strlit1863);
// starting to compile member node (depth = 8)
  int callframe1865 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  Object call1866 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1865);
// compiled member node returning call1866 (depth = 8)
  int op_slot_left_1862 = gc_frame_newslot(call1866);
  params[0] = strlit1863;
  partcv[0] = 1;
  Object opresult1867 = callmethod(call1866, "==(1)", 1, partcv, params);
// compiled op node returning opresult1867 (depth = 7)
  Object if1861 = done;
  if (istrue(opresult1867)) {
// Begin line 615
  setline(615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_1869 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_1869 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1871 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1871 (depth = 8)
  Object if1868 = done;
  if (istrue(opresult1871)) {
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1872 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1873 == NULL) {
    strlit1873 = alloc_String(" (""\xc2""""\xab""condition""\xc2""""\xbb"") then");
    gc_root(strlit1873);
  }
// compiled string node returning strlit1873 (depth = 9)
  gc_frame_newslot(strlit1873);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1873;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1874 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1872);
// compiled call node returning call1874 (depth = 8)
    gc_frame_newslot(call1874);
    if1868 = call1874;
  } else {
// Begin line 618
  setline(618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1875 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1876 == NULL) {
    strlit1876 = alloc_String("(");
    gc_root(strlit1876);
  }
// compiled string node returning strlit1876 (depth = 9)
  gc_frame_newslot(strlit1876);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1876;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1877 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1875);
// compiled call node returning call1877 (depth = 8)
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1878 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1879 == NULL) {
    strlit1879 = alloc_String(") then");
    gc_root(strlit1879);
  }
// compiled string node returning strlit1879 (depth = 9)
  gc_frame_newslot(strlit1879);
// starting to compile member node (depth = 9)
  int callframe1880 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call1881 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe1880);
// compiled member node returning call1881 (depth = 9)
  gc_frame_newslot(call1881);
// starting to compile identifier node (depth = 9)
  Object bool1882 = alloc_Boolean(1);
// compiled identifier node returning bool1882 (depth = 9)
  gc_frame_newslot(bool1882);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1879;
  params[1] = call1881;
  params[2] = bool1882;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1883 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1878);
// compiled call node returning call1883 (depth = 8)
    gc_frame_newslot(call1883);
    if1868 = call1883;
  }
// compiled if node returning if1868 (depth = 7)
    gc_frame_newslot(if1868);
    if1861 = if1868;
  } else {
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1886 == NULL) {
    strlit1886 = alloc_String("identifier");
    gc_root(strlit1886);
  }
// compiled string node returning strlit1886 (depth = 9)
  int op_slot_right_1885 = gc_frame_newslot(strlit1886);
// starting to compile member node (depth = 9)
  int callframe1888 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call1889 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe1888);
// compiled member node returning call1889 (depth = 9)
  int op_slot_left_1885 = gc_frame_newslot(call1889);
  params[0] = strlit1886;
  partcv[0] = 1;
  Object opresult1890 = callmethod(call1889, "==(1)", 1, partcv, params);
// compiled op node returning opresult1890 (depth = 8)
  Object if1884 = done;
  if (istrue(opresult1890)) {
// Begin line 622
  setline(622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_1892 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_1892 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1894 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1894 (depth = 9)
  Object if1891 = done;
  if (istrue(opresult1894)) {
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1895 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1896 == NULL) {
    strlit1896 = alloc_String("(""\xc2""""\xab""condition""\xc2""""\xbb"") ");
    gc_root(strlit1896);
  }
// compiled string node returning strlit1896 (depth = 10)
  gc_frame_newslot(strlit1896);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1896;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1897 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1895);
// compiled call node returning call1897 (depth = 9)
    gc_frame_newslot(call1897);
    if1891 = call1897;
  } else {
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1898 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1899 == NULL) {
    strlit1899 = alloc_String("(");
    gc_root(strlit1899);
  }
// compiled string node returning strlit1899 (depth = 10)
  gc_frame_newslot(strlit1899);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1899;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1900 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1898);
// compiled call node returning call1900 (depth = 9)
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1901 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1902 == NULL) {
    strlit1902 = alloc_String(")");
    gc_root(strlit1902);
  }
// compiled string node returning strlit1902 (depth = 10)
  gc_frame_newslot(strlit1902);
// starting to compile member node (depth = 10)
  int callframe1903 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  Object call1904 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe1903);
// compiled member node returning call1904 (depth = 10)
  gc_frame_newslot(call1904);
// starting to compile identifier node (depth = 10)
  Object bool1905 = alloc_Boolean(1);
// compiled identifier node returning bool1905 (depth = 10)
  gc_frame_newslot(bool1905);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1902;
  params[1] = call1904;
  params[2] = bool1905;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1906 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1901);
// compiled call node returning call1906 (depth = 9)
    gc_frame_newslot(call1906);
    if1891 = call1906;
  }
// compiled if node returning if1891 (depth = 8)
    gc_frame_newslot(if1891);
    if1884 = if1891;
  } else {
  }
// compiled if node returning if1884 (depth = 7)
    gc_frame_newslot(if1884);
    if1861 = if1884;
  }
// compiled if node returning if1861 (depth = 6)
    gc_frame_newslot(if1861);
    if1844 = if1861;
  }
// compiled if node returning if1844 (depth = 5)
    gc_frame_newslot(if1844);
    if1836 = if1844;
  }
// compiled if node returning if1836 (depth = 4)
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1907 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1909 == NULL) {
    strlit1909 = alloc_String("in parentheses or braces after the 'if'.");
    gc_root(strlit1909);
  }
// compiled string node returning strlit1909 (depth = 6)
  int op_slot_right_1908 = gc_frame_newslot(strlit1909);
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1911 == NULL) {
    strlit1911 = alloc_String("an if statement must have a condition ");
    gc_root(strlit1911);
  }
// compiled string node returning strlit1911 (depth = 6)
  int op_slot_left_1908 = gc_frame_newslot(strlit1911);
  params[0] = strlit1909;
  partcv[0] = 1;
  Object opresult1912 = callmethod(strlit1911, "++(1)", 1, partcv, params);
// compiled op node returning opresult1912 (depth = 5)
  gc_frame_newslot(opresult1912);
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1913 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1914 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1913);
// compiled member node returning call1914 (depth = 5)
  gc_frame_newslot(call1914);
// starting to compile member node (depth = 5)
  int callframe1915 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call1916 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1915);
// compiled member node returning call1916 (depth = 5)
  gc_frame_newslot(call1916);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult1912;
  params[1] = call1914;
  params[2] = call1916;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1917 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1907);
// compiled call node returning call1917 (depth = 4)
    gc_frame_newslot(call1917);
    if1770 = call1917;
  } else {
  }
// compiled if node returning if1770 (depth = 3)
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1918 = gc_frame_new();
// call case 4: self request
  Object call1919 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1918);
// compiled member node returning call1919 (depth = 3)
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1921 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe1922 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1923 = alloc_Block(NULL, NULL, "parser", 634);
  gc_frame_newslot(block1923);
// method "_apply"
  block_savedest(block1923);
  Object closure1924 = createclosure(2, "_apply");
  setclosureframe(closure1924, stackframe);
  addtoclosure(closure1924, var_blocksOK);
  addtoclosure(closure1924, selfslot);
  struct UserObject *uo1924 = (struct UserObject*)block1923;
  uo1924->data[0] = (Object)closure1924;
  Method *meth_meth_parser__apply1924 = addmethod2pos(block1923, "_apply", &meth_parser__apply1924, 0);
  int argcv_meth_parser__apply1924[] = {0};
  meth_meth_parser__apply1924->type = alloc_MethodType(1, argcv_meth_parser__apply1924);
  meth_meth_parser__apply1924->definitionModule = modulename;
  meth_meth_parser__apply1924->definitionLine = 3399;
// compiled block node returning block1923 (depth = 6)
  gc_frame_newslot(block1923);
// call case 4: self request
  params[0] = block1923;
  partcv[0] = 1;
  Object call1928 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1922);
// compiled call node returning call1928 (depth = 5)
  Object call1929 = callmethodflags(call1928, "not", 0, partcv, params, 0);
  gc_frame_end(callframe1921);
// compiled member node returning call1929 (depth = 4)
  Object if1920 = done;
  if (istrue(call1929)) {
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1930 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1931 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call1932 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe1931);
// compiled member node returning call1932 (depth = 6)
  Object call1933 = callmethodflags(call1932, "new", 0, partcv, params, 0);
  gc_frame_end(callframe1930);
// compiled member node returning call1933 (depth = 5)
  *var_suggestion = call1933;
  if (call1933 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1934 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1935 = alloc_Block(NULL, NULL, "parser", 637);
  gc_frame_newslot(block1935);
// method "_apply(_)"
  block_savedest(block1935);
  Object closure1936 = createclosure(2, "_apply(1)");
  setclosureframe(closure1936, stackframe);
  addtoclosure(closure1936, var_lastToken);
  addtoclosure(closure1936, selfslot);
  struct UserObject *uo1936 = (struct UserObject*)block1935;
  uo1936->data[0] = (Object)closure1936;
  Method *meth_meth_parser__apply_40_1_41_1936 = addmethod2pos(block1935, "_apply(1)", &meth_parser__apply_40_1_41_1936, 0);
  int argcv_meth_parser__apply_40_1_41_1936[] = {1};
  meth_meth_parser__apply_40_1_41_1936->type = alloc_MethodType(1, argcv_meth_parser__apply_40_1_41_1936);
  meth_meth_parser__apply_40_1_41_1936->definitionModule = modulename;
  meth_meth_parser__apply_40_1_41_1936->definitionLine = 3399;
// compiled block node returning block1935 (depth = 6)
  gc_frame_newslot(block1935);
// call case 4: self request
  params[0] = block1935;
  partcv[0] = 1;
  Object call1954 = callmethodflags(self, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1934);
// compiled call node returning call1954 (depth = 5)
  *var_nextTok = call1954;
  if (call1954 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_right_1956 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 6)
  Object bool1958 = alloc_Boolean(0);
// compiled identifier node returning bool1958 (depth = 6)
  int op_slot_left_1956 = gc_frame_newslot(bool1958);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult1959 = callmethod(bool1958, "==(1)", 1, partcv, params);
// compiled op node returning opresult1959 (depth = 5)
  Object if1955 = done;
  if (istrue(opresult1959)) {
// Begin line 639
  setline(639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1960 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array1961 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit1962 == NULL) {
    strlit1962 = alloc_String("rparen");
    gc_root(strlit1962);
  }
// compiled string node returning strlit1962 (depth = 8)
  params[0] = strlit1962;
  partcv[0] = 1;
  callmethodflags(array1961, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array1961 (depth = 7)
  gc_frame_newslot(array1961);
// call case 4: self request
  params[0] = array1961;
  partcv[0] = 1;
  Object call1963 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1960);
// compiled call node returning call1963 (depth = 6)
  *var_nextTok = call1963;
  if (call1963 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_1966 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_1966 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1968 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1968 (depth = 6)
  Object if1965 = done;
  if (istrue(opresult1968)) {
// Begin line 641
  setline(641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1969 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1970 == NULL) {
    strlit1970 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit1970);
  }
// compiled string node returning strlit1970 (depth = 7)
  gc_frame_newslot(strlit1970);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1970;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1971 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1969);
// compiled call node returning call1971 (depth = 6)
    gc_frame_newslot(call1971);
    if1965 = call1971;
  } else {
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1972 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe1973 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call1974 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe1973);
// compiled member node returning call1974 (depth = 7)
  gc_frame_newslot(call1974);
// Begin line 644
  setline(644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool1975 = alloc_Boolean(1);
// compiled identifier node returning bool1975 (depth = 7)
  gc_frame_newslot(bool1975);
// starting to compile identifier node (depth = 7)
  Object bool1976 = alloc_Boolean(0);
// compiled identifier node returning bool1976 (depth = 7)
  gc_frame_newslot(bool1976);
// starting to compile string node (depth = 7)
  if (strlit1977 == NULL) {
    strlit1977 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit1977);
  }
// compiled string node returning strlit1977 (depth = 7)
  gc_frame_newslot(strlit1977);
// call case 6: other requests
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call1974;
  params[2] = bool1975;
  params[3] = bool1976;
  params[4] = strlit1977;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1978 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe1972);
// compiled call node returning call1978 (depth = 6)
    gc_frame_newslot(call1978);
    if1965 = call1978;
  }
// compiled if node returning if1965 (depth = 5)
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1979 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1981 == NULL) {
    strlit1981 = alloc_String("condition in parentheses or braces after the 'if'.");
    gc_root(strlit1981);
  }
// compiled string node returning strlit1981 (depth = 7)
  int op_slot_right_1980 = gc_frame_newslot(strlit1981);
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1983 == NULL) {
    strlit1983 = alloc_String("an if statement must have a ");
    gc_root(strlit1983);
  }
// compiled string node returning strlit1983 (depth = 7)
  int op_slot_left_1980 = gc_frame_newslot(strlit1983);
  params[0] = strlit1981;
  partcv[0] = 1;
  Object opresult1984 = callmethod(strlit1983, "++(1)", 1, partcv, params);
// compiled op node returning opresult1984 (depth = 6)
  gc_frame_newslot(opresult1984);
// Begin line 648
  setline(648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe1985 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call1986 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe1985);
// compiled member node returning call1986 (depth = 6)
  gc_frame_newslot(call1986);
// starting to compile member node (depth = 6)
  int callframe1987 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call1988 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe1987);
// compiled member node returning call1988 (depth = 6)
  gc_frame_newslot(call1988);
// Begin line 649
  setline(649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult1984;
  params[1] = call1986;
  params[2] = call1988;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1989 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1979);
// compiled call node returning call1989 (depth = 5)
    gc_frame_newslot(call1989);
    if1955 = call1989;
  } else {
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_1991 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_1991 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1993 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult1993 (depth = 6)
  Object if1990 = done;
  if (istrue(opresult1993)) {
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1994 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1995 == NULL) {
    strlit1995 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1995);
  }
// compiled string node returning strlit1995 (depth = 7)
  gc_frame_newslot(strlit1995);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1995;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1996 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1994);
// compiled call node returning call1996 (depth = 6)
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1997 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit1999 == NULL) {
    strlit1999 = alloc_String("condition in parentheses or braces after the 'if'.");
    gc_root(strlit1999);
  }
// compiled string node returning strlit1999 (depth = 8)
  int op_slot_right_1998 = gc_frame_newslot(strlit1999);
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2001 == NULL) {
    strlit2001 = alloc_String("an if statement must have a ");
    gc_root(strlit2001);
  }
// compiled string node returning strlit2001 (depth = 8)
  int op_slot_left_1998 = gc_frame_newslot(strlit2001);
  params[0] = strlit1999;
  partcv[0] = 1;
  Object opresult2002 = callmethod(strlit2001, "++(1)", 1, partcv, params);
// compiled op node returning opresult2002 (depth = 7)
  gc_frame_newslot(opresult2002);
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe2003 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call2004 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2003);
// compiled member node returning call2004 (depth = 7)
  gc_frame_newslot(call2004);
// starting to compile member node (depth = 7)
  int callframe2005 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call2006 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2005);
// compiled member node returning call2006 (depth = 7)
  gc_frame_newslot(call2006);
// Begin line 656
  setline(656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult2002;
  params[1] = call2004;
  params[2] = call2006;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2007 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe1997);
// compiled call node returning call2007 (depth = 6)
    gc_frame_newslot(call2007);
    if1990 = call2007;
  } else {
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2008 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe2009 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call2010 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe2009);
// compiled member node returning call2010 (depth = 7)
  gc_frame_newslot(call2010);
// Begin line 659
  setline(659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool2011 = alloc_Boolean(0);
// compiled identifier node returning bool2011 (depth = 7)
  gc_frame_newslot(bool2011);
// starting to compile identifier node (depth = 7)
  Object bool2012 = alloc_Boolean(1);
// compiled identifier node returning bool2012 (depth = 7)
  gc_frame_newslot(bool2012);
// starting to compile string node (depth = 7)
  if (strlit2013 == NULL) {
    strlit2013 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2013);
  }
// compiled string node returning strlit2013 (depth = 7)
  gc_frame_newslot(strlit2013);
// call case 6: other requests
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call2010;
  params[2] = bool2011;
  params[3] = bool2012;
  params[4] = strlit2013;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2014 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2008);
// compiled call node returning call2014 (depth = 6)
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2015 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2017 == NULL) {
    strlit2017 = alloc_String("condition in parentheses or braces after the 'if'.");
    gc_root(strlit2017);
  }
// compiled string node returning strlit2017 (depth = 8)
  int op_slot_right_2016 = gc_frame_newslot(strlit2017);
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2019 == NULL) {
    strlit2019 = alloc_String("an if statement must have a ");
    gc_root(strlit2019);
  }
// compiled string node returning strlit2019 (depth = 8)
  int op_slot_left_2016 = gc_frame_newslot(strlit2019);
  params[0] = strlit2017;
  partcv[0] = 1;
  Object opresult2020 = callmethod(strlit2019, "++(1)", 1, partcv, params);
// compiled op node returning opresult2020 (depth = 7)
  gc_frame_newslot(opresult2020);
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe2021 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call2022 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2021);
// compiled member node returning call2022 (depth = 7)
  gc_frame_newslot(call2022);
// starting to compile member node (depth = 7)
  int callframe2023 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call2024 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2023);
// compiled member node returning call2024 (depth = 7)
  gc_frame_newslot(call2024);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2026 = alloc_Float64(1);
// compiled num node returning num2026 (depth = 8)
  int op_slot_right_2025 = gc_frame_newslot(num2026);
// starting to compile member node (depth = 8)
  int callframe2028 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  Object call2029 = callmethodflags(*var_nextTok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2028);
// compiled member node returning call2029 (depth = 8)
  int op_slot_left_2025 = gc_frame_newslot(call2029);
  params[0] = num2026;
  partcv[0] = 1;
  Object diff2030 = callmethod(call2029, "-(1)", 1, partcv, params);
// compiled op node returning diff2030 (depth = 7)
  gc_frame_newslot(diff2030);
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult2020;
  params[1] = call2022;
  params[2] = call2024;
  params[3] = diff2030;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2031 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2015);
// compiled call node returning call2031 (depth = 6)
    gc_frame_newslot(call2031);
    if1990 = call2031;
  }
// compiled if node returning if1990 (depth = 5)
    gc_frame_newslot(if1990);
    if1955 = if1990;
  }
// compiled if node returning if1955 (depth = 4)
    gc_frame_newslot(if1955);
    if1920 = if1955;
  } else {
  }
// compiled if node returning if1920 (depth = 3)
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_closer (depth = 5)
  int op_slot_right_2033 = gc_frame_newslot(*var_closer);
// starting to compile member node (depth = 5)
  int callframe2035 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call2036 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe2035);
// compiled member node returning call2036 (depth = 5)
  int op_slot_left_2033 = gc_frame_newslot(call2036);
  params[0] = *var_closer;
  partcv[0] = 1;
  Object opresult2037 = callmethod(call2036, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2037 (depth = 4)
  Object if2032 = done;
  if (istrue(opresult2037)) {
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2038 = gc_frame_new();
// call case 4: self request
  Object call2039 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2038);
// compiled member node returning call2039 (depth = 4)
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2040 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2041 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call2042 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2041);
// compiled member node returning call2042 (depth = 6)
  Object call2043 = callmethodflags(call2042, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2040);
// compiled member node returning call2043 (depth = 5)
  *var_suggestion = call2043;
  if (call2043 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2044 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit2045 == NULL) {
    strlit2045 = alloc_String(")");
    gc_root(strlit2045);
  }
// compiled string node returning strlit2045 (depth = 5)
  gc_frame_newslot(strlit2045);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit2045;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2046 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2044);
// compiled call node returning call2046 (depth = 4)
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2047 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2050 == NULL) {
    strlit2050 = alloc_String("'.");
    gc_root(strlit2050);
  }
// compiled string node returning strlit2050 (depth = 7)
  int op_slot_right_2049 = gc_frame_newslot(strlit2050);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closer (depth = 8)
  int op_slot_right_2052 = gc_frame_newslot(*var_closer);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2055 == NULL) {
    strlit2055 = alloc_String("' must end with a '");
    gc_root(strlit2055);
  }
// compiled string node returning strlit2055 (depth = 9)
  int op_slot_right_2054 = gc_frame_newslot(strlit2055);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_opener (depth = 10)
  int op_slot_right_2057 = gc_frame_newslot(*var_opener);
// starting to compile string node (depth = 10)
  if (strlit2059 == NULL) {
    strlit2059 = alloc_String("'");
    gc_root(strlit2059);
  }
// compiled string node returning strlit2059 (depth = 10)
  int op_slot_left_2057 = gc_frame_newslot(strlit2059);
  params[0] = *var_opener;
  partcv[0] = 1;
  Object opresult2060 = callmethod(strlit2059, "++(1)", 1, partcv, params);
// compiled op node returning opresult2060 (depth = 9)
  int op_slot_left_2054 = gc_frame_newslot(opresult2060);
  params[0] = strlit2055;
  partcv[0] = 1;
  Object opresult2061 = callmethod(opresult2060, "++(1)", 1, partcv, params);
// compiled op node returning opresult2061 (depth = 8)
  int op_slot_left_2052 = gc_frame_newslot(opresult2061);
  params[0] = *var_closer;
  partcv[0] = 1;
  Object opresult2062 = callmethod(opresult2061, "++(1)", 1, partcv, params);
// compiled op node returning opresult2062 (depth = 7)
  int op_slot_left_2049 = gc_frame_newslot(opresult2062);
  params[0] = strlit2050;
  partcv[0] = 1;
  Object opresult2063 = callmethod(opresult2062, "++(1)", 1, partcv, params);
// compiled op node returning opresult2063 (depth = 6)
  int op_slot_right_2048 = gc_frame_newslot(opresult2063);
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit2065 == NULL) {
    strlit2065 = alloc_String("an expression beginning with a ");
    gc_root(strlit2065);
  }
// compiled string node returning strlit2065 (depth = 6)
  int op_slot_left_2048 = gc_frame_newslot(strlit2065);
  params[0] = opresult2063;
  partcv[0] = 1;
  Object opresult2066 = callmethod(strlit2065, "++(1)", 1, partcv, params);
// compiled op node returning opresult2066 (depth = 5)
  gc_frame_newslot(opresult2066);
// Begin line 673
  setline(673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe2067 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call2068 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2067);
// compiled member node returning call2068 (depth = 5)
  gc_frame_newslot(call2068);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2070 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call2071 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2070);
// compiled member node returning call2071 (depth = 6)
  int op_slot_right_2069 = gc_frame_newslot(call2071);
// starting to compile member node (depth = 6)
  int callframe2073 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call2074 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2073);
// compiled member node returning call2074 (depth = 6)
  int op_slot_left_2069 = gc_frame_newslot(call2074);
  params[0] = call2071;
  partcv[0] = 1;
  Object sum2075 = callmethod(call2074, "+(1)", 1, partcv, params);
// compiled op node returning sum2075 (depth = 5)
  gc_frame_newslot(sum2075);
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult2066;
  params[1] = call2068;
  params[2] = sum2075;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2076 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2047);
// compiled call node returning call2076 (depth = 4)
    gc_frame_newslot(call2076);
    if2032 = call2076;
  } else {
  }
// compiled if node returning if2032 (depth = 3)
// Begin line 676
  setline(676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe2077 = gc_frame_new();
// call case 4: self request
  Object call2078 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2077);
// compiled member node returning call2078 (depth = 3)
// Begin line 677
  setline(677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2079 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call2080 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe2079);
// compiled member node returning call2080 (depth = 4)
  *var_cond = call2080;
  if (call2080 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 678
  setline(678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array2081 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2081 (depth = 4)
  *var_body = array2081;
  if (array2081 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array2082 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2082 (depth = 4)
  *var_elseblock = array2082;
  if (array2082 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elseblock (depth = 4)
  *var_curelse = *var_elseblock;
  if (*var_elseblock == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 688
  setline(688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_v = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_localMin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 690
  setline(690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementIndent (depth = 4)
  *var_localStatementIndent = *var_statementIndent;
  if (*var_statementIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 691
  setline(691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2084 = alloc_Float64(2);
// compiled num node returning num2084 (depth = 5)
  int op_slot_right_2083 = gc_frame_newslot(num2084);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_statementIndent (depth = 5)
  int op_slot_left_2083 = gc_frame_newslot(*var_statementIndent);
  params[0] = num2084;
  partcv[0] = 1;
  Object sum2086 = callmethod(*var_statementIndent, "+(1)", 1, partcv, params);
// compiled op node returning sum2086 (depth = 4)
  *var_minInd = sum2086;
  if (sum2086 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2090 == NULL) {
    strlit2090 = alloc_String("then");
    gc_root(strlit2090);
  }
// compiled string node returning strlit2090 (depth = 6)
  int op_slot_right_2089 = gc_frame_newslot(strlit2090);
// starting to compile member node (depth = 6)
  int callframe2092 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call2093 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe2092);
// compiled member node returning call2093 (depth = 6)
  int op_slot_left_2089 = gc_frame_newslot(call2093);
  params[0] = strlit2090;
  partcv[0] = 1;
  Object opresult2094 = callmethod(call2093, "==(1)", 1, partcv, params);
// compiled op node returning opresult2094 (depth = 5)
  int op_slot_right_2088 = gc_frame_newslot(opresult2094);
// starting to compile call node (depth = 5)
  int callframe2096 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2097 == NULL) {
    strlit2097 = alloc_String("identifier");
    gc_root(strlit2097);
  }
// compiled string node returning strlit2097 (depth = 6)
  gc_frame_newslot(strlit2097);
// call case 4: self request
  params[0] = strlit2097;
  partcv[0] = 1;
  Object call2098 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2096);
// compiled call node returning call2098 (depth = 5)
  int op_slot_left_2088 = gc_frame_newslot(call2098);
  params[0] = opresult2094;
  partcv[0] = 1;
  Object opresult2099 = callmethod(call2098, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2099 (depth = 4)
  Object if2087 = done;
  if (istrue(opresult2099)) {
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2100 = gc_frame_new();
// call case 4: self request
  Object call2101 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2100);
// compiled member node returning call2101 (depth = 4)
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2104 == NULL) {
    strlit2104 = alloc_String("lbrace");
    gc_root(strlit2104);
  }
// compiled string node returning strlit2104 (depth = 6)
  int op_slot_right_2103 = gc_frame_newslot(strlit2104);
// starting to compile member node (depth = 6)
  int callframe2106 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call2107 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2106);
// compiled member node returning call2107 (depth = 6)
  int op_slot_left_2103 = gc_frame_newslot(call2107);
  params[0] = strlit2104;
  partcv[0] = 1;
  Object opresult2108 = callmethod(call2107, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2108 (depth = 5)
  Object if2102 = done;
  if (istrue(opresult2108)) {
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2109 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2110 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call2111 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2110);
// compiled member node returning call2111 (depth = 7)
  Object call2112 = callmethodflags(call2111, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2109);
// compiled member node returning call2112 (depth = 6)
  *var_suggestion = call2112;
  if (call2112 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 696
  setline(696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2113 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool2114 = alloc_Boolean(1);
// compiled identifier node returning bool2114 (depth = 7)
  gc_frame_newslot(bool2114);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2114;
  partcv[0] = 2;
  Object call2115 = callmethodflags(self, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2113);
// compiled call node returning call2115 (depth = 6)
  *var_closingBrace = call2115;
  if (call2115 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2117 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2118 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closingBrace (depth = 8)
  Object call2119 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe2118);
// compiled member node returning call2119 (depth = 7)
  Object call2120 = callmethodflags(call2119, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2117);
// compiled member node returning call2120 (depth = 6)
  Object if2116 = done;
  if (istrue(call2120)) {
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  int op_slot_right_2122 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
  int callframe2124 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  Object call2125 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2124);
// compiled member node returning call2125 (depth = 8)
  int op_slot_left_2122 = gc_frame_newslot(call2125);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2126 = callmethod(call2125, "==(1)", 1, partcv, params);
// compiled op node returning opresult2126 (depth = 7)
  Object if2121 = done;
  if (istrue(opresult2126)) {
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2127 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool2128 = alloc_Boolean(0);
// compiled identifier node returning bool2128 (depth = 8)
  gc_frame_newslot(bool2128);
// starting to compile identifier node (depth = 8)
  Object bool2129 = alloc_Boolean(1);
// compiled identifier node returning bool2129 (depth = 8)
  gc_frame_newslot(bool2129);
// starting to compile string node (depth = 8)
  if (strlit2130 == NULL) {
    strlit2130 = alloc_String("then {}");
    gc_root(strlit2130);
  }
// compiled string node returning strlit2130 (depth = 8)
  gc_frame_newslot(strlit2130);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool2128;
  params[2] = bool2129;
  params[3] = strlit2130;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2131 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2127);
// compiled call node returning call2131 (depth = 7)
    gc_frame_newslot(call2131);
    if2121 = call2131;
  } else {
// Begin line 701
  setline(701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2132 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2134 = alloc_Float64(0.1);
// compiled num node returning num2134 (depth = 9)
  int op_slot_right_2133 = gc_frame_newslot(num2134);
// starting to compile member node (depth = 9)
  int callframe2136 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2137 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  Object call2138 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2137);
// compiled member node returning call2138 (depth = 10)
  Object call2139 = callmethodflags(call2138, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2136);
// compiled member node returning call2139 (depth = 9)
  int op_slot_left_2133 = gc_frame_newslot(call2139);
  params[0] = num2134;
  partcv[0] = 1;
  Object sum2140 = callmethod(call2139, "+(1)", 1, partcv, params);
// compiled op node returning sum2140 (depth = 8)
  gc_frame_newslot(sum2140);
// starting to compile string node (depth = 8)
  if (strlit2141 == NULL) {
    strlit2141 = alloc_String("}");
    gc_root(strlit2141);
  }
// compiled string node returning strlit2141 (depth = 8)
  gc_frame_newslot(strlit2141);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum2140;
  params[1] = strlit2141;
  partcv[0] = 2;
  Object call2142 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2132);
// compiled call node returning call2142 (depth = 7)
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2143 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool2144 = alloc_Boolean(0);
// compiled identifier node returning bool2144 (depth = 8)
  gc_frame_newslot(bool2144);
// starting to compile identifier node (depth = 8)
  Object bool2145 = alloc_Boolean(1);
// compiled identifier node returning bool2145 (depth = 8)
  gc_frame_newslot(bool2145);
// starting to compile string node (depth = 8)
  if (strlit2146 == NULL) {
    strlit2146 = alloc_String("then {");
    gc_root(strlit2146);
  }
// compiled string node returning strlit2146 (depth = 8)
  gc_frame_newslot(strlit2146);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool2144;
  params[2] = bool2145;
  params[3] = strlit2146;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2147 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2143);
// compiled call node returning call2147 (depth = 7)
    gc_frame_newslot(call2147);
    if2121 = call2147;
  }
// compiled if node returning if2121 (depth = 6)
    gc_frame_newslot(if2121);
    if2116 = if2121;
  } else {
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2148 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool2149 = alloc_Boolean(0);
// compiled identifier node returning bool2149 (depth = 7)
  gc_frame_newslot(bool2149);
// starting to compile identifier node (depth = 7)
  Object bool2150 = alloc_Boolean(1);
// compiled identifier node returning bool2150 (depth = 7)
  gc_frame_newslot(bool2150);
// starting to compile string node (depth = 7)
  if (strlit2151 == NULL) {
    strlit2151 = alloc_String("then {");
    gc_root(strlit2151);
  }
// compiled string node returning strlit2151 (depth = 7)
  gc_frame_newslot(strlit2151);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = bool2149;
  params[2] = bool2150;
  params[3] = strlit2151;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2152 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2148);
// compiled call node returning call2152 (depth = 6)
    gc_frame_newslot(call2152);
    if2116 = call2152;
  }
// compiled if node returning if2116 (depth = 5)
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2153 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2154 == NULL) {
    strlit2154 = alloc_String("an if statement must have a '{' after the 'then'.");
    gc_root(strlit2154);
  }
// compiled string node returning strlit2154 (depth = 6)
  gc_frame_newslot(strlit2154);
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2155 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call2156 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2155);
// compiled member node returning call2156 (depth = 6)
  gc_frame_newslot(call2156);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2158 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call2159 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2158);
// compiled member node returning call2159 (depth = 7)
  int op_slot_right_2157 = gc_frame_newslot(call2159);
// starting to compile member node (depth = 7)
  int callframe2161 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call2162 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2161);
// compiled member node returning call2162 (depth = 7)
  int op_slot_left_2157 = gc_frame_newslot(call2162);
  params[0] = call2159;
  partcv[0] = 1;
  Object sum2163 = callmethod(call2162, "+(1)", 1, partcv, params);
// compiled op node returning sum2163 (depth = 6)
  gc_frame_newslot(sum2163);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit2154;
  params[1] = call2156;
  params[2] = sum2163;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2164 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2153);
// compiled call node returning call2164 (depth = 5)
    gc_frame_newslot(call2164);
    if2102 = call2164;
  } else {
  }
// compiled if node returning if2102 (depth = 4)
// Begin line 710
  setline(710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2165 = gc_frame_new();
// call case 4: self request
  Object call2166 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2165);
// compiled member node returning call2166 (depth = 4)
// Begin line 711
  setline(711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2169 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call2170 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2169);
// compiled member node returning call2170 (depth = 6)
  int op_slot_right_2168 = gc_frame_newslot(call2170);
// starting to compile member node (depth = 6)
  int callframe2172 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call2173 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2172);
// compiled member node returning call2173 (depth = 6)
  int op_slot_left_2168 = gc_frame_newslot(call2173);
  params[0] = call2170;
  partcv[0] = 1;
  Object opresult2174 = callmethod(call2173, "==(1)", 1, partcv, params);
// compiled op node returning opresult2174 (depth = 5)
  Object if2167 = done;
  if (istrue(opresult2174)) {
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2176 = alloc_Float64(1);
// compiled num node returning num2176 (depth = 7)
  int op_slot_right_2175 = gc_frame_newslot(num2176);
// starting to compile member node (depth = 7)
  int callframe2178 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call2179 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2178);
// compiled member node returning call2179 (depth = 7)
  int op_slot_left_2175 = gc_frame_newslot(call2179);
  params[0] = num2176;
  partcv[0] = 1;
  Object diff2180 = callmethod(call2179, "-(1)", 1, partcv, params);
// compiled op node returning diff2180 (depth = 6)
  *var_minIndentLevel = diff2180;
  if (diff2180 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2167 = done;
  } else {
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_minInd (depth = 6)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2167 = done;
  }
// compiled if node returning if2167 (depth = 4)
// Begin line 716
  setline(716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2183 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2184 = alloc_Block(NULL, NULL, "parser", 716);
  gc_frame_newslot(block2184);
// method "_apply"
  block_savedest(block2184);
  Object closure2185 = createclosure(1, "_apply");
  setclosureframe(closure2185, stackframe);
  addtoclosure(closure2185, selfslot);
  struct UserObject *uo2185 = (struct UserObject*)block2184;
  uo2185->data[0] = (Object)closure2185;
  Method *meth_meth_parser__apply2185 = addmethod2pos(block2184, "_apply", &meth_parser__apply2185, 0);
  int argcv_meth_parser__apply2185[] = {0};
  meth_meth_parser__apply2185->type = alloc_MethodType(1, argcv_meth_parser__apply2185);
  meth_meth_parser__apply2185->definitionModule = modulename;
  meth_meth_parser__apply2185->definitionLine = 3399;
// compiled block node returning block2184 (depth = 5)
  gc_frame_newslot(block2184);
// starting to compile block node (depth = 5)
  Object block2192 = alloc_Block(NULL, NULL, "parser", 716);
  gc_frame_newslot(block2192);
// method "_apply"
  block_savedest(block2192);
  Object closure2193 = createclosure(8, "_apply");
  setclosureframe(closure2193, stackframe);
  addtoclosure(closure2193, var_errormessages);
  addtoclosure(closure2193, var_btok);
  addtoclosure(closure2193, var_lastToken);
  addtoclosure(closure2193, var_sym);
  addtoclosure(closure2193, var_values);
  addtoclosure(closure2193, var_v);
  addtoclosure(closure2193, var_body);
  addtoclosure(closure2193, selfslot);
  struct UserObject *uo2193 = (struct UserObject*)block2192;
  uo2193->data[0] = (Object)closure2193;
  Method *meth_meth_parser__apply2193 = addmethod2pos(block2192, "_apply", &meth_parser__apply2193, 0);
  int argcv_meth_parser__apply2193[] = {0};
  meth_meth_parser__apply2193->type = alloc_MethodType(1, argcv_meth_parser__apply2193);
  meth_meth_parser__apply2193->definitionModule = modulename;
  meth_meth_parser__apply2193->definitionLine = 3399;
// compiled block node returning block2192 (depth = 5)
  gc_frame_newslot(block2192);
// call case 5: prelude request
  params[0] = block2184;
  params[1] = block2192;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2251 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2183);
// compiled call node returning call2251 (depth = 4)
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2252 = gc_frame_new();
// call case 4: self request
  Object call2253 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2252);
// compiled member node returning call2253 (depth = 4)
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_econd = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 736
  setline(736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_eif = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_newelse = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_ebody = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2254 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2255 = alloc_Block(NULL, NULL, "parser", 739);
  gc_frame_newslot(block2255);
// method "_apply"
  block_savedest(block2255);
  Object closure2256 = createclosure(2, "_apply");
  setclosureframe(closure2256, stackframe);
  addtoclosure(closure2256, var_sym);
  addtoclosure(closure2256, selfslot);
  struct UserObject *uo2256 = (struct UserObject*)block2255;
  uo2256->data[0] = (Object)closure2256;
  Method *meth_meth_parser__apply2256 = addmethod2pos(block2255, "_apply", &meth_parser__apply2256, 0);
  int argcv_meth_parser__apply2256[] = {0};
  meth_meth_parser__apply2256->type = alloc_MethodType(1, argcv_meth_parser__apply2256);
  meth_meth_parser__apply2256->definitionModule = modulename;
  meth_meth_parser__apply2256->definitionLine = 3399;
// compiled block node returning block2255 (depth = 5)
  gc_frame_newslot(block2255);
// starting to compile block node (depth = 5)
  Object block2270 = alloc_Block(NULL, NULL, "parser", 739);
  gc_frame_newslot(block2270);
// method "_apply"
  block_savedest(block2270);
  Object closure2271 = createclosure(16, "_apply");
  setclosureframe(closure2271, stackframe);
  addtoclosure(closure2271, var_sym);
  addtoclosure(closure2271, var_statementToken);
  addtoclosure(closure2271, var_errormessages);
  addtoclosure(closure2271, var_blocksOK);
  addtoclosure(closure2271, var_lastToken);
  addtoclosure(closure2271, var_values);
  addtoclosure(closure2271, var_econd);
  addtoclosure(closure2271, var_ebody);
  addtoclosure(closure2271, var_btok);
  addtoclosure(closure2271, var_minIndentLevel);
  addtoclosure(closure2271, var_minInd);
  addtoclosure(closure2271, var_v);
  addtoclosure(closure2271, var_newelse);
  addtoclosure(closure2271, var_eif);
  addtoclosure(closure2271, var_curelse);
  addtoclosure(closure2271, selfslot);
  struct UserObject *uo2271 = (struct UserObject*)block2270;
  uo2271->data[0] = (Object)closure2271;
  Method *meth_meth_parser__apply2271 = addmethod2pos(block2270, "_apply", &meth_parser__apply2271, 0);
  int argcv_meth_parser__apply2271[] = {0};
  meth_meth_parser__apply2271->type = alloc_MethodType(1, argcv_meth_parser__apply2271);
  meth_meth_parser__apply2271->definitionModule = modulename;
  meth_meth_parser__apply2271->definitionLine = 3399;
// compiled block node returning block2270 (depth = 5)
  gc_frame_newslot(block2270);
// call case 5: prelude request
  params[0] = block2255;
  params[1] = block2270;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2825 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2254);
// compiled call node returning call2825 (depth = 4)
// Begin line 902
  setline(902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2829 == NULL) {
    strlit2829 = alloc_String("else");
    gc_root(strlit2829);
  }
// compiled string node returning strlit2829 (depth = 7)
  int op_slot_right_2828 = gc_frame_newslot(strlit2829);
// starting to compile member node (depth = 7)
  int callframe2831 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call2832 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe2831);
// compiled member node returning call2832 (depth = 7)
  int op_slot_left_2828 = gc_frame_newslot(call2832);
  params[0] = strlit2829;
  partcv[0] = 1;
  Object opresult2833 = callmethod(call2832, "==(1)", 1, partcv, params);
// compiled op node returning opresult2833 (depth = 6)
  int op_slot_right_2827 = gc_frame_newslot(opresult2833);
// starting to compile call node (depth = 6)
  int callframe2835 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2836 == NULL) {
    strlit2836 = alloc_String("identifier");
    gc_root(strlit2836);
  }
// compiled string node returning strlit2836 (depth = 7)
  gc_frame_newslot(strlit2836);
// call case 4: self request
  params[0] = strlit2836;
  partcv[0] = 1;
  Object call2837 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2835);
// compiled call node returning call2837 (depth = 6)
  int op_slot_left_2827 = gc_frame_newslot(call2837);
  params[0] = opresult2833;
  partcv[0] = 1;
  Object opresult2838 = callmethod(call2837, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2838 (depth = 5)
  Object if2826 = done;
  if (istrue(opresult2838)) {
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe2839 = gc_frame_new();
// call case 4: self request
  Object call2840 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2839);
// compiled member node returning call2840 (depth = 5)
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2843 == NULL) {
    strlit2843 = alloc_String("lbrace");
    gc_root(strlit2843);
  }
// compiled string node returning strlit2843 (depth = 7)
  int op_slot_right_2842 = gc_frame_newslot(strlit2843);
// starting to compile member node (depth = 7)
  int callframe2845 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call2846 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe2845);
// compiled member node returning call2846 (depth = 7)
  int op_slot_left_2842 = gc_frame_newslot(call2846);
  params[0] = strlit2843;
  partcv[0] = 1;
  Object opresult2847 = callmethod(call2846, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2847 (depth = 6)
  Object if2841 = done;
  if (istrue(opresult2847)) {
// Begin line 905
  setline(905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2848 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2849 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call2850 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe2849);
// compiled member node returning call2850 (depth = 8)
  Object call2851 = callmethodflags(call2850, "new", 0, partcv, params, 0);
  gc_frame_end(callframe2848);
// compiled member node returning call2851 (depth = 7)
  *var_suggestion = call2851;
  if (call2851 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2852 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_btok (depth = 8)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 8)
  Object bool2853 = alloc_Boolean(1);
// compiled identifier node returning bool2853 (depth = 8)
  gc_frame_newslot(bool2853);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2853;
  partcv[0] = 2;
  Object call2854 = callmethodflags(self, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2852);
// compiled call node returning call2854 (depth = 7)
  *var_closingBrace = call2854;
  if (call2854 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 907
  setline(907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2856 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2857 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  Object call2858 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe2857);
// compiled member node returning call2858 (depth = 8)
  Object call2859 = callmethodflags(call2858, "not", 0, partcv, params, 0);
  gc_frame_end(callframe2856);
// compiled member node returning call2859 (depth = 7)
  Object if2855 = done;
  if (istrue(call2859)) {
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  int op_slot_right_2861 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
  int callframe2863 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  Object call2864 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2863);
// compiled member node returning call2864 (depth = 9)
  int op_slot_left_2861 = gc_frame_newslot(call2864);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2865 = callmethod(call2864, "==(1)", 1, partcv, params);
// compiled op node returning opresult2865 (depth = 8)
  Object if2860 = done;
  if (istrue(opresult2865)) {
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2866 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool2867 = alloc_Boolean(0);
// compiled identifier node returning bool2867 (depth = 9)
  gc_frame_newslot(bool2867);
// starting to compile identifier node (depth = 9)
  Object bool2868 = alloc_Boolean(1);
// compiled identifier node returning bool2868 (depth = 9)
  gc_frame_newslot(bool2868);
// starting to compile string node (depth = 9)
  if (strlit2869 == NULL) {
    strlit2869 = alloc_String("else {}");
    gc_root(strlit2869);
  }
// compiled string node returning strlit2869 (depth = 9)
  gc_frame_newslot(strlit2869);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool2867;
  params[2] = bool2868;
  params[3] = strlit2869;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2870 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2866);
// compiled call node returning call2870 (depth = 8)
    gc_frame_newslot(call2870);
    if2860 = call2870;
  } else {
// Begin line 911
  setline(911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2871 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2873 = alloc_Float64(0.1);
// compiled num node returning num2873 (depth = 10)
  int op_slot_right_2872 = gc_frame_newslot(num2873);
// starting to compile member node (depth = 10)
  int callframe2875 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe2876 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  Object call2877 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe2876);
// compiled member node returning call2877 (depth = 11)
  Object call2878 = callmethodflags(call2877, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2875);
// compiled member node returning call2878 (depth = 10)
  int op_slot_left_2872 = gc_frame_newslot(call2878);
  params[0] = num2873;
  partcv[0] = 1;
  Object sum2879 = callmethod(call2878, "+(1)", 1, partcv, params);
// compiled op node returning sum2879 (depth = 9)
  gc_frame_newslot(sum2879);
// starting to compile string node (depth = 9)
  if (strlit2880 == NULL) {
    strlit2880 = alloc_String("}");
    gc_root(strlit2880);
  }
// compiled string node returning strlit2880 (depth = 9)
  gc_frame_newslot(strlit2880);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = sum2879;
  params[1] = strlit2880;
  partcv[0] = 2;
  Object call2881 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2871);
// compiled call node returning call2881 (depth = 8)
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2882 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool2883 = alloc_Boolean(0);
// compiled identifier node returning bool2883 (depth = 9)
  gc_frame_newslot(bool2883);
// starting to compile identifier node (depth = 9)
  Object bool2884 = alloc_Boolean(1);
// compiled identifier node returning bool2884 (depth = 9)
  gc_frame_newslot(bool2884);
// starting to compile string node (depth = 9)
  if (strlit2885 == NULL) {
    strlit2885 = alloc_String("else {");
    gc_root(strlit2885);
  }
// compiled string node returning strlit2885 (depth = 9)
  gc_frame_newslot(strlit2885);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool2883;
  params[2] = bool2884;
  params[3] = strlit2885;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2886 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2882);
// compiled call node returning call2886 (depth = 8)
    gc_frame_newslot(call2886);
    if2860 = call2886;
  }
// compiled if node returning if2860 (depth = 7)
    gc_frame_newslot(if2860);
    if2855 = if2860;
  } else {
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2887 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool2888 = alloc_Boolean(0);
// compiled identifier node returning bool2888 (depth = 8)
  gc_frame_newslot(bool2888);
// starting to compile identifier node (depth = 8)
  Object bool2889 = alloc_Boolean(1);
// compiled identifier node returning bool2889 (depth = 8)
  gc_frame_newslot(bool2889);
// starting to compile string node (depth = 8)
  if (strlit2890 == NULL) {
    strlit2890 = alloc_String("else {");
    gc_root(strlit2890);
  }
// compiled string node returning strlit2890 (depth = 8)
  gc_frame_newslot(strlit2890);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool2888;
  params[2] = bool2889;
  params[3] = strlit2890;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2891 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe2887);
// compiled call node returning call2891 (depth = 7)
    gc_frame_newslot(call2891);
    if2855 = call2891;
  }
// compiled if node returning if2855 (depth = 6)
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2892 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2893 == NULL) {
    strlit2893 = alloc_String("an else statement must have a '{' after the 'else'.");
    gc_root(strlit2893);
  }
// compiled string node returning strlit2893 (depth = 7)
  gc_frame_newslot(strlit2893);
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe2894 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call2895 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2894);
// compiled member node returning call2895 (depth = 7)
  gc_frame_newslot(call2895);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2897 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call2898 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2897);
// compiled member node returning call2898 (depth = 8)
  int op_slot_right_2896 = gc_frame_newslot(call2898);
// starting to compile member node (depth = 8)
  int callframe2900 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call2901 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2900);
// compiled member node returning call2901 (depth = 8)
  int op_slot_left_2896 = gc_frame_newslot(call2901);
  params[0] = call2898;
  partcv[0] = 1;
  Object sum2902 = callmethod(call2901, "+(1)", 1, partcv, params);
// compiled op node returning sum2902 (depth = 7)
  gc_frame_newslot(sum2902);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit2893;
  params[1] = call2895;
  params[2] = sum2902;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2903 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe2892);
// compiled call node returning call2903 (depth = 6)
    gc_frame_newslot(call2903);
    if2841 = call2903;
  } else {
  }
// compiled if node returning if2841 (depth = 5)
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe2904 = gc_frame_new();
// call case 4: self request
  Object call2905 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2904);
// compiled member node returning call2905 (depth = 5)
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2908 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call2909 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2908);
// compiled member node returning call2909 (depth = 7)
  int op_slot_right_2907 = gc_frame_newslot(call2909);
// starting to compile member node (depth = 7)
  int callframe2911 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call2912 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2911);
// compiled member node returning call2912 (depth = 7)
  int op_slot_left_2907 = gc_frame_newslot(call2912);
  params[0] = call2909;
  partcv[0] = 1;
  Object opresult2913 = callmethod(call2912, "==(1)", 1, partcv, params);
// compiled op node returning opresult2913 (depth = 6)
  Object if2906 = done;
  if (istrue(opresult2913)) {
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2915 = alloc_Float64(1);
// compiled num node returning num2915 (depth = 8)
  int op_slot_right_2914 = gc_frame_newslot(num2915);
// starting to compile member node (depth = 8)
  int callframe2917 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call2918 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2917);
// compiled member node returning call2918 (depth = 8)
  int op_slot_left_2914 = gc_frame_newslot(call2918);
  params[0] = num2915;
  partcv[0] = 1;
  Object diff2919 = callmethod(call2918, "-(1)", 1, partcv, params);
// compiled op node returning diff2919 (depth = 7)
  *var_minIndentLevel = diff2919;
  if (diff2919 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2906 = done;
  } else {
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_minInd (depth = 7)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2906 = done;
  }
// compiled if node returning if2906 (depth = 5)
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2922 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2923 = alloc_Block(NULL, NULL, "parser", 928);
  gc_frame_newslot(block2923);
// method "_apply"
  block_savedest(block2923);
  Object closure2924 = createclosure(1, "_apply");
  setclosureframe(closure2924, stackframe);
  addtoclosure(closure2924, selfslot);
  struct UserObject *uo2924 = (struct UserObject*)block2923;
  uo2924->data[0] = (Object)closure2924;
  Method *meth_meth_parser__apply2924 = addmethod2pos(block2923, "_apply", &meth_parser__apply2924, 0);
  int argcv_meth_parser__apply2924[] = {0};
  meth_meth_parser__apply2924->type = alloc_MethodType(1, argcv_meth_parser__apply2924);
  meth_meth_parser__apply2924->definitionModule = modulename;
  meth_meth_parser__apply2924->definitionLine = 3399;
// compiled block node returning block2923 (depth = 6)
  gc_frame_newslot(block2923);
// starting to compile block node (depth = 6)
  Object block2931 = alloc_Block(NULL, NULL, "parser", 928);
  gc_frame_newslot(block2931);
// method "_apply"
  block_savedest(block2931);
  Object closure2932 = createclosure(8, "_apply");
  setclosureframe(closure2932, stackframe);
  addtoclosure(closure2932, var_errormessages);
  addtoclosure(closure2932, var_btok);
  addtoclosure(closure2932, var_lastToken);
  addtoclosure(closure2932, var_sym);
  addtoclosure(closure2932, var_values);
  addtoclosure(closure2932, var_v);
  addtoclosure(closure2932, var_curelse);
  addtoclosure(closure2932, selfslot);
  struct UserObject *uo2932 = (struct UserObject*)block2931;
  uo2932->data[0] = (Object)closure2932;
  Method *meth_meth_parser__apply2932 = addmethod2pos(block2931, "_apply", &meth_parser__apply2932, 0);
  int argcv_meth_parser__apply2932[] = {0};
  meth_meth_parser__apply2932->type = alloc_MethodType(1, argcv_meth_parser__apply2932);
  meth_meth_parser__apply2932->definitionModule = modulename;
  meth_meth_parser__apply2932->definitionLine = 3399;
// compiled block node returning block2931 (depth = 6)
  gc_frame_newslot(block2931);
// call case 5: prelude request
  params[0] = block2923;
  params[1] = block2931;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2990 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2922);
// compiled call node returning call2990 (depth = 5)
// Begin line 946
  setline(946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe2991 = gc_frame_new();
// call case 4: self request
  Object call2992 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2991);
// compiled member node returning call2992 (depth = 5)
    gc_frame_newslot(call2992);
    if2826 = call2992;
  } else {
  }
// compiled if node returning if2826 (depth = 4)
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2993 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2994 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  Object call2995 = callmethodflags(*var_btok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2994);
// compiled member node returning call2995 (depth = 5)
  gc_frame_newslot(call2995);
// starting to compile member node (depth = 5)
  int callframe2996 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  Object call2997 = callmethodflags(*var_btok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2996);
// compiled member node returning call2997 (depth = 5)
  gc_frame_newslot(call2997);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call2995;
  params[1] = call2997;
  partcv[0] = 2;
  Object call2998 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2993);
// compiled call node returning call2998 (depth = 4)
// Begin line 949
  setline(949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2999 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cond (depth = 6)
  gc_frame_newslot(*var_cond);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_body (depth = 6)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elseblock (depth = 6)
  gc_frame_newslot(*var_elseblock);
// call case 4: self request
  params[0] = *var_cond;
  params[1] = *var_body;
  params[2] = *var_elseblock;
  partcv[0] = 3;
  Object call3000 = callmethodflags(self, "newIf(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2999);
// compiled call node returning call3000 (depth = 5)
  *var_o = call3000;
  if (call3000 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3001 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call3002 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3001);
// compiled call node returning call3002 (depth = 4)
    gc_frame_newslot(call3002);
    if2087 = call3002;
  } else {
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3003 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3004 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call3005 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3004);
// compiled member node returning call3005 (depth = 6)
  Object call3006 = callmethodflags(call3005, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3003);
// compiled member node returning call3006 (depth = 5)
  *var_suggestion = call3006;
  if (call3006 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3009 == NULL) {
    strlit3009 = alloc_String("lbrace");
    gc_root(strlit3009);
  }
// compiled string node returning strlit3009 (depth = 6)
  int op_slot_right_3008 = gc_frame_newslot(strlit3009);
// starting to compile member node (depth = 6)
  int callframe3011 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call3012 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3011);
// compiled member node returning call3012 (depth = 6)
  int op_slot_left_3008 = gc_frame_newslot(call3012);
  params[0] = strlit3009;
  partcv[0] = 1;
  Object opresult3013 = callmethod(call3012, "==(1)", 1, partcv, params);
// compiled op node returning opresult3013 (depth = 5)
  Object if3007 = done;
  if (istrue(opresult3013)) {
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3014 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool3015 = alloc_Boolean(0);
// compiled identifier node returning bool3015 (depth = 7)
  gc_frame_newslot(bool3015);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool3015;
  partcv[0] = 2;
  Object call3016 = callmethodflags(self, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3014);
// compiled call node returning call3016 (depth = 6)
  *var_closingBrace = call3016;
  if (call3016 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 956
  setline(956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3018 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3019 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closingBrace (depth = 8)
  Object call3020 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe3019);
// compiled member node returning call3020 (depth = 7)
  Object call3021 = callmethodflags(call3020, "not", 0, partcv, params, 0);
  gc_frame_end(callframe3018);
// compiled member node returning call3021 (depth = 6)
  Object if3017 = done;
  if (istrue(call3021)) {
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_3023 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
  int callframe3025 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  Object call3026 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe3025);
// compiled member node returning call3026 (depth = 8)
  int op_slot_left_3023 = gc_frame_newslot(call3026);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3027 = callmethod(call3026, "==(1)", 1, partcv, params);
// compiled op node returning opresult3027 (depth = 7)
  Object if3022 = done;
  if (istrue(opresult3027)) {
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3028 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool3029 = alloc_Boolean(1);
// compiled identifier node returning bool3029 (depth = 8)
  gc_frame_newslot(bool3029);
// starting to compile identifier node (depth = 8)
  Object bool3030 = alloc_Boolean(0);
// compiled identifier node returning bool3030 (depth = 8)
  gc_frame_newslot(bool3030);
// starting to compile string node (depth = 8)
  if (strlit3031 == NULL) {
    strlit3031 = alloc_String(" then {}");
    gc_root(strlit3031);
  }
// compiled string node returning strlit3031 (depth = 8)
  gc_frame_newslot(strlit3031);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool3029;
  params[2] = bool3030;
  params[3] = strlit3031;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3032 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe3028);
// compiled call node returning call3032 (depth = 7)
    gc_frame_newslot(call3032);
    if3022 = call3032;
  } else {
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3033 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool3034 = alloc_Boolean(1);
// compiled identifier node returning bool3034 (depth = 8)
  gc_frame_newslot(bool3034);
// starting to compile identifier node (depth = 8)
  Object bool3035 = alloc_Boolean(0);
// compiled identifier node returning bool3035 (depth = 8)
  gc_frame_newslot(bool3035);
// starting to compile string node (depth = 8)
  if (strlit3036 == NULL) {
    strlit3036 = alloc_String(" then {");
    gc_root(strlit3036);
  }
// compiled string node returning strlit3036 (depth = 8)
  gc_frame_newslot(strlit3036);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool3034;
  params[2] = bool3035;
  params[3] = strlit3036;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3037 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe3033);
// compiled call node returning call3037 (depth = 7)
// Begin line 961
  setline(961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3038 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3040 = alloc_Float64(0.1);
// compiled num node returning num3040 (depth = 9)
  int op_slot_right_3039 = gc_frame_newslot(num3040);
// starting to compile member node (depth = 9)
  int callframe3042 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe3043 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  Object call3044 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe3043);
// compiled member node returning call3044 (depth = 10)
  Object call3045 = callmethodflags(call3044, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3042);
// compiled member node returning call3045 (depth = 9)
  int op_slot_left_3039 = gc_frame_newslot(call3045);
  params[0] = num3040;
  partcv[0] = 1;
  Object sum3046 = callmethod(call3045, "+(1)", 1, partcv, params);
// compiled op node returning sum3046 (depth = 8)
  gc_frame_newslot(sum3046);
// starting to compile string node (depth = 8)
  if (strlit3047 == NULL) {
    strlit3047 = alloc_String("}");
    gc_root(strlit3047);
  }
// compiled string node returning strlit3047 (depth = 8)
  gc_frame_newslot(strlit3047);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum3046;
  params[1] = strlit3047;
  partcv[0] = 2;
  Object call3048 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3038);
// compiled call node returning call3048 (depth = 7)
    gc_frame_newslot(call3048);
    if3022 = call3048;
  }
// compiled if node returning if3022 (depth = 6)
    gc_frame_newslot(if3022);
    if3017 = if3022;
  } else {
// Begin line 964
  setline(964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3049 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool3050 = alloc_Boolean(1);
// compiled identifier node returning bool3050 (depth = 7)
  gc_frame_newslot(bool3050);
// starting to compile identifier node (depth = 7)
  Object bool3051 = alloc_Boolean(0);
// compiled identifier node returning bool3051 (depth = 7)
  gc_frame_newslot(bool3051);
// starting to compile string node (depth = 7)
  if (strlit3052 == NULL) {
    strlit3052 = alloc_String(" then {");
    gc_root(strlit3052);
  }
// compiled string node returning strlit3052 (depth = 7)
  gc_frame_newslot(strlit3052);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool3050;
  params[2] = bool3051;
  params[3] = strlit3052;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3053 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe3049);
// compiled call node returning call3053 (depth = 6)
    gc_frame_newslot(call3053);
    if3017 = call3053;
  }
// compiled if node returning if3017 (depth = 5)
    gc_frame_newslot(if3017);
    if3007 = if3017;
  } else {
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3054 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool3055 = alloc_Boolean(1);
// compiled identifier node returning bool3055 (depth = 7)
  gc_frame_newslot(bool3055);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool3055;
  partcv[0] = 2;
  Object call3056 = callmethodflags(self, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3054);
// compiled call node returning call3056 (depth = 6)
  *var_closingBrace = call3056;
  if (call3056 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3058 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3059 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closingBrace (depth = 8)
  Object call3060 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe3059);
// compiled member node returning call3060 (depth = 7)
  Object call3061 = callmethodflags(call3060, "not", 0, partcv, params, 0);
  gc_frame_end(callframe3058);
// compiled member node returning call3061 (depth = 6)
  Object if3057 = done;
  if (istrue(call3061)) {
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  int op_slot_right_3063 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
  int callframe3065 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  Object call3066 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe3065);
// compiled member node returning call3066 (depth = 8)
  int op_slot_left_3063 = gc_frame_newslot(call3066);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult3067 = callmethod(call3066, "==(1)", 1, partcv, params);
// compiled op node returning opresult3067 (depth = 7)
  Object if3062 = done;
  if (istrue(opresult3067)) {
// Begin line 970
  setline(970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3068 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3069 == NULL) {
    strlit3069 = alloc_String(" then {}");
    gc_root(strlit3069);
  }
// compiled string node returning strlit3069 (depth = 8)
  gc_frame_newslot(strlit3069);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3069;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3070 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3068);
// compiled call node returning call3070 (depth = 7)
    gc_frame_newslot(call3070);
    if3062 = call3070;
  } else {
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3071 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3072 == NULL) {
    strlit3072 = alloc_String(" then {");
    gc_root(strlit3072);
  }
// compiled string node returning strlit3072 (depth = 8)
  gc_frame_newslot(strlit3072);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3072;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3073 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3071);
// compiled call node returning call3073 (depth = 7)
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3074 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3076 = alloc_Float64(0.1);
// compiled num node returning num3076 (depth = 9)
  int op_slot_right_3075 = gc_frame_newslot(num3076);
// starting to compile member node (depth = 9)
  int callframe3078 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe3079 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  Object call3080 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe3079);
// compiled member node returning call3080 (depth = 10)
  Object call3081 = callmethodflags(call3080, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3078);
// compiled member node returning call3081 (depth = 9)
  int op_slot_left_3075 = gc_frame_newslot(call3081);
  params[0] = num3076;
  partcv[0] = 1;
  Object sum3082 = callmethod(call3081, "+(1)", 1, partcv, params);
// compiled op node returning sum3082 (depth = 8)
  gc_frame_newslot(sum3082);
// starting to compile string node (depth = 8)
  if (strlit3083 == NULL) {
    strlit3083 = alloc_String("}");
    gc_root(strlit3083);
  }
// compiled string node returning strlit3083 (depth = 8)
  gc_frame_newslot(strlit3083);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum3082;
  params[1] = strlit3083;
  partcv[0] = 2;
  Object call3084 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3074);
// compiled call node returning call3084 (depth = 7)
    gc_frame_newslot(call3084);
    if3062 = call3084;
  }
// compiled if node returning if3062 (depth = 6)
    gc_frame_newslot(if3062);
    if3057 = if3062;
  } else {
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3085 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3086 == NULL) {
    strlit3086 = alloc_String(" then {");
    gc_root(strlit3086);
  }
// compiled string node returning strlit3086 (depth = 7)
  gc_frame_newslot(strlit3086);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3086;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3087 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3085);
// compiled call node returning call3087 (depth = 6)
    gc_frame_newslot(call3087);
    if3057 = call3087;
  }
// compiled if node returning if3057 (depth = 5)
    gc_frame_newslot(if3057);
    if3007 = if3057;
  }
// compiled if node returning if3007 (depth = 4)
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3088 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3090 == NULL) {
    strlit3090 = alloc_String("the condition in parentheses.");
    gc_root(strlit3090);
  }
// compiled string node returning strlit3090 (depth = 6)
  int op_slot_right_3089 = gc_frame_newslot(strlit3090);
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3092 == NULL) {
    strlit3092 = alloc_String("an if statement must have 'then' after ");
    gc_root(strlit3092);
  }
// compiled string node returning strlit3092 (depth = 6)
  int op_slot_left_3089 = gc_frame_newslot(strlit3092);
  params[0] = strlit3090;
  partcv[0] = 1;
  Object opresult3093 = callmethod(strlit3092, "++(1)", 1, partcv, params);
// compiled op node returning opresult3093 (depth = 5)
  gc_frame_newslot(opresult3093);
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3094 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call3095 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3094);
// compiled member node returning call3095 (depth = 5)
  gc_frame_newslot(call3095);
// starting to compile member node (depth = 5)
  int callframe3096 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call3097 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3096);
// compiled member node returning call3097 (depth = 5)
  gc_frame_newslot(call3097);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult3093;
  params[1] = call3095;
  params[2] = call3097;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3098 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3088);
// compiled call node returning call3098 (depth = 4)
    gc_frame_newslot(call3098);
    if2087 = call3098;
  }
// compiled if node returning if2087 (depth = 3)
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localMin (depth = 4)
  *var_minIndentLevel = *var_localMin;
  if (*var_localMin == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localStatementIndent (depth = 4)
  *var_statementIndent = *var_localStatementIndent;
  if (*var_localStatementIndent == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if1720 = done;
  } else {
  }
// compiled if node returning if1720 (depth = 2)
  gc_frame_end(frame);
  return if1720;
}
Object meth_parser_identifier3101(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "identifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 991
  setline(991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3103 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3104 == NULL) {
    strlit3104 = alloc_String("identifier");
    gc_root(strlit3104);
  }
// compiled string node returning strlit3104 (depth = 4)
  gc_frame_newslot(strlit3104);
// call case 4: self request
  params[0] = strlit3104;
  partcv[0] = 1;
  Object call3105 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3103);
// compiled call node returning call3105 (depth = 3)
  Object if3102 = done;
  if (istrue(call3105)) {
// Begin line 992
  setline(992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3108 == NULL) {
    strlit3108 = alloc_String("if");
    gc_root(strlit3108);
  }
// compiled string node returning strlit3108 (depth = 5)
  int op_slot_right_3107 = gc_frame_newslot(strlit3108);
// starting to compile member node (depth = 5)
  int callframe3110 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call3111 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3110);
// compiled member node returning call3111 (depth = 5)
  int op_slot_left_3107 = gc_frame_newslot(call3111);
  params[0] = strlit3108;
  partcv[0] = 1;
  Object opresult3112 = callmethod(call3111, "==(1)", 1, partcv, params);
// compiled op node returning opresult3112 (depth = 4)
  Object if3106 = done;
  if (istrue(opresult3112)) {
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3113 = gc_frame_new();
// call case 4: self request
  Object call3114 = callmethodflags(self, "doif", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3113);
// compiled member node returning call3114 (depth = 4)
    gc_frame_newslot(call3114);
    if3106 = call3114;
  } else {
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3115 = gc_frame_new();
// call case 4: self request
  Object call3116 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3115);
// compiled member node returning call3116 (depth = 4)
    gc_frame_newslot(call3116);
    if3106 = call3116;
  }
// compiled if node returning if3106 (depth = 3)
    gc_frame_newslot(if3106);
    if3102 = if3106;
  } else {
  }
// compiled if node returning if3102 (depth = 2)
  gc_frame_end(frame);
  return if3102;
}
Object meth_parser__apply3136(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe3137 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3138 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3137);
// compiled call node returning call3138 (depth = 8)
  gc_frame_end(frame);
  return call3138;
}
Object meth_parser__apply3205(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 8)
  int callframe3206 = gc_frame_new();
// call case 4: self request
  Object call3207 = callmethodflags(self, "term", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3206);
// compiled member node returning call3207 (depth = 8)
  gc_frame_end(frame);
  return call3207;
}
Object meth_parser_prefixop3117(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "prefixop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_op = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "op");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
  Object *var_suggestions = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestions");
  Object *var_rcvr = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "rcvr");
  Object *var_call = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "call");
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3119 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3120 == NULL) {
    strlit3120 = alloc_String("op");
    gc_root(strlit3120);
  }
// compiled string node returning strlit3120 (depth = 4)
  gc_frame_newslot(strlit3120);
// call case 4: self request
  params[0] = strlit3120;
  partcv[0] = 1;
  Object call3121 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3119);
// compiled call node returning call3121 (depth = 3)
  Object if3118 = done;
  if (istrue(call3121)) {
// Begin line 1002
  setline(1002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3122 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call3123 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3122);
// compiled member node returning call3123 (depth = 4)
  *var_op = call3123;
  if (call3123 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3124 = gc_frame_new();
// call case 4: self request
  Object call3125 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3124);
// compiled member node returning call3125 (depth = 3)
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3127 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3128 == NULL) {
    strlit3128 = alloc_String("lparen");
    gc_root(strlit3128);
  }
// compiled string node returning strlit3128 (depth = 5)
  gc_frame_newslot(strlit3128);
// call case 4: self request
  params[0] = strlit3128;
  partcv[0] = 1;
  Object call3129 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3127);
// compiled call node returning call3129 (depth = 4)
  Object if3126 = done;
  if (istrue(call3129)) {
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3130 = gc_frame_new();
// call case 4: self request
  Object call3131 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3130);
// compiled member node returning call3131 (depth = 4)
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3133 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe3134 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block3135 = alloc_Block(NULL, NULL, "parser", 1006);
  gc_frame_newslot(block3135);
// method "_apply"
  block_savedest(block3135);
  Object closure3136 = createclosure(2, "_apply");
  setclosureframe(closure3136, stackframe);
  addtoclosure(closure3136, var_blocksOK);
  addtoclosure(closure3136, selfslot);
  struct UserObject *uo3136 = (struct UserObject*)block3135;
  uo3136->data[0] = (Object)closure3136;
  Method *meth_meth_parser__apply3136 = addmethod2pos(block3135, "_apply", &meth_parser__apply3136, 0);
  int argcv_meth_parser__apply3136[] = {0};
  meth_meth_parser__apply3136->type = alloc_MethodType(1, argcv_meth_parser__apply3136);
  meth_meth_parser__apply3136->definitionModule = modulename;
  meth_meth_parser__apply3136->definitionLine = 3399;
// compiled block node returning block3135 (depth = 7)
  gc_frame_newslot(block3135);
// call case 4: self request
  params[0] = block3135;
  partcv[0] = 1;
  Object call3140 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3134);
// compiled call node returning call3140 (depth = 6)
  Object call3141 = callmethodflags(call3140, "not", 0, partcv, params, 0);
  gc_frame_end(callframe3133);
// compiled member node returning call3141 (depth = 5)
  Object if3132 = done;
  if (istrue(call3141)) {
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3142 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3143 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call3144 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3143);
// compiled member node returning call3144 (depth = 7)
  Object call3145 = callmethodflags(call3144, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3142);
// compiled member node returning call3145 (depth = 6)
  *var_suggestion = call3145;
  if (call3145 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1008
  setline(1008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3146 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array3147 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit3148 == NULL) {
    strlit3148 = alloc_String("rparen");
    gc_root(strlit3148);
  }
// compiled string node returning strlit3148 (depth = 8)
  params[0] = strlit3148;
  partcv[0] = 1;
  callmethodflags(array3147, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3147 (depth = 7)
  gc_frame_newslot(array3147);
// call case 4: self request
  params[0] = array3147;
  partcv[0] = 1;
  Object call3149 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3146);
// compiled call node returning call3149 (depth = 6)
  *var_nextTok = call3149;
  if (call3149 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1009
  setline(1009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_3151 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_3151 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3153 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3153 (depth = 6)
  Object if3150 = done;
  if (istrue(opresult3153)) {
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3154 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3155 == NULL) {
    strlit3155 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3155);
  }
// compiled string node returning strlit3155 (depth = 7)
  gc_frame_newslot(strlit3155);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3155;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3156 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3154);
// compiled call node returning call3156 (depth = 6)
    gc_frame_newslot(call3156);
    if3150 = call3156;
  } else {
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3157 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe3158 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call3159 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe3158);
// compiled member node returning call3159 (depth = 7)
  gc_frame_newslot(call3159);
// starting to compile identifier node (depth = 7)
  Object bool3160 = alloc_Boolean(1);
// compiled identifier node returning bool3160 (depth = 7)
  gc_frame_newslot(bool3160);
// starting to compile identifier node (depth = 7)
  Object bool3161 = alloc_Boolean(0);
// compiled identifier node returning bool3161 (depth = 7)
  gc_frame_newslot(bool3161);
// starting to compile string node (depth = 7)
  if (strlit3162 == NULL) {
    strlit3162 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3162);
  }
// compiled string node returning strlit3162 (depth = 7)
  gc_frame_newslot(strlit3162);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call3159;
  params[2] = bool3160;
  params[3] = bool3161;
  params[4] = strlit3162;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3163 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe3157);
// compiled call node returning call3163 (depth = 6)
    gc_frame_newslot(call3163);
    if3150 = call3163;
  }
// compiled if node returning if3150 (depth = 5)
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3164 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3165 == NULL) {
    strlit3165 = alloc_String("parentheses must contain a valid expression.");
    gc_root(strlit3165);
  }
// compiled string node returning strlit3165 (depth = 6)
  gc_frame_newslot(strlit3165);
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3166 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call3167 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3166);
// compiled member node returning call3167 (depth = 6)
  gc_frame_newslot(call3167);
// starting to compile member node (depth = 6)
  int callframe3168 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call3169 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3168);
// compiled member node returning call3169 (depth = 6)
  gc_frame_newslot(call3169);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3165;
  params[1] = call3167;
  params[2] = call3169;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3170 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3164);
// compiled call node returning call3170 (depth = 5)
    gc_frame_newslot(call3170);
    if3132 = call3170;
  } else {
  }
// compiled if node returning if3132 (depth = 4)
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3173 == NULL) {
    strlit3173 = alloc_String("rparen");
    gc_root(strlit3173);
  }
// compiled string node returning strlit3173 (depth = 6)
  int op_slot_right_3172 = gc_frame_newslot(strlit3173);
// starting to compile member node (depth = 6)
  int callframe3175 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call3176 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3175);
// compiled member node returning call3176 (depth = 6)
  int op_slot_left_3172 = gc_frame_newslot(call3176);
  params[0] = strlit3173;
  partcv[0] = 1;
  Object opresult3177 = callmethod(call3176, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3177 (depth = 5)
  Object if3171 = done;
  if (istrue(opresult3177)) {
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3178 = gc_frame_new();
// call case 4: self request
  Object call3179 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3178);
// compiled member node returning call3179 (depth = 5)
// Begin line 1019
  setline(1019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3180 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3181 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call3182 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3181);
// compiled member node returning call3182 (depth = 7)
  Object call3183 = callmethodflags(call3182, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3180);
// compiled member node returning call3183 (depth = 6)
  *var_suggestion = call3183;
  if (call3183 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3184 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3185 == NULL) {
    strlit3185 = alloc_String(")");
    gc_root(strlit3185);
  }
// compiled string node returning strlit3185 (depth = 6)
  gc_frame_newslot(strlit3185);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit3185;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3186 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3184);
// compiled call node returning call3186 (depth = 5)
// Begin line 1021
  setline(1021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3187 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3188 == NULL) {
    strlit3188 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3188);
  }
// compiled string node returning strlit3188 (depth = 6)
  gc_frame_newslot(strlit3188);
// Begin line 1022
  setline(1022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3189 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call3190 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3189);
// compiled member node returning call3190 (depth = 6)
  gc_frame_newslot(call3190);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3192 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call3193 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3192);
// compiled member node returning call3193 (depth = 7)
  int op_slot_right_3191 = gc_frame_newslot(call3193);
// starting to compile member node (depth = 7)
  int callframe3195 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call3196 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3195);
// compiled member node returning call3196 (depth = 7)
  int op_slot_left_3191 = gc_frame_newslot(call3196);
  params[0] = call3193;
  partcv[0] = 1;
  Object sum3197 = callmethod(call3196, "+(1)", 1, partcv, params);
// compiled op node returning sum3197 (depth = 6)
  gc_frame_newslot(sum3197);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1021
  setline(1021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3188;
  params[1] = call3190;
  params[2] = sum3197;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3198 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3187);
// compiled call node returning call3198 (depth = 5)
    gc_frame_newslot(call3198);
    if3171 = call3198;
  } else {
  }
// compiled if node returning if3171 (depth = 4)
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3199 = gc_frame_new();
// call case 4: self request
  Object call3200 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3199);
// compiled member node returning call3200 (depth = 4)
    gc_frame_newslot(call3200);
    if3126 = call3200;
  } else {
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3202 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe3203 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block3204 = alloc_Block(NULL, NULL, "parser", 1026);
  gc_frame_newslot(block3204);
// method "_apply"
  block_savedest(block3204);
  Object closure3205 = createclosure(1, "_apply");
  setclosureframe(closure3205, stackframe);
  addtoclosure(closure3205, selfslot);
  struct UserObject *uo3205 = (struct UserObject*)block3204;
  uo3205->data[0] = (Object)closure3205;
  Method *meth_meth_parser__apply3205 = addmethod2pos(block3204, "_apply", &meth_parser__apply3205, 0);
  int argcv_meth_parser__apply3205[] = {0};
  meth_meth_parser__apply3205->type = alloc_MethodType(1, argcv_meth_parser__apply3205);
  meth_meth_parser__apply3205->definitionModule = modulename;
  meth_meth_parser__apply3205->definitionLine = 3399;
// compiled block node returning block3204 (depth = 7)
  gc_frame_newslot(block3204);
// call case 4: self request
  params[0] = block3204;
  partcv[0] = 1;
  Object call3209 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3203);
// compiled call node returning call3209 (depth = 6)
  Object call3210 = callmethodflags(call3209, "not", 0, partcv, params, 0);
  gc_frame_end(callframe3202);
// compiled member node returning call3210 (depth = 5)
  Object if3201 = done;
  if (istrue(call3210)) {
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array3211 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3211 (depth = 6)
  *var_suggestions = array3211;
  if (array3211 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3212 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3213 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call3214 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3213);
// compiled member node returning call3214 (depth = 7)
  Object call3215 = callmethodflags(call3214, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3212);
// compiled member node returning call3215 (depth = 6)
  *var_suggestion = call3215;
  if (call3215 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1029
  setline(1029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3216 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array3217 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit3218 == NULL) {
    strlit3218 = alloc_String("rparen");
    gc_root(strlit3218);
  }
// compiled string node returning strlit3218 (depth = 8)
  params[0] = strlit3218;
  partcv[0] = 1;
  callmethodflags(array3217, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3217 (depth = 7)
  gc_frame_newslot(array3217);
// call case 4: self request
  params[0] = array3217;
  partcv[0] = 1;
  Object call3219 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3216);
// compiled call node returning call3219 (depth = 6)
  *var_nextTok = call3219;
  if (call3219 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_3221 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_3221 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3223 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3223 (depth = 6)
  Object if3220 = done;
  if (istrue(opresult3223)) {
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3224 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3225 == NULL) {
    strlit3225 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3225);
  }
// compiled string node returning strlit3225 (depth = 7)
  gc_frame_newslot(strlit3225);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3225;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3226 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3224);
// compiled call node returning call3226 (depth = 6)
    gc_frame_newslot(call3226);
    if3220 = call3226;
  } else {
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3227 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe3228 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call3229 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe3228);
// compiled member node returning call3229 (depth = 7)
  gc_frame_newslot(call3229);
// starting to compile identifier node (depth = 7)
  Object bool3230 = alloc_Boolean(1);
// compiled identifier node returning bool3230 (depth = 7)
  gc_frame_newslot(bool3230);
// starting to compile identifier node (depth = 7)
  Object bool3231 = alloc_Boolean(0);
// compiled identifier node returning bool3231 (depth = 7)
  gc_frame_newslot(bool3231);
// starting to compile string node (depth = 7)
  if (strlit3232 == NULL) {
    strlit3232 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3232);
  }
// compiled string node returning strlit3232 (depth = 7)
  gc_frame_newslot(strlit3232);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call3229;
  params[2] = bool3230;
  params[3] = bool3231;
  params[4] = strlit3232;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3233 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe3227);
// compiled call node returning call3233 (depth = 6)
    gc_frame_newslot(call3233);
    if3220 = call3233;
  }
// compiled if node returning if3220 (depth = 5)
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3234 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3235 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3234);
// compiled call node returning call3235 (depth = 5)
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3238 == NULL) {
    strlit3238 = alloc_String("bind");
    gc_root(strlit3238);
  }
// compiled string node returning strlit3238 (depth = 7)
  int op_slot_right_3237 = gc_frame_newslot(strlit3238);
// starting to compile member node (depth = 7)
  int callframe3240 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3241 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call3242 = callmethodflags(*var_lastToken, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe3241);
// compiled member node returning call3242 (depth = 8)
  Object call3243 = callmethodflags(call3242, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3240);
// compiled member node returning call3243 (depth = 7)
  int op_slot_left_3237 = gc_frame_newslot(call3243);
  params[0] = strlit3238;
  partcv[0] = 1;
  Object opresult3244 = callmethod(call3243, "==(1)", 1, partcv, params);
// compiled op node returning opresult3244 (depth = 6)
  Object if3236 = done;
  if (istrue(opresult3244)) {
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3245 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3246 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call3247 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3246);
// compiled member node returning call3247 (depth = 8)
  Object call3248 = callmethodflags(call3247, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3245);
// compiled member node returning call3248 (depth = 7)
  *var_suggestion = call3248;
  if (call3248 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3250 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
  int callframe3251 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call3252 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe3251);
// compiled member node returning call3252 (depth = 7)
  gc_frame_newslot(call3252);
// starting to compile identifier node (depth = 7)
  Object bool3253 = alloc_Boolean(1);
// compiled identifier node returning bool3253 (depth = 7)
  gc_frame_newslot(bool3253);
// starting to compile identifier node (depth = 7)
  Object bool3254 = alloc_Boolean(0);
// compiled identifier node returning bool3254 (depth = 7)
  gc_frame_newslot(bool3254);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call3252;
  params[2] = bool3253;
  params[3] = bool3254;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3255 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3250);
// compiled call node returning call3255 (depth = 6)
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3256 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe3257 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call3258 = callmethodflags(*var_lastToken, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe3257);
// compiled member node returning call3258 (depth = 7)
  gc_frame_newslot(call3258);
// starting to compile identifier node (depth = 7)
  Object bool3259 = alloc_Boolean(1);
// compiled identifier node returning bool3259 (depth = 7)
  gc_frame_newslot(bool3259);
// starting to compile identifier node (depth = 7)
  Object bool3260 = alloc_Boolean(0);
// compiled identifier node returning bool3260 (depth = 7)
  gc_frame_newslot(bool3260);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = call3258;
  params[1] = bool3259;
  params[2] = bool3260;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3261 = callmethodflags(*var_suggestion, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3256);
// compiled call node returning call3261 (depth = 6)
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3262 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3263 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3262);
// compiled call node returning call3263 (depth = 6)
    gc_frame_newslot(call3263);
    if3236 = call3263;
  } else {
  }
// compiled if node returning if3236 (depth = 5)
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3264 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3265 == NULL) {
    strlit3265 = alloc_String("a prefix operator must be followed by an expression.");
    gc_root(strlit3265);
  }
// compiled string node returning strlit3265 (depth = 6)
  gc_frame_newslot(strlit3265);
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3266 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call3267 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3266);
// compiled member node returning call3267 (depth = 6)
  gc_frame_newslot(call3267);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3269 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call3270 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3269);
// compiled member node returning call3270 (depth = 7)
  int op_slot_right_3268 = gc_frame_newslot(call3270);
// starting to compile member node (depth = 7)
  int callframe3272 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call3273 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3272);
// compiled member node returning call3273 (depth = 7)
  int op_slot_left_3268 = gc_frame_newslot(call3273);
  params[0] = call3270;
  partcv[0] = 1;
  Object sum3274 = callmethod(call3273, "+(1)", 1, partcv, params);
// compiled op node returning sum3274 (depth = 6)
  gc_frame_newslot(sum3274);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3265;
  params[1] = call3267;
  params[2] = sum3274;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3275 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3264);
// compiled call node returning call3275 (depth = 5)
    gc_frame_newslot(call3275);
    if3201 = call3275;
  } else {
  }
// compiled if node returning if3201 (depth = 4)
    gc_frame_newslot(if3201);
    if3126 = if3201;
  }
// compiled if node returning if3126 (depth = 3)
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3276 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3277 = callmethodflags(self, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3276);
// compiled call node returning call3277 (depth = 3)
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3278 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3279 = callmethodflags(self, "callrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3278);
// compiled call node returning call3279 (depth = 3)
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3280 = gc_frame_new();
// call case 4: self request
  Object call3281 = callmethodflags(self, "postfixsquare", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3280);
// compiled member node returning call3281 (depth = 3)
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3282 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call3283 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe3282);
// compiled member node returning call3283 (depth = 4)
  *var_rcvr = call3283;
  if (call3283 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3284 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_rcvr (depth = 5)
  gc_frame_newslot(*var_rcvr);
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 5)
  Object array3285 = alloc_BuiltinList();
  gc_pause();
// starting to compile call node (depth = 6)
  int callframe3286 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_op (depth = 8)
  int op_slot_right_3287 = gc_frame_newslot(*var_op);
// starting to compile string node (depth = 8)
  if (strlit3289 == NULL) {
    strlit3289 = alloc_String("prefix");
    gc_root(strlit3289);
  }
// compiled string node returning strlit3289 (depth = 8)
  int op_slot_left_3287 = gc_frame_newslot(strlit3289);
  params[0] = *var_op;
  partcv[0] = 1;
  Object opresult3290 = callmethod(strlit3289, "++(1)", 1, partcv, params);
// compiled op node returning opresult3290 (depth = 7)
  gc_frame_newslot(opresult3290);
// starting to compile array node (depth = 7)
  Object array3291 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3291 (depth = 7)
  gc_frame_newslot(array3291);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3292 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  Object call3293 = callmethodflags(*var_ast, "requestPart", 0, partcv, params, 0);
  gc_frame_end(callframe3292);
// compiled member node returning call3293 (depth = 7)
  params[0] = opresult3290;
  params[1] = array3291;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3294 = callmethodflags(call3293, "request(1)withArgs(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3286);
// compiled call node returning call3294 (depth = 6)
  params[0] = call3294;
  partcv[0] = 1;
  callmethodflags(array3285, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3285 (depth = 5)
  gc_frame_newslot(array3285);
// call case 6: other requests
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3295 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call3296 = callmethodflags(*var_ast, "callNode", 0, partcv, params, 0);
  gc_frame_end(callframe3295);
// compiled member node returning call3296 (depth = 5)
  params[0] = *var_rcvr;
  params[1] = array3285;
  partcv[0] = 2;
  Object call3297 = callmethodflags(call3296, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3284);
// compiled call node returning call3297 (depth = 4)
  *var_call = call3297;
  if (call3297 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1052
  setline(1052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3298 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_call (depth = 4)
  gc_frame_newslot(*var_call);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_call;
  partcv[0] = 1;
  Object call3299 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3298);
// compiled call node returning call3299 (depth = 3)
    gc_frame_newslot(call3299);
    if3118 = call3299;
  } else {
  }
// compiled if node returning if3118 (depth = 2)
  gc_frame_end(frame);
  return if3118;
}
Object meth_parser__apply3312(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe3313 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3314 == NULL) {
    strlit3314 = alloc_String("identifier");
    gc_root(strlit3314);
  }
// compiled string node returning strlit3314 (depth = 6)
  gc_frame_newslot(strlit3314);
// call case 4: self request
  params[0] = strlit3314;
  partcv[0] = 1;
  Object call3315 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3313);
// compiled call node returning call3315 (depth = 5)
  gc_frame_end(frame);
  return call3315;
}
Object meth_parser__apply3323(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe3324 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3325 == NULL) {
    strlit3325 = alloc_String("dot");
    gc_root(strlit3325);
  }
// compiled string node returning strlit3325 (depth = 8)
  gc_frame_newslot(strlit3325);
// call case 4: self request
  params[0] = strlit3325;
  partcv[0] = 1;
  Object call3326 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3324);
// compiled call node returning call3326 (depth = 7)
  gc_frame_end(frame);
  return call3326;
}
Object meth_parser__apply3329(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_memberIn = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "memberIn");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_memberName = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "memberName");
  Object *var_memberNd = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "memberNd");
// Begin line 1065
  setline(1065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3330 = gc_frame_new();
// call case 4: self request
  Object call3331 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3330);
// compiled member node returning call3331 (depth = 7)
// Begin line 1066
  setline(1066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3332 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  Object call3333 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe3332);
// compiled member node returning call3333 (depth = 8)
  *var_memberIn = call3333;
  if (call3333 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3336 == NULL) {
    strlit3336 = alloc_String("identifier");
    gc_root(strlit3336);
  }
// compiled string node returning strlit3336 (depth = 9)
  int op_slot_right_3335 = gc_frame_newslot(strlit3336);
// starting to compile member node (depth = 9)
  int callframe3338 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call3339 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3338);
// compiled member node returning call3339 (depth = 9)
  int op_slot_left_3335 = gc_frame_newslot(call3339);
  params[0] = strlit3336;
  partcv[0] = 1;
  Object opresult3340 = callmethod(call3339, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3340 (depth = 8)
  Object if3334 = done;
  if (istrue(opresult3340)) {
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile array node (depth = 9)
  Object array3341 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3341 (depth = 9)
  *var_suggestions = array3341;
  if (array3341 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 1069
  setline(1069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3342 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe3343 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call3344 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3343);
// compiled member node returning call3344 (depth = 10)
  Object call3345 = callmethodflags(call3344, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3342);
// compiled member node returning call3345 (depth = 9)
  *var_suggestion = call3345;
  if (call3345 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 1070
  setline(1070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3346 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3347 == NULL) {
    strlit3347 = alloc_String("""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit3347);
  }
// compiled string node returning strlit3347 (depth = 9)
  gc_frame_newslot(strlit3347);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3347;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3348 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3346);
// compiled call node returning call3348 (depth = 8)
// Begin line 1071
  setline(1071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3349 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3350 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3349);
// compiled call node returning call3350 (depth = 8)
// Begin line 1072
  setline(1072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3351 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe3352 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call3353 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3352);
// compiled member node returning call3353 (depth = 10)
  Object call3354 = callmethodflags(call3353, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3351);
// compiled member node returning call3354 (depth = 9)
  *var_suggestion = call3354;
  if (call3354 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 1073
  setline(1073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3356 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3357 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3356);
// compiled call node returning call3357 (depth = 8)
// Begin line 1074
  setline(1074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3358 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3359 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3358);
// compiled call node returning call3359 (depth = 8)
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3360 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3361 == NULL) {
    strlit3361 = alloc_String("a type name must follow the '.'.");
    gc_root(strlit3361);
  }
// compiled string node returning strlit3361 (depth = 9)
  gc_frame_newslot(strlit3361);
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe3362 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call3363 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3362);
// compiled member node returning call3363 (depth = 9)
  gc_frame_newslot(call3363);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3365 = alloc_Float64(1);
// compiled num node returning num3365 (depth = 10)
  int op_slot_right_3364 = gc_frame_newslot(num3365);
// starting to compile member node (depth = 10)
  int callframe3367 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  Object call3368 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3367);
// compiled member node returning call3368 (depth = 10)
  int op_slot_left_3364 = gc_frame_newslot(call3368);
  params[0] = num3365;
  partcv[0] = 1;
  Object sum3369 = callmethod(call3368, "+(1)", 1, partcv, params);
// compiled op node returning sum3369 (depth = 9)
  gc_frame_newslot(sum3369);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit3361;
  params[1] = call3363;
  params[2] = sum3369;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3370 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3360);
// compiled call node returning call3370 (depth = 8)
    gc_frame_newslot(call3370);
    if3334 = call3370;
  } else {
  }
// compiled if node returning if3334 (depth = 7)
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3371 = gc_frame_new();
// call case 4: self request
  Object call3372 = callmethodflags(self, "identifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3371);
// compiled member node returning call3372 (depth = 7)
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3373 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  Object call3374 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe3373);
// compiled member node returning call3374 (depth = 8)
  *var_memberName = call3374;
  if (call3374 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3375 = gc_frame_new();
// starting to compile member node (depth = 9)
  int callframe3376 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_memberName (depth = 10)
  Object call3377 = callmethodflags(*var_memberName, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3376);
// compiled member node returning call3377 (depth = 9)
  gc_frame_newslot(call3377);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_memberIn (depth = 9)
  gc_frame_newslot(*var_memberIn);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3378 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ast (depth = 10)
  Object call3379 = callmethodflags(*var_ast, "memberNode", 0, partcv, params, 0);
  gc_frame_end(callframe3378);
// compiled member node returning call3379 (depth = 9)
  params[0] = call3377;
  params[1] = *var_memberIn;
  partcv[0] = 2;
  Object call3380 = callmethodflags(call3379, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3375);
// compiled call node returning call3380 (depth = 8)
  *var_memberNd = call3380;
  if (call3380 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1081
  setline(1081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3381 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe3382 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_memberName (depth = 9)
  Object call3383 = callmethodflags(*var_memberName, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3382);
// compiled member node returning call3383 (depth = 8)
  gc_frame_newslot(call3383);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_memberNd (depth = 8)
  params[0] = call3383;
  partcv[0] = 1;
  Object call3384 = callmethodflags(*var_memberNd, "line:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3381);
// compiled call node returning call3384 (depth = 7)
// Begin line 1082
  setline(1082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3385 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe3386 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_memberName (depth = 9)
  Object call3387 = callmethodflags(*var_memberName, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3386);
// compiled member node returning call3387 (depth = 8)
  gc_frame_newslot(call3387);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_memberNd (depth = 8)
  params[0] = call3387;
  partcv[0] = 1;
  Object call3388 = callmethodflags(*var_memberNd, "linePos:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3385);
// compiled call node returning call3388 (depth = 7)
// Begin line 1083
  setline(1083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3389 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_memberNd (depth = 8)
  gc_frame_newslot(*var_memberNd);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  params[0] = *var_memberNd;
  partcv[0] = 1;
  Object call3390 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3389);
// compiled call node returning call3390 (depth = 7)
  gc_frame_end(frame);
  return call3390;
}
Object meth_parser__apply3318(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object *var_gens = getfromclosure(closure, 5);
  Object *var_startToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3319 = gc_frame_new();
// call case 4: self request
  Object call3320 = callmethodflags(self, "identifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3319);
// compiled member node returning call3320 (depth = 5)
// Begin line 1064
  setline(1064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3321 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3322 = alloc_Block(NULL, NULL, "parser", 1064);
  gc_frame_newslot(block3322);
// method "_apply"
  block_savedest(block3322);
  Object closure3323 = createclosure(1, "_apply");
  setclosureframe(closure3323, stackframe);
  addtoclosure(closure3323, selfslot);
  struct UserObject *uo3323 = (struct UserObject*)block3322;
  uo3323->data[0] = (Object)closure3323;
  Method *meth_meth_parser__apply3323 = addmethod2pos(block3322, "_apply", &meth_parser__apply3323, 0);
  int argcv_meth_parser__apply3323[] = {0};
  meth_meth_parser__apply3323->type = alloc_MethodType(1, argcv_meth_parser__apply3323);
  meth_meth_parser__apply3323->definitionModule = modulename;
  meth_meth_parser__apply3323->definitionLine = 3399;
// compiled block node returning block3322 (depth = 6)
  gc_frame_newslot(block3322);
// starting to compile block node (depth = 6)
  Object block3328 = alloc_Block(NULL, NULL, "parser", 1064);
  gc_frame_newslot(block3328);
// method "_apply"
  block_savedest(block3328);
  Object closure3329 = createclosure(6, "_apply");
  setclosureframe(closure3329, stackframe);
  addtoclosure(closure3329, var_values);
  addtoclosure(closure3329, var_sym);
  addtoclosure(closure3329, var_errormessages);
  addtoclosure(closure3329, var_lastToken);
  addtoclosure(closure3329, var_ast);
  addtoclosure(closure3329, selfslot);
  struct UserObject *uo3329 = (struct UserObject*)block3328;
  uo3329->data[0] = (Object)closure3329;
  Method *meth_meth_parser__apply3329 = addmethod2pos(block3328, "_apply", &meth_parser__apply3329, 0);
  int argcv_meth_parser__apply3329[] = {0};
  meth_meth_parser__apply3329->type = alloc_MethodType(1, argcv_meth_parser__apply3329);
  meth_meth_parser__apply3329->definitionModule = modulename;
  meth_meth_parser__apply3329->definitionLine = 3399;
// compiled block node returning block3328 (depth = 6)
  gc_frame_newslot(block3328);
// call case 5: prelude request
  params[0] = block3322;
  params[1] = block3328;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3392 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3321);
// compiled call node returning call3392 (depth = 5)
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3393 = gc_frame_new();
// call case 4: self request
  Object call3394 = callmethodflags(self, "generic", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3393);
// compiled member node returning call3394 (depth = 5)
// Begin line 1086
  setline(1086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3395 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe3396 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call3397 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe3396);
// compiled member node returning call3397 (depth = 6)
  gc_frame_newslot(call3397);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_gens (depth = 6)
  params[0] = call3397;
  partcv[0] = 1;
  Object call3398 = callmethodflags(*var_gens, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3395);
// compiled call node returning call3398 (depth = 5)
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3400 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3401 == NULL) {
    strlit3401 = alloc_String("comma");
    gc_root(strlit3401);
  }
// compiled string node returning strlit3401 (depth = 7)
  gc_frame_newslot(strlit3401);
// call case 4: self request
  params[0] = strlit3401;
  partcv[0] = 1;
  Object call3402 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3400);
// compiled call node returning call3402 (depth = 6)
  Object if3399 = done;
  if (istrue(call3402)) {
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3403 = gc_frame_new();
// call case 4: self request
  Object call3404 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3403);
// compiled member node returning call3404 (depth = 6)
    gc_frame_newslot(call3404);
    if3399 = call3404;
  } else {
// Begin line 1090
  setline(1090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3407 == NULL) {
    strlit3407 = alloc_String("rgeneric");
    gc_root(strlit3407);
  }
// compiled string node returning strlit3407 (depth = 8)
  int op_slot_right_3406 = gc_frame_newslot(strlit3407);
// starting to compile member node (depth = 8)
  int callframe3409 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call3410 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3409);
// compiled member node returning call3410 (depth = 8)
  int op_slot_left_3406 = gc_frame_newslot(call3410);
  params[0] = strlit3407;
  partcv[0] = 1;
  Object opresult3411 = callmethod(call3410, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3411 (depth = 7)
  Object if3405 = done;
  if (istrue(opresult3411)) {
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3412 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3413 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call3414 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3413);
// compiled member node returning call3414 (depth = 9)
  Object call3415 = callmethodflags(call3414, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3412);
// compiled member node returning call3415 (depth = 8)
  *var_suggestion = call3415;
  if (call3415 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3416 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3417 == NULL) {
    strlit3417 = alloc_String(">");
    gc_root(strlit3417);
  }
// compiled string node returning strlit3417 (depth = 8)
  gc_frame_newslot(strlit3417);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3417;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3418 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3416);
// compiled call node returning call3418 (depth = 7)
// Begin line 1093
  setline(1093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3419 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3420 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call3421 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3420);
// compiled member node returning call3421 (depth = 9)
  Object call3422 = callmethodflags(call3421, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3419);
// compiled member node returning call3422 (depth = 8)
  *var_suggestion2 = call3422;
  if (call3422 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1094
  setline(1094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3423 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3424 == NULL) {
    strlit3424 = alloc_String(" ");
    gc_root(strlit3424);
  }
// compiled string node returning strlit3424 (depth = 8)
  gc_frame_newslot(strlit3424);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_startToken (depth = 8)
  gc_frame_newslot(*var_startToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion2 (depth = 8)
  params[0] = strlit3424;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3425 = callmethodflags(*var_suggestion2, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3423);
// compiled call node returning call3425 (depth = 7)
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile array node (depth = 8)
  Object array3426 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethodflags(array3426, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion2 (depth = 9)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethodflags(array3426, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3426 (depth = 8)
  *var_suggestions = array3426;
  if (array3426 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1096
  setline(1096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3427 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3428 == NULL) {
    strlit3428 = alloc_String("a type containing a '<' must end with a '>', or the '<' operator must have a space before it.");
    gc_root(strlit3428);
  }
// compiled string node returning strlit3428 (depth = 8)
  gc_frame_newslot(strlit3428);
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe3429 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call3430 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3429);
// compiled member node returning call3430 (depth = 8)
  gc_frame_newslot(call3430);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3432 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call3433 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3432);
// compiled member node returning call3433 (depth = 9)
  int op_slot_right_3431 = gc_frame_newslot(call3433);
// starting to compile member node (depth = 9)
  int callframe3435 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call3436 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3435);
// compiled member node returning call3436 (depth = 9)
  int op_slot_left_3431 = gc_frame_newslot(call3436);
  params[0] = call3433;
  partcv[0] = 1;
  Object sum3437 = callmethod(call3436, "+(1)", 1, partcv, params);
// compiled op node returning sum3437 (depth = 8)
  gc_frame_newslot(sum3437);
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1096
  setline(1096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3428;
  params[1] = call3430;
  params[2] = sum3437;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3438 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3427);
// compiled call node returning call3438 (depth = 7)
    gc_frame_newslot(call3438);
    if3405 = call3438;
  } else {
  }
// compiled if node returning if3405 (depth = 6)
    gc_frame_newslot(if3405);
    if3399 = if3405;
  }
// compiled if node returning if3399 (depth = 5)
  gc_frame_end(frame);
  return if3399;
}
Object meth_parser_generic3300(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "generic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_id = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "id");
  Object *var_gens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "gens");
  Object *var_startToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startToken");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestions");
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3302 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3303 == NULL) {
    strlit3303 = alloc_String("lgeneric");
    gc_root(strlit3303);
  }
// compiled string node returning strlit3303 (depth = 4)
  gc_frame_newslot(strlit3303);
// call case 4: self request
  params[0] = strlit3303;
  partcv[0] = 1;
  Object call3304 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3302);
// compiled call node returning call3304 (depth = 3)
  Object if3301 = done;
  if (istrue(call3304)) {
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3305 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call3306 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe3305);
// compiled member node returning call3306 (depth = 4)
  *var_id = call3306;
  if (call3306 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array3307 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3307 (depth = 4)
  *var_gens = array3307;
  if (array3307 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_startToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3308 = gc_frame_new();
// call case 4: self request
  Object call3309 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3308);
// compiled member node returning call3309 (depth = 3)
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3310 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3311 = alloc_Block(NULL, NULL, "parser", 1062);
  gc_frame_newslot(block3311);
// method "_apply"
  block_savedest(block3311);
  Object closure3312 = createclosure(1, "_apply");
  setclosureframe(closure3312, stackframe);
  addtoclosure(closure3312, selfslot);
  struct UserObject *uo3312 = (struct UserObject*)block3311;
  uo3312->data[0] = (Object)closure3312;
  Method *meth_meth_parser__apply3312 = addmethod2pos(block3311, "_apply", &meth_parser__apply3312, 0);
  int argcv_meth_parser__apply3312[] = {0};
  meth_meth_parser__apply3312->type = alloc_MethodType(1, argcv_meth_parser__apply3312);
  meth_meth_parser__apply3312->definitionModule = modulename;
  meth_meth_parser__apply3312->definitionLine = 3399;
// compiled block node returning block3311 (depth = 4)
  gc_frame_newslot(block3311);
// starting to compile block node (depth = 4)
  Object block3317 = alloc_Block(NULL, NULL, "parser", 1062);
  gc_frame_newslot(block3317);
// method "_apply"
  block_savedest(block3317);
  Object closure3318 = createclosure(8, "_apply");
  setclosureframe(closure3318, stackframe);
  addtoclosure(closure3318, var_values);
  addtoclosure(closure3318, var_sym);
  addtoclosure(closure3318, var_errormessages);
  addtoclosure(closure3318, var_lastToken);
  addtoclosure(closure3318, var_ast);
  addtoclosure(closure3318, var_gens);
  addtoclosure(closure3318, var_startToken);
  addtoclosure(closure3318, selfslot);
  struct UserObject *uo3318 = (struct UserObject*)block3317;
  uo3318->data[0] = (Object)closure3318;
  Method *meth_meth_parser__apply3318 = addmethod2pos(block3317, "_apply", &meth_parser__apply3318, 0);
  int argcv_meth_parser__apply3318[] = {0};
  meth_meth_parser__apply3318->type = alloc_MethodType(1, argcv_meth_parser__apply3318);
  meth_meth_parser__apply3318->definitionModule = modulename;
  meth_meth_parser__apply3318->definitionLine = 3399;
// compiled block node returning block3317 (depth = 4)
  gc_frame_newslot(block3317);
// call case 5: prelude request
  params[0] = block3311;
  params[1] = block3317;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3440 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3310);
// compiled call node returning call3440 (depth = 3)
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3443 == NULL) {
    strlit3443 = alloc_String("rgeneric");
    gc_root(strlit3443);
  }
// compiled string node returning strlit3443 (depth = 5)
  int op_slot_right_3442 = gc_frame_newslot(strlit3443);
// starting to compile member node (depth = 5)
  int callframe3445 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call3446 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3445);
// compiled member node returning call3446 (depth = 5)
  int op_slot_left_3442 = gc_frame_newslot(call3446);
  params[0] = strlit3443;
  partcv[0] = 1;
  Object opresult3447 = callmethod(call3446, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3447 (depth = 4)
  Object if3441 = done;
  if (istrue(opresult3447)) {
// Begin line 1103
  setline(1103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3448 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3449 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call3450 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3449);
// compiled member node returning call3450 (depth = 6)
  Object call3451 = callmethodflags(call3450, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3448);
// compiled member node returning call3451 (depth = 5)
  *var_suggestion = call3451;
  if (call3451 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1104
  setline(1104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3452 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3453 == NULL) {
    strlit3453 = alloc_String(">");
    gc_root(strlit3453);
  }
// compiled string node returning strlit3453 (depth = 5)
  gc_frame_newslot(strlit3453);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit3453;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3454 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3452);
// compiled call node returning call3454 (depth = 4)
// Begin line 1105
  setline(1105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3455 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3456 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call3457 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3456);
// compiled member node returning call3457 (depth = 6)
  Object call3458 = callmethodflags(call3457, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3455);
// compiled member node returning call3458 (depth = 5)
  *var_suggestion2 = call3458;
  if (call3458 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1106
  setline(1106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3459 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3460 == NULL) {
    strlit3460 = alloc_String(" ");
    gc_root(strlit3460);
  }
// compiled string node returning strlit3460 (depth = 5)
  gc_frame_newslot(strlit3460);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startToken (depth = 5)
  gc_frame_newslot(*var_startToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion2 (depth = 5)
  params[0] = strlit3460;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3461 = callmethodflags(*var_suggestion2, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3459);
// compiled call node returning call3461 (depth = 4)
// Begin line 1107
  setline(1107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array3462 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethodflags(array3462, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion2 (depth = 6)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethodflags(array3462, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3462 (depth = 5)
  *var_suggestions = array3462;
  if (array3462 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1108
  setline(1108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3463 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3464 == NULL) {
    strlit3464 = alloc_String("a type containing a '<' must end with a '>', or the '<' operator must have a space before it.");
    gc_root(strlit3464);
  }
// compiled string node returning strlit3464 (depth = 5)
  gc_frame_newslot(strlit3464);
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3465 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call3466 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3465);
// compiled member node returning call3466 (depth = 5)
  gc_frame_newslot(call3466);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3468 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call3469 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3468);
// compiled member node returning call3469 (depth = 6)
  int op_slot_right_3467 = gc_frame_newslot(call3469);
// starting to compile member node (depth = 6)
  int callframe3471 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call3472 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3471);
// compiled member node returning call3472 (depth = 6)
  int op_slot_left_3467 = gc_frame_newslot(call3472);
  params[0] = call3469;
  partcv[0] = 1;
  Object sum3473 = callmethod(call3472, "+(1)", 1, partcv, params);
// compiled op node returning sum3473 (depth = 5)
  gc_frame_newslot(sum3473);
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1108
  setline(1108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3464;
  params[1] = call3466;
  params[2] = sum3473;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3474 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3463);
// compiled call node returning call3474 (depth = 4)
    gc_frame_newslot(call3474);
    if3441 = call3474;
  } else {
  }
// compiled if node returning if3441 (depth = 3)
// Begin line 1112
  setline(1112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3475 = gc_frame_new();
// call case 4: self request
  Object call3476 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3475);
// compiled member node returning call3476 (depth = 3)
// Begin line 1113
  setline(1113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3477 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3478 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_id (depth = 5)
  gc_frame_newslot(*var_id);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_gens (depth = 5)
  gc_frame_newslot(*var_gens);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3479 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call3480 = callmethodflags(*var_ast, "genericNode", 0, partcv, params, 0);
  gc_frame_end(callframe3479);
// compiled member node returning call3480 (depth = 5)
  params[0] = *var_id;
  params[1] = *var_gens;
  partcv[0] = 2;
  Object call3481 = callmethodflags(call3480, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3478);
// compiled call node returning call3481 (depth = 4)
  gc_frame_newslot(call3481);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = call3481;
  partcv[0] = 1;
  Object call3482 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3477);
// compiled call node returning call3482 (depth = 3)
    gc_frame_newslot(call3482);
    if3301 = call3482;
  } else {
  }
// compiled if node returning if3301 (depth = 2)
  gc_frame_end(frame);
  return if3301;
}
Object meth_parser__apply_40_1_41_3521(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_catchTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// Begin line 1131
  setline(1131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3525 == NULL) {
    strlit3525 = alloc_String("catch");
    gc_root(strlit3525);
  }
// compiled string node returning strlit3525 (depth = 10)
  int op_slot_right_3524 = gc_frame_newslot(strlit3525);
// starting to compile member node (depth = 10)
  int callframe3527 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  Object call3528 = callmethodflags(*var_t, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3527);
// compiled member node returning call3528 (depth = 10)
  int op_slot_left_3524 = gc_frame_newslot(call3528);
  params[0] = strlit3525;
  partcv[0] = 1;
  Object opresult3529 = callmethod(call3528, "==(1)", 1, partcv, params);
// compiled op node returning opresult3529 (depth = 9)
  int op_slot_right_3523 = gc_frame_newslot(opresult3529);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3532 == NULL) {
    strlit3532 = alloc_String("identifier");
    gc_root(strlit3532);
  }
// compiled string node returning strlit3532 (depth = 10)
  int op_slot_right_3531 = gc_frame_newslot(strlit3532);
// starting to compile member node (depth = 10)
  int callframe3534 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  Object call3535 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3534);
// compiled member node returning call3535 (depth = 10)
  int op_slot_left_3531 = gc_frame_newslot(call3535);
  params[0] = strlit3532;
  partcv[0] = 1;
  Object opresult3536 = callmethod(call3535, "==(1)", 1, partcv, params);
// compiled op node returning opresult3536 (depth = 9)
  int op_slot_left_3523 = gc_frame_newslot(opresult3536);
  params[0] = opresult3529;
  partcv[0] = 1;
  Object opresult3537 = callmethod(opresult3536, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3537 (depth = 8)
  int op_slot_right_3522 = gc_frame_newslot(opresult3537);
// Begin line 1129
  setline(1129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 1130
  setline(1130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe3542 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_catchTok (depth = 12)
  Object call3543 = callmethodflags(*var_catchTok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3542);
// compiled member node returning call3543 (depth = 11)
  int op_slot_right_3541 = gc_frame_newslot(call3543);
// starting to compile member node (depth = 11)
  int callframe3545 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  Object call3546 = callmethodflags(*var_t, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3545);
// compiled member node returning call3546 (depth = 11)
  int op_slot_left_3541 = gc_frame_newslot(call3546);
  params[0] = call3543;
  partcv[0] = 1;
  Object opresult3547 = callmethod(call3546, "==(1)", 1, partcv, params);
// compiled op node returning opresult3547 (depth = 10)
  int op_slot_right_3540 = gc_frame_newslot(opresult3547);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3550 == NULL) {
    strlit3550 = alloc_String("rparen");
    gc_root(strlit3550);
  }
// compiled string node returning strlit3550 (depth = 11)
  int op_slot_right_3549 = gc_frame_newslot(strlit3550);
// starting to compile member node (depth = 11)
  int callframe3552 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  Object call3553 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3552);
// compiled member node returning call3553 (depth = 11)
  int op_slot_left_3549 = gc_frame_newslot(call3553);
  params[0] = strlit3550;
  partcv[0] = 1;
  Object opresult3554 = callmethod(call3553, "==(1)", 1, partcv, params);
// compiled op node returning opresult3554 (depth = 10)
  int op_slot_left_3540 = gc_frame_newslot(opresult3554);
  params[0] = opresult3547;
  partcv[0] = 1;
  Object opresult3555 = callmethod(opresult3554, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3555 (depth = 9)
  int op_slot_right_3539 = gc_frame_newslot(opresult3555);
// Begin line 1129
  setline(1129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3558 == NULL) {
    strlit3558 = alloc_String("rbrace");
    gc_root(strlit3558);
  }
// compiled string node returning strlit3558 (depth = 10)
  int op_slot_right_3557 = gc_frame_newslot(strlit3558);
// starting to compile member node (depth = 10)
  int callframe3560 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  Object call3561 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3560);
// compiled member node returning call3561 (depth = 10)
  int op_slot_left_3557 = gc_frame_newslot(call3561);
  params[0] = strlit3558;
  partcv[0] = 1;
  Object opresult3562 = callmethod(call3561, "==(1)", 1, partcv, params);
// compiled op node returning opresult3562 (depth = 9)
  int op_slot_left_3539 = gc_frame_newslot(opresult3562);
  params[0] = opresult3555;
  partcv[0] = 1;
  Object opresult3563 = callmethod(opresult3562, "||(1)", 1, partcv, params);
// compiled op node returning opresult3563 (depth = 8)
  int op_slot_left_3522 = gc_frame_newslot(opresult3563);
  params[0] = opresult3537;
  partcv[0] = 1;
  Object opresult3564 = callmethod(opresult3563, "||(1)", 1, partcv, params);
// compiled op node returning opresult3564 (depth = 7)
  gc_frame_end(frame);
  return opresult3564;
}
Object meth_parser__apply3639(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe3640 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_blocksOK (depth = 8)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3641 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3640);
// compiled call node returning call3641 (depth = 7)
  gc_frame_end(frame);
  return call3641;
}
Object meth_parser__apply3710(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3713 == NULL) {
    strlit3713 = alloc_String("catch");
    gc_root(strlit3713);
  }
// compiled string node returning strlit3713 (depth = 6)
  int op_slot_right_3712 = gc_frame_newslot(strlit3713);
// starting to compile member node (depth = 6)
  int callframe3715 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call3716 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3715);
// compiled member node returning call3716 (depth = 6)
  int op_slot_left_3712 = gc_frame_newslot(call3716);
  params[0] = strlit3713;
  partcv[0] = 1;
  Object opresult3717 = callmethod(call3716, "==(1)", 1, partcv, params);
// compiled op node returning opresult3717 (depth = 5)
  int op_slot_right_3711 = gc_frame_newslot(opresult3717);
// starting to compile call node (depth = 5)
  int callframe3719 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3720 == NULL) {
    strlit3720 = alloc_String("identifier");
    gc_root(strlit3720);
  }
// compiled string node returning strlit3720 (depth = 6)
  gc_frame_newslot(strlit3720);
// call case 4: self request
  params[0] = strlit3720;
  partcv[0] = 1;
  Object call3721 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3719);
// compiled call node returning call3721 (depth = 5)
  int op_slot_left_3711 = gc_frame_newslot(call3721);
  params[0] = opresult3717;
  partcv[0] = 1;
  Object opresult3722 = callmethod(call3721, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3722 (depth = 4)
  gc_frame_end(frame);
  return opresult3722;
}
Object meth_parser__apply3744(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 10)
  int callframe3745 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_blocksOK (depth = 11)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3746 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3745);
// compiled call node returning call3746 (depth = 10)
  gc_frame_end(frame);
  return call3746;
}
Object meth_parser__apply3725(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_cases = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1174
  setline(1174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3726 = gc_frame_new();
// call case 4: self request
  Object call3727 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3726);
// compiled member node returning call3727 (depth = 4)
// Begin line 1175
  setline(1175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3729 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3730 == NULL) {
    strlit3730 = alloc_String("lbrace");
    gc_root(strlit3730);
  }
// compiled string node returning strlit3730 (depth = 6)
  gc_frame_newslot(strlit3730);
// call case 4: self request
  params[0] = strlit3730;
  partcv[0] = 1;
  Object call3731 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3729);
// compiled call node returning call3731 (depth = 5)
  Object if3728 = done;
  if (istrue(call3731)) {
// Begin line 1176
  setline(1176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3732 = gc_frame_new();
// call case 4: self request
  Object call3733 = callmethodflags(self, "block", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3732);
// compiled member node returning call3733 (depth = 5)
    gc_frame_newslot(call3733);
    if3728 = call3733;
  } else {
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3735 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3736 == NULL) {
    strlit3736 = alloc_String("lparen");
    gc_root(strlit3736);
  }
// compiled string node returning strlit3736 (depth = 7)
  gc_frame_newslot(strlit3736);
// call case 4: self request
  params[0] = strlit3736;
  partcv[0] = 1;
  Object call3737 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3735);
// compiled call node returning call3737 (depth = 6)
  Object if3734 = done;
  if (istrue(call3737)) {
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3738 = gc_frame_new();
// call case 4: self request
  Object call3739 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3738);
// compiled member node returning call3739 (depth = 6)
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3741 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe3742 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block3743 = alloc_Block(NULL, NULL, "parser", 1179);
  gc_frame_newslot(block3743);
// method "_apply"
  block_savedest(block3743);
  Object closure3744 = createclosure(2, "_apply");
  setclosureframe(closure3744, stackframe);
  addtoclosure(closure3744, var_blocksOK);
  addtoclosure(closure3744, selfslot);
  struct UserObject *uo3744 = (struct UserObject*)block3743;
  uo3744->data[0] = (Object)closure3744;
  Method *meth_meth_parser__apply3744 = addmethod2pos(block3743, "_apply", &meth_parser__apply3744, 0);
  int argcv_meth_parser__apply3744[] = {0};
  meth_meth_parser__apply3744->type = alloc_MethodType(1, argcv_meth_parser__apply3744);
  meth_meth_parser__apply3744->definitionModule = modulename;
  meth_meth_parser__apply3744->definitionLine = 3399;
// compiled block node returning block3743 (depth = 9)
  gc_frame_newslot(block3743);
// call case 4: self request
  params[0] = block3743;
  partcv[0] = 1;
  Object call3748 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3742);
// compiled call node returning call3748 (depth = 8)
  Object call3749 = callmethodflags(call3748, "not", 0, partcv, params, 0);
  gc_frame_end(callframe3741);
// compiled member node returning call3749 (depth = 7)
  Object if3740 = done;
  if (istrue(call3749)) {
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3750 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3751 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call3752 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3751);
// compiled member node returning call3752 (depth = 9)
  Object call3753 = callmethodflags(call3752, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3750);
// compiled member node returning call3753 (depth = 8)
  *var_suggestion = call3753;
  if (call3753 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3754 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array3755 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit3756 == NULL) {
    strlit3756 = alloc_String("rparen");
    gc_root(strlit3756);
  }
// compiled string node returning strlit3756 (depth = 10)
  params[0] = strlit3756;
  partcv[0] = 1;
  callmethodflags(array3755, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3755 (depth = 9)
  gc_frame_newslot(array3755);
// call case 4: self request
  params[0] = array3755;
  partcv[0] = 1;
  Object call3757 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3754);
// compiled call node returning call3757 (depth = 8)
  *var_nextTok = call3757;
  if (call3757 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3759 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3759 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3761 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3761 (depth = 8)
  Object if3758 = done;
  if (istrue(opresult3761)) {
// Begin line 1183
  setline(1183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3762 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3763 == NULL) {
    strlit3763 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3763);
  }
// compiled string node returning strlit3763 (depth = 9)
  gc_frame_newslot(strlit3763);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3763;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3764 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3762);
// compiled call node returning call3764 (depth = 8)
    gc_frame_newslot(call3764);
    if3758 = call3764;
  } else {
// Begin line 1185
  setline(1185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3765 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
  int callframe3766 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call3767 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe3766);
// compiled member node returning call3767 (depth = 9)
  gc_frame_newslot(call3767);
// starting to compile identifier node (depth = 9)
  Object bool3768 = alloc_Boolean(1);
// compiled identifier node returning bool3768 (depth = 9)
  gc_frame_newslot(bool3768);
// starting to compile identifier node (depth = 9)
  Object bool3769 = alloc_Boolean(0);
// compiled identifier node returning bool3769 (depth = 9)
  gc_frame_newslot(bool3769);
// starting to compile string node (depth = 9)
  if (strlit3770 == NULL) {
    strlit3770 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3770);
  }
// compiled string node returning strlit3770 (depth = 9)
  gc_frame_newslot(strlit3770);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call3767;
  params[2] = bool3768;
  params[3] = bool3769;
  params[4] = strlit3770;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3771 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe3765);
// compiled call node returning call3771 (depth = 8)
    gc_frame_newslot(call3771);
    if3758 = call3771;
  }
// compiled if node returning if3758 (depth = 7)
// Begin line 1187
  setline(1187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3772 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3773 == NULL) {
    strlit3773 = alloc_String("a try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3773);
  }
// compiled string node returning strlit3773 (depth = 8)
  gc_frame_newslot(strlit3773);
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe3774 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call3775 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3774);
// compiled member node returning call3775 (depth = 8)
  gc_frame_newslot(call3775);
// starting to compile member node (depth = 8)
  int callframe3776 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call3777 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3776);
// compiled member node returning call3777 (depth = 8)
  gc_frame_newslot(call3777);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1187
  setline(1187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3773;
  params[1] = call3775;
  params[2] = call3777;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3778 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3772);
// compiled call node returning call3778 (depth = 7)
    gc_frame_newslot(call3778);
    if3740 = call3778;
  } else {
  }
// compiled if node returning if3740 (depth = 6)
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3781 == NULL) {
    strlit3781 = alloc_String("rparen");
    gc_root(strlit3781);
  }
// compiled string node returning strlit3781 (depth = 8)
  int op_slot_right_3780 = gc_frame_newslot(strlit3781);
// starting to compile member node (depth = 8)
  int callframe3783 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call3784 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3783);
// compiled member node returning call3784 (depth = 8)
  int op_slot_left_3780 = gc_frame_newslot(call3784);
  params[0] = strlit3781;
  partcv[0] = 1;
  Object opresult3785 = callmethod(call3784, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3785 (depth = 7)
  Object if3779 = done;
  if (istrue(opresult3785)) {
// Begin line 1191
  setline(1191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3786 = gc_frame_new();
// call case 4: self request
  Object call3787 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3786);
// compiled member node returning call3787 (depth = 7)
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe3788 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe3789 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call3790 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3789);
// compiled member node returning call3790 (depth = 9)
  Object call3791 = callmethodflags(call3790, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3788);
// compiled member node returning call3791 (depth = 8)
  *var_suggestion = call3791;
  if (call3791 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1193
  setline(1193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3792 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3793 == NULL) {
    strlit3793 = alloc_String(")");
    gc_root(strlit3793);
  }
// compiled string node returning strlit3793 (depth = 8)
  gc_frame_newslot(strlit3793);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3793;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3794 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3792);
// compiled call node returning call3794 (depth = 7)
// Begin line 1194
  setline(1194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3795 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3796 == NULL) {
    strlit3796 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3796);
  }
// compiled string node returning strlit3796 (depth = 8)
  gc_frame_newslot(strlit3796);
// Begin line 1195
  setline(1195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe3797 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call3798 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3797);
// compiled member node returning call3798 (depth = 8)
  gc_frame_newslot(call3798);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3800 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call3801 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3800);
// compiled member node returning call3801 (depth = 9)
  int op_slot_right_3799 = gc_frame_newslot(call3801);
// starting to compile member node (depth = 9)
  int callframe3803 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call3804 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3803);
// compiled member node returning call3804 (depth = 9)
  int op_slot_left_3799 = gc_frame_newslot(call3804);
  params[0] = call3801;
  partcv[0] = 1;
  Object sum3805 = callmethod(call3804, "+(1)", 1, partcv, params);
// compiled op node returning sum3805 (depth = 8)
  gc_frame_newslot(sum3805);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1194
  setline(1194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3796;
  params[1] = call3798;
  params[2] = sum3805;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3806 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3795);
// compiled call node returning call3806 (depth = 7)
    gc_frame_newslot(call3806);
    if3779 = call3806;
  } else {
  }
// compiled if node returning if3779 (depth = 6)
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3807 = gc_frame_new();
// call case 4: self request
  Object call3808 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3807);
// compiled member node returning call3808 (depth = 6)
    gc_frame_newslot(call3808);
    if3734 = call3808;
  } else {
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array3809 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3809 (depth = 7)
  *var_suggestions = array3809;
  if (array3809 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3810 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3811 = callmethodflags(self, "findNextTokenIndentedAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3810);
// compiled call node returning call3811 (depth = 7)
  *var_nextTok = call3811;
  if (call3811 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3812 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3813 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call3814 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3813);
// compiled member node returning call3814 (depth = 8)
  Object call3815 = callmethodflags(call3814, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3812);
// compiled member node returning call3815 (depth = 7)
  *var_suggestion = call3815;
  if (call3815 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1202
  setline(1202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_right_3817 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 8)
  Object bool3819 = alloc_Boolean(0);
// compiled identifier node returning bool3819 (depth = 8)
  int op_slot_left_3817 = gc_frame_newslot(bool3819);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult3820 = callmethod(bool3819, "==(1)", 1, partcv, params);
// compiled op node returning opresult3820 (depth = 7)
  Object if3816 = done;
  if (istrue(opresult3820)) {
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3821 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3822 == NULL) {
    strlit3822 = alloc_String(" }");
    gc_root(strlit3822);
  }
// compiled string node returning strlit3822 (depth = 8)
  gc_frame_newslot(strlit3822);
// starting to compile member node (depth = 8)
  int callframe3823 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  Object call3824 = callmethodflags(*var_tokens, "last", 0, partcv, params, 0);
  gc_frame_end(callframe3823);
// compiled member node returning call3824 (depth = 8)
  gc_frame_newslot(call3824);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3822;
  params[1] = call3824;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3825 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3821);
// compiled call node returning call3825 (depth = 7)
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3826 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3827 == NULL) {
    strlit3827 = alloc_String(" {");
    gc_root(strlit3827);
  }
// compiled string node returning strlit3827 (depth = 8)
  gc_frame_newslot(strlit3827);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3827;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3828 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3826);
// compiled call node returning call3828 (depth = 7)
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3829 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3830 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3829);
// compiled call node returning call3830 (depth = 7)
    gc_frame_newslot(call3830);
    if3816 = call3830;
  } else {
// Begin line 1212
  setline(1212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3832 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3832 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3834 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3834 (depth = 8)
  Object if3831 = done;
  if (istrue(opresult3834)) {
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3835 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3836 == NULL) {
    strlit3836 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit3836);
  }
// compiled string node returning strlit3836 (depth = 9)
  gc_frame_newslot(strlit3836);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3836;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3837 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3835);
// compiled call node returning call3837 (depth = 8)
// Begin line 1208
  setline(1208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3838 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3839 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3838);
// compiled call node returning call3839 (depth = 8)
// Begin line 1209
  setline(1209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3840 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe3841 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call3842 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3841);
// compiled member node returning call3842 (depth = 10)
  Object call3843 = callmethodflags(call3842, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3840);
// compiled member node returning call3843 (depth = 9)
  *var_suggestion = call3843;
  if (call3843 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3845 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3846 == NULL) {
    strlit3846 = alloc_String(" { ""\xc2""""\xab""match expression""\xc2""""\xbb"" }");
    gc_root(strlit3846);
  }
// compiled string node returning strlit3846 (depth = 9)
  gc_frame_newslot(strlit3846);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3846;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3847 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3845);
// compiled call node returning call3847 (depth = 8)
// Begin line 1211
  setline(1211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3848 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3849 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3848);
// compiled call node returning call3849 (depth = 8)
    gc_frame_newslot(call3849);
    if3831 = call3849;
  } else {
// Begin line 1213
  setline(1213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3850 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3851 == NULL) {
    strlit3851 = alloc_String(" }");
    gc_root(strlit3851);
  }
// compiled string node returning strlit3851 (depth = 9)
  gc_frame_newslot(strlit3851);
// starting to compile member node (depth = 9)
  int callframe3852 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call3853 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe3852);
// compiled member node returning call3853 (depth = 9)
  gc_frame_newslot(call3853);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3851;
  params[1] = call3853;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3854 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3850);
// compiled call node returning call3854 (depth = 8)
// Begin line 1214
  setline(1214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3855 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3856 == NULL) {
    strlit3856 = alloc_String(" {");
    gc_root(strlit3856);
  }
// compiled string node returning strlit3856 (depth = 9)
  gc_frame_newslot(strlit3856);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3856;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3857 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3855);
// compiled call node returning call3857 (depth = 8)
// Begin line 1215
  setline(1215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3858 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3859 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3858);
// compiled call node returning call3859 (depth = 8)
    gc_frame_newslot(call3859);
    if3831 = call3859;
  }
// compiled if node returning if3831 (depth = 7)
    gc_frame_newslot(if3831);
    if3816 = if3831;
  }
// compiled if node returning if3816 (depth = 6)
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3860 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3861 == NULL) {
    strlit3861 = alloc_String("a try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3861);
  }
// compiled string node returning strlit3861 (depth = 7)
  gc_frame_newslot(strlit3861);
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3862 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call3863 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3862);
// compiled member node returning call3863 (depth = 7)
  gc_frame_newslot(call3863);
// starting to compile member node (depth = 7)
  int callframe3864 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call3865 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3864);
// compiled member node returning call3865 (depth = 7)
  gc_frame_newslot(call3865);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit3861;
  params[1] = call3863;
  params[2] = call3865;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3866 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3860);
// compiled call node returning call3866 (depth = 6)
    gc_frame_newslot(call3866);
    if3734 = call3866;
  }
// compiled if node returning if3734 (depth = 5)
    gc_frame_newslot(if3734);
    if3728 = if3734;
  }
// compiled if node returning if3728 (depth = 4)
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3867 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3868 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call3869 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe3868);
// compiled member node returning call3869 (depth = 5)
  gc_frame_newslot(call3869);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cases (depth = 5)
  params[0] = call3869;
  partcv[0] = 1;
  Object call3870 = callmethodflags(*var_cases, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3867);
// compiled call node returning call3870 (depth = 4)
  gc_frame_end(frame);
  return call3870;
}
Object meth_parser__apply3945(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe3946 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3947 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3946);
// compiled call node returning call3947 (depth = 9)
  gc_frame_end(frame);
  return call3947;
}
Object meth_parser_trycatch3483(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "trycatch");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_blocksOK = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_tokens = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_localmin = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "localmin");
  Object *var_catchTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "catchTok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_mainblock = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "mainblock");
  Object *var_cases = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cases");
  Object *var_finally = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "finally");
  Object *var_suggestions = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "suggestions");
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3485 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3488 == NULL) {
    strlit3488 = alloc_String("try");
    gc_root(strlit3488);
  }
// compiled string node returning strlit3488 (depth = 6)
  int op_slot_right_3487 = gc_frame_newslot(strlit3488);
// starting to compile member node (depth = 6)
  int callframe3490 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call3491 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3490);
// compiled member node returning call3491 (depth = 6)
  int op_slot_left_3487 = gc_frame_newslot(call3491);
  params[0] = strlit3488;
  partcv[0] = 1;
  Object opresult3492 = callmethod(call3491, "==(1)", 1, partcv, params);
// compiled op node returning opresult3492 (depth = 5)
  int op_slot_right_3486 = gc_frame_newslot(opresult3492);
// starting to compile call node (depth = 5)
  int callframe3494 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3495 == NULL) {
    strlit3495 = alloc_String("identifier");
    gc_root(strlit3495);
  }
// compiled string node returning strlit3495 (depth = 6)
  gc_frame_newslot(strlit3495);
// call case 4: self request
  params[0] = strlit3495;
  partcv[0] = 1;
  Object call3496 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3494);
// compiled call node returning call3496 (depth = 5)
  int op_slot_left_3486 = gc_frame_newslot(call3496);
  params[0] = opresult3492;
  partcv[0] = 1;
  Object opresult3497 = callmethod(call3496, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3497 (depth = 4)
  partcv[0] = 0;
  Object call3498 = callmethodflags(opresult3497, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe3485);
// compiled call node returning call3498 (depth = 3)
  Object if3484 = done;
  if (istrue(call3498)) {
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3499 = alloc_Float64(0);
// compiled num node returning num3499 (depth = 4)
  return num3499;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3484 = undefined;
  } else {
  }
// compiled if node returning if3484 (depth = 2)
// Begin line 1120
  setline(1120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localmin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1121
  setline(1121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_catchTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1122
  setline(1122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3500 = gc_frame_new();
// call case 4: self request
  Object call3501 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3500);
// compiled member node returning call3501 (depth = 2)
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3503 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3504 == NULL) {
    strlit3504 = alloc_String("lbrace");
    gc_root(strlit3504);
  }
// compiled string node returning strlit3504 (depth = 4)
  gc_frame_newslot(strlit3504);
// call case 4: self request
  params[0] = strlit3504;
  partcv[0] = 1;
  Object call3505 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3503);
// compiled call node returning call3505 (depth = 3)
  Object if3502 = done;
  if (istrue(call3505)) {
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3506 = gc_frame_new();
// call case 4: self request
  Object call3507 = callmethodflags(self, "block", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3506);
// compiled member node returning call3507 (depth = 3)
    gc_frame_newslot(call3507);
    if3502 = call3507;
  } else {
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3510 == NULL) {
    strlit3510 = alloc_String("lparen");
    gc_root(strlit3510);
  }
// compiled string node returning strlit3510 (depth = 5)
  int op_slot_right_3509 = gc_frame_newslot(strlit3510);
// starting to compile member node (depth = 5)
  int callframe3512 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call3513 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3512);
// compiled member node returning call3513 (depth = 5)
  int op_slot_left_3509 = gc_frame_newslot(call3513);
  params[0] = strlit3510;
  partcv[0] = 1;
  Object opresult3514 = callmethod(call3513, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3514 (depth = 4)
  Object if3508 = done;
  if (istrue(opresult3514)) {
// Begin line 1127
  setline(1127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3515 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3516 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call3517 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3516);
// compiled member node returning call3517 (depth = 6)
  Object call3518 = callmethodflags(call3517, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3515);
// compiled member node returning call3518 (depth = 5)
  *var_suggestion = call3518;
  if (call3518 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1129
  setline(1129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3519 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3520 = alloc_Block(NULL, NULL, "parser", 1129);
  gc_frame_newslot(block3520);
// method "_apply(_)"
  block_savedest(block3520);
  Object closure3521 = createclosure(2, "_apply(1)");
  setclosureframe(closure3521, stackframe);
  addtoclosure(closure3521, var_catchTok);
  addtoclosure(closure3521, selfslot);
  struct UserObject *uo3521 = (struct UserObject*)block3520;
  uo3521->data[0] = (Object)closure3521;
  Method *meth_meth_parser__apply_40_1_41_3521 = addmethod2pos(block3520, "_apply(1)", &meth_parser__apply_40_1_41_3521, 0);
  int argcv_meth_parser__apply_40_1_41_3521[] = {1};
  meth_meth_parser__apply_40_1_41_3521->type = alloc_MethodType(1, argcv_meth_parser__apply_40_1_41_3521);
  meth_meth_parser__apply_40_1_41_3521->definitionModule = modulename;
  meth_meth_parser__apply_40_1_41_3521->definitionLine = 3399;
// compiled block node returning block3520 (depth = 6)
  gc_frame_newslot(block3520);
// call case 4: self request
  params[0] = block3520;
  partcv[0] = 1;
  Object call3566 = callmethodflags(self, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3519);
// compiled call node returning call3566 (depth = 5)
  *var_nextTok = call3566;
  if (call3566 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_right_3568 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 6)
  Object bool3570 = alloc_Boolean(0);
// compiled identifier node returning bool3570 (depth = 6)
  int op_slot_left_3568 = gc_frame_newslot(bool3570);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult3571 = callmethod(bool3570, "==(1)", 1, partcv, params);
// compiled op node returning opresult3571 (depth = 5)
  Object if3567 = done;
  if (istrue(opresult3571)) {
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3572 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3573 == NULL) {
    strlit3573 = alloc_String(" {}");
    gc_root(strlit3573);
  }
// compiled string node returning strlit3573 (depth = 6)
  gc_frame_newslot(strlit3573);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_catchTok (depth = 6)
  gc_frame_newslot(*var_catchTok);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit3573;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3574 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3572);
// compiled call node returning call3574 (depth = 5)
    gc_frame_newslot(call3574);
    if3567 = call3574;
  } else {
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3577 == NULL) {
    strlit3577 = alloc_String("rbrace");
    gc_root(strlit3577);
  }
// compiled string node returning strlit3577 (depth = 7)
  int op_slot_right_3576 = gc_frame_newslot(strlit3577);
// starting to compile member node (depth = 7)
  int callframe3579 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call3580 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3579);
// compiled member node returning call3580 (depth = 7)
  int op_slot_left_3576 = gc_frame_newslot(call3580);
  params[0] = strlit3577;
  partcv[0] = 1;
  Object opresult3581 = callmethod(call3580, "==(1)", 1, partcv, params);
// compiled op node returning opresult3581 (depth = 6)
  Object if3575 = done;
  if (istrue(opresult3581)) {
// Begin line 1135
  setline(1135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3582 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3583 == NULL) {
    strlit3583 = alloc_String(" {");
    gc_root(strlit3583);
  }
// compiled string node returning strlit3583 (depth = 7)
  gc_frame_newslot(strlit3583);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_catchTok (depth = 7)
  gc_frame_newslot(*var_catchTok);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3583;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3584 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3582);
// compiled call node returning call3584 (depth = 6)
    gc_frame_newslot(call3584);
    if3575 = call3584;
  } else {
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3587 == NULL) {
    strlit3587 = alloc_String("rparen");
    gc_root(strlit3587);
  }
// compiled string node returning strlit3587 (depth = 8)
  int op_slot_right_3586 = gc_frame_newslot(strlit3587);
// starting to compile member node (depth = 8)
  int callframe3589 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  Object call3590 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3589);
// compiled member node returning call3590 (depth = 8)
  int op_slot_left_3586 = gc_frame_newslot(call3590);
  params[0] = strlit3587;
  partcv[0] = 1;
  Object opresult3591 = callmethod(call3590, "==(1)", 1, partcv, params);
// compiled op node returning opresult3591 (depth = 7)
  Object if3585 = done;
  if (istrue(opresult3591)) {
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3593 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3593 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3595 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3595 (depth = 8)
  Object if3592 = done;
  if (istrue(opresult3595)) {
// Begin line 1138
  setline(1138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3596 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3597 == NULL) {
    strlit3597 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3597);
  }
// compiled string node returning strlit3597 (depth = 9)
  gc_frame_newslot(strlit3597);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool3598 = alloc_Boolean(1);
// compiled identifier node returning bool3598 (depth = 9)
  gc_frame_newslot(bool3598);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3597;
  params[1] = *var_lastToken;
  params[2] = bool3598;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3599 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3596);
// compiled call node returning call3599 (depth = 8)
    gc_frame_newslot(call3599);
    if3592 = call3599;
  } else {
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3600 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3601 == NULL) {
    strlit3601 = alloc_String("(");
    gc_root(strlit3601);
  }
// compiled string node returning strlit3601 (depth = 9)
  gc_frame_newslot(strlit3601);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool3602 = alloc_Boolean(1);
// compiled identifier node returning bool3602 (depth = 9)
  gc_frame_newslot(bool3602);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3601;
  params[1] = *var_lastToken;
  params[2] = bool3602;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3603 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3600);
// compiled call node returning call3603 (depth = 8)
    gc_frame_newslot(call3603);
    if3592 = call3603;
  }
// compiled if node returning if3592 (depth = 7)
    gc_frame_newslot(if3592);
    if3585 = if3592;
  } else {
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3606 == NULL) {
    strlit3606 = alloc_String("identifier");
    gc_root(strlit3606);
  }
// compiled string node returning strlit3606 (depth = 9)
  int op_slot_right_3605 = gc_frame_newslot(strlit3606);
// starting to compile member node (depth = 9)
  int callframe3608 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call3609 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3608);
// compiled member node returning call3609 (depth = 9)
  int op_slot_left_3605 = gc_frame_newslot(call3609);
  params[0] = strlit3606;
  partcv[0] = 1;
  Object opresult3610 = callmethod(call3609, "==(1)", 1, partcv, params);
// compiled op node returning opresult3610 (depth = 8)
  Object if3604 = done;
  if (istrue(opresult3610)) {
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3611 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3612 == NULL) {
    strlit3612 = alloc_String(" {");
    gc_root(strlit3612);
  }
// compiled string node returning strlit3612 (depth = 9)
  gc_frame_newslot(strlit3612);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_catchTok (depth = 9)
  gc_frame_newslot(*var_catchTok);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3612;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3613 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3611);
// compiled call node returning call3613 (depth = 8)
// Begin line 1144
  setline(1144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3614 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3615 == NULL) {
    strlit3615 = alloc_String("} ");
    gc_root(strlit3615);
  }
// compiled string node returning strlit3615 (depth = 9)
  gc_frame_newslot(strlit3615);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  gc_frame_newslot(*var_nextTok);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3615;
  params[1] = *var_nextTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3616 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3614);
// compiled call node returning call3616 (depth = 8)
    gc_frame_newslot(call3616);
    if3604 = call3616;
  } else {
  }
// compiled if node returning if3604 (depth = 7)
    gc_frame_newslot(if3604);
    if3585 = if3604;
  }
// compiled if node returning if3585 (depth = 6)
    gc_frame_newslot(if3585);
    if3575 = if3585;
  }
// compiled if node returning if3575 (depth = 5)
    gc_frame_newslot(if3575);
    if3567 = if3575;
  }
// compiled if node returning if3567 (depth = 4)
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3617 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3618 == NULL) {
    strlit3618 = alloc_String("a catch statement must have either a block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3618);
  }
// compiled string node returning strlit3618 (depth = 5)
  gc_frame_newslot(strlit3618);
// Begin line 1147
  setline(1147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3619 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_catchTok (depth = 6)
  Object call3620 = callmethodflags(*var_catchTok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3619);
// compiled member node returning call3620 (depth = 5)
  gc_frame_newslot(call3620);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3622 = alloc_Float64(1);
// compiled num node returning num3622 (depth = 6)
  int op_slot_right_3621 = gc_frame_newslot(num3622);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3625 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_catchTok (depth = 8)
  Object call3626 = callmethodflags(*var_catchTok, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3625);
// compiled member node returning call3626 (depth = 7)
  int op_slot_right_3624 = gc_frame_newslot(call3626);
// starting to compile member node (depth = 7)
  int callframe3628 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_catchTok (depth = 8)
  Object call3629 = callmethodflags(*var_catchTok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3628);
// compiled member node returning call3629 (depth = 7)
  int op_slot_left_3624 = gc_frame_newslot(call3629);
  params[0] = call3626;
  partcv[0] = 1;
  Object sum3630 = callmethod(call3629, "+(1)", 1, partcv, params);
// compiled op node returning sum3630 (depth = 6)
  int op_slot_left_3621 = gc_frame_newslot(sum3630);
  params[0] = num3622;
  partcv[0] = 1;
  Object sum3631 = callmethod(sum3630, "+(1)", 1, partcv, params);
// compiled op node returning sum3631 (depth = 5)
  gc_frame_newslot(sum3631);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3618;
  params[1] = call3620;
  params[2] = sum3631;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3632 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3617);
// compiled call node returning call3632 (depth = 4)
    gc_frame_newslot(call3632);
    if3508 = call3632;
  } else {
  }
// compiled if node returning if3508 (depth = 3)
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3633 = gc_frame_new();
// call case 4: self request
  Object call3634 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3633);
// compiled member node returning call3634 (depth = 3)
// Begin line 1150
  setline(1150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3636 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe3637 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3638 = alloc_Block(NULL, NULL, "parser", 1150);
  gc_frame_newslot(block3638);
// method "_apply"
  block_savedest(block3638);
  Object closure3639 = createclosure(2, "_apply");
  setclosureframe(closure3639, stackframe);
  addtoclosure(closure3639, var_blocksOK);
  addtoclosure(closure3639, selfslot);
  struct UserObject *uo3639 = (struct UserObject*)block3638;
  uo3639->data[0] = (Object)closure3639;
  Method *meth_meth_parser__apply3639 = addmethod2pos(block3638, "_apply", &meth_parser__apply3639, 0);
  int argcv_meth_parser__apply3639[] = {0};
  meth_meth_parser__apply3639->type = alloc_MethodType(1, argcv_meth_parser__apply3639);
  meth_meth_parser__apply3639->definitionModule = modulename;
  meth_meth_parser__apply3639->definitionLine = 3399;
// compiled block node returning block3638 (depth = 6)
  gc_frame_newslot(block3638);
// call case 4: self request
  params[0] = block3638;
  partcv[0] = 1;
  Object call3643 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3637);
// compiled call node returning call3643 (depth = 5)
  Object call3644 = callmethodflags(call3643, "not", 0, partcv, params, 0);
  gc_frame_end(callframe3636);
// compiled member node returning call3644 (depth = 4)
  Object if3635 = done;
  if (istrue(call3644)) {
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3645 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3646 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call3647 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3646);
// compiled member node returning call3647 (depth = 6)
  Object call3648 = callmethodflags(call3647, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3645);
// compiled member node returning call3648 (depth = 5)
  *var_suggestion = call3648;
  if (call3648 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3649 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array3650 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit3651 == NULL) {
    strlit3651 = alloc_String("rparen");
    gc_root(strlit3651);
  }
// compiled string node returning strlit3651 (depth = 7)
  params[0] = strlit3651;
  partcv[0] = 1;
  callmethodflags(array3650, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3650 (depth = 6)
  gc_frame_newslot(array3650);
// call case 4: self request
  params[0] = array3650;
  partcv[0] = 1;
  Object call3652 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3649);
// compiled call node returning call3652 (depth = 5)
  *var_nextTok = call3652;
  if (call3652 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1153
  setline(1153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_3654 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_3654 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3656 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3656 (depth = 5)
  Object if3653 = done;
  if (istrue(opresult3656)) {
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3657 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3658 == NULL) {
    strlit3658 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3658);
  }
// compiled string node returning strlit3658 (depth = 6)
  gc_frame_newslot(strlit3658);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit3658;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3659 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3657);
// compiled call node returning call3659 (depth = 5)
    gc_frame_newslot(call3659);
    if3653 = call3659;
  } else {
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3660 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe3661 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  Object call3662 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe3661);
// compiled member node returning call3662 (depth = 6)
  gc_frame_newslot(call3662);
// starting to compile identifier node (depth = 6)
  Object bool3663 = alloc_Boolean(1);
// compiled identifier node returning bool3663 (depth = 6)
  gc_frame_newslot(bool3663);
// starting to compile identifier node (depth = 6)
  Object bool3664 = alloc_Boolean(0);
// compiled identifier node returning bool3664 (depth = 6)
  gc_frame_newslot(bool3664);
// starting to compile string node (depth = 6)
  if (strlit3665 == NULL) {
    strlit3665 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3665);
  }
// compiled string node returning strlit3665 (depth = 6)
  gc_frame_newslot(strlit3665);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call3662;
  params[2] = bool3663;
  params[3] = bool3664;
  params[4] = strlit3665;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3666 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe3660);
// compiled call node returning call3666 (depth = 5)
    gc_frame_newslot(call3666);
    if3653 = call3666;
  }
// compiled if node returning if3653 (depth = 4)
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3667 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3668 == NULL) {
    strlit3668 = alloc_String("a catch statement must have either a block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3668);
  }
// compiled string node returning strlit3668 (depth = 5)
  gc_frame_newslot(strlit3668);
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3669 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call3670 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3669);
// compiled member node returning call3670 (depth = 5)
  gc_frame_newslot(call3670);
// starting to compile member node (depth = 5)
  int callframe3671 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call3672 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3671);
// compiled member node returning call3672 (depth = 5)
  gc_frame_newslot(call3672);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3668;
  params[1] = call3670;
  params[2] = call3672;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3673 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3667);
// compiled call node returning call3673 (depth = 4)
    gc_frame_newslot(call3673);
    if3635 = call3673;
  } else {
  }
// compiled if node returning if3635 (depth = 3)
// Begin line 1161
  setline(1161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3676 == NULL) {
    strlit3676 = alloc_String("rparen");
    gc_root(strlit3676);
  }
// compiled string node returning strlit3676 (depth = 5)
  int op_slot_right_3675 = gc_frame_newslot(strlit3676);
// starting to compile member node (depth = 5)
  int callframe3678 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call3679 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3678);
// compiled member node returning call3679 (depth = 5)
  int op_slot_left_3675 = gc_frame_newslot(call3679);
  params[0] = strlit3676;
  partcv[0] = 1;
  Object opresult3680 = callmethod(call3679, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3680 (depth = 4)
  Object if3674 = done;
  if (istrue(opresult3680)) {
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3681 = gc_frame_new();
// call case 4: self request
  Object call3682 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3681);
// compiled member node returning call3682 (depth = 4)
// Begin line 1163
  setline(1163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3683 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3684 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call3685 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3684);
// compiled member node returning call3685 (depth = 6)
  Object call3686 = callmethodflags(call3685, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3683);
// compiled member node returning call3686 (depth = 5)
  *var_suggestion = call3686;
  if (call3686 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1164
  setline(1164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3687 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3688 == NULL) {
    strlit3688 = alloc_String(")");
    gc_root(strlit3688);
  }
// compiled string node returning strlit3688 (depth = 5)
  gc_frame_newslot(strlit3688);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit3688;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3689 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3687);
// compiled call node returning call3689 (depth = 4)
// Begin line 1165
  setline(1165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3690 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3691 == NULL) {
    strlit3691 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3691);
  }
// compiled string node returning strlit3691 (depth = 5)
  gc_frame_newslot(strlit3691);
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3692 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call3693 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3692);
// compiled member node returning call3693 (depth = 5)
  gc_frame_newslot(call3693);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3695 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call3696 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3695);
// compiled member node returning call3696 (depth = 6)
  int op_slot_right_3694 = gc_frame_newslot(call3696);
// starting to compile member node (depth = 6)
  int callframe3698 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call3699 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3698);
// compiled member node returning call3699 (depth = 6)
  int op_slot_left_3694 = gc_frame_newslot(call3699);
  params[0] = call3696;
  partcv[0] = 1;
  Object sum3700 = callmethod(call3699, "+(1)", 1, partcv, params);
// compiled op node returning sum3700 (depth = 5)
  gc_frame_newslot(sum3700);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1165
  setline(1165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3691;
  params[1] = call3693;
  params[2] = sum3700;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3701 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3690);
// compiled call node returning call3701 (depth = 4)
    gc_frame_newslot(call3701);
    if3674 = call3701;
  } else {
  }
// compiled if node returning if3674 (depth = 3)
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3702 = gc_frame_new();
// call case 4: self request
  Object call3703 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3702);
// compiled member node returning call3703 (depth = 3)
    gc_frame_newslot(call3703);
    if3502 = call3703;
  }
// compiled if node returning if3502 (depth = 2)
// Begin line 1170
  setline(1170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3704 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  Object call3705 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe3704);
// compiled member node returning call3705 (depth = 3)
  *var_mainblock = call3705;
  if (call3705 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1171
  setline(1171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array3706 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3706 (depth = 3)
  *var_cases = array3706;
  if (array3706 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool3707 = alloc_Boolean(0);
// compiled identifier node returning bool3707 (depth = 3)
  *var_finally = bool3707;
  if (bool3707 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1173
  setline(1173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3708 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3709 = alloc_Block(NULL, NULL, "parser", 1173);
  gc_frame_newslot(block3709);
// method "_apply"
  block_savedest(block3709);
  Object closure3710 = createclosure(2, "_apply");
  setclosureframe(closure3710, stackframe);
  addtoclosure(closure3710, var_sym);
  addtoclosure(closure3710, selfslot);
  struct UserObject *uo3710 = (struct UserObject*)block3709;
  uo3710->data[0] = (Object)closure3710;
  Method *meth_meth_parser__apply3710 = addmethod2pos(block3709, "_apply", &meth_parser__apply3710, 0);
  int argcv_meth_parser__apply3710[] = {0};
  meth_meth_parser__apply3710->type = alloc_MethodType(1, argcv_meth_parser__apply3710);
  meth_meth_parser__apply3710->definitionModule = modulename;
  meth_meth_parser__apply3710->definitionLine = 3399;
// compiled block node returning block3709 (depth = 3)
  gc_frame_newslot(block3709);
// starting to compile block node (depth = 3)
  Object block3724 = alloc_Block(NULL, NULL, "parser", 1173);
  gc_frame_newslot(block3724);
// method "_apply"
  block_savedest(block3724);
  Object closure3725 = createclosure(8, "_apply");
  setclosureframe(closure3725, stackframe);
  addtoclosure(closure3725, var_blocksOK);
  addtoclosure(closure3725, var_errormessages);
  addtoclosure(closure3725, var_sym);
  addtoclosure(closure3725, var_lastToken);
  addtoclosure(closure3725, var_tokens);
  addtoclosure(closure3725, var_values);
  addtoclosure(closure3725, var_cases);
  addtoclosure(closure3725, selfslot);
  struct UserObject *uo3725 = (struct UserObject*)block3724;
  uo3725->data[0] = (Object)closure3725;
  Method *meth_meth_parser__apply3725 = addmethod2pos(block3724, "_apply", &meth_parser__apply3725, 0);
  int argcv_meth_parser__apply3725[] = {0};
  meth_meth_parser__apply3725->type = alloc_MethodType(1, argcv_meth_parser__apply3725);
  meth_meth_parser__apply3725->definitionModule = modulename;
  meth_meth_parser__apply3725->definitionLine = 3399;
// compiled block node returning block3724 (depth = 3)
  gc_frame_newslot(block3724);
// call case 5: prelude request
  params[0] = block3709;
  params[1] = block3724;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3872 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3708);
// compiled call node returning call3872 (depth = 2)
// Begin line 1222
  setline(1222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3876 == NULL) {
    strlit3876 = alloc_String("case");
    gc_root(strlit3876);
  }
// compiled string node returning strlit3876 (depth = 5)
  int op_slot_right_3875 = gc_frame_newslot(strlit3876);
// starting to compile member node (depth = 5)
  int callframe3878 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call3879 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3878);
// compiled member node returning call3879 (depth = 5)
  int op_slot_left_3875 = gc_frame_newslot(call3879);
  params[0] = strlit3876;
  partcv[0] = 1;
  Object opresult3880 = callmethod(call3879, "==(1)", 1, partcv, params);
// compiled op node returning opresult3880 (depth = 4)
  int op_slot_right_3874 = gc_frame_newslot(opresult3880);
// starting to compile call node (depth = 4)
  int callframe3882 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3883 == NULL) {
    strlit3883 = alloc_String("identifier");
    gc_root(strlit3883);
  }
// compiled string node returning strlit3883 (depth = 5)
  gc_frame_newslot(strlit3883);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_catchTok (depth = 5)
  gc_frame_newslot(*var_catchTok);
// call case 4: self request
  params[0] = strlit3883;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3884 = callmethodflags(self, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3882);
// compiled call node returning call3884 (depth = 4)
  int op_slot_left_3874 = gc_frame_newslot(call3884);
  params[0] = opresult3880;
  partcv[0] = 1;
  Object opresult3885 = callmethod(call3884, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3885 (depth = 3)
  Object if3873 = done;
  if (istrue(opresult3885)) {
// Begin line 1223
  setline(1223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3886 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3887 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call3888 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3887);
// compiled member node returning call3888 (depth = 5)
  Object call3889 = callmethodflags(call3888, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3886);
// compiled member node returning call3889 (depth = 4)
  *var_suggestion = call3889;
  if (call3889 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1224
  setline(1224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3890 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 4)
  if (strlit3891 == NULL) {
    strlit3891 = alloc_String("catch");
    gc_root(strlit3891);
  }
// compiled string node returning strlit3891 (depth = 4)
  gc_frame_newslot(strlit3891);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_sym;
  params[1] = strlit3891;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3892 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3890);
// compiled call node returning call3892 (depth = 3)
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3893 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1227
  setline(1227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit3895 == NULL) {
    strlit3895 = alloc_String("are no 'case' blocks.");
    gc_root(strlit3895);
  }
// compiled string node returning strlit3895 (depth = 5)
  int op_slot_right_3894 = gc_frame_newslot(strlit3895);
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 1226
  setline(1226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3898 == NULL) {
    strlit3898 = alloc_String("'try' and then zero or more 'catch' blocks; there ");
    gc_root(strlit3898);
  }
// compiled string node returning strlit3898 (depth = 6)
  int op_slot_right_3897 = gc_frame_newslot(strlit3898);
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3900 == NULL) {
    strlit3900 = alloc_String("a try-catch statement starts with a ");
    gc_root(strlit3900);
  }
// compiled string node returning strlit3900 (depth = 6)
  int op_slot_left_3897 = gc_frame_newslot(strlit3900);
  params[0] = strlit3898;
  partcv[0] = 1;
  Object opresult3901 = callmethod(strlit3900, "++(1)", 1, partcv, params);
// compiled op node returning opresult3901 (depth = 5)
  int op_slot_left_3894 = gc_frame_newslot(opresult3901);
  params[0] = strlit3895;
  partcv[0] = 1;
  Object opresult3902 = callmethod(opresult3901, "++(1)", 1, partcv, params);
// compiled op node returning opresult3902 (depth = 4)
  gc_frame_newslot(opresult3902);
// Begin line 1228
  setline(1228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3903 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call3904 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3903);
// compiled member node returning call3904 (depth = 4)
  gc_frame_newslot(call3904);
// starting to compile member node (depth = 4)
  int callframe3905 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call3906 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3905);
// compiled member node returning call3906 (depth = 4)
  gc_frame_newslot(call3906);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3908 = alloc_Float64(3);
// compiled num node returning num3908 (depth = 5)
  int op_slot_right_3907 = gc_frame_newslot(num3908);
// starting to compile member node (depth = 5)
  int callframe3910 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call3911 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3910);
// compiled member node returning call3911 (depth = 5)
  int op_slot_left_3907 = gc_frame_newslot(call3911);
  params[0] = num3908;
  partcv[0] = 1;
  Object sum3912 = callmethod(call3911, "+(1)", 1, partcv, params);
// compiled op node returning sum3912 (depth = 4)
  gc_frame_newslot(sum3912);
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult3902;
  params[1] = call3904;
  params[2] = call3906;
  params[3] = sum3912;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call3913 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3893);
// compiled call node returning call3913 (depth = 3)
    gc_frame_newslot(call3913);
    if3873 = call3913;
  } else {
  }
// compiled if node returning if3873 (depth = 2)
// Begin line 1231
  setline(1231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3917 == NULL) {
    strlit3917 = alloc_String("finally");
    gc_root(strlit3917);
  }
// compiled string node returning strlit3917 (depth = 5)
  int op_slot_right_3916 = gc_frame_newslot(strlit3917);
// starting to compile member node (depth = 5)
  int callframe3919 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call3920 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3919);
// compiled member node returning call3920 (depth = 5)
  int op_slot_left_3916 = gc_frame_newslot(call3920);
  params[0] = strlit3917;
  partcv[0] = 1;
  Object opresult3921 = callmethod(call3920, "==(1)", 1, partcv, params);
// compiled op node returning opresult3921 (depth = 4)
  int op_slot_right_3915 = gc_frame_newslot(opresult3921);
// starting to compile call node (depth = 4)
  int callframe3923 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3924 == NULL) {
    strlit3924 = alloc_String("identifier");
    gc_root(strlit3924);
  }
// compiled string node returning strlit3924 (depth = 5)
  gc_frame_newslot(strlit3924);
// call case 4: self request
  params[0] = strlit3924;
  partcv[0] = 1;
  Object call3925 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3923);
// compiled call node returning call3925 (depth = 4)
  int op_slot_left_3915 = gc_frame_newslot(call3925);
  params[0] = opresult3921;
  partcv[0] = 1;
  Object opresult3926 = callmethod(call3925, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3926 (depth = 3)
  Object if3914 = done;
  if (istrue(opresult3926)) {
// Begin line 1232
  setline(1232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3927 = gc_frame_new();
// call case 4: self request
  Object call3928 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3927);
// compiled member node returning call3928 (depth = 3)
// Begin line 1233
  setline(1233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3930 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3931 == NULL) {
    strlit3931 = alloc_String("lbrace");
    gc_root(strlit3931);
  }
// compiled string node returning strlit3931 (depth = 5)
  gc_frame_newslot(strlit3931);
// call case 4: self request
  params[0] = strlit3931;
  partcv[0] = 1;
  Object call3932 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3930);
// compiled call node returning call3932 (depth = 4)
  Object if3929 = done;
  if (istrue(call3932)) {
// Begin line 1234
  setline(1234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3933 = gc_frame_new();
// call case 4: self request
  Object call3934 = callmethodflags(self, "block", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3933);
// compiled member node returning call3934 (depth = 4)
    gc_frame_newslot(call3934);
    if3929 = call3934;
  } else {
// Begin line 1256
  setline(1256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1235
  setline(1235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3936 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3937 == NULL) {
    strlit3937 = alloc_String("lparen");
    gc_root(strlit3937);
  }
// compiled string node returning strlit3937 (depth = 6)
  gc_frame_newslot(strlit3937);
// call case 4: self request
  params[0] = strlit3937;
  partcv[0] = 1;
  Object call3938 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3936);
// compiled call node returning call3938 (depth = 5)
  Object if3935 = done;
  if (istrue(call3938)) {
// Begin line 1236
  setline(1236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe3939 = gc_frame_new();
// call case 4: self request
  Object call3940 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3939);
// compiled member node returning call3940 (depth = 5)
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3942 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe3943 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block3944 = alloc_Block(NULL, NULL, "parser", 1237);
  gc_frame_newslot(block3944);
// method "_apply"
  block_savedest(block3944);
  Object closure3945 = createclosure(2, "_apply");
  setclosureframe(closure3945, stackframe);
  addtoclosure(closure3945, var_blocksOK);
  addtoclosure(closure3945, selfslot);
  struct UserObject *uo3945 = (struct UserObject*)block3944;
  uo3945->data[0] = (Object)closure3945;
  Method *meth_meth_parser__apply3945 = addmethod2pos(block3944, "_apply", &meth_parser__apply3945, 0);
  int argcv_meth_parser__apply3945[] = {0};
  meth_meth_parser__apply3945->type = alloc_MethodType(1, argcv_meth_parser__apply3945);
  meth_meth_parser__apply3945->definitionModule = modulename;
  meth_meth_parser__apply3945->definitionLine = 3399;
// compiled block node returning block3944 (depth = 8)
  gc_frame_newslot(block3944);
// call case 4: self request
  params[0] = block3944;
  partcv[0] = 1;
  Object call3949 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3943);
// compiled call node returning call3949 (depth = 7)
  Object call3950 = callmethodflags(call3949, "not", 0, partcv, params, 0);
  gc_frame_end(callframe3942);
// compiled member node returning call3950 (depth = 6)
  Object if3941 = done;
  if (istrue(call3950)) {
// Begin line 1238
  setline(1238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3951 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3952 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call3953 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3952);
// compiled member node returning call3953 (depth = 8)
  Object call3954 = callmethodflags(call3953, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3951);
// compiled member node returning call3954 (depth = 7)
  *var_suggestion = call3954;
  if (call3954 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3955 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array3956 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit3957 == NULL) {
    strlit3957 = alloc_String("rparen");
    gc_root(strlit3957);
  }
// compiled string node returning strlit3957 (depth = 9)
  params[0] = strlit3957;
  partcv[0] = 1;
  callmethodflags(array3956, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3956 (depth = 8)
  gc_frame_newslot(array3956);
// call case 4: self request
  params[0] = array3956;
  partcv[0] = 1;
  Object call3958 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3955);
// compiled call node returning call3958 (depth = 7)
  *var_nextTok = call3958;
  if (call3958 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_3960 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_3960 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3962 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult3962 (depth = 7)
  Object if3959 = done;
  if (istrue(opresult3962)) {
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3963 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3964 == NULL) {
    strlit3964 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3964);
  }
// compiled string node returning strlit3964 (depth = 8)
  gc_frame_newslot(strlit3964);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3964;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3965 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3963);
// compiled call node returning call3965 (depth = 7)
    gc_frame_newslot(call3965);
    if3959 = call3965;
  } else {
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3966 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
  int callframe3967 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  Object call3968 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe3967);
// compiled member node returning call3968 (depth = 8)
  gc_frame_newslot(call3968);
// starting to compile identifier node (depth = 8)
  Object bool3969 = alloc_Boolean(1);
// compiled identifier node returning bool3969 (depth = 8)
  gc_frame_newslot(bool3969);
// starting to compile identifier node (depth = 8)
  Object bool3970 = alloc_Boolean(0);
// compiled identifier node returning bool3970 (depth = 8)
  gc_frame_newslot(bool3970);
// starting to compile string node (depth = 8)
  if (strlit3971 == NULL) {
    strlit3971 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3971);
  }
// compiled string node returning strlit3971 (depth = 8)
  gc_frame_newslot(strlit3971);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call3968;
  params[2] = bool3969;
  params[3] = bool3970;
  params[4] = strlit3971;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3972 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe3966);
// compiled call node returning call3972 (depth = 7)
    gc_frame_newslot(call3972);
    if3959 = call3972;
  }
// compiled if node returning if3959 (depth = 6)
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3973 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3974 == NULL) {
    strlit3974 = alloc_String("a catch statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit3974);
  }
// compiled string node returning strlit3974 (depth = 7)
  gc_frame_newslot(strlit3974);
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3975 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call3976 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3975);
// compiled member node returning call3976 (depth = 7)
  gc_frame_newslot(call3976);
// starting to compile member node (depth = 7)
  int callframe3977 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call3978 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3977);
// compiled member node returning call3978 (depth = 7)
  gc_frame_newslot(call3978);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit3974;
  params[1] = call3976;
  params[2] = call3978;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3979 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3973);
// compiled call node returning call3979 (depth = 6)
    gc_frame_newslot(call3979);
    if3941 = call3979;
  } else {
  }
// compiled if node returning if3941 (depth = 5)
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3982 == NULL) {
    strlit3982 = alloc_String("rparen");
    gc_root(strlit3982);
  }
// compiled string node returning strlit3982 (depth = 7)
  int op_slot_right_3981 = gc_frame_newslot(strlit3982);
// starting to compile member node (depth = 7)
  int callframe3984 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call3985 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe3984);
// compiled member node returning call3985 (depth = 7)
  int op_slot_left_3981 = gc_frame_newslot(call3985);
  params[0] = strlit3982;
  partcv[0] = 1;
  Object opresult3986 = callmethod(call3985, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3986 (depth = 6)
  Object if3980 = done;
  if (istrue(opresult3986)) {
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3987 = gc_frame_new();
// call case 4: self request
  Object call3988 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3987);
// compiled member node returning call3988 (depth = 6)
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3989 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3990 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call3991 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe3990);
// compiled member node returning call3991 (depth = 8)
  Object call3992 = callmethodflags(call3991, "new", 0, partcv, params, 0);
  gc_frame_end(callframe3989);
// compiled member node returning call3992 (depth = 7)
  *var_suggestion = call3992;
  if (call3992 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3993 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3994 == NULL) {
    strlit3994 = alloc_String(")");
    gc_root(strlit3994);
  }
// compiled string node returning strlit3994 (depth = 7)
  gc_frame_newslot(strlit3994);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3994;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3995 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3993);
// compiled call node returning call3995 (depth = 6)
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3996 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3997 == NULL) {
    strlit3997 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3997);
  }
// compiled string node returning strlit3997 (depth = 7)
  gc_frame_newslot(strlit3997);
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe3998 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call3999 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3998);
// compiled member node returning call3999 (depth = 7)
  gc_frame_newslot(call3999);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe4001 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call4002 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4001);
// compiled member node returning call4002 (depth = 8)
  int op_slot_right_4000 = gc_frame_newslot(call4002);
// starting to compile member node (depth = 8)
  int callframe4004 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call4005 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4004);
// compiled member node returning call4005 (depth = 8)
  int op_slot_left_4000 = gc_frame_newslot(call4005);
  params[0] = call4002;
  partcv[0] = 1;
  Object sum4006 = callmethod(call4005, "+(1)", 1, partcv, params);
// compiled op node returning sum4006 (depth = 7)
  gc_frame_newslot(sum4006);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit3997;
  params[1] = call3999;
  params[2] = sum4006;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4007 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe3996);
// compiled call node returning call4007 (depth = 6)
    gc_frame_newslot(call4007);
    if3980 = call4007;
  } else {
  }
// compiled if node returning if3980 (depth = 5)
// Begin line 1255
  setline(1255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4008 = gc_frame_new();
// call case 4: self request
  Object call4009 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4008);
// compiled member node returning call4009 (depth = 5)
    gc_frame_newslot(call4009);
    if3935 = call4009;
  } else {
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array4010 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4010 (depth = 6)
  *var_suggestions = array4010;
  if (array4010 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1258
  setline(1258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4011 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call4012 = callmethodflags(self, "findNextTokenIndentedAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4011);
// compiled call node returning call4012 (depth = 6)
  *var_nextTok = call4012;
  if (call4012 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1259
  setline(1259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4013 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4014 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call4015 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4014);
// compiled member node returning call4015 (depth = 7)
  Object call4016 = callmethodflags(call4015, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4013);
// compiled member node returning call4016 (depth = 6)
  *var_suggestion = call4016;
  if (call4016 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_right_4018 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 7)
  Object bool4020 = alloc_Boolean(0);
// compiled identifier node returning bool4020 (depth = 7)
  int op_slot_left_4018 = gc_frame_newslot(bool4020);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult4021 = callmethod(bool4020, "==(1)", 1, partcv, params);
// compiled op node returning opresult4021 (depth = 6)
  Object if4017 = done;
  if (istrue(opresult4021)) {
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4022 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4023 == NULL) {
    strlit4023 = alloc_String(" }");
    gc_root(strlit4023);
  }
// compiled string node returning strlit4023 (depth = 7)
  gc_frame_newslot(strlit4023);
// starting to compile member node (depth = 7)
  int callframe4024 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  Object call4025 = callmethodflags(*var_tokens, "first", 0, partcv, params, 0);
  gc_frame_end(callframe4024);
// compiled member node returning call4025 (depth = 7)
  gc_frame_newslot(call4025);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4023;
  params[1] = call4025;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4026 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4022);
// compiled call node returning call4026 (depth = 6)
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4027 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4028 == NULL) {
    strlit4028 = alloc_String(" {");
    gc_root(strlit4028);
  }
// compiled string node returning strlit4028 (depth = 7)
  gc_frame_newslot(strlit4028);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4028;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4029 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4027);
// compiled call node returning call4029 (depth = 6)
// Begin line 1263
  setline(1263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4030 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4031 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4030);
// compiled call node returning call4031 (depth = 6)
    gc_frame_newslot(call4031);
    if4017 = call4031;
  } else {
// Begin line 1270
  setline(1270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1264
  setline(1264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_4033 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_4033 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4035 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult4035 (depth = 7)
  Object if4032 = done;
  if (istrue(opresult4035)) {
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4036 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4037 == NULL) {
    strlit4037 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4037);
  }
// compiled string node returning strlit4037 (depth = 8)
  gc_frame_newslot(strlit4037);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4037;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4038 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4036);
// compiled call node returning call4038 (depth = 7)
// Begin line 1266
  setline(1266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4039 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4040 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4039);
// compiled call node returning call4040 (depth = 7)
// Begin line 1267
  setline(1267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe4041 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4042 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call4043 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4042);
// compiled member node returning call4043 (depth = 9)
  Object call4044 = callmethodflags(call4043, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4041);
// compiled member node returning call4044 (depth = 8)
  *var_suggestion = call4044;
  if (call4044 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 1268
  setline(1268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4046 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4047 == NULL) {
    strlit4047 = alloc_String(" { ""\xc2""""\xab""expression""\xc2""""\xbb"" }");
    gc_root(strlit4047);
  }
// compiled string node returning strlit4047 (depth = 8)
  gc_frame_newslot(strlit4047);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4047;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4048 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4046);
// compiled call node returning call4048 (depth = 7)
// Begin line 1269
  setline(1269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4049 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4050 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4049);
// compiled call node returning call4050 (depth = 7)
    gc_frame_newslot(call4050);
    if4032 = call4050;
  } else {
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4051 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4052 == NULL) {
    strlit4052 = alloc_String(" }");
    gc_root(strlit4052);
  }
// compiled string node returning strlit4052 (depth = 8)
  gc_frame_newslot(strlit4052);
// starting to compile member node (depth = 8)
  int callframe4053 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  Object call4054 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4053);
// compiled member node returning call4054 (depth = 8)
  gc_frame_newslot(call4054);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4052;
  params[1] = call4054;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4055 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4051);
// compiled call node returning call4055 (depth = 7)
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4056 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4057 == NULL) {
    strlit4057 = alloc_String(" {");
    gc_root(strlit4057);
  }
// compiled string node returning strlit4057 (depth = 8)
  gc_frame_newslot(strlit4057);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4057;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4058 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4056);
// compiled call node returning call4058 (depth = 7)
// Begin line 1273
  setline(1273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4059 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4060 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4059);
// compiled call node returning call4060 (depth = 7)
    gc_frame_newslot(call4060);
    if4032 = call4060;
  }
// compiled if node returning if4032 (depth = 6)
    gc_frame_newslot(if4032);
    if4017 = if4032;
  }
// compiled if node returning if4017 (depth = 5)
// Begin line 1275
  setline(1275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4061 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4062 == NULL) {
    strlit4062 = alloc_String("a try-finally statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit4062);
  }
// compiled string node returning strlit4062 (depth = 6)
  gc_frame_newslot(strlit4062);
// Begin line 1276
  setline(1276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4063 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call4064 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4063);
// compiled member node returning call4064 (depth = 6)
  gc_frame_newslot(call4064);
// starting to compile member node (depth = 6)
  int callframe4065 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call4066 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4065);
// compiled member node returning call4066 (depth = 6)
  gc_frame_newslot(call4066);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1275
  setline(1275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit4062;
  params[1] = call4064;
  params[2] = call4066;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4067 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4061);
// compiled call node returning call4067 (depth = 5)
    gc_frame_newslot(call4067);
    if3935 = call4067;
  }
// compiled if node returning if3935 (depth = 4)
    gc_frame_newslot(if3935);
    if3929 = if3935;
  }
// compiled if node returning if3929 (depth = 3)
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4068 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call4069 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe4068);
// compiled member node returning call4069 (depth = 4)
  *var_finally = call4069;
  if (call4069 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if3914 = done;
  } else {
  }
// compiled if node returning if3914 (depth = 2)
// Begin line 1280
  setline(1280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4071 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe4072 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_catchTok (depth = 4)
  Object call4073 = callmethodflags(*var_catchTok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4072);
// compiled member node returning call4073 (depth = 3)
  gc_frame_newslot(call4073);
// starting to compile member node (depth = 3)
  int callframe4074 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_catchTok (depth = 4)
  Object call4075 = callmethodflags(*var_catchTok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4074);
// compiled member node returning call4075 (depth = 3)
  gc_frame_newslot(call4075);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4073;
  params[1] = call4075;
  partcv[0] = 2;
  Object call4076 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4071);
// compiled call node returning call4076 (depth = 2)
// Begin line 1281
  setline(1281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4077 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4078 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_mainblock (depth = 4)
  gc_frame_newslot(*var_mainblock);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases (depth = 4)
  gc_frame_newslot(*var_cases);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_finally (depth = 4)
  gc_frame_newslot(*var_finally);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4079 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call4080 = callmethodflags(*var_ast, "tryCatchNode", 0, partcv, params, 0);
  gc_frame_end(callframe4079);
// compiled member node returning call4080 (depth = 4)
  params[0] = *var_mainblock;
  params[1] = *var_cases;
  params[2] = *var_finally;
  partcv[0] = 3;
  Object call4081 = callmethodflags(call4080, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe4078);
// compiled call node returning call4081 (depth = 3)
  gc_frame_newslot(call4081);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = call4081;
  partcv[0] = 1;
  Object call4082 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4077);
// compiled call node returning call4082 (depth = 2)
// Begin line 1282
  setline(1282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localmin (depth = 3)
  *var_minIndentLevel = *var_localmin;
  if (*var_localmin == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply_40_1_41_4116(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_matchTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4120 == NULL) {
    strlit4120 = alloc_String("case");
    gc_root(strlit4120);
  }
// compiled string node returning strlit4120 (depth = 9)
  int op_slot_right_4119 = gc_frame_newslot(strlit4120);
// starting to compile member node (depth = 9)
  int callframe4122 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call4123 = callmethodflags(*var_t, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4122);
// compiled member node returning call4123 (depth = 9)
  int op_slot_left_4119 = gc_frame_newslot(call4123);
  params[0] = strlit4120;
  partcv[0] = 1;
  Object opresult4124 = callmethod(call4123, "==(1)", 1, partcv, params);
// compiled op node returning opresult4124 (depth = 8)
  int op_slot_right_4118 = gc_frame_newslot(opresult4124);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4127 == NULL) {
    strlit4127 = alloc_String("identifier");
    gc_root(strlit4127);
  }
// compiled string node returning strlit4127 (depth = 9)
  int op_slot_right_4126 = gc_frame_newslot(strlit4127);
// starting to compile member node (depth = 9)
  int callframe4129 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call4130 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe4129);
// compiled member node returning call4130 (depth = 9)
  int op_slot_left_4126 = gc_frame_newslot(call4130);
  params[0] = strlit4127;
  partcv[0] = 1;
  Object opresult4131 = callmethod(call4130, "==(1)", 1, partcv, params);
// compiled op node returning opresult4131 (depth = 8)
  int op_slot_left_4118 = gc_frame_newslot(opresult4131);
  params[0] = opresult4124;
  partcv[0] = 1;
  Object opresult4132 = callmethod(opresult4131, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4132 (depth = 7)
  int op_slot_right_4117 = gc_frame_newslot(opresult4132);
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe4136 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_matchTok (depth = 10)
  Object call4137 = callmethodflags(*var_matchTok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4136);
// compiled member node returning call4137 (depth = 9)
  int op_slot_right_4135 = gc_frame_newslot(call4137);
// starting to compile member node (depth = 9)
  int callframe4139 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call4140 = callmethodflags(*var_t, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4139);
// compiled member node returning call4140 (depth = 9)
  int op_slot_left_4135 = gc_frame_newslot(call4140);
  params[0] = call4137;
  partcv[0] = 1;
  Object opresult4141 = callmethod(call4140, "==(1)", 1, partcv, params);
// compiled op node returning opresult4141 (depth = 8)
  int op_slot_right_4134 = gc_frame_newslot(opresult4141);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4144 == NULL) {
    strlit4144 = alloc_String("rparen");
    gc_root(strlit4144);
  }
// compiled string node returning strlit4144 (depth = 9)
  int op_slot_right_4143 = gc_frame_newslot(strlit4144);
// starting to compile member node (depth = 9)
  int callframe4146 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call4147 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe4146);
// compiled member node returning call4147 (depth = 9)
  int op_slot_left_4143 = gc_frame_newslot(call4147);
  params[0] = strlit4144;
  partcv[0] = 1;
  Object opresult4148 = callmethod(call4147, "==(1)", 1, partcv, params);
// compiled op node returning opresult4148 (depth = 8)
  int op_slot_left_4134 = gc_frame_newslot(opresult4148);
  params[0] = opresult4141;
  partcv[0] = 1;
  Object opresult4149 = callmethod(opresult4148, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4149 (depth = 7)
  int op_slot_left_4117 = gc_frame_newslot(opresult4149);
  params[0] = opresult4132;
  partcv[0] = 1;
  Object opresult4150 = callmethod(opresult4149, "||(1)", 1, partcv, params);
// compiled op node returning opresult4150 (depth = 6)
  gc_frame_end(frame);
  return opresult4150;
}
Object meth_parser__apply4212(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe4213 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blocksOK (depth = 7)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4214 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4213);
// compiled call node returning call4214 (depth = 6)
  gc_frame_end(frame);
  return call4214;
}
Object meth_parser__apply4283(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4286 == NULL) {
    strlit4286 = alloc_String("case");
    gc_root(strlit4286);
  }
// compiled string node returning strlit4286 (depth = 6)
  int op_slot_right_4285 = gc_frame_newslot(strlit4286);
// starting to compile member node (depth = 6)
  int callframe4288 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call4289 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4288);
// compiled member node returning call4289 (depth = 6)
  int op_slot_left_4285 = gc_frame_newslot(call4289);
  params[0] = strlit4286;
  partcv[0] = 1;
  Object opresult4290 = callmethod(call4289, "==(1)", 1, partcv, params);
// compiled op node returning opresult4290 (depth = 5)
  int op_slot_right_4284 = gc_frame_newslot(opresult4290);
// starting to compile call node (depth = 5)
  int callframe4292 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4293 == NULL) {
    strlit4293 = alloc_String("identifier");
    gc_root(strlit4293);
  }
// compiled string node returning strlit4293 (depth = 6)
  gc_frame_newslot(strlit4293);
// call case 4: self request
  params[0] = strlit4293;
  partcv[0] = 1;
  Object call4294 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4292);
// compiled call node returning call4294 (depth = 5)
  int op_slot_left_4284 = gc_frame_newslot(call4294);
  params[0] = opresult4290;
  partcv[0] = 1;
  Object opresult4295 = callmethod(call4294, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4295 (depth = 4)
  gc_frame_end(frame);
  return opresult4295;
}
Object meth_parser__apply4317(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 10)
  int callframe4318 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_blocksOK (depth = 11)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4319 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4318);
// compiled call node returning call4319 (depth = 10)
  gc_frame_end(frame);
  return call4319;
}
Object meth_parser__apply4298(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_cases = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1335
  setline(1335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4299 = gc_frame_new();
// call case 4: self request
  Object call4300 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4299);
// compiled member node returning call4300 (depth = 4)
// Begin line 1336
  setline(1336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4302 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4303 == NULL) {
    strlit4303 = alloc_String("lbrace");
    gc_root(strlit4303);
  }
// compiled string node returning strlit4303 (depth = 6)
  gc_frame_newslot(strlit4303);
// call case 4: self request
  params[0] = strlit4303;
  partcv[0] = 1;
  Object call4304 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4302);
// compiled call node returning call4304 (depth = 5)
  Object if4301 = done;
  if (istrue(call4304)) {
// Begin line 1337
  setline(1337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4305 = gc_frame_new();
// call case 4: self request
  Object call4306 = callmethodflags(self, "block", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4305);
// compiled member node returning call4306 (depth = 5)
    gc_frame_newslot(call4306);
    if4301 = call4306;
  } else {
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1338
  setline(1338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4308 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4309 == NULL) {
    strlit4309 = alloc_String("lparen");
    gc_root(strlit4309);
  }
// compiled string node returning strlit4309 (depth = 7)
  gc_frame_newslot(strlit4309);
// call case 4: self request
  params[0] = strlit4309;
  partcv[0] = 1;
  Object call4310 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4308);
// compiled call node returning call4310 (depth = 6)
  Object if4307 = done;
  if (istrue(call4310)) {
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4311 = gc_frame_new();
// call case 4: self request
  Object call4312 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4311);
// compiled member node returning call4312 (depth = 6)
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4314 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe4315 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block4316 = alloc_Block(NULL, NULL, "parser", 1340);
  gc_frame_newslot(block4316);
// method "_apply"
  block_savedest(block4316);
  Object closure4317 = createclosure(2, "_apply");
  setclosureframe(closure4317, stackframe);
  addtoclosure(closure4317, var_blocksOK);
  addtoclosure(closure4317, selfslot);
  struct UserObject *uo4317 = (struct UserObject*)block4316;
  uo4317->data[0] = (Object)closure4317;
  Method *meth_meth_parser__apply4317 = addmethod2pos(block4316, "_apply", &meth_parser__apply4317, 0);
  int argcv_meth_parser__apply4317[] = {0};
  meth_meth_parser__apply4317->type = alloc_MethodType(1, argcv_meth_parser__apply4317);
  meth_meth_parser__apply4317->definitionModule = modulename;
  meth_meth_parser__apply4317->definitionLine = 3399;
// compiled block node returning block4316 (depth = 9)
  gc_frame_newslot(block4316);
// call case 4: self request
  params[0] = block4316;
  partcv[0] = 1;
  Object call4321 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4315);
// compiled call node returning call4321 (depth = 8)
  Object call4322 = callmethodflags(call4321, "not", 0, partcv, params, 0);
  gc_frame_end(callframe4314);
// compiled member node returning call4322 (depth = 7)
  Object if4313 = done;
  if (istrue(call4322)) {
// Begin line 1341
  setline(1341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe4323 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4324 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call4325 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4324);
// compiled member node returning call4325 (depth = 9)
  Object call4326 = callmethodflags(call4325, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4323);
// compiled member node returning call4326 (depth = 8)
  *var_suggestion = call4326;
  if (call4326 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4327 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array4328 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit4329 == NULL) {
    strlit4329 = alloc_String("rparen");
    gc_root(strlit4329);
  }
// compiled string node returning strlit4329 (depth = 10)
  params[0] = strlit4329;
  partcv[0] = 1;
  callmethodflags(array4328, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array4328 (depth = 9)
  gc_frame_newslot(array4328);
// call case 4: self request
  params[0] = array4328;
  partcv[0] = 1;
  Object call4330 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4327);
// compiled call node returning call4330 (depth = 8)
  *var_nextTok = call4330;
  if (call4330 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1343
  setline(1343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4332 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4332 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4334 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult4334 (depth = 8)
  Object if4331 = done;
  if (istrue(opresult4334)) {
// Begin line 1344
  setline(1344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4335 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4336 == NULL) {
    strlit4336 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4336);
  }
// compiled string node returning strlit4336 (depth = 9)
  gc_frame_newslot(strlit4336);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4336;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4337 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4335);
// compiled call node returning call4337 (depth = 8)
    gc_frame_newslot(call4337);
    if4331 = call4337;
  } else {
// Begin line 1346
  setline(1346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4338 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
  int callframe4339 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call4340 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4339);
// compiled member node returning call4340 (depth = 9)
  gc_frame_newslot(call4340);
// starting to compile identifier node (depth = 9)
  Object bool4341 = alloc_Boolean(1);
// compiled identifier node returning bool4341 (depth = 9)
  gc_frame_newslot(bool4341);
// starting to compile identifier node (depth = 9)
  Object bool4342 = alloc_Boolean(0);
// compiled identifier node returning bool4342 (depth = 9)
  gc_frame_newslot(bool4342);
// starting to compile string node (depth = 9)
  if (strlit4343 == NULL) {
    strlit4343 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4343);
  }
// compiled string node returning strlit4343 (depth = 9)
  gc_frame_newslot(strlit4343);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call4340;
  params[2] = bool4341;
  params[3] = bool4342;
  params[4] = strlit4343;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4344 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe4338);
// compiled call node returning call4344 (depth = 8)
    gc_frame_newslot(call4344);
    if4331 = call4344;
  }
// compiled if node returning if4331 (depth = 7)
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4345 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4346 == NULL) {
    strlit4346 = alloc_String("a match statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4346);
  }
// compiled string node returning strlit4346 (depth = 8)
  gc_frame_newslot(strlit4346);
// Begin line 1349
  setline(1349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe4347 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call4348 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4347);
// compiled member node returning call4348 (depth = 8)
  gc_frame_newslot(call4348);
// starting to compile member node (depth = 8)
  int callframe4349 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call4350 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4349);
// compiled member node returning call4350 (depth = 8)
  gc_frame_newslot(call4350);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit4346;
  params[1] = call4348;
  params[2] = call4350;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4351 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4345);
// compiled call node returning call4351 (depth = 7)
    gc_frame_newslot(call4351);
    if4313 = call4351;
  } else {
  }
// compiled if node returning if4313 (depth = 6)
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4354 == NULL) {
    strlit4354 = alloc_String("rparen");
    gc_root(strlit4354);
  }
// compiled string node returning strlit4354 (depth = 8)
  int op_slot_right_4353 = gc_frame_newslot(strlit4354);
// starting to compile member node (depth = 8)
  int callframe4356 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call4357 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe4356);
// compiled member node returning call4357 (depth = 8)
  int op_slot_left_4353 = gc_frame_newslot(call4357);
  params[0] = strlit4354;
  partcv[0] = 1;
  Object opresult4358 = callmethod(call4357, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4358 (depth = 7)
  Object if4352 = done;
  if (istrue(opresult4358)) {
// Begin line 1352
  setline(1352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4359 = gc_frame_new();
// call case 4: self request
  Object call4360 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4359);
// compiled member node returning call4360 (depth = 7)
// Begin line 1353
  setline(1353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe4361 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4362 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call4363 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4362);
// compiled member node returning call4363 (depth = 9)
  Object call4364 = callmethodflags(call4363, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4361);
// compiled member node returning call4364 (depth = 8)
  *var_suggestion = call4364;
  if (call4364 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1354
  setline(1354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4365 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4366 == NULL) {
    strlit4366 = alloc_String(")");
    gc_root(strlit4366);
  }
// compiled string node returning strlit4366 (depth = 8)
  gc_frame_newslot(strlit4366);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4366;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4367 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4365);
// compiled call node returning call4367 (depth = 7)
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4368 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4369 == NULL) {
    strlit4369 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4369);
  }
// compiled string node returning strlit4369 (depth = 8)
  gc_frame_newslot(strlit4369);
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe4370 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call4371 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4370);
// compiled member node returning call4371 (depth = 8)
  gc_frame_newslot(call4371);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe4373 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call4374 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4373);
// compiled member node returning call4374 (depth = 9)
  int op_slot_right_4372 = gc_frame_newslot(call4374);
// starting to compile member node (depth = 9)
  int callframe4376 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call4377 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4376);
// compiled member node returning call4377 (depth = 9)
  int op_slot_left_4372 = gc_frame_newslot(call4377);
  params[0] = call4374;
  partcv[0] = 1;
  Object sum4378 = callmethod(call4377, "+(1)", 1, partcv, params);
// compiled op node returning sum4378 (depth = 8)
  gc_frame_newslot(sum4378);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit4369;
  params[1] = call4371;
  params[2] = sum4378;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4379 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4368);
// compiled call node returning call4379 (depth = 7)
    gc_frame_newslot(call4379);
    if4352 = call4379;
  } else {
  }
// compiled if node returning if4352 (depth = 6)
// Begin line 1358
  setline(1358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4380 = gc_frame_new();
// call case 4: self request
  Object call4381 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4380);
// compiled member node returning call4381 (depth = 6)
    gc_frame_newslot(call4381);
    if4307 = call4381;
  } else {
// Begin line 1360
  setline(1360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array4382 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4382 (depth = 7)
  *var_suggestions = array4382;
  if (array4382 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1361
  setline(1361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4383 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call4384 = callmethodflags(self, "findNextTokenIndentedAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4383);
// compiled call node returning call4384 (depth = 7)
  *var_nextTok = call4384;
  if (call4384 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1362
  setline(1362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4385 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4386 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call4387 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4386);
// compiled member node returning call4387 (depth = 8)
  Object call4388 = callmethodflags(call4387, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4385);
// compiled member node returning call4388 (depth = 7)
  *var_suggestion = call4388;
  if (call4388 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1363
  setline(1363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_right_4390 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 8)
  Object bool4392 = alloc_Boolean(0);
// compiled identifier node returning bool4392 (depth = 8)
  int op_slot_left_4390 = gc_frame_newslot(bool4392);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult4393 = callmethod(bool4392, "==(1)", 1, partcv, params);
// compiled op node returning opresult4393 (depth = 7)
  Object if4389 = done;
  if (istrue(opresult4393)) {
// Begin line 1364
  setline(1364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4394 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4395 == NULL) {
    strlit4395 = alloc_String(" }");
    gc_root(strlit4395);
  }
// compiled string node returning strlit4395 (depth = 8)
  gc_frame_newslot(strlit4395);
// starting to compile member node (depth = 8)
  int callframe4396 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  Object call4397 = callmethodflags(*var_tokens, "last", 0, partcv, params, 0);
  gc_frame_end(callframe4396);
// compiled member node returning call4397 (depth = 8)
  gc_frame_newslot(call4397);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4395;
  params[1] = call4397;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4398 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4394);
// compiled call node returning call4398 (depth = 7)
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4399 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4400 == NULL) {
    strlit4400 = alloc_String(" {");
    gc_root(strlit4400);
  }
// compiled string node returning strlit4400 (depth = 8)
  gc_frame_newslot(strlit4400);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4400;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4401 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4399);
// compiled call node returning call4401 (depth = 7)
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4402 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4403 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4402);
// compiled call node returning call4403 (depth = 7)
    gc_frame_newslot(call4403);
    if4389 = call4403;
  } else {
// Begin line 1373
  setline(1373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4405 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4405 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4407 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult4407 (depth = 8)
  Object if4404 = done;
  if (istrue(opresult4407)) {
// Begin line 1368
  setline(1368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4408 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4409 == NULL) {
    strlit4409 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4409);
  }
// compiled string node returning strlit4409 (depth = 9)
  gc_frame_newslot(strlit4409);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4409;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4410 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4408);
// compiled call node returning call4410 (depth = 8)
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4411 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4412 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4411);
// compiled call node returning call4412 (depth = 8)
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe4413 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe4414 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call4415 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4414);
// compiled member node returning call4415 (depth = 10)
  Object call4416 = callmethodflags(call4415, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4413);
// compiled member node returning call4416 (depth = 9)
  *var_suggestion = call4416;
  if (call4416 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4418 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4419 == NULL) {
    strlit4419 = alloc_String(" { ""\xc2""""\xab""match expression""\xc2""""\xbb"" }");
    gc_root(strlit4419);
  }
// compiled string node returning strlit4419 (depth = 9)
  gc_frame_newslot(strlit4419);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4419;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4420 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4418);
// compiled call node returning call4420 (depth = 8)
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4421 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4422 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4421);
// compiled call node returning call4422 (depth = 8)
    gc_frame_newslot(call4422);
    if4404 = call4422;
  } else {
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4423 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4424 == NULL) {
    strlit4424 = alloc_String(" }");
    gc_root(strlit4424);
  }
// compiled string node returning strlit4424 (depth = 9)
  gc_frame_newslot(strlit4424);
// starting to compile member node (depth = 9)
  int callframe4425 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call4426 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4425);
// compiled member node returning call4426 (depth = 9)
  gc_frame_newslot(call4426);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4424;
  params[1] = call4426;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4427 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4423);
// compiled call node returning call4427 (depth = 8)
// Begin line 1375
  setline(1375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4428 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4429 == NULL) {
    strlit4429 = alloc_String(" {");
    gc_root(strlit4429);
  }
// compiled string node returning strlit4429 (depth = 9)
  gc_frame_newslot(strlit4429);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4429;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4430 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4428);
// compiled call node returning call4430 (depth = 8)
// Begin line 1376
  setline(1376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4431 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4432 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4431);
// compiled call node returning call4432 (depth = 8)
    gc_frame_newslot(call4432);
    if4404 = call4432;
  }
// compiled if node returning if4404 (depth = 7)
    gc_frame_newslot(if4404);
    if4389 = if4404;
  }
// compiled if node returning if4389 (depth = 6)
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4433 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4434 == NULL) {
    strlit4434 = alloc_String("a match statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4434);
  }
// compiled string node returning strlit4434 (depth = 7)
  gc_frame_newslot(strlit4434);
// Begin line 1379
  setline(1379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4435 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call4436 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4435);
// compiled member node returning call4436 (depth = 7)
  gc_frame_newslot(call4436);
// starting to compile member node (depth = 7)
  int callframe4437 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call4438 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4437);
// compiled member node returning call4438 (depth = 7)
  gc_frame_newslot(call4438);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4434;
  params[1] = call4436;
  params[2] = call4438;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4439 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4433);
// compiled call node returning call4439 (depth = 6)
    gc_frame_newslot(call4439);
    if4307 = call4439;
  }
// compiled if node returning if4307 (depth = 5)
    gc_frame_newslot(if4307);
    if4301 = if4307;
  }
// compiled if node returning if4301 (depth = 4)
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4440 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4441 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call4442 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe4441);
// compiled member node returning call4442 (depth = 5)
  gc_frame_newslot(call4442);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cases (depth = 5)
  params[0] = call4442;
  partcv[0] = 1;
  Object call4443 = callmethodflags(*var_cases, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4440);
// compiled call node returning call4443 (depth = 4)
  gc_frame_end(frame);
  return call4443;
}
Object meth_parser_matchcase4084(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "matchcase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_tokens = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_localmin = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "localmin");
  Object *var_matchTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "matchTok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_matchee = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "matchee");
  Object *var_cases = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cases");
  Object *var_elsecase = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "elsecase");
// Begin line 1285
  setline(1285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4086 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4089 == NULL) {
    strlit4089 = alloc_String("match");
    gc_root(strlit4089);
  }
// compiled string node returning strlit4089 (depth = 6)
  int op_slot_right_4088 = gc_frame_newslot(strlit4089);
// starting to compile member node (depth = 6)
  int callframe4091 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call4092 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4091);
// compiled member node returning call4092 (depth = 6)
  int op_slot_left_4088 = gc_frame_newslot(call4092);
  params[0] = strlit4089;
  partcv[0] = 1;
  Object opresult4093 = callmethod(call4092, "==(1)", 1, partcv, params);
// compiled op node returning opresult4093 (depth = 5)
  int op_slot_right_4087 = gc_frame_newslot(opresult4093);
// starting to compile call node (depth = 5)
  int callframe4095 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4096 == NULL) {
    strlit4096 = alloc_String("identifier");
    gc_root(strlit4096);
  }
// compiled string node returning strlit4096 (depth = 6)
  gc_frame_newslot(strlit4096);
// call case 4: self request
  params[0] = strlit4096;
  partcv[0] = 1;
  Object call4097 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4095);
// compiled call node returning call4097 (depth = 5)
  int op_slot_left_4087 = gc_frame_newslot(call4097);
  params[0] = opresult4093;
  partcv[0] = 1;
  Object opresult4098 = callmethod(call4097, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4098 (depth = 4)
  partcv[0] = 0;
  Object call4099 = callmethodflags(opresult4098, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe4086);
// compiled call node returning call4099 (depth = 3)
  Object if4085 = done;
  if (istrue(call4099)) {
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4100 = alloc_Float64(0);
// compiled num node returning num4100 (depth = 4)
  return num4100;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if4085 = undefined;
  } else {
  }
// compiled if node returning if4085 (depth = 2)
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localmin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1289
  setline(1289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_matchTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1290
  setline(1290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4101 = gc_frame_new();
// call case 4: self request
  Object call4102 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4101);
// compiled member node returning call4102 (depth = 2)
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4105 == NULL) {
    strlit4105 = alloc_String("lparen");
    gc_root(strlit4105);
  }
// compiled string node returning strlit4105 (depth = 4)
  int op_slot_right_4104 = gc_frame_newslot(strlit4105);
// starting to compile member node (depth = 4)
  int callframe4107 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call4108 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe4107);
// compiled member node returning call4108 (depth = 4)
  int op_slot_left_4104 = gc_frame_newslot(call4108);
  params[0] = strlit4105;
  partcv[0] = 1;
  Object opresult4109 = callmethod(call4108, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4109 (depth = 3)
  Object if4103 = done;
  if (istrue(opresult4109)) {
// Begin line 1292
  setline(1292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4110 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4111 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call4112 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4111);
// compiled member node returning call4112 (depth = 5)
  Object call4113 = callmethodflags(call4112, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4110);
// compiled member node returning call4113 (depth = 4)
  *var_suggestion = call4113;
  if (call4113 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4114 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4115 = alloc_Block(NULL, NULL, "parser", 1294);
  gc_frame_newslot(block4115);
// method "_apply(_)"
  block_savedest(block4115);
  Object closure4116 = createclosure(2, "_apply(1)");
  setclosureframe(closure4116, stackframe);
  addtoclosure(closure4116, var_matchTok);
  addtoclosure(closure4116, selfslot);
  struct UserObject *uo4116 = (struct UserObject*)block4115;
  uo4116->data[0] = (Object)closure4116;
  Method *meth_meth_parser__apply_40_1_41_4116 = addmethod2pos(block4115, "_apply(1)", &meth_parser__apply_40_1_41_4116, 0);
  int argcv_meth_parser__apply_40_1_41_4116[] = {1};
  meth_meth_parser__apply_40_1_41_4116->type = alloc_MethodType(1, argcv_meth_parser__apply_40_1_41_4116);
  meth_meth_parser__apply_40_1_41_4116->definitionModule = modulename;
  meth_meth_parser__apply_40_1_41_4116->definitionLine = 3399;
// compiled block node returning block4115 (depth = 5)
  gc_frame_newslot(block4115);
// call case 4: self request
  params[0] = block4115;
  partcv[0] = 1;
  Object call4152 = callmethodflags(self, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4114);
// compiled call node returning call4152 (depth = 4)
  *var_nextTok = call4152;
  if (call4152 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1296
  setline(1296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_right_4154 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 5)
  Object bool4156 = alloc_Boolean(0);
// compiled identifier node returning bool4156 (depth = 5)
  int op_slot_left_4154 = gc_frame_newslot(bool4156);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult4157 = callmethod(bool4156, "==(1)", 1, partcv, params);
// compiled op node returning opresult4157 (depth = 4)
  Object if4153 = done;
  if (istrue(opresult4157)) {
// Begin line 1297
  setline(1297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4158 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4159 == NULL) {
    strlit4159 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4159);
  }
// compiled string node returning strlit4159 (depth = 5)
  gc_frame_newslot(strlit4159);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchTok (depth = 5)
  gc_frame_newslot(*var_matchTok);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4159;
  params[1] = *var_matchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4160 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4158);
// compiled call node returning call4160 (depth = 4)
    gc_frame_newslot(call4160);
    if4153 = call4160;
  } else {
// Begin line 1304
  setline(1304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4163 == NULL) {
    strlit4163 = alloc_String("rparen");
    gc_root(strlit4163);
  }
// compiled string node returning strlit4163 (depth = 6)
  int op_slot_right_4162 = gc_frame_newslot(strlit4163);
// starting to compile member node (depth = 6)
  int callframe4165 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  Object call4166 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe4165);
// compiled member node returning call4166 (depth = 6)
  int op_slot_left_4162 = gc_frame_newslot(call4166);
  params[0] = strlit4163;
  partcv[0] = 1;
  Object opresult4167 = callmethod(call4166, "==(1)", 1, partcv, params);
// compiled op node returning opresult4167 (depth = 5)
  Object if4161 = done;
  if (istrue(opresult4167)) {
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_4169 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_4169 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4171 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult4171 (depth = 6)
  Object if4168 = done;
  if (istrue(opresult4171)) {
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4172 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4173 == NULL) {
    strlit4173 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4173);
  }
// compiled string node returning strlit4173 (depth = 7)
  gc_frame_newslot(strlit4173);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4173;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4174 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4172);
// compiled call node returning call4174 (depth = 6)
    gc_frame_newslot(call4174);
    if4168 = call4174;
  } else {
// Begin line 1302
  setline(1302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4175 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4176 == NULL) {
    strlit4176 = alloc_String("(");
    gc_root(strlit4176);
  }
// compiled string node returning strlit4176 (depth = 7)
  gc_frame_newslot(strlit4176);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4176;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4177 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4175);
// compiled call node returning call4177 (depth = 6)
    gc_frame_newslot(call4177);
    if4168 = call4177;
  }
// compiled if node returning if4168 (depth = 5)
    gc_frame_newslot(if4168);
    if4161 = if4168;
  } else {
// Begin line 1308
  setline(1308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1304
  setline(1304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4180 == NULL) {
    strlit4180 = alloc_String("identifier");
    gc_root(strlit4180);
  }
// compiled string node returning strlit4180 (depth = 7)
  int op_slot_right_4179 = gc_frame_newslot(strlit4180);
// starting to compile member node (depth = 7)
  int callframe4182 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call4183 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe4182);
// compiled member node returning call4183 (depth = 7)
  int op_slot_left_4179 = gc_frame_newslot(call4183);
  params[0] = strlit4180;
  partcv[0] = 1;
  Object opresult4184 = callmethod(call4183, "==(1)", 1, partcv, params);
// compiled op node returning opresult4184 (depth = 6)
  Object if4178 = done;
  if (istrue(opresult4184)) {
// Begin line 1305
  setline(1305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4185 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4186 == NULL) {
    strlit4186 = alloc_String("(");
    gc_root(strlit4186);
  }
// compiled string node returning strlit4186 (depth = 7)
  gc_frame_newslot(strlit4186);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4186;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4187 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4185);
// compiled call node returning call4187 (depth = 6)
// Begin line 1306
  setline(1306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4188 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4189 == NULL) {
    strlit4189 = alloc_String(")");
    gc_root(strlit4189);
  }
// compiled string node returning strlit4189 (depth = 7)
  gc_frame_newslot(strlit4189);
// starting to compile member node (depth = 7)
  int callframe4190 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call4191 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4190);
// compiled member node returning call4191 (depth = 7)
  gc_frame_newslot(call4191);
// starting to compile identifier node (depth = 7)
  Object bool4192 = alloc_Boolean(1);
// compiled identifier node returning bool4192 (depth = 7)
  gc_frame_newslot(bool4192);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4189;
  params[1] = call4191;
  params[2] = bool4192;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4193 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4188);
// compiled call node returning call4193 (depth = 6)
    gc_frame_newslot(call4193);
    if4178 = call4193;
  } else {
  }
// compiled if node returning if4178 (depth = 5)
    gc_frame_newslot(if4178);
    if4161 = if4178;
  }
// compiled if node returning if4161 (depth = 4)
    gc_frame_newslot(if4161);
    if4153 = if4161;
  }
// compiled if node returning if4153 (depth = 3)
// Begin line 1308
  setline(1308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4194 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4195 == NULL) {
    strlit4195 = alloc_String("a match statement must have an expression in parentheses after the 'match'.");
    gc_root(strlit4195);
  }
// compiled string node returning strlit4195 (depth = 4)
  gc_frame_newslot(strlit4195);
// Begin line 1309
  setline(1309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4196 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchTok (depth = 5)
  Object call4197 = callmethodflags(*var_matchTok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4196);
// compiled member node returning call4197 (depth = 4)
  gc_frame_newslot(call4197);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4199 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_matchTok (depth = 6)
  Object call4200 = callmethodflags(*var_matchTok, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4199);
// compiled member node returning call4200 (depth = 5)
  int op_slot_right_4198 = gc_frame_newslot(call4200);
// starting to compile member node (depth = 5)
  int callframe4202 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_matchTok (depth = 6)
  Object call4203 = callmethodflags(*var_matchTok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4202);
// compiled member node returning call4203 (depth = 5)
  int op_slot_left_4198 = gc_frame_newslot(call4203);
  params[0] = call4200;
  partcv[0] = 1;
  Object sum4204 = callmethod(call4203, "+(1)", 1, partcv, params);
// compiled op node returning sum4204 (depth = 4)
  gc_frame_newslot(sum4204);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1308
  setline(1308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit4195;
  params[1] = call4197;
  params[2] = sum4204;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4205 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4194);
// compiled call node returning call4205 (depth = 3)
    gc_frame_newslot(call4205);
    if4103 = call4205;
  } else {
  }
// compiled if node returning if4103 (depth = 2)
// Begin line 1311
  setline(1311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4206 = gc_frame_new();
// call case 4: self request
  Object call4207 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4206);
// compiled member node returning call4207 (depth = 2)
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4209 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe4210 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4211 = alloc_Block(NULL, NULL, "parser", 1312);
  gc_frame_newslot(block4211);
// method "_apply"
  block_savedest(block4211);
  Object closure4212 = createclosure(2, "_apply");
  setclosureframe(closure4212, stackframe);
  addtoclosure(closure4212, var_blocksOK);
  addtoclosure(closure4212, selfslot);
  struct UserObject *uo4212 = (struct UserObject*)block4211;
  uo4212->data[0] = (Object)closure4212;
  Method *meth_meth_parser__apply4212 = addmethod2pos(block4211, "_apply", &meth_parser__apply4212, 0);
  int argcv_meth_parser__apply4212[] = {0};
  meth_meth_parser__apply4212->type = alloc_MethodType(1, argcv_meth_parser__apply4212);
  meth_meth_parser__apply4212->definitionModule = modulename;
  meth_meth_parser__apply4212->definitionLine = 3399;
// compiled block node returning block4211 (depth = 5)
  gc_frame_newslot(block4211);
// call case 4: self request
  params[0] = block4211;
  partcv[0] = 1;
  Object call4216 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4210);
// compiled call node returning call4216 (depth = 4)
  Object call4217 = callmethodflags(call4216, "not", 0, partcv, params, 0);
  gc_frame_end(callframe4209);
// compiled member node returning call4217 (depth = 3)
  Object if4208 = done;
  if (istrue(call4217)) {
// Begin line 1313
  setline(1313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4218 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4219 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call4220 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4219);
// compiled member node returning call4220 (depth = 5)
  Object call4221 = callmethodflags(call4220, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4218);
// compiled member node returning call4221 (depth = 4)
  *var_suggestion = call4221;
  if (call4221 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4222 = gc_frame_new();
// starting to compile array node (depth = 5)
  Object array4223 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 6)
  if (strlit4224 == NULL) {
    strlit4224 = alloc_String("rparen");
    gc_root(strlit4224);
  }
// compiled string node returning strlit4224 (depth = 6)
  params[0] = strlit4224;
  partcv[0] = 1;
  callmethodflags(array4223, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array4223 (depth = 5)
  gc_frame_newslot(array4223);
// call case 4: self request
  params[0] = array4223;
  partcv[0] = 1;
  Object call4225 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4222);
// compiled call node returning call4225 (depth = 4)
  *var_nextTok = call4225;
  if (call4225 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  int op_slot_right_4227 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_left_4227 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4229 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult4229 (depth = 4)
  Object if4226 = done;
  if (istrue(opresult4229)) {
// Begin line 1316
  setline(1316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4230 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4231 == NULL) {
    strlit4231 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4231);
  }
// compiled string node returning strlit4231 (depth = 5)
  gc_frame_newslot(strlit4231);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4231;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4232 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4230);
// compiled call node returning call4232 (depth = 4)
    gc_frame_newslot(call4232);
    if4226 = call4232;
  } else {
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4233 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 5)
  int callframe4234 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  Object call4235 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4234);
// compiled member node returning call4235 (depth = 5)
  gc_frame_newslot(call4235);
// starting to compile identifier node (depth = 5)
  Object bool4236 = alloc_Boolean(1);
// compiled identifier node returning bool4236 (depth = 5)
  gc_frame_newslot(bool4236);
// starting to compile identifier node (depth = 5)
  Object bool4237 = alloc_Boolean(0);
// compiled identifier node returning bool4237 (depth = 5)
  gc_frame_newslot(bool4237);
// starting to compile string node (depth = 5)
  if (strlit4238 == NULL) {
    strlit4238 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4238);
  }
// compiled string node returning strlit4238 (depth = 5)
  gc_frame_newslot(strlit4238);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = call4235;
  params[2] = bool4236;
  params[3] = bool4237;
  params[4] = strlit4238;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4239 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe4233);
// compiled call node returning call4239 (depth = 4)
    gc_frame_newslot(call4239);
    if4226 = call4239;
  }
// compiled if node returning if4226 (depth = 3)
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4240 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4241 == NULL) {
    strlit4241 = alloc_String("a match statement must have an expression in parentheses after the 'match'.");
    gc_root(strlit4241);
  }
// compiled string node returning strlit4241 (depth = 4)
  gc_frame_newslot(strlit4241);
// Begin line 1321
  setline(1321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4242 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call4243 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4242);
// compiled member node returning call4243 (depth = 4)
  gc_frame_newslot(call4243);
// starting to compile member node (depth = 4)
  int callframe4244 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call4245 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4244);
// compiled member node returning call4245 (depth = 4)
  gc_frame_newslot(call4245);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit4241;
  params[1] = call4243;
  params[2] = call4245;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4246 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4240);
// compiled call node returning call4246 (depth = 3)
    gc_frame_newslot(call4246);
    if4208 = call4246;
  } else {
  }
// compiled if node returning if4208 (depth = 2)
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4247 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  Object call4248 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe4247);
// compiled member node returning call4248 (depth = 3)
  *var_matchee = call4248;
  if (call4248 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1324
  setline(1324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4251 == NULL) {
    strlit4251 = alloc_String("rparen");
    gc_root(strlit4251);
  }
// compiled string node returning strlit4251 (depth = 4)
  int op_slot_right_4250 = gc_frame_newslot(strlit4251);
// starting to compile member node (depth = 4)
  int callframe4253 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call4254 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe4253);
// compiled member node returning call4254 (depth = 4)
  int op_slot_left_4250 = gc_frame_newslot(call4254);
  params[0] = strlit4251;
  partcv[0] = 1;
  Object opresult4255 = callmethod(call4254, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4255 (depth = 3)
  Object if4249 = done;
  if (istrue(opresult4255)) {
// Begin line 1325
  setline(1325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4256 = gc_frame_new();
// call case 4: self request
  Object call4257 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4256);
// compiled member node returning call4257 (depth = 3)
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4258 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4259 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call4260 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4259);
// compiled member node returning call4260 (depth = 5)
  Object call4261 = callmethodflags(call4260, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4258);
// compiled member node returning call4261 (depth = 4)
  *var_suggestion = call4261;
  if (call4261 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1327
  setline(1327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4262 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4263 == NULL) {
    strlit4263 = alloc_String(")");
    gc_root(strlit4263);
  }
// compiled string node returning strlit4263 (depth = 4)
  gc_frame_newslot(strlit4263);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit4263;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4264 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4262);
// compiled call node returning call4264 (depth = 3)
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4265 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4266 == NULL) {
    strlit4266 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4266);
  }
// compiled string node returning strlit4266 (depth = 4)
  gc_frame_newslot(strlit4266);
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4267 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call4268 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4267);
// compiled member node returning call4268 (depth = 4)
  gc_frame_newslot(call4268);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4270 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call4271 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4270);
// compiled member node returning call4271 (depth = 5)
  int op_slot_right_4269 = gc_frame_newslot(call4271);
// starting to compile member node (depth = 5)
  int callframe4273 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call4274 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4273);
// compiled member node returning call4274 (depth = 5)
  int op_slot_left_4269 = gc_frame_newslot(call4274);
  params[0] = call4271;
  partcv[0] = 1;
  Object sum4275 = callmethod(call4274, "+(1)", 1, partcv, params);
// compiled op node returning sum4275 (depth = 4)
  gc_frame_newslot(sum4275);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit4266;
  params[1] = call4268;
  params[2] = sum4275;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4276 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4265);
// compiled call node returning call4276 (depth = 3)
    gc_frame_newslot(call4276);
    if4249 = call4276;
  } else {
  }
// compiled if node returning if4249 (depth = 2)
// Begin line 1331
  setline(1331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4277 = gc_frame_new();
// call case 4: self request
  Object call4278 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4277);
// compiled member node returning call4278 (depth = 2)
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array4279 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4279 (depth = 3)
  *var_cases = array4279;
  if (array4279 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1333
  setline(1333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool4280 = alloc_Boolean(0);
// compiled identifier node returning bool4280 (depth = 3)
  *var_elsecase = bool4280;
  if (bool4280 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4281 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4282 = alloc_Block(NULL, NULL, "parser", 1334);
  gc_frame_newslot(block4282);
// method "_apply"
  block_savedest(block4282);
  Object closure4283 = createclosure(2, "_apply");
  setclosureframe(closure4283, stackframe);
  addtoclosure(closure4283, var_sym);
  addtoclosure(closure4283, selfslot);
  struct UserObject *uo4283 = (struct UserObject*)block4282;
  uo4283->data[0] = (Object)closure4283;
  Method *meth_meth_parser__apply4283 = addmethod2pos(block4282, "_apply", &meth_parser__apply4283, 0);
  int argcv_meth_parser__apply4283[] = {0};
  meth_meth_parser__apply4283->type = alloc_MethodType(1, argcv_meth_parser__apply4283);
  meth_meth_parser__apply4283->definitionModule = modulename;
  meth_meth_parser__apply4283->definitionLine = 3399;
// compiled block node returning block4282 (depth = 3)
  gc_frame_newslot(block4282);
// starting to compile block node (depth = 3)
  Object block4297 = alloc_Block(NULL, NULL, "parser", 1334);
  gc_frame_newslot(block4297);
// method "_apply"
  block_savedest(block4297);
  Object closure4298 = createclosure(8, "_apply");
  setclosureframe(closure4298, stackframe);
  addtoclosure(closure4298, var_blocksOK);
  addtoclosure(closure4298, var_errormessages);
  addtoclosure(closure4298, var_sym);
  addtoclosure(closure4298, var_lastToken);
  addtoclosure(closure4298, var_tokens);
  addtoclosure(closure4298, var_values);
  addtoclosure(closure4298, var_cases);
  addtoclosure(closure4298, selfslot);
  struct UserObject *uo4298 = (struct UserObject*)block4297;
  uo4298->data[0] = (Object)closure4298;
  Method *meth_meth_parser__apply4298 = addmethod2pos(block4297, "_apply", &meth_parser__apply4298, 0);
  int argcv_meth_parser__apply4298[] = {0};
  meth_meth_parser__apply4298->type = alloc_MethodType(1, argcv_meth_parser__apply4298);
  meth_meth_parser__apply4298->definitionModule = modulename;
  meth_meth_parser__apply4298->definitionLine = 3399;
// compiled block node returning block4297 (depth = 3)
  gc_frame_newslot(block4297);
// call case 5: prelude request
  params[0] = block4282;
  params[1] = block4297;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4445 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4281);
// compiled call node returning call4445 (depth = 2)
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4446 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe4447 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_matchTok (depth = 4)
  Object call4448 = callmethodflags(*var_matchTok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4447);
// compiled member node returning call4448 (depth = 3)
  gc_frame_newslot(call4448);
// starting to compile member node (depth = 3)
  int callframe4449 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_matchTok (depth = 4)
  Object call4450 = callmethodflags(*var_matchTok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4449);
// compiled member node returning call4450 (depth = 3)
  gc_frame_newslot(call4450);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4448;
  params[1] = call4450;
  partcv[0] = 2;
  Object call4451 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4446);
// compiled call node returning call4451 (depth = 2)
// Begin line 1384
  setline(1384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4452 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4453 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_matchee (depth = 4)
  gc_frame_newslot(*var_matchee);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases (depth = 4)
  gc_frame_newslot(*var_cases);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elsecase (depth = 4)
  gc_frame_newslot(*var_elsecase);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4454 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call4455 = callmethodflags(*var_ast, "matchCaseNode", 0, partcv, params, 0);
  gc_frame_end(callframe4454);
// compiled member node returning call4455 (depth = 4)
  params[0] = *var_matchee;
  params[1] = *var_cases;
  params[2] = *var_elsecase;
  partcv[0] = 3;
  Object call4456 = callmethodflags(call4455, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe4453);
// compiled call node returning call4456 (depth = 3)
  gc_frame_newslot(call4456);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = call4456;
  partcv[0] = 1;
  Object call4457 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4452);
// compiled call node returning call4457 (depth = 2)
// Begin line 1385
  setline(1385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localmin (depth = 3)
  *var_minIndentLevel = *var_localmin;
  if (*var_localmin == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_term4459(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "term");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1390
  setline(1390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4460 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe4461 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call4462 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4461);
// compiled member node returning call4462 (depth = 3)
  gc_frame_newslot(call4462);
// starting to compile member node (depth = 3)
  int callframe4463 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call4464 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4463);
// compiled member node returning call4464 (depth = 3)
  gc_frame_newslot(call4464);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4462;
  params[1] = call4464;
  partcv[0] = 2;
  Object call4465 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4460);
// compiled call node returning call4465 (depth = 2)
// Begin line 1391
  setline(1391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4467 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4468 == NULL) {
    strlit4468 = alloc_String("num");
    gc_root(strlit4468);
  }
// compiled string node returning strlit4468 (depth = 4)
  gc_frame_newslot(strlit4468);
// call case 4: self request
  params[0] = strlit4468;
  partcv[0] = 1;
  Object call4469 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4467);
// compiled call node returning call4469 (depth = 3)
  Object if4466 = done;
  if (istrue(call4469)) {
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4470 = gc_frame_new();
// call case 4: self request
  Object call4471 = callmethodflags(self, "pushnum", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4470);
// compiled member node returning call4471 (depth = 3)
    gc_frame_newslot(call4471);
    if4466 = call4471;
  } else {
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1393
  setline(1393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4473 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4474 == NULL) {
    strlit4474 = alloc_String("string");
    gc_root(strlit4474);
  }
// compiled string node returning strlit4474 (depth = 5)
  gc_frame_newslot(strlit4474);
// call case 4: self request
  params[0] = strlit4474;
  partcv[0] = 1;
  Object call4475 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4473);
// compiled call node returning call4475 (depth = 4)
  Object if4472 = done;
  if (istrue(call4475)) {
// Begin line 1394
  setline(1394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4476 = gc_frame_new();
// call case 4: self request
  Object call4477 = callmethodflags(self, "pushstring", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4476);
// compiled member node returning call4477 (depth = 4)
    gc_frame_newslot(call4477);
    if4472 = call4477;
  } else {
// Begin line 1397
  setline(1397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4481 == NULL) {
    strlit4481 = alloc_String("match");
    gc_root(strlit4481);
  }
// compiled string node returning strlit4481 (depth = 7)
  int op_slot_right_4480 = gc_frame_newslot(strlit4481);
// starting to compile member node (depth = 7)
  int callframe4483 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call4484 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4483);
// compiled member node returning call4484 (depth = 7)
  int op_slot_left_4480 = gc_frame_newslot(call4484);
  params[0] = strlit4481;
  partcv[0] = 1;
  Object opresult4485 = callmethod(call4484, "==(1)", 1, partcv, params);
// compiled op node returning opresult4485 (depth = 6)
  int op_slot_right_4479 = gc_frame_newslot(opresult4485);
// starting to compile call node (depth = 6)
  int callframe4487 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4488 == NULL) {
    strlit4488 = alloc_String("identifier");
    gc_root(strlit4488);
  }
// compiled string node returning strlit4488 (depth = 7)
  gc_frame_newslot(strlit4488);
// call case 4: self request
  params[0] = strlit4488;
  partcv[0] = 1;
  Object call4489 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4487);
// compiled call node returning call4489 (depth = 6)
  int op_slot_left_4479 = gc_frame_newslot(call4489);
  params[0] = opresult4485;
  partcv[0] = 1;
  Object opresult4490 = callmethod(call4489, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4490 (depth = 5)
  Object if4478 = done;
  if (istrue(opresult4490)) {
// Begin line 1396
  setline(1396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4491 = gc_frame_new();
// call case 4: self request
  Object call4492 = callmethodflags(self, "matchcase", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4491);
// compiled member node returning call4492 (depth = 5)
    gc_frame_newslot(call4492);
    if4478 = call4492;
  } else {
// Begin line 1399
  setline(1399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1397
  setline(1397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4496 == NULL) {
    strlit4496 = alloc_String("try");
    gc_root(strlit4496);
  }
// compiled string node returning strlit4496 (depth = 8)
  int op_slot_right_4495 = gc_frame_newslot(strlit4496);
// starting to compile member node (depth = 8)
  int callframe4498 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call4499 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4498);
// compiled member node returning call4499 (depth = 8)
  int op_slot_left_4495 = gc_frame_newslot(call4499);
  params[0] = strlit4496;
  partcv[0] = 1;
  Object opresult4500 = callmethod(call4499, "==(1)", 1, partcv, params);
// compiled op node returning opresult4500 (depth = 7)
  int op_slot_right_4494 = gc_frame_newslot(opresult4500);
// starting to compile call node (depth = 7)
  int callframe4502 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4503 == NULL) {
    strlit4503 = alloc_String("identifier");
    gc_root(strlit4503);
  }
// compiled string node returning strlit4503 (depth = 8)
  gc_frame_newslot(strlit4503);
// call case 4: self request
  params[0] = strlit4503;
  partcv[0] = 1;
  Object call4504 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4502);
// compiled call node returning call4504 (depth = 7)
  int op_slot_left_4494 = gc_frame_newslot(call4504);
  params[0] = opresult4500;
  partcv[0] = 1;
  Object opresult4505 = callmethod(call4504, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4505 (depth = 6)
  Object if4493 = done;
  if (istrue(opresult4505)) {
// Begin line 1398
  setline(1398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4506 = gc_frame_new();
// call case 4: self request
  Object call4507 = callmethodflags(self, "trycatch", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4506);
// compiled member node returning call4507 (depth = 6)
    gc_frame_newslot(call4507);
    if4493 = call4507;
  } else {
// Begin line 1401
  setline(1401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1399
  setline(1399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4509 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4510 == NULL) {
    strlit4510 = alloc_String("identifier");
    gc_root(strlit4510);
  }
// compiled string node returning strlit4510 (depth = 8)
  gc_frame_newslot(strlit4510);
// call case 4: self request
  params[0] = strlit4510;
  partcv[0] = 1;
  Object call4511 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4509);
// compiled call node returning call4511 (depth = 7)
  Object if4508 = done;
  if (istrue(call4511)) {
// Begin line 1400
  setline(1400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4512 = gc_frame_new();
// call case 4: self request
  Object call4513 = callmethodflags(self, "identifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4512);
// compiled member node returning call4513 (depth = 7)
    gc_frame_newslot(call4513);
    if4508 = call4513;
  } else {
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1401
  setline(1401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4515 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4516 == NULL) {
    strlit4516 = alloc_String("object");
    gc_root(strlit4516);
  }
// compiled string node returning strlit4516 (depth = 9)
  gc_frame_newslot(strlit4516);
// call case 4: self request
  params[0] = strlit4516;
  partcv[0] = 1;
  Object call4517 = callmethodflags(self, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4515);
// compiled call node returning call4517 (depth = 8)
  Object if4514 = done;
  if (istrue(call4517)) {
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe4518 = gc_frame_new();
// call case 4: self request
  Object call4519 = callmethodflags(self, "doobject", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4518);
// compiled member node returning call4519 (depth = 8)
    gc_frame_newslot(call4519);
    if4514 = call4519;
  } else {
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe4521 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit4522 == NULL) {
    strlit4522 = alloc_String("type");
    gc_root(strlit4522);
  }
// compiled string node returning strlit4522 (depth = 10)
  gc_frame_newslot(strlit4522);
// call case 4: self request
  params[0] = strlit4522;
  partcv[0] = 1;
  Object call4523 = callmethodflags(self, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4521);
// compiled call node returning call4523 (depth = 9)
  Object if4520 = done;
  if (istrue(call4523)) {
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe4524 = gc_frame_new();
// call case 4: self request
  Object call4525 = callmethodflags(self, "dotypeLiteral", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4524);
// compiled member node returning call4525 (depth = 9)
    gc_frame_newslot(call4525);
    if4520 = call4525;
  } else {
// Begin line 1407
  setline(1407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe4527 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit4528 == NULL) {
    strlit4528 = alloc_String("lbrace");
    gc_root(strlit4528);
  }
// compiled string node returning strlit4528 (depth = 11)
  gc_frame_newslot(strlit4528);
// call case 4: self request
  params[0] = strlit4528;
  partcv[0] = 1;
  Object call4529 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4527);
// compiled call node returning call4529 (depth = 10)
  Object if4526 = done;
  if (istrue(call4529)) {
// Begin line 1406
  setline(1406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe4530 = gc_frame_new();
// call case 4: self request
  Object call4531 = callmethodflags(self, "block", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4530);
// compiled member node returning call4531 (depth = 10)
    gc_frame_newslot(call4531);
    if4526 = call4531;
  } else {
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 1407
  setline(1407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe4533 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit4534 == NULL) {
    strlit4534 = alloc_String("lsquare");
    gc_root(strlit4534);
  }
// compiled string node returning strlit4534 (depth = 12)
  gc_frame_newslot(strlit4534);
// call case 4: self request
  params[0] = strlit4534;
  partcv[0] = 1;
  Object call4535 = callmethodflags(self, "acceptAfterSpaces(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4533);
// compiled call node returning call4535 (depth = 11)
  Object if4532 = done;
  if (istrue(call4535)) {
// Begin line 1408
  setline(1408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
  int callframe4536 = gc_frame_new();
// call case 4: self request
  Object call4537 = callmethodflags(self, "doarray", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4536);
// compiled member node returning call4537 (depth = 11)
    gc_frame_newslot(call4537);
    if4532 = call4537;
  } else {
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe4540 = gc_frame_new();
// starting to compile string node (depth = 14)
  if (strlit4541 == NULL) {
    strlit4541 = alloc_String("lsquare");
    gc_root(strlit4541);
  }
// compiled string node returning strlit4541 (depth = 14)
  gc_frame_newslot(strlit4541);
// call case 4: self request
  params[0] = strlit4541;
  partcv[0] = 1;
  Object call4542 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4540);
// compiled call node returning call4542 (depth = 13)
  int op_slot_right_4539 = gc_frame_newslot(call4542);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit4545 == NULL) {
    strlit4545 = alloc_String("identifier");
    gc_root(strlit4545);
  }
// compiled string node returning strlit4545 (depth = 14)
  int op_slot_right_4544 = gc_frame_newslot(strlit4545);
// starting to compile member node (depth = 14)
  int callframe4547 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_lastToken (depth = 15)
  Object call4548 = callmethodflags(*var_lastToken, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe4547);
// compiled member node returning call4548 (depth = 14)
  int op_slot_left_4544 = gc_frame_newslot(call4548);
  params[0] = strlit4545;
  partcv[0] = 1;
  Object opresult4549 = callmethod(call4548, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4549 (depth = 13)
  int op_slot_left_4539 = gc_frame_newslot(opresult4549);
  params[0] = call4542;
  partcv[0] = 1;
  Object opresult4550 = callmethod(opresult4549, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4550 (depth = 12)
  Object if4538 = done;
  if (istrue(opresult4550)) {
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
  int callframe4551 = gc_frame_new();
// call case 4: self request
  Object call4552 = callmethodflags(self, "doarray", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4551);
// compiled member node returning call4552 (depth = 12)
    gc_frame_newslot(call4552);
    if4538 = call4552;
  } else {
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe4554 = gc_frame_new();
// starting to compile string node (depth = 14)
  if (strlit4555 == NULL) {
    strlit4555 = alloc_String("op");
    gc_root(strlit4555);
  }
// compiled string node returning strlit4555 (depth = 14)
  gc_frame_newslot(strlit4555);
// call case 4: self request
  params[0] = strlit4555;
  partcv[0] = 1;
  Object call4556 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4554);
// compiled call node returning call4556 (depth = 13)
  Object if4553 = done;
  if (istrue(call4556)) {
// Begin line 1413
  setline(1413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
  int callframe4557 = gc_frame_new();
// call case 4: self request
  Object call4558 = callmethodflags(self, "prefixop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4557);
// compiled member node returning call4558 (depth = 13)
    gc_frame_newslot(call4558);
    if4553 = call4558;
  } else {
  }
// compiled if node returning if4553 (depth = 12)
    gc_frame_newslot(if4553);
    if4538 = if4553;
  }
// compiled if node returning if4538 (depth = 11)
    gc_frame_newslot(if4538);
    if4532 = if4538;
  }
// compiled if node returning if4532 (depth = 10)
    gc_frame_newslot(if4532);
    if4526 = if4532;
  }
// compiled if node returning if4526 (depth = 9)
    gc_frame_newslot(if4526);
    if4520 = if4526;
  }
// compiled if node returning if4520 (depth = 8)
    gc_frame_newslot(if4520);
    if4514 = if4520;
  }
// compiled if node returning if4514 (depth = 7)
    gc_frame_newslot(if4514);
    if4508 = if4514;
  }
// compiled if node returning if4508 (depth = 6)
    gc_frame_newslot(if4508);
    if4493 = if4508;
  }
// compiled if node returning if4493 (depth = 5)
    gc_frame_newslot(if4493);
    if4478 = if4493;
  }
// compiled if node returning if4478 (depth = 4)
    gc_frame_newslot(if4478);
    if4472 = if4478;
  }
// compiled if node returning if4472 (depth = 3)
    gc_frame_newslot(if4472);
    if4466 = if4472;
  }
// compiled if node returning if4466 (depth = 2)
  gc_frame_end(frame);
  return if4466;
}
Object meth_parser__apply4585(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_acceptBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe4586 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_acceptBlocks (depth = 8)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4587 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4586);
// compiled call node returning call4587 (depth = 7)
  gc_frame_end(frame);
  return call4587;
}
Object meth_parser_expression_40_1_41_4559(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expression(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expression(_)");
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_statementToken = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for expression(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part expression(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sz");
  Object *var_tmpStatementToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "tmpStatementToken");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4560 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  Object call4561 = callmethodflags(*var_values, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4560);
// compiled member node returning call4561 (depth = 3)
  *var_sz = call4561;
  if (call4561 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4562 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe4563 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call4564 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4563);
// compiled member node returning call4564 (depth = 3)
  gc_frame_newslot(call4564);
// starting to compile member node (depth = 3)
  int callframe4565 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call4566 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4565);
// compiled member node returning call4566 (depth = 3)
  gc_frame_newslot(call4566);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4564;
  params[1] = call4566;
  partcv[0] = 2;
  Object call4567 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4562);
// compiled call node returning call4567 (depth = 2)
// Begin line 1424
  setline(1424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4569 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4570 == NULL) {
    strlit4570 = alloc_String("lparen");
    gc_root(strlit4570);
  }
// compiled string node returning strlit4570 (depth = 4)
  gc_frame_newslot(strlit4570);
// call case 4: self request
  params[0] = strlit4570;
  partcv[0] = 1;
  Object call4571 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4569);
// compiled call node returning call4571 (depth = 3)
  Object if4568 = done;
  if (istrue(call4571)) {
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementToken (depth = 4)
  *var_tmpStatementToken = *var_statementToken;
  if (*var_statementToken == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4573 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4574 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call4575 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4574);
// compiled member node returning call4575 (depth = 4)
  gc_frame_newslot(call4575);
// starting to compile member node (depth = 4)
  int callframe4576 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call4577 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4576);
// compiled member node returning call4577 (depth = 4)
  gc_frame_newslot(call4577);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call4575;
  params[1] = call4577;
  partcv[0] = 2;
  Object call4578 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4573);
// compiled call node returning call4578 (depth = 3)
// Begin line 1428
  setline(1428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4579 = gc_frame_new();
// call case 4: self request
  Object call4580 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4579);
// compiled member node returning call4580 (depth = 3)
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4582 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe4583 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block4584 = alloc_Block(NULL, NULL, "parser", 1429);
  gc_frame_newslot(block4584);
// method "_apply"
  block_savedest(block4584);
  Object closure4585 = createclosure(2, "_apply");
  setclosureframe(closure4585, stackframe);
  addtoclosure(closure4585, var_acceptBlocks);
  addtoclosure(closure4585, selfslot);
  struct UserObject *uo4585 = (struct UserObject*)block4584;
  uo4585->data[0] = (Object)closure4585;
  Method *meth_meth_parser__apply4585 = addmethod2pos(block4584, "_apply", &meth_parser__apply4585, 0);
  int argcv_meth_parser__apply4585[] = {0};
  meth_meth_parser__apply4585->type = alloc_MethodType(1, argcv_meth_parser__apply4585);
  meth_meth_parser__apply4585->definitionModule = modulename;
  meth_meth_parser__apply4585->definitionLine = 3399;
// compiled block node returning block4584 (depth = 6)
  gc_frame_newslot(block4584);
// call case 4: self request
  params[0] = block4584;
  partcv[0] = 1;
  Object call4589 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4583);
// compiled call node returning call4589 (depth = 5)
  Object call4590 = callmethodflags(call4589, "not", 0, partcv, params, 0);
  gc_frame_end(callframe4582);
// compiled member node returning call4590 (depth = 4)
  Object if4581 = done;
  if (istrue(call4590)) {
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4591 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4592 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call4593 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4592);
// compiled member node returning call4593 (depth = 6)
  Object call4594 = callmethodflags(call4593, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4591);
// compiled member node returning call4594 (depth = 5)
  *var_suggestion = call4594;
  if (call4594 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1431
  setline(1431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4595 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array4596 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit4597 == NULL) {
    strlit4597 = alloc_String("rparen");
    gc_root(strlit4597);
  }
// compiled string node returning strlit4597 (depth = 7)
  params[0] = strlit4597;
  partcv[0] = 1;
  callmethodflags(array4596, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array4596 (depth = 6)
  gc_frame_newslot(array4596);
// call case 4: self request
  params[0] = array4596;
  partcv[0] = 1;
  Object call4598 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4595);
// compiled call node returning call4598 (depth = 5)
  *var_nextTok = call4598;
  if (call4598 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1432
  setline(1432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_4600 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_4600 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4602 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult4602 (depth = 5)
  Object if4599 = done;
  if (istrue(opresult4602)) {
// Begin line 1433
  setline(1433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4603 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4604 == NULL) {
    strlit4604 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4604);
  }
// compiled string node returning strlit4604 (depth = 6)
  gc_frame_newslot(strlit4604);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4604;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4605 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4603);
// compiled call node returning call4605 (depth = 5)
    gc_frame_newslot(call4605);
    if4599 = call4605;
  } else {
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4606 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe4607 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  Object call4608 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4607);
// compiled member node returning call4608 (depth = 6)
  gc_frame_newslot(call4608);
// Begin line 1436
  setline(1436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool4609 = alloc_Boolean(1);
// compiled identifier node returning bool4609 (depth = 6)
  gc_frame_newslot(bool4609);
// starting to compile identifier node (depth = 6)
  Object bool4610 = alloc_Boolean(0);
// compiled identifier node returning bool4610 (depth = 6)
  gc_frame_newslot(bool4610);
// starting to compile string node (depth = 6)
  if (strlit4611 == NULL) {
    strlit4611 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4611);
  }
// compiled string node returning strlit4611 (depth = 6)
  gc_frame_newslot(strlit4611);
// call case 6: other requests
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call4608;
  params[2] = bool4609;
  params[3] = bool4610;
  params[4] = strlit4611;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4612 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe4606);
// compiled call node returning call4612 (depth = 5)
    gc_frame_newslot(call4612);
    if4599 = call4612;
  }
// compiled if node returning if4599 (depth = 4)
// Begin line 1438
  setline(1438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4613 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4614 == NULL) {
    strlit4614 = alloc_String("parentheses must contain a valid expression.");
    gc_root(strlit4614);
  }
// compiled string node returning strlit4614 (depth = 5)
  gc_frame_newslot(strlit4614);
// Begin line 1439
  setline(1439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4615 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call4616 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4615);
// compiled member node returning call4616 (depth = 5)
  gc_frame_newslot(call4616);
// starting to compile member node (depth = 5)
  int callframe4617 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call4618 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4617);
// compiled member node returning call4618 (depth = 5)
  gc_frame_newslot(call4618);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1438
  setline(1438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4614;
  params[1] = call4616;
  params[2] = call4618;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4619 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4613);
// compiled call node returning call4619 (depth = 4)
    gc_frame_newslot(call4619);
    if4581 = call4619;
  } else {
  }
// compiled if node returning if4581 (depth = 3)
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4622 == NULL) {
    strlit4622 = alloc_String("rparen");
    gc_root(strlit4622);
  }
// compiled string node returning strlit4622 (depth = 5)
  int op_slot_right_4621 = gc_frame_newslot(strlit4622);
// starting to compile member node (depth = 5)
  int callframe4624 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call4625 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe4624);
// compiled member node returning call4625 (depth = 5)
  int op_slot_left_4621 = gc_frame_newslot(call4625);
  params[0] = strlit4622;
  partcv[0] = 1;
  Object opresult4626 = callmethod(call4625, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4626 (depth = 4)
  Object if4620 = done;
  if (istrue(opresult4626)) {
// Begin line 1442
  setline(1442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4627 = gc_frame_new();
// call case 4: self request
  Object call4628 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4627);
// compiled member node returning call4628 (depth = 4)
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4629 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4630 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call4631 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4630);
// compiled member node returning call4631 (depth = 6)
  Object call4632 = callmethodflags(call4631, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4629);
// compiled member node returning call4632 (depth = 5)
  *var_suggestion = call4632;
  if (call4632 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1444
  setline(1444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4633 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4634 == NULL) {
    strlit4634 = alloc_String(")");
    gc_root(strlit4634);
  }
// compiled string node returning strlit4634 (depth = 5)
  gc_frame_newslot(strlit4634);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4634;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4635 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4633);
// compiled call node returning call4635 (depth = 4)
// Begin line 1445
  setline(1445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4636 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4637 == NULL) {
    strlit4637 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4637);
  }
// compiled string node returning strlit4637 (depth = 5)
  gc_frame_newslot(strlit4637);
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4638 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call4639 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4638);
// compiled member node returning call4639 (depth = 5)
  gc_frame_newslot(call4639);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4641 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call4642 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4641);
// compiled member node returning call4642 (depth = 6)
  int op_slot_right_4640 = gc_frame_newslot(call4642);
// starting to compile member node (depth = 6)
  int callframe4644 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call4645 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4644);
// compiled member node returning call4645 (depth = 6)
  int op_slot_left_4640 = gc_frame_newslot(call4645);
  params[0] = call4642;
  partcv[0] = 1;
  Object sum4646 = callmethod(call4645, "+(1)", 1, partcv, params);
// compiled op node returning sum4646 (depth = 5)
  gc_frame_newslot(sum4646);
// Begin line 1447
  setline(1447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1445
  setline(1445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4637;
  params[1] = call4639;
  params[2] = sum4646;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4647 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4636);
// compiled call node returning call4647 (depth = 4)
    gc_frame_newslot(call4647);
    if4620 = call4647;
  } else {
  }
// compiled if node returning if4620 (depth = 3)
// Begin line 1449
  setline(1449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tmpStatementToken (depth = 4)
  *var_statementToken = *var_tmpStatementToken;
  if (*var_tmpStatementToken == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1450
  setline(1450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4649 = gc_frame_new();
// call case 4: self request
  Object call4650 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4649);
// compiled member node returning call4650 (depth = 3)
    gc_frame_newslot(call4650);
    if4568 = call4650;
  } else {
// Begin line 1452
  setline(1452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4651 = gc_frame_new();
// call case 4: self request
  Object call4652 = callmethodflags(self, "term", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4651);
// compiled member node returning call4652 (depth = 3)
    gc_frame_newslot(call4652);
    if4568 = call4652;
  }
// compiled if node returning if4568 (depth = 2)
// Begin line 1454
  setline(1454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_4654 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
  int callframe4656 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call4657 = callmethodflags(*var_values, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4656);
// compiled member node returning call4657 (depth = 4)
  int op_slot_left_4654 = gc_frame_newslot(call4657);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult4658 = callmethod(call4657, ">(1)", 1, partcv, params);
// compiled op node returning opresult4658 (depth = 3)
  Object if4653 = done;
  if (istrue(opresult4658)) {
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4659 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_acceptBlocks (depth = 4)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4660 = callmethodflags(self, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4659);
// compiled call node returning call4660 (depth = 3)
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4661 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_acceptBlocks (depth = 4)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4662 = callmethodflags(self, "callrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4661);
// compiled call node returning call4662 (depth = 3)
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4663 = gc_frame_new();
// call case 4: self request
  Object call4664 = callmethodflags(self, "postfixsquare", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4663);
// compiled member node returning call4664 (depth = 3)
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4665 = gc_frame_new();
// call case 4: self request
  Object call4666 = callmethodflags(self, "valueexpressionrest", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4665);
// compiled member node returning call4666 (depth = 3)
    gc_frame_newslot(call4666);
    if4653 = call4666;
  } else {
  }
// compiled if node returning if4653 (depth = 2)
  gc_frame_end(frame);
  return if4653;
}
Object meth_parser__apply4680(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe4681 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_blocksOK (depth = 8)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4682 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4681);
// compiled call node returning call4682 (depth = 7)
  gc_frame_end(frame);
  return call4682;
}
Object meth_parser_postfixsquare4667(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "postfixsquare");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_opening = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "opening");
  Object *var_expr = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "expr");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// Begin line 1465
  setline(1465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4669 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4670 == NULL) {
    strlit4670 = alloc_String("lsquare");
    gc_root(strlit4670);
  }
// compiled string node returning strlit4670 (depth = 4)
  gc_frame_newslot(strlit4670);
// call case 4: self request
  params[0] = strlit4670;
  partcv[0] = 1;
  Object call4671 = callmethodflags(self, "acceptWithoutSpaces(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4669);
// compiled call node returning call4671 (depth = 3)
  Object if4668 = done;
  if (istrue(call4671)) {
// Begin line 1466
  setline(1466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_opening = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1467
  setline(1467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4672 = gc_frame_new();
// call case 4: self request
  Object call4673 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4672);
// compiled member node returning call4673 (depth = 3)
// Begin line 1468
  setline(1468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4674 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call4675 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe4674);
// compiled member node returning call4675 (depth = 4)
  *var_expr = call4675;
  if (call4675 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1469
  setline(1469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4677 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe4678 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block4679 = alloc_Block(NULL, NULL, "parser", 1469);
  gc_frame_newslot(block4679);
// method "_apply"
  block_savedest(block4679);
  Object closure4680 = createclosure(2, "_apply");
  setclosureframe(closure4680, stackframe);
  addtoclosure(closure4680, var_blocksOK);
  addtoclosure(closure4680, selfslot);
  struct UserObject *uo4680 = (struct UserObject*)block4679;
  uo4680->data[0] = (Object)closure4680;
  Method *meth_meth_parser__apply4680 = addmethod2pos(block4679, "_apply", &meth_parser__apply4680, 0);
  int argcv_meth_parser__apply4680[] = {0};
  meth_meth_parser__apply4680->type = alloc_MethodType(1, argcv_meth_parser__apply4680);
  meth_meth_parser__apply4680->definitionModule = modulename;
  meth_meth_parser__apply4680->definitionLine = 3399;
// compiled block node returning block4679 (depth = 6)
  gc_frame_newslot(block4679);
// call case 4: self request
  params[0] = block4679;
  partcv[0] = 1;
  Object call4684 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4678);
// compiled call node returning call4684 (depth = 5)
  Object call4685 = callmethodflags(call4684, "not", 0, partcv, params, 0);
  gc_frame_end(callframe4677);
// compiled member node returning call4685 (depth = 4)
  Object if4676 = done;
  if (istrue(call4685)) {
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array4686 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4686 (depth = 5)
  *var_suggestions = array4686;
  if (array4686 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1471
  setline(1471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4687 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4688 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call4689 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4688);
// compiled member node returning call4689 (depth = 6)
  Object call4690 = callmethodflags(call4689, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4687);
// compiled member node returning call4690 (depth = 5)
  *var_suggestion = call4690;
  if (call4690 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1472
  setline(1472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4691 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array4692 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit4693 == NULL) {
    strlit4693 = alloc_String("rsquare");
    gc_root(strlit4693);
  }
// compiled string node returning strlit4693 (depth = 7)
  params[0] = strlit4693;
  partcv[0] = 1;
  callmethodflags(array4692, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array4692 (depth = 6)
  gc_frame_newslot(array4692);
// call case 4: self request
  params[0] = array4692;
  partcv[0] = 1;
  Object call4694 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4691);
// compiled call node returning call4694 (depth = 5)
  *var_nextTok = call4694;
  if (call4694 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_4696 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_4696 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4698 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult4698 (depth = 5)
  Object if4695 = done;
  if (istrue(opresult4698)) {
// Begin line 1474
  setline(1474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4699 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4700 == NULL) {
    strlit4700 = alloc_String("""\xc2""""\xab""index""\xc2""""\xbb""");
    gc_root(strlit4700);
  }
// compiled string node returning strlit4700 (depth = 6)
  gc_frame_newslot(strlit4700);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4700;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4701 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4699);
// compiled call node returning call4701 (depth = 5)
    gc_frame_newslot(call4701);
    if4695 = call4701;
  } else {
// Begin line 1476
  setline(1476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4702 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe4703 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  Object call4704 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4703);
// compiled member node returning call4704 (depth = 6)
  gc_frame_newslot(call4704);
// starting to compile identifier node (depth = 6)
  Object bool4705 = alloc_Boolean(1);
// compiled identifier node returning bool4705 (depth = 6)
  gc_frame_newslot(bool4705);
// starting to compile identifier node (depth = 6)
  Object bool4706 = alloc_Boolean(0);
// compiled identifier node returning bool4706 (depth = 6)
  gc_frame_newslot(bool4706);
// starting to compile string node (depth = 6)
  if (strlit4707 == NULL) {
    strlit4707 = alloc_String("""\xc2""""\xab""index""\xc2""""\xbb""");
    gc_root(strlit4707);
  }
// compiled string node returning strlit4707 (depth = 6)
  gc_frame_newslot(strlit4707);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call4704;
  params[2] = bool4705;
  params[3] = bool4706;
  params[4] = strlit4707;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4708 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe4702);
// compiled call node returning call4708 (depth = 5)
    gc_frame_newslot(call4708);
    if4695 = call4708;
  }
// compiled if node returning if4695 (depth = 4)
// Begin line 1478
  setline(1478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4709 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4710 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4709);
// compiled call node returning call4710 (depth = 4)
// Begin line 1479
  setline(1479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4713 == NULL) {
    strlit4713 = alloc_String("rsquare");
    gc_root(strlit4713);
  }
// compiled string node returning strlit4713 (depth = 6)
  int op_slot_right_4712 = gc_frame_newslot(strlit4713);
// starting to compile member node (depth = 6)
  int callframe4715 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  Object call4716 = callmethodflags(*var_nextTok, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe4715);
// compiled member node returning call4716 (depth = 6)
  int op_slot_left_4712 = gc_frame_newslot(call4716);
  params[0] = strlit4713;
  partcv[0] = 1;
  Object opresult4717 = callmethod(call4716, "==(1)", 1, partcv, params);
// compiled op node returning opresult4717 (depth = 5)
  Object if4711 = done;
  if (istrue(opresult4717)) {
// Begin line 1480
  setline(1480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4718 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4719 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call4720 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4719);
// compiled member node returning call4720 (depth = 7)
  Object call4721 = callmethodflags(call4720, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4718);
// compiled member node returning call4721 (depth = 6)
  *var_suggestion = call4721;
  if (call4721 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1481
  setline(1481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4723 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 6)
  Object bool4724 = alloc_Boolean(1);
// compiled identifier node returning bool4724 (depth = 6)
  gc_frame_newslot(bool4724);
// starting to compile identifier node (depth = 6)
  Object bool4725 = alloc_Boolean(0);
// compiled identifier node returning bool4725 (depth = 6)
  gc_frame_newslot(bool4725);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = *var_nextTok;
  params[2] = bool4724;
  params[3] = bool4725;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4726 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4723);
// compiled call node returning call4726 (depth = 5)
// Begin line 1482
  setline(1482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4727 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4728 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4727);
// compiled call node returning call4728 (depth = 5)
    gc_frame_newslot(call4728);
    if4711 = call4728;
  } else {
  }
// compiled if node returning if4711 (depth = 4)
// Begin line 1484
  setline(1484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4729 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4730 == NULL) {
    strlit4730 = alloc_String("a '[' in an expression must be followed by another expression and a ']'.");
    gc_root(strlit4730);
  }
// compiled string node returning strlit4730 (depth = 5)
  gc_frame_newslot(strlit4730);
// Begin line 1485
  setline(1485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4731 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call4732 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4731);
// compiled member node returning call4732 (depth = 5)
  gc_frame_newslot(call4732);
// starting to compile member node (depth = 5)
  int callframe4733 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call4734 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4733);
// compiled member node returning call4734 (depth = 5)
  gc_frame_newslot(call4734);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1484
  setline(1484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4730;
  params[1] = call4732;
  params[2] = call4734;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4735 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4729);
// compiled call node returning call4735 (depth = 4)
    gc_frame_newslot(call4735);
    if4676 = call4735;
  } else {
  }
// compiled if node returning if4676 (depth = 3)
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4738 == NULL) {
    strlit4738 = alloc_String("rsquare");
    gc_root(strlit4738);
  }
// compiled string node returning strlit4738 (depth = 5)
  int op_slot_right_4737 = gc_frame_newslot(strlit4738);
// starting to compile member node (depth = 5)
  int callframe4740 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call4741 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe4740);
// compiled member node returning call4741 (depth = 5)
  int op_slot_left_4737 = gc_frame_newslot(call4741);
  params[0] = strlit4738;
  partcv[0] = 1;
  Object opresult4742 = callmethod(call4741, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4742 (depth = 4)
  Object if4736 = done;
  if (istrue(opresult4742)) {
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4743 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4744 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call4745 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4744);
// compiled member node returning call4745 (depth = 6)
  Object call4746 = callmethodflags(call4745, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4743);
// compiled member node returning call4746 (depth = 5)
  *var_suggestion = call4746;
  if (call4746 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1489
  setline(1489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4747 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4748 == NULL) {
    strlit4748 = alloc_String("]");
    gc_root(strlit4748);
  }
// compiled string node returning strlit4748 (depth = 5)
  gc_frame_newslot(strlit4748);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4748;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4749 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4747);
// compiled call node returning call4749 (depth = 4)
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4750 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4751 == NULL) {
    strlit4751 = alloc_String("a '[' in an expression must be followed by another expression and a ']'.");
    gc_root(strlit4751);
  }
// compiled string node returning strlit4751 (depth = 5)
  gc_frame_newslot(strlit4751);
// Begin line 1491
  setline(1491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4752 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call4753 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4752);
// compiled member node returning call4753 (depth = 5)
  gc_frame_newslot(call4753);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4755 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call4756 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4755);
// compiled member node returning call4756 (depth = 6)
  int op_slot_right_4754 = gc_frame_newslot(call4756);
// starting to compile member node (depth = 6)
  int callframe4758 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call4759 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4758);
// compiled member node returning call4759 (depth = 6)
  int op_slot_left_4754 = gc_frame_newslot(call4759);
  params[0] = call4756;
  partcv[0] = 1;
  Object sum4760 = callmethod(call4759, "+(1)", 1, partcv, params);
// compiled op node returning sum4760 (depth = 5)
  gc_frame_newslot(sum4760);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4751;
  params[1] = call4753;
  params[2] = sum4760;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4761 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4750);
// compiled call node returning call4761 (depth = 4)
    gc_frame_newslot(call4761);
    if4736 = call4761;
  } else {
  }
// compiled if node returning if4736 (depth = 3)
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4762 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1494
  setline(1494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit4764 == NULL) {
    strlit4764 = alloc_String("For a Lineup, add a space.  For an indexing operation, use `at(_)` or `at(_)put(_)`.");
    gc_root(strlit4764);
  }
// compiled string node returning strlit4764 (depth = 5)
  int op_slot_right_4763 = gc_frame_newslot(strlit4764);
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit4766 == NULL) {
    strlit4766 = alloc_String("'[ ... ]' without preceeding space is no longer part of Grace. ");
    gc_root(strlit4766);
  }
// compiled string node returning strlit4766 (depth = 5)
  int op_slot_left_4763 = gc_frame_newslot(strlit4766);
  params[0] = strlit4764;
  partcv[0] = 1;
  Object opresult4767 = callmethod(strlit4766, "++(1)", 1, partcv, params);
// compiled op node returning opresult4767 (depth = 4)
  gc_frame_newslot(opresult4767);
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4768 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_opening (depth = 5)
  Object call4769 = callmethodflags(*var_opening, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4768);
// compiled member node returning call4769 (depth = 4)
  gc_frame_newslot(call4769);
// starting to compile member node (depth = 4)
  int callframe4770 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_opening (depth = 5)
  Object call4771 = callmethodflags(*var_opening, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4770);
// compiled member node returning call4771 (depth = 4)
  gc_frame_newslot(call4771);
// call case 6: other requests
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult4767;
  params[1] = call4769;
  params[2] = call4771;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call4772 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe4762);
// compiled call node returning call4772 (depth = 3)
    gc_frame_newslot(call4772);
    if4668 = call4772;
  } else {
  }
// compiled if node returning if4668 (depth = 2)
  gc_frame_end(frame);
  return if4668;
}
Object meth_parser_oprec_40_1_41_4773(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "oprec(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method oprec(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for oprec(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part oprec(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1503
  setline(1503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4776 == NULL) {
    strlit4776 = alloc_String("*");
    gc_root(strlit4776);
  }
// compiled string node returning strlit4776 (depth = 4)
  int op_slot_right_4775 = gc_frame_newslot(strlit4776);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  int op_slot_left_4775 = gc_frame_newslot(*var_o);
  params[0] = strlit4776;
  partcv[0] = 1;
  Object opresult4778 = callmethod(*var_o, "==(1)", 1, partcv, params);
// compiled op node returning opresult4778 (depth = 3)
  Object if4774 = done;
  if (istrue(opresult4778)) {
// Begin line 1504
  setline(1504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4779 = alloc_Float64(10);
// compiled num node returning num4779 (depth = 4)
  return num4779;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if4774 = undefined;
  } else {
// Begin line 1508
  setline(1508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1505
  setline(1505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4782 == NULL) {
    strlit4782 = alloc_String("/");
    gc_root(strlit4782);
  }
// compiled string node returning strlit4782 (depth = 5)
  int op_slot_right_4781 = gc_frame_newslot(strlit4782);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  int op_slot_left_4781 = gc_frame_newslot(*var_o);
  params[0] = strlit4782;
  partcv[0] = 1;
  Object opresult4784 = callmethod(*var_o, "==(1)", 1, partcv, params);
// compiled op node returning opresult4784 (depth = 4)
  Object if4780 = done;
  if (istrue(opresult4784)) {
// Begin line 1506
  setline(1506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4785 = alloc_Float64(10);
// compiled num node returning num4785 (depth = 5)
  return num4785;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4780 = undefined;
  } else {
  }
// compiled if node returning if4780 (depth = 3)
    gc_frame_newslot(if4780);
    if4774 = if4780;
  }
// compiled if node returning if4774 (depth = 2)
// Begin line 1508
  setline(1508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile num node (depth = 3)
  Object num4786 = alloc_Float64(5);
// compiled num node returning num4786 (depth = 3)
  return num4786;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_toprec_40_1_41_4787(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toprec(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toprec(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toprec(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ops = &(stackframe->slots[0]);
  *var_ops = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toprec(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "o");
// Begin line 1513
  setline(1513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4790 = alloc_Float64(0);
// compiled num node returning num4790 (depth = 4)
  int op_slot_right_4789 = gc_frame_newslot(num4790);
// starting to compile member node (depth = 4)
  int callframe4792 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ops (depth = 5)
  Object call4793 = callmethodflags(*var_ops, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4792);
// compiled member node returning call4793 (depth = 4)
  int op_slot_left_4789 = gc_frame_newslot(call4793);
  params[0] = num4790;
  partcv[0] = 1;
  Object opresult4794 = callmethod(call4793, ">(1)", 1, partcv, params);
// compiled op node returning opresult4794 (depth = 3)
  Object if4788 = done;
  if (istrue(opresult4794)) {
// Begin line 1514
  setline(1514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4795 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ops (depth = 5)
  Object call4796 = callmethodflags(*var_ops, "last", 0, partcv, params, 0);
  gc_frame_end(callframe4795);
// compiled member node returning call4796 (depth = 4)
  *var_o = call4796;
  if (call4796 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4797 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call4798 = callmethodflags(self, "oprec(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4797);
// compiled call node returning call4798 (depth = 4)
  return call4798;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if4788 = undefined;
  } else {
  }
// compiled if node returning if4788 (depth = 2)
// Begin line 1517
  setline(1517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4799 = alloc_Float64(0);
// compiled num node returning num4799 (depth = 2)
  gc_frame_end(frame);
  return num4799;
}
Object meth_parser__apply4808(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
  int callframe4809 = gc_frame_new();
// call case 4: self request
  Object call4810 = callmethodflags(self, "typeexpression", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4809);
// compiled member node returning call4810 (depth = 5)
  gc_frame_end(frame);
  return call4810;
}
Object meth_parser_typeexpressionrest4800(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeexpressionrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_noBlocks = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1522
  setline(1522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4802 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4803 == NULL) {
    strlit4803 = alloc_String("op");
    gc_root(strlit4803);
  }
// compiled string node returning strlit4803 (depth = 4)
  gc_frame_newslot(strlit4803);
// call case 4: self request
  params[0] = strlit4803;
  partcv[0] = 1;
  Object call4804 = callmethodflags(self, "acceptSameLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4802);
// compiled call node returning call4804 (depth = 3)
  Object if4801 = done;
  if (istrue(call4804)) {
// Begin line 1523
  setline(1523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4805 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4806 == NULL) {
    strlit4806 = alloc_String("type expression");
    gc_root(strlit4806);
  }
// compiled string node returning strlit4806 (depth = 4)
  gc_frame_newslot(strlit4806);
// starting to compile block node (depth = 4)
  Object block4807 = alloc_Block(NULL, NULL, "parser", 1523);
  gc_frame_newslot(block4807);
// method "_apply"
  block_savedest(block4807);
  Object closure4808 = createclosure(1, "_apply");
  setclosureframe(closure4808, stackframe);
  addtoclosure(closure4808, selfslot);
  struct UserObject *uo4808 = (struct UserObject*)block4807;
  uo4808->data[0] = (Object)closure4808;
  Method *meth_meth_parser__apply4808 = addmethod2pos(block4807, "_apply", &meth_parser__apply4808, 0);
  int argcv_meth_parser__apply4808[] = {0};
  meth_meth_parser__apply4808->type = alloc_MethodType(1, argcv_meth_parser__apply4808);
  meth_meth_parser__apply4808->definitionModule = modulename;
  meth_meth_parser__apply4808->definitionLine = 3399;
// compiled block node returning block4807 (depth = 4)
  gc_frame_newslot(block4807);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = strlit4806;
  params[1] = block4807;
  params[2] = *var_noBlocks;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4812 = callmethodflags(self, "expressionrest(1)recursingWith(1)blocks(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4805);
// compiled call node returning call4812 (depth = 3)
    gc_frame_newslot(call4812);
    if4801 = call4812;
  } else {
  }
// compiled if node returning if4801 (depth = 2)
  gc_frame_end(frame);
  return if4801;
}
Object meth_parser__apply4821(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe4822 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4823 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4822);
// compiled call node returning call4823 (depth = 5)
  gc_frame_end(frame);
  return call4823;
}
Object meth_parser_valueexpressionrest4813(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "valueexpressionrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1528
  setline(1528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4815 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4816 == NULL) {
    strlit4816 = alloc_String("op");
    gc_root(strlit4816);
  }
// compiled string node returning strlit4816 (depth = 4)
  gc_frame_newslot(strlit4816);
// call case 4: self request
  params[0] = strlit4816;
  partcv[0] = 1;
  Object call4817 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4815);
// compiled call node returning call4817 (depth = 3)
  Object if4814 = done;
  if (istrue(call4817)) {
// Begin line 1529
  setline(1529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4818 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4819 == NULL) {
    strlit4819 = alloc_String("expression");
    gc_root(strlit4819);
  }
// compiled string node returning strlit4819 (depth = 4)
  gc_frame_newslot(strlit4819);
// starting to compile block node (depth = 4)
  Object block4820 = alloc_Block(NULL, NULL, "parser", 1529);
  gc_frame_newslot(block4820);
// method "_apply"
  block_savedest(block4820);
  Object closure4821 = createclosure(2, "_apply");
  setclosureframe(closure4821, stackframe);
  addtoclosure(closure4821, var_blocksOK);
  addtoclosure(closure4821, selfslot);
  struct UserObject *uo4821 = (struct UserObject*)block4820;
  uo4821->data[0] = (Object)closure4821;
  Method *meth_meth_parser__apply4821 = addmethod2pos(block4820, "_apply", &meth_parser__apply4821, 0);
  int argcv_meth_parser__apply4821[] = {0};
  meth_meth_parser__apply4821->type = alloc_MethodType(1, argcv_meth_parser__apply4821);
  meth_meth_parser__apply4821->definitionModule = modulename;
  meth_meth_parser__apply4821->definitionLine = 3399;
// compiled block node returning block4820 (depth = 4)
  gc_frame_newslot(block4820);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = strlit4819;
  params[1] = block4820;
  params[2] = *var_blocksOK;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4825 = callmethodflags(self, "expressionrest(1)recursingWith(1)blocks(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4818);
// compiled call node returning call4825 (depth = 3)
    gc_frame_newslot(call4825);
    if4814 = call4825;
  } else {
  }
// compiled if node returning if4814 (depth = 2)
  gc_frame_end(frame);
  return if4814;
}
Object meth_parser__apply4841(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4843 == NULL) {
    strlit4843 = alloc_String("=");
    gc_root(strlit4843);
  }
// compiled string node returning strlit4843 (depth = 7)
  int op_slot_right_4842 = gc_frame_newslot(strlit4843);
// starting to compile member node (depth = 7)
  int callframe4845 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call4846 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4845);
// compiled member node returning call4846 (depth = 7)
  int op_slot_left_4842 = gc_frame_newslot(call4846);
  params[0] = strlit4843;
  partcv[0] = 1;
  Object opresult4847 = callmethod(call4846, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4847 (depth = 6)
  gc_frame_end(frame);
  return opresult4847;
}
Object meth_parser__apply4838(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// Begin line 1551
  setline(1551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block4840 = alloc_Block(NULL, NULL, "parser", 1551);
  gc_frame_newslot(block4840);
// method "_apply"
  block_savedest(block4840);
  Object closure4841 = createclosure(2, "_apply");
  setclosureframe(closure4841, stackframe);
  addtoclosure(closure4841, var_sym);
  addtoclosure(closure4841, selfslot);
  struct UserObject *uo4841 = (struct UserObject*)block4840;
  uo4841->data[0] = (Object)closure4841;
  Method *meth_meth_parser__apply4841 = addmethod2pos(block4840, "_apply", &meth_parser__apply4841, 0);
  int argcv_meth_parser__apply4841[] = {0};
  meth_meth_parser__apply4841->type = alloc_MethodType(1, argcv_meth_parser__apply4841);
  meth_meth_parser__apply4841->definitionModule = modulename;
  meth_meth_parser__apply4841->definitionLine = 3399;
// compiled block node returning block4840 (depth = 5)
  int op_slot_right_4839 = gc_frame_newslot(block4840);
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4850 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4851 == NULL) {
    strlit4851 = alloc_String("op");
    gc_root(strlit4851);
  }
// compiled string node returning strlit4851 (depth = 6)
  gc_frame_newslot(strlit4851);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_statementToken (depth = 6)
  gc_frame_newslot(*var_statementToken);
// call case 4: self request
  params[0] = strlit4851;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4852 = callmethodflags(self, "accept(1)onLineOfLastOr(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4850);
// compiled call node returning call4852 (depth = 5)
  int op_slot_left_4839 = gc_frame_newslot(call4852);
  params[0] = block4840;
  partcv[0] = 1;
  Object opresult4853 = callmethod(call4852, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4853 (depth = 4)
  gc_frame_end(frame);
  return opresult4853;
}
Object meth_parser__apply4964(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_prec = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4967 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ops (depth = 9)
  gc_frame_newslot(*var_ops);
// call case 4: self request
  params[0] = *var_ops;
  partcv[0] = 1;
  Object call4968 = callmethodflags(self, "toprec(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4967);
// compiled call node returning call4968 (depth = 8)
  int op_slot_right_4966 = gc_frame_newslot(call4968);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_prec (depth = 8)
  int op_slot_left_4966 = gc_frame_newslot(*var_prec);
  params[0] = call4968;
  partcv[0] = 1;
  Object opresult4970 = callmethod(*var_prec, "≤(1)", 1, partcv, params);
// compiled op node returning opresult4970 (depth = 7)
  int op_slot_right_4965 = gc_frame_newslot(opresult4970);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4973 = alloc_Float64(0);
// compiled num node returning num4973 (depth = 8)
  int op_slot_right_4972 = gc_frame_newslot(num4973);
// starting to compile member node (depth = 8)
  int callframe4975 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ops (depth = 9)
  Object call4976 = callmethodflags(*var_ops, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4975);
// compiled member node returning call4976 (depth = 8)
  int op_slot_left_4972 = gc_frame_newslot(call4976);
  params[0] = num4973;
  partcv[0] = 1;
  Object opresult4977 = callmethod(call4976, ">(1)", 1, partcv, params);
// compiled op node returning opresult4977 (depth = 7)
  int op_slot_left_4965 = gc_frame_newslot(opresult4977);
  params[0] = opresult4970;
  partcv[0] = 1;
  Object opresult4978 = callmethod(opresult4977, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4978 (depth = 6)
  gc_frame_end(frame);
  return opresult4978;
}
Object meth_parser__apply4981(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_o2 = getfromclosure(closure, 1);
  Object *var_terms = getfromclosure(closure, 2);
  Object *var_tmp2 = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 1582
  setline(1582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4982 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ops (depth = 8)
  Object call4983 = callmethodflags(*var_ops, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe4982);
// compiled member node returning call4983 (depth = 7)
  *var_o2 = call4983;
  if (call4983 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1583
  setline(1583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4985 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_terms (depth = 8)
  Object call4986 = callmethodflags(*var_terms, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe4985);
// compiled member node returning call4986 (depth = 7)
  *var_tmp2 = call4986;
  if (call4986 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1584
  setline(1584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4988 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_terms (depth = 8)
  Object call4989 = callmethodflags(*var_terms, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe4988);
// compiled member node returning call4989 (depth = 7)
  *var_tmp = call4989;
  if (call4989 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1585
  setline(1585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4991 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe4992 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp (depth = 8)
  Object call4993 = callmethodflags(*var_tmp, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4992);
// compiled member node returning call4993 (depth = 7)
  gc_frame_newslot(call4993);
// starting to compile member node (depth = 7)
  int callframe4994 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp (depth = 8)
  Object call4995 = callmethodflags(*var_tmp, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4994);
// compiled member node returning call4995 (depth = 7)
  gc_frame_newslot(call4995);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  params[0] = call4993;
  params[1] = call4995;
  partcv[0] = 2;
  Object call4996 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4991);
// compiled call node returning call4996 (depth = 6)
// Begin line 1586
  setline(1586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4997 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o2 (depth = 8)
  gc_frame_newslot(*var_o2);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp (depth = 8)
  gc_frame_newslot(*var_tmp);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp2 (depth = 8)
  gc_frame_newslot(*var_tmp2);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4998 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  Object call4999 = callmethodflags(*var_ast, "opNode", 0, partcv, params, 0);
  gc_frame_end(callframe4998);
// compiled member node returning call4999 (depth = 8)
  params[0] = *var_o2;
  params[1] = *var_tmp;
  params[2] = *var_tmp2;
  partcv[0] = 3;
  Object call5000 = callmethodflags(call4999, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe4997);
// compiled call node returning call5000 (depth = 7)
  *var_tmp = call5000;
  if (call5000 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1587
  setline(1587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5002 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tmp (depth = 7)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_terms (depth = 7)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5003 = callmethodflags(*var_terms, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5002);
// compiled call node returning call5003 (depth = 6)
  gc_frame_end(frame);
  return call5003;
}
Object meth_parser__apply5180(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 9)
  int callframe5181 = gc_frame_new();
// call case 4: self request
  Object call5182 = callmethodflags(self, "term", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5181);
// compiled member node returning call5182 (depth = 9)
  gc_frame_end(frame);
  return call5182;
}
Object meth_parser__apply4856(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_opcount = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_o = getfromclosure(closure, 2);
  Object *var_prec = getfromclosure(closure, 3);
  Object *var_allarith = getfromclosure(closure, 4);
  Object *var_opdtype = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  Object *var_lastToken = getfromclosure(closure, 7);
  Object *var_ops = getfromclosure(closure, 8);
  Object *var_o2 = getfromclosure(closure, 9);
  Object *var_terms = getfromclosure(closure, 10);
  Object *var_tmp2 = getfromclosure(closure, 11);
  Object *var_tmp = getfromclosure(closure, 12);
  Object *var_util = getfromclosure(closure, 13);
  Object *var_ast = getfromclosure(closure, 14);
  Object *var_recurse = getfromclosure(closure, 15);
  Object *var_name = getfromclosure(closure, 16);
  Object *var_acceptBlocks = getfromclosure(closure, 17);
  Object *var_values = getfromclosure(closure, 18);
  Object self = *(getfromclosure(closure, 19));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// starting to compile bind node (depth = 4)
// Begin line 1552
  setline(1552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4858 = alloc_Float64(1);
// compiled num node returning num4858 (depth = 6)
  int op_slot_right_4857 = gc_frame_newslot(num4858);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_opcount (depth = 6)
  int op_slot_left_4857 = gc_frame_newslot(*var_opcount);
  params[0] = num4858;
  partcv[0] = 1;
  Object sum4860 = callmethod(*var_opcount, "+(1)", 1, partcv, params);
// compiled op node returning sum4860 (depth = 5)
  *var_opcount = sum4860;
  if (sum4860 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1553
  setline(1553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4862 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call4863 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4862);
// compiled member node returning call4863 (depth = 5)
  *var_o = call4863;
  if (call4863 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1554
  setline(1554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4865 = gc_frame_new();
// call case 4: self request
  Object call4866 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4865);
// compiled member node returning call4866 (depth = 4)
// Begin line 1555
  setline(1555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4867 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call4868 = callmethodflags(self, "oprec(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4867);
// compiled call node returning call4868 (depth = 5)
  *var_prec = call4868;
  if (call4868 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1556
  setline(1556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4873 == NULL) {
    strlit4873 = alloc_String("-");
    gc_root(strlit4873);
  }
// compiled string node returning strlit4873 (depth = 7)
  int op_slot_right_4872 = gc_frame_newslot(strlit4873);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  int op_slot_left_4872 = gc_frame_newslot(*var_o);
  params[0] = strlit4873;
  partcv[0] = 1;
  Object opresult4875 = callmethod(*var_o, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4875 (depth = 6)
  int op_slot_right_4871 = gc_frame_newslot(opresult4875);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4879 == NULL) {
    strlit4879 = alloc_String("+");
    gc_root(strlit4879);
  }
// compiled string node returning strlit4879 (depth = 8)
  int op_slot_right_4878 = gc_frame_newslot(strlit4879);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  int op_slot_left_4878 = gc_frame_newslot(*var_o);
  params[0] = strlit4879;
  partcv[0] = 1;
  Object opresult4881 = callmethod(*var_o, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4881 (depth = 7)
  int op_slot_right_4877 = gc_frame_newslot(opresult4881);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4885 == NULL) {
    strlit4885 = alloc_String("/");
    gc_root(strlit4885);
  }
// compiled string node returning strlit4885 (depth = 9)
  int op_slot_right_4884 = gc_frame_newslot(strlit4885);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  int op_slot_left_4884 = gc_frame_newslot(*var_o);
  params[0] = strlit4885;
  partcv[0] = 1;
  Object opresult4887 = callmethod(*var_o, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4887 (depth = 8)
  int op_slot_right_4883 = gc_frame_newslot(opresult4887);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4890 == NULL) {
    strlit4890 = alloc_String("*");
    gc_root(strlit4890);
  }
// compiled string node returning strlit4890 (depth = 9)
  int op_slot_right_4889 = gc_frame_newslot(strlit4890);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  int op_slot_left_4889 = gc_frame_newslot(*var_o);
  params[0] = strlit4890;
  partcv[0] = 1;
  Object opresult4892 = callmethod(*var_o, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4892 (depth = 8)
  int op_slot_left_4883 = gc_frame_newslot(opresult4892);
  params[0] = opresult4887;
  partcv[0] = 1;
  Object opresult4893 = callmethod(opresult4892, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4893 (depth = 7)
  int op_slot_left_4877 = gc_frame_newslot(opresult4893);
  params[0] = opresult4881;
  partcv[0] = 1;
  Object opresult4894 = callmethod(opresult4893, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4894 (depth = 6)
  int op_slot_left_4871 = gc_frame_newslot(opresult4894);
  params[0] = opresult4875;
  partcv[0] = 1;
  Object opresult4895 = callmethod(opresult4894, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4895 (depth = 5)
  Object if4870 = done;
  if (istrue(opresult4895)) {
// Begin line 1557
  setline(1557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4896 = alloc_Boolean(0);
// compiled identifier node returning bool4896 (depth = 6)
  *var_allarith = bool4896;
  if (bool4896 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if4870 = done;
  } else {
  }
// compiled if node returning if4870 (depth = 4)
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4900 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_allarith (depth = 7)
  Object call4901 = callmethodflags(*var_allarith, "not", 0, partcv, params, 0);
  gc_frame_end(callframe4900);
// compiled member node returning call4901 (depth = 6)
  int op_slot_right_4899 = gc_frame_newslot(call4901);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  int op_slot_right_4904 = gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_opdtype (depth = 8)
  int op_slot_left_4904 = gc_frame_newslot(*var_opdtype);
  params[0] = *var_o;
  partcv[0] = 1;
  Object opresult4906 = callmethod(*var_opdtype, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4906 (depth = 7)
  int op_slot_right_4903 = gc_frame_newslot(opresult4906);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4909 == NULL) {
    strlit4909 = alloc_String("");
    gc_root(strlit4909);
  }
// compiled string node returning strlit4909 (depth = 8)
  int op_slot_right_4908 = gc_frame_newslot(strlit4909);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_opdtype (depth = 8)
  int op_slot_left_4908 = gc_frame_newslot(*var_opdtype);
  params[0] = strlit4909;
  partcv[0] = 1;
  Object opresult4911 = callmethod(*var_opdtype, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4911 (depth = 7)
  int op_slot_left_4903 = gc_frame_newslot(opresult4911);
  params[0] = opresult4906;
  partcv[0] = 1;
  Object opresult4912 = callmethod(opresult4911, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4912 (depth = 6)
  int op_slot_left_4899 = gc_frame_newslot(opresult4912);
  params[0] = call4901;
  partcv[0] = 1;
  Object opresult4913 = callmethod(opresult4912, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4913 (depth = 5)
  Object if4898 = done;
  if (istrue(opresult4913)) {
// Begin line 1563
  setline(1563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array4914 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4914 (depth = 6)
  *var_suggestions = array4914;
  if (array4914 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1564
  setline(1564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4915 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4916 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call4917 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4916);
// compiled member node returning call4917 (depth = 7)
  Object call4918 = callmethodflags(call4917, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4915);
// compiled member node returning call4918 (depth = 6)
  *var_suggestion = call4918;
  if (call4918 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4919 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4920 == NULL) {
    strlit4920 = alloc_String(")");
    gc_root(strlit4920);
  }
// compiled string node returning strlit4920 (depth = 6)
  gc_frame_newslot(strlit4920);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4920;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4921 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4919);
// compiled call node returning call4921 (depth = 5)
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4922 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4923 == NULL) {
    strlit4923 = alloc_String("(");
    gc_root(strlit4923);
  }
// compiled string node returning strlit4923 (depth = 6)
  gc_frame_newslot(strlit4923);
// starting to compile member node (depth = 6)
  int callframe4924 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call4925 = callmethodflags(*var_lastToken, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4924);
// compiled member node returning call4925 (depth = 6)
  gc_frame_newslot(call4925);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4923;
  params[1] = call4925;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4926 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4922);
// compiled call node returning call4926 (depth = 5)
// Begin line 1567
  setline(1567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4927 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4928 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4927);
// compiled call node returning call4928 (depth = 5)
// Begin line 1568
  setline(1568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4929 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4930 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call4931 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe4930);
// compiled member node returning call4931 (depth = 7)
  Object call4932 = callmethodflags(call4931, "new", 0, partcv, params, 0);
  gc_frame_end(callframe4929);
// compiled member node returning call4932 (depth = 6)
  *var_suggestion = call4932;
  if (call4932 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4934 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4935 == NULL) {
    strlit4935 = alloc_String(")");
    gc_root(strlit4935);
  }
// compiled string node returning strlit4935 (depth = 6)
  gc_frame_newslot(strlit4935);
// starting to compile member node (depth = 6)
  int callframe4936 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call4937 = callmethodflags(*var_lastToken, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4936);
// compiled member node returning call4937 (depth = 6)
  gc_frame_newslot(call4937);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4935;
  params[1] = call4937;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4938 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4934);
// compiled call node returning call4938 (depth = 5)
// Begin line 1570
  setline(1570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4939 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4940 == NULL) {
    strlit4940 = alloc_String("(");
    gc_root(strlit4940);
  }
// compiled string node returning strlit4940 (depth = 6)
  gc_frame_newslot(strlit4940);
// starting to compile member node (depth = 6)
  int callframe4941 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4942 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4943 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call4944 = callmethodflags(*var_lastToken, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4943);
// compiled member node returning call4944 (depth = 8)
  Object call4945 = callmethodflags(call4944, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4942);
// compiled member node returning call4945 (depth = 7)
  Object call4946 = callmethodflags(call4945, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4941);
// compiled member node returning call4946 (depth = 6)
  gc_frame_newslot(call4946);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4940;
  params[1] = call4946;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4947 = callmethodflags(*var_suggestion, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4939);
// compiled call node returning call4947 (depth = 5)
// Begin line 1571
  setline(1571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4948 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4949 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4948);
// compiled call node returning call4949 (depth = 5)
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4950 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4951 == NULL) {
    strlit4951 = alloc_String("an expression containing both arithmetic and non-arithmetic operators requires parentheses.");
    gc_root(strlit4951);
  }
// compiled string node returning strlit4951 (depth = 6)
  gc_frame_newslot(strlit4951);
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4952 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4953 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call4954 = callmethodflags(*var_lastToken, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4953);
// compiled member node returning call4954 (depth = 7)
  Object call4955 = callmethodflags(call4954, "line", 0, partcv, params, 0);
  gc_frame_end(callframe4952);
// compiled member node returning call4955 (depth = 6)
  gc_frame_newslot(call4955);
// starting to compile member node (depth = 6)
  int callframe4956 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4957 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call4958 = callmethodflags(*var_lastToken, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe4957);
// compiled member node returning call4958 (depth = 7)
  Object call4959 = callmethodflags(call4958, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe4956);
// compiled member node returning call4959 (depth = 6)
  gc_frame_newslot(call4959);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit4951;
  params[1] = call4955;
  params[2] = call4959;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4960 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe4950);
// compiled call node returning call4960 (depth = 5)
    gc_frame_newslot(call4960);
    if4898 = call4960;
  } else {
  }
// compiled if node returning if4898 (depth = 4)
// Begin line 1575
  setline(1575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  *var_opdtype = *var_o;
  if (*var_o == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1576
  setline(1576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4962 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4963 = alloc_Block(NULL, NULL, "parser", 1576);
  gc_frame_newslot(block4963);
// method "_apply"
  block_savedest(block4963);
  Object closure4964 = createclosure(3, "_apply");
  setclosureframe(closure4964, stackframe);
  addtoclosure(closure4964, var_ops);
  addtoclosure(closure4964, var_prec);
  addtoclosure(closure4964, selfslot);
  struct UserObject *uo4964 = (struct UserObject*)block4963;
  uo4964->data[0] = (Object)closure4964;
  Method *meth_meth_parser__apply4964 = addmethod2pos(block4963, "_apply", &meth_parser__apply4964, 0);
  int argcv_meth_parser__apply4964[] = {0};
  meth_meth_parser__apply4964->type = alloc_MethodType(1, argcv_meth_parser__apply4964);
  meth_meth_parser__apply4964->definitionModule = modulename;
  meth_meth_parser__apply4964->definitionLine = 3399;
// compiled block node returning block4963 (depth = 5)
  gc_frame_newslot(block4963);
// starting to compile block node (depth = 5)
  Object block4980 = alloc_Block(NULL, NULL, "parser", 1576);
  gc_frame_newslot(block4980);
// method "_apply"
  block_savedest(block4980);
  Object closure4981 = createclosure(8, "_apply");
  setclosureframe(closure4981, stackframe);
  addtoclosure(closure4981, var_ops);
  addtoclosure(closure4981, var_o2);
  addtoclosure(closure4981, var_terms);
  addtoclosure(closure4981, var_tmp2);
  addtoclosure(closure4981, var_tmp);
  addtoclosure(closure4981, var_util);
  addtoclosure(closure4981, var_ast);
  addtoclosure(closure4981, selfslot);
  struct UserObject *uo4981 = (struct UserObject*)block4980;
  uo4981->data[0] = (Object)closure4981;
  Method *meth_meth_parser__apply4981 = addmethod2pos(block4980, "_apply", &meth_parser__apply4981, 0);
  int argcv_meth_parser__apply4981[] = {0};
  meth_meth_parser__apply4981->type = alloc_MethodType(1, argcv_meth_parser__apply4981);
  meth_meth_parser__apply4981->definitionModule = modulename;
  meth_meth_parser__apply4981->definitionLine = 3399;
// compiled block node returning block4980 (depth = 5)
  gc_frame_newslot(block4980);
// call case 5: prelude request
  params[0] = block4963;
  params[1] = block4980;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5005 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4962);
// compiled call node returning call5005 (depth = 4)
// Begin line 1589
  setline(1589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5006 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ops (depth = 5)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5007 = callmethodflags(*var_ops, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5006);
// compiled call node returning call5007 (depth = 4)
// Begin line 1590
  setline(1590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5009 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5010 == NULL) {
    strlit5010 = alloc_String("lparen");
    gc_root(strlit5010);
  }
// compiled string node returning strlit5010 (depth = 6)
  gc_frame_newslot(strlit5010);
// call case 4: self request
  params[0] = strlit5010;
  partcv[0] = 1;
  Object call5011 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5009);
// compiled call node returning call5011 (depth = 5)
  Object if5008 = done;
  if (istrue(call5011)) {
// Begin line 1597
  setline(1597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5012 = gc_frame_new();
// call case 4: self request
  Object call5013 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5012);
// compiled member node returning call5013 (depth = 5)
// Begin line 1598
  setline(1598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5015 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe5016 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_recurse (depth = 8)
  gc_frame_newslot(*var_recurse);
// call case 4: self request
  params[0] = *var_recurse;
  partcv[0] = 1;
  Object call5017 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5016);
// compiled call node returning call5017 (depth = 7)
  Object call5018 = callmethodflags(call5017, "not", 0, partcv, params, 0);
  gc_frame_end(callframe5015);
// compiled member node returning call5018 (depth = 6)
  Object if5014 = done;
  if (istrue(call5018)) {
// Begin line 1599
  setline(1599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5019 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5020 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call5021 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5020);
// compiled member node returning call5021 (depth = 8)
  Object call5022 = callmethodflags(call5021, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5019);
// compiled member node returning call5022 (depth = 7)
  *var_suggestion = call5022;
  if (call5022 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1600
  setline(1600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5023 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array5024 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit5025 == NULL) {
    strlit5025 = alloc_String("rparen");
    gc_root(strlit5025);
  }
// compiled string node returning strlit5025 (depth = 9)
  params[0] = strlit5025;
  partcv[0] = 1;
  callmethodflags(array5024, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array5024 (depth = 8)
  gc_frame_newslot(array5024);
// call case 4: self request
  params[0] = array5024;
  partcv[0] = 1;
  Object call5026 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5023);
// compiled call node returning call5026 (depth = 7)
  *var_nextTok = call5026;
  if (call5026 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1601
  setline(1601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_5028 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_5028 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5030 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult5030 (depth = 7)
  Object if5027 = done;
  if (istrue(opresult5030)) {
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5031 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5033 == NULL) {
    strlit5033 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5033);
  }
// compiled string node returning strlit5033 (depth = 9)
  int op_slot_right_5032 = gc_frame_newslot(strlit5033);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5035 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5037 == NULL) {
    strlit5037 = alloc_String("""\xc2""""\xab""");
    gc_root(strlit5037);
  }
// compiled string node returning strlit5037 (depth = 10)
  int op_slot_left_5035 = gc_frame_newslot(strlit5037);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5038 = callmethod(strlit5037, "++(1)", 1, partcv, params);
// compiled op node returning opresult5038 (depth = 9)
  int op_slot_left_5032 = gc_frame_newslot(opresult5038);
  params[0] = strlit5033;
  partcv[0] = 1;
  Object opresult5039 = callmethod(opresult5038, "++(1)", 1, partcv, params);
// compiled op node returning opresult5039 (depth = 8)
  gc_frame_newslot(opresult5039);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = opresult5039;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5040 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5031);
// compiled call node returning call5040 (depth = 7)
    gc_frame_newslot(call5040);
    if5027 = call5040;
  } else {
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5041 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
  int callframe5042 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  Object call5043 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe5042);
// compiled member node returning call5043 (depth = 8)
  gc_frame_newslot(call5043);
// starting to compile identifier node (depth = 8)
  Object bool5044 = alloc_Boolean(1);
// compiled identifier node returning bool5044 (depth = 8)
  gc_frame_newslot(bool5044);
// starting to compile identifier node (depth = 8)
  Object bool5045 = alloc_Boolean(0);
// compiled identifier node returning bool5045 (depth = 8)
  gc_frame_newslot(bool5045);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5047 == NULL) {
    strlit5047 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5047);
  }
// compiled string node returning strlit5047 (depth = 9)
  int op_slot_right_5046 = gc_frame_newslot(strlit5047);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5049 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5051 == NULL) {
    strlit5051 = alloc_String("""\xc2""""\xab""");
    gc_root(strlit5051);
  }
// compiled string node returning strlit5051 (depth = 10)
  int op_slot_left_5049 = gc_frame_newslot(strlit5051);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5052 = callmethod(strlit5051, "++(1)", 1, partcv, params);
// compiled op node returning opresult5052 (depth = 9)
  int op_slot_left_5046 = gc_frame_newslot(opresult5052);
  params[0] = strlit5047;
  partcv[0] = 1;
  Object opresult5053 = callmethod(opresult5052, "++(1)", 1, partcv, params);
// compiled op node returning opresult5053 (depth = 8)
  gc_frame_newslot(opresult5053);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call5043;
  params[2] = bool5044;
  params[3] = bool5045;
  params[4] = opresult5053;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5054 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe5041);
// compiled call node returning call5054 (depth = 7)
    gc_frame_newslot(call5054);
    if5027 = call5054;
  }
// compiled if node returning if5027 (depth = 6)
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5055 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5057 == NULL) {
    strlit5057 = alloc_String(".");
    gc_root(strlit5057);
  }
// compiled string node returning strlit5057 (depth = 8)
  int op_slot_right_5056 = gc_frame_newslot(strlit5057);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_name (depth = 9)
  int op_slot_right_5059 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 9)
  if (strlit5061 == NULL) {
    strlit5061 = alloc_String("parentheses must contain a valid ");
    gc_root(strlit5061);
  }
// compiled string node returning strlit5061 (depth = 9)
  int op_slot_left_5059 = gc_frame_newslot(strlit5061);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5062 = callmethod(strlit5061, "++(1)", 1, partcv, params);
// compiled op node returning opresult5062 (depth = 8)
  int op_slot_left_5056 = gc_frame_newslot(opresult5062);
  params[0] = strlit5057;
  partcv[0] = 1;
  Object opresult5063 = callmethod(opresult5062, "++(1)", 1, partcv, params);
// compiled op node returning opresult5063 (depth = 7)
  gc_frame_newslot(opresult5063);
// Begin line 1607
  setline(1607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe5064 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call5065 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5064);
// compiled member node returning call5065 (depth = 7)
  gc_frame_newslot(call5065);
// starting to compile member node (depth = 7)
  int callframe5066 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call5067 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5066);
// compiled member node returning call5067 (depth = 7)
  gc_frame_newslot(call5067);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult5063;
  params[1] = call5065;
  params[2] = call5067;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5068 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5055);
// compiled call node returning call5068 (depth = 6)
    gc_frame_newslot(call5068);
    if5014 = call5068;
  } else {
  }
// compiled if node returning if5014 (depth = 5)
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5071 == NULL) {
    strlit5071 = alloc_String("rparen");
    gc_root(strlit5071);
  }
// compiled string node returning strlit5071 (depth = 7)
  int op_slot_right_5070 = gc_frame_newslot(strlit5071);
// starting to compile member node (depth = 7)
  int callframe5073 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call5074 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5073);
// compiled member node returning call5074 (depth = 7)
  int op_slot_left_5070 = gc_frame_newslot(call5074);
  params[0] = strlit5071;
  partcv[0] = 1;
  Object opresult5075 = callmethod(call5074, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5075 (depth = 6)
  Object if5069 = done;
  if (istrue(opresult5075)) {
// Begin line 1610
  setline(1610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe5076 = gc_frame_new();
// call case 4: self request
  Object call5077 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5076);
// compiled member node returning call5077 (depth = 6)
// Begin line 1611
  setline(1611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5078 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5079 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call5080 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5079);
// compiled member node returning call5080 (depth = 8)
  Object call5081 = callmethodflags(call5080, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5078);
// compiled member node returning call5081 (depth = 7)
  *var_suggestion = call5081;
  if (call5081 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5082 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5083 == NULL) {
    strlit5083 = alloc_String(")");
    gc_root(strlit5083);
  }
// compiled string node returning strlit5083 (depth = 7)
  gc_frame_newslot(strlit5083);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit5083;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5084 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5082);
// compiled call node returning call5084 (depth = 6)
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5085 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5086 == NULL) {
    strlit5086 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit5086);
  }
// compiled string node returning strlit5086 (depth = 7)
  gc_frame_newslot(strlit5086);
// Begin line 1614
  setline(1614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe5087 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call5088 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5087);
// compiled member node returning call5088 (depth = 7)
  gc_frame_newslot(call5088);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe5090 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call5091 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe5090);
// compiled member node returning call5091 (depth = 8)
  int op_slot_right_5089 = gc_frame_newslot(call5091);
// starting to compile member node (depth = 8)
  int callframe5093 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call5094 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5093);
// compiled member node returning call5094 (depth = 8)
  int op_slot_left_5089 = gc_frame_newslot(call5094);
  params[0] = call5091;
  partcv[0] = 1;
  Object sum5095 = callmethod(call5094, "+(1)", 1, partcv, params);
// compiled op node returning sum5095 (depth = 7)
  gc_frame_newslot(sum5095);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit5086;
  params[1] = call5088;
  params[2] = sum5095;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5096 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5085);
// compiled call node returning call5096 (depth = 6)
    gc_frame_newslot(call5096);
    if5069 = call5096;
  } else {
  }
// compiled if node returning if5069 (depth = 5)
// Begin line 1616
  setline(1616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5097 = gc_frame_new();
// call case 4: self request
  Object call5098 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5097);
// compiled member node returning call5098 (depth = 5)
    gc_frame_newslot(call5098);
    if5008 = call5098;
  } else {
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5100 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5101 = gc_frame_new();
// call case 4: self request
  Object call5102 = callmethodflags(self, "tokenOnSameLine", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5101);
// compiled member node returning call5102 (depth = 7)
  partcv[0] = 0;
  Object call5103 = callmethodflags(call5102, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe5100);
// compiled call node returning call5103 (depth = 6)
  Object if5099 = done;
  if (istrue(call5103)) {
// Begin line 1619
  setline(1619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array5104 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5104 (depth = 7)
  *var_suggestions = array5104;
  if (array5104 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1620
  setline(1620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5105 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5106 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call5107 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5106);
// compiled member node returning call5107 (depth = 8)
  Object call5108 = callmethodflags(call5107, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5105);
// compiled member node returning call5108 (depth = 7)
  *var_suggestion = call5108;
  if (call5108 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1621
  setline(1621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5109 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool5110 = alloc_Boolean(1);
// compiled identifier node returning bool5110 (depth = 7)
  gc_frame_newslot(bool5110);
// starting to compile identifier node (depth = 7)
  Object bool5111 = alloc_Boolean(0);
// compiled identifier node returning bool5111 (depth = 7)
  gc_frame_newslot(bool5111);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = bool5110;
  params[2] = bool5111;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5112 = callmethodflags(*var_suggestion, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5109);
// compiled call node returning call5112 (depth = 6)
// Begin line 1622
  setline(1622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5113 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5114 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5113);
// compiled call node returning call5114 (depth = 6)
// Begin line 1623
  setline(1623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5115 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5116 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call5117 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5116);
// compiled member node returning call5117 (depth = 8)
  Object call5118 = callmethodflags(call5117, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5115);
// compiled member node returning call5118 (depth = 7)
  *var_suggestion = call5118;
  if (call5118 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1624
  setline(1624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5120 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5122 == NULL) {
    strlit5122 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5122);
  }
// compiled string node returning strlit5122 (depth = 8)
  int op_slot_right_5121 = gc_frame_newslot(strlit5122);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_name (depth = 9)
  int op_slot_right_5124 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 9)
  if (strlit5126 == NULL) {
    strlit5126 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit5126);
  }
// compiled string node returning strlit5126 (depth = 9)
  int op_slot_left_5124 = gc_frame_newslot(strlit5126);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5127 = callmethod(strlit5126, "++(1)", 1, partcv, params);
// compiled op node returning opresult5127 (depth = 8)
  int op_slot_left_5121 = gc_frame_newslot(opresult5127);
  params[0] = strlit5122;
  partcv[0] = 1;
  Object opresult5128 = callmethod(opresult5127, "++(1)", 1, partcv, params);
// compiled op node returning opresult5128 (depth = 7)
  gc_frame_newslot(opresult5128);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = opresult5128;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5129 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5120);
// compiled call node returning call5129 (depth = 6)
// Begin line 1625
  setline(1625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5130 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5131 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5130);
// compiled call node returning call5131 (depth = 6)
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5132 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5133 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call5134 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5133);
// compiled member node returning call5134 (depth = 8)
  Object call5135 = callmethodflags(call5134, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5132);
// compiled member node returning call5135 (depth = 7)
  *var_suggestion = call5135;
  if (call5135 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1627
  setline(1627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5137 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5139 = gc_frame_new();
// starting to compile member node (depth = 9)
  int callframe5140 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call5141 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5140);
// compiled member node returning call5141 (depth = 9)
  gc_frame_newslot(call5141);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe5142 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  Object call5143 = callmethodflags(*var_util, "lines", 0, partcv, params, 0);
  gc_frame_end(callframe5142);
// compiled member node returning call5143 (depth = 9)
  params[0] = call5141;
  partcv[0] = 1;
  Object call5144 = callmethodflags(call5143, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5139);
// compiled call node returning call5144 (depth = 8)
  int op_slot_right_5138 = gc_frame_newslot(call5144);
// starting to compile string node (depth = 8)
  if (strlit5146 == NULL) {
    strlit5146 = alloc_String(" ");
    gc_root(strlit5146);
  }
// compiled string node returning strlit5146 (depth = 8)
  int op_slot_left_5138 = gc_frame_newslot(strlit5146);
  params[0] = call5144;
  partcv[0] = 1;
  Object opresult5147 = callmethod(strlit5146, "++(1)", 1, partcv, params);
// compiled op node returning opresult5147 (depth = 7)
  gc_frame_newslot(opresult5147);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = opresult5147;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5148 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5137);
// compiled call node returning call5148 (depth = 6)
// Begin line 1628
  setline(1628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5149 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe5150 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call5151 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5150);
// compiled member node returning call5151 (depth = 7)
  gc_frame_newslot(call5151);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = call5151;
  partcv[0] = 1;
  Object call5152 = callmethodflags(*var_suggestion, "deleteLine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5149);
// compiled call node returning call5152 (depth = 6)
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5153 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5154 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5153);
// compiled call node returning call5154 (depth = 6)
// Begin line 1630
  setline(1630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5155 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5157 == NULL) {
    strlit5157 = alloc_String("'. This is often caused by a new line in the middle of an expression.");
    gc_root(strlit5157);
  }
// compiled string node returning strlit5157 (depth = 8)
  int op_slot_right_5156 = gc_frame_newslot(strlit5157);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe5160 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call5161 = callmethodflags(*var_lastToken, "value", 0, partcv, params, 0);
  gc_frame_end(callframe5160);
// compiled member node returning call5161 (depth = 9)
  int op_slot_right_5159 = gc_frame_newslot(call5161);
// starting to compile string node (depth = 9)
  if (strlit5163 == NULL) {
    strlit5163 = alloc_String("a valid expression must follow '");
    gc_root(strlit5163);
  }
// compiled string node returning strlit5163 (depth = 9)
  int op_slot_left_5159 = gc_frame_newslot(strlit5163);
  params[0] = call5161;
  partcv[0] = 1;
  Object opresult5164 = callmethod(strlit5163, "++(1)", 1, partcv, params);
// compiled op node returning opresult5164 (depth = 8)
  int op_slot_left_5156 = gc_frame_newslot(opresult5164);
  params[0] = strlit5157;
  partcv[0] = 1;
  Object opresult5165 = callmethod(opresult5164, "++(1)", 1, partcv, params);
// compiled op node returning opresult5165 (depth = 7)
  gc_frame_newslot(opresult5165);
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe5166 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call5167 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5166);
// compiled member node returning call5167 (depth = 7)
  gc_frame_newslot(call5167);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe5169 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call5170 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe5169);
// compiled member node returning call5170 (depth = 8)
  int op_slot_right_5168 = gc_frame_newslot(call5170);
// starting to compile member node (depth = 8)
  int callframe5172 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call5173 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5172);
// compiled member node returning call5173 (depth = 8)
  int op_slot_left_5168 = gc_frame_newslot(call5173);
  params[0] = call5170;
  partcv[0] = 1;
  Object sum5174 = callmethod(call5173, "+(1)", 1, partcv, params);
// compiled op node returning sum5174 (depth = 7)
  gc_frame_newslot(sum5174);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1630
  setline(1630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult5165;
  params[1] = call5167;
  params[2] = sum5174;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5175 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5155);
// compiled call node returning call5175 (depth = 6)
    gc_frame_newslot(call5175);
    if5099 = call5175;
  } else {
  }
// compiled if node returning if5099 (depth = 5)
// Begin line 1633
  setline(1633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5177 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe5178 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block5179 = alloc_Block(NULL, NULL, "parser", 1633);
  gc_frame_newslot(block5179);
// method "_apply"
  block_savedest(block5179);
  Object closure5180 = createclosure(1, "_apply");
  setclosureframe(closure5180, stackframe);
  addtoclosure(closure5180, selfslot);
  struct UserObject *uo5180 = (struct UserObject*)block5179;
  uo5180->data[0] = (Object)closure5180;
  Method *meth_meth_parser__apply5180 = addmethod2pos(block5179, "_apply", &meth_parser__apply5180, 0);
  int argcv_meth_parser__apply5180[] = {0};
  meth_meth_parser__apply5180->type = alloc_MethodType(1, argcv_meth_parser__apply5180);
  meth_meth_parser__apply5180->definitionModule = modulename;
  meth_meth_parser__apply5180->definitionLine = 3399;
// compiled block node returning block5179 (depth = 8)
  gc_frame_newslot(block5179);
// call case 4: self request
  params[0] = block5179;
  partcv[0] = 1;
  Object call5184 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5178);
// compiled call node returning call5184 (depth = 7)
  Object call5185 = callmethodflags(call5184, "not", 0, partcv, params, 0);
  gc_frame_end(callframe5177);
// compiled member node returning call5185 (depth = 6)
  Object if5176 = done;
  if (istrue(call5185)) {
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array5186 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5186 (depth = 7)
  *var_suggestions = array5186;
  if (array5186 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5187 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5188 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call5189 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5188);
// compiled member node returning call5189 (depth = 8)
  Object call5190 = callmethodflags(call5189, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5187);
// compiled member node returning call5190 (depth = 7)
  *var_suggestion = call5190;
  if (call5190 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1636
  setline(1636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5191 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array5192 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit5193 == NULL) {
    strlit5193 = alloc_String("comma");
    gc_root(strlit5193);
  }
// compiled string node returning strlit5193 (depth = 9)
  params[0] = strlit5193;
  partcv[0] = 1;
  callmethodflags(array5192, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 9)
  if (strlit5194 == NULL) {
    strlit5194 = alloc_String("rparen");
    gc_root(strlit5194);
  }
// compiled string node returning strlit5194 (depth = 9)
  params[0] = strlit5194;
  partcv[0] = 1;
  callmethodflags(array5192, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 9)
  if (strlit5195 == NULL) {
    strlit5195 = alloc_String("rsquare");
    gc_root(strlit5195);
  }
// compiled string node returning strlit5195 (depth = 9)
  params[0] = strlit5195;
  partcv[0] = 1;
  callmethodflags(array5192, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 9)
  if (strlit5196 == NULL) {
    strlit5196 = alloc_String("rbrace");
    gc_root(strlit5196);
  }
// compiled string node returning strlit5196 (depth = 9)
  params[0] = strlit5196;
  partcv[0] = 1;
  callmethodflags(array5192, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array5192 (depth = 8)
  gc_frame_newslot(array5192);
// call case 4: self request
  params[0] = array5192;
  partcv[0] = 1;
  Object call5197 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5191);
// compiled call node returning call5197 (depth = 7)
  *var_nextTok = call5197;
  if (call5197 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1637
  setline(1637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_5199 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_5199 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5201 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult5201 (depth = 7)
  Object if5198 = done;
  if (istrue(opresult5201)) {
// Begin line 1638
  setline(1638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5202 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5204 == NULL) {
    strlit5204 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5204);
  }
// compiled string node returning strlit5204 (depth = 9)
  int op_slot_right_5203 = gc_frame_newslot(strlit5204);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5206 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5208 == NULL) {
    strlit5208 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit5208);
  }
// compiled string node returning strlit5208 (depth = 10)
  int op_slot_left_5206 = gc_frame_newslot(strlit5208);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5209 = callmethod(strlit5208, "++(1)", 1, partcv, params);
// compiled op node returning opresult5209 (depth = 9)
  int op_slot_left_5203 = gc_frame_newslot(opresult5209);
  params[0] = strlit5204;
  partcv[0] = 1;
  Object opresult5210 = callmethod(opresult5209, "++(1)", 1, partcv, params);
// compiled op node returning opresult5210 (depth = 8)
  gc_frame_newslot(opresult5210);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = opresult5210;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5211 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5202);
// compiled call node returning call5211 (depth = 7)
    gc_frame_newslot(call5211);
    if5198 = call5211;
  } else {
// Begin line 1640
  setline(1640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5212 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
  int callframe5213 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  Object call5214 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe5213);
// compiled member node returning call5214 (depth = 8)
  gc_frame_newslot(call5214);
// starting to compile identifier node (depth = 8)
  Object bool5215 = alloc_Boolean(1);
// compiled identifier node returning bool5215 (depth = 8)
  gc_frame_newslot(bool5215);
// starting to compile identifier node (depth = 8)
  Object bool5216 = alloc_Boolean(0);
// compiled identifier node returning bool5216 (depth = 8)
  gc_frame_newslot(bool5216);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5218 == NULL) {
    strlit5218 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5218);
  }
// compiled string node returning strlit5218 (depth = 9)
  int op_slot_right_5217 = gc_frame_newslot(strlit5218);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5220 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5222 == NULL) {
    strlit5222 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit5222);
  }
// compiled string node returning strlit5222 (depth = 10)
  int op_slot_left_5220 = gc_frame_newslot(strlit5222);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5223 = callmethod(strlit5222, "++(1)", 1, partcv, params);
// compiled op node returning opresult5223 (depth = 9)
  int op_slot_left_5217 = gc_frame_newslot(opresult5223);
  params[0] = strlit5218;
  partcv[0] = 1;
  Object opresult5224 = callmethod(opresult5223, "++(1)", 1, partcv, params);
// compiled op node returning opresult5224 (depth = 8)
  gc_frame_newslot(opresult5224);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call5214;
  params[2] = bool5215;
  params[3] = bool5216;
  params[4] = opresult5224;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5225 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe5212);
// compiled call node returning call5225 (depth = 7)
    gc_frame_newslot(call5225);
    if5198 = call5225;
  }
// compiled if node returning if5198 (depth = 6)
// Begin line 1642
  setline(1642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5226 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5227 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5226);
// compiled call node returning call5227 (depth = 6)
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5228 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5229 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call5230 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5229);
// compiled member node returning call5230 (depth = 8)
  Object call5231 = callmethodflags(call5230, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5228);
// compiled member node returning call5231 (depth = 7)
  *var_suggestion = call5231;
  if (call5231 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5233 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
  int callframe5234 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call5235 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe5234);
// compiled member node returning call5235 (depth = 7)
  gc_frame_newslot(call5235);
// starting to compile identifier node (depth = 7)
  Object bool5236 = alloc_Boolean(1);
// compiled identifier node returning bool5236 (depth = 7)
  gc_frame_newslot(bool5236);
// starting to compile identifier node (depth = 7)
  Object bool5237 = alloc_Boolean(0);
// compiled identifier node returning bool5237 (depth = 7)
  gc_frame_newslot(bool5237);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call5235;
  params[2] = bool5236;
  params[3] = bool5237;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5238 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5233);
// compiled call node returning call5238 (depth = 6)
// Begin line 1645
  setline(1645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5239 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5240 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5239);
// compiled call node returning call5240 (depth = 6)
// Begin line 1646
  setline(1646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5241 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5243 == NULL) {
    strlit5243 = alloc_String("'. This is often caused by a new line in the middle of an expression.");
    gc_root(strlit5243);
  }
// compiled string node returning strlit5243 (depth = 8)
  int op_slot_right_5242 = gc_frame_newslot(strlit5243);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe5246 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call5247 = callmethodflags(*var_lastToken, "value", 0, partcv, params, 0);
  gc_frame_end(callframe5246);
// compiled member node returning call5247 (depth = 9)
  int op_slot_right_5245 = gc_frame_newslot(call5247);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5250 == NULL) {
    strlit5250 = alloc_String(" must follow '");
    gc_root(strlit5250);
  }
// compiled string node returning strlit5250 (depth = 10)
  int op_slot_right_5249 = gc_frame_newslot(strlit5250);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_name (depth = 11)
  int op_slot_right_5252 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 11)
  if (strlit5254 == NULL) {
    strlit5254 = alloc_String("a valid ");
    gc_root(strlit5254);
  }
// compiled string node returning strlit5254 (depth = 11)
  int op_slot_left_5252 = gc_frame_newslot(strlit5254);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5255 = callmethod(strlit5254, "++(1)", 1, partcv, params);
// compiled op node returning opresult5255 (depth = 10)
  int op_slot_left_5249 = gc_frame_newslot(opresult5255);
  params[0] = strlit5250;
  partcv[0] = 1;
  Object opresult5256 = callmethod(opresult5255, "++(1)", 1, partcv, params);
// compiled op node returning opresult5256 (depth = 9)
  int op_slot_left_5245 = gc_frame_newslot(opresult5256);
  params[0] = call5247;
  partcv[0] = 1;
  Object opresult5257 = callmethod(opresult5256, "++(1)", 1, partcv, params);
// compiled op node returning opresult5257 (depth = 8)
  int op_slot_left_5242 = gc_frame_newslot(opresult5257);
  params[0] = strlit5243;
  partcv[0] = 1;
  Object opresult5258 = callmethod(opresult5257, "++(1)", 1, partcv, params);
// compiled op node returning opresult5258 (depth = 7)
  gc_frame_newslot(opresult5258);
// Begin line 1647
  setline(1647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe5259 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call5260 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5259);
// compiled member node returning call5260 (depth = 7)
  gc_frame_newslot(call5260);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe5262 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call5263 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe5262);
// compiled member node returning call5263 (depth = 8)
  int op_slot_right_5261 = gc_frame_newslot(call5263);
// starting to compile member node (depth = 8)
  int callframe5265 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call5266 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5265);
// compiled member node returning call5266 (depth = 8)
  int op_slot_left_5261 = gc_frame_newslot(call5266);
  params[0] = call5263;
  partcv[0] = 1;
  Object sum5267 = callmethod(call5266, "+(1)", 1, partcv, params);
// compiled op node returning sum5267 (depth = 7)
  gc_frame_newslot(sum5267);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1646
  setline(1646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult5258;
  params[1] = call5260;
  params[2] = sum5267;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5268 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5241);
// compiled call node returning call5268 (depth = 6)
    gc_frame_newslot(call5268);
    if5176 = call5268;
  } else {
  }
// compiled if node returning if5176 (depth = 5)
    gc_frame_newslot(if5176);
    if5008 = if5176;
  }
// compiled if node returning if5008 (depth = 4)
// Begin line 1655
  setline(1655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5269 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_acceptBlocks (depth = 5)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5270 = callmethodflags(self, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5269);
// compiled call node returning call5270 (depth = 4)
// Begin line 1656
  setline(1656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5271 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_acceptBlocks (depth = 5)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5272 = callmethodflags(self, "callrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5271);
// compiled call node returning call5272 (depth = 4)
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5273 = gc_frame_new();
// call case 4: self request
  Object call5274 = callmethodflags(self, "postfixsquare", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5273);
// compiled member node returning call5274 (depth = 4)
// Begin line 1658
  setline(1658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5275 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call5276 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5275);
// compiled member node returning call5276 (depth = 5)
  *var_tmp = call5276;
  if (call5276 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1659
  setline(1659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5278 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tmp (depth = 5)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5279 = callmethodflags(*var_terms, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5278);
// compiled call node returning call5279 (depth = 4)
  gc_frame_end(frame);
  return call5279;
}
Object meth_parser__apply5284(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5286 = alloc_Float64(0);
// compiled num node returning num5286 (depth = 5)
  int op_slot_right_5285 = gc_frame_newslot(num5286);
// starting to compile member node (depth = 5)
  int callframe5288 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ops (depth = 6)
  Object call5289 = callmethodflags(*var_ops, "size", 0, partcv, params, 0);
  gc_frame_end(callframe5288);
// compiled member node returning call5289 (depth = 5)
  int op_slot_left_5285 = gc_frame_newslot(call5289);
  params[0] = num5286;
  partcv[0] = 1;
  Object opresult5290 = callmethod(call5289, ">(1)", 1, partcv, params);
// compiled op node returning opresult5290 (depth = 4)
  gc_frame_end(frame);
  return opresult5290;
}
Object meth_parser__apply5293(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_o = getfromclosure(closure, 1);
  Object *var_terms = getfromclosure(closure, 2);
  Object *var_tmp2 = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1663
  setline(1663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5294 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ops (depth = 6)
  Object call5295 = callmethodflags(*var_ops, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5294);
// compiled member node returning call5295 (depth = 5)
  *var_o = call5295;
  if (call5295 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1664
  setline(1664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5297 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_terms (depth = 6)
  Object call5298 = callmethodflags(*var_terms, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5297);
// compiled member node returning call5298 (depth = 5)
  *var_tmp2 = call5298;
  if (call5298 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1665
  setline(1665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5300 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_terms (depth = 6)
  Object call5301 = callmethodflags(*var_terms, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5300);
// compiled member node returning call5301 (depth = 5)
  *var_tmp = call5301;
  if (call5301 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5303 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5304 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  Object call5305 = callmethodflags(*var_tmp, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5304);
// compiled member node returning call5305 (depth = 5)
  gc_frame_newslot(call5305);
// starting to compile member node (depth = 5)
  int callframe5306 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  Object call5307 = callmethodflags(*var_tmp, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5306);
// compiled member node returning call5307 (depth = 5)
  gc_frame_newslot(call5307);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call5305;
  params[1] = call5307;
  partcv[0] = 2;
  Object call5308 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5303);
// compiled call node returning call5308 (depth = 4)
// Begin line 1667
  setline(1667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5309 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  gc_frame_newslot(*var_tmp);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp2 (depth = 6)
  gc_frame_newslot(*var_tmp2);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5310 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call5311 = callmethodflags(*var_ast, "opNode", 0, partcv, params, 0);
  gc_frame_end(callframe5310);
// compiled member node returning call5311 (depth = 6)
  params[0] = *var_o;
  params[1] = *var_tmp;
  params[2] = *var_tmp2;
  partcv[0] = 3;
  Object call5312 = callmethodflags(call5311, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe5309);
// compiled call node returning call5312 (depth = 5)
  *var_tmp = call5312;
  if (call5312 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1668
  setline(1668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5314 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tmp (depth = 5)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5315 = callmethodflags(*var_terms, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5314);
// compiled call node returning call5315 (depth = 4)
  gc_frame_end(frame);
  return call5315;
}
Object meth_parser_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_4826(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(14, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expressionrest(1)recursingWith(1)blocks(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expressionrest(_)recursingWith(_)blocks(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expressionrest(_)recursingWith(_)blocks(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expressionrest(_)recursingWith(_)blocks(_)");
  Object params[3];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for expressionrest(_)recursingWith(_)blocks(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part expressionrest(_)");
  Object *var_recurse = &(stackframe->slots[1]);
  *var_recurse = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part recursingWith(_)");
  Object *var_acceptBlocks = &(stackframe->slots[2]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part blocks(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_terms = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "terms");
  Object *var_ops = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "ops");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
  Object *var_o2 = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "o2");
  Object *var_tmp2 = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "tmp2");
  Object *var_tmp = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "tmp");
  Object *var_prec = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "prec");
  Object *var_allarith = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "allarith");
  Object *var_opcount = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "opcount");
  Object *var_opdtype = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "opdtype");
// Begin line 1539
  setline(1539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array4827 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4827 (depth = 3)
  *var_terms = array4827;
  if (array4827 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1540
  setline(1540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array4828 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4828 (depth = 3)
  *var_ops = array4828;
  if (array4828 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1541
  setline(1541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_o = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1542
  setline(1542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_o2 = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1543
  setline(1543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_tmp2 = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1544
  setline(1544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4829 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  Object call4830 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe4829);
// compiled member node returning call4830 (depth = 3)
  *var_tmp = call4830;
  if (call4830 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1545
  setline(1545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4831 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tmp (depth = 3)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_terms (depth = 3)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call4832 = callmethodflags(*var_terms, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4831);
// compiled call node returning call4832 (depth = 2)
// Begin line 1546
  setline(1546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_prec = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1547
  setline(1547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool4833 = alloc_Boolean(1);
// compiled identifier node returning bool4833 (depth = 3)
  *var_allarith = bool4833;
  if (bool4833 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1548
  setline(1548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num4834 = alloc_Float64(0);
// compiled num node returning num4834 (depth = 3)
  *var_opcount = num4834;
  if (num4834 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1549
  setline(1549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4835 == NULL) {
    strlit4835 = alloc_String("");
    gc_root(strlit4835);
  }
// compiled string node returning strlit4835 (depth = 3)
  *var_opdtype = strlit4835;
  if (strlit4835 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4836 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4837 = alloc_Block(NULL, NULL, "parser", 1550);
  gc_frame_newslot(block4837);
// method "_apply"
  block_savedest(block4837);
  Object closure4838 = createclosure(3, "_apply");
  setclosureframe(closure4838, stackframe);
  addtoclosure(closure4838, var_sym);
  addtoclosure(closure4838, var_statementToken);
  addtoclosure(closure4838, selfslot);
  struct UserObject *uo4838 = (struct UserObject*)block4837;
  uo4838->data[0] = (Object)closure4838;
  Method *meth_meth_parser__apply4838 = addmethod2pos(block4837, "_apply", &meth_parser__apply4838, 0);
  int argcv_meth_parser__apply4838[] = {0};
  meth_meth_parser__apply4838->type = alloc_MethodType(1, argcv_meth_parser__apply4838);
  meth_meth_parser__apply4838->definitionModule = modulename;
  meth_meth_parser__apply4838->definitionLine = 3399;
// compiled block node returning block4837 (depth = 3)
  gc_frame_newslot(block4837);
// Begin line 1551
  setline(1551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4855 = alloc_Block(NULL, NULL, "parser", 1551);
  gc_frame_newslot(block4855);
// method "_apply"
  block_savedest(block4855);
  Object closure4856 = createclosure(20, "_apply");
  setclosureframe(closure4856, stackframe);
  addtoclosure(closure4856, var_opcount);
  addtoclosure(closure4856, var_sym);
  addtoclosure(closure4856, var_o);
  addtoclosure(closure4856, var_prec);
  addtoclosure(closure4856, var_allarith);
  addtoclosure(closure4856, var_opdtype);
  addtoclosure(closure4856, var_errormessages);
  addtoclosure(closure4856, var_lastToken);
  addtoclosure(closure4856, var_ops);
  addtoclosure(closure4856, var_o2);
  addtoclosure(closure4856, var_terms);
  addtoclosure(closure4856, var_tmp2);
  addtoclosure(closure4856, var_tmp);
  addtoclosure(closure4856, var_util);
  addtoclosure(closure4856, var_ast);
  addtoclosure(closure4856, var_recurse);
  addtoclosure(closure4856, var_name);
  addtoclosure(closure4856, var_acceptBlocks);
  addtoclosure(closure4856, var_values);
  addtoclosure(closure4856, selfslot);
  struct UserObject *uo4856 = (struct UserObject*)block4855;
  uo4856->data[0] = (Object)closure4856;
  Method *meth_meth_parser__apply4856 = addmethod2pos(block4855, "_apply", &meth_parser__apply4856, 0);
  int argcv_meth_parser__apply4856[] = {0};
  meth_meth_parser__apply4856->type = alloc_MethodType(1, argcv_meth_parser__apply4856);
  meth_meth_parser__apply4856->definitionModule = modulename;
  meth_meth_parser__apply4856->definitionLine = 3399;
// compiled block node returning block4855 (depth = 3)
  gc_frame_newslot(block4855);
// call case 5: prelude request
  params[0] = block4837;
  params[1] = block4855;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5281 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4836);
// compiled call node returning call5281 (depth = 2)
// Begin line 1661
  setline(1661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5282 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5283 = alloc_Block(NULL, NULL, "parser", 1661);
  gc_frame_newslot(block5283);
// method "_apply"
  block_savedest(block5283);
  Object closure5284 = createclosure(2, "_apply");
  setclosureframe(closure5284, stackframe);
  addtoclosure(closure5284, var_ops);
  addtoclosure(closure5284, selfslot);
  struct UserObject *uo5284 = (struct UserObject*)block5283;
  uo5284->data[0] = (Object)closure5284;
  Method *meth_meth_parser__apply5284 = addmethod2pos(block5283, "_apply", &meth_parser__apply5284, 0);
  int argcv_meth_parser__apply5284[] = {0};
  meth_meth_parser__apply5284->type = alloc_MethodType(1, argcv_meth_parser__apply5284);
  meth_meth_parser__apply5284->definitionModule = modulename;
  meth_meth_parser__apply5284->definitionLine = 3399;
// compiled block node returning block5283 (depth = 3)
  gc_frame_newslot(block5283);
// starting to compile block node (depth = 3)
  Object block5292 = alloc_Block(NULL, NULL, "parser", 1661);
  gc_frame_newslot(block5292);
// method "_apply"
  block_savedest(block5292);
  Object closure5293 = createclosure(8, "_apply");
  setclosureframe(closure5293, stackframe);
  addtoclosure(closure5293, var_ops);
  addtoclosure(closure5293, var_o);
  addtoclosure(closure5293, var_terms);
  addtoclosure(closure5293, var_tmp2);
  addtoclosure(closure5293, var_tmp);
  addtoclosure(closure5293, var_util);
  addtoclosure(closure5293, var_ast);
  addtoclosure(closure5293, selfslot);
  struct UserObject *uo5293 = (struct UserObject*)block5292;
  uo5293->data[0] = (Object)closure5293;
  Method *meth_meth_parser__apply5293 = addmethod2pos(block5292, "_apply", &meth_parser__apply5293, 0);
  int argcv_meth_parser__apply5293[] = {0};
  meth_meth_parser__apply5293->type = alloc_MethodType(1, argcv_meth_parser__apply5293);
  meth_meth_parser__apply5293->definitionModule = modulename;
  meth_meth_parser__apply5293->definitionLine = 3399;
// compiled block node returning block5292 (depth = 3)
  gc_frame_newslot(block5292);
// call case 5: prelude request
  params[0] = block5283;
  params[1] = block5292;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5317 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5282);
// compiled call node returning call5317 (depth = 2)
// Begin line 1670
  setline(1670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5318 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_terms (depth = 4)
  Object call5319 = callmethodflags(*var_terms, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5318);
// compiled member node returning call5319 (depth = 3)
  *var_tmp = call5319;
  if (call5319 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 1671
  setline(1671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5321 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tmp (depth = 3)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5322 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5321);
// compiled call node returning call5322 (depth = 2)
// Begin line 1672
  setline(1672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5325 = alloc_Float64(0);
// compiled num node returning num5325 (depth = 4)
  int op_slot_right_5324 = gc_frame_newslot(num5325);
// starting to compile member node (depth = 4)
  int callframe5327 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  Object call5328 = callmethodflags(*var_terms, "size", 0, partcv, params, 0);
  gc_frame_end(callframe5327);
// compiled member node returning call5328 (depth = 4)
  int op_slot_left_5324 = gc_frame_newslot(call5328);
  params[0] = num5325;
  partcv[0] = 1;
  Object opresult5329 = callmethod(call5328, ">(1)", 1, partcv, params);
// compiled op node returning opresult5329 (depth = 3)
  Object if5323 = done;
  if (istrue(opresult5329)) {
// Begin line 1673
  setline(1673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5330 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5331 == NULL) {
    strlit5331 = alloc_String("values left on term stack.");
    gc_root(strlit5331);
  }
// compiled string node returning strlit5331 (depth = 4)
  gc_frame_newslot(strlit5331);
// starting to compile member node (depth = 4)
  int callframe5332 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call5333 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5332);
// compiled member node returning call5333 (depth = 4)
  gc_frame_newslot(call5333);
// starting to compile member node (depth = 4)
  int callframe5334 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call5335 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5334);
// compiled member node returning call5335 (depth = 4)
  gc_frame_newslot(call5335);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit5331;
  params[1] = call5333;
  params[2] = call5335;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call5336 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe5330);
// compiled call node returning call5336 (depth = 3)
    gc_frame_newslot(call5336);
    if5323 = call5336;
  } else {
  }
// compiled if node returning if5323 (depth = 2)
  gc_frame_end(frame);
  return if5323;
}
Object meth_parser_dotrest_40_1_41_5337(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 43, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotrest(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method dotrest(_)");
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for dotrest(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part dotrest(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_lookuptarget = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "lookuptarget");
  Object *var_dro = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "dro");
  Object *var_suggestions = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestions");
  Object *var_suggestion = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestion");
// Begin line 1681
  setline(1681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5339 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5340 == NULL) {
    strlit5340 = alloc_String("dot");
    gc_root(strlit5340);
  }
// compiled string node returning strlit5340 (depth = 4)
  gc_frame_newslot(strlit5340);
// call case 4: self request
  params[0] = strlit5340;
  partcv[0] = 1;
  Object call5341 = callmethodflags(self, "acceptSameLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5339);
// compiled call node returning call5341 (depth = 3)
  Object if5338 = done;
  if (istrue(call5341)) {
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5342 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5343 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call5344 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5343);
// compiled member node returning call5344 (depth = 4)
  gc_frame_newslot(call5344);
// starting to compile member node (depth = 4)
  int callframe5345 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call5346 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5345);
// compiled member node returning call5346 (depth = 4)
  gc_frame_newslot(call5346);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call5344;
  params[1] = call5346;
  partcv[0] = 2;
  Object call5347 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5342);
// compiled call node returning call5347 (depth = 3)
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5348 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call5349 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5348);
// compiled member node returning call5349 (depth = 4)
  *var_lookuptarget = call5349;
  if (call5349 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1684
  setline(1684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5350 = gc_frame_new();
// call case 4: self request
  Object call5351 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5350);
// compiled member node returning call5351 (depth = 3)
// Begin line 1685
  setline(1685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5353 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5354 == NULL) {
    strlit5354 = alloc_String("identifier");
    gc_root(strlit5354);
  }
// compiled string node returning strlit5354 (depth = 5)
  gc_frame_newslot(strlit5354);
// call case 4: self request
  params[0] = strlit5354;
  partcv[0] = 1;
  Object call5355 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5353);
// compiled call node returning call5355 (depth = 4)
  Object if5352 = done;
  if (istrue(call5355)) {
// Begin line 1686
  setline(1686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5356 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5357 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call5358 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5357);
// compiled member node returning call5358 (depth = 5)
  gc_frame_newslot(call5358);
// starting to compile member node (depth = 5)
  int callframe5359 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call5360 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5359);
// compiled member node returning call5360 (depth = 5)
  gc_frame_newslot(call5360);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call5358;
  params[1] = call5360;
  partcv[0] = 2;
  Object call5361 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5356);
// compiled call node returning call5361 (depth = 4)
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5362 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5363 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call5364 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe5363);
// compiled member node returning call5364 (depth = 6)
  gc_frame_newslot(call5364);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lookuptarget (depth = 6)
  gc_frame_newslot(*var_lookuptarget);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5365 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call5366 = callmethodflags(*var_ast, "memberNode", 0, partcv, params, 0);
  gc_frame_end(callframe5365);
// compiled member node returning call5366 (depth = 6)
  params[0] = call5364;
  params[1] = *var_lookuptarget;
  partcv[0] = 2;
  Object call5367 = callmethodflags(call5366, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5362);
// compiled call node returning call5367 (depth = 5)
  *var_dro = call5367;
  if (call5367 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5368 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dro (depth = 5)
  gc_frame_newslot(*var_dro);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_dro;
  partcv[0] = 1;
  Object call5369 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5368);
// compiled call node returning call5369 (depth = 4)
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5370 = gc_frame_new();
// call case 4: self request
  Object call5371 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5370);
// compiled member node returning call5371 (depth = 4)
// Begin line 1690
  setline(1690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5373 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5374 == NULL) {
    strlit5374 = alloc_String("dot");
    gc_root(strlit5374);
  }
// compiled string node returning strlit5374 (depth = 6)
  gc_frame_newslot(strlit5374);
// call case 4: self request
  params[0] = strlit5374;
  partcv[0] = 1;
  Object call5375 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5373);
// compiled call node returning call5375 (depth = 5)
  Object if5372 = done;
  if (istrue(call5375)) {
// Begin line 1691
  setline(1691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5376 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acceptBlocks (depth = 6)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5377 = callmethodflags(self, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5376);
// compiled call node returning call5377 (depth = 5)
    gc_frame_newslot(call5377);
    if5372 = call5377;
  } else {
// Begin line 1697
  setline(1697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 1694
  setline(1694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5380 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5381 == NULL) {
    strlit5381 = alloc_String("lgeneric");
    gc_root(strlit5381);
  }
// compiled string node returning strlit5381 (depth = 8)
  gc_frame_newslot(strlit5381);
// call case 4: self request
  params[0] = strlit5381;
  partcv[0] = 1;
  Object call5382 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5380);
// compiled call node returning call5382 (depth = 7)
  int op_slot_right_5379 = gc_frame_newslot(call5382);
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 1693
  setline(1693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5385 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit5386 == NULL) {
    strlit5386 = alloc_String("lsquare");
    gc_root(strlit5386);
  }
// compiled string node returning strlit5386 (depth = 9)
  gc_frame_newslot(strlit5386);
// call case 4: self request
  params[0] = strlit5386;
  partcv[0] = 1;
  Object call5387 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5385);
// compiled call node returning call5387 (depth = 8)
  int op_slot_right_5384 = gc_frame_newslot(call5387);
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 1693
  setline(1693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe5390 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit5391 == NULL) {
    strlit5391 = alloc_String("string");
    gc_root(strlit5391);
  }
// compiled string node returning strlit5391 (depth = 10)
  gc_frame_newslot(strlit5391);
// call case 4: self request
  params[0] = strlit5391;
  partcv[0] = 1;
  Object call5392 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5390);
// compiled call node returning call5392 (depth = 9)
  int op_slot_right_5389 = gc_frame_newslot(call5392);
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// Begin line 1693
  setline(1693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe5395 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit5396 == NULL) {
    strlit5396 = alloc_String("num");
    gc_root(strlit5396);
  }
// compiled string node returning strlit5396 (depth = 11)
  gc_frame_newslot(strlit5396);
// call case 4: self request
  params[0] = strlit5396;
  partcv[0] = 1;
  Object call5397 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5395);
// compiled call node returning call5397 (depth = 10)
  int op_slot_right_5394 = gc_frame_newslot(call5397);
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5401 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit5402 == NULL) {
    strlit5402 = alloc_String("lbrace");
    gc_root(strlit5402);
  }
// compiled string node returning strlit5402 (depth = 13)
  gc_frame_newslot(strlit5402);
// call case 4: self request
  params[0] = strlit5402;
  partcv[0] = 1;
  Object call5403 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5401);
// compiled call node returning call5403 (depth = 12)
  int op_slot_right_5400 = gc_frame_newslot(call5403);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_acceptBlocks (depth = 12)
  int op_slot_left_5400 = gc_frame_newslot(*var_acceptBlocks);
  params[0] = call5403;
  partcv[0] = 1;
  Object opresult5405 = callmethod(*var_acceptBlocks, "&&(1)", 1, partcv, params);
// compiled op node returning opresult5405 (depth = 11)
  int op_slot_right_5399 = gc_frame_newslot(opresult5405);
// starting to compile call node (depth = 11)
  int callframe5407 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit5408 == NULL) {
    strlit5408 = alloc_String("lparen");
    gc_root(strlit5408);
  }
// compiled string node returning strlit5408 (depth = 12)
  gc_frame_newslot(strlit5408);
// call case 4: self request
  params[0] = strlit5408;
  partcv[0] = 1;
  Object call5409 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5407);
// compiled call node returning call5409 (depth = 11)
  int op_slot_left_5399 = gc_frame_newslot(call5409);
  params[0] = opresult5405;
  partcv[0] = 1;
  Object opresult5410 = callmethod(call5409, "||(1)", 1, partcv, params);
// compiled op node returning opresult5410 (depth = 10)
  int op_slot_left_5394 = gc_frame_newslot(opresult5410);
  params[0] = call5397;
  partcv[0] = 1;
  Object opresult5411 = callmethod(opresult5410, "||(1)", 1, partcv, params);
// compiled op node returning opresult5411 (depth = 9)
  int op_slot_left_5389 = gc_frame_newslot(opresult5411);
  params[0] = call5392;
  partcv[0] = 1;
  Object opresult5412 = callmethod(opresult5411, "||(1)", 1, partcv, params);
// compiled op node returning opresult5412 (depth = 8)
  int op_slot_left_5384 = gc_frame_newslot(opresult5412);
  params[0] = call5387;
  partcv[0] = 1;
  Object opresult5413 = callmethod(opresult5412, "||(1)", 1, partcv, params);
// compiled op node returning opresult5413 (depth = 7)
  int op_slot_left_5379 = gc_frame_newslot(opresult5413);
  params[0] = call5382;
  partcv[0] = 1;
  Object opresult5414 = callmethod(opresult5413, "||(1)", 1, partcv, params);
// compiled op node returning opresult5414 (depth = 6)
  Object if5378 = done;
  if (istrue(opresult5414)) {
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5415 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_acceptBlocks (depth = 7)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5416 = callmethodflags(self, "callrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5415);
// compiled call node returning call5416 (depth = 6)
    gc_frame_newslot(call5416);
    if5378 = call5416;
  } else {
  }
// compiled if node returning if5378 (depth = 5)
    gc_frame_newslot(if5378);
    if5372 = if5378;
  }
// compiled if node returning if5372 (depth = 4)
    gc_frame_newslot(if5372);
    if5352 = if5372;
  } else {
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array5417 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5417 (depth = 5)
  *var_suggestions = array5417;
  if (array5417 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1699
  setline(1699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5418 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5419 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call5420 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5419);
// compiled member node returning call5420 (depth = 6)
  Object call5421 = callmethodflags(call5420, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5418);
// compiled member node returning call5421 (depth = 5)
  *var_suggestion = call5421;
  if (call5421 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1700
  setline(1700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5422 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call5423 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5422);
// compiled call node returning call5423 (depth = 4)
// Begin line 1701
  setline(1701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5424 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5425 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5424);
// compiled call node returning call5425 (depth = 4)
// Begin line 1702
  setline(1702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5426 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5427 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call5428 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5427);
// compiled member node returning call5428 (depth = 6)
  Object call5429 = callmethodflags(call5428, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5426);
// compiled member node returning call5429 (depth = 5)
  *var_suggestion = call5429;
  if (call5429 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5431 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5432 == NULL) {
    strlit5432 = alloc_String("""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit5432);
  }
// compiled string node returning strlit5432 (depth = 5)
  gc_frame_newslot(strlit5432);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit5432;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5433 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5431);
// compiled call node returning call5433 (depth = 4)
// Begin line 1704
  setline(1704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5434 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5435 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5434);
// compiled call node returning call5435 (depth = 4)
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5436 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5437 == NULL) {
    strlit5437 = alloc_String("a field or method name must follow a '.'.");
    gc_root(strlit5437);
  }
// compiled string node returning strlit5437 (depth = 5)
  gc_frame_newslot(strlit5437);
// Begin line 1706
  setline(1706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5438 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call5439 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5438);
// compiled member node returning call5439 (depth = 5)
  gc_frame_newslot(call5439);
// starting to compile member node (depth = 5)
  int callframe5440 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call5441 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5440);
// compiled member node returning call5441 (depth = 5)
  gc_frame_newslot(call5441);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit5437;
  params[1] = call5439;
  params[2] = call5441;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5442 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5436);
// compiled call node returning call5442 (depth = 4)
    gc_frame_newslot(call5442);
    if5352 = call5442;
  }
// compiled if node returning if5352 (depth = 3)
    gc_frame_newslot(if5352);
    if5338 = if5352;
  } else {
  }
// compiled if node returning if5338 (depth = 2)
  gc_frame_end(frame);
  return if5338;
}
Object meth_parser__apply5521(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe5522 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5523 == NULL) {
    strlit5523 = alloc_String("lbrace");
    gc_root(strlit5523);
  }
// compiled string node returning strlit5523 (depth = 7)
  gc_frame_newslot(strlit5523);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit5523;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5524 = callmethodflags(self, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5522);
// compiled call node returning call5524 (depth = 6)
  gc_frame_end(frame);
  return call5524;
}
Object meth_parser__apply5568(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_root = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5570 == NULL) {
    strlit5570 = alloc_String("member");
    gc_root(strlit5570);
  }
// compiled string node returning strlit5570 (depth = 10)
  int op_slot_right_5569 = gc_frame_newslot(strlit5570);
// starting to compile member node (depth = 10)
  int callframe5572 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_root (depth = 11)
  Object call5573 = callmethodflags(*var_root, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5572);
// compiled member node returning call5573 (depth = 10)
  int op_slot_left_5569 = gc_frame_newslot(call5573);
  params[0] = strlit5570;
  partcv[0] = 1;
  Object opresult5574 = callmethod(call5573, "==(1)", 1, partcv, params);
// compiled op node returning opresult5574 (depth = 9)
  gc_frame_end(frame);
  return opresult5574;
}
Object meth_parser__apply5577(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_root = getfromclosure(closure, 0);
  Object *var_outroot = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 9)
// Begin line 1762
  setline(1762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_root (depth = 10)
  *var_outroot = *var_root;
  if (*var_root == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 9)
// Begin line 1763
  setline(1763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe5579 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_root (depth = 11)
  Object call5580 = callmethodflags(*var_root, "receiver", 0, partcv, params, 0);
  gc_frame_end(callframe5579);
// compiled member node returning call5580 (depth = 10)
  *var_root = call5580;
  if (call5580 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 9)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_callrest_40_1_41_5443(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 44, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callrest(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method callrest(_)");
  Object params[3];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_minIndentLevel = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for callrest(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part callrest(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_meth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "meth");
  Object *var_lnum = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "lnum");
  Object *var_lpos = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "lpos");
  Object *var_methn = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "methn");
  Object *var_btok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "btok");
  Object *var_signature = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "signature");
  Object *var_part = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "part");
  Object *var_hadcall = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "hadcall");
  Object *var_tok = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "tok");
  Object *var_startInd = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "startInd");
  Object *var_genericIdents = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "genericIdents");
  Object *var_ar = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "ar");
  Object *var_root = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "root");
  Object *var_outroot = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "outroot");
  Object *var_meth_39_ = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "meth'");
  Object *var_call = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "call");
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5446 = alloc_Float64(0);
// compiled num node returning num5446 (depth = 4)
  int op_slot_right_5445 = gc_frame_newslot(num5446);
// starting to compile member node (depth = 4)
  int callframe5448 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call5449 = callmethodflags(*var_values, "size", 0, partcv, params, 0);
  gc_frame_end(callframe5448);
// compiled member node returning call5449 (depth = 4)
  int op_slot_left_5445 = gc_frame_newslot(call5449);
  params[0] = num5446;
  partcv[0] = 1;
  Object opresult5450 = callmethod(call5449, "==(1)", 1, partcv, params);
// compiled op node returning opresult5450 (depth = 3)
  Object if5444 = done;
  if (istrue(opresult5450)) {
// Begin line 1716
  setline(1716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5451 = alloc_Float64(0);
// compiled num node returning num5451 (depth = 4)
  return num5451;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if5444 = undefined;
  } else {
  }
// compiled if node returning if5444 (depth = 2)
// Begin line 1718
  setline(1718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5452 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  Object call5453 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5452);
// compiled member node returning call5453 (depth = 3)
  *var_meth = call5453;
  if (call5453 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5456 == NULL) {
    strlit5456 = alloc_String("identifier");
    gc_root(strlit5456);
  }
// compiled string node returning strlit5456 (depth = 4)
  int op_slot_right_5455 = gc_frame_newslot(strlit5456);
// starting to compile member node (depth = 4)
  int callframe5458 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  Object call5459 = callmethodflags(*var_meth, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5458);
// compiled member node returning call5459 (depth = 4)
  int op_slot_left_5455 = gc_frame_newslot(call5459);
  params[0] = strlit5456;
  partcv[0] = 1;
  Object opresult5460 = callmethod(call5459, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5460 (depth = 3)
  Object if5454 = done;
  if (istrue(opresult5460)) {
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5463 == NULL) {
    strlit5463 = alloc_String("member");
    gc_root(strlit5463);
  }
// compiled string node returning strlit5463 (depth = 5)
  int op_slot_right_5462 = gc_frame_newslot(strlit5463);
// starting to compile member node (depth = 5)
  int callframe5465 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  Object call5466 = callmethodflags(*var_meth, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5465);
// compiled member node returning call5466 (depth = 5)
  int op_slot_left_5462 = gc_frame_newslot(call5466);
  params[0] = strlit5463;
  partcv[0] = 1;
  Object opresult5467 = callmethod(call5466, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5467 (depth = 4)
  Object if5461 = done;
  if (istrue(opresult5467)) {
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5468 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5469 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5468);
// compiled call node returning call5469 (depth = 4)
// Begin line 1722
  setline(1722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5470 = alloc_Float64(0);
// compiled num node returning num5470 (depth = 5)
  return num5470;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if5461 = undefined;
  } else {
  }
// compiled if node returning if5461 (depth = 3)
    gc_frame_newslot(if5461);
    if5454 = if5461;
  } else {
  }
// compiled if node returning if5454 (depth = 2)
// Begin line 1725
  setline(1725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5471 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  Object call5472 = callmethodflags(*var_meth, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5471);
// compiled member node returning call5472 (depth = 3)
  *var_lnum = call5472;
  if (call5472 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5473 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  Object call5474 = callmethodflags(*var_meth, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5473);
// compiled member node returning call5474 (depth = 3)
  *var_lpos = call5474;
  if (call5474 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1727
  setline(1727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5475 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  Object call5476 = callmethodflags(*var_meth, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe5475);
// compiled member node returning call5476 (depth = 3)
  *var_methn = call5476;
  if (call5476 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5477 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe5478 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call5479 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5478);
// compiled member node returning call5479 (depth = 3)
  gc_frame_newslot(call5479);
// starting to compile member node (depth = 3)
  int callframe5480 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call5481 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5480);
// compiled member node returning call5481 (depth = 3)
  gc_frame_newslot(call5481);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call5479;
  params[1] = call5481;
  partcv[0] = 2;
  Object call5482 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5477);
// compiled call node returning call5482 (depth = 2)
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array5483 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5483 (depth = 3)
  *var_signature = array5483;
  if (array5483 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5484 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5485 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call5486 = callmethodflags(*var_ast, "requestPart", 0, partcv, params, 0);
  gc_frame_end(callframe5485);
// compiled member node returning call5486 (depth = 4)
  Object call5487 = callmethodflags(call5486, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5484);
// compiled member node returning call5487 (depth = 3)
  *var_part = call5487;
  if (call5487 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1732
  setline(1732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5488 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  gc_frame_newslot(*var_part);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature (depth = 3)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call5489 = callmethodflags(*var_signature, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5488);
// compiled call node returning call5489 (depth = 2)
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool5490 = alloc_Boolean(0);
// compiled identifier node returning bool5490 (depth = 3)
  *var_hadcall = bool5490;
  if (bool5490 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1734
  setline(1734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  *var_tok = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1735
  setline(1735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_startInd = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1736
  setline(1736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool5491 = alloc_Boolean(0);
// compiled identifier node returning bool5491 (depth = 3)
  *var_genericIdents = bool5491;
  if (bool5491 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5493 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5494 == NULL) {
    strlit5494 = alloc_String("lgeneric");
    gc_root(strlit5494);
  }
// compiled string node returning strlit5494 (depth = 4)
  gc_frame_newslot(strlit5494);
// call case 4: self request
  params[0] = strlit5494;
  partcv[0] = 1;
  Object call5495 = callmethodflags(self, "acceptSameLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5493);
// compiled call node returning call5495 (depth = 3)
  Object if5492 = done;
  if (istrue(call5495)) {
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5496 = gc_frame_new();
// call case 4: self request
  Object call5497 = callmethodflags(self, "typeArgs", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5496);
// compiled member node returning call5497 (depth = 4)
  *var_genericIdents = call5497;
  if (call5497 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if5492 = done;
  } else {
  }
// compiled if node returning if5492 (depth = 2)
// Begin line 1740
  setline(1740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5500 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5501 == NULL) {
    strlit5501 = alloc_String("lparen");
    gc_root(strlit5501);
  }
// compiled string node returning strlit5501 (depth = 4)
  gc_frame_newslot(strlit5501);
// call case 4: self request
  params[0] = strlit5501;
  partcv[0] = 1;
  Object call5502 = callmethodflags(self, "acceptSameLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5500);
// compiled call node returning call5502 (depth = 3)
  Object if5499 = done;
  if (istrue(call5502)) {
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5503 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5504 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call5505 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5504);
// compiled member node returning call5505 (depth = 4)
  gc_frame_newslot(call5505);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = call5505;
  partcv[0] = 1;
  Object call5506 = callmethodflags(*var_part, "line:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5503);
// compiled call node returning call5506 (depth = 3)
// Begin line 1742
  setline(1742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5507 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5508 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call5509 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5508);
// compiled member node returning call5509 (depth = 4)
  gc_frame_newslot(call5509);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = call5509;
  partcv[0] = 1;
  Object call5510 = callmethodflags(*var_part, "linePos:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5507);
// compiled call node returning call5510 (depth = 3)
// Begin line 1743
  setline(1743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5511 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methn (depth = 4)
  gc_frame_newslot(*var_methn);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = *var_methn;
  partcv[0] = 1;
  Object call5512 = callmethodflags(*var_part, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5511);
// compiled call node returning call5512 (depth = 3)
// Begin line 1744
  setline(1744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1745
  setline(1745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool5514 = alloc_Boolean(1);
// compiled identifier node returning bool5514 (depth = 4)
  *var_hadcall = bool5514;
  if (bool5514 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1746
  setline(1746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5516 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  gc_frame_newslot(*var_part);
// call case 4: self request
  params[0] = *var_part;
  partcv[0] = 1;
  Object call5517 = callmethodflags(self, "parenthesizedArg(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5516);
// compiled call node returning call5517 (depth = 3)
    gc_frame_newslot(call5517);
    if5499 = call5517;
  } else {
// Begin line 1749
  setline(1749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1747
  setline(1747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block5520 = alloc_Block(NULL, NULL, "parser", 1747);
  gc_frame_newslot(block5520);
// method "_apply"
  block_savedest(block5520);
  Object closure5521 = createclosure(2, "_apply");
  setclosureframe(closure5521, stackframe);
  addtoclosure(closure5521, var_tok);
  addtoclosure(closure5521, selfslot);
  struct UserObject *uo5521 = (struct UserObject*)block5520;
  uo5521->data[0] = (Object)closure5521;
  Method *meth_meth_parser__apply5521 = addmethod2pos(block5520, "_apply", &meth_parser__apply5521, 0);
  int argcv_meth_parser__apply5521[] = {0};
  meth_meth_parser__apply5521->type = alloc_MethodType(1, argcv_meth_parser__apply5521);
  meth_meth_parser__apply5521->definitionModule = modulename;
  meth_meth_parser__apply5521->definitionLine = 3399;
// compiled block node returning block5520 (depth = 5)
  int op_slot_right_5519 = gc_frame_newslot(block5520);
// starting to compile member node (depth = 5)
  int callframe5527 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acceptBlocks (depth = 6)
  Object call5528 = callmethodflags(*var_acceptBlocks, "not", 0, partcv, params, 0);
  gc_frame_end(callframe5527);
// compiled member node returning call5528 (depth = 5)
  int op_slot_left_5519 = gc_frame_newslot(call5528);
  params[0] = block5520;
  partcv[0] = 1;
  Object opresult5529 = callmethod(call5528, "&&(1)", 1, partcv, params);
// compiled op node returning opresult5529 (depth = 4)
  Object if5518 = done;
  if (istrue(opresult5529)) {
// Begin line 1748
  setline(1748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5530 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5531 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5530);
// compiled call node returning call5531 (depth = 4)
    gc_frame_newslot(call5531);
    if5518 = call5531;
  } else {
// Begin line 1756
  setline(1756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1749
  setline(1749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5533 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call5534 = callmethodflags(self, "acceptArgumentOnLineOf(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5533);
// compiled call node returning call5534 (depth = 5)
  Object if5532 = done;
  if (istrue(call5534)) {
// Begin line 1750
  setline(1750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5536 = alloc_Boolean(1);
// compiled identifier node returning bool5536 (depth = 6)
  *var_hadcall = bool5536;
  if (bool5536 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1752
  setline(1752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5538 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methn (depth = 6)
  gc_frame_newslot(*var_methn);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  params[0] = *var_methn;
  partcv[0] = 1;
  Object call5539 = callmethodflags(*var_part, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5538);
// compiled call node returning call5539 (depth = 5)
// Begin line 1753
  setline(1753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5540 = gc_frame_new();
// call case 4: self request
  Object call5541 = callmethodflags(self, "term", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5540);
// compiled member node returning call5541 (depth = 5)
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5542 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call5543 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5542);
// compiled member node returning call5543 (depth = 6)
  *var_ar = call5543;
  if (call5543 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5544 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ar (depth = 6)
  gc_frame_newslot(*var_ar);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5545 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call5546 = callmethodflags(*var_part, "args", 0, partcv, params, 0);
  gc_frame_end(callframe5545);
// compiled member node returning call5546 (depth = 6)
  params[0] = *var_ar;
  partcv[0] = 1;
  Object call5547 = callmethodflags(call5546, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5544);
// compiled call node returning call5547 (depth = 5)
    gc_frame_newslot(call5547);
    if5532 = call5547;
  } else {
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1756
  setline(1756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5550 == NULL) {
    strlit5550 = alloc_String("identifier");
    gc_root(strlit5550);
  }
// compiled string node returning strlit5550 (depth = 7)
  int op_slot_right_5549 = gc_frame_newslot(strlit5550);
// starting to compile member node (depth = 7)
  int callframe5552 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  Object call5553 = callmethodflags(*var_meth, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5552);
// compiled member node returning call5553 (depth = 7)
  int op_slot_left_5549 = gc_frame_newslot(call5553);
  params[0] = strlit5550;
  partcv[0] = 1;
  Object opresult5554 = callmethod(call5553, "==(1)", 1, partcv, params);
// compiled op node returning opresult5554 (depth = 6)
  Object if5548 = done;
  if (istrue(opresult5554)) {
// Begin line 1757
  setline(1757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5555 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  gc_frame_newslot(*var_meth);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5556 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5555);
// compiled call node returning call5556 (depth = 6)
    gc_frame_newslot(call5556);
    if5548 = call5556;
  } else {
// Begin line 1772
  setline(1772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5559 == NULL) {
    strlit5559 = alloc_String("member");
    gc_root(strlit5559);
  }
// compiled string node returning strlit5559 (depth = 8)
  int op_slot_right_5558 = gc_frame_newslot(strlit5559);
// starting to compile member node (depth = 8)
  int callframe5561 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  Object call5562 = callmethodflags(*var_meth, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5561);
// compiled member node returning call5562 (depth = 8)
  int op_slot_left_5558 = gc_frame_newslot(call5562);
  params[0] = strlit5559;
  partcv[0] = 1;
  Object opresult5563 = callmethod(call5562, "==(1)", 1, partcv, params);
// compiled op node returning opresult5563 (depth = 7)
  Object if5557 = done;
  if (istrue(opresult5563)) {
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe5564 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  Object call5565 = callmethodflags(*var_meth, "receiver", 0, partcv, params, 0);
  gc_frame_end(callframe5564);
// compiled member node returning call5565 (depth = 8)
  *var_root = call5565;
  if (call5565 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  *var_outroot = *var_meth;
  if (*var_meth == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 1761
  setline(1761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5566 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block5567 = alloc_Block(NULL, NULL, "parser", 1761);
  gc_frame_newslot(block5567);
// method "_apply"
  block_savedest(block5567);
  Object closure5568 = createclosure(2, "_apply");
  setclosureframe(closure5568, stackframe);
  addtoclosure(closure5568, var_root);
  addtoclosure(closure5568, selfslot);
  struct UserObject *uo5568 = (struct UserObject*)block5567;
  uo5568->data[0] = (Object)closure5568;
  Method *meth_meth_parser__apply5568 = addmethod2pos(block5567, "_apply", &meth_parser__apply5568, 0);
  int argcv_meth_parser__apply5568[] = {0};
  meth_meth_parser__apply5568->type = alloc_MethodType(1, argcv_meth_parser__apply5568);
  meth_meth_parser__apply5568->definitionModule = modulename;
  meth_meth_parser__apply5568->definitionLine = 3399;
// compiled block node returning block5567 (depth = 8)
  gc_frame_newslot(block5567);
// starting to compile block node (depth = 8)
  Object block5576 = alloc_Block(NULL, NULL, "parser", 1761);
  gc_frame_newslot(block5576);
// method "_apply"
  block_savedest(block5576);
  Object closure5577 = createclosure(3, "_apply");
  setclosureframe(closure5577, stackframe);
  addtoclosure(closure5577, var_root);
  addtoclosure(closure5577, var_outroot);
  addtoclosure(closure5577, selfslot);
  struct UserObject *uo5577 = (struct UserObject*)block5576;
  uo5577->data[0] = (Object)closure5577;
  Method *meth_meth_parser__apply5577 = addmethod2pos(block5576, "_apply", &meth_parser__apply5577, 0);
  int argcv_meth_parser__apply5577[] = {0};
  meth_meth_parser__apply5577->type = alloc_MethodType(1, argcv_meth_parser__apply5577);
  meth_meth_parser__apply5577->definitionModule = modulename;
  meth_meth_parser__apply5577->definitionLine = 3399;
// compiled block node returning block5576 (depth = 8)
  gc_frame_newslot(block5576);
// call case 5: prelude request
  params[0] = block5567;
  params[1] = block5576;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5583 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5566);
// compiled call node returning call5583 (depth = 7)
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5586 == NULL) {
    strlit5586 = alloc_String("identifier");
    gc_root(strlit5586);
  }
// compiled string node returning strlit5586 (depth = 9)
  int op_slot_right_5585 = gc_frame_newslot(strlit5586);
// starting to compile member node (depth = 9)
  int callframe5588 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_root (depth = 10)
  Object call5589 = callmethodflags(*var_root, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5588);
// compiled member node returning call5589 (depth = 9)
  int op_slot_left_5585 = gc_frame_newslot(call5589);
  params[0] = strlit5586;
  partcv[0] = 1;
  Object opresult5590 = callmethod(call5589, "==(1)", 1, partcv, params);
// compiled op node returning opresult5590 (depth = 8)
  Object if5584 = done;
  if (istrue(opresult5590)) {
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5591 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  gc_frame_newslot(*var_meth);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5592 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5591);
// compiled call node returning call5592 (depth = 8)
    gc_frame_newslot(call5592);
    if5584 = call5592;
  } else {
// Begin line 1768
  setline(1768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5593 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_genericIdents (depth = 9)
  gc_frame_newslot(*var_genericIdents);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object call5594 = callmethodflags(*var_meth, "generics:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5593);
// compiled call node returning call5594 (depth = 8)
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5595 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  gc_frame_newslot(*var_meth);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5596 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5595);
// compiled call node returning call5596 (depth = 8)
    gc_frame_newslot(call5596);
    if5584 = call5596;
  }
// compiled if node returning if5584 (depth = 7)
    gc_frame_newslot(if5584);
    if5557 = if5584;
  } else {
  }
// compiled if node returning if5557 (depth = 6)
    gc_frame_newslot(if5557);
    if5548 = if5557;
  }
// compiled if node returning if5548 (depth = 5)
    gc_frame_newslot(if5548);
    if5532 = if5548;
  }
// compiled if node returning if5532 (depth = 4)
    gc_frame_newslot(if5532);
    if5518 = if5532;
  }
// compiled if node returning if5518 (depth = 3)
    gc_frame_newslot(if5518);
    if5499 = if5518;
  }
// compiled if node returning if5499 (depth = 2)
// Begin line 1772
  setline(1772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_hadcall (depth = 3)
  Object if5597 = done;
  if (istrue(*var_hadcall)) {
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5599 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5600 == NULL) {
    strlit5600 = alloc_String("identifier");
    gc_root(strlit5600);
  }
// compiled string node returning strlit5600 (depth = 5)
  gc_frame_newslot(strlit5600);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tok (depth = 5)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit5600;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5601 = callmethodflags(self, "accept(1)onLineOfLastOr(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5599);
// compiled call node returning call5601 (depth = 4)
  Object if5598 = done;
  if (istrue(call5601)) {
// Begin line 1775
  setline(1775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5602 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methn (depth = 6)
  gc_frame_newslot(*var_methn);
// starting to compile identifier node (depth = 6)
  Object bool5603 = alloc_Boolean(0);
// compiled identifier node returning bool5603 (depth = 6)
  gc_frame_newslot(bool5603);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5604 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call5605 = callmethodflags(*var_ast, "identifierNode", 0, partcv, params, 0);
  gc_frame_end(callframe5604);
// compiled member node returning call5605 (depth = 6)
  params[0] = *var_methn;
  params[1] = bool5603;
  partcv[0] = 2;
  Object call5606 = callmethodflags(call5605, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5602);
// compiled call node returning call5606 (depth = 5)
  *var_meth_39_ = call5606;
  if (call5606 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1776
  setline(1776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5607 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lnum (depth = 5)
  gc_frame_newslot(*var_lnum);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth_39_ (depth = 5)
  params[0] = *var_lnum;
  partcv[0] = 1;
  Object call5608 = callmethodflags(*var_meth_39_, "line:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5607);
// compiled call node returning call5608 (depth = 4)
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5609 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lpos (depth = 5)
  gc_frame_newslot(*var_lpos);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth_39_ (depth = 5)
  params[0] = *var_lpos;
  partcv[0] = 1;
  Object call5610 = callmethodflags(*var_meth_39_, "linePos:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5609);
// compiled call node returning call5610 (depth = 4)
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5611 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth_39_ (depth = 6)
  gc_frame_newslot(*var_meth_39_);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_signature (depth = 6)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = *var_meth_39_;
  params[1] = *var_signature;
  params[2] = *var_tok;
  partcv[0] = 3;
  Object call5612 = callmethodflags(self, "callmprest(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5611);
// compiled call node returning call5612 (depth = 5)
  *var_methn = call5612;
  if (call5612 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1779
  setline(1779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5616 == NULL) {
    strlit5616 = alloc_String("member");
    gc_root(strlit5616);
  }
// compiled string node returning strlit5616 (depth = 6)
  int op_slot_right_5615 = gc_frame_newslot(strlit5616);
// starting to compile member node (depth = 6)
  int callframe5618 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  Object call5619 = callmethodflags(*var_meth, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5618);
// compiled member node returning call5619 (depth = 6)
  int op_slot_left_5615 = gc_frame_newslot(call5619);
  params[0] = strlit5616;
  partcv[0] = 1;
  Object opresult5620 = callmethod(call5619, "==(1)", 1, partcv, params);
// compiled op node returning opresult5620 (depth = 5)
  Object if5614 = done;
  if (istrue(opresult5620)) {
// Begin line 1783
  setline(1783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5621 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe5622 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_methn (depth = 8)
  Object call5623 = callmethodflags(*var_methn, "value", 0, partcv, params, 0);
  gc_frame_end(callframe5622);
// compiled member node returning call5623 (depth = 7)
  gc_frame_newslot(call5623);
// starting to compile member node (depth = 7)
  int callframe5624 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  Object call5625 = callmethodflags(*var_meth, "receiver", 0, partcv, params, 0);
  gc_frame_end(callframe5624);
// compiled member node returning call5625 (depth = 7)
  gc_frame_newslot(call5625);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5626 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  Object call5627 = callmethodflags(*var_ast, "memberNode", 0, partcv, params, 0);
  gc_frame_end(callframe5626);
// compiled member node returning call5627 (depth = 7)
  params[0] = call5623;
  params[1] = call5625;
  partcv[0] = 2;
  Object call5628 = callmethodflags(call5627, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5621);
// compiled call node returning call5628 (depth = 6)
  *var_meth = call5628;
  if (call5628 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1784
  setline(1784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5630 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5631 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_methn (depth = 7)
  Object call5632 = callmethodflags(*var_methn, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5631);
// compiled member node returning call5632 (depth = 6)
  gc_frame_newslot(call5632);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  params[0] = call5632;
  partcv[0] = 1;
  Object call5633 = callmethodflags(*var_meth, "line:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5630);
// compiled call node returning call5633 (depth = 5)
// Begin line 1785
  setline(1785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5634 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5635 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_methn (depth = 7)
  Object call5636 = callmethodflags(*var_methn, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5635);
// compiled member node returning call5636 (depth = 6)
  gc_frame_newslot(call5636);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  params[0] = call5636;
  partcv[0] = 1;
  Object call5637 = callmethodflags(*var_meth, "linePos:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5634);
// compiled call node returning call5637 (depth = 5)
    gc_frame_newslot(call5637);
    if5614 = call5637;
  } else {
// Begin line 1787
  setline(1787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methn (depth = 6)
  *var_meth = *var_methn;
  if (*var_methn == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5614 = done;
  }
// compiled if node returning if5614 (depth = 4)
    gc_frame_newslot(if5614);
    if5598 = if5614;
  } else {
  }
// compiled if node returning if5598 (depth = 3)
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5639 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lnum (depth = 4)
  gc_frame_newslot(*var_lnum);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_lnum;
  partcv[0] = 1;
  Object call5640 = callmethodflags(*var_util, "setline(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5639);
// compiled call node returning call5640 (depth = 3)
// Begin line 1791
  setline(1791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5642 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  Object call5643 = callmethodflags(*var_meth, "isIdentifier", 0, partcv, params, 0);
  gc_frame_end(callframe5642);
// compiled member node returning call5643 (depth = 4)
  Object if5641 = done;
  if (istrue(call5643)) {
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5644 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call5645 = callmethodflags(*var_ast, "implicit", 0, partcv, params, 0);
  gc_frame_end(callframe5644);
// compiled member node returning call5645 (depth = 5)
  *var_meth = call5645;
  if (call5645 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5641 = done;
  } else {
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5647 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  Object call5648 = callmethodflags(*var_meth, "receiver", 0, partcv, params, 0);
  gc_frame_end(callframe5647);
// compiled member node returning call5648 (depth = 5)
  *var_meth = call5648;
  if (call5648 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5641 = done;
  }
// compiled if node returning if5641 (depth = 3)
// Begin line 1797
  setline(1797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5650 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  gc_frame_newslot(*var_signature);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5651 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call5652 = callmethodflags(*var_ast, "callNode", 0, partcv, params, 0);
  gc_frame_end(callframe5651);
// compiled member node returning call5652 (depth = 5)
  params[0] = *var_meth;
  params[1] = *var_signature;
  partcv[0] = 2;
  Object call5653 = callmethodflags(call5652, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5650);
// compiled call node returning call5653 (depth = 4)
  *var_call = call5653;
  if (call5653 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5654 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_genericIdents (depth = 4)
  gc_frame_newslot(*var_genericIdents);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_call (depth = 4)
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object call5655 = callmethodflags(*var_call, "generics:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5654);
// compiled call node returning call5655 (depth = 3)
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5656 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_call (depth = 4)
  gc_frame_newslot(*var_call);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_call;
  partcv[0] = 1;
  Object call5657 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5656);
// compiled call node returning call5657 (depth = 3)
    gc_frame_newslot(call5657);
    if5597 = call5657;
  } else {
// Begin line 1803
  setline(1803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1800
  setline(1800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_genericIdents (depth = 5)
  int op_slot_right_5659 = gc_frame_newslot(*var_genericIdents);
// starting to compile identifier node (depth = 5)
  Object bool5661 = alloc_Boolean(0);
// compiled identifier node returning bool5661 (depth = 5)
  int op_slot_left_5659 = gc_frame_newslot(bool5661);
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object opresult5662 = callmethod(bool5661, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5662 (depth = 4)
  Object if5658 = done;
  if (istrue(opresult5662)) {
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5663 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_genericIdents (depth = 5)
  gc_frame_newslot(*var_genericIdents);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object call5664 = callmethodflags(*var_meth, "generics:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5663);
// compiled call node returning call5664 (depth = 4)
    gc_frame_newslot(call5664);
    if5658 = call5664;
  } else {
  }
// compiled if node returning if5658 (depth = 3)
    gc_frame_newslot(if5658);
    if5597 = if5658;
  }
// compiled if node returning if5597 (depth = 2)
// Begin line 1803
  setline(1803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startInd (depth = 3)
  *var_minIndentLevel = *var_startInd;
  if (*var_startInd == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 1804
  setline(1804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5666 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_acceptBlocks (depth = 3)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5667 = callmethodflags(self, "dotrest(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5666);
// compiled call node returning call5667 (depth = 2)
  gc_frame_end(frame);
  return call5667;
}
Object meth_parser__apply5673(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe5674 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blocksOK (depth = 5)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5675 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5674);
// compiled call node returning call5675 (depth = 4)
  gc_frame_end(frame);
  return call5675;
}
Object meth_parser__apply5752(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe5753 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5754 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5753);
// compiled call node returning call5754 (depth = 9)
  gc_frame_end(frame);
  return call5754;
}
Object meth_parser__apply5813(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe5814 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5815 == NULL) {
    strlit5815 = alloc_String("comma");
    gc_root(strlit5815);
  }
// compiled string node returning strlit5815 (depth = 7)
  gc_frame_newslot(strlit5815);
// call case 4: self request
  params[0] = strlit5815;
  partcv[0] = 1;
  Object call5816 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5814);
// compiled call node returning call5816 (depth = 6)
  gc_frame_end(frame);
  return call5816;
}
Object meth_parser__apply5832(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 10)
  int callframe5833 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_blocksOK (depth = 11)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5834 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5833);
// compiled call node returning call5834 (depth = 10)
  gc_frame_end(frame);
  return call5834;
}
Object meth_parser__apply5954(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe5955 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5956 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5955);
// compiled call node returning call5956 (depth = 11)
  gc_frame_end(frame);
  return call5956;
}
Object meth_parser__apply5819(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_part = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
  Object *var_arg = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "arg");
// Begin line 1847
  setline(1847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5820 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe5821 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call5822 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5821);
// compiled member node returning call5822 (depth = 7)
  gc_frame_newslot(call5822);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5823 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  Object call5824 = callmethodflags(*var_part, "args", 0, partcv, params, 0);
  gc_frame_end(callframe5823);
// compiled member node returning call5824 (depth = 7)
  params[0] = call5822;
  partcv[0] = 1;
  Object call5825 = callmethodflags(call5824, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5820);
// compiled call node returning call5825 (depth = 6)
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe5826 = gc_frame_new();
// call case 4: self request
  Object call5827 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5826);
// compiled member node returning call5827 (depth = 6)
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5829 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe5830 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block5831 = alloc_Block(NULL, NULL, "parser", 1849);
  gc_frame_newslot(block5831);
// method "_apply"
  block_savedest(block5831);
  Object closure5832 = createclosure(2, "_apply");
  setclosureframe(closure5832, stackframe);
  addtoclosure(closure5832, var_blocksOK);
  addtoclosure(closure5832, selfslot);
  struct UserObject *uo5832 = (struct UserObject*)block5831;
  uo5832->data[0] = (Object)closure5832;
  Method *meth_meth_parser__apply5832 = addmethod2pos(block5831, "_apply", &meth_parser__apply5832, 0);
  int argcv_meth_parser__apply5832[] = {0};
  meth_meth_parser__apply5832->type = alloc_MethodType(1, argcv_meth_parser__apply5832);
  meth_meth_parser__apply5832->definitionModule = modulename;
  meth_meth_parser__apply5832->definitionLine = 3399;
// compiled block node returning block5831 (depth = 9)
  gc_frame_newslot(block5831);
// call case 4: self request
  params[0] = block5831;
  partcv[0] = 1;
  Object call5836 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5830);
// compiled call node returning call5836 (depth = 8)
  Object call5837 = callmethodflags(call5836, "not", 0, partcv, params, 0);
  gc_frame_end(callframe5829);
// compiled member node returning call5837 (depth = 7)
  Object if5828 = done;
  if (istrue(call5837)) {
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile array node (depth = 8)
  Object array5838 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5838 (depth = 8)
  *var_suggestions = array5838;
  if (array5838 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe5839 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe5840 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call5841 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5840);
// compiled member node returning call5841 (depth = 9)
  Object call5842 = callmethodflags(call5841, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5839);
// compiled member node returning call5842 (depth = 8)
  *var_suggestion = call5842;
  if (call5842 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 1852
  setline(1852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5843 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array5844 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit5845 == NULL) {
    strlit5845 = alloc_String("rparen");
    gc_root(strlit5845);
  }
// compiled string node returning strlit5845 (depth = 10)
  params[0] = strlit5845;
  partcv[0] = 1;
  callmethodflags(array5844, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array5844 (depth = 9)
  gc_frame_newslot(array5844);
// call case 4: self request
  params[0] = array5844;
  partcv[0] = 1;
  Object call5846 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5843);
// compiled call node returning call5846 (depth = 8)
  *var_nextTok = call5846;
  if (call5846 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1853
  setline(1853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_5848 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_5848 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5850 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult5850 (depth = 8)
  Object if5847 = done;
  if (istrue(opresult5850)) {
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5851 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit5852 == NULL) {
    strlit5852 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5852);
  }
// compiled string node returning strlit5852 (depth = 9)
  gc_frame_newslot(strlit5852);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit5852;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5853 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5851);
// compiled call node returning call5853 (depth = 8)
    gc_frame_newslot(call5853);
    if5847 = call5853;
  } else {
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5854 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
  int callframe5855 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call5856 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe5855);
// compiled member node returning call5856 (depth = 9)
  gc_frame_newslot(call5856);
// starting to compile identifier node (depth = 9)
  Object bool5857 = alloc_Boolean(1);
// compiled identifier node returning bool5857 (depth = 9)
  gc_frame_newslot(bool5857);
// starting to compile identifier node (depth = 9)
  Object bool5858 = alloc_Boolean(0);
// compiled identifier node returning bool5858 (depth = 9)
  gc_frame_newslot(bool5858);
// starting to compile string node (depth = 9)
  if (strlit5859 == NULL) {
    strlit5859 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5859);
  }
// compiled string node returning strlit5859 (depth = 9)
  gc_frame_newslot(strlit5859);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call5856;
  params[2] = bool5857;
  params[3] = bool5858;
  params[4] = strlit5859;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5860 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe5854);
// compiled call node returning call5860 (depth = 8)
    gc_frame_newslot(call5860);
    if5847 = call5860;
  }
// compiled if node returning if5847 (depth = 7)
// Begin line 1858
  setline(1858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5861 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5862 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5861);
// compiled call node returning call5862 (depth = 7)
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe5863 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe5864 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call5865 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5864);
// compiled member node returning call5865 (depth = 9)
  Object call5866 = callmethodflags(call5865, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5863);
// compiled member node returning call5866 (depth = 8)
  *var_suggestion = call5866;
  if (call5866 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5868 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
  int callframe5869 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  Object call5870 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe5869);
// compiled member node returning call5870 (depth = 8)
  gc_frame_newslot(call5870);
// starting to compile identifier node (depth = 8)
  Object bool5871 = alloc_Boolean(1);
// compiled identifier node returning bool5871 (depth = 8)
  gc_frame_newslot(bool5871);
// starting to compile identifier node (depth = 8)
  Object bool5872 = alloc_Boolean(0);
// compiled identifier node returning bool5872 (depth = 8)
  gc_frame_newslot(bool5872);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = call5870;
  params[2] = bool5871;
  params[3] = bool5872;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5873 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5868);
// compiled call node returning call5873 (depth = 7)
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5874 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5875 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5874);
// compiled call node returning call5875 (depth = 7)
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5876 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5877 == NULL) {
    strlit5877 = alloc_String("a method request must have an expression after a ','.");
    gc_root(strlit5877);
  }
// compiled string node returning strlit5877 (depth = 8)
  gc_frame_newslot(strlit5877);
// Begin line 1863
  setline(1863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe5878 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call5879 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5878);
// compiled member node returning call5879 (depth = 8)
  gc_frame_newslot(call5879);
// starting to compile member node (depth = 8)
  int callframe5880 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call5881 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5880);
// compiled member node returning call5881 (depth = 8)
  gc_frame_newslot(call5881);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit5877;
  params[1] = call5879;
  params[2] = call5881;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5882 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5876);
// compiled call node returning call5882 (depth = 7)
    gc_frame_newslot(call5882);
    if5828 = call5882;
  } else {
  }
// compiled if node returning if5828 (depth = 6)
// Begin line 1866
  setline(1866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5884 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5885 == NULL) {
    strlit5885 = alloc_String("colon");
    gc_root(strlit5885);
  }
// compiled string node returning strlit5885 (depth = 8)
  gc_frame_newslot(strlit5885);
// call case 4: self request
  params[0] = strlit5885;
  partcv[0] = 1;
  Object call5886 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5884);
// compiled call node returning call5886 (depth = 7)
  Object if5883 = done;
  if (istrue(call5886)) {
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe5887 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  Object call5888 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5887);
// compiled member node returning call5888 (depth = 8)
  *var_arg = call5888;
  if (call5888 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5891 == NULL) {
    strlit5891 = alloc_String("identifier");
    gc_root(strlit5891);
  }
// compiled string node returning strlit5891 (depth = 9)
  int op_slot_right_5890 = gc_frame_newslot(strlit5891);
// starting to compile member node (depth = 9)
  int callframe5893 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_arg (depth = 10)
  Object call5894 = callmethodflags(*var_arg, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5893);
// compiled member node returning call5894 (depth = 9)
  int op_slot_left_5890 = gc_frame_newslot(call5894);
  params[0] = strlit5891;
  partcv[0] = 1;
  Object opresult5895 = callmethod(call5894, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5895 (depth = 8)
  Object if5889 = done;
  if (istrue(opresult5895)) {
// Begin line 1869
  setline(1869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe5896 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe5897 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call5898 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5897);
// compiled member node returning call5898 (depth = 10)
  Object call5899 = callmethodflags(call5898, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5896);
// compiled member node returning call5899 (depth = 9)
  *var_suggestion = call5899;
  if (call5899 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 1870
  setline(1870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5902 == NULL) {
    strlit5902 = alloc_String("identifier");
    gc_root(strlit5902);
  }
// compiled string node returning strlit5902 (depth = 10)
  int op_slot_right_5901 = gc_frame_newslot(strlit5902);
// starting to compile member node (depth = 10)
  int callframe5904 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe5905 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  Object call5906 = callmethodflags(*var_sym, "next", 0, partcv, params, 0);
  gc_frame_end(callframe5905);
// compiled member node returning call5906 (depth = 11)
  Object call5907 = callmethodflags(call5906, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5904);
// compiled member node returning call5907 (depth = 10)
  int op_slot_left_5901 = gc_frame_newslot(call5907);
  params[0] = strlit5902;
  partcv[0] = 1;
  Object opresult5908 = callmethod(call5907, "==(1)", 1, partcv, params);
// compiled op node returning opresult5908 (depth = 9)
  Object if5900 = done;
  if (istrue(opresult5908)) {
// Begin line 1871
  setline(1871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe5909 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
  int callframe5910 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call5911 = callmethodflags(*var_sym, "next", 0, partcv, params, 0);
  gc_frame_end(callframe5910);
// compiled member node returning call5911 (depth = 10)
  gc_frame_newslot(call5911);
// starting to compile identifier node (depth = 10)
  Object bool5912 = alloc_Boolean(1);
// compiled identifier node returning bool5912 (depth = 10)
  gc_frame_newslot(bool5912);
// starting to compile identifier node (depth = 10)
  Object bool5913 = alloc_Boolean(0);
// compiled identifier node returning bool5913 (depth = 10)
  gc_frame_newslot(bool5913);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call5911;
  params[2] = bool5912;
  params[3] = bool5913;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5914 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5909);
// compiled call node returning call5914 (depth = 9)
// Begin line 1872
  setline(1872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe5915 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit5916 == NULL) {
    strlit5916 = alloc_String("only declarations may be followed by a ':' and a type.");
    gc_root(strlit5916);
  }
// compiled string node returning strlit5916 (depth = 10)
  gc_frame_newslot(strlit5916);
// Begin line 1873
  setline(1873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe5917 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call5918 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5917);
// compiled member node returning call5918 (depth = 10)
  gc_frame_newslot(call5918);
// starting to compile member node (depth = 10)
  int callframe5919 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call5920 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5919);
// compiled member node returning call5920 (depth = 10)
  gc_frame_newslot(call5920);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num5922 = alloc_Float64(1);
// compiled num node returning num5922 (depth = 11)
  int op_slot_right_5921 = gc_frame_newslot(num5922);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
  int callframe5925 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe5926 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  Object call5927 = callmethodflags(*var_sym, "next", 0, partcv, params, 0);
  gc_frame_end(callframe5926);
// compiled member node returning call5927 (depth = 13)
  Object call5928 = callmethodflags(call5927, "size", 0, partcv, params, 0);
  gc_frame_end(callframe5925);
// compiled member node returning call5928 (depth = 12)
  int op_slot_right_5924 = gc_frame_newslot(call5928);
// starting to compile member node (depth = 12)
  int callframe5930 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 13)
  int callframe5931 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  Object call5932 = callmethodflags(*var_sym, "next", 0, partcv, params, 0);
  gc_frame_end(callframe5931);
// compiled member node returning call5932 (depth = 13)
  Object call5933 = callmethodflags(call5932, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5930);
// compiled member node returning call5933 (depth = 12)
  int op_slot_left_5924 = gc_frame_newslot(call5933);
  params[0] = call5928;
  partcv[0] = 1;
  Object sum5934 = callmethod(call5933, "+(1)", 1, partcv, params);
// compiled op node returning sum5934 (depth = 11)
  int op_slot_left_5921 = gc_frame_newslot(sum5934);
  params[0] = num5922;
  partcv[0] = 1;
  Object diff5935 = callmethod(sum5934, "-(1)", 1, partcv, params);
// compiled op node returning diff5935 (depth = 10)
  gc_frame_newslot(diff5935);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1872
  setline(1872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit5916;
  params[1] = call5918;
  params[2] = call5920;
  params[3] = diff5935;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call5936 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5915);
// compiled call node returning call5936 (depth = 9)
    gc_frame_newslot(call5936);
    if5900 = call5936;
  } else {
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe5937 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call5938 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5937);
// compiled call node returning call5938 (depth = 9)
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe5939 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit5940 == NULL) {
    strlit5940 = alloc_String("only declarations may be followed by a ':' and a type.");
    gc_root(strlit5940);
  }
// compiled string node returning strlit5940 (depth = 10)
  gc_frame_newslot(strlit5940);
// Begin line 1877
  setline(1877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe5941 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call5942 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5941);
// compiled member node returning call5942 (depth = 10)
  gc_frame_newslot(call5942);
// starting to compile member node (depth = 10)
  int callframe5943 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call5944 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5943);
// compiled member node returning call5944 (depth = 10)
  gc_frame_newslot(call5944);
// starting to compile member node (depth = 10)
  int callframe5945 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call5946 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5945);
// compiled member node returning call5946 (depth = 10)
  gc_frame_newslot(call5946);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit5940;
  params[1] = call5942;
  params[2] = call5944;
  params[3] = call5946;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call5947 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5939);
// compiled call node returning call5947 (depth = 9)
    gc_frame_newslot(call5947);
    if5900 = call5947;
  }
// compiled if node returning if5900 (depth = 8)
    gc_frame_newslot(if5900);
    if5889 = if5900;
  } else {
  }
// compiled if node returning if5889 (depth = 7)
// Begin line 1880
  setline(1880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe5948 = gc_frame_new();
// call case 4: self request
  Object call5949 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5948);
// compiled member node returning call5949 (depth = 7)
// Begin line 1881
  setline(1881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe5951 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 9)
  int callframe5952 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block5953 = alloc_Block(NULL, NULL, "parser", 1881);
  gc_frame_newslot(block5953);
// method "_apply"
  block_savedest(block5953);
  Object closure5954 = createclosure(2, "_apply");
  setclosureframe(closure5954, stackframe);
  addtoclosure(closure5954, var_blocksOK);
  addtoclosure(closure5954, selfslot);
  struct UserObject *uo5954 = (struct UserObject*)block5953;
  uo5954->data[0] = (Object)closure5954;
  Method *meth_meth_parser__apply5954 = addmethod2pos(block5953, "_apply", &meth_parser__apply5954, 0);
  int argcv_meth_parser__apply5954[] = {0};
  meth_meth_parser__apply5954->type = alloc_MethodType(1, argcv_meth_parser__apply5954);
  meth_meth_parser__apply5954->definitionModule = modulename;
  meth_meth_parser__apply5954->definitionLine = 3399;
// compiled block node returning block5953 (depth = 10)
  gc_frame_newslot(block5953);
// call case 4: self request
  params[0] = block5953;
  partcv[0] = 1;
  Object call5958 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5952);
// compiled call node returning call5958 (depth = 9)
  Object call5959 = callmethodflags(call5958, "not", 0, partcv, params, 0);
  gc_frame_end(callframe5951);
// compiled member node returning call5959 (depth = 8)
  Object if5950 = done;
  if (istrue(call5959)) {
// Begin line 1882
  setline(1882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe5960 = gc_frame_new();
// call case 4: self request
  Object call5961 = callmethodflags(self, "checkBadTypeLiteral", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5960);
// compiled member node returning call5961 (depth = 8)
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile array node (depth = 9)
  Object array5962 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5962 (depth = 9)
  *var_suggestions = array5962;
  if (array5962 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 1884
  setline(1884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe5963 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe5964 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call5965 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5964);
// compiled member node returning call5965 (depth = 10)
  Object call5966 = callmethodflags(call5965, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5963);
// compiled member node returning call5966 (depth = 9)
  *var_suggestion = call5966;
  if (call5966 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5967 = gc_frame_new();
// starting to compile array node (depth = 10)
  Object array5968 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 11)
  if (strlit5969 == NULL) {
    strlit5969 = alloc_String("rparen");
    gc_root(strlit5969);
  }
// compiled string node returning strlit5969 (depth = 11)
  params[0] = strlit5969;
  partcv[0] = 1;
  callmethodflags(array5968, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array5968 (depth = 10)
  gc_frame_newslot(array5968);
// call case 4: self request
  params[0] = array5968;
  partcv[0] = 1;
  Object call5970 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5967);
// compiled call node returning call5970 (depth = 9)
  *var_nextTok = call5970;
  if (call5970 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_5972 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_5972 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5974 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult5974 (depth = 9)
  Object if5971 = done;
  if (istrue(opresult5974)) {
// Begin line 1887
  setline(1887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe5975 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit5976 == NULL) {
    strlit5976 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit5976);
  }
// compiled string node returning strlit5976 (depth = 10)
  gc_frame_newslot(strlit5976);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit5976;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5977 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5975);
// compiled call node returning call5977 (depth = 9)
    gc_frame_newslot(call5977);
    if5971 = call5977;
  } else {
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe5978 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
  int callframe5979 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  Object call5980 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe5979);
// compiled member node returning call5980 (depth = 10)
  gc_frame_newslot(call5980);
// starting to compile identifier node (depth = 10)
  Object bool5981 = alloc_Boolean(1);
// compiled identifier node returning bool5981 (depth = 10)
  gc_frame_newslot(bool5981);
// starting to compile identifier node (depth = 10)
  Object bool5982 = alloc_Boolean(0);
// compiled identifier node returning bool5982 (depth = 10)
  gc_frame_newslot(bool5982);
// starting to compile string node (depth = 10)
  if (strlit5983 == NULL) {
    strlit5983 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit5983);
  }
// compiled string node returning strlit5983 (depth = 10)
  gc_frame_newslot(strlit5983);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call5980;
  params[2] = bool5981;
  params[3] = bool5982;
  params[4] = strlit5983;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5984 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe5978);
// compiled call node returning call5984 (depth = 9)
    gc_frame_newslot(call5984);
    if5971 = call5984;
  }
// compiled if node returning if5971 (depth = 8)
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5985 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5986 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5985);
// compiled call node returning call5986 (depth = 8)
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe5987 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe5988 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call5989 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5988);
// compiled member node returning call5989 (depth = 10)
  Object call5990 = callmethodflags(call5989, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5987);
// compiled member node returning call5990 (depth = 9)
  *var_suggestion = call5990;
  if (call5990 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5992 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
  int callframe5993 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call5994 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe5993);
// compiled member node returning call5994 (depth = 9)
  gc_frame_newslot(call5994);
// starting to compile identifier node (depth = 9)
  Object bool5995 = alloc_Boolean(1);
// compiled identifier node returning bool5995 (depth = 9)
  gc_frame_newslot(bool5995);
// starting to compile identifier node (depth = 9)
  Object bool5996 = alloc_Boolean(0);
// compiled identifier node returning bool5996 (depth = 9)
  gc_frame_newslot(bool5996);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call5994;
  params[2] = bool5995;
  params[3] = bool5996;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5997 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5992);
// compiled call node returning call5997 (depth = 8)
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5998 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5999 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5998);
// compiled call node returning call5999 (depth = 8)
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6000 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6001 == NULL) {
    strlit6001 = alloc_String("a type name or type expression must follow ':'.");
    gc_root(strlit6001);
  }
// compiled string node returning strlit6001 (depth = 9)
  gc_frame_newslot(strlit6001);
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe6002 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call6003 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6002);
// compiled member node returning call6003 (depth = 9)
  gc_frame_newslot(call6003);
// starting to compile member node (depth = 9)
  int callframe6004 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call6005 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6004);
// compiled member node returning call6005 (depth = 9)
  gc_frame_newslot(call6005);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6001;
  params[1] = call6003;
  params[2] = call6005;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6006 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6000);
// compiled call node returning call6006 (depth = 8)
    gc_frame_newslot(call6006);
    if5950 = call6006;
  } else {
  }
// compiled if node returning if5950 (depth = 7)
// Begin line 1898
  setline(1898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6007 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe6008 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  Object call6009 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe6008);
// compiled member node returning call6009 (depth = 8)
  gc_frame_newslot(call6009);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_arg (depth = 8)
  params[0] = call6009;
  partcv[0] = 1;
  Object call6010 = callmethodflags(*var_arg, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6007);
// compiled call node returning call6010 (depth = 7)
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6011 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_arg (depth = 8)
  gc_frame_newslot(*var_arg);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  params[0] = *var_arg;
  partcv[0] = 1;
  Object call6012 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6011);
// compiled call node returning call6012 (depth = 7)
    gc_frame_newslot(call6012);
    if5883 = call6012;
  } else {
  }
// compiled if node returning if5883 (depth = 6)
  gc_frame_end(frame);
  return if5883;
}
Object meth_parser__apply5678(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_part = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_expr = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "expr");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// Begin line 1811
  setline(1811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5680 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5681 == NULL) {
    strlit5681 = alloc_String("colon");
    gc_root(strlit5681);
  }
// compiled string node returning strlit5681 (depth = 6)
  gc_frame_newslot(strlit5681);
// call case 4: self request
  params[0] = strlit5681;
  partcv[0] = 1;
  Object call5682 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5680);
// compiled call node returning call5682 (depth = 5)
  Object if5679 = done;
  if (istrue(call5682)) {
// Begin line 1812
  setline(1812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5683 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call5684 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5683);
// compiled member node returning call5684 (depth = 6)
  *var_expr = call5684;
  if (call5684 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1813
  setline(1813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5687 == NULL) {
    strlit5687 = alloc_String("identifier");
    gc_root(strlit5687);
  }
// compiled string node returning strlit5687 (depth = 7)
  int op_slot_right_5686 = gc_frame_newslot(strlit5687);
// starting to compile member node (depth = 7)
  int callframe5689 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_expr (depth = 8)
  Object call5690 = callmethodflags(*var_expr, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5689);
// compiled member node returning call5690 (depth = 7)
  int op_slot_left_5686 = gc_frame_newslot(call5690);
  params[0] = strlit5687;
  partcv[0] = 1;
  Object opresult5691 = callmethod(call5690, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5691 (depth = 6)
  Object if5685 = done;
  if (istrue(opresult5691)) {
// Begin line 1814
  setline(1814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5692 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5693 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call5694 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5693);
// compiled member node returning call5694 (depth = 8)
  Object call5695 = callmethodflags(call5694, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5692);
// compiled member node returning call5695 (depth = 7)
  *var_suggestion = call5695;
  if (call5695 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1815
  setline(1815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5698 == NULL) {
    strlit5698 = alloc_String("identifier");
    gc_root(strlit5698);
  }
// compiled string node returning strlit5698 (depth = 8)
  int op_slot_right_5697 = gc_frame_newslot(strlit5698);
// starting to compile member node (depth = 8)
  int callframe5700 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe5701 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call5702 = callmethodflags(*var_sym, "next", 0, partcv, params, 0);
  gc_frame_end(callframe5701);
// compiled member node returning call5702 (depth = 9)
  Object call5703 = callmethodflags(call5702, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe5700);
// compiled member node returning call5703 (depth = 8)
  int op_slot_left_5697 = gc_frame_newslot(call5703);
  params[0] = strlit5698;
  partcv[0] = 1;
  Object opresult5704 = callmethod(call5703, "==(1)", 1, partcv, params);
// compiled op node returning opresult5704 (depth = 7)
  Object if5696 = done;
  if (istrue(opresult5704)) {
// Begin line 1816
  setline(1816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5705 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
  int callframe5706 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call5707 = callmethodflags(*var_sym, "next", 0, partcv, params, 0);
  gc_frame_end(callframe5706);
// compiled member node returning call5707 (depth = 8)
  gc_frame_newslot(call5707);
// starting to compile identifier node (depth = 8)
  Object bool5708 = alloc_Boolean(1);
// compiled identifier node returning bool5708 (depth = 8)
  gc_frame_newslot(bool5708);
// starting to compile identifier node (depth = 8)
  Object bool5709 = alloc_Boolean(0);
// compiled identifier node returning bool5709 (depth = 8)
  gc_frame_newslot(bool5709);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call5707;
  params[2] = bool5708;
  params[3] = bool5709;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5710 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5705);
// compiled call node returning call5710 (depth = 7)
// Begin line 1817
  setline(1817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5711 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5712 == NULL) {
    strlit5712 = alloc_String("only variables and constants may be followed by a ':' and a type.");
    gc_root(strlit5712);
  }
// compiled string node returning strlit5712 (depth = 8)
  gc_frame_newslot(strlit5712);
// Begin line 1818
  setline(1818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe5713 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call5714 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5713);
// compiled member node returning call5714 (depth = 8)
  gc_frame_newslot(call5714);
// starting to compile member node (depth = 8)
  int callframe5715 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call5716 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5715);
// compiled member node returning call5716 (depth = 8)
  gc_frame_newslot(call5716);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5718 = alloc_Float64(1);
// compiled num node returning num5718 (depth = 9)
  int op_slot_right_5717 = gc_frame_newslot(num5718);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe5721 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe5722 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  Object call5723 = callmethodflags(*var_sym, "next", 0, partcv, params, 0);
  gc_frame_end(callframe5722);
// compiled member node returning call5723 (depth = 11)
  Object call5724 = callmethodflags(call5723, "size", 0, partcv, params, 0);
  gc_frame_end(callframe5721);
// compiled member node returning call5724 (depth = 10)
  int op_slot_right_5720 = gc_frame_newslot(call5724);
// starting to compile member node (depth = 10)
  int callframe5726 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe5727 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  Object call5728 = callmethodflags(*var_sym, "next", 0, partcv, params, 0);
  gc_frame_end(callframe5727);
// compiled member node returning call5728 (depth = 11)
  Object call5729 = callmethodflags(call5728, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5726);
// compiled member node returning call5729 (depth = 10)
  int op_slot_left_5720 = gc_frame_newslot(call5729);
  params[0] = call5724;
  partcv[0] = 1;
  Object sum5730 = callmethod(call5729, "+(1)", 1, partcv, params);
// compiled op node returning sum5730 (depth = 9)
  int op_slot_left_5717 = gc_frame_newslot(sum5730);
  params[0] = num5718;
  partcv[0] = 1;
  Object diff5731 = callmethod(sum5730, "-(1)", 1, partcv, params);
// compiled op node returning diff5731 (depth = 8)
  gc_frame_newslot(diff5731);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1817
  setline(1817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit5712;
  params[1] = call5714;
  params[2] = call5716;
  params[3] = diff5731;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call5732 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5711);
// compiled call node returning call5732 (depth = 7)
    gc_frame_newslot(call5732);
    if5696 = call5732;
  } else {
// Begin line 1820
  setline(1820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5733 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool5734 = alloc_Boolean(1);
// compiled identifier node returning bool5734 (depth = 8)
  gc_frame_newslot(bool5734);
// starting to compile identifier node (depth = 8)
  Object bool5735 = alloc_Boolean(0);
// compiled identifier node returning bool5735 (depth = 8)
  gc_frame_newslot(bool5735);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool5734;
  params[2] = bool5735;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5736 = callmethodflags(*var_suggestion, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5733);
// compiled call node returning call5736 (depth = 7)
// Begin line 1821
  setline(1821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5737 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5738 == NULL) {
    strlit5738 = alloc_String("only variables and constants may be followed by a ':' and a type.");
    gc_root(strlit5738);
  }
// compiled string node returning strlit5738 (depth = 8)
  gc_frame_newslot(strlit5738);
// Begin line 1822
  setline(1822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe5739 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call5740 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5739);
// compiled member node returning call5740 (depth = 8)
  gc_frame_newslot(call5740);
// starting to compile member node (depth = 8)
  int callframe5741 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call5742 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5741);
// compiled member node returning call5742 (depth = 8)
  gc_frame_newslot(call5742);
// starting to compile member node (depth = 8)
  int callframe5743 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call5744 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5743);
// compiled member node returning call5744 (depth = 8)
  gc_frame_newslot(call5744);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1821
  setline(1821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit5738;
  params[1] = call5740;
  params[2] = call5742;
  params[3] = call5744;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call5745 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5737);
// compiled call node returning call5745 (depth = 7)
    gc_frame_newslot(call5745);
    if5696 = call5745;
  }
// compiled if node returning if5696 (depth = 6)
    gc_frame_newslot(if5696);
    if5685 = if5696;
  } else {
  }
// compiled if node returning if5685 (depth = 5)
// Begin line 1825
  setline(1825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5746 = gc_frame_new();
// call case 4: self request
  Object call5747 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5746);
// compiled member node returning call5747 (depth = 5)
// Begin line 1826
  setline(1826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5749 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe5750 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block5751 = alloc_Block(NULL, NULL, "parser", 1826);
  gc_frame_newslot(block5751);
// method "_apply"
  block_savedest(block5751);
  Object closure5752 = createclosure(2, "_apply");
  setclosureframe(closure5752, stackframe);
  addtoclosure(closure5752, var_blocksOK);
  addtoclosure(closure5752, selfslot);
  struct UserObject *uo5752 = (struct UserObject*)block5751;
  uo5752->data[0] = (Object)closure5752;
  Method *meth_meth_parser__apply5752 = addmethod2pos(block5751, "_apply", &meth_parser__apply5752, 0);
  int argcv_meth_parser__apply5752[] = {0};
  meth_meth_parser__apply5752->type = alloc_MethodType(1, argcv_meth_parser__apply5752);
  meth_meth_parser__apply5752->definitionModule = modulename;
  meth_meth_parser__apply5752->definitionLine = 3399;
// compiled block node returning block5751 (depth = 8)
  gc_frame_newslot(block5751);
// call case 4: self request
  params[0] = block5751;
  partcv[0] = 1;
  Object call5756 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5750);
// compiled call node returning call5756 (depth = 7)
  Object call5757 = callmethodflags(call5756, "not", 0, partcv, params, 0);
  gc_frame_end(callframe5749);
// compiled member node returning call5757 (depth = 6)
  Object if5748 = done;
  if (istrue(call5757)) {
// Begin line 1827
  setline(1827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe5758 = gc_frame_new();
// call case 4: self request
  Object call5759 = callmethodflags(self, "checkBadTypeLiteral", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5758);
// compiled member node returning call5759 (depth = 6)
// Begin line 1828
  setline(1828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array5760 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5760 (depth = 7)
  *var_suggestions = array5760;
  if (array5760 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5761 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5762 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call5763 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5762);
// compiled member node returning call5763 (depth = 8)
  Object call5764 = callmethodflags(call5763, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5761);
// compiled member node returning call5764 (depth = 7)
  *var_suggestion = call5764;
  if (call5764 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5765 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array5766 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit5767 == NULL) {
    strlit5767 = alloc_String("rparen");
    gc_root(strlit5767);
  }
// compiled string node returning strlit5767 (depth = 9)
  params[0] = strlit5767;
  partcv[0] = 1;
  callmethodflags(array5766, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array5766 (depth = 8)
  gc_frame_newslot(array5766);
// call case 4: self request
  params[0] = array5766;
  partcv[0] = 1;
  Object call5768 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5765);
// compiled call node returning call5768 (depth = 7)
  *var_nextTok = call5768;
  if (call5768 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_5770 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_5770 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5772 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult5772 (depth = 7)
  Object if5769 = done;
  if (istrue(opresult5772)) {
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5773 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5774 == NULL) {
    strlit5774 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit5774);
  }
// compiled string node returning strlit5774 (depth = 8)
  gc_frame_newslot(strlit5774);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit5774;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5775 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5773);
// compiled call node returning call5775 (depth = 7)
    gc_frame_newslot(call5775);
    if5769 = call5775;
  } else {
// Begin line 1834
  setline(1834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5776 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
  int callframe5777 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  Object call5778 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe5777);
// compiled member node returning call5778 (depth = 8)
  gc_frame_newslot(call5778);
// starting to compile identifier node (depth = 8)
  Object bool5779 = alloc_Boolean(1);
// compiled identifier node returning bool5779 (depth = 8)
  gc_frame_newslot(bool5779);
// starting to compile identifier node (depth = 8)
  Object bool5780 = alloc_Boolean(0);
// compiled identifier node returning bool5780 (depth = 8)
  gc_frame_newslot(bool5780);
// starting to compile string node (depth = 8)
  if (strlit5781 == NULL) {
    strlit5781 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit5781);
  }
// compiled string node returning strlit5781 (depth = 8)
  gc_frame_newslot(strlit5781);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call5778;
  params[2] = bool5779;
  params[3] = bool5780;
  params[4] = strlit5781;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5782 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe5776);
// compiled call node returning call5782 (depth = 7)
    gc_frame_newslot(call5782);
    if5769 = call5782;
  }
// compiled if node returning if5769 (depth = 6)
// Begin line 1836
  setline(1836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5783 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5784 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5783);
// compiled call node returning call5784 (depth = 6)
// Begin line 1837
  setline(1837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5785 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5786 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call5787 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe5786);
// compiled member node returning call5787 (depth = 8)
  Object call5788 = callmethodflags(call5787, "new", 0, partcv, params, 0);
  gc_frame_end(callframe5785);
// compiled member node returning call5788 (depth = 7)
  *var_suggestion = call5788;
  if (call5788 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1838
  setline(1838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5790 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
  int callframe5791 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call5792 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe5791);
// compiled member node returning call5792 (depth = 7)
  gc_frame_newslot(call5792);
// starting to compile identifier node (depth = 7)
  Object bool5793 = alloc_Boolean(1);
// compiled identifier node returning bool5793 (depth = 7)
  gc_frame_newslot(bool5793);
// starting to compile identifier node (depth = 7)
  Object bool5794 = alloc_Boolean(0);
// compiled identifier node returning bool5794 (depth = 7)
  gc_frame_newslot(bool5794);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call5792;
  params[2] = bool5793;
  params[3] = bool5794;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5795 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5790);
// compiled call node returning call5795 (depth = 6)
// Begin line 1839
  setline(1839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5796 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5797 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5796);
// compiled call node returning call5797 (depth = 6)
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5798 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5799 == NULL) {
    strlit5799 = alloc_String("a type name or type expression must follow ':'.");
    gc_root(strlit5799);
  }
// compiled string node returning strlit5799 (depth = 7)
  gc_frame_newslot(strlit5799);
// Begin line 1841
  setline(1841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe5800 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call5801 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe5800);
// compiled member node returning call5801 (depth = 7)
  gc_frame_newslot(call5801);
// starting to compile member node (depth = 7)
  int callframe5802 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call5803 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe5802);
// compiled member node returning call5803 (depth = 7)
  gc_frame_newslot(call5803);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit5799;
  params[1] = call5801;
  params[2] = call5803;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5804 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe5798);
// compiled call node returning call5804 (depth = 6)
    gc_frame_newslot(call5804);
    if5748 = call5804;
  } else {
  }
// compiled if node returning if5748 (depth = 5)
// Begin line 1843
  setline(1843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5805 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5806 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call5807 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe5806);
// compiled member node returning call5807 (depth = 6)
  gc_frame_newslot(call5807);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_expr (depth = 6)
  params[0] = call5807;
  partcv[0] = 1;
  Object call5808 = callmethodflags(*var_expr, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5805);
// compiled call node returning call5808 (depth = 5)
// Begin line 1844
  setline(1844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5809 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_expr (depth = 6)
  gc_frame_newslot(*var_expr);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  params[0] = *var_expr;
  partcv[0] = 1;
  Object call5810 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5809);
// compiled call node returning call5810 (depth = 5)
    gc_frame_newslot(call5810);
    if5679 = call5810;
  } else {
  }
// compiled if node returning if5679 (depth = 4)
// Begin line 1846
  setline(1846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5811 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5812 = alloc_Block(NULL, NULL, "parser", 1846);
  gc_frame_newslot(block5812);
// method "_apply"
  block_savedest(block5812);
  Object closure5813 = createclosure(1, "_apply");
  setclosureframe(closure5813, stackframe);
  addtoclosure(closure5813, selfslot);
  struct UserObject *uo5813 = (struct UserObject*)block5812;
  uo5813->data[0] = (Object)closure5813;
  Method *meth_meth_parser__apply5813 = addmethod2pos(block5812, "_apply", &meth_parser__apply5813, 0);
  int argcv_meth_parser__apply5813[] = {0};
  meth_meth_parser__apply5813->type = alloc_MethodType(1, argcv_meth_parser__apply5813);
  meth_meth_parser__apply5813->definitionModule = modulename;
  meth_meth_parser__apply5813->definitionLine = 3399;
// compiled block node returning block5812 (depth = 5)
  gc_frame_newslot(block5812);
// starting to compile block node (depth = 5)
  Object block5818 = alloc_Block(NULL, NULL, "parser", 1846);
  gc_frame_newslot(block5818);
// method "_apply"
  block_savedest(block5818);
  Object closure5819 = createclosure(7, "_apply");
  setclosureframe(closure5819, stackframe);
  addtoclosure(closure5819, var_values);
  addtoclosure(closure5819, var_part);
  addtoclosure(closure5819, var_blocksOK);
  addtoclosure(closure5819, var_errormessages);
  addtoclosure(closure5819, var_sym);
  addtoclosure(closure5819, var_lastToken);
  addtoclosure(closure5819, selfslot);
  struct UserObject *uo5819 = (struct UserObject*)block5818;
  uo5819->data[0] = (Object)closure5819;
  Method *meth_meth_parser__apply5819 = addmethod2pos(block5818, "_apply", &meth_parser__apply5819, 0);
  int argcv_meth_parser__apply5819[] = {0};
  meth_meth_parser__apply5819->type = alloc_MethodType(1, argcv_meth_parser__apply5819);
  meth_meth_parser__apply5819->definitionModule = modulename;
  meth_meth_parser__apply5819->definitionLine = 3399;
// compiled block node returning block5818 (depth = 5)
  gc_frame_newslot(block5818);
// call case 5: prelude request
  params[0] = block5812;
  params[1] = block5818;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6014 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5811);
// compiled call node returning call6014 (depth = 4)
// Begin line 1902
  setline(1902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6015 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6016 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call6017 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe6016);
// compiled member node returning call6017 (depth = 5)
  gc_frame_newslot(call6017);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6018 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  Object call6019 = callmethodflags(*var_part, "args", 0, partcv, params, 0);
  gc_frame_end(callframe6018);
// compiled member node returning call6019 (depth = 5)
  params[0] = call6017;
  partcv[0] = 1;
  Object call6020 = callmethodflags(call6019, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6015);
// compiled call node returning call6020 (depth = 4)
  gc_frame_end(frame);
  return call6020;
}
Object meth_parser_parenthesizedArg_40_1_41_5668(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 45, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parenthesizedArg(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parenthesizedArg(_)");
  Object params[4];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parenthesizedArg(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parenthesizedArg(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// Begin line 1808
  setline(1808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5669 = gc_frame_new();
// call case 4: self request
  Object call5670 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5669);
// compiled member node returning call5670 (depth = 2)
// Begin line 1809
  setline(1809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5671 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5672 = alloc_Block(NULL, NULL, "parser", 1809);
  gc_frame_newslot(block5672);
// method "_apply"
  block_savedest(block5672);
  Object closure5673 = createclosure(2, "_apply");
  setclosureframe(closure5673, stackframe);
  addtoclosure(closure5673, var_blocksOK);
  addtoclosure(closure5673, selfslot);
  struct UserObject *uo5673 = (struct UserObject*)block5672;
  uo5673->data[0] = (Object)closure5673;
  Method *meth_meth_parser__apply5673 = addmethod2pos(block5672, "_apply", &meth_parser__apply5673, 0);
  int argcv_meth_parser__apply5673[] = {0};
  meth_meth_parser__apply5673->type = alloc_MethodType(1, argcv_meth_parser__apply5673);
  meth_meth_parser__apply5673->definitionModule = modulename;
  meth_meth_parser__apply5673->definitionLine = 3399;
// compiled block node returning block5672 (depth = 3)
  gc_frame_newslot(block5672);
// starting to compile block node (depth = 3)
  Object block5677 = alloc_Block(NULL, NULL, "parser", 1809);
  gc_frame_newslot(block5677);
// method "_apply"
  block_savedest(block5677);
  Object closure5678 = createclosure(7, "_apply");
  setclosureframe(closure5678, stackframe);
  addtoclosure(closure5678, var_values);
  addtoclosure(closure5678, var_errormessages);
  addtoclosure(closure5678, var_sym);
  addtoclosure(closure5678, var_blocksOK);
  addtoclosure(closure5678, var_lastToken);
  addtoclosure(closure5678, var_part);
  addtoclosure(closure5678, selfslot);
  struct UserObject *uo5678 = (struct UserObject*)block5677;
  uo5678->data[0] = (Object)closure5678;
  Method *meth_meth_parser__apply5678 = addmethod2pos(block5677, "_apply", &meth_parser__apply5678, 0);
  int argcv_meth_parser__apply5678[] = {0};
  meth_meth_parser__apply5678->type = alloc_MethodType(1, argcv_meth_parser__apply5678);
  meth_meth_parser__apply5678->definitionModule = modulename;
  meth_meth_parser__apply5678->definitionLine = 3399;
// compiled block node returning block5677 (depth = 3)
  gc_frame_newslot(block5677);
// call case 4: self request
  params[0] = block5672;
  params[1] = block5677;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6022 = callmethodflags(self, "ifConsume(1)then(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5671);
// compiled call node returning call6022 (depth = 2)
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6025 == NULL) {
    strlit6025 = alloc_String("rparen");
    gc_root(strlit6025);
  }
// compiled string node returning strlit6025 (depth = 4)
  int op_slot_right_6024 = gc_frame_newslot(strlit6025);
// starting to compile member node (depth = 4)
  int callframe6027 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call6028 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6027);
// compiled member node returning call6028 (depth = 4)
  int op_slot_left_6024 = gc_frame_newslot(call6028);
  params[0] = strlit6025;
  partcv[0] = 1;
  Object opresult6029 = callmethod(call6028, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6029 (depth = 3)
  Object if6023 = done;
  if (istrue(opresult6029)) {
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6030 = gc_frame_new();
// call case 4: self request
  Object call6031 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6030);
// compiled member node returning call6031 (depth = 3)
// Begin line 1906
  setline(1906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6032 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6033 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call6034 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6033);
// compiled member node returning call6034 (depth = 5)
  Object call6035 = callmethodflags(call6034, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6032);
// compiled member node returning call6035 (depth = 4)
  *var_suggestion = call6035;
  if (call6035 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6036 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6037 == NULL) {
    strlit6037 = alloc_String(")");
    gc_root(strlit6037);
  }
// compiled string node returning strlit6037 (depth = 4)
  gc_frame_newslot(strlit6037);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit6037;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6038 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6036);
// compiled call node returning call6038 (depth = 3)
// Begin line 1908
  setline(1908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6039 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6040 == NULL) {
    strlit6040 = alloc_String("a method request beginning with a '(' must end with a ')'.");
    gc_root(strlit6040);
  }
// compiled string node returning strlit6040 (depth = 4)
  gc_frame_newslot(strlit6040);
// Begin line 1909
  setline(1909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6041 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call6042 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6041);
// compiled member node returning call6042 (depth = 4)
  gc_frame_newslot(call6042);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6044 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call6045 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6044);
// compiled member node returning call6045 (depth = 5)
  int op_slot_right_6043 = gc_frame_newslot(call6045);
// starting to compile member node (depth = 5)
  int callframe6047 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call6048 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6047);
// compiled member node returning call6048 (depth = 5)
  int op_slot_left_6043 = gc_frame_newslot(call6048);
  params[0] = call6045;
  partcv[0] = 1;
  Object sum6049 = callmethod(call6048, "+(1)", 1, partcv, params);
// compiled op node returning sum6049 (depth = 4)
  gc_frame_newslot(sum6049);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1908
  setline(1908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit6040;
  params[1] = call6042;
  params[2] = sum6049;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6050 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6039);
// compiled call node returning call6050 (depth = 3)
    gc_frame_newslot(call6050);
    if6023 = call6050;
  } else {
  }
// compiled if node returning if6023 (depth = 2)
// Begin line 1911
  setline(1911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6053 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  Object call6054 = callmethodflags(*var_part, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6053);
// compiled member node returning call6054 (depth = 4)
  int op_slot_right_6052 = gc_frame_newslot(call6054);
// starting to compile member node (depth = 4)
  int callframe6056 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call6057 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6056);
// compiled member node returning call6057 (depth = 4)
  int op_slot_left_6052 = gc_frame_newslot(call6057);
  params[0] = call6054;
  partcv[0] = 1;
  Object opresult6058 = callmethod(call6057, "==(1)", 1, partcv, params);
// compiled op node returning opresult6058 (depth = 3)
  Object if6051 = done;
  if (istrue(opresult6058)) {
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6059 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6061 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  Object call6062 = callmethodflags(*var_part, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6061);
// compiled member node returning call6062 (depth = 5)
  int op_slot_right_6060 = gc_frame_newslot(call6062);
// starting to compile member node (depth = 5)
  int callframe6064 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call6065 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6064);
// compiled member node returning call6065 (depth = 5)
  int op_slot_left_6060 = gc_frame_newslot(call6065);
  params[0] = call6062;
  partcv[0] = 1;
  Object diff6066 = callmethod(call6065, "-(1)", 1, partcv, params);
// compiled op node returning diff6066 (depth = 4)
  gc_frame_newslot(diff6066);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = diff6066;
  partcv[0] = 1;
  Object call6067 = callmethodflags(*var_part, "lineLength:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6059);
// compiled call node returning call6067 (depth = 3)
    gc_frame_newslot(call6067);
    if6051 = call6067;
  } else {
  }
// compiled if node returning if6051 (depth = 2)
// Begin line 1914
  setline(1914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe6068 = gc_frame_new();
// call case 4: self request
  Object call6069 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6068);
// compiled member node returning call6069 (depth = 2)
  gc_frame_end(frame);
  return call6069;
}
Object meth_parser__apply6086(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
  int callframe6087 = gc_frame_new();
// call case 4: self request
  Object call6088 = callmethodflags(self, "typeArg", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6087);
// compiled member node returning call6088 (depth = 6)
  gc_frame_end(frame);
  return call6088;
}
Object meth_parser__apply6083(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe6084 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6085 = alloc_Block(NULL, NULL, "parser", 1923);
  gc_frame_newslot(block6085);
// method "_apply"
  block_savedest(block6085);
  Object closure6086 = createclosure(1, "_apply");
  setclosureframe(closure6086, stackframe);
  addtoclosure(closure6086, selfslot);
  struct UserObject *uo6086 = (struct UserObject*)block6085;
  uo6086->data[0] = (Object)closure6086;
  Method *meth_meth_parser__apply6086 = addmethod2pos(block6085, "_apply", &meth_parser__apply6086, 0);
  int argcv_meth_parser__apply6086[] = {0};
  meth_meth_parser__apply6086->type = alloc_MethodType(1, argcv_meth_parser__apply6086);
  meth_meth_parser__apply6086->definitionModule = modulename;
  meth_meth_parser__apply6086->definitionLine = 3399;
// compiled block node returning block6085 (depth = 5)
  gc_frame_newslot(block6085);
// call case 4: self request
  params[0] = block6085;
  partcv[0] = 1;
  Object call6090 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6084);
// compiled call node returning call6090 (depth = 4)
  gc_frame_end(frame);
  return call6090;
}
Object meth_parser__apply6093(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_args = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1924
  setline(1924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6094 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6095 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call6096 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe6095);
// compiled member node returning call6096 (depth = 5)
  gc_frame_newslot(call6096);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_args (depth = 5)
  params[0] = call6096;
  partcv[0] = 1;
  Object call6097 = callmethodflags(*var_args, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6094);
// compiled call node returning call6097 (depth = 4)
// Begin line 1925
  setline(1925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6100 == NULL) {
    strlit6100 = alloc_String("comma");
    gc_root(strlit6100);
  }
// compiled string node returning strlit6100 (depth = 6)
  int op_slot_right_6099 = gc_frame_newslot(strlit6100);
// starting to compile member node (depth = 6)
  int callframe6102 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call6103 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6102);
// compiled member node returning call6103 (depth = 6)
  int op_slot_left_6099 = gc_frame_newslot(call6103);
  params[0] = strlit6100;
  partcv[0] = 1;
  Object opresult6104 = callmethod(call6103, "==(1)", 1, partcv, params);
// compiled op node returning opresult6104 (depth = 5)
  Object if6098 = done;
  if (istrue(opresult6104)) {
// starting to compile member node (depth = 5)
  int callframe6105 = gc_frame_new();
// call case 4: self request
  Object call6106 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6105);
// compiled member node returning call6106 (depth = 5)
    gc_frame_newslot(call6106);
    if6098 = call6106;
  } else {
  }
// compiled if node returning if6098 (depth = 4)
  gc_frame_end(frame);
  return if6098;
}
Object meth_parser_typeArgs6070(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 46, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeArgs");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_startToken = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "startToken");
  Object *var_args = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "args");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestions");
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_startToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1920
  setline(1920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array6071 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6071 (depth = 3)
  *var_args = array6071;
  if (array6071 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1921
  setline(1921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6074 == NULL) {
    strlit6074 = alloc_String("lgeneric");
    gc_root(strlit6074);
  }
// compiled string node returning strlit6074 (depth = 4)
  int op_slot_right_6073 = gc_frame_newslot(strlit6074);
// starting to compile member node (depth = 4)
  int callframe6076 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call6077 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6076);
// compiled member node returning call6077 (depth = 4)
  int op_slot_left_6073 = gc_frame_newslot(call6077);
  params[0] = strlit6074;
  partcv[0] = 1;
  Object opresult6078 = callmethod(call6077, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6078 (depth = 3)
  Object if6072 = done;
  if (istrue(opresult6078)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_args (depth = 4)
  return *var_args;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if6072 = undefined;
  } else {
  }
// compiled if node returning if6072 (depth = 2)
// Begin line 1922
  setline(1922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe6079 = gc_frame_new();
// call case 4: self request
  Object call6080 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6079);
// compiled member node returning call6080 (depth = 2)
// Begin line 1923
  setline(1923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6081 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block6082 = alloc_Block(NULL, NULL, "parser", 1923);
  gc_frame_newslot(block6082);
// method "_apply"
  block_savedest(block6082);
  Object closure6083 = createclosure(1, "_apply");
  setclosureframe(closure6083, stackframe);
  addtoclosure(closure6083, selfslot);
  struct UserObject *uo6083 = (struct UserObject*)block6082;
  uo6083->data[0] = (Object)closure6083;
  Method *meth_meth_parser__apply6083 = addmethod2pos(block6082, "_apply", &meth_parser__apply6083, 0);
  int argcv_meth_parser__apply6083[] = {0};
  meth_meth_parser__apply6083->type = alloc_MethodType(1, argcv_meth_parser__apply6083);
  meth_meth_parser__apply6083->definitionModule = modulename;
  meth_meth_parser__apply6083->definitionLine = 3399;
// compiled block node returning block6082 (depth = 3)
  gc_frame_newslot(block6082);
// starting to compile block node (depth = 3)
  Object block6092 = alloc_Block(NULL, NULL, "parser", 1923);
  gc_frame_newslot(block6092);
// method "_apply"
  block_savedest(block6092);
  Object closure6093 = createclosure(4, "_apply");
  setclosureframe(closure6093, stackframe);
  addtoclosure(closure6093, var_values);
  addtoclosure(closure6093, var_args);
  addtoclosure(closure6093, var_sym);
  addtoclosure(closure6093, selfslot);
  struct UserObject *uo6093 = (struct UserObject*)block6092;
  uo6093->data[0] = (Object)closure6093;
  Method *meth_meth_parser__apply6093 = addmethod2pos(block6092, "_apply", &meth_parser__apply6093, 0);
  int argcv_meth_parser__apply6093[] = {0};
  meth_meth_parser__apply6093->type = alloc_MethodType(1, argcv_meth_parser__apply6093);
  meth_meth_parser__apply6093->definitionModule = modulename;
  meth_meth_parser__apply6093->definitionLine = 3399;
// compiled block node returning block6092 (depth = 3)
  gc_frame_newslot(block6092);
// call case 5: prelude request
  params[0] = block6082;
  params[1] = block6092;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6108 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6081);
// compiled call node returning call6108 (depth = 2)
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6111 == NULL) {
    strlit6111 = alloc_String("rgeneric");
    gc_root(strlit6111);
  }
// compiled string node returning strlit6111 (depth = 4)
  int op_slot_right_6110 = gc_frame_newslot(strlit6111);
// starting to compile member node (depth = 4)
  int callframe6113 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call6114 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6113);
// compiled member node returning call6114 (depth = 4)
  int op_slot_left_6110 = gc_frame_newslot(call6114);
  params[0] = strlit6111;
  partcv[0] = 1;
  Object opresult6115 = callmethod(call6114, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6115 (depth = 3)
  Object if6109 = done;
  if (istrue(opresult6115)) {
// Begin line 1928
  setline(1928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6116 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6117 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call6118 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6117);
// compiled member node returning call6118 (depth = 5)
  Object call6119 = callmethodflags(call6118, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6116);
// compiled member node returning call6119 (depth = 4)
  *var_suggestion = call6119;
  if (call6119 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6120 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6121 == NULL) {
    strlit6121 = alloc_String(">");
    gc_root(strlit6121);
  }
// compiled string node returning strlit6121 (depth = 4)
  gc_frame_newslot(strlit6121);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit6121;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6122 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6120);
// compiled call node returning call6122 (depth = 3)
// Begin line 1930
  setline(1930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6123 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6124 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call6125 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6124);
// compiled member node returning call6125 (depth = 5)
  Object call6126 = callmethodflags(call6125, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6123);
// compiled member node returning call6126 (depth = 4)
  *var_suggestion2 = call6126;
  if (call6126 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1931
  setline(1931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6127 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6128 == NULL) {
    strlit6128 = alloc_String(" ");
    gc_root(strlit6128);
  }
// compiled string node returning strlit6128 (depth = 4)
  gc_frame_newslot(strlit6128);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startToken (depth = 4)
  gc_frame_newslot(*var_startToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion2 (depth = 4)
  params[0] = strlit6128;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6129 = callmethodflags(*var_suggestion2, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6127);
// compiled call node returning call6129 (depth = 3)
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array6130 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethodflags(array6130, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion2 (depth = 5)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethodflags(array6130, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array6130 (depth = 4)
  *var_suggestions = array6130;
  if (array6130 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1933
  setline(1933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6131 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1934
  setline(1934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6133 == NULL) {
    strlit6133 = alloc_String("If '<' is intended as an operator, precede it by a space.");
    gc_root(strlit6133);
  }
// compiled string node returning strlit6133 (depth = 5)
  int op_slot_right_6132 = gc_frame_newslot(strlit6133);
// Begin line 1933
  setline(1933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6135 == NULL) {
    strlit6135 = alloc_String("a method request containing a '<' must have a matching '>'. ");
    gc_root(strlit6135);
  }
// compiled string node returning strlit6135 (depth = 5)
  int op_slot_left_6132 = gc_frame_newslot(strlit6135);
  params[0] = strlit6133;
  partcv[0] = 1;
  Object opresult6136 = callmethod(strlit6135, "++(1)", 1, partcv, params);
// compiled op node returning opresult6136 (depth = 4)
  gc_frame_newslot(opresult6136);
// Begin line 1935
  setline(1935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6137 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call6138 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6137);
// compiled member node returning call6138 (depth = 4)
  gc_frame_newslot(call6138);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6140 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call6141 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6140);
// compiled member node returning call6141 (depth = 5)
  int op_slot_right_6139 = gc_frame_newslot(call6141);
// starting to compile member node (depth = 5)
  int callframe6143 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call6144 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6143);
// compiled member node returning call6144 (depth = 5)
  int op_slot_left_6139 = gc_frame_newslot(call6144);
  params[0] = call6141;
  partcv[0] = 1;
  Object sum6145 = callmethod(call6144, "+(1)", 1, partcv, params);
// compiled op node returning sum6145 (depth = 4)
  gc_frame_newslot(sum6145);
// Begin line 1936
  setline(1936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 1933
  setline(1933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult6136;
  params[1] = call6138;
  params[2] = sum6145;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6146 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6131);
// compiled call node returning call6146 (depth = 3)
    gc_frame_newslot(call6146);
    if6109 = call6146;
  } else {
  }
// compiled if node returning if6109 (depth = 2)
// Begin line 1938
  setline(1938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe6147 = gc_frame_new();
// call case 4: self request
  Object call6148 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6147);
// compiled member node returning call6148 (depth = 2)
// Begin line 1939
  setline(1939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_args (depth = 3)
  return *var_args;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser__apply6176(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
  int callframe6177 = gc_frame_new();
// call case 4: self request
  Object call6178 = callmethodflags(self, "dotypeLiteral", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6177);
// compiled member node returning call6178 (depth = 6)
  gc_frame_end(frame);
  return call6178;
}
Object meth_parser_typeArg6149(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 47, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeArg");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1946
  setline(1946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6151 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6152 == NULL) {
    strlit6152 = alloc_String("identifier");
    gc_root(strlit6152);
  }
// compiled string node returning strlit6152 (depth = 4)
  gc_frame_newslot(strlit6152);
// call case 4: self request
  params[0] = strlit6152;
  partcv[0] = 1;
  Object call6153 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6151);
// compiled call node returning call6153 (depth = 3)
  Object if6150 = done;
  if (istrue(call6153)) {
// Begin line 1947
  setline(1947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6154 = gc_frame_new();
// call case 4: self request
  Object call6155 = callmethodflags(self, "identifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6154);
// compiled member node returning call6155 (depth = 3)
// Begin line 1948
  setline(1948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6158 == NULL) {
    strlit6158 = alloc_String("lgeneric");
    gc_root(strlit6158);
  }
// compiled string node returning strlit6158 (depth = 5)
  int op_slot_right_6157 = gc_frame_newslot(strlit6158);
// starting to compile member node (depth = 5)
  int callframe6160 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call6161 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6160);
// compiled member node returning call6161 (depth = 5)
  int op_slot_left_6157 = gc_frame_newslot(call6161);
  params[0] = strlit6158;
  partcv[0] = 1;
  Object opresult6162 = callmethod(call6161, "==(1)", 1, partcv, params);
// compiled op node returning opresult6162 (depth = 4)
  Object if6156 = done;
  if (istrue(opresult6162)) {
// Begin line 1949
  setline(1949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6163 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe6164 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe6165 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call6166 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe6165);
// compiled member node returning call6166 (depth = 6)
  gc_frame_newslot(call6166);
// starting to compile member node (depth = 6)
  int callframe6167 = gc_frame_new();
// call case 4: self request
  Object call6168 = callmethodflags(self, "typeArgs", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6167);
// compiled member node returning call6168 (depth = 6)
  gc_frame_newslot(call6168);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6169 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call6170 = callmethodflags(*var_ast, "genericNode", 0, partcv, params, 0);
  gc_frame_end(callframe6169);
// compiled member node returning call6170 (depth = 6)
  params[0] = call6166;
  params[1] = call6168;
  partcv[0] = 2;
  Object call6171 = callmethodflags(call6170, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6164);
// compiled call node returning call6171 (depth = 5)
  gc_frame_newslot(call6171);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = call6171;
  partcv[0] = 1;
  Object call6172 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6163);
// compiled call node returning call6172 (depth = 4)
    gc_frame_newslot(call6172);
    if6156 = call6172;
  } else {
  }
// compiled if node returning if6156 (depth = 3)
    gc_frame_newslot(if6156);
    if6150 = if6156;
  } else {
// Begin line 1956
  setline(1956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1953
  setline(1953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6174 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6175 = alloc_Block(NULL, NULL, "parser", 1953);
  gc_frame_newslot(block6175);
// method "_apply"
  block_savedest(block6175);
  Object closure6176 = createclosure(1, "_apply");
  setclosureframe(closure6176, stackframe);
  addtoclosure(closure6176, selfslot);
  struct UserObject *uo6176 = (struct UserObject*)block6175;
  uo6176->data[0] = (Object)closure6176;
  Method *meth_meth_parser__apply6176 = addmethod2pos(block6175, "_apply", &meth_parser__apply6176, 0);
  int argcv_meth_parser__apply6176[] = {0};
  meth_meth_parser__apply6176->type = alloc_MethodType(1, argcv_meth_parser__apply6176);
  meth_meth_parser__apply6176->definitionModule = modulename;
  meth_meth_parser__apply6176->definitionLine = 3399;
// compiled block node returning block6175 (depth = 5)
  gc_frame_newslot(block6175);
// call case 4: self request
  params[0] = block6175;
  partcv[0] = 1;
  Object call6180 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6174);
// compiled call node returning call6180 (depth = 4)
  Object if6173 = done;
  if (istrue(call6180)) {
    gc_frame_newslot(done);
    if6173 = done;
  } else {
  }
// compiled if node returning if6173 (depth = 3)
    gc_frame_newslot(if6173);
    if6150 = if6173;
  }
// compiled if node returning if6150 (depth = 2)
  gc_frame_end(frame);
  return if6150;
}
Object meth_parser__apply6188(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6190 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6191 == NULL) {
    strlit6191 = alloc_String("identifier");
    gc_root(strlit6191);
  }
// compiled string node returning strlit6191 (depth = 6)
  gc_frame_newslot(strlit6191);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = strlit6191;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6192 = callmethodflags(self, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6190);
// compiled call node returning call6192 (depth = 5)
  int op_slot_right_6189 = gc_frame_newslot(call6192);
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6194 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6195 == NULL) {
    strlit6195 = alloc_String("identifier");
    gc_root(strlit6195);
  }
// compiled string node returning strlit6195 (depth = 6)
  gc_frame_newslot(strlit6195);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6195;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6196 = callmethodflags(self, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6194);
// compiled call node returning call6196 (depth = 5)
  int op_slot_left_6189 = gc_frame_newslot(call6196);
  params[0] = call6192;
  partcv[0] = 1;
  Object opresult6197 = callmethod(call6196, "||(1)", 1, partcv, params);
// compiled op node returning opresult6197 (depth = 4)
  gc_frame_end(frame);
  return opresult6197;
}
Object meth_parser__apply6353(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 10)
  int callframe6354 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_blocksOK (depth = 11)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6355 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6354);
// compiled call node returning call6355 (depth = 10)
  gc_frame_end(frame);
  return call6355;
}
Object meth_parser__apply6406(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe6407 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6408 == NULL) {
    strlit6408 = alloc_String("comma");
    gc_root(strlit6408);
  }
// compiled string node returning strlit6408 (depth = 8)
  gc_frame_newslot(strlit6408);
// call case 4: self request
  params[0] = strlit6408;
  partcv[0] = 1;
  Object call6409 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6407);
// compiled call node returning call6409 (depth = 7)
  gc_frame_end(frame);
  return call6409;
}
Object meth_parser__apply6426(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe6427 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6428 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6427);
// compiled call node returning call6428 (depth = 11)
  gc_frame_end(frame);
  return call6428;
}
Object meth_parser__apply6412(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_nxt = getfromclosure(closure, 1);
  Object *var_part = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// starting to compile bind node (depth = 7)
// Begin line 2035
  setline(2035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe6413 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  Object call6414 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe6413);
// compiled member node returning call6414 (depth = 8)
  *var_nxt = call6414;
  if (call6414 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 2036
  setline(2036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6416 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  gc_frame_newslot(*var_nxt);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe6417 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  Object call6418 = callmethodflags(*var_part, "args", 0, partcv, params, 0);
  gc_frame_end(callframe6417);
// compiled member node returning call6418 (depth = 8)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call6419 = callmethodflags(call6418, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6416);
// compiled call node returning call6419 (depth = 7)
// Begin line 2037
  setline(2037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe6420 = gc_frame_new();
// call case 4: self request
  Object call6421 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6420);
// compiled member node returning call6421 (depth = 7)
// Begin line 2038
  setline(2038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe6423 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 9)
  int callframe6424 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block6425 = alloc_Block(NULL, NULL, "parser", 2038);
  gc_frame_newslot(block6425);
// method "_apply"
  block_savedest(block6425);
  Object closure6426 = createclosure(2, "_apply");
  setclosureframe(closure6426, stackframe);
  addtoclosure(closure6426, var_blocksOK);
  addtoclosure(closure6426, selfslot);
  struct UserObject *uo6426 = (struct UserObject*)block6425;
  uo6426->data[0] = (Object)closure6426;
  Method *meth_meth_parser__apply6426 = addmethod2pos(block6425, "_apply", &meth_parser__apply6426, 0);
  int argcv_meth_parser__apply6426[] = {0};
  meth_meth_parser__apply6426->type = alloc_MethodType(1, argcv_meth_parser__apply6426);
  meth_meth_parser__apply6426->definitionModule = modulename;
  meth_meth_parser__apply6426->definitionLine = 3399;
// compiled block node returning block6425 (depth = 10)
  gc_frame_newslot(block6425);
// call case 4: self request
  params[0] = block6425;
  partcv[0] = 1;
  Object call6430 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6424);
// compiled call node returning call6430 (depth = 9)
  Object call6431 = callmethodflags(call6430, "not", 0, partcv, params, 0);
  gc_frame_end(callframe6423);
// compiled member node returning call6431 (depth = 8)
  Object if6422 = done;
  if (istrue(call6431)) {
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile array node (depth = 9)
  Object array6432 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6432 (depth = 9)
  *var_suggestions = array6432;
  if (array6432 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 2040
  setline(2040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe6433 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe6434 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call6435 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6434);
// compiled member node returning call6435 (depth = 10)
  Object call6436 = callmethodflags(call6435, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6433);
// compiled member node returning call6436 (depth = 9)
  *var_suggestion = call6436;
  if (call6436 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6437 = gc_frame_new();
// starting to compile array node (depth = 10)
  Object array6438 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 11)
  if (strlit6439 == NULL) {
    strlit6439 = alloc_String("rparen");
    gc_root(strlit6439);
  }
// compiled string node returning strlit6439 (depth = 11)
  params[0] = strlit6439;
  partcv[0] = 1;
  callmethodflags(array6438, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array6438 (depth = 10)
  gc_frame_newslot(array6438);
// call case 4: self request
  params[0] = array6438;
  partcv[0] = 1;
  Object call6440 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6437);
// compiled call node returning call6440 (depth = 9)
  *var_nextTok = call6440;
  if (call6440 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 2042
  setline(2042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_6442 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_6442 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6444 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult6444 (depth = 9)
  Object if6441 = done;
  if (istrue(opresult6444)) {
// Begin line 2043
  setline(2043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6445 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6446 == NULL) {
    strlit6446 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6446);
  }
// compiled string node returning strlit6446 (depth = 10)
  gc_frame_newslot(strlit6446);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit6446;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6447 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6445);
// compiled call node returning call6447 (depth = 9)
    gc_frame_newslot(call6447);
    if6441 = call6447;
  } else {
// Begin line 2045
  setline(2045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6448 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
  int callframe6449 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  Object call6450 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe6449);
// compiled member node returning call6450 (depth = 10)
  gc_frame_newslot(call6450);
// starting to compile identifier node (depth = 10)
  Object bool6451 = alloc_Boolean(1);
// compiled identifier node returning bool6451 (depth = 10)
  gc_frame_newslot(bool6451);
// starting to compile identifier node (depth = 10)
  Object bool6452 = alloc_Boolean(0);
// compiled identifier node returning bool6452 (depth = 10)
  gc_frame_newslot(bool6452);
// starting to compile string node (depth = 10)
  if (strlit6453 == NULL) {
    strlit6453 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6453);
  }
// compiled string node returning strlit6453 (depth = 10)
  gc_frame_newslot(strlit6453);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call6450;
  params[2] = bool6451;
  params[3] = bool6452;
  params[4] = strlit6453;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6454 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe6448);
// compiled call node returning call6454 (depth = 9)
    gc_frame_newslot(call6454);
    if6441 = call6454;
  }
// compiled if node returning if6441 (depth = 8)
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6455 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6456 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6455);
// compiled call node returning call6456 (depth = 8)
// Begin line 2048
  setline(2048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe6457 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe6458 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call6459 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6458);
// compiled member node returning call6459 (depth = 10)
  Object call6460 = callmethodflags(call6459, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6457);
// compiled member node returning call6460 (depth = 9)
  *var_suggestion = call6460;
  if (call6460 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 2049
  setline(2049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6462 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
  int callframe6463 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call6464 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe6463);
// compiled member node returning call6464 (depth = 9)
  gc_frame_newslot(call6464);
// starting to compile identifier node (depth = 9)
  Object bool6465 = alloc_Boolean(1);
// compiled identifier node returning bool6465 (depth = 9)
  gc_frame_newslot(bool6465);
// starting to compile identifier node (depth = 9)
  Object bool6466 = alloc_Boolean(0);
// compiled identifier node returning bool6466 (depth = 9)
  gc_frame_newslot(bool6466);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call6464;
  params[2] = bool6465;
  params[3] = bool6466;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6467 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6462);
// compiled call node returning call6467 (depth = 8)
// Begin line 2050
  setline(2050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6468 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6469 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6468);
// compiled call node returning call6469 (depth = 8)
// Begin line 2051
  setline(2051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6470 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6471 == NULL) {
    strlit6471 = alloc_String("a method request must have an expression after a ','.");
    gc_root(strlit6471);
  }
// compiled string node returning strlit6471 (depth = 9)
  gc_frame_newslot(strlit6471);
// Begin line 2052
  setline(2052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe6472 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call6473 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6472);
// compiled member node returning call6473 (depth = 9)
  gc_frame_newslot(call6473);
// starting to compile member node (depth = 9)
  int callframe6474 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call6475 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6474);
// compiled member node returning call6475 (depth = 9)
  gc_frame_newslot(call6475);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2051
  setline(2051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6471;
  params[1] = call6473;
  params[2] = call6475;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6476 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6470);
// compiled call node returning call6476 (depth = 8)
    gc_frame_newslot(call6476);
    if6422 = call6476;
  } else {
  }
// compiled if node returning if6422 (depth = 7)
  gc_frame_end(frame);
  return if6422;
}
Object meth_parser__apply6200(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_ast = getfromclosure(closure, 0);
  Object *var_part = getfromclosure(closure, 1);
  Object *var_signature = getfromclosure(closure, 2);
  Object *var_methname = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_nxt = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object *var_errormessages = getfromclosure(closure, 7);
  Object *var_sym = getfromclosure(closure, 8);
  Object *var_blocksOK = getfromclosure(closure, 9);
  Object self = *(getfromclosure(closure, 10));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_isTerm = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "isTerm");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_isEmpty = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "isEmpty");
  Object *var_suggestions = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestions");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// starting to compile bind node (depth = 4)
// Begin line 1971
  setline(1971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6201 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6202 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call6203 = callmethodflags(*var_ast, "requestPart", 0, partcv, params, 0);
  gc_frame_end(callframe6202);
// compiled member node returning call6203 (depth = 6)
  Object call6204 = callmethodflags(call6203, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6201);
// compiled member node returning call6204 (depth = 5)
  *var_part = call6204;
  if (call6204 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6206 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  gc_frame_newslot(*var_part);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call6207 = callmethodflags(*var_signature, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6206);
// compiled call node returning call6207 (depth = 4)
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6209 == NULL) {
    strlit6209 = alloc_String("()");
    gc_root(strlit6209);
  }
// compiled string node returning strlit6209 (depth = 6)
  int op_slot_right_6208 = gc_frame_newslot(strlit6209);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methname (depth = 6)
  int op_slot_left_6208 = gc_frame_newslot(*var_methname);
  params[0] = strlit6209;
  partcv[0] = 1;
  Object opresult6211 = callmethod(*var_methname, "++(1)", 1, partcv, params);
// compiled op node returning opresult6211 (depth = 5)
  *var_methname = opresult6211;
  if (opresult6211 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1974
  setline(1974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6213 = gc_frame_new();
// call case 4: self request
  Object call6214 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6213);
// compiled member node returning call6214 (depth = 4)
// Begin line 1975
  setline(1975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6215 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call6216 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe6215);
// compiled member node returning call6216 (depth = 5)
  *var_nxt = call6216;
  if (call6216 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1976
  setline(1976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6219 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nxt (depth = 7)
  Object call6220 = callmethodflags(*var_nxt, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6219);
// compiled member node returning call6220 (depth = 6)
  int op_slot_right_6218 = gc_frame_newslot(call6220);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methname (depth = 6)
  int op_slot_left_6218 = gc_frame_newslot(*var_methname);
  params[0] = call6220;
  partcv[0] = 1;
  Object opresult6222 = callmethod(*var_methname, "++(1)", 1, partcv, params);
// compiled op node returning opresult6222 (depth = 5)
  *var_methname = opresult6222;
  if (opresult6222 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1977
  setline(1977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6224 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6225 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nxt (depth = 6)
  Object call6226 = callmethodflags(*var_nxt, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6225);
// compiled member node returning call6226 (depth = 5)
  gc_frame_newslot(call6226);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = call6226;
  partcv[0] = 1;
  Object call6227 = callmethodflags(*var_part, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6224);
// compiled call node returning call6227 (depth = 4)
// Begin line 1978
  setline(1978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6228 = alloc_Boolean(0);
// compiled identifier node returning bool6228 (depth = 5)
  *var_isTerm = bool6228;
  if (bool6228 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1979
  setline(1979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6230 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6231 == NULL) {
    strlit6231 = alloc_String("lparen");
    gc_root(strlit6231);
  }
// compiled string node returning strlit6231 (depth = 6)
  gc_frame_newslot(strlit6231);
// call case 4: self request
  params[0] = strlit6231;
  partcv[0] = 1;
  Object call6232 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6230);
// compiled call node returning call6232 (depth = 5)
  Object if6229 = done;
  if (istrue(call6232)) {
// Begin line 1980
  setline(1980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6233 = gc_frame_new();
// call case 4: self request
  Object call6234 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6233);
// compiled member node returning call6234 (depth = 5)
    gc_frame_newslot(call6234);
    if6229 = call6234;
  } else {
// Begin line 1983
  setline(1983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1981
  setline(1981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6236 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call6237 = callmethodflags(self, "acceptArgumentOnLineOf(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6236);
// compiled call node returning call6237 (depth = 6)
  Object if6235 = done;
  if (istrue(call6237)) {
// Begin line 1982
  setline(1982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool6238 = alloc_Boolean(1);
// compiled identifier node returning bool6238 (depth = 7)
  *var_isTerm = bool6238;
  if (bool6238 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if6235 = done;
  } else {
// Begin line 1984
  setline(1984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6240 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe6241 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call6242 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6241);
// compiled member node returning call6242 (depth = 8)
  Object call6243 = callmethodflags(call6242, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6240);
// compiled member node returning call6243 (depth = 7)
  *var_suggestion = call6243;
  if (call6243 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 1985
  setline(1985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6246 == NULL) {
    strlit6246 = alloc_String("identifier");
    gc_root(strlit6246);
  }
// compiled string node returning strlit6246 (depth = 8)
  int op_slot_right_6245 = gc_frame_newslot(strlit6246);
// starting to compile member node (depth = 8)
  int callframe6248 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call6249 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6248);
// compiled member node returning call6249 (depth = 8)
  int op_slot_left_6245 = gc_frame_newslot(call6249);
  params[0] = strlit6246;
  partcv[0] = 1;
  Object opresult6250 = callmethod(call6249, "==(1)", 1, partcv, params);
// compiled op node returning opresult6250 (depth = 7)
  Object if6244 = done;
  if (istrue(opresult6250)) {
// Begin line 1986
  setline(1986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6251 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool6252 = alloc_Boolean(1);
// compiled identifier node returning bool6252 (depth = 8)
  gc_frame_newslot(bool6252);
// starting to compile identifier node (depth = 8)
  Object bool6253 = alloc_Boolean(0);
// compiled identifier node returning bool6253 (depth = 8)
  gc_frame_newslot(bool6253);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6255 == NULL) {
    strlit6255 = alloc_String(")");
    gc_root(strlit6255);
  }
// compiled string node returning strlit6255 (depth = 9)
  int op_slot_right_6254 = gc_frame_newslot(strlit6255);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe6258 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call6259 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6258);
// compiled member node returning call6259 (depth = 10)
  int op_slot_right_6257 = gc_frame_newslot(call6259);
// starting to compile string node (depth = 10)
  if (strlit6261 == NULL) {
    strlit6261 = alloc_String("(");
    gc_root(strlit6261);
  }
// compiled string node returning strlit6261 (depth = 10)
  int op_slot_left_6257 = gc_frame_newslot(strlit6261);
  params[0] = call6259;
  partcv[0] = 1;
  Object opresult6262 = callmethod(strlit6261, "++(1)", 1, partcv, params);
// compiled op node returning opresult6262 (depth = 9)
  int op_slot_left_6254 = gc_frame_newslot(opresult6262);
  params[0] = strlit6255;
  partcv[0] = 1;
  Object opresult6263 = callmethod(opresult6262, "++(1)", 1, partcv, params);
// compiled op node returning opresult6263 (depth = 8)
  gc_frame_newslot(opresult6263);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool6252;
  params[2] = bool6253;
  params[3] = opresult6263;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6264 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe6251);
// compiled call node returning call6264 (depth = 7)
// Begin line 1987
  setline(1987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6267 == NULL) {
    strlit6267 = alloc_String("while()do");
    gc_root(strlit6267);
  }
// compiled string node returning strlit6267 (depth = 9)
  int op_slot_right_6266 = gc_frame_newslot(strlit6267);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_methname (depth = 9)
  int op_slot_left_6266 = gc_frame_newslot(*var_methname);
  params[0] = strlit6267;
  partcv[0] = 1;
  Object opresult6269 = callmethod(*var_methname, "==(1)", 1, partcv, params);
// compiled op node returning opresult6269 (depth = 8)
  Object if6265 = done;
  if (istrue(opresult6269)) {
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6270 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6271 == NULL) {
    strlit6271 = alloc_String("a while loop must have either a loop body in braces, or a block in parentheses.");
    gc_root(strlit6271);
  }
// compiled string node returning strlit6271 (depth = 9)
  gc_frame_newslot(strlit6271);
// Begin line 1989
  setline(1989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe6272 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call6273 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6272);
// compiled member node returning call6273 (depth = 9)
  gc_frame_newslot(call6273);
// starting to compile member node (depth = 9)
  int callframe6274 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call6275 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6274);
// compiled member node returning call6275 (depth = 9)
  gc_frame_newslot(call6275);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6271;
  params[1] = call6273;
  params[2] = call6275;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6276 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6270);
// compiled call node returning call6276 (depth = 8)
    gc_frame_newslot(call6276);
    if6265 = call6276;
  } else {
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 1990
  setline(1990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6279 == NULL) {
    strlit6279 = alloc_String("for()do");
    gc_root(strlit6279);
  }
// compiled string node returning strlit6279 (depth = 10)
  int op_slot_right_6278 = gc_frame_newslot(strlit6279);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_methname (depth = 10)
  int op_slot_left_6278 = gc_frame_newslot(*var_methname);
  params[0] = strlit6279;
  partcv[0] = 1;
  Object opresult6281 = callmethod(*var_methname, "==(1)", 1, partcv, params);
// compiled op node returning opresult6281 (depth = 9)
  Object if6277 = done;
  if (istrue(opresult6281)) {
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6282 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6283 == NULL) {
    strlit6283 = alloc_String("a for loop must have either a loop body in braces, or a block in parentheses.");
    gc_root(strlit6283);
  }
// compiled string node returning strlit6283 (depth = 10)
  gc_frame_newslot(strlit6283);
// Begin line 1992
  setline(1992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe6284 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call6285 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6284);
// compiled member node returning call6285 (depth = 10)
  gc_frame_newslot(call6285);
// starting to compile member node (depth = 10)
  int callframe6286 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call6287 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6286);
// compiled member node returning call6287 (depth = 10)
  gc_frame_newslot(call6287);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit6283;
  params[1] = call6285;
  params[2] = call6287;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6288 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6282);
// compiled call node returning call6288 (depth = 9)
    gc_frame_newslot(call6288);
    if6277 = call6288;
  } else {
  }
// compiled if node returning if6277 (depth = 8)
    gc_frame_newslot(if6277);
    if6265 = if6277;
  }
// compiled if node returning if6265 (depth = 7)
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6289 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6290 == NULL) {
    strlit6290 = alloc_String("each argument list in a multi-part method request must be parenthesized, unless it is self-delimiting.");
    gc_root(strlit6290);
  }
// compiled string node returning strlit6290 (depth = 8)
  gc_frame_newslot(strlit6290);
// Begin line 1995
  setline(1995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe6291 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call6292 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6291);
// compiled member node returning call6292 (depth = 8)
  gc_frame_newslot(call6292);
// starting to compile member node (depth = 8)
  int callframe6293 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call6294 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6293);
// compiled member node returning call6294 (depth = 8)
  gc_frame_newslot(call6294);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6290;
  params[1] = call6292;
  params[2] = call6294;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6295 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6289);
// compiled call node returning call6295 (depth = 7)
    gc_frame_newslot(call6295);
    if6244 = call6295;
  } else {
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6298 == NULL) {
    strlit6298 = alloc_String("while()do");
    gc_root(strlit6298);
  }
// compiled string node returning strlit6298 (depth = 9)
  int op_slot_right_6297 = gc_frame_newslot(strlit6298);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_methname (depth = 9)
  int op_slot_left_6297 = gc_frame_newslot(*var_methname);
  params[0] = strlit6298;
  partcv[0] = 1;
  Object opresult6300 = callmethod(*var_methname, "==(1)", 1, partcv, params);
// compiled op node returning opresult6300 (depth = 8)
  Object if6296 = done;
  if (istrue(opresult6300)) {
// Begin line 1998
  setline(1998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6301 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6302 == NULL) {
    strlit6302 = alloc_String(" {}");
    gc_root(strlit6302);
  }
// compiled string node returning strlit6302 (depth = 9)
  gc_frame_newslot(strlit6302);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit6302;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6303 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6301);
// compiled call node returning call6303 (depth = 8)
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6304 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6305 == NULL) {
    strlit6305 = alloc_String("a while loop must have a body.");
    gc_root(strlit6305);
  }
// compiled string node returning strlit6305 (depth = 9)
  gc_frame_newslot(strlit6305);
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe6306 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call6307 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6306);
// compiled member node returning call6307 (depth = 9)
  gc_frame_newslot(call6307);
// starting to compile member node (depth = 9)
  int callframe6308 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call6309 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6308);
// compiled member node returning call6309 (depth = 9)
  gc_frame_newslot(call6309);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6305;
  params[1] = call6307;
  params[2] = call6309;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6310 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6304);
// compiled call node returning call6310 (depth = 8)
    gc_frame_newslot(call6310);
    if6296 = call6310;
  } else {
// Begin line 2005
  setline(2005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 2001
  setline(2001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6313 == NULL) {
    strlit6313 = alloc_String("for()do");
    gc_root(strlit6313);
  }
// compiled string node returning strlit6313 (depth = 10)
  int op_slot_right_6312 = gc_frame_newslot(strlit6313);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_methname (depth = 10)
  int op_slot_left_6312 = gc_frame_newslot(*var_methname);
  params[0] = strlit6313;
  partcv[0] = 1;
  Object opresult6315 = callmethod(*var_methname, "==(1)", 1, partcv, params);
// compiled op node returning opresult6315 (depth = 9)
  Object if6311 = done;
  if (istrue(opresult6315)) {
// Begin line 2002
  setline(2002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6316 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6317 == NULL) {
    strlit6317 = alloc_String(" {}");
    gc_root(strlit6317);
  }
// compiled string node returning strlit6317 (depth = 10)
  gc_frame_newslot(strlit6317);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit6317;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6318 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6316);
// compiled call node returning call6318 (depth = 9)
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6319 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6320 == NULL) {
    strlit6320 = alloc_String("a for loop must have a body.");
    gc_root(strlit6320);
  }
// compiled string node returning strlit6320 (depth = 10)
  gc_frame_newslot(strlit6320);
// Begin line 2004
  setline(2004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe6321 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call6322 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6321);
// compiled member node returning call6322 (depth = 10)
  gc_frame_newslot(call6322);
// starting to compile member node (depth = 10)
  int callframe6323 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call6324 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6323);
// compiled member node returning call6324 (depth = 10)
  gc_frame_newslot(call6324);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit6320;
  params[1] = call6322;
  params[2] = call6324;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6325 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6319);
// compiled call node returning call6325 (depth = 9)
    gc_frame_newslot(call6325);
    if6311 = call6325;
  } else {
// Begin line 2006
  setline(2006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6326 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6327 == NULL) {
    strlit6327 = alloc_String("()");
    gc_root(strlit6327);
  }
// compiled string node returning strlit6327 (depth = 10)
  gc_frame_newslot(strlit6327);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit6327;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6328 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6326);
// compiled call node returning call6328 (depth = 9)
// Begin line 2007
  setline(2007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6329 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6330 == NULL) {
    strlit6330 = alloc_String("a multi-part method request must end with '()'.");
    gc_root(strlit6330);
  }
// compiled string node returning strlit6330 (depth = 10)
  gc_frame_newslot(strlit6330);
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe6331 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call6332 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6331);
// compiled member node returning call6332 (depth = 10)
  gc_frame_newslot(call6332);
// starting to compile member node (depth = 10)
  int callframe6333 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call6334 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6333);
// compiled member node returning call6334 (depth = 10)
  gc_frame_newslot(call6334);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2007
  setline(2007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit6330;
  params[1] = call6332;
  params[2] = call6334;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6335 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6329);
// compiled call node returning call6335 (depth = 9)
    gc_frame_newslot(call6335);
    if6311 = call6335;
  }
// compiled if node returning if6311 (depth = 8)
    gc_frame_newslot(if6311);
    if6296 = if6311;
  }
// compiled if node returning if6296 (depth = 7)
    gc_frame_newslot(if6296);
    if6244 = if6296;
  }
// compiled if node returning if6244 (depth = 6)
    gc_frame_newslot(if6244);
    if6235 = if6244;
  }
// compiled if node returning if6235 (depth = 5)
    gc_frame_newslot(if6235);
    if6229 = if6235;
  }
// compiled if node returning if6229 (depth = 4)
// Begin line 2012
  setline(2012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6336 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6337 == NULL) {
    strlit6337 = alloc_String("rparen");
    gc_root(strlit6337);
  }
// compiled string node returning strlit6337 (depth = 6)
  gc_frame_newslot(strlit6337);
// call case 4: self request
  params[0] = strlit6337;
  partcv[0] = 1;
  Object call6338 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6336);
// compiled call node returning call6338 (depth = 5)
  *var_isEmpty = call6338;
  if (call6338 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_isTerm (depth = 5)
  Object if6339 = done;
  if (istrue(*var_isTerm)) {
// Begin line 2014
  setline(2014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6340 = gc_frame_new();
// call case 4: self request
  Object call6341 = callmethodflags(self, "term", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6340);
// compiled member node returning call6341 (depth = 5)
    gc_frame_newslot(call6341);
    if6339 = call6341;
  } else {
// Begin line 2016
  setline(2016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6344 == NULL) {
    strlit6344 = alloc_String("rparen");
    gc_root(strlit6344);
  }
// compiled string node returning strlit6344 (depth = 7)
  int op_slot_right_6343 = gc_frame_newslot(strlit6344);
// starting to compile member node (depth = 7)
  int callframe6346 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call6347 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6346);
// compiled member node returning call6347 (depth = 7)
  int op_slot_left_6343 = gc_frame_newslot(call6347);
  params[0] = strlit6344;
  partcv[0] = 1;
  Object opresult6348 = callmethod(call6347, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6348 (depth = 6)
  Object if6342 = done;
  if (istrue(opresult6348)) {
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6350 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe6351 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block6352 = alloc_Block(NULL, NULL, "parser", 2017);
  gc_frame_newslot(block6352);
// method "_apply"
  block_savedest(block6352);
  Object closure6353 = createclosure(2, "_apply");
  setclosureframe(closure6353, stackframe);
  addtoclosure(closure6353, var_blocksOK);
  addtoclosure(closure6353, selfslot);
  struct UserObject *uo6353 = (struct UserObject*)block6352;
  uo6353->data[0] = (Object)closure6353;
  Method *meth_meth_parser__apply6353 = addmethod2pos(block6352, "_apply", &meth_parser__apply6353, 0);
  int argcv_meth_parser__apply6353[] = {0};
  meth_meth_parser__apply6353->type = alloc_MethodType(1, argcv_meth_parser__apply6353);
  meth_meth_parser__apply6353->definitionModule = modulename;
  meth_meth_parser__apply6353->definitionLine = 3399;
// compiled block node returning block6352 (depth = 9)
  gc_frame_newslot(block6352);
// call case 4: self request
  params[0] = block6352;
  partcv[0] = 1;
  Object call6357 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6351);
// compiled call node returning call6357 (depth = 8)
  Object call6358 = callmethodflags(call6357, "not", 0, partcv, params, 0);
  gc_frame_end(callframe6350);
// compiled member node returning call6358 (depth = 7)
  Object if6349 = done;
  if (istrue(call6358)) {
// Begin line 2018
  setline(2018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile array node (depth = 8)
  Object array6359 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6359 (depth = 8)
  *var_suggestions = array6359;
  if (array6359 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 2019
  setline(2019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe6360 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe6361 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call6362 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6361);
// compiled member node returning call6362 (depth = 9)
  Object call6363 = callmethodflags(call6362, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6360);
// compiled member node returning call6363 (depth = 8)
  *var_suggestion = call6363;
  if (call6363 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6364 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array6365 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit6366 == NULL) {
    strlit6366 = alloc_String("rparen");
    gc_root(strlit6366);
  }
// compiled string node returning strlit6366 (depth = 10)
  params[0] = strlit6366;
  partcv[0] = 1;
  callmethodflags(array6365, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array6365 (depth = 9)
  gc_frame_newslot(array6365);
// call case 4: self request
  params[0] = array6365;
  partcv[0] = 1;
  Object call6367 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6364);
// compiled call node returning call6367 (depth = 8)
  *var_nextTok = call6367;
  if (call6367 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 2021
  setline(2021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_6369 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_6369 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6371 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult6371 (depth = 8)
  Object if6368 = done;
  if (istrue(opresult6371)) {
// Begin line 2022
  setline(2022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6372 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6373 == NULL) {
    strlit6373 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6373);
  }
// compiled string node returning strlit6373 (depth = 9)
  gc_frame_newslot(strlit6373);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit6373;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6374 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6372);
// compiled call node returning call6374 (depth = 8)
    gc_frame_newslot(call6374);
    if6368 = call6374;
  } else {
// Begin line 2024
  setline(2024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6375 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
  int callframe6376 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call6377 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe6376);
// compiled member node returning call6377 (depth = 9)
  gc_frame_newslot(call6377);
// starting to compile identifier node (depth = 9)
  Object bool6378 = alloc_Boolean(1);
// compiled identifier node returning bool6378 (depth = 9)
  gc_frame_newslot(bool6378);
// starting to compile identifier node (depth = 9)
  Object bool6379 = alloc_Boolean(0);
// compiled identifier node returning bool6379 (depth = 9)
  gc_frame_newslot(bool6379);
// starting to compile string node (depth = 9)
  if (strlit6380 == NULL) {
    strlit6380 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6380);
  }
// compiled string node returning strlit6380 (depth = 9)
  gc_frame_newslot(strlit6380);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call6377;
  params[2] = bool6378;
  params[3] = bool6379;
  params[4] = strlit6380;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6381 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe6375);
// compiled call node returning call6381 (depth = 8)
// Begin line 2025
  setline(2025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6382 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6383 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6382);
// compiled call node returning call6383 (depth = 8)
// Begin line 2026
  setline(2026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe6384 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe6385 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call6386 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6385);
// compiled member node returning call6386 (depth = 10)
  Object call6387 = callmethodflags(call6386, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6384);
// compiled member node returning call6387 (depth = 9)
  *var_suggestion = call6387;
  if (call6387 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 2027
  setline(2027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6389 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
  int callframe6390 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call6391 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe6390);
// compiled member node returning call6391 (depth = 9)
  gc_frame_newslot(call6391);
// starting to compile identifier node (depth = 9)
  Object bool6392 = alloc_Boolean(1);
// compiled identifier node returning bool6392 (depth = 9)
  gc_frame_newslot(bool6392);
// starting to compile identifier node (depth = 9)
  Object bool6393 = alloc_Boolean(0);
// compiled identifier node returning bool6393 (depth = 9)
  gc_frame_newslot(bool6393);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call6391;
  params[2] = bool6392;
  params[3] = bool6393;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6394 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6389);
// compiled call node returning call6394 (depth = 8)
    gc_frame_newslot(call6394);
    if6368 = call6394;
  }
// compiled if node returning if6368 (depth = 7)
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6395 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6396 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6395);
// compiled call node returning call6396 (depth = 7)
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6397 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6398 == NULL) {
    strlit6398 = alloc_String("a method request must have an expression or a ')' after a '('.");
    gc_root(strlit6398);
  }
// compiled string node returning strlit6398 (depth = 8)
  gc_frame_newslot(strlit6398);
// Begin line 2031
  setline(2031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe6399 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call6400 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6399);
// compiled member node returning call6400 (depth = 8)
  gc_frame_newslot(call6400);
// starting to compile member node (depth = 8)
  int callframe6401 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call6402 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6401);
// compiled member node returning call6402 (depth = 8)
  gc_frame_newslot(call6402);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6398;
  params[1] = call6400;
  params[2] = call6402;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6403 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6397);
// compiled call node returning call6403 (depth = 7)
    gc_frame_newslot(call6403);
    if6349 = call6403;
  } else {
  }
// compiled if node returning if6349 (depth = 6)
    gc_frame_newslot(if6349);
    if6342 = if6349;
  } else {
  }
// compiled if node returning if6342 (depth = 5)
// Begin line 2034
  setline(2034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6404 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block6405 = alloc_Block(NULL, NULL, "parser", 2034);
  gc_frame_newslot(block6405);
// method "_apply"
  block_savedest(block6405);
  Object closure6406 = createclosure(1, "_apply");
  setclosureframe(closure6406, stackframe);
  addtoclosure(closure6406, selfslot);
  struct UserObject *uo6406 = (struct UserObject*)block6405;
  uo6406->data[0] = (Object)closure6406;
  Method *meth_meth_parser__apply6406 = addmethod2pos(block6405, "_apply", &meth_parser__apply6406, 0);
  int argcv_meth_parser__apply6406[] = {0};
  meth_meth_parser__apply6406->type = alloc_MethodType(1, argcv_meth_parser__apply6406);
  meth_meth_parser__apply6406->definitionModule = modulename;
  meth_meth_parser__apply6406->definitionLine = 3399;
// compiled block node returning block6405 (depth = 6)
  gc_frame_newslot(block6405);
// starting to compile block node (depth = 6)
  Object block6411 = alloc_Block(NULL, NULL, "parser", 2034);
  gc_frame_newslot(block6411);
// method "_apply"
  block_savedest(block6411);
  Object closure6412 = createclosure(8, "_apply");
  setclosureframe(closure6412, stackframe);
  addtoclosure(closure6412, var_values);
  addtoclosure(closure6412, var_nxt);
  addtoclosure(closure6412, var_part);
  addtoclosure(closure6412, var_blocksOK);
  addtoclosure(closure6412, var_errormessages);
  addtoclosure(closure6412, var_sym);
  addtoclosure(closure6412, var_lastToken);
  addtoclosure(closure6412, selfslot);
  struct UserObject *uo6412 = (struct UserObject*)block6411;
  uo6412->data[0] = (Object)closure6412;
  Method *meth_meth_parser__apply6412 = addmethod2pos(block6411, "_apply", &meth_parser__apply6412, 0);
  int argcv_meth_parser__apply6412[] = {0};
  meth_meth_parser__apply6412->type = alloc_MethodType(1, argcv_meth_parser__apply6412);
  meth_meth_parser__apply6412->definitionModule = modulename;
  meth_meth_parser__apply6412->definitionLine = 3399;
// compiled block node returning block6411 (depth = 6)
  gc_frame_newslot(block6411);
// call case 5: prelude request
  params[0] = block6405;
  params[1] = block6411;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6478 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6404);
// compiled call node returning call6478 (depth = 5)
    gc_frame_newslot(call6478);
    if6339 = call6478;
  }
// compiled if node returning if6339 (depth = 4)
// Begin line 2056
  setline(2056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6480 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_isEmpty (depth = 6)
  partcv[0] = 0;
  Object call6481 = callmethodflags(*var_isEmpty, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe6480);
// compiled call node returning call6481 (depth = 5)
  Object if6479 = done;
  if (istrue(call6481)) {
// Begin line 2057
  setline(2057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6482 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call6483 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe6482);
// compiled member node returning call6483 (depth = 6)
  *var_nxt = call6483;
  if (call6483 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 2058
  setline(2058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6485 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nxt (depth = 6)
  gc_frame_newslot(*var_nxt);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6486 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call6487 = callmethodflags(*var_part, "args", 0, partcv, params, 0);
  gc_frame_end(callframe6486);
// compiled member node returning call6487 (depth = 6)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call6488 = callmethodflags(call6487, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6485);
// compiled call node returning call6488 (depth = 5)
    gc_frame_newslot(call6488);
    if6479 = call6488;
  } else {
  }
// compiled if node returning if6479 (depth = 4)
// Begin line 2060
  setline(2060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6490 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_isTerm (depth = 6)
  Object call6491 = callmethodflags(*var_isTerm, "not", 0, partcv, params, 0);
  gc_frame_end(callframe6490);
// compiled member node returning call6491 (depth = 5)
  Object if6489 = done;
  if (istrue(call6491)) {
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6494 == NULL) {
    strlit6494 = alloc_String("rparen");
    gc_root(strlit6494);
  }
// compiled string node returning strlit6494 (depth = 7)
  int op_slot_right_6493 = gc_frame_newslot(strlit6494);
// starting to compile member node (depth = 7)
  int callframe6496 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call6497 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6496);
// compiled member node returning call6497 (depth = 7)
  int op_slot_left_6493 = gc_frame_newslot(call6497);
  params[0] = strlit6494;
  partcv[0] = 1;
  Object opresult6498 = callmethod(call6497, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6498 (depth = 6)
  Object if6492 = done;
  if (istrue(opresult6498)) {
// Begin line 2062
  setline(2062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe6499 = gc_frame_new();
// call case 4: self request
  Object call6500 = callmethodflags(self, "checkBadOperators", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6499);
// compiled member node returning call6500 (depth = 6)
// Begin line 2063
  setline(2063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6501 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe6502 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call6503 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6502);
// compiled member node returning call6503 (depth = 8)
  Object call6504 = callmethodflags(call6503, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6501);
// compiled member node returning call6504 (depth = 7)
  *var_suggestion = call6504;
  if (call6504 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 2064
  setline(2064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6505 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6506 == NULL) {
    strlit6506 = alloc_String(")");
    gc_root(strlit6506);
  }
// compiled string node returning strlit6506 (depth = 7)
  gc_frame_newslot(strlit6506);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit6506;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6507 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6505);
// compiled call node returning call6507 (depth = 6)
// Begin line 2065
  setline(2065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6508 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6509 == NULL) {
    strlit6509 = alloc_String("a part of a multi-part method request beginning with a '(' must end with a ')'.");
    gc_root(strlit6509);
  }
// compiled string node returning strlit6509 (depth = 7)
  gc_frame_newslot(strlit6509);
// Begin line 2066
  setline(2066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe6510 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call6511 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6510);
// compiled member node returning call6511 (depth = 7)
  gc_frame_newslot(call6511);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe6513 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call6514 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6513);
// compiled member node returning call6514 (depth = 8)
  int op_slot_right_6512 = gc_frame_newslot(call6514);
// starting to compile member node (depth = 8)
  int callframe6516 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call6517 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6516);
// compiled member node returning call6517 (depth = 8)
  int op_slot_left_6512 = gc_frame_newslot(call6517);
  params[0] = call6514;
  partcv[0] = 1;
  Object sum6518 = callmethod(call6517, "+(1)", 1, partcv, params);
// compiled op node returning sum6518 (depth = 7)
  gc_frame_newslot(sum6518);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2065
  setline(2065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit6509;
  params[1] = call6511;
  params[2] = sum6518;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6519 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6508);
// compiled call node returning call6519 (depth = 6)
    gc_frame_newslot(call6519);
    if6492 = call6519;
  } else {
  }
// compiled if node returning if6492 (depth = 5)
    gc_frame_newslot(if6492);
    if6489 = if6492;
  } else {
  }
// compiled if node returning if6489 (depth = 4)
// Begin line 2069
  setline(2069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6522 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_isTerm (depth = 7)
  Object call6523 = callmethodflags(*var_isTerm, "not", 0, partcv, params, 0);
  gc_frame_end(callframe6522);
// compiled member node returning call6523 (depth = 6)
  int op_slot_right_6521 = gc_frame_newslot(call6523);
// starting to compile call node (depth = 6)
  int callframe6525 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6526 == NULL) {
    strlit6526 = alloc_String("rparen");
    gc_root(strlit6526);
  }
// compiled string node returning strlit6526 (depth = 7)
  gc_frame_newslot(strlit6526);
// call case 4: self request
  params[0] = strlit6526;
  partcv[0] = 1;
  Object call6527 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6525);
// compiled call node returning call6527 (depth = 6)
  int op_slot_left_6521 = gc_frame_newslot(call6527);
  params[0] = call6523;
  partcv[0] = 1;
  Object opresult6528 = callmethod(call6527, "&&(1)", 1, partcv, params);
// compiled op node returning opresult6528 (depth = 5)
  Object if6520 = done;
  if (istrue(opresult6528)) {
// Begin line 2070
  setline(2070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6529 = gc_frame_new();
// call case 4: self request
  Object call6530 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6529);
// compiled member node returning call6530 (depth = 5)
    gc_frame_newslot(call6530);
    if6520 = call6530;
  } else {
  }
// compiled if node returning if6520 (depth = 4)
  gc_frame_end(frame);
  return if6520;
}
Object meth_parser_callmprest_40_3_41_6181(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 48, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callmprest(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method callmprest(_,_,_)");
  Object params[2];
  int partcv[2];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_blocksOK = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for callmprest(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_meth = &(stackframe->slots[0]);
  *var_meth = args[curarg];
  curarg++;
  Object *var_signature = &(stackframe->slots[1]);
  *var_signature = args[curarg];
  curarg++;
  Object *var_tok = &(stackframe->slots[2]);
  *var_tok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part callmprest(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_methname = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "methname");
  Object *var_nxt = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nxt");
  Object *var_lp = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "lp");
  Object *var_part = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "part");
  Object *var_meth_39_ = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "meth'");
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe6182 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  Object call6183 = callmethodflags(*var_meth, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6182);
// compiled member node returning call6183 (depth = 3)
  *var_methname = call6183;
  if (call6183 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_nxt = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe6184 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  Object call6185 = callmethodflags(*var_meth, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6184);
// compiled member node returning call6185 (depth = 3)
  *var_lp = call6185;
  if (call6185 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_part = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6186 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block6187 = alloc_Block(NULL, NULL, "parser", 1967);
  gc_frame_newslot(block6187);
// method "_apply"
  block_savedest(block6187);
  Object closure6188 = createclosure(3, "_apply");
  setclosureframe(closure6188, stackframe);
  addtoclosure(closure6188, var_lastToken);
  addtoclosure(closure6188, var_tok);
  addtoclosure(closure6188, selfslot);
  struct UserObject *uo6188 = (struct UserObject*)block6187;
  uo6188->data[0] = (Object)closure6188;
  Method *meth_meth_parser__apply6188 = addmethod2pos(block6187, "_apply", &meth_parser__apply6188, 0);
  int argcv_meth_parser__apply6188[] = {0};
  meth_meth_parser__apply6188->type = alloc_MethodType(1, argcv_meth_parser__apply6188);
  meth_meth_parser__apply6188->definitionModule = modulename;
  meth_meth_parser__apply6188->definitionLine = 3399;
// compiled block node returning block6187 (depth = 3)
  gc_frame_newslot(block6187);
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block6199 = alloc_Block(NULL, NULL, "parser", 1968);
  gc_frame_newslot(block6199);
// method "_apply"
  block_savedest(block6199);
  Object closure6200 = createclosure(11, "_apply");
  setclosureframe(closure6200, stackframe);
  addtoclosure(closure6200, var_ast);
  addtoclosure(closure6200, var_part);
  addtoclosure(closure6200, var_signature);
  addtoclosure(closure6200, var_methname);
  addtoclosure(closure6200, var_values);
  addtoclosure(closure6200, var_nxt);
  addtoclosure(closure6200, var_lastToken);
  addtoclosure(closure6200, var_errormessages);
  addtoclosure(closure6200, var_sym);
  addtoclosure(closure6200, var_blocksOK);
  addtoclosure(closure6200, selfslot);
  struct UserObject *uo6200 = (struct UserObject*)block6199;
  uo6200->data[0] = (Object)closure6200;
  Method *meth_meth_parser__apply6200 = addmethod2pos(block6199, "_apply", &meth_parser__apply6200, 0);
  int argcv_meth_parser__apply6200[] = {0};
  meth_meth_parser__apply6200->type = alloc_MethodType(1, argcv_meth_parser__apply6200);
  meth_meth_parser__apply6200->definitionModule = modulename;
  meth_meth_parser__apply6200->definitionLine = 3399;
// compiled block node returning block6199 (depth = 3)
  gc_frame_newslot(block6199);
// call case 5: prelude request
  params[0] = block6187;
  params[1] = block6199;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6532 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6186);
// compiled call node returning call6532 (depth = 2)
// Begin line 2073
  setline(2073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6533 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methname (depth = 4)
  gc_frame_newslot(*var_methname);
// starting to compile identifier node (depth = 4)
  Object bool6534 = alloc_Boolean(0);
// compiled identifier node returning bool6534 (depth = 4)
  gc_frame_newslot(bool6534);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6535 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call6536 = callmethodflags(*var_ast, "identifierNode", 0, partcv, params, 0);
  gc_frame_end(callframe6535);
// compiled member node returning call6536 (depth = 4)
  params[0] = *var_methname;
  params[1] = bool6534;
  partcv[0] = 2;
  Object call6537 = callmethodflags(call6536, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6533);
// compiled call node returning call6537 (depth = 3)
  *var_meth_39_ = call6537;
  if (call6537 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2074
  setline(2074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6538 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe6539 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  Object call6540 = callmethodflags(*var_meth, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6539);
// compiled member node returning call6540 (depth = 3)
  gc_frame_newslot(call6540);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth_39_ (depth = 3)
  params[0] = call6540;
  partcv[0] = 1;
  Object call6541 = callmethodflags(*var_meth_39_, "line:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6538);
// compiled call node returning call6541 (depth = 2)
// Begin line 2075
  setline(2075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6542 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe6543 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  Object call6544 = callmethodflags(*var_meth, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6543);
// compiled member node returning call6544 (depth = 3)
  gc_frame_newslot(call6544);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth_39_ (depth = 3)
  params[0] = call6544;
  partcv[0] = 1;
  Object call6545 = callmethodflags(*var_meth_39_, "linePos:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6542);
// compiled call node returning call6545 (depth = 2)
// Begin line 2076
  setline(2076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_meth_39_ (depth = 2)
  gc_frame_end(frame);
  return *var_meth_39_;
}
Object meth_parser__apply_40_1_41_6570(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// Begin line 2089
  setline(2089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe6573 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call6574 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6573);
// compiled member node returning call6574 (depth = 9)
  int op_slot_right_6572 = gc_frame_newslot(call6574);
// starting to compile member node (depth = 9)
  int callframe6576 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call6577 = callmethodflags(*var_t, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6576);
// compiled member node returning call6577 (depth = 9)
  int op_slot_left_6572 = gc_frame_newslot(call6577);
  params[0] = call6574;
  partcv[0] = 1;
  Object opresult6578 = callmethod(call6577, "==(1)", 1, partcv, params);
// compiled op node returning opresult6578 (depth = 8)
  int op_slot_right_6571 = gc_frame_newslot(opresult6578);
// Begin line 2088
  setline(2088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 2089
  setline(2089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6582 == NULL) {
    strlit6582 = alloc_String("=");
    gc_root(strlit6582);
  }
// compiled string node returning strlit6582 (depth = 10)
  int op_slot_right_6581 = gc_frame_newslot(strlit6582);
// starting to compile member node (depth = 10)
  int callframe6584 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  Object call6585 = callmethodflags(*var_t, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6584);
// compiled member node returning call6585 (depth = 10)
  int op_slot_left_6581 = gc_frame_newslot(call6585);
  params[0] = strlit6582;
  partcv[0] = 1;
  Object opresult6586 = callmethod(call6585, "==(1)", 1, partcv, params);
// compiled op node returning opresult6586 (depth = 9)
  int op_slot_right_6580 = gc_frame_newslot(opresult6586);
// Begin line 2088
  setline(2088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6589 == NULL) {
    strlit6589 = alloc_String("op");
    gc_root(strlit6589);
  }
// compiled string node returning strlit6589 (depth = 10)
  int op_slot_right_6588 = gc_frame_newslot(strlit6589);
// starting to compile member node (depth = 10)
  int callframe6591 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  Object call6592 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6591);
// compiled member node returning call6592 (depth = 10)
  int op_slot_left_6588 = gc_frame_newslot(call6592);
  params[0] = strlit6589;
  partcv[0] = 1;
  Object opresult6593 = callmethod(call6592, "==(1)", 1, partcv, params);
// compiled op node returning opresult6593 (depth = 9)
  int op_slot_left_6580 = gc_frame_newslot(opresult6593);
  params[0] = opresult6586;
  partcv[0] = 1;
  Object opresult6594 = callmethod(opresult6593, "&&(1)", 1, partcv, params);
// compiled op node returning opresult6594 (depth = 8)
  int op_slot_left_6571 = gc_frame_newslot(opresult6594);
  params[0] = opresult6578;
  partcv[0] = 1;
  Object opresult6595 = callmethod(opresult6594, "&&(1)", 1, partcv, params);
// compiled op node returning opresult6595 (depth = 7)
  gc_frame_end(frame);
  return opresult6595;
}
Object meth_parser__apply6662(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe6663 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6664 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6663);
// compiled call node returning call6664 (depth = 8)
  gc_frame_end(frame);
  return call6664;
}
Object meth_parser_defdec6546(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 49, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(17, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defdec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_blocksOK = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_pos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "pos");
  Object *var_defTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "defTok");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextToken = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextToken");
  Object *var_val = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "val");
  Object *var_name = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "name");
  Object *var_dtype = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "dtype");
  Object *var_anns = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "anns");
  Object *var_nextTok = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "nextTok");
  Object *var_suggestions = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "suggestions");
  Object *var_o = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "o");
// Begin line 2081
  setline(2081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6548 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6549 == NULL) {
    strlit6549 = alloc_String("def");
    gc_root(strlit6549);
  }
// compiled string node returning strlit6549 (depth = 4)
  gc_frame_newslot(strlit6549);
// call case 4: self request
  params[0] = strlit6549;
  partcv[0] = 1;
  Object call6550 = callmethodflags(self, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6548);
// compiled call node returning call6550 (depth = 3)
  Object if6547 = done;
  if (istrue(call6550)) {
// Begin line 2082
  setline(2082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6551 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call6552 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6551);
// compiled member node returning call6552 (depth = 4)
  *var_line = call6552;
  if (call6552 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2083
  setline(2083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6553 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call6554 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6553);
// compiled member node returning call6554 (depth = 4)
  *var_pos = call6554;
  if (call6554 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2084
  setline(2084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_defTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2085
  setline(2085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6555 = gc_frame_new();
// call case 4: self request
  Object call6556 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6555);
// compiled member node returning call6556 (depth = 3)
// Begin line 2086
  setline(2086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6559 == NULL) {
    strlit6559 = alloc_String("identifier");
    gc_root(strlit6559);
  }
// compiled string node returning strlit6559 (depth = 5)
  int op_slot_right_6558 = gc_frame_newslot(strlit6559);
// starting to compile member node (depth = 5)
  int callframe6561 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call6562 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6561);
// compiled member node returning call6562 (depth = 5)
  int op_slot_left_6558 = gc_frame_newslot(call6562);
  params[0] = strlit6559;
  partcv[0] = 1;
  Object opresult6563 = callmethod(call6562, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6563 (depth = 4)
  Object if6557 = done;
  if (istrue(opresult6563)) {
// Begin line 2087
  setline(2087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6564 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6565 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call6566 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6565);
// compiled member node returning call6566 (depth = 6)
  Object call6567 = callmethodflags(call6566, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6564);
// compiled member node returning call6567 (depth = 5)
  *var_suggestion = call6567;
  if (call6567 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2088
  setline(2088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6568 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block6569 = alloc_Block(NULL, NULL, "parser", 2088);
  gc_frame_newslot(block6569);
// method "_apply(_)"
  block_savedest(block6569);
  Object closure6570 = createclosure(2, "_apply(1)");
  setclosureframe(closure6570, stackframe);
  addtoclosure(closure6570, var_sym);
  addtoclosure(closure6570, selfslot);
  struct UserObject *uo6570 = (struct UserObject*)block6569;
  uo6570->data[0] = (Object)closure6570;
  Method *meth_meth_parser__apply_40_1_41_6570 = addmethod2pos(block6569, "_apply(1)", &meth_parser__apply_40_1_41_6570, 0);
  int argcv_meth_parser__apply_40_1_41_6570[] = {1};
  meth_meth_parser__apply_40_1_41_6570->type = alloc_MethodType(1, argcv_meth_parser__apply_40_1_41_6570);
  meth_meth_parser__apply_40_1_41_6570->definitionModule = modulename;
  meth_meth_parser__apply_40_1_41_6570->definitionLine = 3399;
// compiled block node returning block6569 (depth = 6)
  gc_frame_newslot(block6569);
// call case 4: self request
  params[0] = block6569;
  partcv[0] = 1;
  Object call6597 = callmethodflags(self, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6568);
// compiled call node returning call6597 (depth = 5)
  *var_nextToken = call6597;
  if (call6597 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2090
  setline(2090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextToken (depth = 6)
  int op_slot_right_6599 = gc_frame_newslot(*var_nextToken);
// starting to compile identifier node (depth = 6)
  Object bool6601 = alloc_Boolean(0);
// compiled identifier node returning bool6601 (depth = 6)
  int op_slot_left_6599 = gc_frame_newslot(bool6601);
  params[0] = *var_nextToken;
  partcv[0] = 1;
  Object opresult6602 = callmethod(bool6601, "==(1)", 1, partcv, params);
// compiled op node returning opresult6602 (depth = 5)
  Object if6598 = done;
  if (istrue(opresult6602)) {
// Begin line 2091
  setline(2091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6603 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6604 == NULL) {
    strlit6604 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb"" =");
    gc_root(strlit6604);
  }
// compiled string node returning strlit6604 (depth = 6)
  gc_frame_newslot(strlit6604);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit6604;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6605 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6603);
// compiled call node returning call6605 (depth = 5)
    gc_frame_newslot(call6605);
    if6598 = call6605;
  } else {
// Begin line 2094
  setline(2094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2092
  setline(2092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_6607 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextToken (depth = 7)
  int op_slot_left_6607 = gc_frame_newslot(*var_nextToken);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6609 = callmethod(*var_nextToken, "==(1)", 1, partcv, params);
// compiled op node returning opresult6609 (depth = 6)
  Object if6606 = done;
  if (istrue(opresult6609)) {
// Begin line 2093
  setline(2093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6610 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6611 == NULL) {
    strlit6611 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb""");
    gc_root(strlit6611);
  }
// compiled string node returning strlit6611 (depth = 7)
  gc_frame_newslot(strlit6611);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit6611;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6612 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6610);
// compiled call node returning call6612 (depth = 6)
    gc_frame_newslot(call6612);
    if6606 = call6612;
  } else {
// Begin line 2095
  setline(2095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6613 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe6614 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextToken (depth = 8)
  Object call6615 = callmethodflags(*var_nextToken, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe6614);
// compiled member node returning call6615 (depth = 7)
  gc_frame_newslot(call6615);
// Begin line 2096
  setline(2096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool6616 = alloc_Boolean(0);
// compiled identifier node returning bool6616 (depth = 7)
  gc_frame_newslot(bool6616);
// starting to compile identifier node (depth = 7)
  Object bool6617 = alloc_Boolean(1);
// compiled identifier node returning bool6617 (depth = 7)
  gc_frame_newslot(bool6617);
// starting to compile string node (depth = 7)
  if (strlit6618 == NULL) {
    strlit6618 = alloc_String("""\xc2""""\xab""name""\xc2""""\xbb"" ");
    gc_root(strlit6618);
  }
// compiled string node returning strlit6618 (depth = 7)
  gc_frame_newslot(strlit6618);
// call case 6: other requests
// Begin line 2095
  setline(2095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call6615;
  params[2] = bool6616;
  params[3] = bool6617;
  params[4] = strlit6618;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6619 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe6613);
// compiled call node returning call6619 (depth = 6)
    gc_frame_newslot(call6619);
    if6606 = call6619;
  }
// compiled if node returning if6606 (depth = 5)
    gc_frame_newslot(if6606);
    if6598 = if6606;
  }
// compiled if node returning if6598 (depth = 4)
// Begin line 2098
  setline(2098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6620 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 2099
  setline(2099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit6622 == NULL) {
    strlit6622 = alloc_String("and a value after the 'def'.");
    gc_root(strlit6622);
  }
// compiled string node returning strlit6622 (depth = 6)
  int op_slot_right_6621 = gc_frame_newslot(strlit6622);
// Begin line 2098
  setline(2098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit6624 == NULL) {
    strlit6624 = alloc_String("a definition must have a name, '=', ");
    gc_root(strlit6624);
  }
// compiled string node returning strlit6624 (depth = 6)
  int op_slot_left_6621 = gc_frame_newslot(strlit6624);
  params[0] = strlit6622;
  partcv[0] = 1;
  Object opresult6625 = callmethod(strlit6624, "++(1)", 1, partcv, params);
// compiled op node returning opresult6625 (depth = 5)
  gc_frame_newslot(opresult6625);
// Begin line 2099
  setline(2099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6626 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call6627 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6626);
// compiled member node returning call6627 (depth = 5)
  gc_frame_newslot(call6627);
// starting to compile member node (depth = 5)
  int callframe6628 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call6629 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6628);
// compiled member node returning call6629 (depth = 5)
  gc_frame_newslot(call6629);
// Begin line 2100
  setline(2100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2098
  setline(2098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult6625;
  params[1] = call6627;
  params[2] = call6629;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6630 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6620);
// compiled call node returning call6630 (depth = 4)
    gc_frame_newslot(call6630);
    if6557 = call6630;
  } else {
  }
// compiled if node returning if6557 (depth = 3)
// Begin line 2102
  setline(2102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6631 = gc_frame_new();
// call case 4: self request
  Object call6632 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6631);
// compiled member node returning call6632 (depth = 3)
// Begin line 2103
  setline(2103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool6633 = alloc_Boolean(0);
// compiled identifier node returning bool6633 (depth = 4)
  *var_val = bool6633;
  if (bool6633 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2104
  setline(2104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6634 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call6635 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe6634);
// compiled member node returning call6635 (depth = 4)
  *var_name = call6635;
  if (call6635 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2105
  setline(2105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6636 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool6637 = alloc_Boolean(1);
// compiled identifier node returning bool6637 (depth = 4)
  gc_frame_newslot(bool6637);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name (depth = 4)
  params[0] = bool6637;
  partcv[0] = 1;
  Object call6638 = callmethodflags(*var_name, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6636);
// compiled call node returning call6638 (depth = 3)
// Begin line 2106
  setline(2106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6639 = gc_frame_new();
// call case 4: self request
  Object call6640 = callmethodflags(self, "optionalTypeAnnotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6639);
// compiled member node returning call6640 (depth = 4)
  *var_dtype = call6640;
  if (call6640 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2107
  setline(2107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6641 = gc_frame_new();
// call case 4: self request
  Object call6642 = callmethodflags(self, "doannotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6641);
// compiled member node returning call6642 (depth = 4)
  *var_anns = call6642;
  if (call6642 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2108
  setline(2108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6646 == NULL) {
    strlit6646 = alloc_String("=");
    gc_root(strlit6646);
  }
// compiled string node returning strlit6646 (depth = 6)
  int op_slot_right_6645 = gc_frame_newslot(strlit6646);
// starting to compile member node (depth = 6)
  int callframe6648 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call6649 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6648);
// compiled member node returning call6649 (depth = 6)
  int op_slot_left_6645 = gc_frame_newslot(call6649);
  params[0] = strlit6646;
  partcv[0] = 1;
  Object opresult6650 = callmethod(call6649, "==(1)", 1, partcv, params);
// compiled op node returning opresult6650 (depth = 5)
  int op_slot_right_6644 = gc_frame_newslot(opresult6650);
// starting to compile call node (depth = 5)
  int callframe6652 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6653 == NULL) {
    strlit6653 = alloc_String("op");
    gc_root(strlit6653);
  }
// compiled string node returning strlit6653 (depth = 6)
  gc_frame_newslot(strlit6653);
// call case 4: self request
  params[0] = strlit6653;
  partcv[0] = 1;
  Object call6654 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6652);
// compiled call node returning call6654 (depth = 5)
  int op_slot_left_6644 = gc_frame_newslot(call6654);
  params[0] = opresult6650;
  partcv[0] = 1;
  Object opresult6655 = callmethod(call6654, "&&(1)", 1, partcv, params);
// compiled op node returning opresult6655 (depth = 4)
  Object if6643 = done;
  if (istrue(opresult6655)) {
// Begin line 2109
  setline(2109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6656 = gc_frame_new();
// call case 4: self request
  Object call6657 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6656);
// compiled member node returning call6657 (depth = 4)
// Begin line 2110
  setline(2110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6659 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe6660 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block6661 = alloc_Block(NULL, NULL, "parser", 2110);
  gc_frame_newslot(block6661);
// method "_apply"
  block_savedest(block6661);
  Object closure6662 = createclosure(2, "_apply");
  setclosureframe(closure6662, stackframe);
  addtoclosure(closure6662, var_blocksOK);
  addtoclosure(closure6662, selfslot);
  struct UserObject *uo6662 = (struct UserObject*)block6661;
  uo6662->data[0] = (Object)closure6662;
  Method *meth_meth_parser__apply6662 = addmethod2pos(block6661, "_apply", &meth_parser__apply6662, 0);
  int argcv_meth_parser__apply6662[] = {0};
  meth_meth_parser__apply6662->type = alloc_MethodType(1, argcv_meth_parser__apply6662);
  meth_meth_parser__apply6662->definitionModule = modulename;
  meth_meth_parser__apply6662->definitionLine = 3399;
// compiled block node returning block6661 (depth = 7)
  gc_frame_newslot(block6661);
// call case 4: self request
  params[0] = block6661;
  partcv[0] = 1;
  Object call6666 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6660);
// compiled call node returning call6666 (depth = 6)
  Object call6667 = callmethodflags(call6666, "not", 0, partcv, params, 0);
  gc_frame_end(callframe6659);
// compiled member node returning call6667 (depth = 5)
  Object if6658 = done;
  if (istrue(call6667)) {
// Begin line 2111
  setline(2111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6668 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6669 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call6670 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6669);
// compiled member node returning call6670 (depth = 7)
  Object call6671 = callmethodflags(call6670, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6668);
// compiled member node returning call6671 (depth = 6)
  *var_suggestion = call6671;
  if (call6671 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2112
  setline(2112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6672 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array6673 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6673 (depth = 7)
  gc_frame_newslot(array6673);
// call case 4: self request
  params[0] = array6673;
  partcv[0] = 1;
  Object call6674 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6672);
// compiled call node returning call6674 (depth = 6)
  *var_nextTok = call6674;
  if (call6674 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2113
  setline(2113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_6676 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_6676 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6678 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult6678 (depth = 6)
  Object if6675 = done;
  if (istrue(opresult6678)) {
// Begin line 2114
  setline(2114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6679 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6680 == NULL) {
    strlit6680 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6680);
  }
// compiled string node returning strlit6680 (depth = 7)
  gc_frame_newslot(strlit6680);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit6680;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6681 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6679);
// compiled call node returning call6681 (depth = 6)
    gc_frame_newslot(call6681);
    if6675 = call6681;
  } else {
// Begin line 2116
  setline(2116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6682 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe6683 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call6684 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe6683);
// compiled member node returning call6684 (depth = 7)
  gc_frame_newslot(call6684);
// Begin line 2117
  setline(2117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool6685 = alloc_Boolean(1);
// compiled identifier node returning bool6685 (depth = 7)
  gc_frame_newslot(bool6685);
// starting to compile identifier node (depth = 7)
  Object bool6686 = alloc_Boolean(0);
// compiled identifier node returning bool6686 (depth = 7)
  gc_frame_newslot(bool6686);
// starting to compile string node (depth = 7)
  if (strlit6687 == NULL) {
    strlit6687 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6687);
  }
// compiled string node returning strlit6687 (depth = 7)
  gc_frame_newslot(strlit6687);
// call case 6: other requests
// Begin line 2116
  setline(2116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call6684;
  params[2] = bool6685;
  params[3] = bool6686;
  params[4] = strlit6687;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6688 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe6682);
// compiled call node returning call6688 (depth = 6)
    gc_frame_newslot(call6688);
    if6675 = call6688;
  }
// compiled if node returning if6675 (depth = 5)
// Begin line 2119
  setline(2119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6689 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6690 == NULL) {
    strlit6690 = alloc_String("a definition must have a value after the '='.");
    gc_root(strlit6690);
  }
// compiled string node returning strlit6690 (depth = 6)
  gc_frame_newslot(strlit6690);
// Begin line 2120
  setline(2120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe6691 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call6692 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6691);
// compiled member node returning call6692 (depth = 6)
  gc_frame_newslot(call6692);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6694 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call6695 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6694);
// compiled member node returning call6695 (depth = 7)
  int op_slot_right_6693 = gc_frame_newslot(call6695);
// starting to compile member node (depth = 7)
  int callframe6697 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call6698 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6697);
// compiled member node returning call6698 (depth = 7)
  int op_slot_left_6693 = gc_frame_newslot(call6698);
  params[0] = call6695;
  partcv[0] = 1;
  Object sum6699 = callmethod(call6698, "+(1)", 1, partcv, params);
// compiled op node returning sum6699 (depth = 6)
  gc_frame_newslot(sum6699);
// Begin line 2121
  setline(2121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2119
  setline(2119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit6690;
  params[1] = call6692;
  params[2] = sum6699;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6700 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6689);
// compiled call node returning call6700 (depth = 5)
    gc_frame_newslot(call6700);
    if6658 = call6700;
  } else {
  }
// compiled if node returning if6658 (depth = 4)
// Begin line 2123
  setline(2123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6701 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call6702 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe6701);
// compiled member node returning call6702 (depth = 5)
  *var_val = call6702;
  if (call6702 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6643 = done;
  } else {
// Begin line 2135
  setline(2135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2124
  setline(2124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6705 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6706 == NULL) {
    strlit6706 = alloc_String("bind");
    gc_root(strlit6706);
  }
// compiled string node returning strlit6706 (depth = 6)
  gc_frame_newslot(strlit6706);
// call case 4: self request
  params[0] = strlit6706;
  partcv[0] = 1;
  Object call6707 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6705);
// compiled call node returning call6707 (depth = 5)
  Object if6704 = done;
  if (istrue(call6707)) {
// Begin line 2125
  setline(2125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array6708 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6708 (depth = 6)
  *var_suggestions = array6708;
  if (array6708 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2126
  setline(2126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6709 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6710 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call6711 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6710);
// compiled member node returning call6711 (depth = 7)
  Object call6712 = callmethodflags(call6711, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6709);
// compiled member node returning call6712 (depth = 6)
  *var_suggestion = call6712;
  if (call6712 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2127
  setline(2127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6713 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 6)
  if (strlit6714 == NULL) {
    strlit6714 = alloc_String("=");
    gc_root(strlit6714);
  }
// compiled string node returning strlit6714 (depth = 6)
  gc_frame_newslot(strlit6714);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = strlit6714;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6715 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6713);
// compiled call node returning call6715 (depth = 5)
// Begin line 2128
  setline(2128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6716 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6717 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6716);
// compiled call node returning call6717 (depth = 5)
// Begin line 2129
  setline(2129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6718 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6719 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call6720 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6719);
// compiled member node returning call6720 (depth = 7)
  Object call6721 = callmethodflags(call6720, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6718);
// compiled member node returning call6721 (depth = 6)
  *var_suggestion = call6721;
  if (call6721 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 2130
  setline(2130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6723 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  gc_frame_newslot(*var_defTok);
// starting to compile string node (depth = 6)
  if (strlit6724 == NULL) {
    strlit6724 = alloc_String("var");
    gc_root(strlit6724);
  }
// compiled string node returning strlit6724 (depth = 6)
  gc_frame_newslot(strlit6724);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_defTok;
  params[1] = strlit6724;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6725 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6723);
// compiled call node returning call6725 (depth = 5)
// Begin line 2131
  setline(2131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6726 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6727 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6726);
// compiled call node returning call6727 (depth = 5)
// Begin line 2132
  setline(2132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6728 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2133
  setline(2133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6730 == NULL) {
    strlit6730 = alloc_String("A variable declaration uses 'var' and ':='.");
    gc_root(strlit6730);
  }
// compiled string node returning strlit6730 (depth = 7)
  int op_slot_right_6729 = gc_frame_newslot(strlit6730);
// Begin line 2132
  setline(2132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6732 == NULL) {
    strlit6732 = alloc_String("a definition must use '=' instead of ':='. ");
    gc_root(strlit6732);
  }
// compiled string node returning strlit6732 (depth = 7)
  int op_slot_left_6729 = gc_frame_newslot(strlit6732);
  params[0] = strlit6730;
  partcv[0] = 1;
  Object opresult6733 = callmethod(strlit6732, "++(1)", 1, partcv, params);
// compiled op node returning opresult6733 (depth = 6)
  gc_frame_newslot(opresult6733);
// Begin line 2134
  setline(2134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe6734 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call6735 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6734);
// compiled member node returning call6735 (depth = 6)
  gc_frame_newslot(call6735);
// starting to compile member node (depth = 6)
  int callframe6736 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call6737 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6736);
// compiled member node returning call6737 (depth = 6)
  gc_frame_newslot(call6737);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num6739 = alloc_Float64(1);
// compiled num node returning num6739 (depth = 7)
  int op_slot_right_6738 = gc_frame_newslot(num6739);
// starting to compile member node (depth = 7)
  int callframe6741 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call6742 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6741);
// compiled member node returning call6742 (depth = 7)
  int op_slot_left_6738 = gc_frame_newslot(call6742);
  params[0] = num6739;
  partcv[0] = 1;
  Object sum6743 = callmethod(call6742, "+(1)", 1, partcv, params);
// compiled op node returning sum6743 (depth = 6)
  gc_frame_newslot(sum6743);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2132
  setline(2132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult6733;
  params[1] = call6735;
  params[2] = call6737;
  params[3] = sum6743;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call6744 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6728);
// compiled call node returning call6744 (depth = 5)
    gc_frame_newslot(call6744);
    if6704 = call6744;
  } else {
// Begin line 2136
  setline(2136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array6745 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6745 (depth = 6)
  *var_suggestions = array6745;
  if (array6745 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2137
  setline(2137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6746 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6747 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call6748 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6747);
// compiled member node returning call6748 (depth = 7)
  Object call6749 = callmethodflags(call6748, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6746);
// compiled member node returning call6749 (depth = 6)
  *var_suggestion = call6749;
  if (call6749 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2138
  setline(2138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6750 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6751 == NULL) {
    strlit6751 = alloc_String(" = ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6751);
  }
// compiled string node returning strlit6751 (depth = 6)
  gc_frame_newslot(strlit6751);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit6751;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6752 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6750);
// compiled call node returning call6752 (depth = 5)
// Begin line 2139
  setline(2139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6753 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6754 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6753);
// compiled call node returning call6754 (depth = 5)
// Begin line 2140
  setline(2140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6755 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6756 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call6757 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6756);
// compiled member node returning call6757 (depth = 7)
  Object call6758 = callmethodflags(call6757, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6755);
// compiled member node returning call6758 (depth = 6)
  *var_suggestion = call6758;
  if (call6758 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 2141
  setline(2141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6760 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  gc_frame_newslot(*var_defTok);
// starting to compile string node (depth = 6)
  if (strlit6761 == NULL) {
    strlit6761 = alloc_String("var");
    gc_root(strlit6761);
  }
// compiled string node returning strlit6761 (depth = 6)
  gc_frame_newslot(strlit6761);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_defTok;
  params[1] = strlit6761;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6762 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6760);
// compiled call node returning call6762 (depth = 5)
// Begin line 2142
  setline(2142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6763 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6764 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6763);
// compiled call node returning call6764 (depth = 5)
// Begin line 2143
  setline(2143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6765 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2144
  setline(2144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6767 == NULL) {
    strlit6767 = alloc_String("A variable declaration does not require a value but uses 'var', not 'def'.");
    gc_root(strlit6767);
  }
// compiled string node returning strlit6767 (depth = 7)
  int op_slot_right_6766 = gc_frame_newslot(strlit6767);
// Begin line 2143
  setline(2143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6769 == NULL) {
    strlit6769 = alloc_String("a definition must have '=' and a value after the name. ");
    gc_root(strlit6769);
  }
// compiled string node returning strlit6769 (depth = 7)
  int op_slot_left_6766 = gc_frame_newslot(strlit6769);
  params[0] = strlit6767;
  partcv[0] = 1;
  Object opresult6770 = callmethod(strlit6769, "++(1)", 1, partcv, params);
// compiled op node returning opresult6770 (depth = 6)
  gc_frame_newslot(opresult6770);
// Begin line 2145
  setline(2145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe6771 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call6772 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6771);
// compiled member node returning call6772 (depth = 6)
  gc_frame_newslot(call6772);
// starting to compile member node (depth = 6)
  int callframe6773 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call6774 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6773);
// compiled member node returning call6774 (depth = 6)
  gc_frame_newslot(call6774);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2143
  setline(2143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult6770;
  params[1] = call6772;
  params[2] = call6774;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6775 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6765);
// compiled call node returning call6775 (depth = 5)
    gc_frame_newslot(call6775);
    if6704 = call6775;
  }
// compiled if node returning if6704 (depth = 4)
    gc_frame_newslot(if6704);
    if6643 = if6704;
  }
// compiled if node returning if6643 (depth = 3)
// Begin line 2147
  setline(2147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6776 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6777 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_defTok (depth = 5)
  Object call6778 = callmethodflags(*var_defTok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6777);
// compiled member node returning call6778 (depth = 4)
  gc_frame_newslot(call6778);
// starting to compile member node (depth = 4)
  int callframe6779 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_defTok (depth = 5)
  Object call6780 = callmethodflags(*var_defTok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6779);
// compiled member node returning call6780 (depth = 4)
  gc_frame_newslot(call6780);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call6778;
  params[1] = call6780;
  partcv[0] = 2;
  Object call6781 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6776);
// compiled call node returning call6781 (depth = 3)
// Begin line 2148
  setline(2148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6782 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6783 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call6784 = callmethodflags(*var_ast, "defDecNode", 0, partcv, params, 0);
  gc_frame_end(callframe6783);
// compiled member node returning call6784 (depth = 5)
  params[0] = *var_name;
  params[1] = *var_val;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call6785 = callmethodflags(call6784, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe6782);
// compiled call node returning call6785 (depth = 4)
  *var_o = call6785;
  if (call6785 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2149
  setline(2149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_6787 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool6789 = alloc_Boolean(0);
// compiled identifier node returning bool6789 (depth = 5)
  int op_slot_left_6787 = gc_frame_newslot(bool6789);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult6790 = callmethod(bool6789, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6790 (depth = 4)
  Object if6786 = done;
  if (istrue(opresult6790)) {
// starting to compile call node (depth = 4)
  int callframe6791 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6792 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  Object call6793 = callmethodflags(*var_o, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe6792);
// compiled member node returning call6793 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call6794 = callmethodflags(call6793, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6791);
// compiled call node returning call6794 (depth = 4)
    gc_frame_newslot(call6794);
    if6786 = call6794;
  } else {
  }
// compiled if node returning if6786 (depth = 3)
// Begin line 2150
  setline(2150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6795 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defTok (depth = 4)
  gc_frame_newslot(*var_defTok);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_defTok;
  partcv[0] = 1;
  Object call6796 = callmethodflags(*var_o, "startToken:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6795);
// compiled call node returning call6796 (depth = 3)
// Begin line 2151
  setline(2151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6797 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call6798 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6797);
// compiled call node returning call6798 (depth = 3)
// Begin line 2152
  setline(2152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6799 = gc_frame_new();
// call case 4: self request
  Object call6800 = callmethodflags(self, "reconcileComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6799);
// compiled member node returning call6800 (depth = 3)
    gc_frame_newslot(call6800);
    if6547 = call6800;
  } else {
  }
// compiled if node returning if6547 (depth = 2)
  gc_frame_end(frame);
  return if6547;
}
Object meth_parser__apply_40_1_41_6825(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// Begin line 2166
  setline(2166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe6828 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call6829 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6828);
// compiled member node returning call6829 (depth = 9)
  int op_slot_right_6827 = gc_frame_newslot(call6829);
// starting to compile member node (depth = 9)
  int callframe6831 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call6832 = callmethodflags(*var_t, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6831);
// compiled member node returning call6832 (depth = 9)
  int op_slot_left_6827 = gc_frame_newslot(call6832);
  params[0] = call6829;
  partcv[0] = 1;
  Object opresult6833 = callmethod(call6832, "==(1)", 1, partcv, params);
// compiled op node returning opresult6833 (depth = 8)
  int op_slot_right_6826 = gc_frame_newslot(opresult6833);
// Begin line 2165
  setline(2165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6836 == NULL) {
    strlit6836 = alloc_String("bind");
    gc_root(strlit6836);
  }
// compiled string node returning strlit6836 (depth = 9)
  int op_slot_right_6835 = gc_frame_newslot(strlit6836);
// starting to compile member node (depth = 9)
  int callframe6838 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call6839 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6838);
// compiled member node returning call6839 (depth = 9)
  int op_slot_left_6835 = gc_frame_newslot(call6839);
  params[0] = strlit6836;
  partcv[0] = 1;
  Object opresult6840 = callmethod(call6839, "==(1)", 1, partcv, params);
// compiled op node returning opresult6840 (depth = 8)
  int op_slot_left_6826 = gc_frame_newslot(opresult6840);
  params[0] = opresult6833;
  partcv[0] = 1;
  Object opresult6841 = callmethod(opresult6840, "&&(1)", 1, partcv, params);
// compiled op node returning opresult6841 (depth = 7)
  gc_frame_end(frame);
  return opresult6841;
}
Object meth_parser__apply6847(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_nextToken = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_6848 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextToken (depth = 8)
  int op_slot_left_6848 = gc_frame_newslot(*var_nextToken);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6850 = callmethod(*var_nextToken, "==(1)", 1, partcv, params);
// compiled op node returning opresult6850 (depth = 7)
  gc_frame_end(frame);
  return opresult6850;
}
Object meth_parser__apply6897(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe6898 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6899 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6898);
// compiled call node returning call6899 (depth = 8)
  gc_frame_end(frame);
  return call6899;
}
Object meth_parser_vardec6801(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 50, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(16, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "vardec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_blocksOK = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_pos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "pos");
  Object *var_varTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "varTok");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextToken = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextToken");
  Object *var_val = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "val");
  Object *var_name = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "name");
  Object *var_dtype = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "dtype");
  Object *var_anns = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "anns");
  Object *var_suggestions = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "suggestions");
  Object *var_nextTok = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "nextTok");
  Object *var_o = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "o");
// Begin line 2158
  setline(2158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6803 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6804 == NULL) {
    strlit6804 = alloc_String("var");
    gc_root(strlit6804);
  }
// compiled string node returning strlit6804 (depth = 4)
  gc_frame_newslot(strlit6804);
// call case 4: self request
  params[0] = strlit6804;
  partcv[0] = 1;
  Object call6805 = callmethodflags(self, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6803);
// compiled call node returning call6805 (depth = 3)
  Object if6802 = done;
  if (istrue(call6805)) {
// Begin line 2159
  setline(2159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6806 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call6807 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6806);
// compiled member node returning call6807 (depth = 4)
  *var_line = call6807;
  if (call6807 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2160
  setline(2160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6808 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call6809 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6808);
// compiled member node returning call6809 (depth = 4)
  *var_pos = call6809;
  if (call6809 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2161
  setline(2161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_varTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2162
  setline(2162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6810 = gc_frame_new();
// call case 4: self request
  Object call6811 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6810);
// compiled member node returning call6811 (depth = 3)
// Begin line 2163
  setline(2163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6814 == NULL) {
    strlit6814 = alloc_String("identifier");
    gc_root(strlit6814);
  }
// compiled string node returning strlit6814 (depth = 5)
  int op_slot_right_6813 = gc_frame_newslot(strlit6814);
// starting to compile member node (depth = 5)
  int callframe6816 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call6817 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe6816);
// compiled member node returning call6817 (depth = 5)
  int op_slot_left_6813 = gc_frame_newslot(call6817);
  params[0] = strlit6814;
  partcv[0] = 1;
  Object opresult6818 = callmethod(call6817, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6818 (depth = 4)
  Object if6812 = done;
  if (istrue(opresult6818)) {
// Begin line 2164
  setline(2164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6819 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6820 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call6821 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6820);
// compiled member node returning call6821 (depth = 6)
  Object call6822 = callmethodflags(call6821, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6819);
// compiled member node returning call6822 (depth = 5)
  *var_suggestion = call6822;
  if (call6822 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2165
  setline(2165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6823 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block6824 = alloc_Block(NULL, NULL, "parser", 2165);
  gc_frame_newslot(block6824);
// method "_apply(_)"
  block_savedest(block6824);
  Object closure6825 = createclosure(2, "_apply(1)");
  setclosureframe(closure6825, stackframe);
  addtoclosure(closure6825, var_sym);
  addtoclosure(closure6825, selfslot);
  struct UserObject *uo6825 = (struct UserObject*)block6824;
  uo6825->data[0] = (Object)closure6825;
  Method *meth_meth_parser__apply_40_1_41_6825 = addmethod2pos(block6824, "_apply(1)", &meth_parser__apply_40_1_41_6825, 0);
  int argcv_meth_parser__apply_40_1_41_6825[] = {1};
  meth_meth_parser__apply_40_1_41_6825->type = alloc_MethodType(1, argcv_meth_parser__apply_40_1_41_6825);
  meth_meth_parser__apply_40_1_41_6825->definitionModule = modulename;
  meth_meth_parser__apply_40_1_41_6825->definitionLine = 3399;
// compiled block node returning block6824 (depth = 6)
  gc_frame_newslot(block6824);
// call case 4: self request
  params[0] = block6824;
  partcv[0] = 1;
  Object call6843 = callmethodflags(self, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6823);
// compiled call node returning call6843 (depth = 5)
  *var_nextToken = call6843;
  if (call6843 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2167
  setline(2167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block6846 = alloc_Block(NULL, NULL, "parser", 2167);
  gc_frame_newslot(block6846);
// method "_apply"
  block_savedest(block6846);
  Object closure6847 = createclosure(3, "_apply");
  setclosureframe(closure6847, stackframe);
  addtoclosure(closure6847, var_sym);
  addtoclosure(closure6847, var_nextToken);
  addtoclosure(closure6847, selfslot);
  struct UserObject *uo6847 = (struct UserObject*)block6846;
  uo6847->data[0] = (Object)closure6847;
  Method *meth_meth_parser__apply6847 = addmethod2pos(block6846, "_apply", &meth_parser__apply6847, 0);
  int argcv_meth_parser__apply6847[] = {0};
  meth_meth_parser__apply6847->type = alloc_MethodType(1, argcv_meth_parser__apply6847);
  meth_meth_parser__apply6847->definitionModule = modulename;
  meth_meth_parser__apply6847->definitionLine = 3399;
// compiled block node returning block6846 (depth = 6)
  int op_slot_right_6845 = gc_frame_newslot(block6846);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextToken (depth = 7)
  int op_slot_right_6853 = gc_frame_newslot(*var_nextToken);
// starting to compile identifier node (depth = 7)
  Object bool6855 = alloc_Boolean(0);
// compiled identifier node returning bool6855 (depth = 7)
  int op_slot_left_6853 = gc_frame_newslot(bool6855);
  params[0] = *var_nextToken;
  partcv[0] = 1;
  Object opresult6856 = callmethod(bool6855, "==(1)", 1, partcv, params);
// compiled op node returning opresult6856 (depth = 6)
  int op_slot_left_6845 = gc_frame_newslot(opresult6856);
  params[0] = block6846;
  partcv[0] = 1;
  Object opresult6857 = callmethod(opresult6856, "||(1)", 1, partcv, params);
// compiled op node returning opresult6857 (depth = 5)
  Object if6844 = done;
  if (istrue(opresult6857)) {
// Begin line 2168
  setline(2168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6858 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6859 == NULL) {
    strlit6859 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb""");
    gc_root(strlit6859);
  }
// compiled string node returning strlit6859 (depth = 6)
  gc_frame_newslot(strlit6859);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit6859;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6860 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6858);
// compiled call node returning call6860 (depth = 5)
    gc_frame_newslot(call6860);
    if6844 = call6860;
  } else {
// Begin line 2170
  setline(2170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6861 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe6862 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextToken (depth = 7)
  Object call6863 = callmethodflags(*var_nextToken, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe6862);
// compiled member node returning call6863 (depth = 6)
  gc_frame_newslot(call6863);
// Begin line 2171
  setline(2171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool6864 = alloc_Boolean(0);
// compiled identifier node returning bool6864 (depth = 6)
  gc_frame_newslot(bool6864);
// starting to compile identifier node (depth = 6)
  Object bool6865 = alloc_Boolean(1);
// compiled identifier node returning bool6865 (depth = 6)
  gc_frame_newslot(bool6865);
// starting to compile string node (depth = 6)
  if (strlit6866 == NULL) {
    strlit6866 = alloc_String("""\xc2""""\xab""name""\xc2""""\xbb"" ");
    gc_root(strlit6866);
  }
// compiled string node returning strlit6866 (depth = 6)
  gc_frame_newslot(strlit6866);
// call case 6: other requests
// Begin line 2170
  setline(2170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call6863;
  params[2] = bool6864;
  params[3] = bool6865;
  params[4] = strlit6866;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6867 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe6861);
// compiled call node returning call6867 (depth = 5)
    gc_frame_newslot(call6867);
    if6844 = call6867;
  }
// compiled if node returning if6844 (depth = 4)
// Begin line 2173
  setline(2173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6868 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6869 == NULL) {
    strlit6869 = alloc_String("a variable declaration must have a name after the 'var'.");
    gc_root(strlit6869);
  }
// compiled string node returning strlit6869 (depth = 5)
  gc_frame_newslot(strlit6869);
// Begin line 2174
  setline(2174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6870 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call6871 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6870);
// compiled member node returning call6871 (depth = 5)
  gc_frame_newslot(call6871);
// starting to compile member node (depth = 5)
  int callframe6872 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call6873 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6872);
// compiled member node returning call6873 (depth = 5)
  gc_frame_newslot(call6873);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2173
  setline(2173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit6869;
  params[1] = call6871;
  params[2] = call6873;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6874 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6868);
// compiled call node returning call6874 (depth = 4)
    gc_frame_newslot(call6874);
    if6812 = call6874;
  } else {
  }
// compiled if node returning if6812 (depth = 3)
// Begin line 2176
  setline(2176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6875 = gc_frame_new();
// call case 4: self request
  Object call6876 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6875);
// compiled member node returning call6876 (depth = 3)
// Begin line 2177
  setline(2177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool6877 = alloc_Boolean(0);
// compiled identifier node returning bool6877 (depth = 4)
  *var_val = bool6877;
  if (bool6877 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2178
  setline(2178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6878 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call6879 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe6878);
// compiled member node returning call6879 (depth = 4)
  *var_name = call6879;
  if (call6879 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2179
  setline(2179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6880 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool6881 = alloc_Boolean(1);
// compiled identifier node returning bool6881 (depth = 4)
  gc_frame_newslot(bool6881);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name (depth = 4)
  params[0] = bool6881;
  partcv[0] = 1;
  Object call6882 = callmethodflags(*var_name, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6880);
// compiled call node returning call6882 (depth = 3)
// Begin line 2180
  setline(2180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6883 = gc_frame_new();
// call case 4: self request
  Object call6884 = callmethodflags(self, "optionalTypeAnnotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6883);
// compiled member node returning call6884 (depth = 4)
  *var_dtype = call6884;
  if (call6884 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2181
  setline(2181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6885 = gc_frame_new();
// call case 4: self request
  Object call6886 = callmethodflags(self, "doannotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6885);
// compiled member node returning call6886 (depth = 4)
  *var_anns = call6886;
  if (call6886 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2182
  setline(2182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6888 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6889 == NULL) {
    strlit6889 = alloc_String("bind");
    gc_root(strlit6889);
  }
// compiled string node returning strlit6889 (depth = 5)
  gc_frame_newslot(strlit6889);
// call case 4: self request
  params[0] = strlit6889;
  partcv[0] = 1;
  Object call6890 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6888);
// compiled call node returning call6890 (depth = 4)
  Object if6887 = done;
  if (istrue(call6890)) {
// Begin line 2183
  setline(2183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6891 = gc_frame_new();
// call case 4: self request
  Object call6892 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6891);
// compiled member node returning call6892 (depth = 4)
// Begin line 2184
  setline(2184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6894 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe6895 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block6896 = alloc_Block(NULL, NULL, "parser", 2184);
  gc_frame_newslot(block6896);
// method "_apply"
  block_savedest(block6896);
  Object closure6897 = createclosure(2, "_apply");
  setclosureframe(closure6897, stackframe);
  addtoclosure(closure6897, var_blocksOK);
  addtoclosure(closure6897, selfslot);
  struct UserObject *uo6897 = (struct UserObject*)block6896;
  uo6897->data[0] = (Object)closure6897;
  Method *meth_meth_parser__apply6897 = addmethod2pos(block6896, "_apply", &meth_parser__apply6897, 0);
  int argcv_meth_parser__apply6897[] = {0};
  meth_meth_parser__apply6897->type = alloc_MethodType(1, argcv_meth_parser__apply6897);
  meth_meth_parser__apply6897->definitionModule = modulename;
  meth_meth_parser__apply6897->definitionLine = 3399;
// compiled block node returning block6896 (depth = 7)
  gc_frame_newslot(block6896);
// call case 4: self request
  params[0] = block6896;
  partcv[0] = 1;
  Object call6901 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6895);
// compiled call node returning call6901 (depth = 6)
  Object call6902 = callmethodflags(call6901, "not", 0, partcv, params, 0);
  gc_frame_end(callframe6894);
// compiled member node returning call6902 (depth = 5)
  Object if6893 = done;
  if (istrue(call6902)) {
// Begin line 2185
  setline(2185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array6903 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6903 (depth = 6)
  *var_suggestions = array6903;
  if (array6903 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2186
  setline(2186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6904 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6905 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call6906 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6905);
// compiled member node returning call6906 (depth = 7)
  Object call6907 = callmethodflags(call6906, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6904);
// compiled member node returning call6907 (depth = 6)
  *var_suggestion = call6907;
  if (call6907 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2187
  setline(2187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6908 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array6909 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6909 (depth = 7)
  gc_frame_newslot(array6909);
// call case 4: self request
  params[0] = array6909;
  partcv[0] = 1;
  Object call6910 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6908);
// compiled call node returning call6910 (depth = 6)
  *var_nextTok = call6910;
  if (call6910 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2188
  setline(2188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_6912 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_6912 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6914 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult6914 (depth = 6)
  Object if6911 = done;
  if (istrue(opresult6914)) {
// Begin line 2189
  setline(2189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6915 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6916 == NULL) {
    strlit6916 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6916);
  }
// compiled string node returning strlit6916 (depth = 7)
  gc_frame_newslot(strlit6916);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit6916;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6917 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6915);
// compiled call node returning call6917 (depth = 6)
    gc_frame_newslot(call6917);
    if6911 = call6917;
  } else {
// Begin line 2191
  setline(2191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6918 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe6919 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call6920 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe6919);
// compiled member node returning call6920 (depth = 7)
  gc_frame_newslot(call6920);
// Begin line 2192
  setline(2192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool6921 = alloc_Boolean(1);
// compiled identifier node returning bool6921 (depth = 7)
  gc_frame_newslot(bool6921);
// starting to compile identifier node (depth = 7)
  Object bool6922 = alloc_Boolean(0);
// compiled identifier node returning bool6922 (depth = 7)
  gc_frame_newslot(bool6922);
// starting to compile string node (depth = 7)
  if (strlit6923 == NULL) {
    strlit6923 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6923);
  }
// compiled string node returning strlit6923 (depth = 7)
  gc_frame_newslot(strlit6923);
// call case 6: other requests
// Begin line 2191
  setline(2191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call6920;
  params[2] = bool6921;
  params[3] = bool6922;
  params[4] = strlit6923;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6924 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe6918);
// compiled call node returning call6924 (depth = 6)
    gc_frame_newslot(call6924);
    if6911 = call6924;
  }
// compiled if node returning if6911 (depth = 5)
// Begin line 2194
  setline(2194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6925 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6926 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6925);
// compiled call node returning call6926 (depth = 5)
// Begin line 2195
  setline(2195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6927 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6928 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call6929 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6928);
// compiled member node returning call6929 (depth = 7)
  Object call6930 = callmethodflags(call6929, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6927);
// compiled member node returning call6930 (depth = 6)
  *var_suggestion = call6930;
  if (call6930 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 2196
  setline(2196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6932 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 6)
  int callframe6933 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  Object call6934 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe6933);
// compiled member node returning call6934 (depth = 6)
  gc_frame_newslot(call6934);
// starting to compile identifier node (depth = 6)
  Object bool6935 = alloc_Boolean(1);
// compiled identifier node returning bool6935 (depth = 6)
  gc_frame_newslot(bool6935);
// starting to compile identifier node (depth = 6)
  Object bool6936 = alloc_Boolean(0);
// compiled identifier node returning bool6936 (depth = 6)
  gc_frame_newslot(bool6936);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = call6934;
  params[2] = bool6935;
  params[3] = bool6936;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6937 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6932);
// compiled call node returning call6937 (depth = 5)
// Begin line 2197
  setline(2197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6938 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6939 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6938);
// compiled call node returning call6939 (depth = 5)
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6940 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2199
  setline(2199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6942 == NULL) {
    strlit6942 = alloc_String("A variable without a value can be declared with 'var' followed only by the variable name.");
    gc_root(strlit6942);
  }
// compiled string node returning strlit6942 (depth = 7)
  int op_slot_right_6941 = gc_frame_newslot(strlit6942);
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6944 == NULL) {
    strlit6944 = alloc_String("a variable declaration must have a value after the ':='. ");
    gc_root(strlit6944);
  }
// compiled string node returning strlit6944 (depth = 7)
  int op_slot_left_6941 = gc_frame_newslot(strlit6944);
  params[0] = strlit6942;
  partcv[0] = 1;
  Object opresult6945 = callmethod(strlit6944, "++(1)", 1, partcv, params);
// compiled op node returning opresult6945 (depth = 6)
  gc_frame_newslot(opresult6945);
// Begin line 2200
  setline(2200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe6946 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call6947 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6946);
// compiled member node returning call6947 (depth = 6)
  gc_frame_newslot(call6947);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6949 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call6950 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6949);
// compiled member node returning call6950 (depth = 7)
  int op_slot_right_6948 = gc_frame_newslot(call6950);
// starting to compile member node (depth = 7)
  int callframe6952 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call6953 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6952);
// compiled member node returning call6953 (depth = 7)
  int op_slot_left_6948 = gc_frame_newslot(call6953);
  params[0] = call6950;
  partcv[0] = 1;
  Object sum6954 = callmethod(call6953, "+(1)", 1, partcv, params);
// compiled op node returning sum6954 (depth = 6)
  gc_frame_newslot(sum6954);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult6945;
  params[1] = call6947;
  params[2] = sum6954;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6955 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6940);
// compiled call node returning call6955 (depth = 5)
    gc_frame_newslot(call6955);
    if6893 = call6955;
  } else {
  }
// compiled if node returning if6893 (depth = 4)
// Begin line 2202
  setline(2202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6956 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call6957 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe6956);
// compiled member node returning call6957 (depth = 5)
  *var_val = call6957;
  if (call6957 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6887 = done;
  } else {
// Begin line 2204
  setline(2204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6962 == NULL) {
    strlit6962 = alloc_String("=");
    gc_root(strlit6962);
  }
// compiled string node returning strlit6962 (depth = 7)
  int op_slot_right_6961 = gc_frame_newslot(strlit6962);
// starting to compile member node (depth = 7)
  int callframe6964 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call6965 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6964);
// compiled member node returning call6965 (depth = 7)
  int op_slot_left_6961 = gc_frame_newslot(call6965);
  params[0] = strlit6962;
  partcv[0] = 1;
  Object opresult6966 = callmethod(call6965, "==(1)", 1, partcv, params);
// compiled op node returning opresult6966 (depth = 6)
  int op_slot_right_6960 = gc_frame_newslot(opresult6966);
// starting to compile call node (depth = 6)
  int callframe6968 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6969 == NULL) {
    strlit6969 = alloc_String("op");
    gc_root(strlit6969);
  }
// compiled string node returning strlit6969 (depth = 7)
  gc_frame_newslot(strlit6969);
// call case 4: self request
  params[0] = strlit6969;
  partcv[0] = 1;
  Object call6970 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6968);
// compiled call node returning call6970 (depth = 6)
  int op_slot_left_6960 = gc_frame_newslot(call6970);
  params[0] = opresult6966;
  partcv[0] = 1;
  Object opresult6971 = callmethod(call6970, "&&(1)", 1, partcv, params);
// compiled op node returning opresult6971 (depth = 5)
  Object if6959 = done;
  if (istrue(opresult6971)) {
// Begin line 2205
  setline(2205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array6972 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6972 (depth = 6)
  *var_suggestions = array6972;
  if (array6972 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2206
  setline(2206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6973 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6974 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call6975 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6974);
// compiled member node returning call6975 (depth = 7)
  Object call6976 = callmethodflags(call6975, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6973);
// compiled member node returning call6976 (depth = 6)
  *var_suggestion = call6976;
  if (call6976 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2207
  setline(2207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6977 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 6)
  if (strlit6978 == NULL) {
    strlit6978 = alloc_String(":=");
    gc_root(strlit6978);
  }
// compiled string node returning strlit6978 (depth = 6)
  gc_frame_newslot(strlit6978);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = strlit6978;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6979 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6977);
// compiled call node returning call6979 (depth = 5)
// Begin line 2208
  setline(2208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6980 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6981 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6980);
// compiled call node returning call6981 (depth = 5)
// Begin line 2209
  setline(2209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6982 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6983 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call6984 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe6983);
// compiled member node returning call6984 (depth = 7)
  Object call6985 = callmethodflags(call6984, "new", 0, partcv, params, 0);
  gc_frame_end(callframe6982);
// compiled member node returning call6985 (depth = 6)
  *var_suggestion = call6985;
  if (call6985 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 2210
  setline(2210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6987 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_varTok (depth = 6)
  gc_frame_newslot(*var_varTok);
// starting to compile string node (depth = 6)
  if (strlit6988 == NULL) {
    strlit6988 = alloc_String("def");
    gc_root(strlit6988);
  }
// compiled string node returning strlit6988 (depth = 6)
  gc_frame_newslot(strlit6988);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_varTok;
  params[1] = strlit6988;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6989 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6987);
// compiled call node returning call6989 (depth = 5)
// Begin line 2211
  setline(2211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6990 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6991 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6990);
// compiled call node returning call6991 (depth = 5)
// Begin line 2212
  setline(2212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6992 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6993 == NULL) {
    strlit6993 = alloc_String("a variable declaration must use ':=' instead of '='. A definition uses 'def' and '='.");
    gc_root(strlit6993);
  }
// compiled string node returning strlit6993 (depth = 6)
  gc_frame_newslot(strlit6993);
// Begin line 2213
  setline(2213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe6994 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call6995 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe6994);
// compiled member node returning call6995 (depth = 6)
  gc_frame_newslot(call6995);
// starting to compile member node (depth = 6)
  int callframe6996 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call6997 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6996);
// compiled member node returning call6997 (depth = 6)
  gc_frame_newslot(call6997);
// starting to compile member node (depth = 6)
  int callframe6998 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call6999 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe6998);
// compiled member node returning call6999 (depth = 6)
  gc_frame_newslot(call6999);
// Begin line 2214
  setline(2214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2212
  setline(2212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit6993;
  params[1] = call6995;
  params[2] = call6997;
  params[3] = call6999;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call7000 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe6992);
// compiled call node returning call7000 (depth = 5)
    gc_frame_newslot(call7000);
    if6959 = call7000;
  } else {
  }
// compiled if node returning if6959 (depth = 4)
    gc_frame_newslot(if6959);
    if6887 = if6959;
  }
// compiled if node returning if6887 (depth = 3)
// Begin line 2217
  setline(2217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7001 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  gc_frame_newslot(*var_line);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_line;
  params[1] = *var_pos;
  partcv[0] = 2;
  Object call7002 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7001);
// compiled call node returning call7002 (depth = 3)
// Begin line 2218
  setline(2218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7003 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7004 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call7005 = callmethodflags(*var_ast, "varDecNode", 0, partcv, params, 0);
  gc_frame_end(callframe7004);
// compiled member node returning call7005 (depth = 5)
  params[0] = *var_name;
  params[1] = *var_val;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call7006 = callmethodflags(call7005, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe7003);
// compiled call node returning call7006 (depth = 4)
  *var_o = call7006;
  if (call7006 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2219
  setline(2219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_7008 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool7010 = alloc_Boolean(0);
// compiled identifier node returning bool7010 (depth = 5)
  int op_slot_left_7008 = gc_frame_newslot(bool7010);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult7011 = callmethod(bool7010, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7011 (depth = 4)
  Object if7007 = done;
  if (istrue(opresult7011)) {
// starting to compile call node (depth = 4)
  int callframe7012 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7013 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  Object call7014 = callmethodflags(*var_o, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe7013);
// compiled member node returning call7014 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call7015 = callmethodflags(call7014, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7012);
// compiled call node returning call7015 (depth = 4)
    gc_frame_newslot(call7015);
    if7007 = call7015;
  } else {
  }
// compiled if node returning if7007 (depth = 3)
// Begin line 2220
  setline(2220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7016 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call7017 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7016);
// compiled call node returning call7017 (depth = 3)
// Begin line 2221
  setline(2221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7018 = gc_frame_new();
// call case 4: self request
  Object call7019 = callmethodflags(self, "reconcileComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7018);
// compiled member node returning call7019 (depth = 3)
    gc_frame_newslot(call7019);
    if6802 = call7019;
  } else {
  }
// compiled if node returning if6802 (depth = 2)
  gc_frame_end(frame);
  return if6802;
}
Object meth_parser__apply7030(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe7031 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call7032 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7031);
// compiled call node returning call7032 (depth = 5)
  gc_frame_end(frame);
  return call7032;
}
Object meth_parser__apply7038(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe7039 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit7040 == NULL) {
    strlit7040 = alloc_String("comma");
    gc_root(strlit7040);
  }
// compiled string node returning strlit7040 (depth = 8)
  gc_frame_newslot(strlit7040);
// call case 4: self request
  params[0] = strlit7040;
  partcv[0] = 1;
  Object call7041 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7039);
// compiled call node returning call7041 (depth = 7)
  gc_frame_end(frame);
  return call7041;
}
Object meth_parser__apply7056(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe7057 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call7058 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7057);
// compiled call node returning call7058 (depth = 11)
  gc_frame_end(frame);
  return call7058;
}
Object meth_parser__apply7044(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_tmp = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// starting to compile bind node (depth = 7)
// Begin line 2233
  setline(2233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe7045 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  Object call7046 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe7045);
// compiled member node returning call7046 (depth = 8)
  *var_tmp = call7046;
  if (call7046 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 2234
  setline(2234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7048 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp (depth = 8)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_params (depth = 8)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call7049 = callmethodflags(*var_params, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7048);
// compiled call node returning call7049 (depth = 7)
// Begin line 2235
  setline(2235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe7050 = gc_frame_new();
// call case 4: self request
  Object call7051 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7050);
// compiled member node returning call7051 (depth = 7)
// Begin line 2236
  setline(2236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe7053 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 9)
  int callframe7054 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block7055 = alloc_Block(NULL, NULL, "parser", 2236);
  gc_frame_newslot(block7055);
// method "_apply"
  block_savedest(block7055);
  Object closure7056 = createclosure(2, "_apply");
  setclosureframe(closure7056, stackframe);
  addtoclosure(closure7056, var_blocksOK);
  addtoclosure(closure7056, selfslot);
  struct UserObject *uo7056 = (struct UserObject*)block7055;
  uo7056->data[0] = (Object)closure7056;
  Method *meth_meth_parser__apply7056 = addmethod2pos(block7055, "_apply", &meth_parser__apply7056, 0);
  int argcv_meth_parser__apply7056[] = {0};
  meth_meth_parser__apply7056->type = alloc_MethodType(1, argcv_meth_parser__apply7056);
  meth_meth_parser__apply7056->definitionModule = modulename;
  meth_meth_parser__apply7056->definitionLine = 3399;
// compiled block node returning block7055 (depth = 10)
  gc_frame_newslot(block7055);
// call case 4: self request
  params[0] = block7055;
  partcv[0] = 1;
  Object call7060 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7054);
// compiled call node returning call7060 (depth = 9)
  Object call7061 = callmethodflags(call7060, "not", 0, partcv, params, 0);
  gc_frame_end(callframe7053);
// compiled member node returning call7061 (depth = 8)
  Object if7052 = done;
  if (istrue(call7061)) {
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile array node (depth = 9)
  Object array7062 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7062 (depth = 9)
  *var_suggestions = array7062;
  if (array7062 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 2238
  setline(2238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe7063 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe7064 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call7065 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7064);
// compiled member node returning call7065 (depth = 10)
  Object call7066 = callmethodflags(call7065, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7063);
// compiled member node returning call7066 (depth = 9)
  *var_suggestion = call7066;
  if (call7066 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 2239
  setline(2239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7067 = gc_frame_new();
// starting to compile array node (depth = 10)
  Object array7068 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 11)
  if (strlit7069 == NULL) {
    strlit7069 = alloc_String("rsquare");
    gc_root(strlit7069);
  }
// compiled string node returning strlit7069 (depth = 11)
  params[0] = strlit7069;
  partcv[0] = 1;
  callmethodflags(array7068, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array7068 (depth = 10)
  gc_frame_newslot(array7068);
// call case 4: self request
  params[0] = array7068;
  partcv[0] = 1;
  Object call7070 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7067);
// compiled call node returning call7070 (depth = 9)
  *var_nextTok = call7070;
  if (call7070 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 2240
  setline(2240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_7072 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_7072 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7074 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult7074 (depth = 9)
  Object if7071 = done;
  if (istrue(opresult7074)) {
// Begin line 2241
  setline(2241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe7075 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit7076 == NULL) {
    strlit7076 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7076);
  }
// compiled string node returning strlit7076 (depth = 10)
  gc_frame_newslot(strlit7076);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit7076;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7077 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7075);
// compiled call node returning call7077 (depth = 9)
    gc_frame_newslot(call7077);
    if7071 = call7077;
  } else {
// Begin line 2243
  setline(2243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe7078 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
  int callframe7079 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  Object call7080 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe7079);
// compiled member node returning call7080 (depth = 10)
  gc_frame_newslot(call7080);
// starting to compile identifier node (depth = 10)
  Object bool7081 = alloc_Boolean(1);
// compiled identifier node returning bool7081 (depth = 10)
  gc_frame_newslot(bool7081);
// starting to compile identifier node (depth = 10)
  Object bool7082 = alloc_Boolean(0);
// compiled identifier node returning bool7082 (depth = 10)
  gc_frame_newslot(bool7082);
// starting to compile string node (depth = 10)
  if (strlit7083 == NULL) {
    strlit7083 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7083);
  }
// compiled string node returning strlit7083 (depth = 10)
  gc_frame_newslot(strlit7083);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call7080;
  params[2] = bool7081;
  params[3] = bool7082;
  params[4] = strlit7083;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7084 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe7078);
// compiled call node returning call7084 (depth = 9)
    gc_frame_newslot(call7084);
    if7071 = call7084;
  }
// compiled if node returning if7071 (depth = 8)
// Begin line 2245
  setline(2245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7085 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7086 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7085);
// compiled call node returning call7086 (depth = 8)
// Begin line 2246
  setline(2246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe7087 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe7088 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call7089 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7088);
// compiled member node returning call7089 (depth = 10)
  Object call7090 = callmethodflags(call7089, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7087);
// compiled member node returning call7090 (depth = 9)
  *var_suggestion = call7090;
  if (call7090 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 2247
  setline(2247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7092 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
  int callframe7093 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call7094 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe7093);
// compiled member node returning call7094 (depth = 9)
  gc_frame_newslot(call7094);
// starting to compile identifier node (depth = 9)
  Object bool7095 = alloc_Boolean(1);
// compiled identifier node returning bool7095 (depth = 9)
  gc_frame_newslot(bool7095);
// starting to compile identifier node (depth = 9)
  Object bool7096 = alloc_Boolean(0);
// compiled identifier node returning bool7096 (depth = 9)
  gc_frame_newslot(bool7096);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call7094;
  params[2] = bool7095;
  params[3] = bool7096;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7097 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7092);
// compiled call node returning call7097 (depth = 8)
// Begin line 2248
  setline(2248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7098 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7099 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7098);
// compiled call node returning call7099 (depth = 8)
// Begin line 2249
  setline(2249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7100 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit7101 == NULL) {
    strlit7101 = alloc_String("a Lineup must contain zero or more expressions separated by commas.");
    gc_root(strlit7101);
  }
// compiled string node returning strlit7101 (depth = 9)
  gc_frame_newslot(strlit7101);
// Begin line 2250
  setline(2250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe7102 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call7103 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7102);
// compiled member node returning call7103 (depth = 9)
  gc_frame_newslot(call7103);
// starting to compile member node (depth = 9)
  int callframe7104 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call7105 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7104);
// compiled member node returning call7105 (depth = 9)
  gc_frame_newslot(call7105);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2249
  setline(2249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit7101;
  params[1] = call7103;
  params[2] = call7105;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7106 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7100);
// compiled call node returning call7106 (depth = 8)
    gc_frame_newslot(call7106);
    if7052 = call7106;
  } else {
  }
// compiled if node returning if7052 (depth = 7)
  gc_frame_end(frame);
  return if7052;
}
Object meth_parser__apply7035(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_tmp = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2232
  setline(2232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7036 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7037 = alloc_Block(NULL, NULL, "parser", 2232);
  gc_frame_newslot(block7037);
// method "_apply"
  block_savedest(block7037);
  Object closure7038 = createclosure(1, "_apply");
  setclosureframe(closure7038, stackframe);
  addtoclosure(closure7038, selfslot);
  struct UserObject *uo7038 = (struct UserObject*)block7037;
  uo7038->data[0] = (Object)closure7038;
  Method *meth_meth_parser__apply7038 = addmethod2pos(block7037, "_apply", &meth_parser__apply7038, 0);
  int argcv_meth_parser__apply7038[] = {0};
  meth_meth_parser__apply7038->type = alloc_MethodType(1, argcv_meth_parser__apply7038);
  meth_meth_parser__apply7038->definitionModule = modulename;
  meth_meth_parser__apply7038->definitionLine = 3399;
// compiled block node returning block7037 (depth = 6)
  gc_frame_newslot(block7037);
// starting to compile block node (depth = 6)
  Object block7043 = alloc_Block(NULL, NULL, "parser", 2232);
  gc_frame_newslot(block7043);
// method "_apply"
  block_savedest(block7043);
  Object closure7044 = createclosure(8, "_apply");
  setclosureframe(closure7044, stackframe);
  addtoclosure(closure7044, var_values);
  addtoclosure(closure7044, var_tmp);
  addtoclosure(closure7044, var_params);
  addtoclosure(closure7044, var_blocksOK);
  addtoclosure(closure7044, var_errormessages);
  addtoclosure(closure7044, var_sym);
  addtoclosure(closure7044, var_lastToken);
  addtoclosure(closure7044, selfslot);
  struct UserObject *uo7044 = (struct UserObject*)block7043;
  uo7044->data[0] = (Object)closure7044;
  Method *meth_meth_parser__apply7044 = addmethod2pos(block7043, "_apply", &meth_parser__apply7044, 0);
  int argcv_meth_parser__apply7044[] = {0};
  meth_meth_parser__apply7044->type = alloc_MethodType(1, argcv_meth_parser__apply7044);
  meth_meth_parser__apply7044->definitionModule = modulename;
  meth_meth_parser__apply7044->definitionLine = 3399;
// compiled block node returning block7043 (depth = 6)
  gc_frame_newslot(block7043);
// call case 5: prelude request
  params[0] = block7037;
  params[1] = block7043;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7108 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7036);
// compiled call node returning call7108 (depth = 5)
// Begin line 2253
  setline(2253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7109 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call7110 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe7109);
// compiled member node returning call7110 (depth = 6)
  *var_tmp = call7110;
  if (call7110 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 2254
  setline(2254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7112 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  gc_frame_newslot(*var_tmp);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_params (depth = 6)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call7113 = callmethodflags(*var_params, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7112);
// compiled call node returning call7113 (depth = 5)
  gc_frame_end(frame);
  return call7113;
}
Object meth_parser_doarray7020(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 51, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doarray");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_tmp = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "tmp");
  Object *var_params = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "params");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_o = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "o");
// Begin line 2227
  setline(2227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7022 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7023 == NULL) {
    strlit7023 = alloc_String("lsquare");
    gc_root(strlit7023);
  }
// compiled string node returning strlit7023 (depth = 4)
  gc_frame_newslot(strlit7023);
// call case 4: self request
  params[0] = strlit7023;
  partcv[0] = 1;
  Object call7024 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7022);
// compiled call node returning call7024 (depth = 3)
  Object if7021 = done;
  if (istrue(call7024)) {
// Begin line 2228
  setline(2228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7025 = gc_frame_new();
// call case 4: self request
  Object call7026 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7025);
// compiled member node returning call7026 (depth = 3)
// Begin line 2229
  setline(2229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_tmp = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2230
  setline(2230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array7027 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7027 (depth = 4)
  *var_params = array7027;
  if (array7027 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2231
  setline(2231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7028 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block7029 = alloc_Block(NULL, NULL, "parser", 2231);
  gc_frame_newslot(block7029);
// method "_apply"
  block_savedest(block7029);
  Object closure7030 = createclosure(2, "_apply");
  setclosureframe(closure7030, stackframe);
  addtoclosure(closure7030, var_blocksOK);
  addtoclosure(closure7030, selfslot);
  struct UserObject *uo7030 = (struct UserObject*)block7029;
  uo7030->data[0] = (Object)closure7030;
  Method *meth_meth_parser__apply7030 = addmethod2pos(block7029, "_apply", &meth_parser__apply7030, 0);
  int argcv_meth_parser__apply7030[] = {0};
  meth_meth_parser__apply7030->type = alloc_MethodType(1, argcv_meth_parser__apply7030);
  meth_meth_parser__apply7030->definitionModule = modulename;
  meth_meth_parser__apply7030->definitionLine = 3399;
// compiled block node returning block7029 (depth = 4)
  gc_frame_newslot(block7029);
// starting to compile block node (depth = 4)
  Object block7034 = alloc_Block(NULL, NULL, "parser", 2231);
  gc_frame_newslot(block7034);
// method "_apply"
  block_savedest(block7034);
  Object closure7035 = createclosure(8, "_apply");
  setclosureframe(closure7035, stackframe);
  addtoclosure(closure7035, var_values);
  addtoclosure(closure7035, var_tmp);
  addtoclosure(closure7035, var_params);
  addtoclosure(closure7035, var_blocksOK);
  addtoclosure(closure7035, var_errormessages);
  addtoclosure(closure7035, var_sym);
  addtoclosure(closure7035, var_lastToken);
  addtoclosure(closure7035, selfslot);
  struct UserObject *uo7035 = (struct UserObject*)block7034;
  uo7035->data[0] = (Object)closure7035;
  Method *meth_meth_parser__apply7035 = addmethod2pos(block7034, "_apply", &meth_parser__apply7035, 0);
  int argcv_meth_parser__apply7035[] = {0};
  meth_meth_parser__apply7035->type = alloc_MethodType(1, argcv_meth_parser__apply7035);
  meth_meth_parser__apply7035->definitionModule = modulename;
  meth_meth_parser__apply7035->definitionLine = 3399;
// compiled block node returning block7034 (depth = 4)
  gc_frame_newslot(block7034);
// call case 4: self request
  params[0] = block7029;
  params[1] = block7034;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7115 = callmethodflags(self, "ifConsume(1)then(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7028);
// compiled call node returning call7115 (depth = 3)
// Begin line 2256
  setline(2256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7118 == NULL) {
    strlit7118 = alloc_String("rsquare");
    gc_root(strlit7118);
  }
// compiled string node returning strlit7118 (depth = 5)
  int op_slot_right_7117 = gc_frame_newslot(strlit7118);
// starting to compile member node (depth = 5)
  int callframe7120 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call7121 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7120);
// compiled member node returning call7121 (depth = 5)
  int op_slot_left_7117 = gc_frame_newslot(call7121);
  params[0] = strlit7118;
  partcv[0] = 1;
  Object opresult7122 = callmethod(call7121, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7122 (depth = 4)
  Object if7116 = done;
  if (istrue(opresult7122)) {
// Begin line 2257
  setline(2257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7123 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7124 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call7125 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7124);
// compiled member node returning call7125 (depth = 6)
  Object call7126 = callmethodflags(call7125, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7123);
// compiled member node returning call7126 (depth = 5)
  *var_suggestion = call7126;
  if (call7126 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2258
  setline(2258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7127 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7128 == NULL) {
    strlit7128 = alloc_String("]");
    gc_root(strlit7128);
  }
// compiled string node returning strlit7128 (depth = 5)
  gc_frame_newslot(strlit7128);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit7128;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7129 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7127);
// compiled call node returning call7129 (depth = 4)
// Begin line 2259
  setline(2259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7130 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7131 == NULL) {
    strlit7131 = alloc_String("a Lineup beginning with a '[' must end with a ']'.");
    gc_root(strlit7131);
  }
// compiled string node returning strlit7131 (depth = 5)
  gc_frame_newslot(strlit7131);
// Begin line 2260
  setline(2260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7132 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call7133 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7132);
// compiled member node returning call7133 (depth = 5)
  gc_frame_newslot(call7133);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7135 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call7136 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe7135);
// compiled member node returning call7136 (depth = 6)
  int op_slot_right_7134 = gc_frame_newslot(call7136);
// starting to compile member node (depth = 6)
  int callframe7138 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call7139 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7138);
// compiled member node returning call7139 (depth = 6)
  int op_slot_left_7134 = gc_frame_newslot(call7139);
  params[0] = call7136;
  partcv[0] = 1;
  Object sum7140 = callmethod(call7139, "+(1)", 1, partcv, params);
// compiled op node returning sum7140 (depth = 5)
  gc_frame_newslot(sum7140);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2259
  setline(2259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7131;
  params[1] = call7133;
  params[2] = sum7140;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7141 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7130);
// compiled call node returning call7141 (depth = 4)
    gc_frame_newslot(call7141);
    if7116 = call7141;
  } else {
  }
// compiled if node returning if7116 (depth = 3)
// Begin line 2262
  setline(2262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7142 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  gc_frame_newslot(*var_params);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7143 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call7144 = callmethodflags(*var_ast, "arrayNode", 0, partcv, params, 0);
  gc_frame_end(callframe7143);
// compiled member node returning call7144 (depth = 5)
  params[0] = *var_params;
  partcv[0] = 1;
  Object call7145 = callmethodflags(call7144, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7142);
// compiled call node returning call7145 (depth = 4)
  *var_o = call7145;
  if (call7145 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2263
  setline(2263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7146 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call7147 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7146);
// compiled call node returning call7147 (depth = 3)
// Begin line 2264
  setline(2264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7148 = gc_frame_new();
// call case 4: self request
  Object call7149 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7148);
// compiled member node returning call7149 (depth = 3)
    gc_frame_newslot(call7149);
    if7021 = call7149;
  } else {
  }
// compiled if node returning if7021 (depth = 2)
  gc_frame_end(frame);
  return if7021;
}
Object meth_parser_dodialect7150(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 52, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dodialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_errorPos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "errorPos");
// Begin line 2270
  setline(2270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7152 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7153 == NULL) {
    strlit7153 = alloc_String("dialect");
    gc_root(strlit7153);
  }
// compiled string node returning strlit7153 (depth = 4)
  gc_frame_newslot(strlit7153);
// call case 4: self request
  params[0] = strlit7153;
  partcv[0] = 1;
  Object call7154 = callmethodflags(self, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7152);
// compiled call node returning call7154 (depth = 3)
  Object if7151 = done;
  if (istrue(call7154)) {
// Begin line 2271
  setline(2271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7155 = gc_frame_new();
// call case 4: self request
  Object call7156 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7155);
// compiled member node returning call7156 (depth = 3)
// Begin line 2272
  setline(2272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7159 == NULL) {
    strlit7159 = alloc_String("string");
    gc_root(strlit7159);
  }
// compiled string node returning strlit7159 (depth = 5)
  int op_slot_right_7158 = gc_frame_newslot(strlit7159);
// starting to compile member node (depth = 5)
  int callframe7161 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call7162 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7161);
// compiled member node returning call7162 (depth = 5)
  int op_slot_left_7158 = gc_frame_newslot(call7162);
  params[0] = strlit7159;
  partcv[0] = 1;
  Object opresult7163 = callmethod(call7162, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7163 (depth = 4)
  Object if7157 = done;
  if (istrue(opresult7163)) {
// Begin line 2273
  setline(2273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7164 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7165 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call7166 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7165);
// compiled member node returning call7166 (depth = 6)
  Object call7167 = callmethodflags(call7166, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7164);
// compiled member node returning call7167 (depth = 5)
  *var_suggestion = call7167;
  if (call7167 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2274
  setline(2274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 2275
  setline(2275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7171 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call7172 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7171);
// compiled member node returning call7172 (depth = 7)
  int op_slot_right_7170 = gc_frame_newslot(call7172);
// starting to compile member node (depth = 7)
  int callframe7174 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call7175 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7174);
// compiled member node returning call7175 (depth = 7)
  int op_slot_left_7170 = gc_frame_newslot(call7175);
  params[0] = call7172;
  partcv[0] = 1;
  Object opresult7176 = callmethod(call7175, "==(1)", 1, partcv, params);
// compiled op node returning opresult7176 (depth = 6)
  int op_slot_right_7169 = gc_frame_newslot(opresult7176);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7179 == NULL) {
    strlit7179 = alloc_String("identifier");
    gc_root(strlit7179);
  }
// compiled string node returning strlit7179 (depth = 7)
  int op_slot_right_7178 = gc_frame_newslot(strlit7179);
// starting to compile member node (depth = 7)
  int callframe7181 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call7182 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7181);
// compiled member node returning call7182 (depth = 7)
  int op_slot_left_7178 = gc_frame_newslot(call7182);
  params[0] = strlit7179;
  partcv[0] = 1;
  Object opresult7183 = callmethod(call7182, "==(1)", 1, partcv, params);
// compiled op node returning opresult7183 (depth = 6)
  int op_slot_left_7169 = gc_frame_newslot(opresult7183);
  params[0] = opresult7176;
  partcv[0] = 1;
  Object opresult7184 = callmethod(opresult7183, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7184 (depth = 5)
  Object if7168 = done;
  if (istrue(opresult7184)) {
// Begin line 2276
  setline(2276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7185 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7187 == NULL) {
    strlit7187 = alloc_String("""\x22""");
    gc_root(strlit7187);
  }
// compiled string node returning strlit7187 (depth = 7)
  int op_slot_right_7186 = gc_frame_newslot(strlit7187);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe7190 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call7191 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7190);
// compiled member node returning call7191 (depth = 8)
  int op_slot_right_7189 = gc_frame_newslot(call7191);
// starting to compile string node (depth = 8)
  if (strlit7193 == NULL) {
    strlit7193 = alloc_String("""\x22""");
    gc_root(strlit7193);
  }
// compiled string node returning strlit7193 (depth = 8)
  int op_slot_left_7189 = gc_frame_newslot(strlit7193);
  params[0] = call7191;
  partcv[0] = 1;
  Object opresult7194 = callmethod(strlit7193, "++(1)", 1, partcv, params);
// compiled op node returning opresult7194 (depth = 7)
  int op_slot_left_7186 = gc_frame_newslot(opresult7194);
  params[0] = strlit7187;
  partcv[0] = 1;
  Object opresult7195 = callmethod(opresult7194, "++(1)", 1, partcv, params);
// compiled op node returning opresult7195 (depth = 6)
  gc_frame_newslot(opresult7195);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult7195;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7196 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7185);
// compiled call node returning call7196 (depth = 5)
// Begin line 2277
  setline(2277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7197 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call7198 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7197);
// compiled member node returning call7198 (depth = 6)
  *var_errorPos = call7198;
  if (call7198 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7168 = done;
  } else {
// Begin line 2279
  setline(2279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7200 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7201 == NULL) {
    strlit7201 = alloc_String(" ""\x22""""\xc2""""\xab""dialect name""\xc2""""\xbb""""\x22""");
    gc_root(strlit7201);
  }
// compiled string node returning strlit7201 (depth = 6)
  gc_frame_newslot(strlit7201);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7201;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7202 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7200);
// compiled call node returning call7202 (depth = 5)
// Begin line 2280
  setline(2280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7204 = alloc_Float64(1);
// compiled num node returning num7204 (depth = 7)
  int op_slot_right_7203 = gc_frame_newslot(num7204);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe7207 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call7208 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe7207);
// compiled member node returning call7208 (depth = 8)
  int op_slot_right_7206 = gc_frame_newslot(call7208);
// starting to compile member node (depth = 8)
  int callframe7210 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call7211 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7210);
// compiled member node returning call7211 (depth = 8)
  int op_slot_left_7206 = gc_frame_newslot(call7211);
  params[0] = call7208;
  partcv[0] = 1;
  Object sum7212 = callmethod(call7211, "+(1)", 1, partcv, params);
// compiled op node returning sum7212 (depth = 7)
  int op_slot_left_7203 = gc_frame_newslot(sum7212);
  params[0] = num7204;
  partcv[0] = 1;
  Object sum7213 = callmethod(sum7212, "+(1)", 1, partcv, params);
// compiled op node returning sum7213 (depth = 6)
  *var_errorPos = sum7213;
  if (sum7213 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7168 = done;
  }
// compiled if node returning if7168 (depth = 4)
// Begin line 2282
  setline(2282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7215 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7216 == NULL) {
    strlit7216 = alloc_String("a dialect statement must have the name of the dialect in quotes after the 'dialect'.");
    gc_root(strlit7216);
  }
// compiled string node returning strlit7216 (depth = 5)
  gc_frame_newslot(strlit7216);
// Begin line 2283
  setline(2283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7217 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call7218 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7217);
// compiled member node returning call7218 (depth = 5)
  gc_frame_newslot(call7218);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2282
  setline(2282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7216;
  params[1] = call7218;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7219 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7215);
// compiled call node returning call7219 (depth = 4)
    gc_frame_newslot(call7219);
    if7157 = call7219;
  } else {
  }
// compiled if node returning if7157 (depth = 3)
// Begin line 2285
  setline(2285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7220 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7221 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7222 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call7223 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7222);
// compiled member node returning call7223 (depth = 5)
  gc_frame_newslot(call7223);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7224 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call7225 = callmethodflags(*var_ast, "dialectNode", 0, partcv, params, 0);
  gc_frame_end(callframe7224);
// compiled member node returning call7225 (depth = 5)
  params[0] = call7223;
  partcv[0] = 1;
  Object call7226 = callmethodflags(call7225, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7221);
// compiled call node returning call7226 (depth = 4)
  gc_frame_newslot(call7226);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = call7226;
  partcv[0] = 1;
  Object call7227 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7220);
// compiled call node returning call7227 (depth = 3)
// Begin line 2286
  setline(2286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7228 = gc_frame_new();
// call case 4: self request
  Object call7229 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7228);
// compiled member node returning call7229 (depth = 3)
    gc_frame_newslot(call7229);
    if7151 = call7229;
  } else {
  }
// compiled if node returning if7151 (depth = 2)
  gc_frame_end(frame);
  return if7151;
}
Object meth_parser__apply7270(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe7271 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_noBlocks (depth = 8)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call7272 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7271);
// compiled call node returning call7272 (depth = 7)
  gc_frame_end(frame);
  return call7272;
}
Object meth_parser__apply7380(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_inhNode = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe7381 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inhNode (depth = 6)
  gc_frame_newslot(*var_inhNode);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  gc_frame_newslot(*var_btok);
// call case 4: self request
  params[0] = *var_inhNode;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7382 = callmethodflags(self, "inheritsModifier(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7381);
// compiled call node returning call7382 (depth = 5)
  gc_frame_end(frame);
  return call7382;
}
Object meth_parser__apply7385(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_parser_inheritsOrUses7230(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 53, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritsOrUses");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_done = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_noBlocks = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_values = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_msg = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "msg");
  Object *var_inhNode = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "inhNode");
// Begin line 2293
  setline(2293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7232 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe7233 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7234 == NULL) {
    strlit7234 = alloc_String("keyword");
    gc_root(strlit7234);
  }
// compiled string node returning strlit7234 (depth = 5)
  gc_frame_newslot(strlit7234);
// call case 4: self request
  params[0] = strlit7234;
  partcv[0] = 1;
  Object call7235 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7233);
// compiled call node returning call7235 (depth = 4)
  partcv[0] = 0;
  Object call7236 = callmethodflags(call7235, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe7232);
// compiled call node returning call7236 (depth = 3)
  Object if7231 = done;
  if (istrue(call7236)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if7231 = undefined;
  } else {
  }
// compiled if node returning if7231 (depth = 2)
// Begin line 2294
  setline(2294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7240 == NULL) {
    strlit7240 = alloc_String("use");
    gc_root(strlit7240);
  }
// compiled string node returning strlit7240 (depth = 5)
  int op_slot_right_7239 = gc_frame_newslot(strlit7240);
// starting to compile member node (depth = 5)
  int callframe7242 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call7243 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7242);
// compiled member node returning call7243 (depth = 5)
  int op_slot_left_7239 = gc_frame_newslot(call7243);
  params[0] = strlit7240;
  partcv[0] = 1;
  Object opresult7244 = callmethod(call7243, "==(1)", 1, partcv, params);
// compiled op node returning opresult7244 (depth = 4)
  int op_slot_right_7238 = gc_frame_newslot(opresult7244);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7248 == NULL) {
    strlit7248 = alloc_String("inherit");
    gc_root(strlit7248);
  }
// compiled string node returning strlit7248 (depth = 6)
  int op_slot_right_7247 = gc_frame_newslot(strlit7248);
// starting to compile member node (depth = 6)
  int callframe7250 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call7251 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7250);
// compiled member node returning call7251 (depth = 6)
  int op_slot_left_7247 = gc_frame_newslot(call7251);
  params[0] = strlit7248;
  partcv[0] = 1;
  Object opresult7252 = callmethod(call7251, "==(1)", 1, partcv, params);
// compiled op node returning opresult7252 (depth = 5)
  int op_slot_right_7246 = gc_frame_newslot(opresult7252);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7255 == NULL) {
    strlit7255 = alloc_String("inherits");
    gc_root(strlit7255);
  }
// compiled string node returning strlit7255 (depth = 6)
  int op_slot_right_7254 = gc_frame_newslot(strlit7255);
// starting to compile member node (depth = 6)
  int callframe7257 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call7258 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7257);
// compiled member node returning call7258 (depth = 6)
  int op_slot_left_7254 = gc_frame_newslot(call7258);
  params[0] = strlit7255;
  partcv[0] = 1;
  Object opresult7259 = callmethod(call7258, "==(1)", 1, partcv, params);
// compiled op node returning opresult7259 (depth = 5)
  int op_slot_left_7246 = gc_frame_newslot(opresult7259);
  params[0] = opresult7252;
  partcv[0] = 1;
  Object opresult7260 = callmethod(opresult7259, "||(1)", 1, partcv, params);
// compiled op node returning opresult7260 (depth = 4)
  int op_slot_left_7238 = gc_frame_newslot(opresult7260);
  params[0] = opresult7244;
  partcv[0] = 1;
  Object opresult7261 = callmethod(opresult7260, "||(1)", 1, partcv, params);
// compiled op node returning opresult7261 (depth = 3)
  Object if7237 = done;
  if (istrue(opresult7261)) {
// Begin line 2295
  setline(2295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2296
  setline(2296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7262 = gc_frame_new();
// call case 4: self request
  Object call7263 = callmethodflags(self, "checkIndent", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7262);
// compiled member node returning call7263 (depth = 3)
// Begin line 2297
  setline(2297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7264 = gc_frame_new();
// call case 4: self request
  Object call7265 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7264);
// compiled member node returning call7265 (depth = 3)
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7267 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe7268 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7269 = alloc_Block(NULL, NULL, "parser", 2298);
  gc_frame_newslot(block7269);
// method "_apply"
  block_savedest(block7269);
  Object closure7270 = createclosure(2, "_apply");
  setclosureframe(closure7270, stackframe);
  addtoclosure(closure7270, var_noBlocks);
  addtoclosure(closure7270, selfslot);
  struct UserObject *uo7270 = (struct UserObject*)block7269;
  uo7270->data[0] = (Object)closure7270;
  Method *meth_meth_parser__apply7270 = addmethod2pos(block7269, "_apply", &meth_parser__apply7270, 0);
  int argcv_meth_parser__apply7270[] = {0};
  meth_meth_parser__apply7270->type = alloc_MethodType(1, argcv_meth_parser__apply7270);
  meth_meth_parser__apply7270->definitionModule = modulename;
  meth_meth_parser__apply7270->definitionLine = 3399;
// compiled block node returning block7269 (depth = 6)
  gc_frame_newslot(block7269);
// call case 4: self request
  params[0] = block7269;
  partcv[0] = 1;
  Object call7274 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7268);
// compiled call node returning call7274 (depth = 5)
  Object call7275 = callmethodflags(call7274, "not", 0, partcv, params, 0);
  gc_frame_end(callframe7267);
// compiled member node returning call7275 (depth = 4)
  Object if7266 = done;
  if (istrue(call7275)) {
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array7276 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7276 (depth = 5)
  *var_suggestions = array7276;
  if (array7276 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2300
  setline(2300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7277 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7278 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call7279 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7278);
// compiled member node returning call7279 (depth = 6)
  Object call7280 = callmethodflags(call7279, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7277);
// compiled member node returning call7280 (depth = 5)
  *var_suggestion = call7280;
  if (call7280 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2301
  setline(2301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7281 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array7282 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit7283 == NULL) {
    strlit7283 = alloc_String("rsquare");
    gc_root(strlit7283);
  }
// compiled string node returning strlit7283 (depth = 7)
  params[0] = strlit7283;
  partcv[0] = 1;
  callmethodflags(array7282, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array7282 (depth = 6)
  gc_frame_newslot(array7282);
// call case 4: self request
  params[0] = array7282;
  partcv[0] = 1;
  Object call7284 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7281);
// compiled call node returning call7284 (depth = 5)
  *var_nextTok = call7284;
  if (call7284 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2302
  setline(2302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_7286 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_7286 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7288 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult7288 (depth = 5)
  Object if7285 = done;
  if (istrue(opresult7288)) {
// Begin line 2303
  setline(2303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7289 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7290 == NULL) {
    strlit7290 = alloc_String(" ""\xc2""""\xab""parent""\xc2""""\xbb""");
    gc_root(strlit7290);
  }
// compiled string node returning strlit7290 (depth = 6)
  gc_frame_newslot(strlit7290);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7290;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7291 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7289);
// compiled call node returning call7291 (depth = 5)
    gc_frame_newslot(call7291);
    if7285 = call7291;
  } else {
// Begin line 2305
  setline(2305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7292 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe7293 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  Object call7294 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe7293);
// compiled member node returning call7294 (depth = 6)
  gc_frame_newslot(call7294);
// starting to compile identifier node (depth = 6)
  Object bool7295 = alloc_Boolean(1);
// compiled identifier node returning bool7295 (depth = 6)
  gc_frame_newslot(bool7295);
// starting to compile identifier node (depth = 6)
  Object bool7296 = alloc_Boolean(0);
// compiled identifier node returning bool7296 (depth = 6)
  gc_frame_newslot(bool7296);
// starting to compile string node (depth = 6)
  if (strlit7297 == NULL) {
    strlit7297 = alloc_String(" ""\xc2""""\xab""parent""\xc2""""\xbb""");
    gc_root(strlit7297);
  }
// compiled string node returning strlit7297 (depth = 6)
  gc_frame_newslot(strlit7297);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call7294;
  params[2] = bool7295;
  params[3] = bool7296;
  params[4] = strlit7297;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7298 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe7292);
// compiled call node returning call7298 (depth = 5)
    gc_frame_newslot(call7298);
    if7285 = call7298;
  }
// compiled if node returning if7285 (depth = 4)
// Begin line 2307
  setline(2307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7299 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7300 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7299);
// compiled call node returning call7300 (depth = 4)
// Begin line 2308
  setline(2308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7301 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7302 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call7303 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7302);
// compiled member node returning call7303 (depth = 6)
  Object call7304 = callmethodflags(call7303, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7301);
// compiled member node returning call7304 (depth = 5)
  *var_suggestion = call7304;
  if (call7304 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2309
  setline(2309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7306 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 5)
  int callframe7307 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  Object call7308 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe7307);
// compiled member node returning call7308 (depth = 5)
  gc_frame_newslot(call7308);
// starting to compile identifier node (depth = 5)
  Object bool7309 = alloc_Boolean(1);
// compiled identifier node returning bool7309 (depth = 5)
  gc_frame_newslot(bool7309);
// starting to compile identifier node (depth = 5)
  Object bool7310 = alloc_Boolean(0);
// compiled identifier node returning bool7310 (depth = 5)
  gc_frame_newslot(bool7310);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  params[1] = call7308;
  params[2] = bool7309;
  params[3] = bool7310;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7311 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7306);
// compiled call node returning call7311 (depth = 4)
// Begin line 2310
  setline(2310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7312 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7313 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7312);
// compiled call node returning call7313 (depth = 4)
// Begin line 2311
  setline(2311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7315 == NULL) {
    strlit7315 = alloc_String(" keyword must be followed by an expression that creates ");
    gc_root(strlit7315);
  }
// compiled string node returning strlit7315 (depth = 6)
  int op_slot_right_7314 = gc_frame_newslot(strlit7315);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7318 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_btok (depth = 8)
  Object call7319 = callmethodflags(*var_btok, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7318);
// compiled member node returning call7319 (depth = 7)
  int op_slot_right_7317 = gc_frame_newslot(call7319);
// starting to compile string node (depth = 7)
  if (strlit7321 == NULL) {
    strlit7321 = alloc_String("The ");
    gc_root(strlit7321);
  }
// compiled string node returning strlit7321 (depth = 7)
  int op_slot_left_7317 = gc_frame_newslot(strlit7321);
  params[0] = call7319;
  partcv[0] = 1;
  Object opresult7322 = callmethod(strlit7321, "++(1)", 1, partcv, params);
// compiled op node returning opresult7322 (depth = 6)
  int op_slot_left_7314 = gc_frame_newslot(opresult7322);
  params[0] = strlit7315;
  partcv[0] = 1;
  Object opresult7323 = callmethod(opresult7322, "++(1)", 1, partcv, params);
// compiled op node returning opresult7323 (depth = 5)
  *var_msg = opresult7323;
  if (opresult7323 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2312
  setline(2312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7326 == NULL) {
    strlit7326 = alloc_String("use");
    gc_root(strlit7326);
  }
// compiled string node returning strlit7326 (depth = 6)
  int op_slot_right_7325 = gc_frame_newslot(strlit7326);
// starting to compile member node (depth = 6)
  int callframe7328 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  Object call7329 = callmethodflags(*var_btok, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7328);
// compiled member node returning call7329 (depth = 6)
  int op_slot_left_7325 = gc_frame_newslot(call7329);
  params[0] = strlit7326;
  partcv[0] = 1;
  Object opresult7330 = callmethod(call7329, "==(1)", 1, partcv, params);
// compiled op node returning opresult7330 (depth = 5)
  Object if7324 = done;
  if (istrue(opresult7330)) {
// Begin line 2313
  setline(2313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7332 == NULL) {
    strlit7332 = alloc_String("the trait being used.");
    gc_root(strlit7332);
  }
// compiled string node returning strlit7332 (depth = 7)
  int op_slot_right_7331 = gc_frame_newslot(strlit7332);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_msg (depth = 7)
  int op_slot_left_7331 = gc_frame_newslot(*var_msg);
  params[0] = strlit7332;
  partcv[0] = 1;
  Object opresult7334 = callmethod(*var_msg, "++(1)", 1, partcv, params);
// compiled op node returning opresult7334 (depth = 6)
  *var_msg = opresult7334;
  if (opresult7334 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7324 = done;
  } else {
// Begin line 2315
  setline(2315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7337 == NULL) {
    strlit7337 = alloc_String("the object being inherited.");
    gc_root(strlit7337);
  }
// compiled string node returning strlit7337 (depth = 7)
  int op_slot_right_7336 = gc_frame_newslot(strlit7337);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_msg (depth = 7)
  int op_slot_left_7336 = gc_frame_newslot(*var_msg);
  params[0] = strlit7337;
  partcv[0] = 1;
  Object opresult7339 = callmethod(*var_msg, "++(1)", 1, partcv, params);
// compiled op node returning opresult7339 (depth = 6)
  *var_msg = opresult7339;
  if (opresult7339 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7324 = done;
  }
// compiled if node returning if7324 (depth = 4)
// Begin line 2317
  setline(2317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7341 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_msg (depth = 5)
  gc_frame_newslot(*var_msg);
// Begin line 2318
  setline(2318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7342 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call7343 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7342);
// compiled member node returning call7343 (depth = 5)
  gc_frame_newslot(call7343);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7345 = alloc_Float64(1);
// compiled num node returning num7345 (depth = 6)
  int op_slot_right_7344 = gc_frame_newslot(num7345);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7348 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call7349 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe7348);
// compiled member node returning call7349 (depth = 7)
  int op_slot_right_7347 = gc_frame_newslot(call7349);
// starting to compile member node (depth = 7)
  int callframe7351 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call7352 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7351);
// compiled member node returning call7352 (depth = 7)
  int op_slot_left_7347 = gc_frame_newslot(call7352);
  params[0] = call7349;
  partcv[0] = 1;
  Object sum7353 = callmethod(call7352, "+(1)", 1, partcv, params);
// compiled op node returning sum7353 (depth = 6)
  int op_slot_left_7344 = gc_frame_newslot(sum7353);
  params[0] = num7345;
  partcv[0] = 1;
  Object sum7354 = callmethod(sum7353, "+(1)", 1, partcv, params);
// compiled op node returning sum7354 (depth = 5)
  gc_frame_newslot(sum7354);
// Begin line 2319
  setline(2319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2317
  setline(2317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = *var_msg;
  params[1] = call7343;
  params[2] = sum7354;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7355 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7341);
// compiled call node returning call7355 (depth = 4)
    gc_frame_newslot(call7355);
    if7266 = call7355;
  } else {
  }
// compiled if node returning if7266 (depth = 3)
// Begin line 2321
  setline(2321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7356 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7357 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  Object call7358 = callmethodflags(*var_btok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7357);
// compiled member node returning call7358 (depth = 4)
  gc_frame_newslot(call7358);
// starting to compile member node (depth = 4)
  int callframe7359 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  Object call7360 = callmethodflags(*var_btok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7359);
// compiled member node returning call7360 (depth = 4)
  gc_frame_newslot(call7360);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call7358;
  params[1] = call7360;
  partcv[0] = 2;
  Object call7361 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7356);
// compiled call node returning call7361 (depth = 3)
// Begin line 2322
  setline(2322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7362 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7363 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call7364 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe7363);
// compiled member node returning call7364 (depth = 5)
  gc_frame_newslot(call7364);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7365 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call7366 = callmethodflags(*var_ast, "inheritsNode", 0, partcv, params, 0);
  gc_frame_end(callframe7365);
// compiled member node returning call7366 (depth = 5)
  params[0] = call7364;
  partcv[0] = 1;
  Object call7367 = callmethodflags(call7366, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7362);
// compiled call node returning call7367 (depth = 4)
  *var_inhNode = call7367;
  if (call7367 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2323
  setline(2323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7370 == NULL) {
    strlit7370 = alloc_String("use");
    gc_root(strlit7370);
  }
// compiled string node returning strlit7370 (depth = 5)
  int op_slot_right_7369 = gc_frame_newslot(strlit7370);
// starting to compile member node (depth = 5)
  int callframe7372 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  Object call7373 = callmethodflags(*var_btok, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7372);
// compiled member node returning call7373 (depth = 5)
  int op_slot_left_7369 = gc_frame_newslot(call7373);
  params[0] = strlit7370;
  partcv[0] = 1;
  Object opresult7374 = callmethod(call7373, "==(1)", 1, partcv, params);
// compiled op node returning opresult7374 (depth = 4)
  Object if7368 = done;
  if (istrue(opresult7374)) {
// Begin line 2324
  setline(2324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7375 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool7376 = alloc_Boolean(1);
// compiled identifier node returning bool7376 (depth = 5)
  gc_frame_newslot(bool7376);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_inhNode (depth = 5)
  params[0] = bool7376;
  partcv[0] = 1;
  Object call7377 = callmethodflags(*var_inhNode, "isUse:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7375);
// compiled call node returning call7377 (depth = 4)
    gc_frame_newslot(call7377);
    if7368 = call7377;
  } else {
  }
// compiled if node returning if7368 (depth = 3)
// Begin line 2326
  setline(2326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7378 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block7379 = alloc_Block(NULL, NULL, "parser", 2326);
  gc_frame_newslot(block7379);
// method "_apply"
  block_savedest(block7379);
  Object closure7380 = createclosure(3, "_apply");
  setclosureframe(closure7380, stackframe);
  addtoclosure(closure7380, var_inhNode);
  addtoclosure(closure7380, var_btok);
  addtoclosure(closure7380, selfslot);
  struct UserObject *uo7380 = (struct UserObject*)block7379;
  uo7380->data[0] = (Object)closure7380;
  Method *meth_meth_parser__apply7380 = addmethod2pos(block7379, "_apply", &meth_parser__apply7380, 0);
  int argcv_meth_parser__apply7380[] = {0};
  meth_meth_parser__apply7380->type = alloc_MethodType(1, argcv_meth_parser__apply7380);
  meth_meth_parser__apply7380->definitionModule = modulename;
  meth_meth_parser__apply7380->definitionLine = 3399;
// compiled block node returning block7379 (depth = 4)
  gc_frame_newslot(block7379);
// starting to compile block node (depth = 4)
  Object block7384 = alloc_Block(NULL, NULL, "parser", 2326);
  gc_frame_newslot(block7384);
// method "_apply"
  block_savedest(block7384);
  Object closure7385 = createclosure(1, "_apply");
  setclosureframe(closure7385, stackframe);
  addtoclosure(closure7385, selfslot);
  struct UserObject *uo7385 = (struct UserObject*)block7384;
  uo7385->data[0] = (Object)closure7385;
  Method *meth_meth_parser__apply7385 = addmethod2pos(block7384, "_apply", &meth_parser__apply7385, 0);
  int argcv_meth_parser__apply7385[] = {0};
  meth_meth_parser__apply7385->type = alloc_MethodType(1, argcv_meth_parser__apply7385);
  meth_meth_parser__apply7385->definitionModule = modulename;
  meth_meth_parser__apply7385->definitionLine = 3399;
// compiled block node returning block7384 (depth = 4)
  gc_frame_newslot(block7384);
// call case 5: prelude request
  params[0] = block7379;
  params[1] = block7384;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7387 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7378);
// compiled call node returning call7387 (depth = 3)
// Begin line 2327
  setline(2327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7388 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_inhNode (depth = 4)
  gc_frame_newslot(*var_inhNode);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_inhNode;
  partcv[0] = 1;
  Object call7389 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7388);
// compiled call node returning call7389 (depth = 3)
    gc_frame_newslot(call7389);
    if7237 = call7389;
  } else {
  }
// compiled if node returning if7237 (depth = 2)
  gc_frame_end(frame);
  return if7237;
}
Object meth_parser_inheritsModifier_40_1_41_onLineOf_40_1_41_7390(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 54, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritsModifier(1)onLineOf(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method inheritsModifier(_)onLineOf(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method inheritsModifier(_)onLineOf(_)");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for inheritsModifier(_)onLineOf(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part inheritsModifier(_)");
  Object *var_startToken = &(stackframe->slots[1]);
  *var_startToken = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onLineOf(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2333
  setline(2333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7392 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe7393 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7394 == NULL) {
    strlit7394 = alloc_String("keyword");
    gc_root(strlit7394);
  }
// compiled string node returning strlit7394 (depth = 5)
  gc_frame_newslot(strlit7394);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startToken (depth = 5)
  gc_frame_newslot(*var_startToken);
// call case 4: self request
  params[0] = strlit7394;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7395 = callmethodflags(self, "accept(1)onLineOf(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7393);
// compiled call node returning call7395 (depth = 4)
  partcv[0] = 0;
  Object call7396 = callmethodflags(call7395, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe7392);
// compiled call node returning call7396 (depth = 3)
  Object if7391 = done;
  if (istrue(call7396)) {
// Begin line 2334
  setline(2334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool7397 = alloc_Boolean(0);
// compiled identifier node returning bool7397 (depth = 4)
  return bool7397;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if7391 = undefined;
  } else {
  }
// compiled if node returning if7391 (depth = 2)
// Begin line 2336
  setline(2336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7400 == NULL) {
    strlit7400 = alloc_String("alias");
    gc_root(strlit7400);
  }
// compiled string node returning strlit7400 (depth = 4)
  int op_slot_right_7399 = gc_frame_newslot(strlit7400);
// starting to compile member node (depth = 4)
  int callframe7402 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call7403 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7402);
// compiled member node returning call7403 (depth = 4)
  int op_slot_left_7399 = gc_frame_newslot(call7403);
  params[0] = strlit7400;
  partcv[0] = 1;
  Object opresult7404 = callmethod(call7403, "==(1)", 1, partcv, params);
// compiled op node returning opresult7404 (depth = 3)
  Object if7398 = done;
  if (istrue(opresult7404)) {
// Begin line 2337
  setline(2337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7405 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_node (depth = 4)
  gc_frame_newslot(*var_node);
// call case 4: self request
  params[0] = *var_node;
  partcv[0] = 1;
  Object call7406 = callmethodflags(self, "parseAlias(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7405);
// compiled call node returning call7406 (depth = 3)
    gc_frame_newslot(call7406);
    if7398 = call7406;
  } else {
// Begin line 2340
  setline(2340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2338
  setline(2338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7409 == NULL) {
    strlit7409 = alloc_String("exclude");
    gc_root(strlit7409);
  }
// compiled string node returning strlit7409 (depth = 5)
  int op_slot_right_7408 = gc_frame_newslot(strlit7409);
// starting to compile member node (depth = 5)
  int callframe7411 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call7412 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7411);
// compiled member node returning call7412 (depth = 5)
  int op_slot_left_7408 = gc_frame_newslot(call7412);
  params[0] = strlit7409;
  partcv[0] = 1;
  Object opresult7413 = callmethod(call7412, "==(1)", 1, partcv, params);
// compiled op node returning opresult7413 (depth = 4)
  Object if7407 = done;
  if (istrue(opresult7413)) {
// Begin line 2339
  setline(2339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7414 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  gc_frame_newslot(*var_node);
// call case 4: self request
  params[0] = *var_node;
  partcv[0] = 1;
  Object call7415 = callmethodflags(self, "parseExclude(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7414);
// compiled call node returning call7415 (depth = 4)
    gc_frame_newslot(call7415);
    if7407 = call7415;
  } else {
// Begin line 2341
  setline(2341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7416 = alloc_Boolean(0);
// compiled identifier node returning bool7416 (depth = 4)
    gc_frame_newslot(bool7416);
    if7407 = bool7416;
  }
// compiled if node returning if7407 (depth = 3)
    gc_frame_newslot(if7407);
    if7398 = if7407;
  }
// compiled if node returning if7398 (depth = 2)
  gc_frame_end(frame);
  return if7398;
}
Object meth_parser_parseAlias_40_1_41_7417(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 55, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parseAlias(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseAlias(_)");
  Object params[4];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parseAlias(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parseAlias(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newMeth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newMeth");
  Object *var_oldMeth = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldMeth");
// Begin line 2346
  setline(2346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe7418 = gc_frame_new();
// call case 4: self request
  Object call7419 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7418);
// compiled member node returning call7419 (depth = 2)
// Begin line 2347
  setline(2347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7420 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool7421 = alloc_Boolean(1);
// compiled identifier node returning bool7421 (depth = 4)
  gc_frame_newslot(bool7421);
// call case 4: self request
  params[0] = bool7421;
  partcv[0] = 1;
  Object call7422 = callmethodflags(self, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7420);
// compiled call node returning call7422 (depth = 3)
  *var_newMeth = call7422;
  if (call7422 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2348
  setline(2348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7426 == NULL) {
    strlit7426 = alloc_String("=");
    gc_root(strlit7426);
  }
// compiled string node returning strlit7426 (depth = 5)
  int op_slot_right_7425 = gc_frame_newslot(strlit7426);
// starting to compile member node (depth = 5)
  int callframe7428 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call7429 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7428);
// compiled member node returning call7429 (depth = 5)
  int op_slot_left_7425 = gc_frame_newslot(call7429);
  params[0] = strlit7426;
  partcv[0] = 1;
  Object opresult7430 = callmethod(call7429, "==(1)", 1, partcv, params);
// compiled op node returning opresult7430 (depth = 4)
  int op_slot_right_7424 = gc_frame_newslot(opresult7430);
// starting to compile call node (depth = 4)
  int callframe7432 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7433 == NULL) {
    strlit7433 = alloc_String("op");
    gc_root(strlit7433);
  }
// compiled string node returning strlit7433 (depth = 5)
  gc_frame_newslot(strlit7433);
// call case 4: self request
  params[0] = strlit7433;
  partcv[0] = 1;
  Object call7434 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7432);
// compiled call node returning call7434 (depth = 4)
  int op_slot_left_7424 = gc_frame_newslot(call7434);
  params[0] = opresult7430;
  partcv[0] = 1;
  Object opresult7435 = callmethod(call7434, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7435 (depth = 3)
  Object if7423 = done;
  if (istrue(opresult7435)) {
// Begin line 2349
  setline(2349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7436 = gc_frame_new();
// call case 4: self request
  Object call7437 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7436);
// compiled member node returning call7437 (depth = 3)
// Begin line 2350
  setline(2350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7438 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe7439 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool7440 = alloc_Boolean(1);
// compiled identifier node returning bool7440 (depth = 6)
  gc_frame_newslot(bool7440);
// call case 4: self request
  params[0] = bool7440;
  partcv[0] = 1;
  Object call7441 = callmethodflags(self, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7439);
// compiled call node returning call7441 (depth = 5)
  Object call7442 = callmethodflags(call7441, "appliedOccurence", 0, partcv, params, 0);
  gc_frame_end(callframe7438);
// compiled member node returning call7442 (depth = 4)
  *var_oldMeth = call7442;
  if (call7442 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2351
  setline(2351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7445 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldMeth (depth = 6)
  Object call7446 = callmethodflags(*var_oldMeth, "numParams", 0, partcv, params, 0);
  gc_frame_end(callframe7445);
// compiled member node returning call7446 (depth = 5)
  int op_slot_right_7444 = gc_frame_newslot(call7446);
// starting to compile member node (depth = 5)
  int callframe7448 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newMeth (depth = 6)
  Object call7449 = callmethodflags(*var_newMeth, "numParams", 0, partcv, params, 0);
  gc_frame_end(callframe7448);
// compiled member node returning call7449 (depth = 5)
  int op_slot_left_7444 = gc_frame_newslot(call7449);
  params[0] = call7446;
  partcv[0] = 1;
  Object opresult7450 = callmethod(call7449, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7450 (depth = 4)
  Object if7443 = done;
  if (istrue(opresult7450)) {
// Begin line 2352
  setline(2352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7451 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7452 == NULL) {
    strlit7452 = alloc_String("a method and its alias must have the same number of parameters");
    gc_root(strlit7452);
  }
// compiled string node returning strlit7452 (depth = 5)
  gc_frame_newslot(strlit7452);
// Begin line 2353
  setline(2353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7453 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newMeth (depth = 6)
  Object call7454 = callmethodflags(*var_newMeth, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7453);
// compiled member node returning call7454 (depth = 5)
  gc_frame_newslot(call7454);
// starting to compile member node (depth = 5)
  int callframe7455 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newMeth (depth = 6)
  Object call7456 = callmethodflags(*var_newMeth, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7455);
// compiled member node returning call7456 (depth = 5)
  gc_frame_newslot(call7456);
// starting to compile member node (depth = 5)
  int callframe7457 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldMeth (depth = 6)
  Object call7458 = callmethodflags(*var_oldMeth, "endPos", 0, partcv, params, 0);
  gc_frame_end(callframe7457);
// compiled member node returning call7458 (depth = 5)
  gc_frame_newslot(call7458);
// call case 6: other requests
// Begin line 2352
  setline(2352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7452;
  params[1] = call7454;
  params[2] = call7456;
  params[3] = call7458;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call7459 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe7451);
// compiled call node returning call7459 (depth = 4)
    gc_frame_newslot(call7459);
    if7443 = call7459;
  } else {
  }
// compiled if node returning if7443 (depth = 3)
// Begin line 2355
  setline(2355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7460 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7461 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newMeth (depth = 5)
  Object call7462 = callmethodflags(*var_newMeth, "asIdentifier", 0, partcv, params, 0);
  gc_frame_end(callframe7461);
// compiled member node returning call7462 (depth = 4)
  gc_frame_newslot(call7462);
// starting to compile member node (depth = 4)
  int callframe7463 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_oldMeth (depth = 5)
  Object call7464 = callmethodflags(*var_oldMeth, "asIdentifier", 0, partcv, params, 0);
  gc_frame_end(callframe7463);
// compiled member node returning call7464 (depth = 4)
  gc_frame_newslot(call7464);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_node (depth = 4)
  params[0] = call7462;
  params[1] = call7464;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7465 = callmethodflags(*var_node, "addAlias(1)for(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7460);
// compiled call node returning call7465 (depth = 3)
    gc_frame_newslot(call7465);
    if7423 = call7465;
  } else {
// Begin line 2357
  setline(2357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7466 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 2358
  setline(2358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit7468 == NULL) {
    strlit7468 = alloc_String("'""\xe2""""\x80""""\xb9""newMethodName""\xe2""""\x80""""\xba"" = ""\xe2""""\x80""""\xb9""oldMethodName""\xe2""""\x80""""\xba""'");
    gc_root(strlit7468);
  }
// compiled string node returning strlit7468 (depth = 5)
  int op_slot_right_7467 = gc_frame_newslot(strlit7468);
// Begin line 2357
  setline(2357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit7470 == NULL) {
    strlit7470 = alloc_String("an alias modifier must take the form ");
    gc_root(strlit7470);
  }
// compiled string node returning strlit7470 (depth = 5)
  int op_slot_left_7467 = gc_frame_newslot(strlit7470);
  params[0] = strlit7468;
  partcv[0] = 1;
  Object opresult7471 = callmethod(strlit7470, "++(1)", 1, partcv, params);
// compiled op node returning opresult7471 (depth = 4)
  gc_frame_newslot(opresult7471);
// Begin line 2359
  setline(2359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7472 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call7473 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7472);
// compiled member node returning call7473 (depth = 4)
  gc_frame_newslot(call7473);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7475 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call7476 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe7475);
// compiled member node returning call7476 (depth = 5)
  int op_slot_right_7474 = gc_frame_newslot(call7476);
// starting to compile member node (depth = 5)
  int callframe7478 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call7479 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7478);
// compiled member node returning call7479 (depth = 5)
  int op_slot_left_7474 = gc_frame_newslot(call7479);
  params[0] = call7476;
  partcv[0] = 1;
  Object sum7480 = callmethod(call7479, "+(1)", 1, partcv, params);
// compiled op node returning sum7480 (depth = 4)
  gc_frame_newslot(sum7480);
// call case 6: other requests
// Begin line 2357
  setline(2357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult7471;
  params[1] = call7473;
  params[2] = sum7480;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call7481 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe7466);
// compiled call node returning call7481 (depth = 3)
    gc_frame_newslot(call7481);
    if7423 = call7481;
  }
// compiled if node returning if7423 (depth = 2)
// Begin line 2361
  setline(2361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool7482 = alloc_Boolean(1);
// compiled identifier node returning bool7482 (depth = 3)
  return bool7482;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_parseExclude_40_1_41_7483(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parseExclude(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseExclude(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parseExclude(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parseExclude(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_excludedMeth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "excludedMeth");
// Begin line 2364
  setline(2364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe7484 = gc_frame_new();
// call case 4: self request
  Object call7485 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7484);
// compiled member node returning call7485 (depth = 2)
// Begin line 2365
  setline(2365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe7486 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe7487 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool7488 = alloc_Boolean(1);
// compiled identifier node returning bool7488 (depth = 5)
  gc_frame_newslot(bool7488);
// call case 4: self request
  params[0] = bool7488;
  partcv[0] = 1;
  Object call7489 = callmethodflags(self, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7487);
// compiled call node returning call7489 (depth = 4)
  Object call7490 = callmethodflags(call7489, "appliedOccurence", 0, partcv, params, 0);
  gc_frame_end(callframe7486);
// compiled member node returning call7490 (depth = 3)
  *var_excludedMeth = call7490;
  if (call7490 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2366
  setline(2366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7491 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe7492 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_excludedMeth (depth = 4)
  Object call7493 = callmethodflags(*var_excludedMeth, "asIdentifier", 0, partcv, params, 0);
  gc_frame_end(callframe7492);
// compiled member node returning call7493 (depth = 3)
  gc_frame_newslot(call7493);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_node (depth = 3)
  params[0] = call7493;
  partcv[0] = 1;
  Object call7494 = callmethodflags(*var_node, "addExclusion(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7491);
// compiled call node returning call7494 (depth = 2)
// Begin line 2367
  setline(2367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool7495 = alloc_Boolean(1);
// compiled identifier node returning bool7495 (depth = 3)
  return bool7495;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_doobject7496(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 57, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doobject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2374
  setline(2374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7498 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7499 == NULL) {
    strlit7499 = alloc_String("object");
    gc_root(strlit7499);
  }
// compiled string node returning strlit7499 (depth = 4)
  gc_frame_newslot(strlit7499);
// call case 4: self request
  params[0] = strlit7499;
  partcv[0] = 1;
  Object call7500 = callmethodflags(self, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7498);
// compiled call node returning call7500 (depth = 3)
  Object if7497 = done;
  if (istrue(call7500)) {
// Begin line 2375
  setline(2375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7501 = gc_frame_new();
// call case 4: self request
  Object call7502 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7501);
// compiled member node returning call7502 (depth = 3)
// Begin line 2376
  setline(2376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7503 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7504 == NULL) {
    strlit7504 = alloc_String("an object constructor");
    gc_root(strlit7504);
  }
// compiled string node returning strlit7504 (depth = 4)
  gc_frame_newslot(strlit7504);
// Begin line 2377
  setline(2377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 4)
  if (strlit7505 == NULL) {
    strlit7505 = alloc_String("'object'");
    gc_root(strlit7505);
  }
// compiled string node returning strlit7505 (depth = 4)
  gc_frame_newslot(strlit7505);
// call case 4: self request
  params[0] = strlit7504;
  params[1] = *var_lastToken;
  params[2] = strlit7505;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7506 = callmethodflags(self, "parseObjectConstructorBody(1)startingWith(1)after(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7503);
// compiled call node returning call7506 (depth = 3)
    gc_frame_newslot(call7506);
    if7497 = call7506;
  } else {
  }
// compiled if node returning if7497 (depth = 2)
  gc_frame_end(frame);
  return if7497;
}
Object meth_parser__apply_40_1_41_7523(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7525 == NULL) {
    strlit7525 = alloc_String("rbrace");
    gc_root(strlit7525);
  }
// compiled string node returning strlit7525 (depth = 7)
  int op_slot_right_7524 = gc_frame_newslot(strlit7525);
// starting to compile member node (depth = 7)
  int callframe7527 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  Object call7528 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7527);
// compiled member node returning call7528 (depth = 7)
  int op_slot_left_7524 = gc_frame_newslot(call7528);
  params[0] = strlit7525;
  partcv[0] = 1;
  Object opresult7529 = callmethod(call7528, "==(1)", 1, partcv, params);
// compiled op node returning opresult7529 (depth = 6)
  gc_frame_end(frame);
  return opresult7529;
}
Object meth_parser__apply7602(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7604 == NULL) {
    strlit7604 = alloc_String("eof");
    gc_root(strlit7604);
  }
// compiled string node returning strlit7604 (depth = 7)
  int op_slot_right_7603 = gc_frame_newslot(strlit7604);
// starting to compile member node (depth = 7)
  int callframe7606 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call7607 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7606);
// compiled member node returning call7607 (depth = 7)
  int op_slot_left_7603 = gc_frame_newslot(call7607);
  params[0] = strlit7604;
  partcv[0] = 1;
  Object opresult7608 = callmethod(call7607, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7608 (depth = 6)
  gc_frame_end(frame);
  return opresult7608;
}
Object meth_parser__apply7599(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block7601 = alloc_Block(NULL, NULL, "parser", 2410);
  gc_frame_newslot(block7601);
// method "_apply"
  block_savedest(block7601);
  Object closure7602 = createclosure(2, "_apply");
  setclosureframe(closure7602, stackframe);
  addtoclosure(closure7602, var_sym);
  addtoclosure(closure7602, selfslot);
  struct UserObject *uo7602 = (struct UserObject*)block7601;
  uo7602->data[0] = (Object)closure7602;
  Method *meth_meth_parser__apply7602 = addmethod2pos(block7601, "_apply", &meth_parser__apply7602, 0);
  int argcv_meth_parser__apply7602[] = {0};
  meth_meth_parser__apply7602->type = alloc_MethodType(1, argcv_meth_parser__apply7602);
  meth_meth_parser__apply7602->definitionModule = modulename;
  meth_meth_parser__apply7602->definitionLine = 3399;
// compiled block node returning block7601 (depth = 5)
  int op_slot_right_7600 = gc_frame_newslot(block7601);
// starting to compile member node (depth = 5)
  int callframe7611 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe7612 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7613 == NULL) {
    strlit7613 = alloc_String("rbrace");
    gc_root(strlit7613);
  }
// compiled string node returning strlit7613 (depth = 7)
  gc_frame_newslot(strlit7613);
// call case 4: self request
  params[0] = strlit7613;
  partcv[0] = 1;
  Object call7614 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7612);
// compiled call node returning call7614 (depth = 6)
  Object call7615 = callmethodflags(call7614, "not", 0, partcv, params, 0);
  gc_frame_end(callframe7611);
// compiled member node returning call7615 (depth = 5)
  int op_slot_left_7600 = gc_frame_newslot(call7615);
  params[0] = block7601;
  partcv[0] = 1;
  Object opresult7616 = callmethod(call7615, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7616 (depth = 4)
  gc_frame_end(frame);
  return opresult7616;
}
Object meth_parser__apply7623(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
  int callframe7624 = gc_frame_new();
// call case 4: self request
  Object call7625 = callmethodflags(self, "inheritsOrUses", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7624);
// compiled member node returning call7625 (depth = 7)
  gc_frame_end(frame);
  return call7625;
}
Object meth_parser__apply7703(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 8)
  int callframe7704 = gc_frame_new();
// call case 4: self request
  Object call7705 = callmethodflags(self, "methoddec", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7704);
// compiled member node returning call7705 (depth = 8)
  gc_frame_end(frame);
  return call7705;
}
Object meth_parser__apply7717(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 9)
  int callframe7718 = gc_frame_new();
// call case 4: self request
  Object call7719 = callmethodflags(self, "statement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7718);
// compiled member node returning call7719 (depth = 9)
  gc_frame_end(frame);
  return call7719;
}
Object meth_parser__apply7619(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_inPreamble = getfromclosure(closure, 1);
  Object *var_usedTraits = getfromclosure(closure, 2);
  Object *var_superObject = getfromclosure(closure, 3);
  Object *var_constructName = getfromclosure(closure, 4);
  Object *var_errormessages = getfromclosure(closure, 5);
  Object *var_body = getfromclosure(closure, 6);
  Object *var_sym = getfromclosure(closure, 7);
  Object self = *(getfromclosure(closure, 8));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_parentNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "parentNode");
// Begin line 2411
  setline(2411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7621 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7622 = alloc_Block(NULL, NULL, "parser", 2411);
  gc_frame_newslot(block7622);
// method "_apply"
  block_savedest(block7622);
  Object closure7623 = createclosure(1, "_apply");
  setclosureframe(closure7623, stackframe);
  addtoclosure(closure7623, selfslot);
  struct UserObject *uo7623 = (struct UserObject*)block7622;
  uo7623->data[0] = (Object)closure7623;
  Method *meth_meth_parser__apply7623 = addmethod2pos(block7622, "_apply", &meth_parser__apply7623, 0);
  int argcv_meth_parser__apply7623[] = {0};
  meth_meth_parser__apply7623->type = alloc_MethodType(1, argcv_meth_parser__apply7623);
  meth_meth_parser__apply7623->definitionModule = modulename;
  meth_meth_parser__apply7623->definitionLine = 3399;
// compiled block node returning block7622 (depth = 6)
  gc_frame_newslot(block7622);
// call case 4: self request
  params[0] = block7622;
  partcv[0] = 1;
  Object call7627 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7621);
// compiled call node returning call7627 (depth = 5)
  Object if7620 = done;
  if (istrue(call7627)) {
// Begin line 2412
  setline(2412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7628 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call7629 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe7628);
// compiled member node returning call7629 (depth = 6)
  *var_parentNode = call7629;
  if (call7629 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2413
  setline(2413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inPreamble (depth = 6)
  Object if7630 = done;
  if (istrue(*var_inPreamble)) {
// Begin line 2414
  setline(2414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7632 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  Object call7633 = callmethodflags(*var_parentNode, "isUse", 0, partcv, params, 0);
  gc_frame_end(callframe7632);
// compiled member node returning call7633 (depth = 7)
  Object if7631 = done;
  if (istrue(call7633)) {
// Begin line 2415
  setline(2415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7634 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  gc_frame_newslot(*var_parentNode);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_usedTraits (depth = 8)
  params[0] = *var_parentNode;
  partcv[0] = 1;
  Object call7635 = callmethodflags(*var_usedTraits, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7634);
// compiled call node returning call7635 (depth = 7)
    gc_frame_newslot(call7635);
    if7631 = call7635;
  } else {
// Begin line 2418
  setline(2418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2416
  setline(2416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe7637 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_usedTraits (depth = 9)
  Object call7638 = callmethodflags(*var_usedTraits, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe7637);
// compiled member node returning call7638 (depth = 8)
  Object if7636 = done;
  if (istrue(call7638)) {
// Begin line 2417
  setline(2417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  *var_superObject = *var_parentNode;
  if (*var_parentNode == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if7636 = done;
  } else {
// Begin line 2419
  setline(2419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7640 = gc_frame_new();
// starting to compile op node (depth = 9)
// Begin line 2420
  setline(2420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit7643 == NULL) {
    strlit7643 = alloc_String("");
    gc_root(strlit7643);
  }
// compiled string node returning strlit7643 (depth = 11)
  int op_slot_right_7642 = gc_frame_newslot(strlit7643);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_constructName (depth = 12)
  int op_slot_right_7645 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 12)
  if (strlit7647 == NULL) {
    strlit7647 = alloc_String("before 'use' in ");
    gc_root(strlit7647);
  }
// compiled string node returning strlit7647 (depth = 12)
  int op_slot_left_7645 = gc_frame_newslot(strlit7647);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult7648 = callmethod(strlit7647, "++(1)", 1, partcv, params);
// compiled op node returning opresult7648 (depth = 11)
  int op_slot_left_7642 = gc_frame_newslot(opresult7648);
  params[0] = strlit7643;
  partcv[0] = 1;
  Object opresult7649 = callmethod(opresult7648, "++(1)", 1, partcv, params);
// compiled op node returning opresult7649 (depth = 10)
  int op_slot_right_7641 = gc_frame_newslot(opresult7649);
// Begin line 2419
  setline(2419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit7651 == NULL) {
    strlit7651 = alloc_String("'inherit' must come ");
    gc_root(strlit7651);
  }
// compiled string node returning strlit7651 (depth = 10)
  int op_slot_left_7641 = gc_frame_newslot(strlit7651);
  params[0] = opresult7649;
  partcv[0] = 1;
  Object opresult7652 = callmethod(strlit7651, "++(1)", 1, partcv, params);
// compiled op node returning opresult7652 (depth = 9)
  gc_frame_newslot(opresult7652);
// Begin line 2421
  setline(2421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe7653 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_parentNode (depth = 10)
  Object call7654 = callmethodflags(*var_parentNode, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7653);
// compiled member node returning call7654 (depth = 9)
  gc_frame_newslot(call7654);
// starting to compile member node (depth = 9)
  int callframe7655 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_parentNode (depth = 10)
  Object call7656 = callmethodflags(*var_parentNode, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7655);
// compiled member node returning call7656 (depth = 9)
  gc_frame_newslot(call7656);
// Begin line 2422
  setline(2422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num7658 = alloc_Float64(7);
// compiled num node returning num7658 (depth = 10)
  int op_slot_right_7657 = gc_frame_newslot(num7658);
// starting to compile member node (depth = 10)
  int callframe7660 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_parentNode (depth = 11)
  Object call7661 = callmethodflags(*var_parentNode, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7660);
// compiled member node returning call7661 (depth = 10)
  int op_slot_left_7657 = gc_frame_newslot(call7661);
  params[0] = num7658;
  partcv[0] = 1;
  Object sum7662 = callmethod(call7661, "+(1)", 1, partcv, params);
// compiled op node returning sum7662 (depth = 9)
  gc_frame_newslot(sum7662);
// call case 6: other requests
// Begin line 2419
  setline(2419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult7652;
  params[1] = call7654;
  params[2] = call7656;
  params[3] = sum7662;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call7663 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe7640);
// compiled call node returning call7663 (depth = 8)
    gc_frame_newslot(call7663);
    if7636 = call7663;
  }
// compiled if node returning if7636 (depth = 7)
    gc_frame_newslot(if7636);
    if7631 = if7636;
  }
// compiled if node returning if7631 (depth = 6)
    gc_frame_newslot(if7631);
    if7630 = if7631;
  } else {
// Begin line 2425
  setline(2425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7664 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 2426
  setline(2426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7667 == NULL) {
    strlit7667 = alloc_String("");
    gc_root(strlit7667);
  }
// compiled string node returning strlit7667 (depth = 9)
  int op_slot_right_7666 = gc_frame_newslot(strlit7667);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_constructName (depth = 10)
  int op_slot_right_7669 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 10)
  if (strlit7671 == NULL) {
    strlit7671 = alloc_String("come at the start of ");
    gc_root(strlit7671);
  }
// compiled string node returning strlit7671 (depth = 10)
  int op_slot_left_7669 = gc_frame_newslot(strlit7671);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult7672 = callmethod(strlit7671, "++(1)", 1, partcv, params);
// compiled op node returning opresult7672 (depth = 9)
  int op_slot_left_7666 = gc_frame_newslot(opresult7672);
  params[0] = strlit7667;
  partcv[0] = 1;
  Object opresult7673 = callmethod(opresult7672, "++(1)", 1, partcv, params);
// compiled op node returning opresult7673 (depth = 8)
  int op_slot_right_7665 = gc_frame_newslot(opresult7673);
// Begin line 2425
  setline(2425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7676 == NULL) {
    strlit7676 = alloc_String("' must ");
    gc_root(strlit7676);
  }
// compiled string node returning strlit7676 (depth = 9)
  int op_slot_right_7675 = gc_frame_newslot(strlit7676);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe7679 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_parentNode (depth = 11)
  Object call7680 = callmethodflags(*var_parentNode, "statementName", 0, partcv, params, 0);
  gc_frame_end(callframe7679);
// compiled member node returning call7680 (depth = 10)
  int op_slot_right_7678 = gc_frame_newslot(call7680);
// starting to compile string node (depth = 10)
  if (strlit7682 == NULL) {
    strlit7682 = alloc_String("'");
    gc_root(strlit7682);
  }
// compiled string node returning strlit7682 (depth = 10)
  int op_slot_left_7678 = gc_frame_newslot(strlit7682);
  params[0] = call7680;
  partcv[0] = 1;
  Object opresult7683 = callmethod(strlit7682, "++(1)", 1, partcv, params);
// compiled op node returning opresult7683 (depth = 9)
  int op_slot_left_7675 = gc_frame_newslot(opresult7683);
  params[0] = strlit7676;
  partcv[0] = 1;
  Object opresult7684 = callmethod(opresult7683, "++(1)", 1, partcv, params);
// compiled op node returning opresult7684 (depth = 8)
  int op_slot_left_7665 = gc_frame_newslot(opresult7684);
  params[0] = opresult7673;
  partcv[0] = 1;
  Object opresult7685 = callmethod(opresult7684, "++(1)", 1, partcv, params);
// compiled op node returning opresult7685 (depth = 7)
  gc_frame_newslot(opresult7685);
// Begin line 2427
  setline(2427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe7686 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  Object call7687 = callmethodflags(*var_parentNode, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7686);
// compiled member node returning call7687 (depth = 7)
  gc_frame_newslot(call7687);
// starting to compile member node (depth = 7)
  int callframe7688 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  Object call7689 = callmethodflags(*var_parentNode, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7688);
// compiled member node returning call7689 (depth = 7)
  gc_frame_newslot(call7689);
// Begin line 2428
  setline(2428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe7691 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe7692 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_parentNode (depth = 10)
  Object call7693 = callmethodflags(*var_parentNode, "statementName", 0, partcv, params, 0);
  gc_frame_end(callframe7692);
// compiled member node returning call7693 (depth = 9)
  Object call7694 = callmethodflags(call7693, "size", 0, partcv, params, 0);
  gc_frame_end(callframe7691);
// compiled member node returning call7694 (depth = 8)
  int op_slot_right_7690 = gc_frame_newslot(call7694);
// starting to compile member node (depth = 8)
  int callframe7696 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  Object call7697 = callmethodflags(*var_parentNode, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7696);
// compiled member node returning call7697 (depth = 8)
  int op_slot_left_7690 = gc_frame_newslot(call7697);
  params[0] = call7694;
  partcv[0] = 1;
  Object sum7698 = callmethod(call7697, "+(1)", 1, partcv, params);
// compiled op node returning sum7698 (depth = 7)
  gc_frame_newslot(sum7698);
// call case 6: other requests
// Begin line 2425
  setline(2425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult7685;
  params[1] = call7687;
  params[2] = call7689;
  params[3] = sum7698;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call7699 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe7664);
// compiled call node returning call7699 (depth = 6)
    gc_frame_newslot(call7699);
    if7630 = call7699;
  }
// compiled if node returning if7630 (depth = 5)
    gc_frame_newslot(if7630);
    if7620 = if7630;
  } else {
// Begin line 2433
  setline(2433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2430
  setline(2430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7701 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block7702 = alloc_Block(NULL, NULL, "parser", 2430);
  gc_frame_newslot(block7702);
// method "_apply"
  block_savedest(block7702);
  Object closure7703 = createclosure(1, "_apply");
  setclosureframe(closure7703, stackframe);
  addtoclosure(closure7703, selfslot);
  struct UserObject *uo7703 = (struct UserObject*)block7702;
  uo7703->data[0] = (Object)closure7703;
  Method *meth_meth_parser__apply7703 = addmethod2pos(block7702, "_apply", &meth_parser__apply7703, 0);
  int argcv_meth_parser__apply7703[] = {0};
  meth_meth_parser__apply7703->type = alloc_MethodType(1, argcv_meth_parser__apply7703);
  meth_meth_parser__apply7703->definitionModule = modulename;
  meth_meth_parser__apply7703->definitionLine = 3399;
// compiled block node returning block7702 (depth = 7)
  gc_frame_newslot(block7702);
// call case 4: self request
  params[0] = block7702;
  partcv[0] = 1;
  Object call7707 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7701);
// compiled call node returning call7707 (depth = 6)
  Object if7700 = done;
  if (istrue(call7707)) {
// Begin line 2431
  setline(2431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool7708 = alloc_Boolean(0);
// compiled identifier node returning bool7708 (depth = 7)
  *var_inPreamble = bool7708;
  if (bool7708 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 2432
  setline(2432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7710 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe7711 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call7712 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe7711);
// compiled member node returning call7712 (depth = 7)
  gc_frame_newslot(call7712);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_body (depth = 7)
  params[0] = call7712;
  partcv[0] = 1;
  Object call7713 = callmethodflags(*var_body, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7710);
// compiled call node returning call7713 (depth = 6)
    gc_frame_newslot(call7713);
    if7700 = call7713;
  } else {
// Begin line 2436
  setline(2436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2433
  setline(2433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7715 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block7716 = alloc_Block(NULL, NULL, "parser", 2433);
  gc_frame_newslot(block7716);
// method "_apply"
  block_savedest(block7716);
  Object closure7717 = createclosure(1, "_apply");
  setclosureframe(closure7717, stackframe);
  addtoclosure(closure7717, selfslot);
  struct UserObject *uo7717 = (struct UserObject*)block7716;
  uo7717->data[0] = (Object)closure7717;
  Method *meth_meth_parser__apply7717 = addmethod2pos(block7716, "_apply", &meth_parser__apply7717, 0);
  int argcv_meth_parser__apply7717[] = {0};
  meth_meth_parser__apply7717->type = alloc_MethodType(1, argcv_meth_parser__apply7717);
  meth_meth_parser__apply7717->definitionModule = modulename;
  meth_meth_parser__apply7717->definitionLine = 3399;
// compiled block node returning block7716 (depth = 8)
  gc_frame_newslot(block7716);
// call case 4: self request
  params[0] = block7716;
  partcv[0] = 1;
  Object call7721 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7715);
// compiled call node returning call7721 (depth = 7)
  Object if7714 = done;
  if (istrue(call7721)) {
// Begin line 2434
  setline(2434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool7722 = alloc_Boolean(0);
// compiled identifier node returning bool7722 (depth = 8)
  *var_inPreamble = bool7722;
  if (bool7722 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 2435
  setline(2435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7724 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe7725 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  Object call7726 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe7725);
// compiled member node returning call7726 (depth = 8)
  gc_frame_newslot(call7726);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call7726;
  partcv[0] = 1;
  Object call7727 = callmethodflags(*var_body, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7724);
// compiled call node returning call7727 (depth = 7)
    gc_frame_newslot(call7727);
    if7714 = call7727;
  } else {
// Begin line 2437
  setline(2437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7728 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 2438
  setline(2438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit7731 == NULL) {
    strlit7731 = alloc_String("");
    gc_root(strlit7731);
  }
// compiled string node returning strlit7731 (depth = 10)
  int op_slot_right_7730 = gc_frame_newslot(strlit7731);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_constructName (depth = 11)
  int op_slot_right_7733 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 11)
  if (strlit7735 == NULL) {
    strlit7735 = alloc_String("of of ");
    gc_root(strlit7735);
  }
// compiled string node returning strlit7735 (depth = 11)
  int op_slot_left_7733 = gc_frame_newslot(strlit7735);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult7736 = callmethod(strlit7735, "++(1)", 1, partcv, params);
// compiled op node returning opresult7736 (depth = 10)
  int op_slot_left_7730 = gc_frame_newslot(opresult7736);
  params[0] = strlit7731;
  partcv[0] = 1;
  Object opresult7737 = callmethod(opresult7736, "++(1)", 1, partcv, params);
// compiled op node returning opresult7737 (depth = 9)
  int op_slot_right_7729 = gc_frame_newslot(opresult7737);
// Begin line 2437
  setline(2437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit7740 == NULL) {
    strlit7740 = alloc_String("' in body ");
    gc_root(strlit7740);
  }
// compiled string node returning strlit7740 (depth = 10)
  int op_slot_right_7739 = gc_frame_newslot(strlit7740);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe7743 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  Object call7744 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7743);
// compiled member node returning call7744 (depth = 11)
  int op_slot_right_7742 = gc_frame_newslot(call7744);
// starting to compile string node (depth = 11)
  if (strlit7746 == NULL) {
    strlit7746 = alloc_String("unexpected symbol '");
    gc_root(strlit7746);
  }
// compiled string node returning strlit7746 (depth = 11)
  int op_slot_left_7742 = gc_frame_newslot(strlit7746);
  params[0] = call7744;
  partcv[0] = 1;
  Object opresult7747 = callmethod(strlit7746, "++(1)", 1, partcv, params);
// compiled op node returning opresult7747 (depth = 10)
  int op_slot_left_7739 = gc_frame_newslot(opresult7747);
  params[0] = strlit7740;
  partcv[0] = 1;
  Object opresult7748 = callmethod(opresult7747, "++(1)", 1, partcv, params);
// compiled op node returning opresult7748 (depth = 9)
  int op_slot_left_7729 = gc_frame_newslot(opresult7748);
  params[0] = opresult7737;
  partcv[0] = 1;
  Object opresult7749 = callmethod(opresult7748, "++(1)", 1, partcv, params);
// compiled op node returning opresult7749 (depth = 8)
  gc_frame_newslot(opresult7749);
// Begin line 2439
  setline(2439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe7750 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call7751 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7750);
// compiled member node returning call7751 (depth = 8)
  gc_frame_newslot(call7751);
// starting to compile member node (depth = 8)
  int callframe7752 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call7753 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7752);
// compiled member node returning call7753 (depth = 8)
  gc_frame_newslot(call7753);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num7755 = alloc_Float64(1);
// compiled num node returning num7755 (depth = 9)
  int op_slot_right_7754 = gc_frame_newslot(num7755);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe7758 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe7759 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  Object call7760 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7759);
// compiled member node returning call7760 (depth = 11)
  Object call7761 = callmethodflags(call7760, "size", 0, partcv, params, 0);
  gc_frame_end(callframe7758);
// compiled member node returning call7761 (depth = 10)
  int op_slot_right_7757 = gc_frame_newslot(call7761);
// starting to compile member node (depth = 10)
  int callframe7763 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call7764 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7763);
// compiled member node returning call7764 (depth = 10)
  int op_slot_left_7757 = gc_frame_newslot(call7764);
  params[0] = call7761;
  partcv[0] = 1;
  Object sum7765 = callmethod(call7764, "+(1)", 1, partcv, params);
// compiled op node returning sum7765 (depth = 9)
  int op_slot_left_7754 = gc_frame_newslot(sum7765);
  params[0] = num7755;
  partcv[0] = 1;
  Object diff7766 = callmethod(sum7765, "-(1)", 1, partcv, params);
// compiled op node returning diff7766 (depth = 8)
  gc_frame_newslot(diff7766);
// call case 6: other requests
// Begin line 2437
  setline(2437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult7749;
  params[1] = call7751;
  params[2] = call7753;
  params[3] = diff7766;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call7767 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe7728);
// compiled call node returning call7767 (depth = 7)
    gc_frame_newslot(call7767);
    if7714 = call7767;
  }
// compiled if node returning if7714 (depth = 6)
    gc_frame_newslot(if7714);
    if7700 = if7714;
  }
// compiled if node returning if7700 (depth = 5)
    gc_frame_newslot(if7700);
    if7620 = if7700;
  }
// compiled if node returning if7620 (depth = 4)
  gc_frame_end(frame);
  return if7620;
}
Object meth_parser_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_7507(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 58, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(13, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parseObjectConstructorBody(1)startingWith(1)after(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseObjectConstructorBody(_)startingWith(_)after(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseObjectConstructorBody(_)startingWith(_)after(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseObjectConstructorBody(_)startingWith(_)after(_)");
  Object params[4];
  int partcv[3];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_statementToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for parseObjectConstructorBody(_)startingWith(_)after(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_constructName = &(stackframe->slots[0]);
  *var_constructName = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parseObjectConstructorBody(_)");
  Object *var_btok = &(stackframe->slots[1]);
  *var_btok = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part startingWith(_)");
  Object *var_prev = &(stackframe->slots[2]);
  *var_prev = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part after(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_localMinIndentLevel = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "localMinIndentLevel");
  Object *var_anns = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "anns");
  Object *var_suggestion = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestion");
  Object *var_nextTok = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "nextTok");
  Object *var_body = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "body");
  Object *var_superObject = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "superObject");
  Object *var_usedTraits = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "usedTraits");
  Object *var_inPreamble = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "inPreamble");
  Object *var_objNode = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "objNode");
// Begin line 2386
  setline(2386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2387
  setline(2387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe7508 = gc_frame_new();
// call case 4: self request
  Object call7509 = callmethodflags(self, "doannotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7508);
// compiled member node returning call7509 (depth = 3)
  *var_anns = call7509;
  if (call7509 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2388
  setline(2388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7512 == NULL) {
    strlit7512 = alloc_String("lbrace");
    gc_root(strlit7512);
  }
// compiled string node returning strlit7512 (depth = 4)
  int op_slot_right_7511 = gc_frame_newslot(strlit7512);
// starting to compile member node (depth = 4)
  int callframe7514 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call7515 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7514);
// compiled member node returning call7515 (depth = 4)
  int op_slot_left_7511 = gc_frame_newslot(call7515);
  params[0] = strlit7512;
  partcv[0] = 1;
  Object opresult7516 = callmethod(call7515, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7516 (depth = 3)
  Object if7510 = done;
  if (istrue(opresult7516)) {
// Begin line 2389
  setline(2389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7517 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7518 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call7519 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7518);
// compiled member node returning call7519 (depth = 5)
  Object call7520 = callmethodflags(call7519, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7517);
// compiled member node returning call7520 (depth = 4)
  *var_suggestion = call7520;
  if (call7520 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2390
  setline(2390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7521 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block7522 = alloc_Block(NULL, NULL, "parser", 2390);
  gc_frame_newslot(block7522);
// method "_apply(_)"
  block_savedest(block7522);
  Object closure7523 = createclosure(1, "_apply(1)");
  setclosureframe(closure7523, stackframe);
  addtoclosure(closure7523, selfslot);
  struct UserObject *uo7523 = (struct UserObject*)block7522;
  uo7523->data[0] = (Object)closure7523;
  Method *meth_meth_parser__apply_40_1_41_7523 = addmethod2pos(block7522, "_apply(1)", &meth_parser__apply_40_1_41_7523, 0);
  int argcv_meth_parser__apply_40_1_41_7523[] = {1};
  meth_meth_parser__apply_40_1_41_7523->type = alloc_MethodType(1, argcv_meth_parser__apply_40_1_41_7523);
  meth_meth_parser__apply_40_1_41_7523->definitionModule = modulename;
  meth_meth_parser__apply_40_1_41_7523->definitionLine = 3399;
// compiled block node returning block7522 (depth = 5)
  gc_frame_newslot(block7522);
// call case 4: self request
  params[0] = block7522;
  partcv[0] = 1;
  Object call7531 = callmethodflags(self, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7521);
// compiled call node returning call7531 (depth = 4)
  *var_nextTok = call7531;
  if (call7531 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2391
  setline(2391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_right_7533 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 5)
  Object bool7535 = alloc_Boolean(0);
// compiled identifier node returning bool7535 (depth = 5)
  int op_slot_left_7533 = gc_frame_newslot(bool7535);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult7536 = callmethod(bool7535, "==(1)", 1, partcv, params);
// compiled op node returning opresult7536 (depth = 4)
  Object if7532 = done;
  if (istrue(opresult7536)) {
// Begin line 2392
  setline(2392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7537 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7538 == NULL) {
    strlit7538 = alloc_String(" {}");
    gc_root(strlit7538);
  }
// compiled string node returning strlit7538 (depth = 5)
  gc_frame_newslot(strlit7538);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit7538;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7539 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7537);
// compiled call node returning call7539 (depth = 4)
    gc_frame_newslot(call7539);
    if7532 = call7539;
  } else {
// Begin line 2394
  setline(2394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7540 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7541 == NULL) {
    strlit7541 = alloc_String(" {");
    gc_root(strlit7541);
  }
// compiled string node returning strlit7541 (depth = 5)
  gc_frame_newslot(strlit7541);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit7541;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7542 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7540);
// compiled call node returning call7542 (depth = 4)
    gc_frame_newslot(call7542);
    if7532 = call7542;
  }
// compiled if node returning if7532 (depth = 3)
// Begin line 2396
  setline(2396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7543 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7545 == NULL) {
    strlit7545 = alloc_String(".");
    gc_root(strlit7545);
  }
// compiled string node returning strlit7545 (depth = 5)
  int op_slot_right_7544 = gc_frame_newslot(strlit7545);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_prev (depth = 6)
  int op_slot_right_7547 = gc_frame_newslot(*var_prev);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7550 == NULL) {
    strlit7550 = alloc_String(" must have a '{' after the ");
    gc_root(strlit7550);
  }
// compiled string node returning strlit7550 (depth = 7)
  int op_slot_right_7549 = gc_frame_newslot(strlit7550);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_constructName (depth = 8)
  int op_slot_right_7552 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 8)
  if (strlit7554 == NULL) {
    strlit7554 = alloc_String("");
    gc_root(strlit7554);
  }
// compiled string node returning strlit7554 (depth = 8)
  int op_slot_left_7552 = gc_frame_newslot(strlit7554);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult7555 = callmethod(strlit7554, "++(1)", 1, partcv, params);
// compiled op node returning opresult7555 (depth = 7)
  int op_slot_left_7549 = gc_frame_newslot(opresult7555);
  params[0] = strlit7550;
  partcv[0] = 1;
  Object opresult7556 = callmethod(opresult7555, "++(1)", 1, partcv, params);
// compiled op node returning opresult7556 (depth = 6)
  int op_slot_left_7547 = gc_frame_newslot(opresult7556);
  params[0] = *var_prev;
  partcv[0] = 1;
  Object opresult7557 = callmethod(opresult7556, "++(1)", 1, partcv, params);
// compiled op node returning opresult7557 (depth = 5)
  int op_slot_left_7544 = gc_frame_newslot(opresult7557);
  params[0] = strlit7545;
  partcv[0] = 1;
  Object opresult7558 = callmethod(opresult7557, "++(1)", 1, partcv, params);
// compiled op node returning opresult7558 (depth = 4)
  gc_frame_newslot(opresult7558);
// Begin line 2397
  setline(2397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7559 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call7560 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7559);
// compiled member node returning call7560 (depth = 4)
  gc_frame_newslot(call7560);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7562 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call7563 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe7562);
// compiled member node returning call7563 (depth = 5)
  int op_slot_right_7561 = gc_frame_newslot(call7563);
// starting to compile member node (depth = 5)
  int callframe7565 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call7566 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7565);
// compiled member node returning call7566 (depth = 5)
  int op_slot_left_7561 = gc_frame_newslot(call7566);
  params[0] = call7563;
  partcv[0] = 1;
  Object sum7567 = callmethod(call7566, "+(1)", 1, partcv, params);
// compiled op node returning sum7567 (depth = 4)
  gc_frame_newslot(sum7567);
// Begin line 2398
  setline(2398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2396
  setline(2396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult7558;
  params[1] = call7560;
  params[2] = sum7567;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7568 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7543);
// compiled call node returning call7568 (depth = 3)
    gc_frame_newslot(call7568);
    if7510 = call7568;
  } else {
  }
// compiled if node returning if7510 (depth = 2)
// Begin line 2400
  setline(2400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe7569 = gc_frame_new();
// call case 4: self request
  Object call7570 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7569);
// compiled member node returning call7570 (depth = 2)
// Begin line 2401
  setline(2401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7573 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_statementToken (depth = 5)
  Object call7574 = callmethodflags(*var_statementToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7573);
// compiled member node returning call7574 (depth = 4)
  int op_slot_right_7572 = gc_frame_newslot(call7574);
// starting to compile member node (depth = 4)
  int callframe7576 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call7577 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7576);
// compiled member node returning call7577 (depth = 4)
  int op_slot_left_7572 = gc_frame_newslot(call7577);
  params[0] = call7574;
  partcv[0] = 1;
  Object opresult7578 = callmethod(call7577, "==(1)", 1, partcv, params);
// compiled op node returning opresult7578 (depth = 3)
  Object if7571 = done;
  if (istrue(opresult7578)) {
// Begin line 2402
  setline(2402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num7580 = alloc_Float64(2);
// compiled num node returning num7580 (depth = 5)
  int op_slot_right_7579 = gc_frame_newslot(num7580);
// starting to compile member node (depth = 5)
  int callframe7582 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call7583 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7582);
// compiled member node returning call7583 (depth = 5)
  int op_slot_left_7579 = gc_frame_newslot(call7583);
  params[0] = num7580;
  partcv[0] = 1;
  Object diff7584 = callmethod(call7583, "-(1)", 1, partcv, params);
// compiled op node returning diff7584 (depth = 4)
  *var_minIndentLevel = diff7584;
  if (diff7584 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if7571 = done;
  } else {
// Begin line 2404
  setline(2404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num7587 = alloc_Float64(2);
// compiled num node returning num7587 (depth = 5)
  int op_slot_right_7586 = gc_frame_newslot(num7587);
// starting to compile member node (depth = 5)
  int callframe7589 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_statementToken (depth = 6)
  Object call7590 = callmethodflags(*var_statementToken, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe7589);
// compiled member node returning call7590 (depth = 5)
  int op_slot_left_7586 = gc_frame_newslot(call7590);
  params[0] = num7587;
  partcv[0] = 1;
  Object sum7591 = callmethod(call7590, "+(1)", 1, partcv, params);
// compiled op node returning sum7591 (depth = 4)
  *var_minIndentLevel = sum7591;
  if (sum7591 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if7571 = done;
  }
// compiled if node returning if7571 (depth = 2)
// Begin line 2406
  setline(2406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array7593 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7593 (depth = 3)
  *var_body = array7593;
  if (array7593 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2407
  setline(2407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool7594 = alloc_Boolean(0);
// compiled identifier node returning bool7594 (depth = 3)
  *var_superObject = bool7594;
  if (bool7594 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2408
  setline(2408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array7595 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7595 (depth = 3)
  *var_usedTraits = array7595;
  if (array7595 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2409
  setline(2409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool7596 = alloc_Boolean(1);
// compiled identifier node returning bool7596 (depth = 3)
  *var_inPreamble = bool7596;
  if (bool7596 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2410
  setline(2410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7597 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block7598 = alloc_Block(NULL, NULL, "parser", 2410);
  gc_frame_newslot(block7598);
// method "_apply"
  block_savedest(block7598);
  Object closure7599 = createclosure(2, "_apply");
  setclosureframe(closure7599, stackframe);
  addtoclosure(closure7599, var_sym);
  addtoclosure(closure7599, selfslot);
  struct UserObject *uo7599 = (struct UserObject*)block7598;
  uo7599->data[0] = (Object)closure7599;
  Method *meth_meth_parser__apply7599 = addmethod2pos(block7598, "_apply", &meth_parser__apply7599, 0);
  int argcv_meth_parser__apply7599[] = {0};
  meth_meth_parser__apply7599->type = alloc_MethodType(1, argcv_meth_parser__apply7599);
  meth_meth_parser__apply7599->definitionModule = modulename;
  meth_meth_parser__apply7599->definitionLine = 3399;
// compiled block node returning block7598 (depth = 3)
  gc_frame_newslot(block7598);
// starting to compile block node (depth = 3)
  Object block7618 = alloc_Block(NULL, NULL, "parser", 2410);
  gc_frame_newslot(block7618);
// method "_apply"
  block_savedest(block7618);
  Object closure7619 = createclosure(9, "_apply");
  setclosureframe(closure7619, stackframe);
  addtoclosure(closure7619, var_values);
  addtoclosure(closure7619, var_inPreamble);
  addtoclosure(closure7619, var_usedTraits);
  addtoclosure(closure7619, var_superObject);
  addtoclosure(closure7619, var_constructName);
  addtoclosure(closure7619, var_errormessages);
  addtoclosure(closure7619, var_body);
  addtoclosure(closure7619, var_sym);
  addtoclosure(closure7619, selfslot);
  struct UserObject *uo7619 = (struct UserObject*)block7618;
  uo7619->data[0] = (Object)closure7619;
  Method *meth_meth_parser__apply7619 = addmethod2pos(block7618, "_apply", &meth_parser__apply7619, 0);
  int argcv_meth_parser__apply7619[] = {0};
  meth_meth_parser__apply7619->type = alloc_MethodType(1, argcv_meth_parser__apply7619);
  meth_meth_parser__apply7619->definitionModule = modulename;
  meth_meth_parser__apply7619->definitionLine = 3399;
// compiled block node returning block7618 (depth = 3)
  gc_frame_newslot(block7618);
// call case 5: prelude request
  params[0] = block7598;
  params[1] = block7618;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7769 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7597);
// compiled call node returning call7769 (depth = 2)
// Begin line 2442
  setline(2442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe7770 = gc_frame_new();
// call case 4: self request
  Object call7771 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7770);
// compiled member node returning call7771 (depth = 2)
// Begin line 2443
  setline(2443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7772 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe7773 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_btok (depth = 4)
  Object call7774 = callmethodflags(*var_btok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7773);
// compiled member node returning call7774 (depth = 3)
  gc_frame_newslot(call7774);
// starting to compile member node (depth = 3)
  int callframe7775 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_btok (depth = 4)
  Object call7776 = callmethodflags(*var_btok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7775);
// compiled member node returning call7776 (depth = 3)
  gc_frame_newslot(call7776);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call7774;
  params[1] = call7776;
  partcv[0] = 2;
  Object call7777 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7772);
// compiled call node returning call7777 (depth = 2)
// Begin line 2444
  setline(2444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7778 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_body (depth = 4)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_superObject (depth = 4)
  gc_frame_newslot(*var_superObject);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7779 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call7780 = callmethodflags(*var_ast, "objectNode", 0, partcv, params, 0);
  gc_frame_end(callframe7779);
// compiled member node returning call7780 (depth = 4)
  params[0] = *var_body;
  params[1] = *var_superObject;
  partcv[0] = 2;
  Object call7781 = callmethodflags(call7780, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7778);
// compiled call node returning call7781 (depth = 3)
  *var_objNode = call7781;
  if (call7781 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2445
  setline(2445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_anns (depth = 4)
  int op_slot_right_7783 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 4)
  Object bool7785 = alloc_Boolean(0);
// compiled identifier node returning bool7785 (depth = 4)
  int op_slot_left_7783 = gc_frame_newslot(bool7785);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult7786 = callmethod(bool7785, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7786 (depth = 3)
  Object if7782 = done;
  if (istrue(opresult7786)) {
// starting to compile call node (depth = 3)
  int callframe7787 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_anns (depth = 4)
  gc_frame_newslot(*var_anns);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7788 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objNode (depth = 5)
  Object call7789 = callmethodflags(*var_objNode, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe7788);
// compiled member node returning call7789 (depth = 4)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call7790 = callmethodflags(call7789, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7787);
// compiled call node returning call7790 (depth = 3)
    gc_frame_newslot(call7790);
    if7782 = call7790;
  } else {
  }
// compiled if node returning if7782 (depth = 2)
// Begin line 2446
  setline(2446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7791 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_usedTraits (depth = 3)
  gc_frame_newslot(*var_usedTraits);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_objNode (depth = 3)
  params[0] = *var_usedTraits;
  partcv[0] = 1;
  Object call7792 = callmethodflags(*var_objNode, "usedTraits:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7791);
// compiled call node returning call7792 (depth = 2)
// Begin line 2447
  setline(2447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7793 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_objNode (depth = 3)
  gc_frame_newslot(*var_objNode);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_objNode;
  partcv[0] = 1;
  Object call7794 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7793);
// compiled call node returning call7794 (depth = 2)
// Begin line 2448
  setline(2448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localMinIndentLevel (depth = 3)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_doclass7796(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 59, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(15, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doclass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_localMinIndentLevel = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "localMinIndentLevel");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_objName = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "objName");
  Object *var_meth = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "meth");
  Object *var_objNode = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "objNode");
  Object *var_asStringBody = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "asStringBody");
  Object *var_signature = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "signature");
  Object *var_asStringMeth = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "asStringMeth");
  Object *var_metaBody = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "metaBody");
  Object *var_metaObj = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "metaObj");
  Object *var_defDec = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "defDec");
// Begin line 2480
  setline(2480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2481
  setline(2481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe7797 = gc_frame_new();
// call case 4: self request
  Object call7798 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7797);
// compiled member node returning call7798 (depth = 2)
// Begin line 2482
  setline(2482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2483
  setline(2483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7801 == NULL) {
    strlit7801 = alloc_String("identifier");
    gc_root(strlit7801);
  }
// compiled string node returning strlit7801 (depth = 4)
  int op_slot_right_7800 = gc_frame_newslot(strlit7801);
// starting to compile member node (depth = 4)
  int callframe7803 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call7804 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7803);
// compiled member node returning call7804 (depth = 4)
  int op_slot_left_7800 = gc_frame_newslot(call7804);
  params[0] = strlit7801;
  partcv[0] = 1;
  Object opresult7805 = callmethod(call7804, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7805 (depth = 3)
  Object if7799 = done;
  if (istrue(opresult7805)) {
// Begin line 2484
  setline(2484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array7806 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7806 (depth = 4)
  *var_suggestions = array7806;
  if (array7806 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2485
  setline(2485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7809 == NULL) {
    strlit7809 = alloc_String("lbrace");
    gc_root(strlit7809);
  }
// compiled string node returning strlit7809 (depth = 5)
  int op_slot_right_7808 = gc_frame_newslot(strlit7809);
// starting to compile member node (depth = 5)
  int callframe7811 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call7812 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7811);
// compiled member node returning call7812 (depth = 5)
  int op_slot_left_7808 = gc_frame_newslot(call7812);
  params[0] = strlit7809;
  partcv[0] = 1;
  Object opresult7813 = callmethod(call7812, "==(1)", 1, partcv, params);
// compiled op node returning opresult7813 (depth = 4)
  Object if7807 = done;
  if (istrue(opresult7813)) {
// Begin line 2486
  setline(2486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7814 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7815 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call7816 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7815);
// compiled member node returning call7816 (depth = 6)
  Object call7817 = callmethodflags(call7816, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7814);
// compiled member node returning call7817 (depth = 5)
  *var_suggestion = call7817;
  if (call7817 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2487
  setline(2487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7818 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7819 == NULL) {
    strlit7819 = alloc_String(" ""\xc2""""\xab""class name""\xc2""""\xbb"".new");
    gc_root(strlit7819);
  }
// compiled string node returning strlit7819 (depth = 5)
  gc_frame_newslot(strlit7819);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit7819;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7820 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7818);
// compiled call node returning call7820 (depth = 4)
// Begin line 2488
  setline(2488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7821 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7822 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7821);
// compiled call node returning call7822 (depth = 4)
// Begin line 2489
  setline(2489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7823 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7824 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call7825 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7824);
// compiled member node returning call7825 (depth = 6)
  Object call7826 = callmethodflags(call7825, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7823);
// compiled member node returning call7826 (depth = 5)
  *var_suggestion = call7826;
  if (call7826 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2490
  setline(2490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7828 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 5)
  if (strlit7829 == NULL) {
    strlit7829 = alloc_String("object");
    gc_root(strlit7829);
  }
// compiled string node returning strlit7829 (depth = 5)
  gc_frame_newslot(strlit7829);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  params[1] = strlit7829;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7830 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7828);
// compiled call node returning call7830 (depth = 4)
// Begin line 2491
  setline(2491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7831 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7832 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7831);
// compiled call node returning call7832 (depth = 4)
    gc_frame_newslot(call7832);
    if7807 = call7832;
  } else {
// Begin line 2493
  setline(2493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7833 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7834 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call7835 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe7834);
// compiled member node returning call7835 (depth = 6)
  Object call7836 = callmethodflags(call7835, "new", 0, partcv, params, 0);
  gc_frame_end(callframe7833);
// compiled member node returning call7836 (depth = 5)
  *var_suggestion = call7836;
  if (call7836 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2494
  setline(2494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7837 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7838 == NULL) {
    strlit7838 = alloc_String(" ""\xc2""""\xab""class name""\xc2""""\xbb"".new {}");
    gc_root(strlit7838);
  }
// compiled string node returning strlit7838 (depth = 5)
  gc_frame_newslot(strlit7838);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit7838;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7839 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7837);
// compiled call node returning call7839 (depth = 4)
// Begin line 2495
  setline(2495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7840 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7841 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7840);
// compiled call node returning call7841 (depth = 4)
    gc_frame_newslot(call7841);
    if7807 = call7841;
  }
// compiled if node returning if7807 (depth = 3)
// Begin line 2497
  setline(2497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7842 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7843 == NULL) {
    strlit7843 = alloc_String("a class must have a name after the 'class'.");
    gc_root(strlit7843);
  }
// compiled string node returning strlit7843 (depth = 4)
  gc_frame_newslot(strlit7843);
// Begin line 2498
  setline(2498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe7844 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call7845 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe7844);
// compiled member node returning call7845 (depth = 4)
  gc_frame_newslot(call7845);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num7847 = alloc_Float64(1);
// compiled num node returning num7847 (depth = 5)
  int op_slot_right_7846 = gc_frame_newslot(num7847);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7850 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call7851 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe7850);
// compiled member node returning call7851 (depth = 6)
  int op_slot_right_7849 = gc_frame_newslot(call7851);
// starting to compile member node (depth = 6)
  int callframe7853 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call7854 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe7853);
// compiled member node returning call7854 (depth = 6)
  int op_slot_left_7849 = gc_frame_newslot(call7854);
  params[0] = call7851;
  partcv[0] = 1;
  Object sum7855 = callmethod(call7854, "+(1)", 1, partcv, params);
// compiled op node returning sum7855 (depth = 5)
  int op_slot_left_7846 = gc_frame_newslot(sum7855);
  params[0] = num7847;
  partcv[0] = 1;
  Object sum7856 = callmethod(sum7855, "+(1)", 1, partcv, params);
// compiled op node returning sum7856 (depth = 4)
  gc_frame_newslot(sum7856);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2497
  setline(2497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit7843;
  params[1] = call7845;
  params[2] = sum7856;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7857 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe7842);
// compiled call node returning call7857 (depth = 3)
    gc_frame_newslot(call7857);
    if7799 = call7857;
  } else {
  }
// compiled if node returning if7799 (depth = 2)
// Begin line 2500
  setline(2500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool7858 = alloc_Boolean(0);
// compiled identifier node returning bool7858 (depth = 3)
  *var_objName = bool7858;
  if (bool7858 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2501
  setline(2501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7861 == NULL) {
    strlit7861 = alloc_String("dot");
    gc_root(strlit7861);
  }
// compiled string node returning strlit7861 (depth = 4)
  int op_slot_right_7860 = gc_frame_newslot(strlit7861);
// starting to compile member node (depth = 4)
  int callframe7863 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7864 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  Object call7865 = callmethodflags(*var_tokens, "first", 0, partcv, params, 0);
  gc_frame_end(callframe7864);
// compiled member node returning call7865 (depth = 5)
  Object call7866 = callmethodflags(call7865, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7863);
// compiled member node returning call7866 (depth = 4)
  int op_slot_left_7860 = gc_frame_newslot(call7866);
  params[0] = strlit7861;
  partcv[0] = 1;
  Object opresult7867 = callmethod(call7866, "==(1)", 1, partcv, params);
// compiled op node returning opresult7867 (depth = 3)
  Object if7859 = done;
  if (istrue(opresult7867)) {
// Begin line 2502
  setline(2502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7868 = gc_frame_new();
// call case 4: self request
  Object call7869 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7868);
// compiled member node returning call7869 (depth = 3)
// Begin line 2503
  setline(2503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7870 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call7871 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe7870);
// compiled member node returning call7871 (depth = 4)
  *var_objName = call7871;
  if (call7871 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2504
  setline(2504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7873 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool7874 = alloc_Boolean(1);
// compiled identifier node returning bool7874 (depth = 4)
  gc_frame_newslot(bool7874);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objName (depth = 4)
  params[0] = bool7874;
  partcv[0] = 1;
  Object call7875 = callmethodflags(*var_objName, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7873);
// compiled call node returning call7875 (depth = 3)
// Begin line 2505
  setline(2505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7876 = gc_frame_new();
// call case 4: self request
  Object call7877 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7876);
// compiled member node returning call7877 (depth = 3)
    gc_frame_newslot(call7877);
    if7859 = call7877;
  } else {
  }
// compiled if node returning if7859 (depth = 2)
// Begin line 2507
  setline(2507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7878 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool7879 = alloc_Boolean(0);
// compiled identifier node returning bool7879 (depth = 4)
  gc_frame_newslot(bool7879);
// call case 4: self request
  params[0] = bool7879;
  partcv[0] = 1;
  Object call7880 = callmethodflags(self, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7878);
// compiled call node returning call7880 (depth = 3)
  *var_meth = call7880;
  if (call7880 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2508
  setline(2508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7881 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_btok (depth = 3)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  params[0] = *var_btok;
  partcv[0] = 1;
  Object call7882 = callmethodflags(*var_meth, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7881);
// compiled call node returning call7882 (depth = 2)
// Begin line 2509
  setline(2509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7883 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit7884 == NULL) {
    strlit7884 = alloc_String("a class");
    gc_root(strlit7884);
  }
// compiled string node returning strlit7884 (depth = 3)
  gc_frame_newslot(strlit7884);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_btok (depth = 3)
  gc_frame_newslot(*var_btok);
// starting to compile string node (depth = 3)
  if (strlit7885 == NULL) {
    strlit7885 = alloc_String("method header");
    gc_root(strlit7885);
  }
// compiled string node returning strlit7885 (depth = 3)
  gc_frame_newslot(strlit7885);
// call case 4: self request
  params[0] = strlit7884;
  params[1] = *var_btok;
  params[2] = strlit7885;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7886 = callmethodflags(self, "parseObjectConstructorBody(1)startingWith(1)after(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7883);
// compiled call node returning call7886 (depth = 2)
// Begin line 2510
  setline(2510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe7887 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  Object call7888 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe7887);
// compiled member node returning call7888 (depth = 3)
  *var_objNode = call7888;
  if (call7888 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2511
  setline(2511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7889 = gc_frame_new();
// starting to compile array node (depth = 3)
  Object array7890 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objNode (depth = 4)
  params[0] = *var_objNode;
  partcv[0] = 1;
  callmethodflags(array7890, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array7890 (depth = 3)
  gc_frame_newslot(array7890);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  params[0] = array7890;
  partcv[0] = 1;
  Object call7891 = callmethodflags(*var_meth, "body:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7889);
// compiled call node returning call7891 (depth = 2)
// Begin line 2512
  setline(2512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7892 = gc_frame_new();
// starting to compile identifier node (depth = 3)
  Object bool7893 = alloc_Boolean(1);
// compiled identifier node returning bool7893 (depth = 3)
  gc_frame_newslot(bool7893);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  params[0] = bool7893;
  partcv[0] = 1;
  Object call7894 = callmethodflags(*var_meth, "usesClassSyntax:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7892);
// compiled call node returning call7894 (depth = 2)
// Begin line 2513
  setline(2513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7895 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe7896 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objNode (depth = 4)
  Object call7897 = callmethodflags(*var_objNode, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe7896);
// compiled member node returning call7897 (depth = 3)
  gc_frame_newslot(call7897);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe7898 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  Object call7899 = callmethodflags(*var_meth, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe7898);
// compiled member node returning call7899 (depth = 3)
  params[0] = call7897;
  partcv[0] = 1;
  Object call7900 = callmethodflags(call7899, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7895);
// compiled call node returning call7900 (depth = 2)
// Begin line 2515
  setline(2515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objName (depth = 4)
  int op_slot_right_7902 = gc_frame_newslot(*var_objName);
// starting to compile identifier node (depth = 4)
  Object bool7904 = alloc_Boolean(0);
// compiled identifier node returning bool7904 (depth = 4)
  int op_slot_left_7902 = gc_frame_newslot(bool7904);
  params[0] = *var_objName;
  partcv[0] = 1;
  Object opresult7905 = callmethod(bool7904, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7905 (depth = 3)
  Object if7901 = done;
  if (istrue(opresult7905)) {
// Begin line 2516
  setline(2516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7906 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7908 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  Object call7909 = callmethodflags(*var_meth, "canonicalName", 0, partcv, params, 0);
  gc_frame_end(callframe7908);
// compiled member node returning call7909 (depth = 5)
  int op_slot_right_7907 = gc_frame_newslot(call7909);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7912 == NULL) {
    strlit7912 = alloc_String(".");
    gc_root(strlit7912);
  }
// compiled string node returning strlit7912 (depth = 6)
  int op_slot_right_7911 = gc_frame_newslot(strlit7912);
// starting to compile member node (depth = 6)
  int callframe7914 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_objName (depth = 7)
  Object call7915 = callmethodflags(*var_objName, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe7914);
// compiled member node returning call7915 (depth = 6)
  int op_slot_left_7911 = gc_frame_newslot(call7915);
  params[0] = strlit7912;
  partcv[0] = 1;
  Object opresult7916 = callmethod(call7915, "++(1)", 1, partcv, params);
// compiled op node returning opresult7916 (depth = 5)
  int op_slot_left_7907 = gc_frame_newslot(opresult7916);
  params[0] = call7909;
  partcv[0] = 1;
  Object opresult7917 = callmethod(opresult7916, "++(1)", 1, partcv, params);
// compiled op node returning opresult7917 (depth = 4)
  gc_frame_newslot(opresult7917);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objNode (depth = 4)
  params[0] = opresult7917;
  partcv[0] = 1;
  Object call7918 = callmethodflags(*var_objNode, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7906);
// compiled call node returning call7918 (depth = 3)
// Begin line 2517
  setline(2517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array7919 = alloc_BuiltinList();
  gc_pause();
// starting to compile call node (depth = 5)
  int callframe7920 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7922 == NULL) {
    strlit7922 = alloc_String("");
    gc_root(strlit7922);
  }
// compiled string node returning strlit7922 (depth = 7)
  int op_slot_right_7921 = gc_frame_newslot(strlit7922);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe7925 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_objName (depth = 9)
  Object call7926 = callmethodflags(*var_objName, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe7925);
// compiled member node returning call7926 (depth = 8)
  int op_slot_right_7924 = gc_frame_newslot(call7926);
// starting to compile string node (depth = 8)
  if (strlit7928 == NULL) {
    strlit7928 = alloc_String("class ");
    gc_root(strlit7928);
  }
// compiled string node returning strlit7928 (depth = 8)
  int op_slot_left_7924 = gc_frame_newslot(strlit7928);
  params[0] = call7926;
  partcv[0] = 1;
  Object opresult7929 = callmethod(strlit7928, "++(1)", 1, partcv, params);
// compiled op node returning opresult7929 (depth = 7)
  int op_slot_left_7921 = gc_frame_newslot(opresult7929);
  params[0] = strlit7922;
  partcv[0] = 1;
  Object opresult7930 = callmethod(opresult7929, "++(1)", 1, partcv, params);
// compiled op node returning opresult7930 (depth = 6)
  gc_frame_newslot(opresult7930);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7931 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call7932 = callmethodflags(*var_ast, "stringNode", 0, partcv, params, 0);
  gc_frame_end(callframe7931);
// compiled member node returning call7932 (depth = 6)
  params[0] = opresult7930;
  partcv[0] = 1;
  Object call7933 = callmethodflags(call7932, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7920);
// compiled call node returning call7933 (depth = 5)
  params[0] = call7933;
  partcv[0] = 1;
  callmethodflags(array7919, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array7919 (depth = 4)
  *var_asStringBody = array7919;
  if (array7919 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2518
  setline(2518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array7934 = alloc_BuiltinList();
  gc_pause();
// starting to compile call node (depth = 5)
  int callframe7935 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7936 == NULL) {
    strlit7936 = alloc_String("asString");
    gc_root(strlit7936);
  }
// compiled string node returning strlit7936 (depth = 6)
  gc_frame_newslot(strlit7936);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7937 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call7938 = callmethodflags(*var_ast, "signaturePart", 0, partcv, params, 0);
  gc_frame_end(callframe7937);
// compiled member node returning call7938 (depth = 6)
  params[0] = strlit7936;
  partcv[0] = 1;
  Object call7939 = callmethodflags(call7938, "partName(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7935);
// compiled call node returning call7939 (depth = 5)
  params[0] = call7939;
  partcv[0] = 1;
  callmethodflags(array7934, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array7934 (depth = 4)
  *var_signature = array7934;
  if (array7934 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2519
  setline(2519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7940 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_asStringBody (depth = 5)
  gc_frame_newslot(*var_asStringBody);
// starting to compile identifier node (depth = 5)
  Object bool7941 = alloc_Boolean(0);
// compiled identifier node returning bool7941 (depth = 5)
  gc_frame_newslot(bool7941);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7942 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call7943 = callmethodflags(*var_ast, "methodNode", 0, partcv, params, 0);
  gc_frame_end(callframe7942);
// compiled member node returning call7943 (depth = 5)
  params[0] = *var_signature;
  params[1] = *var_asStringBody;
  params[2] = bool7941;
  partcv[0] = 3;
  Object call7944 = callmethodflags(call7943, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe7940);
// compiled call node returning call7944 (depth = 4)
  *var_asStringMeth = call7944;
  if (call7944 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2520
  setline(2520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array7945 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  params[0] = *var_meth;
  partcv[0] = 1;
  callmethodflags(array7945, "push(1)", 1, partcv, params, CFLAG_SELF);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_asStringMeth (depth = 5)
  params[0] = *var_asStringMeth;
  partcv[0] = 1;
  callmethodflags(array7945, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array7945 (depth = 4)
  *var_metaBody = array7945;
  if (array7945 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2521
  setline(2521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7946 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_metaBody (depth = 5)
  gc_frame_newslot(*var_metaBody);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7948 == NULL) {
    strlit7948 = alloc_String("");
    gc_root(strlit7948);
  }
// compiled string node returning strlit7948 (depth = 6)
  int op_slot_right_7947 = gc_frame_newslot(strlit7948);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7951 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_objName (depth = 8)
  Object call7952 = callmethodflags(*var_objName, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe7951);
// compiled member node returning call7952 (depth = 7)
  int op_slot_right_7950 = gc_frame_newslot(call7952);
// starting to compile string node (depth = 7)
  if (strlit7954 == NULL) {
    strlit7954 = alloc_String("class ");
    gc_root(strlit7954);
  }
// compiled string node returning strlit7954 (depth = 7)
  int op_slot_left_7950 = gc_frame_newslot(strlit7954);
  params[0] = call7952;
  partcv[0] = 1;
  Object opresult7955 = callmethod(strlit7954, "++(1)", 1, partcv, params);
// compiled op node returning opresult7955 (depth = 6)
  int op_slot_left_7947 = gc_frame_newslot(opresult7955);
  params[0] = strlit7948;
  partcv[0] = 1;
  Object opresult7956 = callmethod(opresult7955, "++(1)", 1, partcv, params);
// compiled op node returning opresult7956 (depth = 5)
  gc_frame_newslot(opresult7956);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7957 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call7958 = callmethodflags(*var_ast, "objectNode", 0, partcv, params, 0);
  gc_frame_end(callframe7957);
// compiled member node returning call7958 (depth = 5)
  params[0] = *var_metaBody;
  params[1] = opresult7956;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7959 = callmethodflags(call7958, "body(1)named(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7946);
// compiled call node returning call7959 (depth = 4)
  *var_metaObj = call7959;
  if (call7959 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2522
  setline(2522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7960 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objName (depth = 5)
  gc_frame_newslot(*var_objName);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_metaObj (depth = 5)
  gc_frame_newslot(*var_metaObj);
// starting to compile member node (depth = 5)
  int callframe7961 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call7962 = callmethodflags(*var_ast, "unknownType", 0, partcv, params, 0);
  gc_frame_end(callframe7961);
// compiled member node returning call7962 (depth = 5)
  gc_frame_newslot(call7962);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7963 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call7964 = callmethodflags(*var_ast, "defDecNode", 0, partcv, params, 0);
  gc_frame_end(callframe7963);
// compiled member node returning call7964 (depth = 5)
  params[0] = *var_objName;
  params[1] = *var_metaObj;
  params[2] = call7962;
  partcv[0] = 3;
  Object call7965 = callmethodflags(call7964, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe7960);
// compiled call node returning call7965 (depth = 4)
  *var_defDec = call7965;
  if (call7965 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2523
  setline(2523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7966 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_btok (depth = 4)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defDec (depth = 4)
  params[0] = *var_btok;
  partcv[0] = 1;
  Object call7967 = callmethodflags(*var_defDec, "startToken:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7966);
// compiled call node returning call7967 (depth = 3)
// Begin line 2524
  setline(2524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7968 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7969 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7970 == NULL) {
    strlit7970 = alloc_String("public");
    gc_root(strlit7970);
  }
// compiled string node returning strlit7970 (depth = 5)
  gc_frame_newslot(strlit7970);
// starting to compile identifier node (depth = 5)
  Object bool7971 = alloc_Boolean(0);
// compiled identifier node returning bool7971 (depth = 5)
  gc_frame_newslot(bool7971);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7972 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call7973 = callmethodflags(*var_ast, "identifierNode", 0, partcv, params, 0);
  gc_frame_end(callframe7972);
// compiled member node returning call7973 (depth = 5)
  params[0] = strlit7970;
  params[1] = bool7971;
  partcv[0] = 2;
  Object call7974 = callmethodflags(call7973, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7969);
// compiled call node returning call7974 (depth = 4)
  gc_frame_newslot(call7974);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7975 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_defDec (depth = 5)
  Object call7976 = callmethodflags(*var_defDec, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe7975);
// compiled member node returning call7976 (depth = 4)
  params[0] = call7974;
  partcv[0] = 1;
  Object call7977 = callmethodflags(call7976, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7968);
// compiled call node returning call7977 (depth = 3)
// Begin line 2525
  setline(2525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7978 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defDec (depth = 4)
  gc_frame_newslot(*var_defDec);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_defDec;
  partcv[0] = 1;
  Object call7979 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7978);
// compiled call node returning call7979 (depth = 3)
    gc_frame_newslot(call7979);
    if7901 = call7979;
  } else {
// Begin line 2527
  setline(2527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7980 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7981 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  Object call7982 = callmethodflags(*var_meth, "canonicalName", 0, partcv, params, 0);
  gc_frame_end(callframe7981);
// compiled member node returning call7982 (depth = 4)
  gc_frame_newslot(call7982);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objNode (depth = 4)
  params[0] = call7982;
  partcv[0] = 1;
  Object call7983 = callmethodflags(*var_objNode, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7980);
// compiled call node returning call7983 (depth = 3)
// Begin line 2528
  setline(2528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7986 == NULL) {
    strlit7986 = alloc_String("class");
    gc_root(strlit7986);
  }
// compiled string node returning strlit7986 (depth = 5)
  int op_slot_right_7985 = gc_frame_newslot(strlit7986);
// starting to compile member node (depth = 5)
  int callframe7988 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  Object call7989 = callmethodflags(*var_btok, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7988);
// compiled member node returning call7989 (depth = 5)
  int op_slot_left_7985 = gc_frame_newslot(call7989);
  params[0] = strlit7986;
  partcv[0] = 1;
  Object opresult7990 = callmethod(call7989, "==(1)", 1, partcv, params);
// compiled op node returning opresult7990 (depth = 4)
  Object if7984 = done;
  if (istrue(opresult7990)) {
// Begin line 2529
  setline(2529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7991 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool7992 = alloc_Boolean(1);
// compiled identifier node returning bool7992 (depth = 5)
  gc_frame_newslot(bool7992);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objNode (depth = 5)
  params[0] = bool7992;
  partcv[0] = 1;
  Object call7993 = callmethodflags(*var_objNode, "inClass:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7991);
// compiled call node returning call7993 (depth = 4)
    gc_frame_newslot(call7993);
    if7984 = call7993;
  } else {
// Begin line 2533
  setline(2533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2530
  setline(2530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7996 == NULL) {
    strlit7996 = alloc_String("trait");
    gc_root(strlit7996);
  }
// compiled string node returning strlit7996 (depth = 6)
  int op_slot_right_7995 = gc_frame_newslot(strlit7996);
// starting to compile member node (depth = 6)
  int callframe7998 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  Object call7999 = callmethodflags(*var_btok, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7998);
// compiled member node returning call7999 (depth = 6)
  int op_slot_left_7995 = gc_frame_newslot(call7999);
  params[0] = strlit7996;
  partcv[0] = 1;
  Object opresult8000 = callmethod(call7999, "==(1)", 1, partcv, params);
// compiled op node returning opresult8000 (depth = 5)
  Object if7994 = done;
  if (istrue(opresult8000)) {
// Begin line 2531
  setline(2531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8001 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool8002 = alloc_Boolean(1);
// compiled identifier node returning bool8002 (depth = 6)
  gc_frame_newslot(bool8002);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_objNode (depth = 6)
  params[0] = bool8002;
  partcv[0] = 1;
  Object call8003 = callmethodflags(*var_objNode, "inTrait:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8001);
// compiled call node returning call8003 (depth = 5)
    gc_frame_newslot(call8003);
    if7994 = call8003;
  } else {
  }
// compiled if node returning if7994 (depth = 4)
    gc_frame_newslot(if7994);
    if7984 = if7994;
  }
// compiled if node returning if7984 (depth = 3)
// Begin line 2533
  setline(2533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8004 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  gc_frame_newslot(*var_meth);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call8005 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8004);
// compiled call node returning call8005 (depth = 3)
    gc_frame_newslot(call8005);
    if7901 = call8005;
  }
// compiled if node returning if7901 (depth = 2)
// Begin line 2535
  setline(2535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe8006 = gc_frame_new();
// call case 4: self request
  Object call8007 = callmethodflags(self, "reconcileComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8006);
// compiled member node returning call8007 (depth = 2)
// Begin line 2536
  setline(2536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localMinIndentLevel (depth = 3)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply8013(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2543
  setline(2543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8015 == NULL) {
    strlit8015 = alloc_String("method");
    gc_root(strlit8015);
  }
// compiled string node returning strlit8015 (depth = 6)
  int op_slot_right_8014 = gc_frame_newslot(strlit8015);
// starting to compile member node (depth = 6)
  int callframe8017 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8018 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  Object call8019 = callmethodflags(*var_tokens, "first", 0, partcv, params, 0);
  gc_frame_end(callframe8018);
// compiled member node returning call8019 (depth = 7)
  Object call8020 = callmethodflags(call8019, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8017);
// compiled member node returning call8020 (depth = 6)
  int op_slot_left_8014 = gc_frame_newslot(call8020);
  params[0] = strlit8015;
  partcv[0] = 1;
  Object opresult8021 = callmethod(call8020, "==(1)", 1, partcv, params);
// compiled op node returning opresult8021 (depth = 5)
  gc_frame_end(frame);
  return opresult8021;
}
Object meth_parser__apply8026(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2542
  setline(2542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8028 == NULL) {
    strlit8028 = alloc_String("keyword");
    gc_root(strlit8028);
  }
// compiled string node returning strlit8028 (depth = 7)
  int op_slot_right_8027 = gc_frame_newslot(strlit8028);
// starting to compile member node (depth = 7)
  int callframe8030 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe8031 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  Object call8032 = callmethodflags(*var_tokens, "first", 0, partcv, params, 0);
  gc_frame_end(callframe8031);
// compiled member node returning call8032 (depth = 8)
  Object call8033 = callmethodflags(call8032, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8030);
// compiled member node returning call8033 (depth = 7)
  int op_slot_left_8027 = gc_frame_newslot(call8033);
  params[0] = strlit8028;
  partcv[0] = 1;
  Object opresult8034 = callmethod(call8033, "==(1)", 1, partcv, params);
// compiled op node returning opresult8034 (depth = 6)
  gc_frame_end(frame);
  return opresult8034;
}
Object meth_parser_dofactoryMethod8009(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 60, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dofactoryMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_tokens = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_localMinIndentLevel = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "localMinIndentLevel");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_meth = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "meth");
  Object *var_objNode = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "objNode");
// Begin line 2541
  setline(2541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 2542
  setline(2542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block8012 = alloc_Block(NULL, NULL, "parser", 2542);
  gc_frame_newslot(block8012);
// method "_apply"
  block_savedest(block8012);
  Object closure8013 = createclosure(2, "_apply");
  setclosureframe(closure8013, stackframe);
  addtoclosure(closure8013, var_tokens);
  addtoclosure(closure8013, selfslot);
  struct UserObject *uo8013 = (struct UserObject*)block8012;
  uo8013->data[0] = (Object)closure8013;
  Method *meth_meth_parser__apply8013 = addmethod2pos(block8012, "_apply", &meth_parser__apply8013, 0);
  int argcv_meth_parser__apply8013[] = {0};
  meth_meth_parser__apply8013->type = alloc_MethodType(1, argcv_meth_parser__apply8013);
  meth_meth_parser__apply8013->definitionModule = modulename;
  meth_meth_parser__apply8013->definitionLine = 3399;
// compiled block node returning block8012 (depth = 4)
  int op_slot_right_8011 = gc_frame_newslot(block8012);
// Begin line 2541
  setline(2541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block8025 = alloc_Block(NULL, NULL, "parser", 2541);
  gc_frame_newslot(block8025);
// method "_apply"
  block_savedest(block8025);
  Object closure8026 = createclosure(2, "_apply");
  setclosureframe(closure8026, stackframe);
  addtoclosure(closure8026, var_tokens);
  addtoclosure(closure8026, selfslot);
  struct UserObject *uo8026 = (struct UserObject*)block8025;
  uo8026->data[0] = (Object)closure8026;
  Method *meth_meth_parser__apply8026 = addmethod2pos(block8025, "_apply", &meth_parser__apply8026, 0);
  int argcv_meth_parser__apply8026[] = {0};
  meth_meth_parser__apply8026->type = alloc_MethodType(1, argcv_meth_parser__apply8026);
  meth_meth_parser__apply8026->definitionModule = modulename;
  meth_meth_parser__apply8026->definitionLine = 3399;
// compiled block node returning block8025 (depth = 5)
  int op_slot_right_8024 = gc_frame_newslot(block8025);
// Begin line 2541
  setline(2541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8037 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8038 == NULL) {
    strlit8038 = alloc_String("factory");
    gc_root(strlit8038);
  }
// compiled string node returning strlit8038 (depth = 6)
  gc_frame_newslot(strlit8038);
// call case 4: self request
  params[0] = strlit8038;
  partcv[0] = 1;
  Object call8039 = callmethodflags(self, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8037);
// compiled call node returning call8039 (depth = 5)
  int op_slot_left_8024 = gc_frame_newslot(call8039);
  params[0] = block8025;
  partcv[0] = 1;
  Object opresult8040 = callmethod(call8039, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8040 (depth = 4)
  int op_slot_left_8011 = gc_frame_newslot(opresult8040);
  params[0] = block8012;
  partcv[0] = 1;
  Object opresult8041 = callmethod(opresult8040, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8041 (depth = 3)
  Object if8010 = done;
  if (istrue(opresult8041)) {
// Begin line 2544
  setline(2544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2545
  setline(2545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8042 = gc_frame_new();
// call case 4: self request
  Object call8043 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8042);
// compiled member node returning call8043 (depth = 3)
// Begin line 2546
  setline(2546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8044 = gc_frame_new();
// call case 4: self request
  Object call8045 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8044);
// compiled member node returning call8045 (depth = 3)
// Begin line 2547
  setline(2547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2548
  setline(2548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8048 == NULL) {
    strlit8048 = alloc_String("identifier");
    gc_root(strlit8048);
  }
// compiled string node returning strlit8048 (depth = 5)
  int op_slot_right_8047 = gc_frame_newslot(strlit8048);
// starting to compile member node (depth = 5)
  int callframe8050 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call8051 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8050);
// compiled member node returning call8051 (depth = 5)
  int op_slot_left_8047 = gc_frame_newslot(call8051);
  params[0] = strlit8048;
  partcv[0] = 1;
  Object opresult8052 = callmethod(call8051, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8052 (depth = 4)
  Object if8046 = done;
  if (istrue(opresult8052)) {
// Begin line 2549
  setline(2549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array8053 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8053 (depth = 5)
  *var_suggestions = array8053;
  if (array8053 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2550
  setline(2550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8056 == NULL) {
    strlit8056 = alloc_String("lbrace");
    gc_root(strlit8056);
  }
// compiled string node returning strlit8056 (depth = 6)
  int op_slot_right_8055 = gc_frame_newslot(strlit8056);
// starting to compile member node (depth = 6)
  int callframe8058 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8059 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8058);
// compiled member node returning call8059 (depth = 6)
  int op_slot_left_8055 = gc_frame_newslot(call8059);
  params[0] = strlit8056;
  partcv[0] = 1;
  Object opresult8060 = callmethod(call8059, "==(1)", 1, partcv, params);
// compiled op node returning opresult8060 (depth = 5)
  Object if8054 = done;
  if (istrue(opresult8060)) {
// Begin line 2551
  setline(2551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8061 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8062 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call8063 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8062);
// compiled member node returning call8063 (depth = 7)
  Object call8064 = callmethodflags(call8063, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8061);
// compiled member node returning call8064 (depth = 6)
  *var_suggestion = call8064;
  if (call8064 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2552
  setline(2552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8065 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8066 == NULL) {
    strlit8066 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit8066);
  }
// compiled string node returning strlit8066 (depth = 6)
  gc_frame_newslot(strlit8066);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8066;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8067 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8065);
// compiled call node returning call8067 (depth = 5)
// Begin line 2553
  setline(2553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8068 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8069 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8068);
// compiled call node returning call8069 (depth = 5)
// Begin line 2554
  setline(2554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8070 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8071 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call8072 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8071);
// compiled member node returning call8072 (depth = 7)
  Object call8073 = callmethodflags(call8072, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8070);
// compiled member node returning call8073 (depth = 6)
  *var_suggestion = call8073;
  if (call8073 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 2555
  setline(2555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8075 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 6)
  if (strlit8076 == NULL) {
    strlit8076 = alloc_String("object");
    gc_root(strlit8076);
  }
// compiled string node returning strlit8076 (depth = 6)
  gc_frame_newslot(strlit8076);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = strlit8076;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8077 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8075);
// compiled call node returning call8077 (depth = 5)
// Begin line 2556
  setline(2556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8078 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8079 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8078);
// compiled call node returning call8079 (depth = 5)
    gc_frame_newslot(call8079);
    if8054 = call8079;
  } else {
// Begin line 2558
  setline(2558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8080 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8081 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call8082 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8081);
// compiled member node returning call8082 (depth = 7)
  Object call8083 = callmethodflags(call8082, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8080);
// compiled member node returning call8083 (depth = 6)
  *var_suggestion = call8083;
  if (call8083 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2559
  setline(2559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8084 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8085 == NULL) {
    strlit8085 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb"" {}");
    gc_root(strlit8085);
  }
// compiled string node returning strlit8085 (depth = 6)
  gc_frame_newslot(strlit8085);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8085;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8086 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8084);
// compiled call node returning call8086 (depth = 5)
// Begin line 2560
  setline(2560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8087 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8088 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8087);
// compiled call node returning call8088 (depth = 5)
    gc_frame_newslot(call8088);
    if8054 = call8088;
  }
// compiled if node returning if8054 (depth = 4)
// Begin line 2562
  setline(2562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8089 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8090 == NULL) {
    strlit8090 = alloc_String("a factory method must have a name after the 'method'.");
    gc_root(strlit8090);
  }
// compiled string node returning strlit8090 (depth = 5)
  gc_frame_newslot(strlit8090);
// Begin line 2563
  setline(2563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8091 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call8092 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8091);
// compiled member node returning call8092 (depth = 5)
  gc_frame_newslot(call8092);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8094 = alloc_Float64(1);
// compiled num node returning num8094 (depth = 6)
  int op_slot_right_8093 = gc_frame_newslot(num8094);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8097 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call8098 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8097);
// compiled member node returning call8098 (depth = 7)
  int op_slot_right_8096 = gc_frame_newslot(call8098);
// starting to compile member node (depth = 7)
  int callframe8100 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call8101 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8100);
// compiled member node returning call8101 (depth = 7)
  int op_slot_left_8096 = gc_frame_newslot(call8101);
  params[0] = call8098;
  partcv[0] = 1;
  Object sum8102 = callmethod(call8101, "+(1)", 1, partcv, params);
// compiled op node returning sum8102 (depth = 6)
  int op_slot_left_8093 = gc_frame_newslot(sum8102);
  params[0] = num8094;
  partcv[0] = 1;
  Object sum8103 = callmethod(sum8102, "+(1)", 1, partcv, params);
// compiled op node returning sum8103 (depth = 5)
  gc_frame_newslot(sum8103);
// Begin line 2564
  setline(2564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2562
  setline(2562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8090;
  params[1] = call8092;
  params[2] = sum8103;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8104 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8089);
// compiled call node returning call8104 (depth = 4)
    gc_frame_newslot(call8104);
    if8046 = call8104;
  } else {
  }
// compiled if node returning if8046 (depth = 3)
// Begin line 2566
  setline(2566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8105 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool8106 = alloc_Boolean(0);
// compiled identifier node returning bool8106 (depth = 5)
  gc_frame_newslot(bool8106);
// call case 4: self request
  params[0] = bool8106;
  partcv[0] = 1;
  Object call8107 = callmethodflags(self, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8105);
// compiled call node returning call8107 (depth = 4)
  *var_meth = call8107;
  if (call8107 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2567
  setline(2567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8108 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8109 == NULL) {
    strlit8109 = alloc_String("a factory method");
    gc_root(strlit8109);
  }
// compiled string node returning strlit8109 (depth = 4)
  gc_frame_newslot(strlit8109);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_btok (depth = 4)
  gc_frame_newslot(*var_btok);
// starting to compile string node (depth = 4)
  if (strlit8110 == NULL) {
    strlit8110 = alloc_String("method header");
    gc_root(strlit8110);
  }
// compiled string node returning strlit8110 (depth = 4)
  gc_frame_newslot(strlit8110);
// call case 4: self request
  params[0] = strlit8109;
  params[1] = *var_btok;
  params[2] = strlit8110;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8111 = callmethodflags(self, "parseObjectConstructorBody(1)startingWith(1)after(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8108);
// compiled call node returning call8111 (depth = 3)
// Begin line 2568
  setline(2568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8112 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call8113 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe8112);
// compiled member node returning call8113 (depth = 4)
  *var_objNode = call8113;
  if (call8113 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2569
  setline(2569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8114 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8115 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  Object call8116 = callmethodflags(*var_meth, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe8115);
// compiled member node returning call8116 (depth = 4)
  gc_frame_newslot(call8116);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objNode (depth = 4)
  params[0] = call8116;
  partcv[0] = 1;
  Object call8117 = callmethodflags(*var_objNode, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8114);
// compiled call node returning call8117 (depth = 3)
// Begin line 2570
  setline(2570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8118 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8119 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  Object call8120 = callmethodflags(*var_btok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8119);
// compiled member node returning call8120 (depth = 4)
  gc_frame_newslot(call8120);
// starting to compile member node (depth = 4)
  int callframe8121 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  Object call8122 = callmethodflags(*var_btok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8121);
// compiled member node returning call8122 (depth = 4)
  gc_frame_newslot(call8122);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call8120;
  params[1] = call8122;
  partcv[0] = 2;
  Object call8123 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8118);
// compiled call node returning call8123 (depth = 3)
// Begin line 2571
  setline(2571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8124 = gc_frame_new();
// starting to compile array node (depth = 4)
  Object array8125 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objNode (depth = 5)
  params[0] = *var_objNode;
  partcv[0] = 1;
  callmethodflags(array8125, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array8125 (depth = 4)
  gc_frame_newslot(array8125);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  params[0] = array8125;
  partcv[0] = 1;
  Object call8126 = callmethodflags(*var_meth, "body:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8124);
// compiled call node returning call8126 (depth = 3)
// Begin line 2572
  setline(2572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8127 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8128 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objNode (depth = 5)
  Object call8129 = callmethodflags(*var_objNode, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe8128);
// compiled member node returning call8129 (depth = 4)
  gc_frame_newslot(call8129);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8130 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  Object call8131 = callmethodflags(*var_meth, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe8130);
// compiled member node returning call8131 (depth = 4)
  params[0] = call8129;
  partcv[0] = 1;
  Object call8132 = callmethodflags(call8131, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8127);
// compiled call node returning call8132 (depth = 3)
// Begin line 2576
  setline(2576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8133 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  gc_frame_newslot(*var_meth);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call8134 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8133);
// compiled call node returning call8134 (depth = 3)
// Begin line 2577
  setline(2577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8135 = gc_frame_new();
// call case 4: self request
  Object call8136 = callmethodflags(self, "reconcileComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8135);
// compiled member node returning call8136 (depth = 3)
// Begin line 2578
  setline(2578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localMinIndentLevel (depth = 4)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if8010 = done;
  } else {
  }
// compiled if node returning if8010 (depth = 2)
  gc_frame_end(frame);
  return if8010;
}
Object meth_parser__apply8199(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8201 == NULL) {
    strlit8201 = alloc_String("lbrace");
    gc_root(strlit8201);
  }
// compiled string node returning strlit8201 (depth = 7)
  int op_slot_right_8200 = gc_frame_newslot(strlit8201);
// starting to compile member node (depth = 7)
  int callframe8203 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  Object call8204 = callmethodflags(*var_s, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8203);
// compiled member node returning call8204 (depth = 7)
  int op_slot_left_8200 = gc_frame_newslot(call8204);
  params[0] = strlit8201;
  partcv[0] = 1;
  Object opresult8205 = callmethod(call8204, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8205 (depth = 6)
  gc_frame_end(frame);
  return opresult8205;
}
Object meth_parser__apply8208(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2613
  setline(2613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8209 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_body (depth = 7)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call8210 = callmethodflags(*var_body, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8209);
// compiled call node returning call8210 (depth = 6)
// Begin line 2614
  setline(2614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe8211 = gc_frame_new();
// call case 4: self request
  Object call8212 = callmethodflags(self, "statement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8211);
// compiled member node returning call8212 (depth = 6)
// Begin line 2615
  setline(2615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8213 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call8214 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe8213);
// compiled member node returning call8214 (depth = 7)
  *var_s = call8214;
  if (call8214 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_methoddec8138(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 61, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(12, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methoddec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_stok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "stok");
  Object *var_methNode = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "methNode");
  Object *var_body = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "body");
  Object *var_localMin = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "localMin");
  Object *var_anns = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "anns");
  Object *var_s = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "s");
  Object *var_suggestion = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "closingBrace");
// Begin line 2585
  setline(2585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8140 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8141 == NULL) {
    strlit8141 = alloc_String("method");
    gc_root(strlit8141);
  }
// compiled string node returning strlit8141 (depth = 4)
  gc_frame_newslot(strlit8141);
// call case 4: self request
  params[0] = strlit8141;
  partcv[0] = 1;
  Object call8142 = callmethodflags(self, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8140);
// compiled call node returning call8142 (depth = 3)
  Object if8139 = done;
  if (istrue(call8142)) {
// Begin line 2586
  setline(2586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2587
  setline(2587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8143 = gc_frame_new();
// call case 4: self request
  Object call8144 = callmethodflags(self, "checkIndent", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8143);
// compiled member node returning call8144 (depth = 3)
// Begin line 2588
  setline(2588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2589
  setline(2589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_stok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2590
  setline(2590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8146 = gc_frame_new();
// call case 4: self request
  Object call8147 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8146);
// compiled member node returning call8147 (depth = 3)
// Begin line 2591
  setline(2591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8148 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  gc_frame_newslot(*var_btok);
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe8149 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool8150 = alloc_Boolean(0);
// compiled identifier node returning bool8150 (depth = 6)
  gc_frame_newslot(bool8150);
// call case 4: self request
  params[0] = bool8150;
  partcv[0] = 1;
  Object call8151 = callmethodflags(self, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8149);
// compiled call node returning call8151 (depth = 5)
  params[0] = *var_btok;
  partcv[0] = 1;
  Object call8152 = callmethodflags(call8151, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8148);
// compiled call node returning call8152 (depth = 4)
  *var_methNode = call8152;
  if (call8152 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2592
  setline(2592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array8153 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8153 (depth = 4)
  *var_body = array8153;
  if (array8153 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2593
  setline(2593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_localMin = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2594
  setline(2594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8154 = gc_frame_new();
// call case 4: self request
  Object call8155 = callmethodflags(self, "doannotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8154);
// compiled member node returning call8155 (depth = 4)
  *var_anns = call8155;
  if (call8155 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2595
  setline(2595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8157 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8158 == NULL) {
    strlit8158 = alloc_String("lbrace");
    gc_root(strlit8158);
  }
// compiled string node returning strlit8158 (depth = 5)
  gc_frame_newslot(strlit8158);
// call case 4: self request
  params[0] = strlit8158;
  partcv[0] = 1;
  Object call8159 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8157);
// compiled call node returning call8159 (depth = 4)
  Object if8156 = done;
  if (istrue(call8159)) {
// Begin line 2596
  setline(2596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe8160 = gc_frame_new();
// call case 4: self request
  Object call8161 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8160);
// compiled member node returning call8161 (depth = 4)
// Begin line 2597
  setline(2597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_minIndentLevel (depth = 5)
  *var_localMin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2598
  setline(2598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8165 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_stok (depth = 7)
  Object call8166 = callmethodflags(*var_stok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8165);
// compiled member node returning call8166 (depth = 6)
  int op_slot_right_8164 = gc_frame_newslot(call8166);
// starting to compile member node (depth = 6)
  int callframe8168 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8169 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8168);
// compiled member node returning call8169 (depth = 6)
  int op_slot_left_8164 = gc_frame_newslot(call8169);
  params[0] = call8166;
  partcv[0] = 1;
  Object opresult8170 = callmethod(call8169, "==(1)", 1, partcv, params);
// compiled op node returning opresult8170 (depth = 5)
  Object if8163 = done;
  if (istrue(opresult8170)) {
// Begin line 2599
  setline(2599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8172 = alloc_Float64(1);
// compiled num node returning num8172 (depth = 7)
  int op_slot_right_8171 = gc_frame_newslot(num8172);
// starting to compile member node (depth = 7)
  int callframe8174 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call8175 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8174);
// compiled member node returning call8175 (depth = 7)
  int op_slot_left_8171 = gc_frame_newslot(call8175);
  params[0] = num8172;
  partcv[0] = 1;
  Object diff8176 = callmethod(call8175, "-(1)", 1, partcv, params);
// compiled op node returning diff8176 (depth = 6)
  *var_minIndentLevel = diff8176;
  if (diff8176 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8163 = done;
  } else {
// Begin line 2601
  setline(2601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8179 = alloc_Float64(1);
// compiled num node returning num8179 (depth = 7)
  int op_slot_right_8178 = gc_frame_newslot(num8179);
// starting to compile member node (depth = 7)
  int callframe8181 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_stok (depth = 8)
  Object call8182 = callmethodflags(*var_stok, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe8181);
// compiled member node returning call8182 (depth = 7)
  int op_slot_left_8178 = gc_frame_newslot(call8182);
  params[0] = num8179;
  partcv[0] = 1;
  Object sum8183 = callmethod(call8182, "+(1)", 1, partcv, params);
// compiled op node returning sum8183 (depth = 6)
  *var_minIndentLevel = sum8183;
  if (sum8183 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8163 = done;
  }
// compiled if node returning if8163 (depth = 4)
// Begin line 2603
  setline(2603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8185 = gc_frame_new();
// starting to compile object node (depth = 5)
  Object inheritingObject8186 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8186 = alloc_userobj2(3,4, objclass8186);
  gc_frame_newslot(obj8186);
// OBJECT OUTER DEC outer
  adddatum2(obj8186, self, 0);
  addmethodreal(obj8186,"outer", &reader_parser_outer_8187);
  Object oldself8186 = self;
  struct StackFrameObject *oldstackframe8186 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8186);
  gc_frame_newslot((Object)stackframe);
  self = obj8186;
  Object *oldselfslot8186 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8186 = (*(struct UserObject *)self).data[0], lowerouter8186 = thisouter8186;
  if (inheritingObject8186) {
    struct UserObject *inho8186 = (struct UserObject *)inheritingObject8186;
    while (inho8186->super != GraceDefaultObject) inho8186 = (struct UserObject *)inho8186->super;
    inho8186->super = obj8186;
    self = inheritingObject8186;
    *selfslot = self;
    lowerouter8186 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8186;
  }
if (objclass8186 == NULL) {
  Method *reader8188 = addmethodrealflags(obj8186, "kind",&reader_parser_kind_8188, MFLAG_DEF);
  reader8188->definitionModule = modulename;
  reader8188->definitionLine = 2604;
}
adddatum2(obj8186, alloc_Undefined(), 1);
if (objclass8186 == NULL) {
  Method *reader8189 = addmethodrealflags(obj8186, "register", &reader_parser_register_8189, 0);
  Method *writer8189 = addmethodrealflags(obj8186, "register:=(1)", &writer_parser_register_8189, 0);
  reader8189->definitionModule = modulename;
  writer8189->definitionModule = modulename;
  reader8189->definitionLine = 2605;
  writer8189->definitionLine = 2605;
}
obj8186->flags |= OFLAG_MUTABLE;
adddatum2(obj8186, alloc_Undefined(), 2);
  sourceObject = obj8186;
// Begin line 2604
  setline(2604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit8190 == NULL) {
    strlit8190 = alloc_String("lbrace");
    gc_root(strlit8190);
  }
// compiled string node returning strlit8190 (depth = 6)
  adddatum2(obj8186, strlit8190, 1);
  sourceObject = obj8186;
// Begin line 2605
  setline(2605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit8191 == NULL) {
    strlit8191 = alloc_String("");
    gc_root(strlit8191);
  }
// compiled string node returning strlit8191 (depth = 6)
  adddatum2(obj8186, strlit8191, 2);
  objclass8186 = obj8186->class;
  objclass8186->definitionModule = modulename;
  objclass8186->definitionLine = 2603;
  (*(struct UserObject *)self).data[0] = lowerouter8186;
  self = oldself8186;
  selfslot = oldselfslot8186;
  stackframe = oldstackframe8186;
// compiled object node returning obj8186 (depth = 5)
  gc_frame_newslot(obj8186);
// call case 6: other requests
// Begin line 2603
  setline(2603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = obj8186;
  partcv[0] = 1;
  Object call8192 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8185);
// compiled call node returning call8192 (depth = 4)
// Begin line 2607
  setline(2607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe8193 = gc_frame_new();
// call case 4: self request
  Object call8194 = callmethodflags(self, "statement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8193);
// compiled member node returning call8194 (depth = 4)
// Begin line 2608
  setline(2608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8195 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call8196 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe8195);
// compiled member node returning call8196 (depth = 5)
  *var_s = call8196;
  if (call8196 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2609
  setline(2609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8197 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8198 = alloc_Block(NULL, NULL, "parser", 2609);
  gc_frame_newslot(block8198);
// method "_apply"
  block_savedest(block8198);
  Object closure8199 = createclosure(2, "_apply");
  setclosureframe(closure8199, stackframe);
  addtoclosure(closure8199, var_s);
  addtoclosure(closure8199, selfslot);
  struct UserObject *uo8199 = (struct UserObject*)block8198;
  uo8199->data[0] = (Object)closure8199;
  Method *meth_meth_parser__apply8199 = addmethod2pos(block8198, "_apply", &meth_parser__apply8199, 0);
  int argcv_meth_parser__apply8199[] = {0};
  meth_meth_parser__apply8199->type = alloc_MethodType(1, argcv_meth_parser__apply8199);
  meth_meth_parser__apply8199->definitionModule = modulename;
  meth_meth_parser__apply8199->definitionLine = 3399;
// compiled block node returning block8198 (depth = 5)
  gc_frame_newslot(block8198);
// starting to compile block node (depth = 5)
  Object block8207 = alloc_Block(NULL, NULL, "parser", 2609);
  gc_frame_newslot(block8207);
// method "_apply"
  block_savedest(block8207);
  Object closure8208 = createclosure(4, "_apply");
  setclosureframe(closure8208, stackframe);
  addtoclosure(closure8208, var_s);
  addtoclosure(closure8208, var_body);
  addtoclosure(closure8208, var_values);
  addtoclosure(closure8208, selfslot);
  struct UserObject *uo8208 = (struct UserObject*)block8207;
  uo8208->data[0] = (Object)closure8208;
  Method *meth_meth_parser__apply8208 = addmethod2pos(block8207, "_apply", &meth_parser__apply8208, 0);
  int argcv_meth_parser__apply8208[] = {0};
  meth_meth_parser__apply8208->type = alloc_MethodType(1, argcv_meth_parser__apply8208);
  meth_meth_parser__apply8208->definitionModule = modulename;
  meth_meth_parser__apply8208->definitionLine = 3399;
// compiled block node returning block8207 (depth = 5)
  gc_frame_newslot(block8207);
// call case 5: prelude request
  params[0] = block8198;
  params[1] = block8207;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8217 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8197);
// compiled call node returning call8217 (depth = 4)
// Begin line 2617
  setline(2617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8220 == NULL) {
    strlit8220 = alloc_String("rbrace");
    gc_root(strlit8220);
  }
// compiled string node returning strlit8220 (depth = 6)
  int op_slot_right_8219 = gc_frame_newslot(strlit8220);
// starting to compile member node (depth = 6)
  int callframe8222 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8223 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8222);
// compiled member node returning call8223 (depth = 6)
  int op_slot_left_8219 = gc_frame_newslot(call8223);
  params[0] = strlit8220;
  partcv[0] = 1;
  Object opresult8224 = callmethod(call8223, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8224 (depth = 5)
  Object if8218 = done;
  if (istrue(opresult8224)) {
// Begin line 2618
  setline(2618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8225 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8226 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call8227 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8226);
// compiled member node returning call8227 (depth = 7)
  Object call8228 = callmethodflags(call8227, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8225);
// compiled member node returning call8228 (depth = 6)
  *var_suggestion = call8228;
  if (call8228 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2619
  setline(2619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8229 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool8230 = alloc_Boolean(0);
// compiled identifier node returning bool8230 (depth = 7)
  gc_frame_newslot(bool8230);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool8230;
  partcv[0] = 2;
  Object call8231 = callmethodflags(self, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8229);
// compiled call node returning call8231 (depth = 6)
  *var_closingBrace = call8231;
  if (call8231 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2620
  setline(2620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8233 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8234 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closingBrace (depth = 8)
  Object call8235 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe8234);
// compiled member node returning call8235 (depth = 7)
  Object call8236 = callmethodflags(call8235, "not", 0, partcv, params, 0);
  gc_frame_end(callframe8233);
// compiled member node returning call8236 (depth = 6)
  Object if8232 = done;
  if (istrue(call8236)) {
// Begin line 2621
  setline(2621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_8238 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
  int callframe8240 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  Object call8241 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe8240);
// compiled member node returning call8241 (depth = 8)
  int op_slot_left_8238 = gc_frame_newslot(call8241);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult8242 = callmethod(call8241, "==(1)", 1, partcv, params);
// compiled op node returning opresult8242 (depth = 7)
  Object if8237 = done;
  if (istrue(opresult8242)) {
// Begin line 2622
  setline(2622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8243 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8244 == NULL) {
    strlit8244 = alloc_String("}");
    gc_root(strlit8244);
  }
// compiled string node returning strlit8244 (depth = 8)
  gc_frame_newslot(strlit8244);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit8244;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8245 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8243);
// compiled call node returning call8245 (depth = 7)
    gc_frame_newslot(call8245);
    if8237 = call8245;
  } else {
// Begin line 2624
  setline(2624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8246 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num8248 = alloc_Float64(0.1);
// compiled num node returning num8248 (depth = 9)
  int op_slot_right_8247 = gc_frame_newslot(num8248);
// starting to compile member node (depth = 9)
  int callframe8250 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe8251 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  Object call8252 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe8251);
// compiled member node returning call8252 (depth = 10)
  Object call8253 = callmethodflags(call8252, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8250);
// compiled member node returning call8253 (depth = 9)
  int op_slot_left_8247 = gc_frame_newslot(call8253);
  params[0] = num8248;
  partcv[0] = 1;
  Object sum8254 = callmethod(call8253, "+(1)", 1, partcv, params);
// compiled op node returning sum8254 (depth = 8)
  gc_frame_newslot(sum8254);
// starting to compile string node (depth = 8)
  if (strlit8255 == NULL) {
    strlit8255 = alloc_String("}");
    gc_root(strlit8255);
  }
// compiled string node returning strlit8255 (depth = 8)
  gc_frame_newslot(strlit8255);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum8254;
  params[1] = strlit8255;
  partcv[0] = 2;
  Object call8256 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8246);
// compiled call node returning call8256 (depth = 7)
    gc_frame_newslot(call8256);
    if8237 = call8256;
  }
// compiled if node returning if8237 (depth = 6)
    gc_frame_newslot(if8237);
    if8232 = if8237;
  } else {
  }
// compiled if node returning if8232 (depth = 5)
// Begin line 2627
  setline(2627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8257 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call8258 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8257);
// compiled call node returning call8258 (depth = 5)
// Begin line 2628
  setline(2628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8259 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8260 == NULL) {
    strlit8260 = alloc_String("a method must end with a '}'.");
    gc_root(strlit8260);
  }
// compiled string node returning strlit8260 (depth = 6)
  gc_frame_newslot(strlit8260);
// Begin line 2629
  setline(2629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe8261 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8262 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8261);
// compiled member node returning call8262 (depth = 6)
  gc_frame_newslot(call8262);
// starting to compile member node (depth = 6)
  int callframe8263 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8264 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8263);
// compiled member node returning call8264 (depth = 6)
  gc_frame_newslot(call8264);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2628
  setline(2628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit8260;
  params[1] = call8262;
  params[2] = call8264;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8265 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8259);
// compiled call node returning call8265 (depth = 5)
    gc_frame_newslot(call8265);
    if8218 = call8265;
  } else {
  }
// compiled if node returning if8218 (depth = 4)
// Begin line 2631
  setline(2631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe8266 = gc_frame_new();
// call case 4: self request
  Object call8267 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8266);
// compiled member node returning call8267 (depth = 4)
// Begin line 2632
  setline(2632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_localMin (depth = 5)
  *var_minIndentLevel = *var_localMin;
  if (*var_localMin == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8156 = done;
  } else {
// Begin line 2634
  setline(2634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8269 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8270 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call8271 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8270);
// compiled member node returning call8271 (depth = 6)
  Object call8272 = callmethodflags(call8271, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8269);
// compiled member node returning call8272 (depth = 5)
  *var_suggestion = call8272;
  if (call8272 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2635
  setline(2635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8273 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 6)
  Object bool8274 = alloc_Boolean(1);
// compiled identifier node returning bool8274 (depth = 6)
  gc_frame_newslot(bool8274);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool8274;
  partcv[0] = 2;
  Object call8275 = callmethodflags(self, "findClosingBrace(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8273);
// compiled call node returning call8275 (depth = 5)
  *var_closingBrace = call8275;
  if (call8275 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2636
  setline(2636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8277 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8278 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_closingBrace (depth = 7)
  Object call8279 = callmethodflags(*var_closingBrace, "found", 0, partcv, params, 0);
  gc_frame_end(callframe8278);
// compiled member node returning call8279 (depth = 6)
  Object call8280 = callmethodflags(call8279, "not", 0, partcv, params, 0);
  gc_frame_end(callframe8277);
// compiled member node returning call8280 (depth = 5)
  Object if8276 = done;
  if (istrue(call8280)) {
// Begin line 2637
  setline(2637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  int op_slot_right_8282 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
  int callframe8284 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closingBrace (depth = 8)
  Object call8285 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe8284);
// compiled member node returning call8285 (depth = 7)
  int op_slot_left_8282 = gc_frame_newslot(call8285);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult8286 = callmethod(call8285, "==(1)", 1, partcv, params);
// compiled op node returning opresult8286 (depth = 6)
  Object if8281 = done;
  if (istrue(opresult8286)) {
// Begin line 2638
  setline(2638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8287 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8288 == NULL) {
    strlit8288 = alloc_String(" {}");
    gc_root(strlit8288);
  }
// compiled string node returning strlit8288 (depth = 7)
  gc_frame_newslot(strlit8288);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool8289 = alloc_Boolean(1);
// compiled identifier node returning bool8289 (depth = 7)
  gc_frame_newslot(bool8289);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit8288;
  params[1] = *var_lastToken;
  params[2] = bool8289;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8290 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8287);
// compiled call node returning call8290 (depth = 6)
    gc_frame_newslot(call8290);
    if8281 = call8290;
  } else {
// Begin line 2640
  setline(2640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8291 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8293 = alloc_Float64(0.1);
// compiled num node returning num8293 (depth = 8)
  int op_slot_right_8292 = gc_frame_newslot(num8293);
// starting to compile member node (depth = 8)
  int callframe8295 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe8296 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  Object call8297 = callmethodflags(*var_closingBrace, "tok", 0, partcv, params, 0);
  gc_frame_end(callframe8296);
// compiled member node returning call8297 (depth = 9)
  Object call8298 = callmethodflags(call8297, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8295);
// compiled member node returning call8298 (depth = 8)
  int op_slot_left_8292 = gc_frame_newslot(call8298);
  params[0] = num8293;
  partcv[0] = 1;
  Object sum8299 = callmethod(call8298, "+(1)", 1, partcv, params);
// compiled op node returning sum8299 (depth = 7)
  gc_frame_newslot(sum8299);
// starting to compile string node (depth = 7)
  if (strlit8300 == NULL) {
    strlit8300 = alloc_String("}");
    gc_root(strlit8300);
  }
// compiled string node returning strlit8300 (depth = 7)
  gc_frame_newslot(strlit8300);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = sum8299;
  params[1] = strlit8300;
  partcv[0] = 2;
  Object call8301 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8291);
// compiled call node returning call8301 (depth = 6)
// Begin line 2641
  setline(2641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8302 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8303 == NULL) {
    strlit8303 = alloc_String(" {");
    gc_root(strlit8303);
  }
// compiled string node returning strlit8303 (depth = 7)
  gc_frame_newslot(strlit8303);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool8304 = alloc_Boolean(1);
// compiled identifier node returning bool8304 (depth = 7)
  gc_frame_newslot(bool8304);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit8303;
  params[1] = *var_lastToken;
  params[2] = bool8304;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8305 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8302);
// compiled call node returning call8305 (depth = 6)
    gc_frame_newslot(call8305);
    if8281 = call8305;
  }
// compiled if node returning if8281 (depth = 5)
    gc_frame_newslot(if8281);
    if8276 = if8281;
  } else {
// Begin line 2644
  setline(2644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8306 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8307 == NULL) {
    strlit8307 = alloc_String(" {");
    gc_root(strlit8307);
  }
// compiled string node returning strlit8307 (depth = 6)
  gc_frame_newslot(strlit8307);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 6)
  Object bool8308 = alloc_Boolean(1);
// compiled identifier node returning bool8308 (depth = 6)
  gc_frame_newslot(bool8308);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8307;
  params[1] = *var_lastToken;
  params[2] = bool8308;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8309 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)andTrailingSpace(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8306);
// compiled call node returning call8309 (depth = 5)
    gc_frame_newslot(call8309);
    if8276 = call8309;
  }
// compiled if node returning if8276 (depth = 4)
// Begin line 2646
  setline(2646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8310 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8311 == NULL) {
    strlit8311 = alloc_String("a method must have a '{' after the name.");
    gc_root(strlit8311);
  }
// compiled string node returning strlit8311 (depth = 5)
  gc_frame_newslot(strlit8311);
// Begin line 2647
  setline(2647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8312 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call8313 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8312);
// compiled member node returning call8313 (depth = 5)
  gc_frame_newslot(call8313);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8315 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call8316 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8315);
// compiled member node returning call8316 (depth = 6)
  int op_slot_right_8314 = gc_frame_newslot(call8316);
// starting to compile member node (depth = 6)
  int callframe8318 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call8319 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8318);
// compiled member node returning call8319 (depth = 6)
  int op_slot_left_8314 = gc_frame_newslot(call8319);
  params[0] = call8316;
  partcv[0] = 1;
  Object sum8320 = callmethod(call8319, "+(1)", 1, partcv, params);
// compiled op node returning sum8320 (depth = 5)
  gc_frame_newslot(sum8320);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2646
  setline(2646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8311;
  params[1] = call8313;
  params[2] = sum8320;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8321 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8310);
// compiled call node returning call8321 (depth = 4)
    gc_frame_newslot(call8321);
    if8156 = call8321;
  }
// compiled if node returning if8156 (depth = 3)
// Begin line 2649
  setline(2649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8322 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_body (depth = 4)
  gc_frame_newslot(*var_body);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methNode (depth = 4)
  params[0] = *var_body;
  partcv[0] = 1;
  Object call8323 = callmethodflags(*var_methNode, "body:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8322);
// compiled call node returning call8323 (depth = 3)
// Begin line 2650
  setline(2650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8324 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8325 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  Object call8326 = callmethodflags(*var_btok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8325);
// compiled member node returning call8326 (depth = 4)
  gc_frame_newslot(call8326);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call8326;
  partcv[0] = 1;
  Object call8327 = callmethodflags(*var_util, "setline(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8324);
// compiled call node returning call8327 (depth = 3)
// Begin line 2651
  setline(2651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_8329 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool8331 = alloc_Boolean(0);
// compiled identifier node returning bool8331 (depth = 5)
  int op_slot_left_8329 = gc_frame_newslot(bool8331);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult8332 = callmethod(bool8331, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8332 (depth = 4)
  Object if8328 = done;
  if (istrue(opresult8332)) {
// starting to compile call node (depth = 4)
  int callframe8333 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8334 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methNode (depth = 6)
  Object call8335 = callmethodflags(*var_methNode, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe8334);
// compiled member node returning call8335 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call8336 = callmethodflags(call8335, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8333);
// compiled call node returning call8336 (depth = 4)
    gc_frame_newslot(call8336);
    if8328 = call8336;
  } else {
  }
// compiled if node returning if8328 (depth = 3)
// Begin line 2652
  setline(2652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8337 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methNode (depth = 4)
  gc_frame_newslot(*var_methNode);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_methNode;
  partcv[0] = 1;
  Object call8338 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8337);
// compiled call node returning call8338 (depth = 3)
// Begin line 2653
  setline(2653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8339 = gc_frame_new();
// call case 4: self request
  Object call8340 = callmethodflags(self, "reconcileComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8339);
// compiled member node returning call8340 (depth = 3)
    gc_frame_newslot(call8340);
    if8139 = call8340;
  } else {
  }
// compiled if node returning if8139 (depth = 2)
  gc_frame_end(frame);
  return if8139;
}
Object meth_parser__apply8346(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sameline = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8348 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8349 == NULL) {
    strlit8349 = alloc_String("identifier");
    gc_root(strlit8349);
  }
// compiled string node returning strlit8349 (depth = 6)
  gc_frame_newslot(strlit8349);
// call case 4: self request
  params[0] = strlit8349;
  partcv[0] = 1;
  Object call8350 = callmethodflags(self, "acceptSameLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8348);
// compiled call node returning call8350 (depth = 5)
  int op_slot_right_8347 = gc_frame_newslot(call8350);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8353 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8354 == NULL) {
    strlit8354 = alloc_String("identifier");
    gc_root(strlit8354);
  }
// compiled string node returning strlit8354 (depth = 7)
  gc_frame_newslot(strlit8354);
// call case 4: self request
  params[0] = strlit8354;
  partcv[0] = 1;
  Object call8355 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8353);
// compiled call node returning call8355 (depth = 6)
  int op_slot_right_8352 = gc_frame_newslot(call8355);
// starting to compile call node (depth = 6)
  int callframe8357 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sameline (depth = 7)
  partcv[0] = 0;
  Object call8358 = callmethodflags(*var_sameline, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe8357);
// compiled call node returning call8358 (depth = 6)
  int op_slot_left_8352 = gc_frame_newslot(call8358);
  params[0] = call8355;
  partcv[0] = 1;
  Object opresult8359 = callmethod(call8358, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8359 (depth = 5)
  int op_slot_left_8347 = gc_frame_newslot(opresult8359);
  params[0] = call8350;
  partcv[0] = 1;
  Object opresult8360 = callmethod(opresult8359, "||(1)", 1, partcv, params);
// compiled op node returning opresult8360 (depth = 4)
  gc_frame_end(frame);
  return opresult8360;
}
Object meth_parser__apply8403(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// Begin line 2679
  setline(2679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8407 == NULL) {
    strlit8407 = alloc_String("*");
    gc_root(strlit8407);
  }
// compiled string node returning strlit8407 (depth = 9)
  int op_slot_right_8406 = gc_frame_newslot(strlit8407);
// starting to compile member node (depth = 9)
  int callframe8409 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call8410 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8409);
// compiled member node returning call8410 (depth = 9)
  int op_slot_left_8406 = gc_frame_newslot(call8410);
  params[0] = strlit8407;
  partcv[0] = 1;
  Object opresult8411 = callmethod(call8410, "==(1)", 1, partcv, params);
// compiled op node returning opresult8411 (depth = 8)
  int op_slot_right_8405 = gc_frame_newslot(opresult8411);
// starting to compile call node (depth = 8)
  int callframe8413 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit8414 == NULL) {
    strlit8414 = alloc_String("op");
    gc_root(strlit8414);
  }
// compiled string node returning strlit8414 (depth = 9)
  gc_frame_newslot(strlit8414);
// call case 4: self request
  params[0] = strlit8414;
  partcv[0] = 1;
  Object call8415 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8413);
// compiled call node returning call8415 (depth = 8)
  int op_slot_left_8405 = gc_frame_newslot(call8415);
  params[0] = opresult8411;
  partcv[0] = 1;
  Object opresult8416 = callmethod(call8415, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8416 (depth = 7)
  int op_slot_right_8404 = gc_frame_newslot(opresult8416);
// Begin line 2678
  setline(2678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8418 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8419 == NULL) {
    strlit8419 = alloc_String("identifier");
    gc_root(strlit8419);
  }
// compiled string node returning strlit8419 (depth = 8)
  gc_frame_newslot(strlit8419);
// call case 4: self request
  params[0] = strlit8419;
  partcv[0] = 1;
  Object call8420 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8418);
// compiled call node returning call8420 (depth = 7)
  int op_slot_left_8404 = gc_frame_newslot(call8420);
  params[0] = opresult8416;
  partcv[0] = 1;
  Object opresult8421 = callmethod(call8420, "||(1)", 1, partcv, params);
// compiled op node returning opresult8421 (depth = 6)
  gc_frame_end(frame);
  return opresult8421;
}
Object meth_parser__apply8424(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_part = getfromclosure(closure, 4);
  Object *var_comma = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_nxt = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "nxt");
// Begin line 2680
  setline(2680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8426 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8427 == NULL) {
    strlit8427 = alloc_String("op");
    gc_root(strlit8427);
  }
// compiled string node returning strlit8427 (depth = 8)
  gc_frame_newslot(strlit8427);
// call case 4: self request
  params[0] = strlit8427;
  partcv[0] = 1;
  Object call8428 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8426);
// compiled call node returning call8428 (depth = 7)
  Object if8425 = done;
  if (istrue(call8428)) {
// Begin line 2681
  setline(2681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe8429 = gc_frame_new();
// call case 4: self request
  Object call8430 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8429);
// compiled member node returning call8430 (depth = 7)
// Begin line 2682
  setline(2682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8431 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8433 == NULL) {
    strlit8433 = alloc_String(" an Iterable.");
    gc_root(strlit8433);
  }
// compiled string node returning strlit8433 (depth = 9)
  int op_slot_right_8432 = gc_frame_newslot(strlit8433);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe8436 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call8437 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8436);
// compiled member node returning call8437 (depth = 10)
  int op_slot_right_8435 = gc_frame_newslot(call8437);
// starting to compile string node (depth = 10)
  if (strlit8439 == NULL) {
    strlit8439 = alloc_String("variable length parameters (parameters prefixed by '*') are no longer part of Grace.  Consider making ");
    gc_root(strlit8439);
  }
// compiled string node returning strlit8439 (depth = 10)
  int op_slot_left_8435 = gc_frame_newslot(strlit8439);
  params[0] = call8437;
  partcv[0] = 1;
  Object opresult8440 = callmethod(strlit8439, "++(1)", 1, partcv, params);
// compiled op node returning opresult8440 (depth = 9)
  int op_slot_left_8432 = gc_frame_newslot(opresult8440);
  params[0] = strlit8433;
  partcv[0] = 1;
  Object opresult8441 = callmethod(opresult8440, "++(1)", 1, partcv, params);
// compiled op node returning opresult8441 (depth = 8)
  gc_frame_newslot(opresult8441);
// Begin line 2683
  setline(2683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe8442 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call8443 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8442);
// compiled member node returning call8443 (depth = 8)
  gc_frame_newslot(call8443);
// starting to compile member node (depth = 8)
  int callframe8444 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call8445 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8444);
// compiled member node returning call8445 (depth = 8)
  gc_frame_newslot(call8445);
// call case 6: other requests
// Begin line 2682
  setline(2682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult8441;
  params[1] = call8443;
  params[2] = call8445;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call8446 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe8431);
// compiled call node returning call8446 (depth = 7)
    gc_frame_newslot(call8446);
    if8425 = call8446;
  } else {
  }
// compiled if node returning if8425 (depth = 6)
// Begin line 2685
  setline(2685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe8447 = gc_frame_new();
// call case 4: self request
  Object call8448 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8447);
// compiled member node returning call8448 (depth = 6)
// Begin line 2686
  setline(2686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8449 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call8450 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe8449);
// compiled member node returning call8450 (depth = 7)
  *var_nxt = call8450;
  if (call8450 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 2687
  setline(2687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8451 = gc_frame_new();
// starting to compile identifier node (depth = 7)
  Object bool8452 = alloc_Boolean(1);
// compiled identifier node returning bool8452 (depth = 7)
  gc_frame_newslot(bool8452);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nxt (depth = 7)
  params[0] = bool8452;
  partcv[0] = 1;
  Object call8453 = callmethodflags(*var_nxt, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8451);
// compiled call node returning call8453 (depth = 6)
// Begin line 2688
  setline(2688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8454 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe8455 = gc_frame_new();
// call case 4: self request
  Object call8456 = callmethodflags(self, "optionalTypeAnnotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8455);
// compiled member node returning call8456 (depth = 7)
  gc_frame_newslot(call8456);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nxt (depth = 7)
  params[0] = call8456;
  partcv[0] = 1;
  Object call8457 = callmethodflags(*var_nxt, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8454);
// compiled call node returning call8457 (depth = 6)
// Begin line 2689
  setline(2689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8458 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nxt (depth = 7)
  gc_frame_newslot(*var_nxt);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8459 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  Object call8460 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe8459);
// compiled member node returning call8460 (depth = 7)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call8461 = callmethodflags(call8460, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8458);
// compiled call node returning call8461 (depth = 6)
// Begin line 2690
  setline(2690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8463 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8464 == NULL) {
    strlit8464 = alloc_String("comma");
    gc_root(strlit8464);
  }
// compiled string node returning strlit8464 (depth = 8)
  gc_frame_newslot(strlit8464);
// call case 4: self request
  params[0] = strlit8464;
  partcv[0] = 1;
  Object call8465 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8463);
// compiled call node returning call8465 (depth = 7)
  Object if8462 = done;
  if (istrue(call8465)) {
// Begin line 2691
  setline(2691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  *var_comma = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 2692
  setline(2692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe8467 = gc_frame_new();
// call case 4: self request
  Object call8468 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8467);
// compiled member node returning call8468 (depth = 7)
    gc_frame_newslot(call8468);
    if8462 = call8468;
  } else {
  }
// compiled if node returning if8462 (depth = 6)
  gc_frame_end(frame);
  return if8462;
}
Object meth_parser__apply8363(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_signature = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_part = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "part");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_comma = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "comma");
// Begin line 2667
  setline(2667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe8364 = gc_frame_new();
// call case 4: self request
  Object call8365 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8364);
// compiled member node returning call8365 (depth = 4)
// Begin line 2668
  setline(2668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8366 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe8367 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8368 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call8369 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe8368);
// compiled member node returning call8369 (depth = 7)
  Object call8370 = callmethodflags(call8369, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe8367);
// compiled member node returning call8370 (depth = 6)
  gc_frame_newslot(call8370);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8371 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call8372 = callmethodflags(*var_ast, "signaturePart", 0, partcv, params, 0);
  gc_frame_end(callframe8371);
// compiled member node returning call8372 (depth = 6)
  params[0] = call8370;
  partcv[0] = 1;
  Object call8373 = callmethodflags(call8372, "partName(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8366);
// compiled call node returning call8373 (depth = 5)
  *var_part = call8373;
  if (call8373 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2669
  setline(2669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8375 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe8376 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8377 == NULL) {
    strlit8377 = alloc_String("lparen");
    gc_root(strlit8377);
  }
// compiled string node returning strlit8377 (depth = 7)
  gc_frame_newslot(strlit8377);
// call case 4: self request
  params[0] = strlit8377;
  partcv[0] = 1;
  Object call8378 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8376);
// compiled call node returning call8378 (depth = 6)
  Object call8379 = callmethodflags(call8378, "not", 0, partcv, params, 0);
  gc_frame_end(callframe8375);
// compiled member node returning call8379 (depth = 5)
  Object if8374 = done;
  if (istrue(call8379)) {
// Begin line 2670
  setline(2670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8380 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8381 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call8382 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8381);
// compiled member node returning call8382 (depth = 7)
  Object call8383 = callmethodflags(call8382, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8380);
// compiled member node returning call8383 (depth = 6)
  *var_suggestion = call8383;
  if (call8383 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2671
  setline(2671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8384 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8385 == NULL) {
    strlit8385 = alloc_String("()");
    gc_root(strlit8385);
  }
// compiled string node returning strlit8385 (depth = 6)
  gc_frame_newslot(strlit8385);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8385;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8386 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8384);
// compiled call node returning call8386 (depth = 5)
// Begin line 2672
  setline(2672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8387 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2673
  setline(2673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8389 == NULL) {
    strlit8389 = alloc_String("parameter lists must have parentheses around each parameter list.");
    gc_root(strlit8389);
  }
// compiled string node returning strlit8389 (depth = 7)
  int op_slot_right_8388 = gc_frame_newslot(strlit8389);
// Begin line 2672
  setline(2672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8391 == NULL) {
    strlit8391 = alloc_String("the declaration of a method with multiple ");
    gc_root(strlit8391);
  }
// compiled string node returning strlit8391 (depth = 7)
  int op_slot_left_8388 = gc_frame_newslot(strlit8391);
  params[0] = strlit8389;
  partcv[0] = 1;
  Object opresult8392 = callmethod(strlit8391, "++(1)", 1, partcv, params);
// compiled op node returning opresult8392 (depth = 6)
  gc_frame_newslot(opresult8392);
// Begin line 2674
  setline(2674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe8393 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8394 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8393);
// compiled member node returning call8394 (depth = 6)
  gc_frame_newslot(call8394);
// starting to compile member node (depth = 6)
  int callframe8395 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8396 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8395);
// compiled member node returning call8396 (depth = 6)
  gc_frame_newslot(call8396);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2672
  setline(2672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult8392;
  params[1] = call8394;
  params[2] = call8396;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8397 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8387);
// compiled call node returning call8397 (depth = 5)
    gc_frame_newslot(call8397);
    if8374 = call8397;
  } else {
  }
// compiled if node returning if8374 (depth = 4)
// Begin line 2676
  setline(2676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe8398 = gc_frame_new();
// call case 4: self request
  Object call8399 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8398);
// compiled member node returning call8399 (depth = 4)
// Begin line 2677
  setline(2677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8400 = alloc_Boolean(0);
// compiled identifier node returning bool8400 (depth = 5)
  *var_comma = bool8400;
  if (bool8400 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2678
  setline(2678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8401 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8402 = alloc_Block(NULL, NULL, "parser", 2678);
  gc_frame_newslot(block8402);
// method "_apply"
  block_savedest(block8402);
  Object closure8403 = createclosure(2, "_apply");
  setclosureframe(closure8403, stackframe);
  addtoclosure(closure8403, var_sym);
  addtoclosure(closure8403, selfslot);
  struct UserObject *uo8403 = (struct UserObject*)block8402;
  uo8403->data[0] = (Object)closure8403;
  Method *meth_meth_parser__apply8403 = addmethod2pos(block8402, "_apply", &meth_parser__apply8403, 0);
  int argcv_meth_parser__apply8403[] = {0};
  meth_meth_parser__apply8403->type = alloc_MethodType(1, argcv_meth_parser__apply8403);
  meth_meth_parser__apply8403->definitionModule = modulename;
  meth_meth_parser__apply8403->definitionLine = 3399;
// compiled block node returning block8402 (depth = 5)
  gc_frame_newslot(block8402);
// Begin line 2679
  setline(2679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block8423 = alloc_Block(NULL, NULL, "parser", 2679);
  gc_frame_newslot(block8423);
// method "_apply"
  block_savedest(block8423);
  Object closure8424 = createclosure(7, "_apply");
  setclosureframe(closure8424, stackframe);
  addtoclosure(closure8424, var_sym);
  addtoclosure(closure8424, var_lastToken);
  addtoclosure(closure8424, var_errormessages);
  addtoclosure(closure8424, var_values);
  addtoclosure(closure8424, var_part);
  addtoclosure(closure8424, var_comma);
  addtoclosure(closure8424, selfslot);
  struct UserObject *uo8424 = (struct UserObject*)block8423;
  uo8424->data[0] = (Object)closure8424;
  Method *meth_meth_parser__apply8424 = addmethod2pos(block8423, "_apply", &meth_parser__apply8424, 0);
  int argcv_meth_parser__apply8424[] = {0};
  meth_meth_parser__apply8424->type = alloc_MethodType(1, argcv_meth_parser__apply8424);
  meth_meth_parser__apply8424->definitionModule = modulename;
  meth_meth_parser__apply8424->definitionLine = 3399;
// compiled block node returning block8423 (depth = 5)
  gc_frame_newslot(block8423);
// call case 5: prelude request
  params[0] = block8402;
  params[1] = block8423;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8470 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8401);
// compiled call node returning call8470 (depth = 4)
// Begin line 2695
  setline(2695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8473 == NULL) {
    strlit8473 = alloc_String("rparen");
    gc_root(strlit8473);
  }
// compiled string node returning strlit8473 (depth = 6)
  int op_slot_right_8472 = gc_frame_newslot(strlit8473);
// starting to compile member node (depth = 6)
  int callframe8475 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8476 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8475);
// compiled member node returning call8476 (depth = 6)
  int op_slot_left_8472 = gc_frame_newslot(call8476);
  params[0] = strlit8473;
  partcv[0] = 1;
  Object opresult8477 = callmethod(call8476, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8477 (depth = 5)
  Object if8471 = done;
  if (istrue(opresult8477)) {
// Begin line 2696
  setline(2696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8478 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8479 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call8480 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8479);
// compiled member node returning call8480 (depth = 7)
  Object call8481 = callmethodflags(call8480, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8478);
// compiled member node returning call8481 (depth = 6)
  *var_suggestion = call8481;
  if (call8481 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2697
  setline(2697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8482 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8483 == NULL) {
    strlit8483 = alloc_String(")");
    gc_root(strlit8483);
  }
// compiled string node returning strlit8483 (depth = 6)
  gc_frame_newslot(strlit8483);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8483;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8484 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8482);
// compiled call node returning call8484 (depth = 5)
// Begin line 2698
  setline(2698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8485 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8486 == NULL) {
    strlit8486 = alloc_String("a part of a multi-part method beginning with a '(' must end with a ')'.");
    gc_root(strlit8486);
  }
// compiled string node returning strlit8486 (depth = 6)
  gc_frame_newslot(strlit8486);
// Begin line 2699
  setline(2699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe8487 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call8488 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8487);
// compiled member node returning call8488 (depth = 6)
  gc_frame_newslot(call8488);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8490 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call8491 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8490);
// compiled member node returning call8491 (depth = 7)
  int op_slot_right_8489 = gc_frame_newslot(call8491);
// starting to compile member node (depth = 7)
  int callframe8493 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call8494 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8493);
// compiled member node returning call8494 (depth = 7)
  int op_slot_left_8489 = gc_frame_newslot(call8494);
  params[0] = call8491;
  partcv[0] = 1;
  Object sum8495 = callmethod(call8494, "+(1)", 1, partcv, params);
// compiled op node returning sum8495 (depth = 6)
  gc_frame_newslot(sum8495);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2698
  setline(2698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit8486;
  params[1] = call8488;
  params[2] = sum8495;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8496 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8485);
// compiled call node returning call8496 (depth = 5)
    gc_frame_newslot(call8496);
    if8471 = call8496;
  } else {
  }
// compiled if node returning if8471 (depth = 4)
// Begin line 2701
  setline(2701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe8497 = gc_frame_new();
// call case 4: self request
  Object call8498 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8497);
// compiled member node returning call8498 (depth = 4)
// Begin line 2702
  setline(2702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8499 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  gc_frame_newslot(*var_part);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call8500 = callmethodflags(*var_signature, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8499);
// compiled call node returning call8500 (depth = 4)
  gc_frame_end(frame);
  return call8500;
}
Object meth_parser_methodDecRest_40_2_41_8341(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 62, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodDecRest(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method methodDecRest(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodDecRest(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tm = &(stackframe->slots[0]);
  *var_tm = args[curarg];
  curarg++;
  Object *var_sameline = &(stackframe->slots[1]);
  *var_sameline = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part methodDecRest(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_signature = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "signature");
// Begin line 2665
  setline(2665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe8342 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tm (depth = 4)
  Object call8343 = callmethodflags(*var_tm, "signature", 0, partcv, params, 0);
  gc_frame_end(callframe8342);
// compiled member node returning call8343 (depth = 3)
  *var_signature = call8343;
  if (call8343 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2666
  setline(2666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8344 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block8345 = alloc_Block(NULL, NULL, "parser", 2666);
  gc_frame_newslot(block8345);
// method "_apply"
  block_savedest(block8345);
  Object closure8346 = createclosure(2, "_apply");
  setclosureframe(closure8346, stackframe);
  addtoclosure(closure8346, var_sameline);
  addtoclosure(closure8346, selfslot);
  struct UserObject *uo8346 = (struct UserObject*)block8345;
  uo8346->data[0] = (Object)closure8346;
  Method *meth_meth_parser__apply8346 = addmethod2pos(block8345, "_apply", &meth_parser__apply8346, 0);
  int argcv_meth_parser__apply8346[] = {0};
  meth_meth_parser__apply8346->type = alloc_MethodType(1, argcv_meth_parser__apply8346);
  meth_meth_parser__apply8346->definitionModule = modulename;
  meth_meth_parser__apply8346->definitionLine = 3399;
// compiled block node returning block8345 (depth = 3)
  gc_frame_newslot(block8345);
// starting to compile block node (depth = 3)
  Object block8362 = alloc_Block(NULL, NULL, "parser", 2666);
  gc_frame_newslot(block8362);
// method "_apply"
  block_savedest(block8362);
  Object closure8363 = createclosure(7, "_apply");
  setclosureframe(closure8363, stackframe);
  addtoclosure(closure8363, var_values);
  addtoclosure(closure8363, var_ast);
  addtoclosure(closure8363, var_errormessages);
  addtoclosure(closure8363, var_lastToken);
  addtoclosure(closure8363, var_sym);
  addtoclosure(closure8363, var_signature);
  addtoclosure(closure8363, selfslot);
  struct UserObject *uo8363 = (struct UserObject*)block8362;
  uo8363->data[0] = (Object)closure8363;
  Method *meth_meth_parser__apply8363 = addmethod2pos(block8362, "_apply", &meth_parser__apply8363, 0);
  int argcv_meth_parser__apply8363[] = {0};
  meth_meth_parser__apply8363->type = alloc_MethodType(1, argcv_meth_parser__apply8363);
  meth_meth_parser__apply8363->definitionModule = modulename;
  meth_meth_parser__apply8363->definitionLine = 3399;
// compiled block node returning block8362 (depth = 3)
  gc_frame_newslot(block8362);
// call case 5: prelude request
  params[0] = block8345;
  params[1] = block8362;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8502 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8344);
// compiled call node returning call8502 (depth = 2)
  gc_frame_end(frame);
  return call8502;
}
Object meth_parser__apply8513(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
  int callframe8514 = gc_frame_new();
// call case 4: self request
  Object call8515 = callmethodflags(self, "typeexpression", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8514);
// compiled member node returning call8515 (depth = 6)
  gc_frame_end(frame);
  return call8515;
}
Object meth_parser_optionalTypeAnnotation8503(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 63, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "optionalTypeAnnotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// Begin line 2709
  setline(2709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8505 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8506 == NULL) {
    strlit8506 = alloc_String("colon");
    gc_root(strlit8506);
  }
// compiled string node returning strlit8506 (depth = 4)
  gc_frame_newslot(strlit8506);
// call case 4: self request
  params[0] = strlit8506;
  partcv[0] = 1;
  Object call8507 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8505);
// compiled call node returning call8507 (depth = 3)
  Object if8504 = done;
  if (istrue(call8507)) {
// Begin line 2710
  setline(2710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8508 = gc_frame_new();
// call case 4: self request
  Object call8509 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8508);
// compiled member node returning call8509 (depth = 3)
// Begin line 2711
  setline(2711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8511 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8512 = alloc_Block(NULL, NULL, "parser", 2711);
  gc_frame_newslot(block8512);
// method "_apply"
  block_savedest(block8512);
  Object closure8513 = createclosure(1, "_apply");
  setclosureframe(closure8513, stackframe);
  addtoclosure(closure8513, selfslot);
  struct UserObject *uo8513 = (struct UserObject*)block8512;
  uo8513->data[0] = (Object)closure8513;
  Method *meth_meth_parser__apply8513 = addmethod2pos(block8512, "_apply", &meth_parser__apply8513, 0);
  int argcv_meth_parser__apply8513[] = {0};
  meth_meth_parser__apply8513->type = alloc_MethodType(1, argcv_meth_parser__apply8513);
  meth_meth_parser__apply8513->definitionModule = modulename;
  meth_meth_parser__apply8513->definitionLine = 3399;
// compiled block node returning block8512 (depth = 5)
  gc_frame_newslot(block8512);
// call case 4: self request
  params[0] = block8512;
  partcv[0] = 1;
  Object call8517 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8511);
// compiled call node returning call8517 (depth = 4)
  Object if8510 = done;
  if (istrue(call8517)) {
// Begin line 2712
  setline(2712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe8518 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call8519 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe8518);
// compiled member node returning call8519 (depth = 4)
    gc_frame_newslot(call8519);
    if8510 = call8519;
  } else {
// Begin line 2714
  setline(2714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe8520 = gc_frame_new();
// call case 4: self request
  Object call8521 = callmethodflags(self, "checkBadTypeLiteral", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8520);
// compiled member node returning call8521 (depth = 4)
// Begin line 2715
  setline(2715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array8522 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8522 (depth = 5)
  *var_suggestions = array8522;
  if (array8522 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2716
  setline(2716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8523 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8524 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call8525 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8524);
// compiled member node returning call8525 (depth = 6)
  Object call8526 = callmethodflags(call8525, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8523);
// compiled member node returning call8526 (depth = 5)
  *var_suggestion = call8526;
  if (call8526 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2717
  setline(2717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8527 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8528 == NULL) {
    strlit8528 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit8528);
  }
// compiled string node returning strlit8528 (depth = 5)
  gc_frame_newslot(strlit8528);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit8528;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8529 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8527);
// compiled call node returning call8529 (depth = 4)
// Begin line 2718
  setline(2718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8530 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8531 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8530);
// compiled call node returning call8531 (depth = 4)
// Begin line 2719
  setline(2719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8532 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8533 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call8534 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8533);
// compiled member node returning call8534 (depth = 6)
  Object call8535 = callmethodflags(call8534, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8532);
// compiled member node returning call8535 (depth = 5)
  *var_suggestion = call8535;
  if (call8535 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2720
  setline(2720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8537 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 5)
  Object bool8538 = alloc_Boolean(1);
// compiled identifier node returning bool8538 (depth = 5)
  gc_frame_newslot(bool8538);
// starting to compile identifier node (depth = 5)
  Object bool8539 = alloc_Boolean(0);
// compiled identifier node returning bool8539 (depth = 5)
  gc_frame_newslot(bool8539);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  params[1] = bool8538;
  params[2] = bool8539;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8540 = callmethodflags(*var_suggestion, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8537);
// compiled call node returning call8540 (depth = 4)
// Begin line 2721
  setline(2721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8541 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8542 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8541);
// compiled call node returning call8542 (depth = 4)
// Begin line 2722
  setline(2722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8543 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8544 == NULL) {
    strlit8544 = alloc_String("a type name or type expression must follow ':'.");
    gc_root(strlit8544);
  }
// compiled string node returning strlit8544 (depth = 5)
  gc_frame_newslot(strlit8544);
// Begin line 2723
  setline(2723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8545 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call8546 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8545);
// compiled member node returning call8546 (depth = 5)
  gc_frame_newslot(call8546);
// starting to compile member node (depth = 5)
  int callframe8547 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call8548 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8547);
// compiled member node returning call8548 (depth = 5)
  gc_frame_newslot(call8548);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2722
  setline(2722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8544;
  params[1] = call8546;
  params[2] = call8548;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8549 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8543);
// compiled call node returning call8549 (depth = 4)
    gc_frame_newslot(call8549);
    if8510 = call8549;
  }
// compiled if node returning if8510 (depth = 3)
    gc_frame_newslot(if8510);
    if8504 = if8510;
  } else {
// Begin line 2726
  setline(2726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8550 = alloc_Boolean(0);
// compiled identifier node returning bool8550 (depth = 3)
    gc_frame_newslot(bool8550);
    if8504 = bool8550;
  }
// compiled if node returning if8504 (depth = 2)
  gc_frame_end(frame);
  return if8504;
}
Object meth_parser__apply8618(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8620 == NULL) {
    strlit8620 = alloc_String("rsquare");
    gc_root(strlit8620);
  }
// compiled string node returning strlit8620 (depth = 6)
  int op_slot_right_8619 = gc_frame_newslot(strlit8620);
// starting to compile member node (depth = 6)
  int callframe8622 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8623 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8622);
// compiled member node returning call8623 (depth = 6)
  int op_slot_left_8619 = gc_frame_newslot(call8623);
  params[0] = strlit8620;
  partcv[0] = 1;
  Object opresult8624 = callmethod(call8623, "==(1)", 1, partcv, params);
// compiled op node returning opresult8624 (depth = 5)
  gc_frame_end(frame);
  return opresult8624;
}
Object meth_parser__apply8698(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// Begin line 2761
  setline(2761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8702 == NULL) {
    strlit8702 = alloc_String("*");
    gc_root(strlit8702);
  }
// compiled string node returning strlit8702 (depth = 8)
  int op_slot_right_8701 = gc_frame_newslot(strlit8702);
// starting to compile member node (depth = 8)
  int callframe8704 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call8705 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8704);
// compiled member node returning call8705 (depth = 8)
  int op_slot_left_8701 = gc_frame_newslot(call8705);
  params[0] = strlit8702;
  partcv[0] = 1;
  Object opresult8706 = callmethod(call8705, "==(1)", 1, partcv, params);
// compiled op node returning opresult8706 (depth = 7)
  int op_slot_right_8700 = gc_frame_newslot(opresult8706);
// starting to compile call node (depth = 7)
  int callframe8708 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8709 == NULL) {
    strlit8709 = alloc_String("op");
    gc_root(strlit8709);
  }
// compiled string node returning strlit8709 (depth = 8)
  gc_frame_newslot(strlit8709);
// call case 4: self request
  params[0] = strlit8709;
  partcv[0] = 1;
  Object call8710 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8708);
// compiled call node returning call8710 (depth = 7)
  int op_slot_left_8700 = gc_frame_newslot(call8710);
  params[0] = opresult8706;
  partcv[0] = 1;
  Object opresult8711 = callmethod(call8710, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8711 (depth = 6)
  int op_slot_right_8699 = gc_frame_newslot(opresult8711);
// Begin line 2760
  setline(2760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8713 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8714 == NULL) {
    strlit8714 = alloc_String("identifier");
    gc_root(strlit8714);
  }
// compiled string node returning strlit8714 (depth = 7)
  gc_frame_newslot(strlit8714);
// call case 4: self request
  params[0] = strlit8714;
  partcv[0] = 1;
  Object call8715 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8713);
// compiled call node returning call8715 (depth = 6)
  int op_slot_left_8699 = gc_frame_newslot(call8715);
  params[0] = opresult8711;
  partcv[0] = 1;
  Object opresult8716 = callmethod(call8715, "||(1)", 1, partcv, params);
// compiled op node returning opresult8716 (depth = 5)
  gc_frame_end(frame);
  return opresult8716;
}
Object meth_parser__apply8719(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_id = getfromclosure(closure, 4);
  Object *var_part = getfromclosure(closure, 5);
  Object *var_comma = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// Begin line 2764
  setline(2764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8721 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8722 == NULL) {
    strlit8722 = alloc_String("op");
    gc_root(strlit8722);
  }
// compiled string node returning strlit8722 (depth = 7)
  gc_frame_newslot(strlit8722);
// call case 4: self request
  params[0] = strlit8722;
  partcv[0] = 1;
  Object call8723 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8721);
// compiled call node returning call8723 (depth = 6)
  Object if8720 = done;
  if (istrue(call8723)) {
// Begin line 2765
  setline(2765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe8724 = gc_frame_new();
// call case 4: self request
  Object call8725 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8724);
// compiled member node returning call8725 (depth = 6)
// Begin line 2766
  setline(2766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8726 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8728 == NULL) {
    strlit8728 = alloc_String(" an Iterable.");
    gc_root(strlit8728);
  }
// compiled string node returning strlit8728 (depth = 8)
  int op_slot_right_8727 = gc_frame_newslot(strlit8728);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe8731 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call8732 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8731);
// compiled member node returning call8732 (depth = 9)
  int op_slot_right_8730 = gc_frame_newslot(call8732);
// starting to compile string node (depth = 9)
  if (strlit8734 == NULL) {
    strlit8734 = alloc_String("variable length parameters (parameters prefixed by '*') are no longer part of Grace.  Consider making ");
    gc_root(strlit8734);
  }
// compiled string node returning strlit8734 (depth = 9)
  int op_slot_left_8730 = gc_frame_newslot(strlit8734);
  params[0] = call8732;
  partcv[0] = 1;
  Object opresult8735 = callmethod(strlit8734, "++(1)", 1, partcv, params);
// compiled op node returning opresult8735 (depth = 8)
  int op_slot_left_8727 = gc_frame_newslot(opresult8735);
  params[0] = strlit8728;
  partcv[0] = 1;
  Object opresult8736 = callmethod(opresult8735, "++(1)", 1, partcv, params);
// compiled op node returning opresult8736 (depth = 7)
  gc_frame_newslot(opresult8736);
// Begin line 2767
  setline(2767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe8737 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call8738 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8737);
// compiled member node returning call8738 (depth = 7)
  gc_frame_newslot(call8738);
// starting to compile member node (depth = 7)
  int callframe8739 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call8740 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8739);
// compiled member node returning call8740 (depth = 7)
  gc_frame_newslot(call8740);
// call case 6: other requests
// Begin line 2766
  setline(2766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult8736;
  params[1] = call8738;
  params[2] = call8740;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call8741 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe8726);
// compiled call node returning call8741 (depth = 6)
    gc_frame_newslot(call8741);
    if8720 = call8741;
  } else {
  }
// compiled if node returning if8720 (depth = 5)
// Begin line 2769
  setline(2769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8742 = gc_frame_new();
// call case 4: self request
  Object call8743 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8742);
// compiled member node returning call8743 (depth = 5)
// Begin line 2770
  setline(2770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8744 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  Object call8745 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe8744);
// compiled member node returning call8745 (depth = 6)
  *var_id = call8745;
  if (call8745 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 2771
  setline(2771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8747 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool8748 = alloc_Boolean(1);
// compiled identifier node returning bool8748 (depth = 6)
  gc_frame_newslot(bool8748);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_id (depth = 6)
  params[0] = bool8748;
  partcv[0] = 1;
  Object call8749 = callmethodflags(*var_id, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8747);
// compiled call node returning call8749 (depth = 5)
// Begin line 2772
  setline(2772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8750 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe8751 = gc_frame_new();
// call case 4: self request
  Object call8752 = callmethodflags(self, "optionalTypeAnnotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8751);
// compiled member node returning call8752 (depth = 6)
  gc_frame_newslot(call8752);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_id (depth = 6)
  params[0] = call8752;
  partcv[0] = 1;
  Object call8753 = callmethodflags(*var_id, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8750);
// compiled call node returning call8753 (depth = 5)
// Begin line 2773
  setline(2773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8754 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_id (depth = 6)
  gc_frame_newslot(*var_id);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8755 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call8756 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe8755);
// compiled member node returning call8756 (depth = 6)
  params[0] = *var_id;
  partcv[0] = 1;
  Object call8757 = callmethodflags(call8756, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8754);
// compiled call node returning call8757 (depth = 5)
// Begin line 2774
  setline(2774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8759 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8760 == NULL) {
    strlit8760 = alloc_String("comma");
    gc_root(strlit8760);
  }
// compiled string node returning strlit8760 (depth = 7)
  gc_frame_newslot(strlit8760);
// call case 4: self request
  params[0] = strlit8760;
  partcv[0] = 1;
  Object call8761 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8759);
// compiled call node returning call8761 (depth = 6)
  Object if8758 = done;
  if (istrue(call8761)) {
// Begin line 2775
  setline(2775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  *var_comma = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 2776
  setline(2776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe8763 = gc_frame_new();
// call case 4: self request
  Object call8764 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8763);
// compiled member node returning call8764 (depth = 6)
    gc_frame_newslot(call8764);
    if8758 = call8764;
  } else {
// Begin line 2785
  setline(2785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2777
  setline(2777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8767 == NULL) {
    strlit8767 = alloc_String("rparen");
    gc_root(strlit8767);
  }
// compiled string node returning strlit8767 (depth = 8)
  int op_slot_right_8766 = gc_frame_newslot(strlit8767);
// starting to compile member node (depth = 8)
  int callframe8769 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call8770 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8769);
// compiled member node returning call8770 (depth = 8)
  int op_slot_left_8766 = gc_frame_newslot(call8770);
  params[0] = strlit8767;
  partcv[0] = 1;
  Object opresult8771 = callmethod(call8770, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8771 (depth = 7)
  Object if8765 = done;
  if (istrue(opresult8771)) {
// Begin line 2778
  setline(2778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8774 == NULL) {
    strlit8774 = alloc_String("rparen");
    gc_root(strlit8774);
  }
// compiled string node returning strlit8774 (depth = 9)
  int op_slot_right_8773 = gc_frame_newslot(strlit8774);
// starting to compile member node (depth = 9)
  int callframe8776 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call8777 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8776);
// compiled member node returning call8777 (depth = 9)
  int op_slot_left_8773 = gc_frame_newslot(call8777);
  params[0] = strlit8774;
  partcv[0] = 1;
  Object opresult8778 = callmethod(call8777, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8778 (depth = 8)
  Object if8772 = done;
  if (istrue(opresult8778)) {
// Begin line 2779
  setline(2779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe8779 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe8780 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call8781 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8780);
// compiled member node returning call8781 (depth = 10)
  Object call8782 = callmethodflags(call8781, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8779);
// compiled member node returning call8782 (depth = 9)
  *var_suggestion = call8782;
  if (call8782 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 2780
  setline(2780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8783 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit8784 == NULL) {
    strlit8784 = alloc_String(")");
    gc_root(strlit8784);
  }
// compiled string node returning strlit8784 (depth = 9)
  gc_frame_newslot(strlit8784);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit8784;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8785 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8783);
// compiled call node returning call8785 (depth = 8)
// Begin line 2781
  setline(2781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8786 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit8787 == NULL) {
    strlit8787 = alloc_String("a part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit8787);
  }
// compiled string node returning strlit8787 (depth = 9)
  gc_frame_newslot(strlit8787);
// Begin line 2782
  setline(2782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe8788 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call8789 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8788);
// compiled member node returning call8789 (depth = 9)
  gc_frame_newslot(call8789);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe8791 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  Object call8792 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8791);
// compiled member node returning call8792 (depth = 10)
  int op_slot_right_8790 = gc_frame_newslot(call8792);
// starting to compile member node (depth = 10)
  int callframe8794 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  Object call8795 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8794);
// compiled member node returning call8795 (depth = 10)
  int op_slot_left_8790 = gc_frame_newslot(call8795);
  params[0] = call8792;
  partcv[0] = 1;
  Object sum8796 = callmethod(call8795, "+(1)", 1, partcv, params);
// compiled op node returning sum8796 (depth = 9)
  gc_frame_newslot(sum8796);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2781
  setline(2781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit8787;
  params[1] = call8789;
  params[2] = sum8796;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8797 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8786);
// compiled call node returning call8797 (depth = 8)
    gc_frame_newslot(call8797);
    if8772 = call8797;
  } else {
  }
// compiled if node returning if8772 (depth = 7)
    gc_frame_newslot(if8772);
    if8765 = if8772;
  } else {
  }
// compiled if node returning if8765 (depth = 6)
    gc_frame_newslot(if8765);
    if8758 = if8765;
  }
// compiled if node returning if8758 (depth = 5)
  gc_frame_end(frame);
  return if8758;
}
Object meth_parser__apply_40_1_41_8813(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe8816 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call8817 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8816);
// compiled member node returning call8817 (depth = 9)
  int op_slot_right_8815 = gc_frame_newslot(call8817);
// starting to compile member node (depth = 9)
  int callframe8819 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call8820 = callmethodflags(*var_t, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8819);
// compiled member node returning call8820 (depth = 9)
  int op_slot_left_8815 = gc_frame_newslot(call8820);
  params[0] = call8817;
  partcv[0] = 1;
  Object opresult8821 = callmethod(call8820, "==(1)", 1, partcv, params);
// compiled op node returning opresult8821 (depth = 8)
  int op_slot_right_8814 = gc_frame_newslot(opresult8821);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8824 == NULL) {
    strlit8824 = alloc_String("rparen");
    gc_root(strlit8824);
  }
// compiled string node returning strlit8824 (depth = 9)
  int op_slot_right_8823 = gc_frame_newslot(strlit8824);
// starting to compile member node (depth = 9)
  int callframe8826 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  Object call8827 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8826);
// compiled member node returning call8827 (depth = 9)
  int op_slot_left_8823 = gc_frame_newslot(call8827);
  params[0] = strlit8824;
  partcv[0] = 1;
  Object opresult8828 = callmethod(call8827, "==(1)", 1, partcv, params);
// compiled op node returning opresult8828 (depth = 8)
  int op_slot_left_8814 = gc_frame_newslot(opresult8828);
  params[0] = opresult8821;
  partcv[0] = 1;
  Object opresult8829 = callmethod(opresult8828, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8829 (depth = 7)
  gc_frame_end(frame);
  return opresult8829;
}
Object meth_parser_methodsignature_40_1_41_8551(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 64, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodsignature(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method methodsignature(_)");
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodsignature(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sameline = &(stackframe->slots[0]);
  *var_sameline = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part methodsignature(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_startToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startToken");
  Object *var_part = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "part");
  Object *var_result = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "result");
  Object *var_lparen = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "lparen");
  Object *var_id = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "id");
  Object *var_comma = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "comma");
  Object *var_rparen = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "rparen");
// Begin line 2732
  setline(2732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8555 == NULL) {
    strlit8555 = alloc_String("lsquare");
    gc_root(strlit8555);
  }
// compiled string node returning strlit8555 (depth = 5)
  int op_slot_right_8554 = gc_frame_newslot(strlit8555);
// starting to compile member node (depth = 5)
  int callframe8557 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call8558 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8557);
// compiled member node returning call8558 (depth = 5)
  int op_slot_left_8554 = gc_frame_newslot(call8558);
  params[0] = strlit8555;
  partcv[0] = 1;
  Object opresult8559 = callmethod(call8558, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8559 (depth = 4)
  int op_slot_right_8553 = gc_frame_newslot(opresult8559);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8563 == NULL) {
    strlit8563 = alloc_String("op");
    gc_root(strlit8563);
  }
// compiled string node returning strlit8563 (depth = 6)
  int op_slot_right_8562 = gc_frame_newslot(strlit8563);
// starting to compile member node (depth = 6)
  int callframe8565 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8566 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8565);
// compiled member node returning call8566 (depth = 6)
  int op_slot_left_8562 = gc_frame_newslot(call8566);
  params[0] = strlit8563;
  partcv[0] = 1;
  Object opresult8567 = callmethod(call8566, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8567 (depth = 5)
  int op_slot_right_8561 = gc_frame_newslot(opresult8567);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8570 == NULL) {
    strlit8570 = alloc_String("identifier");
    gc_root(strlit8570);
  }
// compiled string node returning strlit8570 (depth = 6)
  int op_slot_right_8569 = gc_frame_newslot(strlit8570);
// starting to compile member node (depth = 6)
  int callframe8572 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8573 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8572);
// compiled member node returning call8573 (depth = 6)
  int op_slot_left_8569 = gc_frame_newslot(call8573);
  params[0] = strlit8570;
  partcv[0] = 1;
  Object opresult8574 = callmethod(call8573, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8574 (depth = 5)
  int op_slot_left_8561 = gc_frame_newslot(opresult8574);
  params[0] = opresult8567;
  partcv[0] = 1;
  Object opresult8575 = callmethod(opresult8574, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8575 (depth = 4)
  int op_slot_left_8553 = gc_frame_newslot(opresult8575);
  params[0] = opresult8559;
  partcv[0] = 1;
  Object opresult8576 = callmethod(opresult8575, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8576 (depth = 3)
  Object if8552 = done;
  if (istrue(opresult8576)) {
// Begin line 2733
  setline(2733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8577 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8578 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call8579 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8578);
// compiled member node returning call8579 (depth = 5)
  Object call8580 = callmethodflags(call8579, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8577);
// compiled member node returning call8580 (depth = 4)
  *var_suggestion = call8580;
  if (call8580 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2734
  setline(2734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8581 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8582 == NULL) {
    strlit8582 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit8582);
  }
// compiled string node returning strlit8582 (depth = 4)
  gc_frame_newslot(strlit8582);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit8582;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8583 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8581);
// compiled call node returning call8583 (depth = 3)
// Begin line 2735
  setline(2735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8584 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8585 == NULL) {
    strlit8585 = alloc_String("a method name must start with an identifier, or be an operator.");
    gc_root(strlit8585);
  }
// compiled string node returning strlit8585 (depth = 4)
  gc_frame_newslot(strlit8585);
// Begin line 2736
  setline(2736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe8586 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call8587 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8586);
// compiled member node returning call8587 (depth = 4)
  gc_frame_newslot(call8587);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8589 = alloc_Float64(1);
// compiled num node returning num8589 (depth = 5)
  int op_slot_right_8588 = gc_frame_newslot(num8589);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8592 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call8593 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8592);
// compiled member node returning call8593 (depth = 6)
  int op_slot_right_8591 = gc_frame_newslot(call8593);
// starting to compile member node (depth = 6)
  int callframe8595 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call8596 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8595);
// compiled member node returning call8596 (depth = 6)
  int op_slot_left_8591 = gc_frame_newslot(call8596);
  params[0] = call8593;
  partcv[0] = 1;
  Object sum8597 = callmethod(call8596, "+(1)", 1, partcv, params);
// compiled op node returning sum8597 (depth = 5)
  int op_slot_left_8588 = gc_frame_newslot(sum8597);
  params[0] = num8589;
  partcv[0] = 1;
  Object sum8598 = callmethod(sum8597, "+(1)", 1, partcv, params);
// compiled op node returning sum8598 (depth = 4)
  gc_frame_newslot(sum8598);
// Begin line 2737
  setline(2737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2735
  setline(2735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit8585;
  params[1] = call8587;
  params[2] = sum8598;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8599 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8584);
// compiled call node returning call8599 (depth = 3)
    gc_frame_newslot(call8599);
    if8552 = call8599;
  } else {
  }
// compiled if node returning if8552 (depth = 2)
// Begin line 2739
  setline(2739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_startToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2740
  setline(2740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8600 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8601 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startToken (depth = 5)
  Object call8602 = callmethodflags(*var_startToken, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8601);
// compiled member node returning call8602 (depth = 4)
  gc_frame_newslot(call8602);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8603 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call8604 = callmethodflags(*var_ast, "signaturePart", 0, partcv, params, 0);
  gc_frame_end(callframe8603);
// compiled member node returning call8604 (depth = 4)
  params[0] = call8602;
  partcv[0] = 1;
  Object call8605 = callmethodflags(call8604, "partName(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8600);
// compiled call node returning call8605 (depth = 3)
  *var_part = call8605;
  if (call8605 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2741
  setline(2741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe8606 = gc_frame_new();
// call case 4: self request
  Object call8607 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8606);
// compiled member node returning call8607 (depth = 2)
// Begin line 2742
  setline(2742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8608 = gc_frame_new();
// starting to compile array node (depth = 4)
  Object array8609 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = *var_part;
  partcv[0] = 1;
  callmethodflags(array8609, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array8609 (depth = 4)
  gc_frame_newslot(array8609);
// starting to compile array node (depth = 4)
  Object array8610 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8610 (depth = 4)
  gc_frame_newslot(array8610);
// starting to compile identifier node (depth = 4)
  Object bool8611 = alloc_Boolean(0);
// compiled identifier node returning bool8611 (depth = 4)
  gc_frame_newslot(bool8611);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8612 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call8613 = callmethodflags(*var_ast, "methodNode", 0, partcv, params, 0);
  gc_frame_end(callframe8612);
// compiled member node returning call8613 (depth = 4)
  params[0] = array8609;
  params[1] = array8610;
  params[2] = bool8611;
  partcv[0] = 3;
  Object call8614 = callmethodflags(call8613, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe8608);
// compiled call node returning call8614 (depth = 3)
  *var_result = call8614;
  if (call8614 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2743
  setline(2743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile block node (depth = 4)
  Object block8617 = alloc_Block(NULL, NULL, "parser", 2743);
  gc_frame_newslot(block8617);
// method "_apply"
  block_savedest(block8617);
  Object closure8618 = createclosure(2, "_apply");
  setclosureframe(closure8618, stackframe);
  addtoclosure(closure8618, var_sym);
  addtoclosure(closure8618, selfslot);
  struct UserObject *uo8618 = (struct UserObject*)block8617;
  uo8618->data[0] = (Object)closure8618;
  Method *meth_meth_parser__apply8618 = addmethod2pos(block8617, "_apply", &meth_parser__apply8618, 0);
  int argcv_meth_parser__apply8618[] = {0};
  meth_meth_parser__apply8618->type = alloc_MethodType(1, argcv_meth_parser__apply8618);
  meth_meth_parser__apply8618->definitionModule = modulename;
  meth_meth_parser__apply8618->definitionLine = 3399;
// compiled block node returning block8617 (depth = 4)
  int op_slot_right_8616 = gc_frame_newslot(block8617);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8628 == NULL) {
    strlit8628 = alloc_String("[");
    gc_root(strlit8628);
  }
// compiled string node returning strlit8628 (depth = 5)
  int op_slot_right_8627 = gc_frame_newslot(strlit8628);
// starting to compile member node (depth = 5)
  int callframe8630 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startToken (depth = 6)
  Object call8631 = callmethodflags(*var_startToken, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8630);
// compiled member node returning call8631 (depth = 5)
  int op_slot_left_8627 = gc_frame_newslot(call8631);
  params[0] = strlit8628;
  partcv[0] = 1;
  Object opresult8632 = callmethod(call8631, "==(1)", 1, partcv, params);
// compiled op node returning opresult8632 (depth = 4)
  int op_slot_left_8616 = gc_frame_newslot(opresult8632);
  params[0] = block8617;
  partcv[0] = 1;
  Object opresult8633 = callmethod(opresult8632, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8633 (depth = 3)
  Object if8615 = done;
  if (istrue(opresult8633)) {
// Begin line 2744
  setline(2744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8634 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8635 == NULL) {
    strlit8635 = alloc_String("methods named '[]' and '[]:=' are no longer part of Grace.");
    gc_root(strlit8635);
  }
// compiled string node returning strlit8635 (depth = 4)
  gc_frame_newslot(strlit8635);
// Begin line 2745
  setline(2745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe8636 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call8637 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8636);
// compiled member node returning call8637 (depth = 4)
  gc_frame_newslot(call8637);
// starting to compile member node (depth = 4)
  int callframe8638 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call8639 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8638);
// compiled member node returning call8639 (depth = 4)
  gc_frame_newslot(call8639);
// starting to compile member node (depth = 4)
  int callframe8640 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call8641 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8640);
// compiled member node returning call8641 (depth = 4)
  gc_frame_newslot(call8641);
// call case 6: other requests
// Begin line 2744
  setline(2744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit8635;
  params[1] = call8637;
  params[2] = call8639;
  params[3] = call8641;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call8642 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe8634);
// compiled call node returning call8642 (depth = 3)
    gc_frame_newslot(call8642);
    if8615 = call8642;
  } else {
  }
// compiled if node returning if8615 (depth = 2)
// Begin line 2747
  setline(2747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8644 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8645 == NULL) {
    strlit8645 = alloc_String("lgeneric");
    gc_root(strlit8645);
  }
// compiled string node returning strlit8645 (depth = 4)
  gc_frame_newslot(strlit8645);
// call case 4: self request
  params[0] = strlit8645;
  partcv[0] = 1;
  Object call8646 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8644);
// compiled call node returning call8646 (depth = 3)
  Object if8643 = done;
  if (istrue(call8646)) {
// starting to compile call node (depth = 3)
  int callframe8647 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8648 = gc_frame_new();
// call case 4: self request
  Object call8649 = callmethodflags(self, "typeparameters", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8648);
// compiled member node returning call8649 (depth = 4)
  gc_frame_newslot(call8649);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = call8649;
  partcv[0] = 1;
  Object call8650 = callmethodflags(*var_result, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8647);
// compiled call node returning call8650 (depth = 3)
    gc_frame_newslot(call8650);
    if8643 = call8650;
  } else {
  }
// compiled if node returning if8643 (depth = 2)
// Begin line 2748
  setline(2748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8652 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8653 == NULL) {
    strlit8653 = alloc_String("bind");
    gc_root(strlit8653);
  }
// compiled string node returning strlit8653 (depth = 4)
  gc_frame_newslot(strlit8653);
// call case 4: self request
  params[0] = strlit8653;
  partcv[0] = 1;
  Object call8654 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8652);
// compiled call node returning call8654 (depth = 3)
  Object if8651 = done;
  if (istrue(call8654)) {
// Begin line 2749
  setline(2749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8655 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8657 == NULL) {
    strlit8657 = alloc_String(":=");
    gc_root(strlit8657);
  }
// compiled string node returning strlit8657 (depth = 5)
  int op_slot_right_8656 = gc_frame_newslot(strlit8657);
// starting to compile member node (depth = 5)
  int callframe8659 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  Object call8660 = callmethodflags(*var_part, "name", 0, partcv, params, 0);
  gc_frame_end(callframe8659);
// compiled member node returning call8660 (depth = 5)
  int op_slot_left_8656 = gc_frame_newslot(call8660);
  params[0] = strlit8657;
  partcv[0] = 1;
  Object opresult8661 = callmethod(call8660, "++(1)", 1, partcv, params);
// compiled op node returning opresult8661 (depth = 4)
  gc_frame_newslot(opresult8661);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = opresult8661;
  partcv[0] = 1;
  Object call8662 = callmethodflags(*var_part, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8655);
// compiled call node returning call8662 (depth = 3)
// Begin line 2750
  setline(2750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8663 = gc_frame_new();
// call case 4: self request
  Object call8664 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8663);
// compiled member node returning call8664 (depth = 3)
    gc_frame_newslot(call8664);
    if8651 = call8664;
  } else {
// Begin line 2755
  setline(2755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2751
  setline(2751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8668 == NULL) {
    strlit8668 = alloc_String("prefix");
    gc_root(strlit8668);
  }
// compiled string node returning strlit8668 (depth = 6)
  int op_slot_right_8667 = gc_frame_newslot(strlit8668);
// starting to compile member node (depth = 6)
  int callframe8670 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_startToken (depth = 7)
  Object call8671 = callmethodflags(*var_startToken, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8670);
// compiled member node returning call8671 (depth = 6)
  int op_slot_left_8667 = gc_frame_newslot(call8671);
  params[0] = strlit8668;
  partcv[0] = 1;
  Object opresult8672 = callmethod(call8671, "==(1)", 1, partcv, params);
// compiled op node returning opresult8672 (depth = 5)
  int op_slot_right_8666 = gc_frame_newslot(opresult8672);
// starting to compile call node (depth = 5)
  int callframe8674 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8675 == NULL) {
    strlit8675 = alloc_String("op");
    gc_root(strlit8675);
  }
// compiled string node returning strlit8675 (depth = 6)
  gc_frame_newslot(strlit8675);
// call case 4: self request
  params[0] = strlit8675;
  partcv[0] = 1;
  Object call8676 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8674);
// compiled call node returning call8676 (depth = 5)
  int op_slot_left_8666 = gc_frame_newslot(call8676);
  params[0] = opresult8672;
  partcv[0] = 1;
  Object opresult8677 = callmethod(call8676, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8677 (depth = 4)
  Object if8665 = done;
  if (istrue(opresult8677)) {
// Begin line 2752
  setline(2752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8678 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8680 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8681 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8680);
// compiled member node returning call8681 (depth = 6)
  int op_slot_right_8679 = gc_frame_newslot(call8681);
// starting to compile member node (depth = 6)
  int callframe8683 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call8684 = callmethodflags(*var_part, "name", 0, partcv, params, 0);
  gc_frame_end(callframe8683);
// compiled member node returning call8684 (depth = 6)
  int op_slot_left_8679 = gc_frame_newslot(call8684);
  params[0] = call8681;
  partcv[0] = 1;
  Object opresult8685 = callmethod(call8684, "++(1)", 1, partcv, params);
// compiled op node returning opresult8685 (depth = 5)
  gc_frame_newslot(opresult8685);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = opresult8685;
  partcv[0] = 1;
  Object call8686 = callmethodflags(*var_part, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8678);
// compiled call node returning call8686 (depth = 4)
// Begin line 2753
  setline(2753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe8687 = gc_frame_new();
// call case 4: self request
  Object call8688 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8687);
// compiled member node returning call8688 (depth = 4)
    gc_frame_newslot(call8688);
    if8665 = call8688;
  } else {
  }
// compiled if node returning if8665 (depth = 3)
    gc_frame_newslot(if8665);
    if8651 = if8665;
  }
// compiled if node returning if8651 (depth = 2)
// Begin line 2755
  setline(2755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8690 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8691 == NULL) {
    strlit8691 = alloc_String("lparen");
    gc_root(strlit8691);
  }
// compiled string node returning strlit8691 (depth = 4)
  gc_frame_newslot(strlit8691);
// call case 4: self request
  params[0] = strlit8691;
  partcv[0] = 1;
  Object call8692 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8690);
// compiled call node returning call8692 (depth = 3)
  Object if8689 = done;
  if (istrue(call8692)) {
// Begin line 2756
  setline(2756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_lparen = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2757
  setline(2757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8693 = gc_frame_new();
// call case 4: self request
  Object call8694 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8693);
// compiled member node returning call8694 (depth = 3)
// Begin line 2758
  setline(2758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_id = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2759
  setline(2759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool8695 = alloc_Boolean(0);
// compiled identifier node returning bool8695 (depth = 4)
  *var_comma = bool8695;
  if (bool8695 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2760
  setline(2760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8696 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block8697 = alloc_Block(NULL, NULL, "parser", 2760);
  gc_frame_newslot(block8697);
// method "_apply"
  block_savedest(block8697);
  Object closure8698 = createclosure(2, "_apply");
  setclosureframe(closure8698, stackframe);
  addtoclosure(closure8698, var_sym);
  addtoclosure(closure8698, selfslot);
  struct UserObject *uo8698 = (struct UserObject*)block8697;
  uo8698->data[0] = (Object)closure8698;
  Method *meth_meth_parser__apply8698 = addmethod2pos(block8697, "_apply", &meth_parser__apply8698, 0);
  int argcv_meth_parser__apply8698[] = {0};
  meth_meth_parser__apply8698->type = alloc_MethodType(1, argcv_meth_parser__apply8698);
  meth_meth_parser__apply8698->definitionModule = modulename;
  meth_meth_parser__apply8698->definitionLine = 3399;
// compiled block node returning block8697 (depth = 4)
  gc_frame_newslot(block8697);
// Begin line 2761
  setline(2761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block8718 = alloc_Block(NULL, NULL, "parser", 2761);
  gc_frame_newslot(block8718);
// method "_apply"
  block_savedest(block8718);
  Object closure8719 = createclosure(8, "_apply");
  setclosureframe(closure8719, stackframe);
  addtoclosure(closure8719, var_sym);
  addtoclosure(closure8719, var_lastToken);
  addtoclosure(closure8719, var_errormessages);
  addtoclosure(closure8719, var_values);
  addtoclosure(closure8719, var_id);
  addtoclosure(closure8719, var_part);
  addtoclosure(closure8719, var_comma);
  addtoclosure(closure8719, selfslot);
  struct UserObject *uo8719 = (struct UserObject*)block8718;
  uo8719->data[0] = (Object)closure8719;
  Method *meth_meth_parser__apply8719 = addmethod2pos(block8718, "_apply", &meth_parser__apply8719, 0);
  int argcv_meth_parser__apply8719[] = {0};
  meth_meth_parser__apply8719->type = alloc_MethodType(1, argcv_meth_parser__apply8719);
  meth_meth_parser__apply8719->definitionModule = modulename;
  meth_meth_parser__apply8719->definitionLine = 3399;
// compiled block node returning block8718 (depth = 4)
  gc_frame_newslot(block8718);
// call case 5: prelude request
  params[0] = block8697;
  params[1] = block8718;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8799 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8696);
// compiled call node returning call8799 (depth = 3)
// Begin line 2786
  setline(2786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8802 == NULL) {
    strlit8802 = alloc_String("rparen");
    gc_root(strlit8802);
  }
// compiled string node returning strlit8802 (depth = 5)
  int op_slot_right_8801 = gc_frame_newslot(strlit8802);
// starting to compile member node (depth = 5)
  int callframe8804 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call8805 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8804);
// compiled member node returning call8805 (depth = 5)
  int op_slot_left_8801 = gc_frame_newslot(call8805);
  params[0] = strlit8802;
  partcv[0] = 1;
  Object opresult8806 = callmethod(call8805, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8806 (depth = 4)
  Object if8800 = done;
  if (istrue(opresult8806)) {
// Begin line 2787
  setline(2787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8807 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8808 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call8809 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8808);
// compiled member node returning call8809 (depth = 6)
  Object call8810 = callmethodflags(call8809, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8807);
// compiled member node returning call8810 (depth = 5)
  *var_suggestion = call8810;
  if (call8810 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2788
  setline(2788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8811 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8812 = alloc_Block(NULL, NULL, "parser", 2788);
  gc_frame_newslot(block8812);
// method "_apply(_)"
  block_savedest(block8812);
  Object closure8813 = createclosure(2, "_apply(1)");
  setclosureframe(closure8813, stackframe);
  addtoclosure(closure8813, var_lastToken);
  addtoclosure(closure8813, selfslot);
  struct UserObject *uo8813 = (struct UserObject*)block8812;
  uo8813->data[0] = (Object)closure8813;
  Method *meth_meth_parser__apply_40_1_41_8813 = addmethod2pos(block8812, "_apply(1)", &meth_parser__apply_40_1_41_8813, 0);
  int argcv_meth_parser__apply_40_1_41_8813[] = {1};
  meth_meth_parser__apply_40_1_41_8813->type = alloc_MethodType(1, argcv_meth_parser__apply_40_1_41_8813);
  meth_meth_parser__apply_40_1_41_8813->definitionModule = modulename;
  meth_meth_parser__apply_40_1_41_8813->definitionLine = 3399;
// compiled block node returning block8812 (depth = 6)
  gc_frame_newslot(block8812);
// call case 4: self request
  params[0] = block8812;
  partcv[0] = 1;
  Object call8831 = callmethodflags(self, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8811);
// compiled call node returning call8831 (depth = 5)
  *var_rparen = call8831;
  if (call8831 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2789
  setline(2789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_rparen (depth = 6)
  int op_slot_right_8833 = gc_frame_newslot(*var_rparen);
// starting to compile identifier node (depth = 6)
  Object bool8835 = alloc_Boolean(0);
// compiled identifier node returning bool8835 (depth = 6)
  int op_slot_left_8833 = gc_frame_newslot(bool8835);
  params[0] = *var_rparen;
  partcv[0] = 1;
  Object opresult8836 = callmethod(bool8835, "==(1)", 1, partcv, params);
// compiled op node returning opresult8836 (depth = 5)
  Object if8832 = done;
  if (istrue(opresult8836)) {
// Begin line 2790
  setline(2790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8837 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 6)
  if (strlit8838 == NULL) {
    strlit8838 = alloc_String(")");
    gc_root(strlit8838);
  }
// compiled string node returning strlit8838 (depth = 6)
  gc_frame_newslot(strlit8838);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = strlit8838;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8839 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8837);
// compiled call node returning call8839 (depth = 5)
    gc_frame_newslot(call8839);
    if8832 = call8839;
  } else {
// Begin line 2792
  setline(2792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8840 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call8841 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8840);
// compiled call node returning call8841 (depth = 5)
    gc_frame_newslot(call8841);
    if8832 = call8841;
  }
// compiled if node returning if8832 (depth = 4)
// Begin line 2794
  setline(2794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8842 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8843 == NULL) {
    strlit8843 = alloc_String("a part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit8843);
  }
// compiled string node returning strlit8843 (depth = 5)
  gc_frame_newslot(strlit8843);
// Begin line 2795
  setline(2795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8844 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call8845 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8844);
// compiled member node returning call8845 (depth = 5)
  gc_frame_newslot(call8845);
// starting to compile member node (depth = 5)
  int callframe8846 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call8847 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8846);
// compiled member node returning call8847 (depth = 5)
  gc_frame_newslot(call8847);
// starting to compile member node (depth = 5)
  int callframe8848 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call8849 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8848);
// compiled member node returning call8849 (depth = 5)
  gc_frame_newslot(call8849);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2794
  setline(2794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8843;
  params[1] = call8845;
  params[2] = call8847;
  params[3] = call8849;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call8850 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8842);
// compiled call node returning call8850 (depth = 4)
    gc_frame_newslot(call8850);
    if8800 = call8850;
  } else {
  }
// compiled if node returning if8800 (depth = 3)
// Begin line 2797
  setline(2797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8853 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  Object call8854 = callmethodflags(*var_part, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8853);
// compiled member node returning call8854 (depth = 5)
  int op_slot_right_8852 = gc_frame_newslot(call8854);
// starting to compile member node (depth = 5)
  int callframe8856 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call8857 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8856);
// compiled member node returning call8857 (depth = 5)
  int op_slot_left_8852 = gc_frame_newslot(call8857);
  params[0] = call8854;
  partcv[0] = 1;
  Object opresult8858 = callmethod(call8857, "==(1)", 1, partcv, params);
// compiled op node returning opresult8858 (depth = 4)
  Object if8851 = done;
  if (istrue(opresult8858)) {
// Begin line 2798
  setline(2798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8859 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8861 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call8862 = callmethodflags(*var_part, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8861);
// compiled member node returning call8862 (depth = 6)
  int op_slot_right_8860 = gc_frame_newslot(call8862);
// starting to compile member node (depth = 6)
  int callframe8864 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call8865 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8864);
// compiled member node returning call8865 (depth = 6)
  int op_slot_left_8860 = gc_frame_newslot(call8865);
  params[0] = call8862;
  partcv[0] = 1;
  Object diff8866 = callmethod(call8865, "-(1)", 1, partcv, params);
// compiled op node returning diff8866 (depth = 5)
  gc_frame_newslot(diff8866);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = diff8866;
  partcv[0] = 1;
  Object call8867 = callmethodflags(*var_part, "lineLength:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8859);
// compiled call node returning call8867 (depth = 4)
    gc_frame_newslot(call8867);
    if8851 = call8867;
  } else {
  }
// compiled if node returning if8851 (depth = 3)
// Begin line 2800
  setline(2800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8868 = gc_frame_new();
// call case 4: self request
  Object call8869 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8868);
// compiled member node returning call8869 (depth = 3)
// Begin line 2801
  setline(2801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 2802
  setline(2802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8872 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8873 == NULL) {
    strlit8873 = alloc_String("identifier");
    gc_root(strlit8873);
  }
// compiled string node returning strlit8873 (depth = 6)
  gc_frame_newslot(strlit8873);
// call case 4: self request
  params[0] = strlit8873;
  partcv[0] = 1;
  Object call8874 = callmethodflags(self, "acceptSameLine(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8872);
// compiled call node returning call8874 (depth = 5)
  int op_slot_right_8871 = gc_frame_newslot(call8874);
// Begin line 2801
  setline(2801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8877 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8878 == NULL) {
    strlit8878 = alloc_String("identifier");
    gc_root(strlit8878);
  }
// compiled string node returning strlit8878 (depth = 7)
  gc_frame_newslot(strlit8878);
// call case 4: self request
  params[0] = strlit8878;
  partcv[0] = 1;
  Object call8879 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8877);
// compiled call node returning call8879 (depth = 6)
  int op_slot_right_8876 = gc_frame_newslot(call8879);
// starting to compile call node (depth = 6)
  int callframe8881 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sameline (depth = 7)
  partcv[0] = 0;
  Object call8882 = callmethodflags(*var_sameline, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe8881);
// compiled call node returning call8882 (depth = 6)
  int op_slot_left_8876 = gc_frame_newslot(call8882);
  params[0] = call8879;
  partcv[0] = 1;
  Object opresult8883 = callmethod(call8882, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8883 (depth = 5)
  int op_slot_left_8871 = gc_frame_newslot(opresult8883);
  params[0] = call8874;
  partcv[0] = 1;
  Object opresult8884 = callmethod(opresult8883, "||(1)", 1, partcv, params);
// compiled op node returning opresult8884 (depth = 4)
  Object if8870 = done;
  if (istrue(opresult8884)) {
// Begin line 2805
  setline(2805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8885 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  gc_frame_newslot(*var_result);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sameline (depth = 5)
  gc_frame_newslot(*var_sameline);
// call case 4: self request
  params[0] = *var_result;
  params[1] = *var_sameline;
  partcv[0] = 2;
  Object call8886 = callmethodflags(self, "methodDecRest(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8885);
// compiled call node returning call8886 (depth = 4)
    gc_frame_newslot(call8886);
    if8870 = call8886;
  } else {
  }
// compiled if node returning if8870 (depth = 3)
    gc_frame_newslot(if8870);
    if8689 = if8870;
  } else {
  }
// compiled if node returning if8689 (depth = 2)
// Begin line 2808
  setline(2808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8888 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8889 == NULL) {
    strlit8889 = alloc_String("arrow");
    gc_root(strlit8889);
  }
// compiled string node returning strlit8889 (depth = 4)
  gc_frame_newslot(strlit8889);
// call case 4: self request
  params[0] = strlit8889;
  partcv[0] = 1;
  Object call8890 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8888);
// compiled call node returning call8890 (depth = 3)
  Object if8887 = done;
  if (istrue(call8890)) {
// Begin line 2810
  setline(2810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8891 = gc_frame_new();
// call case 4: self request
  Object call8892 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8891);
// compiled member node returning call8892 (depth = 3)
// Begin line 2811
  setline(2811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8893 = gc_frame_new();
// call case 4: self request
  Object call8894 = callmethodflags(self, "typeexpression", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8893);
// compiled member node returning call8894 (depth = 3)
// Begin line 2812
  setline(2812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8895 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8896 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call8897 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe8896);
// compiled member node returning call8897 (depth = 4)
  gc_frame_newslot(call8897);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = call8897;
  partcv[0] = 1;
  Object call8898 = callmethodflags(*var_result, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8895);
// compiled call node returning call8898 (depth = 3)
    gc_frame_newslot(call8898);
    if8887 = call8898;
  } else {
  }
// compiled if node returning if8887 (depth = 2)
// Begin line 2814
  setline(2814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_parser__apply8905(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe8906 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8907 == NULL) {
    strlit8907 = alloc_String("identifier");
    gc_root(strlit8907);
  }
// compiled string node returning strlit8907 (depth = 5)
  gc_frame_newslot(strlit8907);
// call case 4: self request
  params[0] = strlit8907;
  partcv[0] = 1;
  Object call8908 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8906);
// compiled call node returning call8908 (depth = 4)
  gc_frame_end(frame);
  return call8908;
}
Object meth_parser__apply8911(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_typeIds = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_id = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "id");
// Begin line 2821
  setline(2821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe8912 = gc_frame_new();
// call case 4: self request
  Object call8913 = callmethodflags(self, "identifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8912);
// compiled member node returning call8913 (depth = 4)
// Begin line 2822
  setline(2822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8914 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call8915 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe8914);
// compiled member node returning call8915 (depth = 5)
  *var_id = call8915;
  if (call8915 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2823
  setline(2823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8916 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool8917 = alloc_Boolean(1);
// compiled identifier node returning bool8917 (depth = 5)
  gc_frame_newslot(bool8917);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_id (depth = 5)
  params[0] = bool8917;
  partcv[0] = 1;
  Object call8918 = callmethodflags(*var_id, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8916);
// compiled call node returning call8918 (depth = 4)
// Begin line 2824
  setline(2824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8919 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_id (depth = 5)
  gc_frame_newslot(*var_id);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeIds (depth = 5)
  params[0] = *var_id;
  partcv[0] = 1;
  Object call8920 = callmethodflags(*var_typeIds, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8919);
// compiled call node returning call8920 (depth = 4)
// Begin line 2825
  setline(2825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8922 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8923 == NULL) {
    strlit8923 = alloc_String("comma");
    gc_root(strlit8923);
  }
// compiled string node returning strlit8923 (depth = 6)
  gc_frame_newslot(strlit8923);
// call case 4: self request
  params[0] = strlit8923;
  partcv[0] = 1;
  Object call8924 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8922);
// compiled call node returning call8924 (depth = 5)
  Object if8921 = done;
  if (istrue(call8924)) {
// Begin line 2826
  setline(2826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8925 = gc_frame_new();
// call case 4: self request
  Object call8926 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8925);
// compiled member node returning call8926 (depth = 5)
    gc_frame_newslot(call8926);
    if8921 = call8926;
  } else {
  }
// compiled if node returning if8921 (depth = 4)
  gc_frame_end(frame);
  return if8921;
}
Object meth_parser__apply_40_1_41_8931(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe8932 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool8933 = alloc_Boolean(1);
// compiled identifier node returning bool8933 (depth = 5)
  gc_frame_newslot(bool8933);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  params[0] = bool8933;
  partcv[0] = 1;
  Object call8934 = callmethodflags(*var_each, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8932);
// compiled call node returning call8934 (depth = 4)
  gc_frame_end(frame);
  return call8934;
}
Object meth_parser_typeparameters8899(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 65, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeparameters");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_typeIds = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "typeIds");
  Object *var_result = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "result");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// Begin line 2818
  setline(2818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe8900 = gc_frame_new();
// call case 4: self request
  Object call8901 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8900);
// compiled member node returning call8901 (depth = 2)
// Begin line 2819
  setline(2819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array8902 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8902 (depth = 3)
  *var_typeIds = array8902;
  if (array8902 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2820
  setline(2820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8903 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block8904 = alloc_Block(NULL, NULL, "parser", 2820);
  gc_frame_newslot(block8904);
// method "_apply"
  block_savedest(block8904);
  Object closure8905 = createclosure(1, "_apply");
  setclosureframe(closure8905, stackframe);
  addtoclosure(closure8905, selfslot);
  struct UserObject *uo8905 = (struct UserObject*)block8904;
  uo8905->data[0] = (Object)closure8905;
  Method *meth_meth_parser__apply8905 = addmethod2pos(block8904, "_apply", &meth_parser__apply8905, 0);
  int argcv_meth_parser__apply8905[] = {0};
  meth_meth_parser__apply8905->type = alloc_MethodType(1, argcv_meth_parser__apply8905);
  meth_meth_parser__apply8905->definitionModule = modulename;
  meth_meth_parser__apply8905->definitionLine = 3399;
// compiled block node returning block8904 (depth = 3)
  gc_frame_newslot(block8904);
// starting to compile block node (depth = 3)
  Object block8910 = alloc_Block(NULL, NULL, "parser", 2820);
  gc_frame_newslot(block8910);
// method "_apply"
  block_savedest(block8910);
  Object closure8911 = createclosure(3, "_apply");
  setclosureframe(closure8911, stackframe);
  addtoclosure(closure8911, var_values);
  addtoclosure(closure8911, var_typeIds);
  addtoclosure(closure8911, selfslot);
  struct UserObject *uo8911 = (struct UserObject*)block8910;
  uo8911->data[0] = (Object)closure8911;
  Method *meth_meth_parser__apply8911 = addmethod2pos(block8910, "_apply", &meth_parser__apply8911, 0);
  int argcv_meth_parser__apply8911[] = {0};
  meth_meth_parser__apply8911->type = alloc_MethodType(1, argcv_meth_parser__apply8911);
  meth_meth_parser__apply8911->definitionModule = modulename;
  meth_meth_parser__apply8911->definitionLine = 3399;
// compiled block node returning block8910 (depth = 3)
  gc_frame_newslot(block8910);
// call case 5: prelude request
  params[0] = block8904;
  params[1] = block8910;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8928 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8903);
// compiled call node returning call8928 (depth = 2)
// Begin line 2829
  setline(2829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8929 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block8930 = alloc_Block(NULL, NULL, "parser", 2829);
  gc_frame_newslot(block8930);
// method "_apply(_)"
  block_savedest(block8930);
  Object closure8931 = createclosure(1, "_apply(1)");
  setclosureframe(closure8931, stackframe);
  addtoclosure(closure8931, selfslot);
  struct UserObject *uo8931 = (struct UserObject*)block8930;
  uo8931->data[0] = (Object)closure8931;
  Method *meth_meth_parser__apply_40_1_41_8931 = addmethod2pos(block8930, "_apply(1)", &meth_parser__apply_40_1_41_8931, 0);
  int argcv_meth_parser__apply_40_1_41_8931[] = {1};
  meth_meth_parser__apply_40_1_41_8931->type = alloc_MethodType(1, argcv_meth_parser__apply_40_1_41_8931);
  meth_meth_parser__apply_40_1_41_8931->definitionModule = modulename;
  meth_meth_parser__apply_40_1_41_8931->definitionLine = 3399;
// compiled block node returning block8930 (depth = 3)
  gc_frame_newslot(block8930);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeIds (depth = 3)
  params[0] = block8930;
  partcv[0] = 1;
  Object call8936 = callmethodflags(*var_typeIds, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8929);
// compiled call node returning call8936 (depth = 2)
// Begin line 2830
  setline(2830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8937 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_typeIds (depth = 4)
  gc_frame_newslot(*var_typeIds);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8938 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call8939 = callmethodflags(*var_ast, "typeParametersNode", 0, partcv, params, 0);
  gc_frame_end(callframe8938);
// compiled member node returning call8939 (depth = 4)
  params[0] = *var_typeIds;
  partcv[0] = 1;
  Object call8940 = callmethodflags(call8939, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8937);
// compiled call node returning call8940 (depth = 3)
  *var_result = call8940;
  if (call8940 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2831
  setline(2831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8943 == NULL) {
    strlit8943 = alloc_String("rgeneric");
    gc_root(strlit8943);
  }
// compiled string node returning strlit8943 (depth = 4)
  int op_slot_right_8942 = gc_frame_newslot(strlit8943);
// starting to compile member node (depth = 4)
  int callframe8945 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call8946 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8945);
// compiled member node returning call8946 (depth = 4)
  int op_slot_left_8942 = gc_frame_newslot(call8946);
  params[0] = strlit8943;
  partcv[0] = 1;
  Object opresult8947 = callmethod(call8946, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8947 (depth = 3)
  Object if8941 = done;
  if (istrue(opresult8947)) {
// Begin line 2832
  setline(2832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8948 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8949 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call8950 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8949);
// compiled member node returning call8950 (depth = 5)
  Object call8951 = callmethodflags(call8950, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8948);
// compiled member node returning call8951 (depth = 4)
  *var_suggestion = call8951;
  if (call8951 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2833
  setline(2833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8952 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8953 == NULL) {
    strlit8953 = alloc_String(">");
    gc_root(strlit8953);
  }
// compiled string node returning strlit8953 (depth = 4)
  gc_frame_newslot(strlit8953);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit8953;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8954 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8952);
// compiled call node returning call8954 (depth = 3)
// Begin line 2834
  setline(2834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8955 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8956 == NULL) {
    strlit8956 = alloc_String("a list of type parameters starting with '<' must end with '>'.");
    gc_root(strlit8956);
  }
// compiled string node returning strlit8956 (depth = 4)
  gc_frame_newslot(strlit8956);
// Begin line 2835
  setline(2835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe8957 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call8958 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8957);
// compiled member node returning call8958 (depth = 4)
  gc_frame_newslot(call8958);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8960 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call8961 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8960);
// compiled member node returning call8961 (depth = 5)
  int op_slot_right_8959 = gc_frame_newslot(call8961);
// starting to compile member node (depth = 5)
  int callframe8963 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call8964 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe8963);
// compiled member node returning call8964 (depth = 5)
  int op_slot_left_8959 = gc_frame_newslot(call8964);
  params[0] = call8961;
  partcv[0] = 1;
  Object sum8965 = callmethod(call8964, "+(1)", 1, partcv, params);
// compiled op node returning sum8965 (depth = 4)
  gc_frame_newslot(sum8965);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2834
  setline(2834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit8956;
  params[1] = call8958;
  params[2] = sum8965;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8966 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe8955);
// compiled call node returning call8966 (depth = 3)
    gc_frame_newslot(call8966);
    if8941 = call8966;
  } else {
  }
// compiled if node returning if8941 (depth = 2)
// Begin line 2837
  setline(2837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe8967 = gc_frame_new();
// call case 4: self request
  Object call8968 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8967);
// compiled member node returning call8968 (depth = 2)
// Begin line 2838
  setline(2838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_parser_doimport8969(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 66, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(12, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doimport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_util = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_importline = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "importline");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_errorPos = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "errorPos");
  Object *var_p = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "p");
  Object *var_name = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "name");
  Object *var_dtype = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "dtype");
  Object *var_o = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "o");
  Object *var_anns = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "anns");
// Begin line 2844
  setline(2844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8971 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8972 == NULL) {
    strlit8972 = alloc_String("import");
    gc_root(strlit8972);
  }
// compiled string node returning strlit8972 (depth = 4)
  gc_frame_newslot(strlit8972);
// call case 4: self request
  params[0] = strlit8972;
  partcv[0] = 1;
  Object call8973 = callmethodflags(self, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8971);
// compiled call node returning call8973 (depth = 3)
  Object if8970 = done;
  if (istrue(call8973)) {
// Begin line 2845
  setline(2845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8974 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call8975 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8974);
// compiled member node returning call8975 (depth = 4)
  *var_importline = call8975;
  if (call8975 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2846
  setline(2846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8976 = gc_frame_new();
// call case 4: self request
  Object call8977 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8976);
// compiled member node returning call8977 (depth = 3)
// Begin line 2847
  setline(2847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8980 == NULL) {
    strlit8980 = alloc_String("string");
    gc_root(strlit8980);
  }
// compiled string node returning strlit8980 (depth = 5)
  int op_slot_right_8979 = gc_frame_newslot(strlit8980);
// starting to compile member node (depth = 5)
  int callframe8982 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call8983 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe8982);
// compiled member node returning call8983 (depth = 5)
  int op_slot_left_8979 = gc_frame_newslot(call8983);
  params[0] = strlit8980;
  partcv[0] = 1;
  Object opresult8984 = callmethod(call8983, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8984 (depth = 4)
  Object if8978 = done;
  if (istrue(opresult8984)) {
// Begin line 2848
  setline(2848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8985 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8986 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call8987 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe8986);
// compiled member node returning call8987 (depth = 6)
  Object call8988 = callmethodflags(call8987, "new", 0, partcv, params, 0);
  gc_frame_end(callframe8985);
// compiled member node returning call8988 (depth = 5)
  *var_suggestion = call8988;
  if (call8988 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2849
  setline(2849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 2850
  setline(2850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe8992 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call8993 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8992);
// compiled member node returning call8993 (depth = 7)
  int op_slot_right_8991 = gc_frame_newslot(call8993);
// starting to compile member node (depth = 7)
  int callframe8995 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call8996 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe8995);
// compiled member node returning call8996 (depth = 7)
  int op_slot_left_8991 = gc_frame_newslot(call8996);
  params[0] = call8993;
  partcv[0] = 1;
  Object opresult8997 = callmethod(call8996, "==(1)", 1, partcv, params);
// compiled op node returning opresult8997 (depth = 6)
  int op_slot_right_8990 = gc_frame_newslot(opresult8997);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9000 == NULL) {
    strlit9000 = alloc_String("identifier");
    gc_root(strlit9000);
  }
// compiled string node returning strlit9000 (depth = 7)
  int op_slot_right_8999 = gc_frame_newslot(strlit9000);
// starting to compile member node (depth = 7)
  int callframe9002 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call9003 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9002);
// compiled member node returning call9003 (depth = 7)
  int op_slot_left_8999 = gc_frame_newslot(call9003);
  params[0] = strlit9000;
  partcv[0] = 1;
  Object opresult9004 = callmethod(call9003, "==(1)", 1, partcv, params);
// compiled op node returning opresult9004 (depth = 6)
  int op_slot_left_8990 = gc_frame_newslot(opresult9004);
  params[0] = opresult8997;
  partcv[0] = 1;
  Object opresult9005 = callmethod(opresult9004, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9005 (depth = 5)
  Object if8989 = done;
  if (istrue(opresult9005)) {
// Begin line 2851
  setline(2851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9006 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9008 == NULL) {
    strlit9008 = alloc_String("""\x22""");
    gc_root(strlit9008);
  }
// compiled string node returning strlit9008 (depth = 7)
  int op_slot_right_9007 = gc_frame_newslot(strlit9008);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9011 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call9012 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9011);
// compiled member node returning call9012 (depth = 8)
  int op_slot_right_9010 = gc_frame_newslot(call9012);
// starting to compile string node (depth = 8)
  if (strlit9014 == NULL) {
    strlit9014 = alloc_String("""\x22""");
    gc_root(strlit9014);
  }
// compiled string node returning strlit9014 (depth = 8)
  int op_slot_left_9010 = gc_frame_newslot(strlit9014);
  params[0] = call9012;
  partcv[0] = 1;
  Object opresult9015 = callmethod(strlit9014, "++(1)", 1, partcv, params);
// compiled op node returning opresult9015 (depth = 7)
  int op_slot_left_9007 = gc_frame_newslot(opresult9015);
  params[0] = strlit9008;
  partcv[0] = 1;
  Object opresult9016 = callmethod(opresult9015, "++(1)", 1, partcv, params);
// compiled op node returning opresult9016 (depth = 6)
  gc_frame_newslot(opresult9016);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult9016;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9017 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9006);
// compiled call node returning call9017 (depth = 5)
// Begin line 2852
  setline(2852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9018 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call9019 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9018);
// compiled member node returning call9019 (depth = 6)
  *var_errorPos = call9019;
  if (call9019 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8989 = done;
  } else {
// Begin line 2854
  setline(2854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9021 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9022 == NULL) {
    strlit9022 = alloc_String(" ""\x22""""\xc2""""\xab""module name""\xc2""""\xbb""""\x22""");
    gc_root(strlit9022);
  }
// compiled string node returning strlit9022 (depth = 6)
  gc_frame_newslot(strlit9022);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit9022;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9023 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9021);
// compiled call node returning call9023 (depth = 5)
// Begin line 2855
  setline(2855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9025 = alloc_Float64(1);
// compiled num node returning num9025 (depth = 7)
  int op_slot_right_9024 = gc_frame_newslot(num9025);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9028 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call9029 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9028);
// compiled member node returning call9029 (depth = 8)
  int op_slot_right_9027 = gc_frame_newslot(call9029);
// starting to compile member node (depth = 8)
  int callframe9031 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call9032 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9031);
// compiled member node returning call9032 (depth = 8)
  int op_slot_left_9027 = gc_frame_newslot(call9032);
  params[0] = call9029;
  partcv[0] = 1;
  Object sum9033 = callmethod(call9032, "+(1)", 1, partcv, params);
// compiled op node returning sum9033 (depth = 7)
  int op_slot_left_9024 = gc_frame_newslot(sum9033);
  params[0] = num9025;
  partcv[0] = 1;
  Object sum9034 = callmethod(sum9033, "+(1)", 1, partcv, params);
// compiled op node returning sum9034 (depth = 6)
  *var_errorPos = sum9034;
  if (sum9034 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8989 = done;
  }
// compiled if node returning if8989 (depth = 4)
// Begin line 2857
  setline(2857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9036 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9037 == NULL) {
    strlit9037 = alloc_String("an import statement must have the name of the module in quotes, 'as', and an identifier after 'import'.");
    gc_root(strlit9037);
  }
// compiled string node returning strlit9037 (depth = 5)
  gc_frame_newslot(strlit9037);
// Begin line 2858
  setline(2858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe9038 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call9039 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9038);
// compiled member node returning call9039 (depth = 5)
  gc_frame_newslot(call9039);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2857
  setline(2857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9037;
  params[1] = call9039;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9040 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9036);
// compiled call node returning call9040 (depth = 4)
    gc_frame_newslot(call9040);
    if8978 = call9040;
  } else {
  }
// compiled if node returning if8978 (depth = 3)
// Begin line 2860
  setline(2860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9041 = gc_frame_new();
// call case 4: self request
  Object call9042 = callmethodflags(self, "pushstring", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9041);
// compiled member node returning call9042 (depth = 3)
// Begin line 2861
  setline(2861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9043 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call9044 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe9043);
// compiled member node returning call9044 (depth = 4)
  *var_p = call9044;
  if (call9044 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2862
  setline(2862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9048 == NULL) {
    strlit9048 = alloc_String("as");
    gc_root(strlit9048);
  }
// compiled string node returning strlit9048 (depth = 6)
  int op_slot_right_9047 = gc_frame_newslot(strlit9048);
// starting to compile member node (depth = 6)
  int callframe9050 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call9051 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9050);
// compiled member node returning call9051 (depth = 6)
  int op_slot_left_9047 = gc_frame_newslot(call9051);
  params[0] = strlit9048;
  partcv[0] = 1;
  Object opresult9052 = callmethod(call9051, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9052 (depth = 5)
  int op_slot_right_9046 = gc_frame_newslot(opresult9052);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9055 == NULL) {
    strlit9055 = alloc_String("identifier");
    gc_root(strlit9055);
  }
// compiled string node returning strlit9055 (depth = 6)
  int op_slot_right_9054 = gc_frame_newslot(strlit9055);
// starting to compile member node (depth = 6)
  int callframe9057 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call9058 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9057);
// compiled member node returning call9058 (depth = 6)
  int op_slot_left_9054 = gc_frame_newslot(call9058);
  params[0] = strlit9055;
  partcv[0] = 1;
  Object opresult9059 = callmethod(call9058, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9059 (depth = 5)
  int op_slot_left_9046 = gc_frame_newslot(opresult9059);
  params[0] = opresult9052;
  partcv[0] = 1;
  Object opresult9060 = callmethod(opresult9059, "||(1)", 1, partcv, params);
// compiled op node returning opresult9060 (depth = 4)
  Object if9045 = done;
  if (istrue(opresult9060)) {
// Begin line 2863
  setline(2863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9061 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9062 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call9063 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9062);
// compiled member node returning call9063 (depth = 6)
  Object call9064 = callmethodflags(call9063, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9061);
// compiled member node returning call9064 (depth = 5)
  *var_suggestion = call9064;
  if (call9064 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2864
  setline(2864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9068 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call9069 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9068);
// compiled member node returning call9069 (depth = 7)
  int op_slot_right_9067 = gc_frame_newslot(call9069);
// starting to compile member node (depth = 7)
  int callframe9071 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call9072 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9071);
// compiled member node returning call9072 (depth = 7)
  int op_slot_left_9067 = gc_frame_newslot(call9072);
  params[0] = call9069;
  partcv[0] = 1;
  Object opresult9073 = callmethod(call9072, "==(1)", 1, partcv, params);
// compiled op node returning opresult9073 (depth = 6)
  int op_slot_right_9066 = gc_frame_newslot(opresult9073);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9076 == NULL) {
    strlit9076 = alloc_String("identifier");
    gc_root(strlit9076);
  }
// compiled string node returning strlit9076 (depth = 7)
  int op_slot_right_9075 = gc_frame_newslot(strlit9076);
// starting to compile member node (depth = 7)
  int callframe9078 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call9079 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9078);
// compiled member node returning call9079 (depth = 7)
  int op_slot_left_9075 = gc_frame_newslot(call9079);
  params[0] = strlit9076;
  partcv[0] = 1;
  Object opresult9080 = callmethod(call9079, "==(1)", 1, partcv, params);
// compiled op node returning opresult9080 (depth = 6)
  int op_slot_left_9066 = gc_frame_newslot(opresult9080);
  params[0] = opresult9073;
  partcv[0] = 1;
  Object opresult9081 = callmethod(opresult9080, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9081 (depth = 5)
  Object if9065 = done;
  if (istrue(opresult9081)) {
// Begin line 2865
  setline(2865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9082 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9083 == NULL) {
    strlit9083 = alloc_String(" as");
    gc_root(strlit9083);
  }
// compiled string node returning strlit9083 (depth = 6)
  gc_frame_newslot(strlit9083);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit9083;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9084 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9082);
// compiled call node returning call9084 (depth = 5)
    gc_frame_newslot(call9084);
    if9065 = call9084;
  } else {
// Begin line 2867
  setline(2867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9085 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9087 == NULL) {
    strlit9087 = alloc_String("");
    gc_root(strlit9087);
  }
// compiled string node returning strlit9087 (depth = 7)
  int op_slot_right_9086 = gc_frame_newslot(strlit9087);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9090 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_p (depth = 9)
  Object call9091 = callmethodflags(*var_p, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9090);
// compiled member node returning call9091 (depth = 8)
  int op_slot_right_9089 = gc_frame_newslot(call9091);
// starting to compile string node (depth = 8)
  if (strlit9093 == NULL) {
    strlit9093 = alloc_String(" as ");
    gc_root(strlit9093);
  }
// compiled string node returning strlit9093 (depth = 8)
  int op_slot_left_9089 = gc_frame_newslot(strlit9093);
  params[0] = call9091;
  partcv[0] = 1;
  Object opresult9094 = callmethod(strlit9093, "++(1)", 1, partcv, params);
// compiled op node returning opresult9094 (depth = 7)
  int op_slot_left_9086 = gc_frame_newslot(opresult9094);
  params[0] = strlit9087;
  partcv[0] = 1;
  Object opresult9095 = callmethod(opresult9094, "++(1)", 1, partcv, params);
// compiled op node returning opresult9095 (depth = 6)
  gc_frame_newslot(opresult9095);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = opresult9095;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9096 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9085);
// compiled call node returning call9096 (depth = 5)
    gc_frame_newslot(call9096);
    if9065 = call9096;
  }
// compiled if node returning if9065 (depth = 4)
// Begin line 2869
  setline(2869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9097 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9098 == NULL) {
    strlit9098 = alloc_String("an import statement must have 'as', and an identifier after the name of the module in quotes.");
    gc_root(strlit9098);
  }
// compiled string node returning strlit9098 (depth = 5)
  gc_frame_newslot(strlit9098);
// Begin line 2870
  setline(2870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe9099 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call9100 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9099);
// compiled member node returning call9100 (depth = 5)
  gc_frame_newslot(call9100);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9102 = alloc_Float64(1);
// compiled num node returning num9102 (depth = 6)
  int op_slot_right_9101 = gc_frame_newslot(num9102);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9105 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call9106 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9105);
// compiled member node returning call9106 (depth = 7)
  int op_slot_right_9104 = gc_frame_newslot(call9106);
// starting to compile member node (depth = 7)
  int callframe9108 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call9109 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9108);
// compiled member node returning call9109 (depth = 7)
  int op_slot_left_9104 = gc_frame_newslot(call9109);
  params[0] = call9106;
  partcv[0] = 1;
  Object sum9110 = callmethod(call9109, "+(1)", 1, partcv, params);
// compiled op node returning sum9110 (depth = 6)
  int op_slot_left_9101 = gc_frame_newslot(sum9110);
  params[0] = num9102;
  partcv[0] = 1;
  Object sum9111 = callmethod(sum9110, "+(1)", 1, partcv, params);
// compiled op node returning sum9111 (depth = 5)
  gc_frame_newslot(sum9111);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2869
  setline(2869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9098;
  params[1] = call9100;
  params[2] = sum9111;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9112 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9097);
// compiled call node returning call9112 (depth = 4)
    gc_frame_newslot(call9112);
    if9045 = call9112;
  } else {
  }
// compiled if node returning if9045 (depth = 3)
// Begin line 2872
  setline(2872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9113 = gc_frame_new();
// call case 4: self request
  Object call9114 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9113);
// compiled member node returning call9114 (depth = 3)
// Begin line 2873
  setline(2873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9117 == NULL) {
    strlit9117 = alloc_String("identifier");
    gc_root(strlit9117);
  }
// compiled string node returning strlit9117 (depth = 5)
  int op_slot_right_9116 = gc_frame_newslot(strlit9117);
// starting to compile member node (depth = 5)
  int callframe9119 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call9120 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9119);
// compiled member node returning call9120 (depth = 5)
  int op_slot_left_9116 = gc_frame_newslot(call9120);
  params[0] = strlit9117;
  partcv[0] = 1;
  Object opresult9121 = callmethod(call9120, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9121 (depth = 4)
  Object if9115 = done;
  if (istrue(opresult9121)) {
// Begin line 2874
  setline(2874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9122 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9123 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call9124 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9123);
// compiled member node returning call9124 (depth = 6)
  Object call9125 = callmethodflags(call9124, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9122);
// compiled member node returning call9125 (depth = 5)
  *var_suggestion = call9125;
  if (call9125 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2875
  setline(2875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 2876
  setline(2876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9129 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call9130 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9129);
// compiled member node returning call9130 (depth = 7)
  int op_slot_right_9128 = gc_frame_newslot(call9130);
// starting to compile member node (depth = 7)
  int callframe9132 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call9133 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9132);
// compiled member node returning call9133 (depth = 7)
  int op_slot_left_9128 = gc_frame_newslot(call9133);
  params[0] = call9130;
  partcv[0] = 1;
  Object opresult9134 = callmethod(call9133, "==(1)", 1, partcv, params);
// compiled op node returning opresult9134 (depth = 6)
  int op_slot_right_9127 = gc_frame_newslot(opresult9134);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9137 == NULL) {
    strlit9137 = alloc_String("string");
    gc_root(strlit9137);
  }
// compiled string node returning strlit9137 (depth = 7)
  int op_slot_right_9136 = gc_frame_newslot(strlit9137);
// starting to compile member node (depth = 7)
  int callframe9139 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call9140 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9139);
// compiled member node returning call9140 (depth = 7)
  int op_slot_left_9136 = gc_frame_newslot(call9140);
  params[0] = strlit9137;
  partcv[0] = 1;
  Object opresult9141 = callmethod(call9140, "==(1)", 1, partcv, params);
// compiled op node returning opresult9141 (depth = 6)
  int op_slot_left_9127 = gc_frame_newslot(opresult9141);
  params[0] = opresult9134;
  partcv[0] = 1;
  Object opresult9142 = callmethod(opresult9141, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9142 (depth = 5)
  Object if9126 = done;
  if (istrue(opresult9142)) {
// Begin line 2877
  setline(2877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9143 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9145 == NULL) {
    strlit9145 = alloc_String("");
    gc_root(strlit9145);
  }
// compiled string node returning strlit9145 (depth = 7)
  int op_slot_right_9144 = gc_frame_newslot(strlit9145);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9148 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call9149 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9148);
// compiled member node returning call9149 (depth = 8)
  int op_slot_right_9147 = gc_frame_newslot(call9149);
// starting to compile string node (depth = 8)
  if (strlit9151 == NULL) {
    strlit9151 = alloc_String("");
    gc_root(strlit9151);
  }
// compiled string node returning strlit9151 (depth = 8)
  int op_slot_left_9147 = gc_frame_newslot(strlit9151);
  params[0] = call9149;
  partcv[0] = 1;
  Object opresult9152 = callmethod(strlit9151, "++(1)", 1, partcv, params);
// compiled op node returning opresult9152 (depth = 7)
  int op_slot_left_9144 = gc_frame_newslot(opresult9152);
  params[0] = strlit9145;
  partcv[0] = 1;
  Object opresult9153 = callmethod(opresult9152, "++(1)", 1, partcv, params);
// compiled op node returning opresult9153 (depth = 6)
  gc_frame_newslot(opresult9153);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult9153;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9154 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9143);
// compiled call node returning call9154 (depth = 5)
// Begin line 2878
  setline(2878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9155 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call9156 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9155);
// compiled member node returning call9156 (depth = 6)
  *var_errorPos = call9156;
  if (call9156 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9126 = done;
  } else {
// Begin line 2880
  setline(2880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9158 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9160 == NULL) {
    strlit9160 = alloc_String("");
    gc_root(strlit9160);
  }
// compiled string node returning strlit9160 (depth = 7)
  int op_slot_right_9159 = gc_frame_newslot(strlit9160);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9163 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_p (depth = 9)
  Object call9164 = callmethodflags(*var_p, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9163);
// compiled member node returning call9164 (depth = 8)
  int op_slot_right_9162 = gc_frame_newslot(call9164);
// starting to compile string node (depth = 8)
  if (strlit9166 == NULL) {
    strlit9166 = alloc_String(" ");
    gc_root(strlit9166);
  }
// compiled string node returning strlit9166 (depth = 8)
  int op_slot_left_9162 = gc_frame_newslot(strlit9166);
  params[0] = call9164;
  partcv[0] = 1;
  Object opresult9167 = callmethod(strlit9166, "++(1)", 1, partcv, params);
// compiled op node returning opresult9167 (depth = 7)
  int op_slot_left_9159 = gc_frame_newslot(opresult9167);
  params[0] = strlit9160;
  partcv[0] = 1;
  Object opresult9168 = callmethod(opresult9167, "++(1)", 1, partcv, params);
// compiled op node returning opresult9168 (depth = 6)
  gc_frame_newslot(opresult9168);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = opresult9168;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9169 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9158);
// compiled call node returning call9169 (depth = 5)
// Begin line 2881
  setline(2881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9171 = alloc_Float64(1);
// compiled num node returning num9171 (depth = 7)
  int op_slot_right_9170 = gc_frame_newslot(num9171);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9174 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call9175 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9174);
// compiled member node returning call9175 (depth = 8)
  int op_slot_right_9173 = gc_frame_newslot(call9175);
// starting to compile member node (depth = 8)
  int callframe9177 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call9178 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9177);
// compiled member node returning call9178 (depth = 8)
  int op_slot_left_9173 = gc_frame_newslot(call9178);
  params[0] = call9175;
  partcv[0] = 1;
  Object sum9179 = callmethod(call9178, "+(1)", 1, partcv, params);
// compiled op node returning sum9179 (depth = 7)
  int op_slot_left_9170 = gc_frame_newslot(sum9179);
  params[0] = num9171;
  partcv[0] = 1;
  Object sum9180 = callmethod(sum9179, "+(1)", 1, partcv, params);
// compiled op node returning sum9180 (depth = 6)
  *var_errorPos = sum9180;
  if (sum9180 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9126 = done;
  }
// compiled if node returning if9126 (depth = 4)
// Begin line 2883
  setline(2883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9182 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9183 == NULL) {
    strlit9183 = alloc_String("an import statement must have an identifier after 'as'.");
    gc_root(strlit9183);
  }
// compiled string node returning strlit9183 (depth = 5)
  gc_frame_newslot(strlit9183);
// Begin line 2884
  setline(2884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe9184 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call9185 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9184);
// compiled member node returning call9185 (depth = 5)
  gc_frame_newslot(call9185);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2883
  setline(2883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9183;
  params[1] = call9185;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9186 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9182);
// compiled call node returning call9186 (depth = 4)
    gc_frame_newslot(call9186);
    if9115 = call9186;
  } else {
  }
// compiled if node returning if9115 (depth = 3)
// Begin line 2886
  setline(2886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9187 = gc_frame_new();
// call case 4: self request
  Object call9188 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9187);
// compiled member node returning call9188 (depth = 3)
// Begin line 2887
  setline(2887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9189 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call9190 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe9189);
// compiled member node returning call9190 (depth = 4)
  *var_name = call9190;
  if (call9190 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2888
  setline(2888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9191 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool9192 = alloc_Boolean(1);
// compiled identifier node returning bool9192 (depth = 4)
  gc_frame_newslot(bool9192);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name (depth = 4)
  params[0] = bool9192;
  partcv[0] = 1;
  Object call9193 = callmethodflags(*var_name, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9191);
// compiled call node returning call9193 (depth = 3)
// Begin line 2889
  setline(2889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9194 = gc_frame_new();
// call case 4: self request
  Object call9195 = callmethodflags(self, "optionalTypeAnnotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9194);
// compiled member node returning call9195 (depth = 4)
  *var_dtype = call9195;
  if (call9195 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2890
  setline(2890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9196 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_importline (depth = 4)
  gc_frame_newslot(*var_importline);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_importline;
  partcv[0] = 1;
  Object call9197 = callmethodflags(*var_util, "setline(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9196);
// compiled call node returning call9197 (depth = 3)
// Begin line 2891
  setline(2891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9198 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9199 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  Object call9200 = callmethodflags(*var_p, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9199);
// compiled member node returning call9200 (depth = 5)
  gc_frame_newslot(call9200);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9201 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call9202 = callmethodflags(*var_ast, "importNode", 0, partcv, params, 0);
  gc_frame_end(callframe9201);
// compiled member node returning call9202 (depth = 5)
  params[0] = call9200;
  params[1] = *var_name;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call9203 = callmethodflags(call9202, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe9198);
// compiled call node returning call9203 (depth = 4)
  *var_o = call9203;
  if (call9203 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2892
  setline(2892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9204 = gc_frame_new();
// call case 4: self request
  Object call9205 = callmethodflags(self, "doannotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9204);
// compiled member node returning call9205 (depth = 4)
  *var_anns = call9205;
  if (call9205 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2893
  setline(2893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_9207 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool9209 = alloc_Boolean(0);
// compiled identifier node returning bool9209 (depth = 5)
  int op_slot_left_9207 = gc_frame_newslot(bool9209);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult9210 = callmethod(bool9209, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9210 (depth = 4)
  Object if9206 = done;
  if (istrue(opresult9210)) {
// starting to compile call node (depth = 4)
  int callframe9211 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9212 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  Object call9213 = callmethodflags(*var_o, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe9212);
// compiled member node returning call9213 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call9214 = callmethodflags(call9213, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9211);
// compiled call node returning call9214 (depth = 4)
    gc_frame_newslot(call9214);
    if9206 = call9214;
  } else {
  }
// compiled if node returning if9206 (depth = 3)
// Begin line 2894
  setline(2894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9215 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call9216 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9215);
// compiled call node returning call9216 (depth = 3)
// Begin line 2895
  setline(2895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9217 = gc_frame_new();
// call case 4: self request
  Object call9218 = callmethodflags(self, "reconcileComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9217);
// compiled member node returning call9218 (depth = 3)
    gc_frame_newslot(call9218);
    if8970 = call9218;
  } else {
  }
// compiled if node returning if8970 (depth = 2)
  gc_frame_end(frame);
  return if8970;
}
Object meth_parser__apply9229(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
  int callframe9230 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe9231 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9232 == NULL) {
    strlit9232 = alloc_String("rbrace");
    gc_root(strlit9232);
  }
// compiled string node returning strlit9232 (depth = 8)
  gc_frame_newslot(strlit9232);
// call case 4: self request
  params[0] = strlit9232;
  partcv[0] = 1;
  Object call9233 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9231);
// compiled call node returning call9233 (depth = 7)
  Object call9234 = callmethodflags(call9233, "not", 0, partcv, params, 0);
  gc_frame_end(callframe9230);
// compiled member node returning call9234 (depth = 6)
  gc_frame_end(frame);
  return call9234;
}
Object meth_parser__apply9244(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe9245 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call9246 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9245);
// compiled call node returning call9246 (depth = 8)
  gc_frame_end(frame);
  return call9246;
}
Object meth_parser_doreturn9219(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 67, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doreturn");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_retTok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "retTok");
  Object *var_retval = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "retval");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
// Begin line 2901
  setline(2901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9221 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9222 == NULL) {
    strlit9222 = alloc_String("return");
    gc_root(strlit9222);
  }
// compiled string node returning strlit9222 (depth = 4)
  gc_frame_newslot(strlit9222);
// call case 4: self request
  params[0] = strlit9222;
  partcv[0] = 1;
  Object call9223 = callmethodflags(self, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9221);
// compiled call node returning call9223 (depth = 3)
  Object if9220 = done;
  if (istrue(call9223)) {
// Begin line 2902
  setline(2902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_retTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2903
  setline(2903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9224 = gc_frame_new();
// call case 4: self request
  Object call9225 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9224);
// compiled member node returning call9225 (depth = 3)
// Begin line 2904
  setline(2904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_retval = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2905
  setline(2905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block9228 = alloc_Block(NULL, NULL, "parser", 2905);
  gc_frame_newslot(block9228);
// method "_apply"
  block_savedest(block9228);
  Object closure9229 = createclosure(1, "_apply");
  setclosureframe(closure9229, stackframe);
  addtoclosure(closure9229, selfslot);
  struct UserObject *uo9229 = (struct UserObject*)block9228;
  uo9229->data[0] = (Object)closure9229;
  Method *meth_meth_parser__apply9229 = addmethod2pos(block9228, "_apply", &meth_parser__apply9229, 0);
  int argcv_meth_parser__apply9229[] = {0};
  meth_meth_parser__apply9229->type = alloc_MethodType(1, argcv_meth_parser__apply9229);
  meth_meth_parser__apply9229->definitionModule = modulename;
  meth_meth_parser__apply9229->definitionLine = 3399;
// compiled block node returning block9228 (depth = 5)
  int op_slot_right_9227 = gc_frame_newslot(block9228);
// starting to compile member node (depth = 5)
  int callframe9237 = gc_frame_new();
// call case 4: self request
  Object call9238 = callmethodflags(self, "tokenOnSameLine", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9237);
// compiled member node returning call9238 (depth = 5)
  int op_slot_left_9227 = gc_frame_newslot(call9238);
  params[0] = block9228;
  partcv[0] = 1;
  Object opresult9239 = callmethod(call9238, "&&(1)", 1, partcv, params);
// compiled op node returning opresult9239 (depth = 4)
  Object if9226 = done;
  if (istrue(opresult9239)) {
// Begin line 2906
  setline(2906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9241 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe9242 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block9243 = alloc_Block(NULL, NULL, "parser", 2906);
  gc_frame_newslot(block9243);
// method "_apply"
  block_savedest(block9243);
  Object closure9244 = createclosure(2, "_apply");
  setclosureframe(closure9244, stackframe);
  addtoclosure(closure9244, var_blocksOK);
  addtoclosure(closure9244, selfslot);
  struct UserObject *uo9244 = (struct UserObject*)block9243;
  uo9244->data[0] = (Object)closure9244;
  Method *meth_meth_parser__apply9244 = addmethod2pos(block9243, "_apply", &meth_parser__apply9244, 0);
  int argcv_meth_parser__apply9244[] = {0};
  meth_meth_parser__apply9244->type = alloc_MethodType(1, argcv_meth_parser__apply9244);
  meth_meth_parser__apply9244->definitionModule = modulename;
  meth_meth_parser__apply9244->definitionLine = 3399;
// compiled block node returning block9243 (depth = 7)
  gc_frame_newslot(block9243);
// call case 4: self request
  params[0] = block9243;
  partcv[0] = 1;
  Object call9248 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9242);
// compiled call node returning call9248 (depth = 6)
  Object call9249 = callmethodflags(call9248, "not", 0, partcv, params, 0);
  gc_frame_end(callframe9241);
// compiled member node returning call9249 (depth = 5)
  Object if9240 = done;
  if (istrue(call9249)) {
// Begin line 2907
  setline(2907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array9250 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9250 (depth = 6)
  *var_suggestions = array9250;
  if (array9250 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2908
  setline(2908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9251 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9252 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call9253 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9252);
// compiled member node returning call9253 (depth = 7)
  Object call9254 = callmethodflags(call9253, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9251);
// compiled member node returning call9254 (depth = 6)
  *var_suggestion = call9254;
  if (call9254 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2909
  setline(2909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9255 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array9256 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit9257 == NULL) {
    strlit9257 = alloc_String("rbrace");
    gc_root(strlit9257);
  }
// compiled string node returning strlit9257 (depth = 8)
  params[0] = strlit9257;
  partcv[0] = 1;
  callmethodflags(array9256, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array9256 (depth = 7)
  gc_frame_newslot(array9256);
// call case 4: self request
  params[0] = array9256;
  partcv[0] = 1;
  Object call9258 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9255);
// compiled call node returning call9258 (depth = 6)
  *var_nextTok = call9258;
  if (call9258 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2910
  setline(2910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_9260 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_9260 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult9262 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult9262 (depth = 6)
  Object if9259 = done;
  if (istrue(opresult9262)) {
// Begin line 2911
  setline(2911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9263 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9264 == NULL) {
    strlit9264 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit9264);
  }
// compiled string node returning strlit9264 (depth = 7)
  gc_frame_newslot(strlit9264);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit9264;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9265 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9263);
// compiled call node returning call9265 (depth = 6)
// Begin line 2912
  setline(2912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9266 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9267 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9266);
// compiled call node returning call9267 (depth = 6)
// Begin line 2913
  setline(2913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9268 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe9269 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call9270 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9269);
// compiled member node returning call9270 (depth = 8)
  Object call9271 = callmethodflags(call9270, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9268);
// compiled member node returning call9271 (depth = 7)
  *var_suggestion = call9271;
  if (call9271 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 2914
  setline(2914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9273 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool9274 = alloc_Boolean(1);
// compiled identifier node returning bool9274 (depth = 7)
  gc_frame_newslot(bool9274);
// starting to compile identifier node (depth = 7)
  Object bool9275 = alloc_Boolean(0);
// compiled identifier node returning bool9275 (depth = 7)
  gc_frame_newslot(bool9275);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool9274;
  params[2] = bool9275;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9276 = callmethodflags(*var_suggestion, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9273);
// compiled call node returning call9276 (depth = 6)
    gc_frame_newslot(call9276);
    if9259 = call9276;
  } else {
// Begin line 2916
  setline(2916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9277 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe9278 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call9279 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe9278);
// compiled member node returning call9279 (depth = 7)
  gc_frame_newslot(call9279);
// starting to compile identifier node (depth = 7)
  Object bool9280 = alloc_Boolean(1);
// compiled identifier node returning bool9280 (depth = 7)
  gc_frame_newslot(bool9280);
// starting to compile identifier node (depth = 7)
  Object bool9281 = alloc_Boolean(0);
// compiled identifier node returning bool9281 (depth = 7)
  gc_frame_newslot(bool9281);
// starting to compile string node (depth = 7)
  if (strlit9282 == NULL) {
    strlit9282 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit9282);
  }
// compiled string node returning strlit9282 (depth = 7)
  gc_frame_newslot(strlit9282);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call9279;
  params[2] = bool9280;
  params[3] = bool9281;
  params[4] = strlit9282;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call9283 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe9277);
// compiled call node returning call9283 (depth = 6)
// Begin line 2917
  setline(2917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9284 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9285 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9284);
// compiled call node returning call9285 (depth = 6)
// Begin line 2918
  setline(2918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9286 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe9287 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call9288 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9287);
// compiled member node returning call9288 (depth = 8)
  Object call9289 = callmethodflags(call9288, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9286);
// compiled member node returning call9289 (depth = 7)
  *var_suggestion = call9289;
  if (call9289 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 2919
  setline(2919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9291 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
  int callframe9292 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  Object call9293 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe9292);
// compiled member node returning call9293 (depth = 7)
  gc_frame_newslot(call9293);
// starting to compile identifier node (depth = 7)
  Object bool9294 = alloc_Boolean(1);
// compiled identifier node returning bool9294 (depth = 7)
  gc_frame_newslot(bool9294);
// starting to compile identifier node (depth = 7)
  Object bool9295 = alloc_Boolean(0);
// compiled identifier node returning bool9295 (depth = 7)
  gc_frame_newslot(bool9295);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call9293;
  params[2] = bool9294;
  params[3] = bool9295;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9296 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9291);
// compiled call node returning call9296 (depth = 6)
    gc_frame_newslot(call9296);
    if9259 = call9296;
  }
// compiled if node returning if9259 (depth = 5)
// Begin line 2921
  setline(2921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9297 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9298 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9297);
// compiled call node returning call9298 (depth = 5)
// Begin line 2922
  setline(2922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9299 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9300 == NULL) {
    strlit9300 = alloc_String("a return statement must have either an expression or a new-line after 'return'.");
    gc_root(strlit9300);
  }
// compiled string node returning strlit9300 (depth = 6)
  gc_frame_newslot(strlit9300);
// Begin line 2923
  setline(2923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe9301 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call9302 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9301);
// compiled member node returning call9302 (depth = 6)
  gc_frame_newslot(call9302);
// starting to compile member node (depth = 6)
  int callframe9303 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call9304 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9303);
// compiled member node returning call9304 (depth = 6)
  gc_frame_newslot(call9304);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9306 = alloc_Float64(1);
// compiled num node returning num9306 (depth = 7)
  int op_slot_right_9305 = gc_frame_newslot(num9306);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9309 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call9310 = callmethodflags(*var_sym, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9309);
// compiled member node returning call9310 (depth = 8)
  int op_slot_right_9308 = gc_frame_newslot(call9310);
// starting to compile member node (depth = 8)
  int callframe9312 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call9313 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9312);
// compiled member node returning call9313 (depth = 8)
  int op_slot_left_9308 = gc_frame_newslot(call9313);
  params[0] = call9310;
  partcv[0] = 1;
  Object sum9314 = callmethod(call9313, "+(1)", 1, partcv, params);
// compiled op node returning sum9314 (depth = 7)
  int op_slot_left_9305 = gc_frame_newslot(sum9314);
  params[0] = num9306;
  partcv[0] = 1;
  Object diff9315 = callmethod(sum9314, "-(1)", 1, partcv, params);
// compiled op node returning diff9315 (depth = 6)
  gc_frame_newslot(diff9315);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 2922
  setline(2922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit9300;
  params[1] = call9302;
  params[2] = call9304;
  params[3] = diff9315;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9316 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9299);
// compiled call node returning call9316 (depth = 5)
    gc_frame_newslot(call9316);
    if9240 = call9316;
  } else {
  }
// compiled if node returning if9240 (depth = 4)
// Begin line 2925
  setline(2925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9317 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call9318 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe9317);
// compiled member node returning call9318 (depth = 5)
  *var_retval = call9318;
  if (call9318 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9226 = done;
  } else {
// Begin line 2927
  setline(2927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9320 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9321 == NULL) {
    strlit9321 = alloc_String("done");
    gc_root(strlit9321);
  }
// compiled string node returning strlit9321 (depth = 6)
  gc_frame_newslot(strlit9321);
// starting to compile identifier node (depth = 6)
  Object bool9322 = alloc_Boolean(0);
// compiled identifier node returning bool9322 (depth = 6)
  gc_frame_newslot(bool9322);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9323 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call9324 = callmethodflags(*var_ast, "identifierNode", 0, partcv, params, 0);
  gc_frame_end(callframe9323);
// compiled member node returning call9324 (depth = 6)
  params[0] = strlit9321;
  params[1] = bool9322;
  partcv[0] = 2;
  Object call9325 = callmethodflags(call9324, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9320);
// compiled call node returning call9325 (depth = 5)
  *var_retval = call9325;
  if (call9325 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9226 = done;
  }
// compiled if node returning if9226 (depth = 3)
// Begin line 2929
  setline(2929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9327 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9328 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_retTok (depth = 5)
  Object call9329 = callmethodflags(*var_retTok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9328);
// compiled member node returning call9329 (depth = 4)
  gc_frame_newslot(call9329);
// starting to compile member node (depth = 4)
  int callframe9330 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_retTok (depth = 5)
  Object call9331 = callmethodflags(*var_retTok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9330);
// compiled member node returning call9331 (depth = 4)
  gc_frame_newslot(call9331);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call9329;
  params[1] = call9331;
  partcv[0] = 2;
  Object call9332 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9327);
// compiled call node returning call9332 (depth = 3)
// Begin line 2930
  setline(2930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9333 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_retval (depth = 5)
  gc_frame_newslot(*var_retval);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9334 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call9335 = callmethodflags(*var_ast, "returnNode", 0, partcv, params, 0);
  gc_frame_end(callframe9334);
// compiled member node returning call9335 (depth = 5)
  params[0] = *var_retval;
  partcv[0] = 1;
  Object call9336 = callmethodflags(call9335, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9333);
// compiled call node returning call9336 (depth = 4)
  *var_o = call9336;
  if (call9336 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2931
  setline(2931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9337 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call9338 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9337);
// compiled call node returning call9338 (depth = 3)
    gc_frame_newslot(call9338);
    if9220 = call9338;
  } else {
  }
// compiled if node returning if9220 (depth = 2)
  gc_frame_end(frame);
  return if9220;
}
Object meth_parser_domethodtype9339(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 68, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "domethodtype");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_methodTypeTok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "methodTypeTok");
  Object *var_methNode = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "methNode");
  Object *var_dtype = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "dtype");
  Object *var_o = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "o");
  Object *var_suggestion = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestion");
  Object *var_newLine = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "newLine");
// Begin line 2937
  setline(2937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_methodTypeTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2938
  setline(2938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9340 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool9341 = alloc_Boolean(1);
// compiled identifier node returning bool9341 (depth = 4)
  gc_frame_newslot(bool9341);
// call case 4: self request
  params[0] = bool9341;
  partcv[0] = 1;
  Object call9342 = callmethodflags(self, "methodsignature(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9340);
// compiled call node returning call9342 (depth = 3)
  *var_methNode = call9342;
  if (call9342 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2939
  setline(2939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe9343 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methNode (depth = 4)
  Object call9344 = callmethodflags(*var_methNode, "dtype", 0, partcv, params, 0);
  gc_frame_end(callframe9343);
// compiled member node returning call9344 (depth = 3)
  *var_dtype = call9344;
  if (call9344 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2940
  setline(2940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9347 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methNode (depth = 5)
  Object call9348 = callmethodflags(*var_methNode, "dtype", 0, partcv, params, 0);
  gc_frame_end(callframe9347);
// compiled member node returning call9348 (depth = 4)
  int op_slot_right_9346 = gc_frame_newslot(call9348);
// starting to compile identifier node (depth = 4)
  Object bool9350 = alloc_Boolean(0);
// compiled identifier node returning bool9350 (depth = 4)
  int op_slot_left_9346 = gc_frame_newslot(bool9350);
  params[0] = call9348;
  partcv[0] = 1;
  Object opresult9351 = callmethod(bool9350, "==(1)", 1, partcv, params);
// compiled op node returning opresult9351 (depth = 3)
  Object if9345 = done;
  if (istrue(opresult9351)) {
// Begin line 2941
  setline(2941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9352 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9353 == NULL) {
    strlit9353 = alloc_String("Done");
    gc_root(strlit9353);
  }
// compiled string node returning strlit9353 (depth = 5)
  gc_frame_newslot(strlit9353);
// starting to compile identifier node (depth = 5)
  Object bool9354 = alloc_Boolean(0);
// compiled identifier node returning bool9354 (depth = 5)
  gc_frame_newslot(bool9354);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9355 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call9356 = callmethodflags(*var_ast, "identifierNode", 0, partcv, params, 0);
  gc_frame_end(callframe9355);
// compiled member node returning call9356 (depth = 5)
  params[0] = strlit9353;
  params[1] = bool9354;
  partcv[0] = 2;
  Object call9357 = callmethodflags(call9356, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9352);
// compiled call node returning call9357 (depth = 4)
  *var_dtype = call9357;
  if (call9357 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9345 = done;
  } else {
  }
// compiled if node returning if9345 (depth = 2)
// Begin line 2943
  setline(2943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 2944
  setline(2944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9359 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methodTypeTok (depth = 4)
  gc_frame_newslot(*var_methodTypeTok);
// call case 6: other requests
// Begin line 2943
  setline(2943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9360 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9361 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methNode (depth = 6)
  Object call9362 = callmethodflags(*var_methNode, "signature", 0, partcv, params, 0);
  gc_frame_end(callframe9361);
// compiled member node returning call9362 (depth = 5)
  gc_frame_newslot(call9362);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9363 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call9364 = callmethodflags(*var_ast, "methodTypeNode", 0, partcv, params, 0);
  gc_frame_end(callframe9363);
// compiled member node returning call9364 (depth = 5)
  params[0] = call9362;
  params[1] = *var_dtype;
  partcv[0] = 2;
  Object call9365 = callmethodflags(call9364, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9360);
// compiled call node returning call9365 (depth = 4)
  params[0] = *var_methodTypeTok;
  partcv[0] = 1;
  Object call9366 = callmethodflags(call9365, "setPositionFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9359);
// compiled call node returning call9366 (depth = 3)
  *var_o = call9366;
  if (call9366 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2945
  setline(2945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9367 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe9368 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methNode (depth = 4)
  Object call9369 = callmethodflags(*var_methNode, "typeParams", 0, partcv, params, 0);
  gc_frame_end(callframe9368);
// compiled member node returning call9369 (depth = 3)
  gc_frame_newslot(call9369);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  params[0] = call9369;
  partcv[0] = 1;
  Object call9370 = callmethodflags(*var_o, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9367);
// compiled call node returning call9370 (depth = 2)
// Begin line 2946
  setline(2946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9371 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call9372 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9371);
// compiled call node returning call9372 (depth = 2)
// Begin line 2947
  setline(2947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe9373 = gc_frame_new();
// call case 4: self request
  Object call9374 = callmethodflags(self, "reconcileComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9373);
// compiled member node returning call9374 (depth = 2)
// Begin line 2948
  setline(2948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9376 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9377 == NULL) {
    strlit9377 = alloc_String("semicolon");
    gc_root(strlit9377);
  }
// compiled string node returning strlit9377 (depth = 4)
  gc_frame_newslot(strlit9377);
// call case 4: self request
  params[0] = strlit9377;
  partcv[0] = 1;
  Object call9378 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9376);
// compiled call node returning call9378 (depth = 3)
  Object if9375 = done;
  if (istrue(call9378)) {
// Begin line 2949
  setline(2949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9379 = gc_frame_new();
// call case 4: self request
  Object call9380 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9379);
// compiled member node returning call9380 (depth = 3)
    gc_frame_newslot(call9380);
    if9375 = call9380;
  } else {
// Begin line 2951
  setline(2951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9382 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe9383 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9384 == NULL) {
    strlit9384 = alloc_String("rbrace");
    gc_root(strlit9384);
  }
// compiled string node returning strlit9384 (depth = 6)
  gc_frame_newslot(strlit9384);
// call case 4: self request
  params[0] = strlit9384;
  partcv[0] = 1;
  Object call9385 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9383);
// compiled call node returning call9385 (depth = 5)
  partcv[0] = 0;
  Object call9386 = callmethodflags(call9385, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe9382);
// compiled call node returning call9386 (depth = 4)
  Object if9381 = done;
  if (istrue(call9386)) {
// Begin line 2952
  setline(2952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9389 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call9390 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9389);
// compiled member node returning call9390 (depth = 6)
  int op_slot_right_9388 = gc_frame_newslot(call9390);
// starting to compile member node (depth = 6)
  int callframe9392 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call9393 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9392);
// compiled member node returning call9393 (depth = 6)
  int op_slot_left_9388 = gc_frame_newslot(call9393);
  params[0] = call9390;
  partcv[0] = 1;
  Object opresult9394 = callmethod(call9393, "==(1)", 1, partcv, params);
// compiled op node returning opresult9394 (depth = 5)
  Object if9387 = done;
  if (istrue(opresult9394)) {
// Begin line 2953
  setline(2953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9395 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9396 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call9397 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9396);
// compiled member node returning call9397 (depth = 7)
  Object call9398 = callmethodflags(call9397, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9395);
// compiled member node returning call9398 (depth = 6)
  *var_suggestion = call9398;
  if (call9398 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2954
  setline(2954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9400 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call9401 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9400);
// compiled member node returning call9401 (depth = 7)
  int op_slot_right_9399 = gc_frame_newslot(call9401);
// starting to compile call node (depth = 7)
  int callframe9403 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num9404 = alloc_Float64(1);
// compiled num node returning num9404 (depth = 8)
  gc_frame_newslot(num9404);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num9406 = alloc_Float64(1);
// compiled num node returning num9406 (depth = 9)
  int op_slot_right_9405 = gc_frame_newslot(num9406);
// starting to compile member node (depth = 9)
  int callframe9408 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call9409 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9408);
// compiled member node returning call9409 (depth = 9)
  int op_slot_left_9405 = gc_frame_newslot(call9409);
  params[0] = num9406;
  partcv[0] = 1;
  Object diff9410 = callmethod(call9409, "-(1)", 1, partcv, params);
// compiled op node returning diff9410 (depth = 8)
  gc_frame_newslot(diff9410);
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe9411 = gc_frame_new();
// starting to compile member node (depth = 9)
  int callframe9412 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call9413 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9412);
// compiled member node returning call9413 (depth = 9)
  gc_frame_newslot(call9413);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe9414 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  Object call9415 = callmethodflags(*var_util, "lines", 0, partcv, params, 0);
  gc_frame_end(callframe9414);
// compiled member node returning call9415 (depth = 9)
  params[0] = call9413;
  partcv[0] = 1;
  Object call9416 = callmethodflags(call9415, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9411);
// compiled call node returning call9416 (depth = 8)
  params[0] = num9404;
  params[1] = diff9410;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9417 = callmethodflags(call9416, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9403);
// compiled call node returning call9417 (depth = 7)
  int op_slot_left_9399 = gc_frame_newslot(call9417);
  params[0] = call9401;
  partcv[0] = 1;
  Object opresult9418 = callmethod(call9417, "++(1)", 1, partcv, params);
// compiled op node returning opresult9418 (depth = 6)
  *var_newLine = opresult9418;
  if (opresult9418 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 2955
  setline(2955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9419 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9421 = alloc_Float64(0.1);
// compiled num node returning num9421 (depth = 7)
  int op_slot_right_9420 = gc_frame_newslot(num9421);
// starting to compile member node (depth = 7)
  int callframe9423 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call9424 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9423);
// compiled member node returning call9424 (depth = 7)
  int op_slot_left_9420 = gc_frame_newslot(call9424);
  params[0] = num9421;
  partcv[0] = 1;
  Object sum9425 = callmethod(call9424, "+(1)", 1, partcv, params);
// compiled op node returning sum9425 (depth = 6)
  gc_frame_newslot(sum9425);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newLine (depth = 6)
  gc_frame_newslot(*var_newLine);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = sum9425;
  params[1] = *var_newLine;
  partcv[0] = 2;
  Object call9426 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9419);
// compiled call node returning call9426 (depth = 5)
// Begin line 2956
  setline(2956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9427 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
  Object bool9428 = alloc_Boolean(1);
// compiled identifier node returning bool9428 (depth = 6)
  gc_frame_newslot(bool9428);
// starting to compile identifier node (depth = 6)
  Object bool9429 = alloc_Boolean(1);
// compiled identifier node returning bool9429 (depth = 6)
  gc_frame_newslot(bool9429);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = bool9428;
  params[2] = bool9429;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9430 = callmethodflags(*var_suggestion, "deleteToken(1)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9427);
// compiled call node returning call9430 (depth = 5)
// Begin line 2957
  setline(2957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9431 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9432 == NULL) {
    strlit9432 = alloc_String("methods in a type literal must be on separate lines, or separated by semicolons.");
    gc_root(strlit9432);
  }
// compiled string node returning strlit9432 (depth = 6)
  gc_frame_newslot(strlit9432);
// Begin line 2958
  setline(2958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe9433 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call9434 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9433);
// compiled member node returning call9434 (depth = 6)
  gc_frame_newslot(call9434);
// starting to compile member node (depth = 6)
  int callframe9435 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call9436 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9435);
// compiled member node returning call9436 (depth = 6)
  gc_frame_newslot(call9436);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2957
  setline(2957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit9432;
  params[1] = call9434;
  params[2] = call9436;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9437 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9431);
// compiled call node returning call9437 (depth = 5)
    gc_frame_newslot(call9437);
    if9387 = call9437;
  } else {
  }
// compiled if node returning if9387 (depth = 4)
    gc_frame_newslot(if9387);
    if9381 = if9387;
  } else {
  }
// compiled if node returning if9381 (depth = 3)
    gc_frame_newslot(if9381);
    if9375 = if9381;
  }
// compiled if node returning if9375 (depth = 2)
  gc_frame_end(frame);
  return if9375;
}
Object meth_parser__apply9480(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
  int callframe9481 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe9482 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9483 == NULL) {
    strlit9483 = alloc_String("rbrace");
    gc_root(strlit9483);
  }
// compiled string node returning strlit9483 (depth = 7)
  gc_frame_newslot(strlit9483);
// call case 4: self request
  params[0] = strlit9483;
  partcv[0] = 1;
  Object call9484 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9482);
// compiled call node returning call9484 (depth = 6)
  Object call9485 = callmethodflags(call9484, "not", 0, partcv, params, 0);
  gc_frame_end(callframe9481);
// compiled member node returning call9485 (depth = 5)
  gc_frame_end(frame);
  return call9485;
}
Object meth_parser__apply9488(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_types = getfromclosure(closure, 1);
  Object *var_meths = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2984
  setline(2984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9490 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9491 == NULL) {
    strlit9491 = alloc_String("type");
    gc_root(strlit9491);
  }
// compiled string node returning strlit9491 (depth = 7)
  gc_frame_newslot(strlit9491);
// call case 4: self request
  params[0] = strlit9491;
  partcv[0] = 1;
  Object call9492 = callmethodflags(self, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9490);
// compiled call node returning call9492 (depth = 6)
  Object if9489 = done;
  if (istrue(call9492)) {
// Begin line 2985
  setline(2985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe9493 = gc_frame_new();
// call case 4: self request
  Object call9494 = callmethodflags(self, "typedec", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9493);
// compiled member node returning call9494 (depth = 6)
// Begin line 2986
  setline(2986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9495 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe9496 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call9497 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe9496);
// compiled member node returning call9497 (depth = 7)
  gc_frame_newslot(call9497);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_types (depth = 7)
  params[0] = call9497;
  partcv[0] = 1;
  Object call9498 = callmethodflags(*var_types, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9495);
// compiled call node returning call9498 (depth = 6)
    gc_frame_newslot(call9498);
    if9489 = call9498;
  } else {
// Begin line 2988
  setline(2988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe9499 = gc_frame_new();
// call case 4: self request
  Object call9500 = callmethodflags(self, "domethodtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9499);
// compiled member node returning call9500 (depth = 6)
// Begin line 2989
  setline(2989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9501 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe9502 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call9503 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe9502);
// compiled member node returning call9503 (depth = 7)
  gc_frame_newslot(call9503);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meths (depth = 7)
  params[0] = call9503;
  partcv[0] = 1;
  Object call9504 = callmethodflags(*var_meths, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9501);
// compiled call node returning call9504 (depth = 6)
    gc_frame_newslot(call9504);
    if9489 = call9504;
  }
// compiled if node returning if9489 (depth = 5)
  gc_frame_end(frame);
  return if9489;
}
Object meth_parser_dotypeLiteral9438(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 69, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotypeLiteral");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_auto_count = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_typeLiteralTok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "typeLiteralTok");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_meths = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "meths");
  Object *var_types = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "types");
  Object *var_mc = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "mc");
  Object *var_t = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "t");
// Begin line 2966
  setline(2966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_typeLiteralTok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2967
  setline(2967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9440 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9441 == NULL) {
    strlit9441 = alloc_String("type");
    gc_root(strlit9441);
  }
// compiled string node returning strlit9441 (depth = 4)
  gc_frame_newslot(strlit9441);
// call case 4: self request
  params[0] = strlit9441;
  partcv[0] = 1;
  Object call9442 = callmethodflags(self, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9440);
// compiled call node returning call9442 (depth = 3)
  Object if9439 = done;
  if (istrue(call9442)) {
// Begin line 2968
  setline(2968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9443 = gc_frame_new();
// call case 4: self request
  Object call9444 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9443);
// compiled member node returning call9444 (depth = 3)
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9446 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe9447 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9448 == NULL) {
    strlit9448 = alloc_String("lbrace");
    gc_root(strlit9448);
  }
// compiled string node returning strlit9448 (depth = 6)
  gc_frame_newslot(strlit9448);
// call case 4: self request
  params[0] = strlit9448;
  partcv[0] = 1;
  Object call9449 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9447);
// compiled call node returning call9449 (depth = 5)
  partcv[0] = 0;
  Object call9450 = callmethodflags(call9449, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe9446);
// compiled call node returning call9450 (depth = 4)
  Object if9445 = done;
  if (istrue(call9450)) {
// Begin line 2970
  setline(2970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9451 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9452 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call9453 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9452);
// compiled member node returning call9453 (depth = 6)
  Object call9454 = callmethodflags(call9453, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9451);
// compiled member node returning call9454 (depth = 5)
  *var_suggestion = call9454;
  if (call9454 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2971
  setline(2971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9455 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 5)
  if (strlit9456 == NULL) {
    strlit9456 = alloc_String("{");
    gc_root(strlit9456);
  }
// compiled string node returning strlit9456 (depth = 5)
  gc_frame_newslot(strlit9456);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = strlit9456;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9457 = callmethodflags(*var_suggestion, "replaceToken(1)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9455);
// compiled call node returning call9457 (depth = 4)
// Begin line 2972
  setline(2972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9458 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9459 == NULL) {
    strlit9459 = alloc_String("type literals must open with a brace.");
    gc_root(strlit9459);
  }
// compiled string node returning strlit9459 (depth = 5)
  gc_frame_newslot(strlit9459);
// Begin line 2973
  setline(2973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe9460 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call9461 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9460);
// compiled member node returning call9461 (depth = 5)
  gc_frame_newslot(call9461);
// starting to compile member node (depth = 5)
  int callframe9462 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call9463 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9462);
// compiled member node returning call9463 (depth = 5)
  gc_frame_newslot(call9463);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 2972
  setline(2972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9459;
  params[1] = call9461;
  params[2] = call9463;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9464 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9458);
// compiled call node returning call9464 (depth = 4)
// Begin line 2974
  setline(2974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 2975
  setline(2975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_done (depth = 5)
  return *var_done;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if9445 = undefined;
  } else {
  }
// compiled if node returning if9445 (depth = 3)
    gc_frame_newslot(if9445);
    if9439 = if9445;
  } else {
  }
// compiled if node returning if9439 (depth = 2)
// Begin line 2977
  setline(2977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9466 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9467 == NULL) {
    strlit9467 = alloc_String("lbrace");
    gc_root(strlit9467);
  }
// compiled string node returning strlit9467 (depth = 4)
  gc_frame_newslot(strlit9467);
// call case 4: self request
  params[0] = strlit9467;
  partcv[0] = 1;
  Object call9468 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9466);
// compiled call node returning call9468 (depth = 3)
  Object if9465 = done;
  if (istrue(call9468)) {
// Begin line 2978
  setline(2978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array9469 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9469 (depth = 4)
  *var_meths = array9469;
  if (array9469 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2979
  setline(2979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array9470 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9470 (depth = 4)
  *var_types = array9470;
  if (array9470 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2980
  setline(2980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_auto_count (depth = 4)
  *var_mc = *var_auto_count;
  if (*var_auto_count == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9472 = alloc_Float64(1);
// compiled num node returning num9472 (depth = 5)
  int op_slot_right_9471 = gc_frame_newslot(num9472);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_auto_count (depth = 5)
  int op_slot_left_9471 = gc_frame_newslot(*var_auto_count);
  params[0] = num9472;
  partcv[0] = 1;
  Object sum9474 = callmethod(*var_auto_count, "+(1)", 1, partcv, params);
// compiled op node returning sum9474 (depth = 4)
  *var_auto_count = sum9474;
  if (sum9474 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2982
  setline(2982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9476 = gc_frame_new();
// call case 4: self request
  Object call9477 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9476);
// compiled member node returning call9477 (depth = 3)
// Begin line 2983
  setline(2983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9478 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9479 = alloc_Block(NULL, NULL, "parser", 2983);
  gc_frame_newslot(block9479);
// method "_apply"
  block_savedest(block9479);
  Object closure9480 = createclosure(1, "_apply");
  setclosureframe(closure9480, stackframe);
  addtoclosure(closure9480, selfslot);
  struct UserObject *uo9480 = (struct UserObject*)block9479;
  uo9480->data[0] = (Object)closure9480;
  Method *meth_meth_parser__apply9480 = addmethod2pos(block9479, "_apply", &meth_parser__apply9480, 0);
  int argcv_meth_parser__apply9480[] = {0};
  meth_meth_parser__apply9480->type = alloc_MethodType(1, argcv_meth_parser__apply9480);
  meth_meth_parser__apply9480->definitionModule = modulename;
  meth_meth_parser__apply9480->definitionLine = 3399;
// compiled block node returning block9479 (depth = 4)
  gc_frame_newslot(block9479);
// starting to compile block node (depth = 4)
  Object block9487 = alloc_Block(NULL, NULL, "parser", 2983);
  gc_frame_newslot(block9487);
// method "_apply"
  block_savedest(block9487);
  Object closure9488 = createclosure(4, "_apply");
  setclosureframe(closure9488, stackframe);
  addtoclosure(closure9488, var_values);
  addtoclosure(closure9488, var_types);
  addtoclosure(closure9488, var_meths);
  addtoclosure(closure9488, selfslot);
  struct UserObject *uo9488 = (struct UserObject*)block9487;
  uo9488->data[0] = (Object)closure9488;
  Method *meth_meth_parser__apply9488 = addmethod2pos(block9487, "_apply", &meth_parser__apply9488, 0);
  int argcv_meth_parser__apply9488[] = {0};
  meth_meth_parser__apply9488->type = alloc_MethodType(1, argcv_meth_parser__apply9488);
  meth_meth_parser__apply9488->definitionModule = modulename;
  meth_meth_parser__apply9488->definitionLine = 3399;
// compiled block node returning block9487 (depth = 4)
  gc_frame_newslot(block9487);
// call case 5: prelude request
  params[0] = block9479;
  params[1] = block9487;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9506 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9478);
// compiled call node returning call9506 (depth = 3)
// Begin line 2992
  setline(2992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9507 = gc_frame_new();
// call case 4: self request
  Object call9508 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9507);
// compiled member node returning call9508 (depth = 3)
// Begin line 2993
  setline(2993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9509 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9510 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeLiteralTok (depth = 5)
  Object call9511 = callmethodflags(*var_typeLiteralTok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9510);
// compiled member node returning call9511 (depth = 4)
  gc_frame_newslot(call9511);
// starting to compile member node (depth = 4)
  int callframe9512 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeLiteralTok (depth = 5)
  Object call9513 = callmethodflags(*var_typeLiteralTok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9512);
// compiled member node returning call9513 (depth = 4)
  gc_frame_newslot(call9513);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call9511;
  params[1] = call9513;
  partcv[0] = 2;
  Object call9514 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9509);
// compiled call node returning call9514 (depth = 3)
// Begin line 2994
  setline(2994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9515 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meths (depth = 5)
  gc_frame_newslot(*var_meths);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_types (depth = 5)
  gc_frame_newslot(*var_types);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9516 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call9517 = callmethodflags(*var_ast, "typeLiteralNode", 0, partcv, params, 0);
  gc_frame_end(callframe9516);
// compiled member node returning call9517 (depth = 5)
  params[0] = *var_meths;
  params[1] = *var_types;
  partcv[0] = 2;
  Object call9518 = callmethodflags(call9517, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9515);
// compiled call node returning call9518 (depth = 4)
  *var_t = call9518;
  if (call9518 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2995
  setline(2995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9519 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call9520 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9519);
// compiled call node returning call9520 (depth = 3)
    gc_frame_newslot(call9520);
    if9465 = call9520;
  } else {
  }
// compiled if node returning if9465 (depth = 2)
  gc_frame_end(frame);
  return if9465;
}
Object meth_parser__apply_40_1_41_9610(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9612 == NULL) {
    strlit9612 = alloc_String("lbrace");
    gc_root(strlit9612);
  }
// compiled string node returning strlit9612 (depth = 8)
  int op_slot_right_9611 = gc_frame_newslot(strlit9612);
// starting to compile member node (depth = 8)
  int callframe9614 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  Object call9615 = callmethodflags(*var_t, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9614);
// compiled member node returning call9615 (depth = 8)
  int op_slot_left_9611 = gc_frame_newslot(call9615);
  params[0] = strlit9612;
  partcv[0] = 1;
  Object opresult9616 = callmethod(call9615, "==(1)", 1, partcv, params);
// compiled op node returning opresult9616 (depth = 7)
  gc_frame_end(frame);
  return opresult9616;
}
Object meth_parser__apply9622(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_nextTok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_9623 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_9623 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult9625 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult9625 (depth = 7)
  gc_frame_end(frame);
  return opresult9625;
}
Object meth_parser_typedec9521(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 70, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typedec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object *var_noBlocks = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_pos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "pos");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nt = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nt");
  Object *var_anns = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "anns");
  Object *var_nextTok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nextTok");
// Begin line 3001
  setline(3001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9523 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9524 == NULL) {
    strlit9524 = alloc_String("type");
    gc_root(strlit9524);
  }
// compiled string node returning strlit9524 (depth = 4)
  gc_frame_newslot(strlit9524);
// call case 4: self request
  params[0] = strlit9524;
  partcv[0] = 1;
  Object call9525 = callmethodflags(self, "acceptKeyword(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9523);
// compiled call node returning call9525 (depth = 3)
  Object if9522 = done;
  if (istrue(call9525)) {
// Begin line 3002
  setline(3002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9526 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call9527 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9526);
// compiled member node returning call9527 (depth = 4)
  *var_line = call9527;
  if (call9527 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 3003
  setline(3003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9528 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call9529 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9528);
// compiled member node returning call9529 (depth = 4)
  *var_pos = call9529;
  if (call9529 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 3004
  setline(3004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9530 = gc_frame_new();
// call case 4: self request
  Object call9531 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9530);
// compiled member node returning call9531 (depth = 3)
// Begin line 3005
  setline(3005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9534 == NULL) {
    strlit9534 = alloc_String("identifier");
    gc_root(strlit9534);
  }
// compiled string node returning strlit9534 (depth = 5)
  int op_slot_right_9533 = gc_frame_newslot(strlit9534);
// starting to compile member node (depth = 5)
  int callframe9536 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call9537 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9536);
// compiled member node returning call9537 (depth = 5)
  int op_slot_left_9533 = gc_frame_newslot(call9537);
  params[0] = strlit9534;
  partcv[0] = 1;
  Object opresult9538 = callmethod(call9537, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9538 (depth = 4)
  Object if9532 = done;
  if (istrue(opresult9538)) {
// Begin line 3006
  setline(3006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9539 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9540 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call9541 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9540);
// compiled member node returning call9541 (depth = 6)
  Object call9542 = callmethodflags(call9541, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9539);
// compiled member node returning call9542 (depth = 5)
  *var_suggestion = call9542;
  if (call9542 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3007
  setline(3007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9543 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9544 == NULL) {
    strlit9544 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit9544);
  }
// compiled string node returning strlit9544 (depth = 5)
  gc_frame_newslot(strlit9544);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit9544;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9545 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9543);
// compiled call node returning call9545 (depth = 4)
// Begin line 3008
  setline(3008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9546 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9547 == NULL) {
    strlit9547 = alloc_String("a type declaration must have a name after the 'type'.");
    gc_root(strlit9547);
  }
// compiled string node returning strlit9547 (depth = 5)
  gc_frame_newslot(strlit9547);
// Begin line 3009
  setline(3009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe9548 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call9549 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9548);
// compiled member node returning call9549 (depth = 5)
  gc_frame_newslot(call9549);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9551 = alloc_Float64(1);
// compiled num node returning num9551 (depth = 6)
  int op_slot_right_9550 = gc_frame_newslot(num9551);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9554 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call9555 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9554);
// compiled member node returning call9555 (depth = 7)
  int op_slot_right_9553 = gc_frame_newslot(call9555);
// starting to compile member node (depth = 7)
  int callframe9557 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call9558 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9557);
// compiled member node returning call9558 (depth = 7)
  int op_slot_left_9553 = gc_frame_newslot(call9558);
  params[0] = call9555;
  partcv[0] = 1;
  Object sum9559 = callmethod(call9558, "+(1)", 1, partcv, params);
// compiled op node returning sum9559 (depth = 6)
  int op_slot_left_9550 = gc_frame_newslot(sum9559);
  params[0] = num9551;
  partcv[0] = 1;
  Object sum9560 = callmethod(sum9559, "+(1)", 1, partcv, params);
// compiled op node returning sum9560 (depth = 5)
  gc_frame_newslot(sum9560);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 3008
  setline(3008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9547;
  params[1] = call9549;
  params[2] = sum9560;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9561 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9546);
// compiled call node returning call9561 (depth = 4)
    gc_frame_newslot(call9561);
    if9532 = call9561;
  } else {
  }
// compiled if node returning if9532 (depth = 3)
// Begin line 3011
  setline(3011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9562 = gc_frame_new();
// call case 4: self request
  Object call9563 = callmethodflags(self, "pushidentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9562);
// compiled member node returning call9563 (depth = 3)
// Begin line 3012
  setline(3012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9564 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  gc_frame_newslot(*var_line);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_line;
  params[1] = *var_pos;
  partcv[0] = 2;
  Object call9565 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9564);
// compiled call node returning call9565 (depth = 3)
// Begin line 3013
  setline(3013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9566 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9567 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  Object call9568 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe9567);
// compiled member node returning call9568 (depth = 5)
  gc_frame_newslot(call9568);
// starting to compile identifier node (depth = 5)
  Object bool9569 = alloc_Boolean(0);
// compiled identifier node returning bool9569 (depth = 5)
  gc_frame_newslot(bool9569);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9570 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  Object call9571 = callmethodflags(*var_ast, "typeDecNode", 0, partcv, params, 0);
  gc_frame_end(callframe9570);
// compiled member node returning call9571 (depth = 5)
  params[0] = call9568;
  params[1] = bool9569;
  partcv[0] = 2;
  Object call9572 = callmethodflags(call9571, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9566);
// compiled call node returning call9572 (depth = 4)
  *var_nt = call9572;
  if (call9572 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 3014
  setline(3014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9574 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9575 == NULL) {
    strlit9575 = alloc_String("lgeneric");
    gc_root(strlit9575);
  }
// compiled string node returning strlit9575 (depth = 5)
  gc_frame_newslot(strlit9575);
// call case 4: self request
  params[0] = strlit9575;
  partcv[0] = 1;
  Object call9576 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9574);
// compiled call node returning call9576 (depth = 4)
  Object if9573 = done;
  if (istrue(call9576)) {
// starting to compile call node (depth = 4)
  int callframe9577 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9578 = gc_frame_new();
// call case 4: self request
  Object call9579 = callmethodflags(self, "typeparameters", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9578);
// compiled member node returning call9579 (depth = 5)
  gc_frame_newslot(call9579);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nt (depth = 5)
  params[0] = call9579;
  partcv[0] = 1;
  Object call9580 = callmethodflags(*var_nt, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9577);
// compiled call node returning call9580 (depth = 4)
    gc_frame_newslot(call9580);
    if9573 = call9580;
  } else {
  }
// compiled if node returning if9573 (depth = 3)
// Begin line 3015
  setline(3015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9581 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool9582 = alloc_Boolean(1);
// compiled identifier node returning bool9582 (depth = 4)
  gc_frame_newslot(bool9582);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9583 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nt (depth = 5)
  Object call9584 = callmethodflags(*var_nt, "name", 0, partcv, params, 0);
  gc_frame_end(callframe9583);
// compiled member node returning call9584 (depth = 4)
  params[0] = bool9582;
  partcv[0] = 1;
  Object call9585 = callmethodflags(call9584, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9581);
// compiled call node returning call9585 (depth = 3)
// Begin line 3016
  setline(3016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9586 = gc_frame_new();
// call case 4: self request
  Object call9587 = callmethodflags(self, "doannotation", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9586);
// compiled member node returning call9587 (depth = 4)
  *var_anns = call9587;
  if (call9587 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 3017
  setline(3017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9591 == NULL) {
    strlit9591 = alloc_String("=");
    gc_root(strlit9591);
  }
// compiled string node returning strlit9591 (depth = 6)
  int op_slot_right_9590 = gc_frame_newslot(strlit9591);
// starting to compile member node (depth = 6)
  int callframe9593 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call9594 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9593);
// compiled member node returning call9594 (depth = 6)
  int op_slot_left_9590 = gc_frame_newslot(call9594);
  params[0] = strlit9591;
  partcv[0] = 1;
  Object opresult9595 = callmethod(call9594, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9595 (depth = 5)
  int op_slot_right_9589 = gc_frame_newslot(opresult9595);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9598 == NULL) {
    strlit9598 = alloc_String("op");
    gc_root(strlit9598);
  }
// compiled string node returning strlit9598 (depth = 6)
  int op_slot_right_9597 = gc_frame_newslot(strlit9598);
// starting to compile member node (depth = 6)
  int callframe9600 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call9601 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9600);
// compiled member node returning call9601 (depth = 6)
  int op_slot_left_9597 = gc_frame_newslot(call9601);
  params[0] = strlit9598;
  partcv[0] = 1;
  Object opresult9602 = callmethod(call9601, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9602 (depth = 5)
  int op_slot_left_9589 = gc_frame_newslot(opresult9602);
  params[0] = opresult9595;
  partcv[0] = 1;
  Object opresult9603 = callmethod(opresult9602, "||(1)", 1, partcv, params);
// compiled op node returning opresult9603 (depth = 4)
  Object if9588 = done;
  if (istrue(opresult9603)) {
// Begin line 3018
  setline(3018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9604 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9605 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call9606 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9605);
// compiled member node returning call9606 (depth = 6)
  Object call9607 = callmethodflags(call9606, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9604);
// compiled member node returning call9607 (depth = 5)
  *var_suggestion = call9607;
  if (call9607 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 3019
  setline(3019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9608 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block9609 = alloc_Block(NULL, NULL, "parser", 3019);
  gc_frame_newslot(block9609);
// method "_apply(_)"
  block_savedest(block9609);
  Object closure9610 = createclosure(1, "_apply(1)");
  setclosureframe(closure9610, stackframe);
  addtoclosure(closure9610, selfslot);
  struct UserObject *uo9610 = (struct UserObject*)block9609;
  uo9610->data[0] = (Object)closure9610;
  Method *meth_meth_parser__apply_40_1_41_9610 = addmethod2pos(block9609, "_apply(1)", &meth_parser__apply_40_1_41_9610, 0);
  int argcv_meth_parser__apply_40_1_41_9610[] = {1};
  meth_meth_parser__apply_40_1_41_9610->type = alloc_MethodType(1, argcv_meth_parser__apply_40_1_41_9610);
  meth_meth_parser__apply_40_1_41_9610->definitionModule = modulename;
  meth_meth_parser__apply_40_1_41_9610->definitionLine = 3399;
// compiled block node returning block9609 (depth = 6)
  gc_frame_newslot(block9609);
// call case 4: self request
  params[0] = block9609;
  partcv[0] = 1;
  Object call9618 = callmethodflags(self, "findNextToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9608);
// compiled call node returning call9618 (depth = 5)
  *var_nextTok = call9618;
  if (call9618 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3020
  setline(3020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block9621 = alloc_Block(NULL, NULL, "parser", 3020);
  gc_frame_newslot(block9621);
// method "_apply"
  block_savedest(block9621);
  Object closure9622 = createclosure(3, "_apply");
  setclosureframe(closure9622, stackframe);
  addtoclosure(closure9622, var_sym);
  addtoclosure(closure9622, var_nextTok);
  addtoclosure(closure9622, selfslot);
  struct UserObject *uo9622 = (struct UserObject*)block9621;
  uo9622->data[0] = (Object)closure9622;
  Method *meth_meth_parser__apply9622 = addmethod2pos(block9621, "_apply", &meth_parser__apply9622, 0);
  int argcv_meth_parser__apply9622[] = {0};
  meth_meth_parser__apply9622->type = alloc_MethodType(1, argcv_meth_parser__apply9622);
  meth_meth_parser__apply9622->definitionModule = modulename;
  meth_meth_parser__apply9622->definitionLine = 3399;
// compiled block node returning block9621 (depth = 6)
  int op_slot_right_9620 = gc_frame_newslot(block9621);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_right_9628 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 7)
  Object bool9630 = alloc_Boolean(0);
// compiled identifier node returning bool9630 (depth = 7)
  int op_slot_left_9628 = gc_frame_newslot(bool9630);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult9631 = callmethod(bool9630, "==(1)", 1, partcv, params);
// compiled op node returning opresult9631 (depth = 6)
  int op_slot_left_9620 = gc_frame_newslot(opresult9631);
  params[0] = block9621;
  partcv[0] = 1;
  Object opresult9632 = callmethod(opresult9631, "||(1)", 1, partcv, params);
// compiled op node returning opresult9632 (depth = 5)
  Object if9619 = done;
  if (istrue(opresult9632)) {
// Begin line 3021
  setline(3021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9633 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9634 == NULL) {
    strlit9634 = alloc_String(" =");
    gc_root(strlit9634);
  }
// compiled string node returning strlit9634 (depth = 6)
  gc_frame_newslot(strlit9634);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit9634;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9635 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9633);
// compiled call node returning call9635 (depth = 5)
    gc_frame_newslot(call9635);
    if9619 = call9635;
  } else {
// Begin line 3023
  setline(3023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9636 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe9637 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  Object call9638 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe9637);
// compiled member node returning call9638 (depth = 6)
  gc_frame_newslot(call9638);
// starting to compile string node (depth = 6)
  if (strlit9639 == NULL) {
    strlit9639 = alloc_String("=");
    gc_root(strlit9639);
  }
// compiled string node returning strlit9639 (depth = 6)
  gc_frame_newslot(strlit9639);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call9638;
  params[2] = strlit9639;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9640 = callmethodflags(*var_suggestion, "replaceTokenRange(2)with(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9636);
// compiled call node returning call9640 (depth = 5)
    gc_frame_newslot(call9640);
    if9619 = call9640;
  }
// compiled if node returning if9619 (depth = 4)
// Begin line 3025
  setline(3025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9641 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9642 == NULL) {
    strlit9642 = alloc_String("a type declaration must have an '=' after the type name.");
    gc_root(strlit9642);
  }
// compiled string node returning strlit9642 (depth = 5)
  gc_frame_newslot(strlit9642);
// Begin line 3026
  setline(3026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe9643 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call9644 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9643);
// compiled member node returning call9644 (depth = 5)
  gc_frame_newslot(call9644);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9646 = alloc_Float64(1);
// compiled num node returning num9646 (depth = 6)
  int op_slot_right_9645 = gc_frame_newslot(num9646);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9649 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call9650 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9649);
// compiled member node returning call9650 (depth = 7)
  int op_slot_right_9648 = gc_frame_newslot(call9650);
// starting to compile member node (depth = 7)
  int callframe9652 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call9653 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9652);
// compiled member node returning call9653 (depth = 7)
  int op_slot_left_9648 = gc_frame_newslot(call9653);
  params[0] = call9650;
  partcv[0] = 1;
  Object sum9654 = callmethod(call9653, "+(1)", 1, partcv, params);
// compiled op node returning sum9654 (depth = 6)
  int op_slot_left_9645 = gc_frame_newslot(sum9654);
  params[0] = num9646;
  partcv[0] = 1;
  Object sum9655 = callmethod(sum9654, "+(1)", 1, partcv, params);
// compiled op node returning sum9655 (depth = 5)
  gc_frame_newslot(sum9655);
// Begin line 3027
  setline(3027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 3025
  setline(3025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9642;
  params[1] = call9644;
  params[2] = sum9655;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9656 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9641);
// compiled call node returning call9656 (depth = 4)
    gc_frame_newslot(call9656);
    if9588 = call9656;
  } else {
  }
// compiled if node returning if9588 (depth = 3)
// Begin line 3029
  setline(3029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9657 = gc_frame_new();
// call case 4: self request
  Object call9658 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9657);
// compiled member node returning call9658 (depth = 3)
// Begin line 3031
  setline(3031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9660 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9661 == NULL) {
    strlit9661 = alloc_String("lbrace");
    gc_root(strlit9661);
  }
// compiled string node returning strlit9661 (depth = 5)
  gc_frame_newslot(strlit9661);
// call case 4: self request
  params[0] = strlit9661;
  partcv[0] = 1;
  Object call9662 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9660);
// compiled call node returning call9662 (depth = 4)
  Object if9659 = done;
  if (istrue(call9662)) {
// Begin line 3032
  setline(3032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9663 = gc_frame_new();
// call case 4: self request
  Object call9664 = callmethodflags(self, "dotypeLiteral", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9663);
// compiled member node returning call9664 (depth = 4)
    gc_frame_newslot(call9664);
    if9659 = call9664;
  } else {
// Begin line 3034
  setline(3034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9665 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_noBlocks (depth = 5)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call9666 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9665);
// compiled call node returning call9666 (depth = 4)
    gc_frame_newslot(call9666);
    if9659 = call9666;
  }
// compiled if node returning if9659 (depth = 3)
// Begin line 3036
  setline(3036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9667 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9668 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call9669 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe9668);
// compiled member node returning call9669 (depth = 4)
  gc_frame_newslot(call9669);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nt (depth = 4)
  params[0] = call9669;
  partcv[0] = 1;
  Object call9670 = callmethodflags(*var_nt, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9667);
// compiled call node returning call9670 (depth = 3)
// Begin line 3037
  setline(3037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_9672 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool9674 = alloc_Boolean(0);
// compiled identifier node returning bool9674 (depth = 5)
  int op_slot_left_9672 = gc_frame_newslot(bool9674);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult9675 = callmethod(bool9674, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9675 (depth = 4)
  Object if9671 = done;
  if (istrue(opresult9675)) {
// Begin line 3038
  setline(3038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9676 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9677 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nt (depth = 6)
  Object call9678 = callmethodflags(*var_nt, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe9677);
// compiled member node returning call9678 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call9679 = callmethodflags(call9678, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9676);
// compiled call node returning call9679 (depth = 4)
    gc_frame_newslot(call9679);
    if9671 = call9679;
  } else {
  }
// compiled if node returning if9671 (depth = 3)
// Begin line 3040
  setline(3040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9680 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nt (depth = 4)
  gc_frame_newslot(*var_nt);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_nt;
  partcv[0] = 1;
  Object call9681 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9680);
// compiled call node returning call9681 (depth = 3)
// Begin line 3041
  setline(3041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9682 = gc_frame_new();
// call case 4: self request
  Object call9683 = callmethodflags(self, "reconcileComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9682);
// compiled member node returning call9683 (depth = 3)
    gc_frame_newslot(call9683);
    if9522 = call9683;
  } else {
  }
// compiled if node returning if9522 (depth = 2)
  gc_frame_end(frame);
  return if9522;
}
Object meth_parser__apply_40_1_41_9763(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[3];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_suggestion = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___0 = &(stackframe->slots[0]);
  *var___0 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3059
  setline(3059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe9764 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit9765 == NULL) {
    strlit9765 = alloc_String(" ");
    gc_root(strlit9765);
  }
// compiled string node returning strlit9765 (depth = 11)
  gc_frame_newslot(strlit9765);
// starting to compile num node (depth = 11)
  Object num9766 = alloc_Float64(1);
// compiled num node returning num9766 (depth = 11)
  gc_frame_newslot(num9766);
// starting to compile member node (depth = 11)
  int callframe9767 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  Object call9768 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9767);
// compiled member node returning call9768 (depth = 11)
  gc_frame_newslot(call9768);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit9765;
  params[1] = num9766;
  params[2] = call9768;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9769 = callmethodflags(*var_suggestion, "insert(1)atPosition(1)onLine(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9764);
// compiled call node returning call9769 (depth = 10)
  gc_frame_end(frame);
  return call9769;
}
Object meth_parser__apply9781(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_minIndentLevel (depth = 12)
  int op_slot_right_9783 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile member node (depth = 12)
  int callframe9785 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  Object call9786 = callmethodflags(*var_tok, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe9785);
// compiled member node returning call9786 (depth = 12)
  int op_slot_left_9783 = gc_frame_newslot(call9786);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult9787 = callmethod(call9786, "≥(1)", 1, partcv, params);
// compiled op node returning opresult9787 (depth = 11)
  int op_slot_right_9782 = gc_frame_newslot(opresult9787);
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num9791 = alloc_Float64(1);
// compiled num node returning num9791 (depth = 13)
  int op_slot_right_9790 = gc_frame_newslot(num9791);
// starting to compile member node (depth = 13)
  int callframe9793 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tok (depth = 14)
  Object call9794 = callmethodflags(*var_tok, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe9793);
// compiled member node returning call9794 (depth = 13)
  int op_slot_left_9790 = gc_frame_newslot(call9794);
  params[0] = num9791;
  partcv[0] = 1;
  Object sum9795 = callmethod(call9794, "+(1)", 1, partcv, params);
// compiled op node returning sum9795 (depth = 12)
  int op_slot_right_9789 = gc_frame_newslot(sum9795);
// starting to compile member node (depth = 12)
  int callframe9797 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  Object call9798 = callmethodflags(*var_tok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9797);
// compiled member node returning call9798 (depth = 12)
  int op_slot_left_9789 = gc_frame_newslot(call9798);
  params[0] = sum9795;
  partcv[0] = 1;
  Object opresult9799 = callmethod(call9798, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9799 (depth = 11)
  int op_slot_left_9782 = gc_frame_newslot(opresult9799);
  params[0] = opresult9787;
  partcv[0] = 1;
  Object opresult9800 = callmethod(opresult9799, "||(1)", 1, partcv, params);
// compiled op node returning opresult9800 (depth = 10)
  gc_frame_end(frame);
  return opresult9800;
}
Object meth_parser__apply9803(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 10)
// Begin line 3066
  setline(3066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
  int callframe9804 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tok (depth = 12)
  Object call9805 = callmethodflags(*var_tok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe9804);
// compiled member node returning call9805 (depth = 11)
  *var_tok = call9805;
  if (call9805 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply_40_1_41_9818(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_line = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___1 = &(stackframe->slots[0]);
  *var___1 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3070
  setline(3070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit9820 == NULL) {
    strlit9820 = alloc_String(" ");
    gc_root(strlit9820);
  }
// compiled string node returning strlit9820 (depth = 12)
  int op_slot_right_9819 = gc_frame_newslot(strlit9820);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_line (depth = 12)
  int op_slot_left_9819 = gc_frame_newslot(*var_line);
  params[0] = strlit9820;
  partcv[0] = 1;
  Object opresult9822 = callmethod(*var_line, "++(1)", 1, partcv, params);
// compiled op node returning opresult9822 (depth = 11)
  *var_line = opresult9822;
  if (opresult9822 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_checkIndent9684(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 71, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_lastIndent = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_tok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "tok");
  Object *var_line = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "line");
  Object *var_m1 = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "m1");
  Object *var_m2 = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "m2");
  Object *var_m3 = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "m3");
  Object *var_m4 = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "m4");
  Object *var_m5 = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "m5");
  Object *var_msg = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "msg");
// Begin line 3046
  setline(3046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indentFreePass (depth = 3)
  Object if9685 = done;
  if (istrue(*var_indentFreePass)) {
// Begin line 3047
  setline(3047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool9686 = alloc_Boolean(0);
// compiled identifier node returning bool9686 (depth = 4)
  *var_indentFreePass = bool9686;
  if (bool9686 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9685 = done;
  } else {
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3048
  setline(3048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9690 == NULL) {
    strlit9690 = alloc_String("semicolon");
    gc_root(strlit9690);
  }
// compiled string node returning strlit9690 (depth = 5)
  int op_slot_right_9689 = gc_frame_newslot(strlit9690);
// starting to compile member node (depth = 5)
  int callframe9692 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call9693 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9692);
// compiled member node returning call9693 (depth = 5)
  int op_slot_left_9689 = gc_frame_newslot(call9693);
  params[0] = strlit9690;
  partcv[0] = 1;
  Object opresult9694 = callmethod(call9693, "==(1)", 1, partcv, params);
// compiled op node returning opresult9694 (depth = 4)
  Object if9688 = done;
  if (istrue(opresult9694)) {
    gc_frame_newslot(done);
    if9688 = done;
  } else {
// Begin line 3053
  setline(3053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 3051
  setline(3051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9698 == NULL) {
    strlit9698 = alloc_String("rsquare");
    gc_root(strlit9698);
  }
// compiled string node returning strlit9698 (depth = 7)
  int op_slot_right_9697 = gc_frame_newslot(strlit9698);
// starting to compile member node (depth = 7)
  int callframe9700 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call9701 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9700);
// compiled member node returning call9701 (depth = 7)
  int op_slot_left_9697 = gc_frame_newslot(call9701);
  params[0] = strlit9698;
  partcv[0] = 1;
  Object opresult9702 = callmethod(call9701, "==(1)", 1, partcv, params);
// compiled op node returning opresult9702 (depth = 6)
  int op_slot_right_9696 = gc_frame_newslot(opresult9702);
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9706 == NULL) {
    strlit9706 = alloc_String("rparen");
    gc_root(strlit9706);
  }
// compiled string node returning strlit9706 (depth = 8)
  int op_slot_right_9705 = gc_frame_newslot(strlit9706);
// starting to compile member node (depth = 8)
  int callframe9708 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call9709 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9708);
// compiled member node returning call9709 (depth = 8)
  int op_slot_left_9705 = gc_frame_newslot(call9709);
  params[0] = strlit9706;
  partcv[0] = 1;
  Object opresult9710 = callmethod(call9709, "==(1)", 1, partcv, params);
// compiled op node returning opresult9710 (depth = 7)
  int op_slot_right_9704 = gc_frame_newslot(opresult9710);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9713 == NULL) {
    strlit9713 = alloc_String("rbrace");
    gc_root(strlit9713);
  }
// compiled string node returning strlit9713 (depth = 8)
  int op_slot_right_9712 = gc_frame_newslot(strlit9713);
// starting to compile member node (depth = 8)
  int callframe9715 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call9716 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9715);
// compiled member node returning call9716 (depth = 8)
  int op_slot_left_9712 = gc_frame_newslot(call9716);
  params[0] = strlit9713;
  partcv[0] = 1;
  Object opresult9717 = callmethod(call9716, "==(1)", 1, partcv, params);
// compiled op node returning opresult9717 (depth = 7)
  int op_slot_left_9704 = gc_frame_newslot(opresult9717);
  params[0] = opresult9710;
  partcv[0] = 1;
  Object opresult9718 = callmethod(opresult9717, "||(1)", 1, partcv, params);
// compiled op node returning opresult9718 (depth = 6)
  int op_slot_left_9696 = gc_frame_newslot(opresult9718);
  params[0] = opresult9702;
  partcv[0] = 1;
  Object opresult9719 = callmethod(opresult9718, "||(1)", 1, partcv, params);
// compiled op node returning opresult9719 (depth = 5)
  Object if9695 = done;
  if (istrue(opresult9719)) {
    gc_frame_newslot(done);
    if9695 = done;
  } else {
// Begin line 3054
  setline(3054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3053
  setline(3053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9722 == NULL) {
    strlit9722 = alloc_String("eof");
    gc_root(strlit9722);
  }
// compiled string node returning strlit9722 (depth = 7)
  int op_slot_right_9721 = gc_frame_newslot(strlit9722);
// starting to compile member node (depth = 7)
  int callframe9724 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call9725 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe9724);
// compiled member node returning call9725 (depth = 7)
  int op_slot_left_9721 = gc_frame_newslot(call9725);
  params[0] = strlit9722;
  partcv[0] = 1;
  Object opresult9726 = callmethod(call9725, "==(1)", 1, partcv, params);
// compiled op node returning opresult9726 (depth = 6)
  Object if9720 = done;
  if (istrue(opresult9726)) {
    gc_frame_newslot(done);
    if9720 = done;
  } else {
// Begin line 3079
  setline(3079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3054
  setline(3054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_minIndentLevel (depth = 8)
  int op_slot_right_9728 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile member node (depth = 8)
  int callframe9730 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call9731 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe9730);
// compiled member node returning call9731 (depth = 8)
  int op_slot_left_9728 = gc_frame_newslot(call9731);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult9732 = callmethod(call9731, "<(1)", 1, partcv, params);
// compiled op node returning opresult9732 (depth = 7)
  Object if9727 = done;
  if (istrue(opresult9732)) {
// Begin line 3055
  setline(3055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_minIndentLevel (depth = 9)
  int op_slot_right_9734 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num9737 = alloc_Float64(1);
// compiled num node returning num9737 (depth = 10)
  int op_slot_right_9736 = gc_frame_newslot(num9737);
// starting to compile member node (depth = 10)
  int callframe9739 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call9740 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9739);
// compiled member node returning call9740 (depth = 10)
  int op_slot_left_9736 = gc_frame_newslot(call9740);
  params[0] = num9737;
  partcv[0] = 1;
  Object diff9741 = callmethod(call9740, "-(1)", 1, partcv, params);
// compiled op node returning diff9741 (depth = 9)
  int op_slot_left_9734 = gc_frame_newslot(diff9741);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult9742 = callmethod(diff9741, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9742 (depth = 8)
  Object if9733 = done;
  if (istrue(opresult9742)) {
// Begin line 3056
  setline(3056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile array node (depth = 9)
  Object array9743 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9743 (depth = 9)
  *var_suggestions = array9743;
  if (array9743 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 3057
  setline(3057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe9744 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe9745 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call9746 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9745);
// compiled member node returning call9746 (depth = 10)
  Object call9747 = callmethodflags(call9746, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9744);
// compiled member node returning call9747 (depth = 9)
  *var_suggestion = call9747;
  if (call9747 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 3058
  setline(3058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9748 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num9752 = alloc_Float64(1);
// compiled num node returning num9752 (depth = 12)
  int op_slot_right_9751 = gc_frame_newslot(num9752);
// starting to compile member node (depth = 12)
  int callframe9754 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  Object call9755 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9754);
// compiled member node returning call9755 (depth = 12)
  int op_slot_left_9751 = gc_frame_newslot(call9755);
  params[0] = num9752;
  partcv[0] = 1;
  Object diff9756 = callmethod(call9755, "-(1)", 1, partcv, params);
// compiled op node returning diff9756 (depth = 11)
  int op_slot_right_9750 = gc_frame_newslot(diff9756);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_minIndentLevel (depth = 11)
  int op_slot_left_9750 = gc_frame_newslot(*var_minIndentLevel);
  params[0] = diff9756;
  partcv[0] = 1;
  Object diff9758 = callmethod(*var_minIndentLevel, "-(1)", 1, partcv, params);
// compiled op node returning diff9758 (depth = 10)
  int op_slot_right_9749 = gc_frame_newslot(diff9758);
// starting to compile num node (depth = 10)
  Object num9760 = alloc_Float64(1);
// compiled num node returning num9760 (depth = 10)
  int op_slot_left_9749 = gc_frame_newslot(num9760);
  params[0] = diff9758;
  partcv[0] = 1;
  Object opresult9761 = callmethod(num9760, "..(1)", 1, partcv, params);
// compiled op node returning opresult9761 (depth = 9)
  gc_frame_newslot(opresult9761);
// starting to compile block node (depth = 9)
  Object block9762 = alloc_Block(NULL, NULL, "parser", 3058);
  gc_frame_newslot(block9762);
// method "_apply(_)"
  block_savedest(block9762);
  Object closure9763 = createclosure(3, "_apply(1)");
  setclosureframe(closure9763, stackframe);
  addtoclosure(closure9763, var_sym);
  addtoclosure(closure9763, var_suggestion);
  addtoclosure(closure9763, selfslot);
  struct UserObject *uo9763 = (struct UserObject*)block9762;
  uo9763->data[0] = (Object)closure9763;
  Method *meth_meth_parser__apply_40_1_41_9763 = addmethod2pos(block9762, "_apply(1)", &meth_parser__apply_40_1_41_9763, 0);
  int argcv_meth_parser__apply_40_1_41_9763[] = {1};
  meth_meth_parser__apply_40_1_41_9763->type = alloc_MethodType(1, argcv_meth_parser__apply_40_1_41_9763);
  meth_meth_parser__apply_40_1_41_9763->definitionModule = modulename;
  meth_meth_parser__apply_40_1_41_9763->definitionLine = 3399;
// compiled block node returning block9762 (depth = 9)
  gc_frame_newslot(block9762);
// call case 5: prelude request
  params[0] = opresult9761;
  params[1] = block9762;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9771 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9748);
// compiled call node returning call9771 (depth = 8)
// Begin line 3061
  setline(3061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9772 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9773 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9772);
// compiled call node returning call9773 (depth = 8)
// Begin line 3062
  setline(3062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe9774 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe9775 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  Object call9776 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe9775);
// compiled member node returning call9776 (depth = 10)
  Object call9777 = callmethodflags(call9776, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9774);
// compiled member node returning call9777 (depth = 9)
  *var_suggestion = call9777;
  if (call9777 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 3064
  setline(3064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  *var_tok = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 3065
  setline(3065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9779 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block9780 = alloc_Block(NULL, NULL, "parser", 3065);
  gc_frame_newslot(block9780);
// method "_apply"
  block_savedest(block9780);
  Object closure9781 = createclosure(3, "_apply");
  setclosureframe(closure9781, stackframe);
  addtoclosure(closure9781, var_minIndentLevel);
  addtoclosure(closure9781, var_tok);
  addtoclosure(closure9781, selfslot);
  struct UserObject *uo9781 = (struct UserObject*)block9780;
  uo9781->data[0] = (Object)closure9781;
  Method *meth_meth_parser__apply9781 = addmethod2pos(block9780, "_apply", &meth_parser__apply9781, 0);
  int argcv_meth_parser__apply9781[] = {0};
  meth_meth_parser__apply9781->type = alloc_MethodType(1, argcv_meth_parser__apply9781);
  meth_meth_parser__apply9781->definitionModule = modulename;
  meth_meth_parser__apply9781->definitionLine = 3399;
// compiled block node returning block9780 (depth = 9)
  gc_frame_newslot(block9780);
// starting to compile block node (depth = 9)
  Object block9802 = alloc_Block(NULL, NULL, "parser", 3065);
  gc_frame_newslot(block9802);
// method "_apply"
  block_savedest(block9802);
  Object closure9803 = createclosure(2, "_apply");
  setclosureframe(closure9803, stackframe);
  addtoclosure(closure9803, var_tok);
  addtoclosure(closure9803, selfslot);
  struct UserObject *uo9803 = (struct UserObject*)block9802;
  uo9803->data[0] = (Object)closure9803;
  Method *meth_meth_parser__apply9803 = addmethod2pos(block9802, "_apply", &meth_parser__apply9803, 0);
  int argcv_meth_parser__apply9803[] = {0};
  meth_meth_parser__apply9803->type = alloc_MethodType(1, argcv_meth_parser__apply9803);
  meth_meth_parser__apply9803->definitionModule = modulename;
  meth_meth_parser__apply9803->definitionLine = 3399;
// compiled block node returning block9802 (depth = 9)
  gc_frame_newslot(block9802);
// call case 5: prelude request
  params[0] = block9780;
  params[1] = block9802;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9808 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9779);
// compiled call node returning call9808 (depth = 8)
// Begin line 3068
  setline(3068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9809 == NULL) {
    strlit9809 = alloc_String("");
    gc_root(strlit9809);
  }
// compiled string node returning strlit9809 (depth = 9)
  *var_line = strlit9809;
  if (strlit9809 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 3069
  setline(3069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9810 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe9812 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  Object call9813 = callmethodflags(*var_tok, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe9812);
// compiled member node returning call9813 (depth = 10)
  int op_slot_right_9811 = gc_frame_newslot(call9813);
// starting to compile num node (depth = 10)
  Object num9815 = alloc_Float64(1);
// compiled num node returning num9815 (depth = 10)
  int op_slot_left_9811 = gc_frame_newslot(num9815);
  params[0] = call9813;
  partcv[0] = 1;
  Object opresult9816 = callmethod(num9815, "..(1)", 1, partcv, params);
// compiled op node returning opresult9816 (depth = 9)
  gc_frame_newslot(opresult9816);
// starting to compile block node (depth = 9)
  Object block9817 = alloc_Block(NULL, NULL, "parser", 3069);
  gc_frame_newslot(block9817);
// method "_apply(_)"
  block_savedest(block9817);
  Object closure9818 = createclosure(2, "_apply(1)");
  setclosureframe(closure9818, stackframe);
  addtoclosure(closure9818, var_line);
  addtoclosure(closure9818, selfslot);
  struct UserObject *uo9818 = (struct UserObject*)block9817;
  uo9818->data[0] = (Object)closure9818;
  Method *meth_meth_parser__apply_40_1_41_9818 = addmethod2pos(block9817, "_apply(1)", &meth_parser__apply_40_1_41_9818, 0);
  int argcv_meth_parser__apply_40_1_41_9818[] = {1};
  meth_meth_parser__apply_40_1_41_9818->type = alloc_MethodType(1, argcv_meth_parser__apply_40_1_41_9818);
  meth_meth_parser__apply_40_1_41_9818->definitionModule = modulename;
  meth_meth_parser__apply_40_1_41_9818->definitionLine = 3399;
// compiled block node returning block9817 (depth = 9)
  gc_frame_newslot(block9817);
// call case 5: prelude request
  params[0] = opresult9816;
  params[1] = block9817;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9825 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9810);
// compiled call node returning call9825 (depth = 8)
// Begin line 3072
  setline(3072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9827 == NULL) {
    strlit9827 = alloc_String("}");
    gc_root(strlit9827);
  }
// compiled string node returning strlit9827 (depth = 10)
  int op_slot_right_9826 = gc_frame_newslot(strlit9827);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_line (depth = 10)
  int op_slot_left_9826 = gc_frame_newslot(*var_line);
  params[0] = strlit9827;
  partcv[0] = 1;
  Object opresult9829 = callmethod(*var_line, "++(1)", 1, partcv, params);
// compiled op node returning opresult9829 (depth = 9)
  *var_line = opresult9829;
  if (opresult9829 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 3073
  setline(3073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9831 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num9833 = alloc_Float64(0.9);
// compiled num node returning num9833 (depth = 10)
  int op_slot_right_9832 = gc_frame_newslot(num9833);
// starting to compile member node (depth = 10)
  int callframe9835 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call9836 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9835);
// compiled member node returning call9836 (depth = 10)
  int op_slot_left_9832 = gc_frame_newslot(call9836);
  params[0] = num9833;
  partcv[0] = 1;
  Object diff9837 = callmethod(call9836, "-(1)", 1, partcv, params);
// compiled op node returning diff9837 (depth = 9)
  gc_frame_newslot(diff9837);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_line (depth = 9)
  gc_frame_newslot(*var_line);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = diff9837;
  params[1] = *var_line;
  partcv[0] = 2;
  Object call9838 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9831);
// compiled call node returning call9838 (depth = 8)
// Begin line 3074
  setline(3074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9839 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9840 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9839);
// compiled call node returning call9840 (depth = 8)
// Begin line 3075
  setline(3075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9841 = gc_frame_new();
// starting to compile op node (depth = 9)
// Begin line 3076
  setline(3076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit9844 == NULL) {
    strlit9844 = alloc_String(". This is often caused by a missing '}'.");
    gc_root(strlit9844);
  }
// compiled string node returning strlit9844 (depth = 11)
  int op_slot_right_9843 = gc_frame_newslot(strlit9844);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_minIndentLevel (depth = 12)
  int op_slot_right_9846 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile string node (depth = 12)
  if (strlit9848 == NULL) {
    strlit9848 = alloc_String("at least ");
    gc_root(strlit9848);
  }
// compiled string node returning strlit9848 (depth = 12)
  int op_slot_left_9846 = gc_frame_newslot(strlit9848);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult9849 = callmethod(strlit9848, "++(1)", 1, partcv, params);
// compiled op node returning opresult9849 (depth = 11)
  int op_slot_left_9843 = gc_frame_newslot(opresult9849);
  params[0] = strlit9844;
  partcv[0] = 1;
  Object opresult9850 = callmethod(opresult9849, "++(1)", 1, partcv, params);
// compiled op node returning opresult9850 (depth = 10)
  int op_slot_right_9842 = gc_frame_newslot(opresult9850);
// Begin line 3075
  setline(3075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit9852 == NULL) {
    strlit9852 = alloc_String("the indentation for this line must be ");
    gc_root(strlit9852);
  }
// compiled string node returning strlit9852 (depth = 10)
  int op_slot_left_9842 = gc_frame_newslot(strlit9852);
  params[0] = opresult9850;
  partcv[0] = 1;
  Object opresult9853 = callmethod(strlit9852, "++(1)", 1, partcv, params);
// compiled op node returning opresult9853 (depth = 9)
  gc_frame_newslot(opresult9853);
// Begin line 3077
  setline(3077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe9854 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call9855 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9854);
// compiled member node returning call9855 (depth = 9)
  gc_frame_newslot(call9855);
// starting to compile member node (depth = 9)
  int callframe9856 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call9857 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9856);
// compiled member node returning call9857 (depth = 9)
  gc_frame_newslot(call9857);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 3075
  setline(3075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult9853;
  params[1] = call9855;
  params[2] = call9857;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9858 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe9841);
// compiled call node returning call9858 (depth = 8)
    gc_frame_newslot(call9858);
    if9733 = call9858;
  } else {
  }
// compiled if node returning if9733 (depth = 7)
    gc_frame_newslot(if9733);
    if9727 = if9733;
  } else {
// Begin line 3081
  setline(3081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 3079
  setline(3079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num9862 = alloc_Float64(1);
// compiled num node returning num9862 (depth = 10)
  int op_slot_right_9861 = gc_frame_newslot(num9862);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_minIndentLevel (depth = 10)
  int op_slot_left_9861 = gc_frame_newslot(*var_minIndentLevel);
  params[0] = num9862;
  partcv[0] = 1;
  Object sum9864 = callmethod(*var_minIndentLevel, "+(1)", 1, partcv, params);
// compiled op node returning sum9864 (depth = 9)
  int op_slot_right_9860 = gc_frame_newslot(sum9864);
// starting to compile member node (depth = 9)
  int callframe9866 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call9867 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe9866);
// compiled member node returning call9867 (depth = 9)
  int op_slot_left_9860 = gc_frame_newslot(call9867);
  params[0] = sum9864;
  partcv[0] = 1;
  Object opresult9868 = callmethod(call9867, ">(1)", 1, partcv, params);
// compiled op node returning opresult9868 (depth = 8)
  Object if9859 = done;
  if (istrue(opresult9868)) {
// Begin line 3080
  setline(3080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe9869 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call9870 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe9869);
// compiled member node returning call9870 (depth = 9)
  *var_minIndentLevel = call9870;
  if (call9870 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if9859 = done;
  } else {
// Begin line 3090
  setline(3090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 3081
  setline(3081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num9874 = alloc_Float64(1);
// compiled num node returning num9874 (depth = 10)
  int op_slot_right_9873 = gc_frame_newslot(num9874);
// starting to compile member node (depth = 10)
  int callframe9876 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastIndent (depth = 12)
  int op_slot_right_9877 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 12)
  int callframe9879 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  Object call9880 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe9879);
// compiled member node returning call9880 (depth = 12)
  int op_slot_left_9877 = gc_frame_newslot(call9880);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object diff9881 = callmethod(call9880, "-(1)", 1, partcv, params);
// compiled op node returning diff9881 (depth = 11)
  Object call9882 = callmethodflags(diff9881, "abs", 0, partcv, params, 0);
  gc_frame_end(callframe9876);
// compiled member node returning call9882 (depth = 10)
  int op_slot_left_9873 = gc_frame_newslot(call9882);
  params[0] = num9874;
  partcv[0] = 1;
  Object opresult9883 = callmethod(call9882, "==(1)", 1, partcv, params);
// compiled op node returning opresult9883 (depth = 9)
  Object if9872 = done;
  if (istrue(opresult9883)) {
// Begin line 3082
  setline(3082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9884 == NULL) {
    strlit9884 = alloc_String("the indentation for this line can't differ ");
    gc_root(strlit9884);
  }
// compiled string node returning strlit9884 (depth = 10)
  *var_m1 = strlit9884;
  if (strlit9884 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 9)
// Begin line 3083
  setline(3083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9885 == NULL) {
    strlit9885 = alloc_String("from that of the previous line by 1.""\x0a""  To start a block, or ");
    gc_root(strlit9885);
  }
// compiled string node returning strlit9885 (depth = 10)
  *var_m2 = strlit9885;
  if (strlit9885 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 9)
// Begin line 3084
  setline(3084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9886 == NULL) {
    strlit9886 = alloc_String("to signal a continuation line, increase the indent by 2 or more. ");
    gc_root(strlit9886);
  }
// compiled string node returning strlit9886 (depth = 10)
  *var_m3 = strlit9886;
  if (strlit9886 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 9)
// Begin line 3085
  setline(3085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9887 == NULL) {
    strlit9887 = alloc_String("To end a block, or end the continuation, decrease the indent ");
    gc_root(strlit9887);
  }
// compiled string node returning strlit9887 (depth = 10)
  *var_m4 = strlit9887;
  if (strlit9887 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 9)
// Begin line 3086
  setline(3086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9888 == NULL) {
    strlit9888 = alloc_String("to the prior level. Otherwise, use the same indent as the previous line.");
    gc_root(strlit9888);
  }
// compiled string node returning strlit9888 (depth = 10)
  *var_m5 = strlit9888;
  if (strlit9888 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 9)
// Begin line 3087
  setline(3087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_m5 (depth = 11)
  int op_slot_right_9889 = gc_frame_newslot(*var_m5);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_m4 (depth = 12)
  int op_slot_right_9891 = gc_frame_newslot(*var_m4);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_m3 (depth = 13)
  int op_slot_right_9893 = gc_frame_newslot(*var_m3);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_m2 (depth = 14)
  int op_slot_right_9895 = gc_frame_newslot(*var_m2);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_m1 (depth = 14)
  int op_slot_left_9895 = gc_frame_newslot(*var_m1);
  params[0] = *var_m2;
  partcv[0] = 1;
  Object opresult9897 = callmethod(*var_m1, "++(1)", 1, partcv, params);
// compiled op node returning opresult9897 (depth = 13)
  int op_slot_left_9893 = gc_frame_newslot(opresult9897);
  params[0] = *var_m3;
  partcv[0] = 1;
  Object opresult9898 = callmethod(opresult9897, "++(1)", 1, partcv, params);
// compiled op node returning opresult9898 (depth = 12)
  int op_slot_left_9891 = gc_frame_newslot(opresult9898);
  params[0] = *var_m4;
  partcv[0] = 1;
  Object opresult9899 = callmethod(opresult9898, "++(1)", 1, partcv, params);
// compiled op node returning opresult9899 (depth = 11)
  int op_slot_left_9889 = gc_frame_newslot(opresult9899);
  params[0] = *var_m5;
  partcv[0] = 1;
  Object opresult9900 = callmethod(opresult9899, "++(1)", 1, partcv, params);
// compiled op node returning opresult9900 (depth = 10)
  *var_msg = opresult9900;
  if (opresult9900 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 9)
// Begin line 3088
  setline(3088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe9901 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_msg (depth = 10)
  gc_frame_newslot(*var_msg);
// starting to compile member node (depth = 10)
  int callframe9902 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call9903 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe9902);
// compiled member node returning call9903 (depth = 10)
  gc_frame_newslot(call9903);
// starting to compile member node (depth = 10)
  int callframe9904 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call9905 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe9904);
// compiled member node returning call9905 (depth = 10)
  gc_frame_newslot(call9905);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = *var_msg;
  params[1] = call9903;
  params[2] = call9905;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call9906 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)", 2, partcv, params, 0);
  gc_frame_end(callframe9901);
// compiled call node returning call9906 (depth = 9)
    gc_frame_newslot(call9906);
    if9872 = call9906;
  } else {
  }
// compiled if node returning if9872 (depth = 8)
    gc_frame_newslot(if9872);
    if9859 = if9872;
  }
// compiled if node returning if9859 (depth = 7)
    gc_frame_newslot(if9859);
    if9727 = if9859;
  }
// compiled if node returning if9727 (depth = 6)
    gc_frame_newslot(if9727);
    if9720 = if9727;
  }
// compiled if node returning if9720 (depth = 5)
    gc_frame_newslot(if9720);
    if9695 = if9720;
  }
// compiled if node returning if9695 (depth = 4)
    gc_frame_newslot(if9695);
    if9688 = if9695;
  }
// compiled if node returning if9688 (depth = 3)
    gc_frame_newslot(if9688);
    if9685 = if9688;
  }
// compiled if node returning if9685 (depth = 2)
  gc_frame_end(frame);
  return if9685;
}
Object meth_parser__apply10003(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe10004 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call10005 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10004);
// compiled call node returning call10005 (depth = 5)
  gc_frame_end(frame);
  return call10005;
}
Object meth_parser__apply10084(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 10)
  int callframe10085 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_blocksOK (depth = 11)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call10086 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10085);
// compiled call node returning call10086 (depth = 10)
  gc_frame_end(frame);
  return call10086;
}
Object meth_parser__apply10008(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_btok = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  Object self = *(getfromclosure(closure, 8));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_dest = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "dest");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_val = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "val");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
// Begin line 3127
  setline(3127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 3130
  setline(3130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10011 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit10012 == NULL) {
    strlit10012 = alloc_String("bind");
    gc_root(strlit10012);
  }
// compiled string node returning strlit10012 (depth = 8)
  gc_frame_newslot(strlit10012);
// call case 4: self request
  params[0] = strlit10012;
  partcv[0] = 1;
  Object call10013 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10011);
// compiled call node returning call10013 (depth = 7)
  int op_slot_right_10010 = gc_frame_newslot(call10013);
// Begin line 3127
  setline(3127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 3129
  setline(3129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10017 == NULL) {
    strlit10017 = alloc_String("index");
    gc_root(strlit10017);
  }
// compiled string node returning strlit10017 (depth = 9)
  int op_slot_right_10016 = gc_frame_newslot(strlit10017);
// starting to compile member node (depth = 9)
  int callframe10019 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe10020 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  Object call10021 = callmethodflags(*var_values, "last", 0, partcv, params, 0);
  gc_frame_end(callframe10020);
// compiled member node returning call10021 (depth = 10)
  Object call10022 = callmethodflags(call10021, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe10019);
// compiled member node returning call10022 (depth = 9)
  int op_slot_left_10016 = gc_frame_newslot(call10022);
  params[0] = strlit10017;
  partcv[0] = 1;
  Object opresult10023 = callmethod(call10022, "==(1)", 1, partcv, params);
// compiled op node returning opresult10023 (depth = 8)
  int op_slot_right_10015 = gc_frame_newslot(opresult10023);
// Begin line 3127
  setline(3127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 3128
  setline(3128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10027 == NULL) {
    strlit10027 = alloc_String("member");
    gc_root(strlit10027);
  }
// compiled string node returning strlit10027 (depth = 10)
  int op_slot_right_10026 = gc_frame_newslot(strlit10027);
// starting to compile member node (depth = 10)
  int callframe10029 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe10030 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_values (depth = 12)
  Object call10031 = callmethodflags(*var_values, "last", 0, partcv, params, 0);
  gc_frame_end(callframe10030);
// compiled member node returning call10031 (depth = 11)
  Object call10032 = callmethodflags(call10031, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe10029);
// compiled member node returning call10032 (depth = 10)
  int op_slot_left_10026 = gc_frame_newslot(call10032);
  params[0] = strlit10027;
  partcv[0] = 1;
  Object opresult10033 = callmethod(call10032, "==(1)", 1, partcv, params);
// compiled op node returning opresult10033 (depth = 9)
  int op_slot_right_10025 = gc_frame_newslot(opresult10033);
// Begin line 3127
  setline(3127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10036 == NULL) {
    strlit10036 = alloc_String("identifier");
    gc_root(strlit10036);
  }
// compiled string node returning strlit10036 (depth = 10)
  int op_slot_right_10035 = gc_frame_newslot(strlit10036);
// starting to compile member node (depth = 10)
  int callframe10038 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe10039 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_values (depth = 12)
  Object call10040 = callmethodflags(*var_values, "last", 0, partcv, params, 0);
  gc_frame_end(callframe10039);
// compiled member node returning call10040 (depth = 11)
  Object call10041 = callmethodflags(call10040, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe10038);
// compiled member node returning call10041 (depth = 10)
  int op_slot_left_10035 = gc_frame_newslot(call10041);
  params[0] = strlit10036;
  partcv[0] = 1;
  Object opresult10042 = callmethod(call10041, "==(1)", 1, partcv, params);
// compiled op node returning opresult10042 (depth = 9)
  int op_slot_left_10025 = gc_frame_newslot(opresult10042);
  params[0] = opresult10033;
  partcv[0] = 1;
  Object opresult10043 = callmethod(opresult10042, "||(1)", 1, partcv, params);
// compiled op node returning opresult10043 (depth = 8)
  int op_slot_left_10015 = gc_frame_newslot(opresult10043);
  params[0] = opresult10023;
  partcv[0] = 1;
  Object opresult10044 = callmethod(opresult10043, "||(1)", 1, partcv, params);
// compiled op node returning opresult10044 (depth = 7)
  int op_slot_left_10010 = gc_frame_newslot(opresult10044);
  params[0] = call10013;
  partcv[0] = 1;
  Object opresult10045 = callmethod(opresult10044, "&&(1)", 1, partcv, params);
// compiled op node returning opresult10045 (depth = 6)
  Object if10009 = done;
  if (istrue(opresult10045)) {
// Begin line 3131
  setline(3131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe10046 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call10047 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe10046);
// compiled member node returning call10047 (depth = 7)
  *var_dest = call10047;
  if (call10047 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 3132
  setline(3132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10050 == NULL) {
    strlit10050 = alloc_String("lbrace");
    gc_root(strlit10050);
  }
// compiled string node returning strlit10050 (depth = 8)
  int op_slot_right_10049 = gc_frame_newslot(strlit10050);
// starting to compile member node (depth = 8)
  int callframe10052 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_dest (depth = 9)
  Object call10053 = callmethodflags(*var_dest, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe10052);
// compiled member node returning call10053 (depth = 8)
  int op_slot_left_10049 = gc_frame_newslot(call10053);
  params[0] = strlit10050;
  partcv[0] = 1;
  Object opresult10054 = callmethod(call10053, "==(1)", 1, partcv, params);
// compiled op node returning opresult10054 (depth = 7)
  Object if10048 = done;
  if (istrue(opresult10054)) {
// Begin line 3133
  setline(3133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10056 == NULL) {
    strlit10056 = alloc_String("");
    gc_root(strlit10056);
  }
// compiled string node returning strlit10056 (depth = 9)
  int op_slot_right_10055 = gc_frame_newslot(strlit10056);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe10059 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call10060 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10059);
// compiled member node returning call10060 (depth = 10)
  int op_slot_right_10058 = gc_frame_newslot(call10060);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit10063 == NULL) {
    strlit10063 = alloc_String(", sym.line = ");
    gc_root(strlit10063);
  }
// compiled string node returning strlit10063 (depth = 11)
  int op_slot_right_10062 = gc_frame_newslot(strlit10063);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  int op_slot_right_10065 = gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 12)
  if (strlit10067 == NULL) {
    strlit10067 = alloc_String("sym = ");
    gc_root(strlit10067);
  }
// compiled string node returning strlit10067 (depth = 12)
  int op_slot_left_10065 = gc_frame_newslot(strlit10067);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult10068 = callmethod(strlit10067, "++(1)", 1, partcv, params);
// compiled op node returning opresult10068 (depth = 11)
  int op_slot_left_10062 = gc_frame_newslot(opresult10068);
  params[0] = strlit10063;
  partcv[0] = 1;
  Object opresult10069 = callmethod(opresult10068, "++(1)", 1, partcv, params);
// compiled op node returning opresult10069 (depth = 10)
  int op_slot_left_10058 = gc_frame_newslot(opresult10069);
  params[0] = call10060;
  partcv[0] = 1;
  Object opresult10070 = callmethod(opresult10069, "++(1)", 1, partcv, params);
// compiled op node returning opresult10070 (depth = 9)
  int op_slot_left_10055 = gc_frame_newslot(opresult10070);
  params[0] = strlit10056;
  partcv[0] = 1;
  Object opresult10071 = callmethod(opresult10070, "++(1)", 1, partcv, params);
// compiled op node returning opresult10071 (depth = 8)
  params[0] = opresult10071;
  Object call10072 = gracelib_print(NULL, 1,  params);
// compiled call node returning call10072 (depth = 7)
// Begin line 3134
  setline(3134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10073 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit10074 == NULL) {
    strlit10074 = alloc_String("popped lbrace token while parsing statement");
    gc_root(strlit10074);
  }
// compiled string node returning strlit10074 (depth = 8)
  gc_frame_newslot(strlit10074);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe10075 = gc_frame_new();
// call case 5: prelude request
  Object call10076 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10075);
// compiled member node returning call10076 (depth = 8)
  params[0] = strlit10074;
  partcv[0] = 1;
  Object call10077 = callmethodflags(call10076, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10073);
// compiled call node returning call10077 (depth = 7)
    gc_frame_newslot(call10077);
    if10048 = call10077;
  } else {
  }
// compiled if node returning if10048 (depth = 6)
// Begin line 3136
  setline(3136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe10078 = gc_frame_new();
// call case 4: self request
  Object call10079 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10078);
// compiled member node returning call10079 (depth = 6)
// Begin line 3137
  setline(3137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe10081 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe10082 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block10083 = alloc_Block(NULL, NULL, "parser", 3137);
  gc_frame_newslot(block10083);
// method "_apply"
  block_savedest(block10083);
  Object closure10084 = createclosure(2, "_apply");
  setclosureframe(closure10084, stackframe);
  addtoclosure(closure10084, var_blocksOK);
  addtoclosure(closure10084, selfslot);
  struct UserObject *uo10084 = (struct UserObject*)block10083;
  uo10084->data[0] = (Object)closure10084;
  Method *meth_meth_parser__apply10084 = addmethod2pos(block10083, "_apply", &meth_parser__apply10084, 0);
  int argcv_meth_parser__apply10084[] = {0};
  meth_meth_parser__apply10084->type = alloc_MethodType(1, argcv_meth_parser__apply10084);
  meth_meth_parser__apply10084->definitionModule = modulename;
  meth_meth_parser__apply10084->definitionLine = 3399;
// compiled block node returning block10083 (depth = 9)
  gc_frame_newslot(block10083);
// call case 4: self request
  params[0] = block10083;
  partcv[0] = 1;
  Object call10088 = callmethodflags(self, "didConsume(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10082);
// compiled call node returning call10088 (depth = 8)
  Object call10089 = callmethodflags(call10088, "not", 0, partcv, params, 0);
  gc_frame_end(callframe10081);
// compiled member node returning call10089 (depth = 7)
  Object if10080 = done;
  if (istrue(call10089)) {
// Begin line 3138
  setline(3138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile array node (depth = 8)
  Object array10090 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10090 (depth = 8)
  *var_suggestions = array10090;
  if (array10090 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 3139
  setline(3139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe10091 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe10092 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call10093 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe10092);
// compiled member node returning call10093 (depth = 9)
  Object call10094 = callmethodflags(call10093, "new", 0, partcv, params, 0);
  gc_frame_end(callframe10091);
// compiled member node returning call10094 (depth = 8)
  *var_suggestion = call10094;
  if (call10094 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 3140
  setline(3140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10095 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array10096 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit10097 == NULL) {
    strlit10097 = alloc_String("rbrace");
    gc_root(strlit10097);
  }
// compiled string node returning strlit10097 (depth = 10)
  params[0] = strlit10097;
  partcv[0] = 1;
  callmethodflags(array10096, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array10096 (depth = 9)
  gc_frame_newslot(array10096);
// call case 4: self request
  params[0] = array10096;
  partcv[0] = 1;
  Object call10098 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10095);
// compiled call node returning call10098 (depth = 8)
  *var_nextTok = call10098;
  if (call10098 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 7)
// Begin line 3141
  setline(3141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_10100 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_10100 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult10102 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult10102 (depth = 8)
  Object if10099 = done;
  if (istrue(opresult10102)) {
// Begin line 3142
  setline(3142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10103 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit10104 == NULL) {
    strlit10104 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit10104);
  }
// compiled string node returning strlit10104 (depth = 9)
  gc_frame_newslot(strlit10104);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit10104;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10105 = callmethodflags(*var_suggestion, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10103);
// compiled call node returning call10105 (depth = 8)
    gc_frame_newslot(call10105);
    if10099 = call10105;
  } else {
// Begin line 3144
  setline(3144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10106 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
  int callframe10107 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  Object call10108 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe10107);
// compiled member node returning call10108 (depth = 9)
  gc_frame_newslot(call10108);
// starting to compile identifier node (depth = 9)
  Object bool10109 = alloc_Boolean(1);
// compiled identifier node returning bool10109 (depth = 9)
  gc_frame_newslot(bool10109);
// starting to compile identifier node (depth = 9)
  Object bool10110 = alloc_Boolean(0);
// compiled identifier node returning bool10110 (depth = 9)
  gc_frame_newslot(bool10110);
// starting to compile string node (depth = 9)
  if (strlit10111 == NULL) {
    strlit10111 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit10111);
  }
// compiled string node returning strlit10111 (depth = 9)
  gc_frame_newslot(strlit10111);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call10108;
  params[2] = bool10109;
  params[3] = bool10110;
  params[4] = strlit10111;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call10112 = callmethodflags(*var_suggestion, "replaceTokenRange(2)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe10106);
// compiled call node returning call10112 (depth = 8)
    gc_frame_newslot(call10112);
    if10099 = call10112;
  }
// compiled if node returning if10099 (depth = 7)
// Begin line 3146
  setline(3146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10113 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10114 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10113);
// compiled call node returning call10114 (depth = 7)
// Begin line 3147
  setline(3147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe10115 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe10116 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call10117 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe10116);
// compiled member node returning call10117 (depth = 9)
  Object call10118 = callmethodflags(call10117, "new", 0, partcv, params, 0);
  gc_frame_end(callframe10115);
// compiled member node returning call10118 (depth = 8)
  *var_suggestion = call10118;
  if (call10118 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 3148
  setline(3148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10120 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
  int callframe10121 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  Object call10122 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe10121);
// compiled member node returning call10122 (depth = 8)
  gc_frame_newslot(call10122);
// starting to compile identifier node (depth = 8)
  Object bool10123 = alloc_Boolean(1);
// compiled identifier node returning bool10123 (depth = 8)
  gc_frame_newslot(bool10123);
// starting to compile identifier node (depth = 8)
  Object bool10124 = alloc_Boolean(0);
// compiled identifier node returning bool10124 (depth = 8)
  gc_frame_newslot(bool10124);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = call10122;
  params[2] = bool10123;
  params[3] = bool10124;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10125 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe10120);
// compiled call node returning call10125 (depth = 7)
// Begin line 3149
  setline(3149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10126 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10127 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10126);
// compiled call node returning call10127 (depth = 7)
// Begin line 3150
  setline(3150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10128 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit10129 == NULL) {
    strlit10129 = alloc_String("a valid expression must follow ':='.");
    gc_root(strlit10129);
  }
// compiled string node returning strlit10129 (depth = 8)
  gc_frame_newslot(strlit10129);
// Begin line 3151
  setline(3151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe10130 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call10131 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10130);
// compiled member node returning call10131 (depth = 8)
  gc_frame_newslot(call10131);
// starting to compile member node (depth = 8)
  int callframe10132 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call10133 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10132);
// compiled member node returning call10133 (depth = 8)
  gc_frame_newslot(call10133);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 3150
  setline(3150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit10129;
  params[1] = call10131;
  params[2] = call10133;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10134 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe10128);
// compiled call node returning call10134 (depth = 7)
    gc_frame_newslot(call10134);
    if10080 = call10134;
  } else {
  }
// compiled if node returning if10080 (depth = 6)
// Begin line 3153
  setline(3153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe10135 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call10136 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe10135);
// compiled member node returning call10136 (depth = 7)
  *var_val = call10136;
  if (call10136 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 3154
  setline(3154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10137 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe10138 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_btok (depth = 8)
  Object call10139 = callmethodflags(*var_btok, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10138);
// compiled member node returning call10139 (depth = 7)
  gc_frame_newslot(call10139);
// starting to compile member node (depth = 7)
  int callframe10140 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_btok (depth = 8)
  Object call10141 = callmethodflags(*var_btok, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10140);
// compiled member node returning call10141 (depth = 7)
  gc_frame_newslot(call10141);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  params[0] = call10139;
  params[1] = call10141;
  partcv[0] = 2;
  Object call10142 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe10137);
// compiled call node returning call10142 (depth = 6)
// Begin line 3155
  setline(3155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10143 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_dest (depth = 8)
  gc_frame_newslot(*var_dest);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_val (depth = 8)
  gc_frame_newslot(*var_val);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe10144 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  Object call10145 = callmethodflags(*var_ast, "bindNode", 0, partcv, params, 0);
  gc_frame_end(callframe10144);
// compiled member node returning call10145 (depth = 8)
  params[0] = *var_dest;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call10146 = callmethodflags(call10145, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe10143);
// compiled call node returning call10146 (depth = 7)
  *var_o = call10146;
  if (call10146 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 3156
  setline(3156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10147 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10148 = callmethodflags(*var_values, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10147);
// compiled call node returning call10148 (depth = 6)
    gc_frame_newslot(call10148);
    if10009 = call10148;
  } else {
  }
// compiled if node returning if10009 (depth = 5)
  gc_frame_end(frame);
  return if10009;
}
Object meth_parser_statement9907(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 72, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementIndent = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_errormessages = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  Object *var_indentFreePass = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_oldLine = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "oldLine");
// Begin line 3099
  setline(3099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe9908 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call9909 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe9908);
// compiled member node returning call9909 (depth = 3)
  *var_statementIndent = call9909;
  if (call9909 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 3100
  setline(3100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 3101
  setline(3101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3102
  setline(3102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe9912 = gc_frame_new();
// call case 4: self request
  Object call9913 = callmethodflags(self, "checkIndent", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9912);
// compiled member node returning call9913 (depth = 2)
// Begin line 3103
  setline(3103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9915 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9916 == NULL) {
    strlit9916 = alloc_String("keyword");
    gc_root(strlit9916);
  }
// compiled string node returning strlit9916 (depth = 4)
  gc_frame_newslot(strlit9916);
// call case 4: self request
  params[0] = strlit9916;
  partcv[0] = 1;
  Object call9917 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9915);
// compiled call node returning call9917 (depth = 3)
  Object if9914 = done;
  if (istrue(call9917)) {
// Begin line 3104
  setline(3104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9920 == NULL) {
    strlit9920 = alloc_String("var");
    gc_root(strlit9920);
  }
// compiled string node returning strlit9920 (depth = 5)
  int op_slot_right_9919 = gc_frame_newslot(strlit9920);
// starting to compile member node (depth = 5)
  int callframe9922 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call9923 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9922);
// compiled member node returning call9923 (depth = 5)
  int op_slot_left_9919 = gc_frame_newslot(call9923);
  params[0] = strlit9920;
  partcv[0] = 1;
  Object opresult9924 = callmethod(call9923, "==(1)", 1, partcv, params);
// compiled op node returning opresult9924 (depth = 4)
  Object if9918 = done;
  if (istrue(opresult9924)) {
// Begin line 3105
  setline(3105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9925 = gc_frame_new();
// call case 4: self request
  Object call9926 = callmethodflags(self, "vardec", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9925);
// compiled member node returning call9926 (depth = 4)
    gc_frame_newslot(call9926);
    if9918 = call9926;
  } else {
// Begin line 3108
  setline(3108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3106
  setline(3106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9929 == NULL) {
    strlit9929 = alloc_String("def");
    gc_root(strlit9929);
  }
// compiled string node returning strlit9929 (depth = 6)
  int op_slot_right_9928 = gc_frame_newslot(strlit9929);
// starting to compile member node (depth = 6)
  int callframe9931 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call9932 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9931);
// compiled member node returning call9932 (depth = 6)
  int op_slot_left_9928 = gc_frame_newslot(call9932);
  params[0] = strlit9929;
  partcv[0] = 1;
  Object opresult9933 = callmethod(call9932, "==(1)", 1, partcv, params);
// compiled op node returning opresult9933 (depth = 5)
  Object if9927 = done;
  if (istrue(opresult9933)) {
// Begin line 3107
  setline(3107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe9934 = gc_frame_new();
// call case 4: self request
  Object call9935 = callmethodflags(self, "defdec", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9934);
// compiled member node returning call9935 (depth = 5)
    gc_frame_newslot(call9935);
    if9927 = call9935;
  } else {
// Begin line 3110
  setline(3110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3108
  setline(3108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9938 == NULL) {
    strlit9938 = alloc_String("import");
    gc_root(strlit9938);
  }
// compiled string node returning strlit9938 (depth = 7)
  int op_slot_right_9937 = gc_frame_newslot(strlit9938);
// starting to compile member node (depth = 7)
  int callframe9940 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call9941 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9940);
// compiled member node returning call9941 (depth = 7)
  int op_slot_left_9937 = gc_frame_newslot(call9941);
  params[0] = strlit9938;
  partcv[0] = 1;
  Object opresult9942 = callmethod(call9941, "==(1)", 1, partcv, params);
// compiled op node returning opresult9942 (depth = 6)
  Object if9936 = done;
  if (istrue(opresult9942)) {
// Begin line 3109
  setline(3109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe9943 = gc_frame_new();
// call case 4: self request
  Object call9944 = callmethodflags(self, "doimport", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9943);
// compiled member node returning call9944 (depth = 6)
    gc_frame_newslot(call9944);
    if9936 = call9944;
  } else {
// Begin line 3112
  setline(3112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3110
  setline(3110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9947 == NULL) {
    strlit9947 = alloc_String("dialect");
    gc_root(strlit9947);
  }
// compiled string node returning strlit9947 (depth = 8)
  int op_slot_right_9946 = gc_frame_newslot(strlit9947);
// starting to compile member node (depth = 8)
  int callframe9949 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call9950 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9949);
// compiled member node returning call9950 (depth = 8)
  int op_slot_left_9946 = gc_frame_newslot(call9950);
  params[0] = strlit9947;
  partcv[0] = 1;
  Object opresult9951 = callmethod(call9950, "==(1)", 1, partcv, params);
// compiled op node returning opresult9951 (depth = 7)
  Object if9945 = done;
  if (istrue(opresult9951)) {
// Begin line 3111
  setline(3111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe9952 = gc_frame_new();
// call case 4: self request
  Object call9953 = callmethodflags(self, "dodialect", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9952);
// compiled member node returning call9953 (depth = 7)
    gc_frame_newslot(call9953);
    if9945 = call9953;
  } else {
// Begin line 3114
  setline(3114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 3112
  setline(3112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9956 == NULL) {
    strlit9956 = alloc_String("type");
    gc_root(strlit9956);
  }
// compiled string node returning strlit9956 (depth = 9)
  int op_slot_right_9955 = gc_frame_newslot(strlit9956);
// starting to compile member node (depth = 9)
  int callframe9958 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call9959 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9958);
// compiled member node returning call9959 (depth = 9)
  int op_slot_left_9955 = gc_frame_newslot(call9959);
  params[0] = strlit9956;
  partcv[0] = 1;
  Object opresult9960 = callmethod(call9959, "==(1)", 1, partcv, params);
// compiled op node returning opresult9960 (depth = 8)
  Object if9954 = done;
  if (istrue(opresult9960)) {
// Begin line 3113
  setline(3113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe9961 = gc_frame_new();
// call case 4: self request
  Object call9962 = callmethodflags(self, "typedec", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9961);
// compiled member node returning call9962 (depth = 8)
    gc_frame_newslot(call9962);
    if9954 = call9962;
  } else {
// Begin line 3116
  setline(3116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 3114
  setline(3114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9965 == NULL) {
    strlit9965 = alloc_String("class");
    gc_root(strlit9965);
  }
// compiled string node returning strlit9965 (depth = 10)
  int op_slot_right_9964 = gc_frame_newslot(strlit9965);
// starting to compile member node (depth = 10)
  int callframe9967 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call9968 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9967);
// compiled member node returning call9968 (depth = 10)
  int op_slot_left_9964 = gc_frame_newslot(call9968);
  params[0] = strlit9965;
  partcv[0] = 1;
  Object opresult9969 = callmethod(call9968, "==(1)", 1, partcv, params);
// compiled op node returning opresult9969 (depth = 9)
  Object if9963 = done;
  if (istrue(opresult9969)) {
// Begin line 3115
  setline(3115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe9970 = gc_frame_new();
// call case 4: self request
  Object call9971 = callmethodflags(self, "doclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9970);
// compiled member node returning call9971 (depth = 9)
    gc_frame_newslot(call9971);
    if9963 = call9971;
  } else {
// Begin line 3118
  setline(3118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 3116
  setline(3116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit9974 == NULL) {
    strlit9974 = alloc_String("trait");
    gc_root(strlit9974);
  }
// compiled string node returning strlit9974 (depth = 11)
  int op_slot_right_9973 = gc_frame_newslot(strlit9974);
// starting to compile member node (depth = 11)
  int callframe9976 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  Object call9977 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9976);
// compiled member node returning call9977 (depth = 11)
  int op_slot_left_9973 = gc_frame_newslot(call9977);
  params[0] = strlit9974;
  partcv[0] = 1;
  Object opresult9978 = callmethod(call9977, "==(1)", 1, partcv, params);
// compiled op node returning opresult9978 (depth = 10)
  Object if9972 = done;
  if (istrue(opresult9978)) {
// Begin line 3117
  setline(3117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
  int callframe9979 = gc_frame_new();
// call case 4: self request
  Object call9980 = callmethodflags(self, "doclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9979);
// compiled member node returning call9980 (depth = 10)
    gc_frame_newslot(call9980);
    if9972 = call9980;
  } else {
// Begin line 3120
  setline(3120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 3118
  setline(3118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit9983 == NULL) {
    strlit9983 = alloc_String("factory");
    gc_root(strlit9983);
  }
// compiled string node returning strlit9983 (depth = 12)
  int op_slot_right_9982 = gc_frame_newslot(strlit9983);
// starting to compile member node (depth = 12)
  int callframe9985 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  Object call9986 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9985);
// compiled member node returning call9986 (depth = 12)
  int op_slot_left_9982 = gc_frame_newslot(call9986);
  params[0] = strlit9983;
  partcv[0] = 1;
  Object opresult9987 = callmethod(call9986, "==(1)", 1, partcv, params);
// compiled op node returning opresult9987 (depth = 11)
  Object if9981 = done;
  if (istrue(opresult9987)) {
// Begin line 3119
  setline(3119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
  int callframe9988 = gc_frame_new();
// call case 4: self request
  Object call9989 = callmethodflags(self, "dofactoryMethod", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9988);
// compiled member node returning call9989 (depth = 11)
    gc_frame_newslot(call9989);
    if9981 = call9989;
  } else {
// Begin line 3122
  setline(3122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 3120
  setline(3120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit9992 == NULL) {
    strlit9992 = alloc_String("return");
    gc_root(strlit9992);
  }
// compiled string node returning strlit9992 (depth = 13)
  int op_slot_right_9991 = gc_frame_newslot(strlit9992);
// starting to compile member node (depth = 13)
  int callframe9994 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  Object call9995 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe9994);
// compiled member node returning call9995 (depth = 13)
  int op_slot_left_9991 = gc_frame_newslot(call9995);
  params[0] = strlit9992;
  partcv[0] = 1;
  Object opresult9996 = callmethod(call9995, "==(1)", 1, partcv, params);
// compiled op node returning opresult9996 (depth = 12)
  Object if9990 = done;
  if (istrue(opresult9996)) {
// Begin line 3121
  setline(3121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
  int callframe9997 = gc_frame_new();
// call case 4: self request
  Object call9998 = callmethodflags(self, "doreturn", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9997);
// compiled member node returning call9998 (depth = 12)
    gc_frame_newslot(call9998);
    if9990 = call9998;
  } else {
// Begin line 3123
  setline(3123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe9999 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call10000 = callmethodflags(self, "expression(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9999);
// compiled call node returning call10000 (depth = 12)
    gc_frame_newslot(call10000);
    if9990 = call10000;
  }
// compiled if node returning if9990 (depth = 11)
    gc_frame_newslot(if9990);
    if9981 = if9990;
  }
// compiled if node returning if9981 (depth = 10)
    gc_frame_newslot(if9981);
    if9972 = if9981;
  }
// compiled if node returning if9972 (depth = 9)
    gc_frame_newslot(if9972);
    if9963 = if9972;
  }
// compiled if node returning if9963 (depth = 8)
    gc_frame_newslot(if9963);
    if9954 = if9963;
  }
// compiled if node returning if9954 (depth = 7)
    gc_frame_newslot(if9954);
    if9945 = if9954;
  }
// compiled if node returning if9945 (depth = 6)
    gc_frame_newslot(if9945);
    if9936 = if9945;
  }
// compiled if node returning if9936 (depth = 5)
    gc_frame_newslot(if9936);
    if9927 = if9936;
  }
// compiled if node returning if9927 (depth = 4)
    gc_frame_newslot(if9927);
    if9918 = if9927;
  }
// compiled if node returning if9918 (depth = 3)
    gc_frame_newslot(if9918);
    if9914 = if9918;
  } else {
// Begin line 3126
  setline(3126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10001 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block10002 = alloc_Block(NULL, NULL, "parser", 3126);
  gc_frame_newslot(block10002);
// method "_apply"
  block_savedest(block10002);
  Object closure10003 = createclosure(2, "_apply");
  setclosureframe(closure10003, stackframe);
  addtoclosure(closure10003, var_blocksOK);
  addtoclosure(closure10003, selfslot);
  struct UserObject *uo10003 = (struct UserObject*)block10002;
  uo10003->data[0] = (Object)closure10003;
  Method *meth_meth_parser__apply10003 = addmethod2pos(block10002, "_apply", &meth_parser__apply10003, 0);
  int argcv_meth_parser__apply10003[] = {0};
  meth_meth_parser__apply10003->type = alloc_MethodType(1, argcv_meth_parser__apply10003);
  meth_meth_parser__apply10003->definitionModule = modulename;
  meth_meth_parser__apply10003->definitionLine = 3399;
// compiled block node returning block10002 (depth = 4)
  gc_frame_newslot(block10002);
// starting to compile block node (depth = 4)
  Object block10007 = alloc_Block(NULL, NULL, "parser", 3126);
  gc_frame_newslot(block10007);
// method "_apply"
  block_savedest(block10007);
  Object closure10008 = createclosure(9, "_apply");
  setclosureframe(closure10008, stackframe);
  addtoclosure(closure10008, var_values);
  addtoclosure(closure10008, var_sym);
  addtoclosure(closure10008, var_blocksOK);
  addtoclosure(closure10008, var_errormessages);
  addtoclosure(closure10008, var_lastToken);
  addtoclosure(closure10008, var_btok);
  addtoclosure(closure10008, var_util);
  addtoclosure(closure10008, var_ast);
  addtoclosure(closure10008, selfslot);
  struct UserObject *uo10008 = (struct UserObject*)block10007;
  uo10008->data[0] = (Object)closure10008;
  Method *meth_meth_parser__apply10008 = addmethod2pos(block10007, "_apply", &meth_parser__apply10008, 0);
  int argcv_meth_parser__apply10008[] = {0};
  meth_meth_parser__apply10008->type = alloc_MethodType(1, argcv_meth_parser__apply10008);
  meth_meth_parser__apply10008->definitionModule = modulename;
  meth_meth_parser__apply10008->definitionLine = 3399;
// compiled block node returning block10007 (depth = 4)
  gc_frame_newslot(block10007);
// call case 4: self request
  params[0] = block10002;
  params[1] = block10007;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10150 = callmethodflags(self, "ifConsume(1)then(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10001);
// compiled call node returning call10150 (depth = 3)
    gc_frame_newslot(call10150);
    if9914 = call10150;
  }
// compiled if node returning if9914 (depth = 2)
// Begin line 3160
  setline(3160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe10151 = gc_frame_new();
// call case 4: self request
  Object call10152 = callmethodflags(self, "reconcileComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10151);
// compiled member node returning call10152 (depth = 2)
// Begin line 3161
  setline(3161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10154 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10155 == NULL) {
    strlit10155 = alloc_String("eof");
    gc_root(strlit10155);
  }
// compiled string node returning strlit10155 (depth = 4)
  gc_frame_newslot(strlit10155);
// call case 4: self request
  params[0] = strlit10155;
  partcv[0] = 1;
  Object call10156 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10154);
// compiled call node returning call10156 (depth = 3)
  Object if10153 = done;
  if (istrue(call10156)) {
// Begin line 3162
  setline(3162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool10157 = alloc_Boolean(1);
// compiled identifier node returning bool10157 (depth = 4)
  return bool10157;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if10153 = undefined;
  } else {
  }
// compiled if node returning if10153 (depth = 2)
// Begin line 3164
  setline(3164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10159 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10160 == NULL) {
    strlit10160 = alloc_String("semicolon");
    gc_root(strlit10160);
  }
// compiled string node returning strlit10160 (depth = 4)
  gc_frame_newslot(strlit10160);
// call case 4: self request
  params[0] = strlit10160;
  partcv[0] = 1;
  Object call10161 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10159);
// compiled call node returning call10161 (depth = 3)
  Object if10158 = done;
  if (istrue(call10161)) {
// Begin line 3165
  setline(3165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10162 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10163 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10162);
// compiled member node returning call10163 (depth = 4)
  *var_oldLine = call10163;
  if (call10163 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 3166
  setline(3166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe10164 = gc_frame_new();
// call case 4: self request
  Object call10165 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10164);
// compiled member node returning call10165 (depth = 3)
// Begin line 3167
  setline(3167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_oldLine (depth = 5)
  int op_slot_right_10167 = gc_frame_newslot(*var_oldLine);
// starting to compile member node (depth = 5)
  int callframe10169 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call10170 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10169);
// compiled member node returning call10170 (depth = 5)
  int op_slot_left_10167 = gc_frame_newslot(call10170);
  params[0] = *var_oldLine;
  partcv[0] = 1;
  Object opresult10171 = callmethod(call10170, "==(1)", 1, partcv, params);
// compiled op node returning opresult10171 (depth = 4)
  Object if10166 = done;
  if (istrue(opresult10171)) {
// Begin line 3168
  setline(3168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool10172 = alloc_Boolean(1);
// compiled identifier node returning bool10172 (depth = 5)
  *var_indentFreePass = bool10172;
  if (bool10172 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10166 = done;
  } else {
  }
// compiled if node returning if10166 (depth = 3)
    gc_frame_newslot(if10166);
    if10158 = if10166;
  } else {
// Begin line 3171
  setline(3171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe10174 = gc_frame_new();
// call case 4: self request
  Object call10175 = callmethodflags(self, "checkUnexpectedTokenAfterStatement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10174);
// compiled member node returning call10175 (depth = 3)
    gc_frame_newslot(call10175);
    if10158 = call10175;
  }
// compiled if node returning if10158 (depth = 2)
  gc_frame_end(frame);
  return if10158;
}
Object meth_parser__apply10234(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_previousCommentToken = getfromclosure(closure, 1);
  Object *var_tokens = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 3191
  setline(3191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  *var_previousCommentToken = *var_sym;
  if (*var_sym == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 3192
  setline(3192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10236 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  Object call10237 = callmethodflags(*var_tokens, "poll", 0, partcv, params, 0);
  gc_frame_end(callframe10236);
// compiled member node returning call10237 (depth = 5)
  *var_sym = call10237;
  if (call10237 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 3193
  setline(3193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10242 = alloc_Float64(1);
// compiled num node returning num10242 (depth = 7)
  int op_slot_right_10241 = gc_frame_newslot(num10242);
// starting to compile member node (depth = 7)
  int callframe10244 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_previousCommentToken (depth = 8)
  Object call10245 = callmethodflags(*var_previousCommentToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10244);
// compiled member node returning call10245 (depth = 7)
  int op_slot_left_10241 = gc_frame_newslot(call10245);
  params[0] = num10242;
  partcv[0] = 1;
  Object sum10246 = callmethod(call10245, "+(1)", 1, partcv, params);
// compiled op node returning sum10246 (depth = 6)
  int op_slot_right_10240 = gc_frame_newslot(sum10246);
// starting to compile member node (depth = 6)
  int callframe10248 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call10249 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10248);
// compiled member node returning call10249 (depth = 6)
  int op_slot_left_10240 = gc_frame_newslot(call10249);
  params[0] = sum10246;
  partcv[0] = 1;
  Object opresult10250 = callmethod(call10249, ">(1)", 1, partcv, params);
// compiled op node returning opresult10250 (depth = 5)
  Object if10239 = done;
  if (istrue(opresult10250)) {
// starting to compile member node (depth = 5)
  int callframe10251 = gc_frame_new();
// call case 4: self request
  Object call10252 = callmethodflags(self, "noteBlank", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10251);
// compiled member node returning call10252 (depth = 5)
    gc_frame_newslot(call10252);
    if10239 = call10252;
  } else {
  }
// compiled if node returning if10239 (depth = 4)
// Begin line 3194
  setline(3194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10253 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10254 == NULL) {
    strlit10254 = alloc_String("comment");
    gc_root(strlit10254);
  }
// compiled string node returning strlit10254 (depth = 5)
  gc_frame_newslot(strlit10254);
// call case 4: self request
  params[0] = strlit10254;
  partcv[0] = 1;
  Object call10255 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10253);
// compiled call node returning call10255 (depth = 4)
  gc_frame_end(frame);
  return call10255;
}
Object meth_parser__apply10258(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_o = getfromclosure(closure, 3);
  Object *var_comments = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3196
  setline(3196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10259 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe10260 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call10261 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10260);
// compiled member node returning call10261 (depth = 5)
  gc_frame_newslot(call10261);
// starting to compile member node (depth = 5)
  int callframe10262 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call10263 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10262);
// compiled member node returning call10263 (depth = 5)
  gc_frame_newslot(call10263);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call10261;
  params[1] = call10263;
  partcv[0] = 2;
  Object call10264 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe10259);
// compiled call node returning call10264 (depth = 4)
// Begin line 3197
  setline(3197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10265 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe10266 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call10267 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe10266);
// compiled member node returning call10267 (depth = 6)
  gc_frame_newslot(call10267);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10268 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  Object call10269 = callmethodflags(*var_ast, "commentNode", 0, partcv, params, 0);
  gc_frame_end(callframe10268);
// compiled member node returning call10269 (depth = 6)
  params[0] = call10267;
  partcv[0] = 1;
  Object call10270 = callmethodflags(call10269, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10265);
// compiled call node returning call10270 (depth = 5)
  *var_o = call10270;
  if (call10270 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 3198
  setline(3198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10275 = alloc_Float64(1);
// compiled num node returning num10275 (depth = 7)
  int op_slot_right_10274 = gc_frame_newslot(num10275);
// starting to compile member node (depth = 7)
  int callframe10277 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call10278 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10277);
// compiled member node returning call10278 (depth = 7)
  int op_slot_left_10274 = gc_frame_newslot(call10278);
  params[0] = num10275;
  partcv[0] = 1;
  Object diff10279 = callmethod(call10278, "-(1)", 1, partcv, params);
// compiled op node returning diff10279 (depth = 6)
  int op_slot_right_10273 = gc_frame_newslot(diff10279);
// starting to compile member node (depth = 6)
  int callframe10281 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe10282 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_comments (depth = 8)
  Object call10283 = callmethodflags(*var_comments, "last", 0, partcv, params, 0);
  gc_frame_end(callframe10282);
// compiled member node returning call10283 (depth = 7)
  Object call10284 = callmethodflags(call10283, "endLine", 0, partcv, params, 0);
  gc_frame_end(callframe10281);
// compiled member node returning call10284 (depth = 6)
  int op_slot_left_10273 = gc_frame_newslot(call10284);
  params[0] = diff10279;
  partcv[0] = 1;
  Object opresult10285 = callmethod(call10284, "==(1)", 1, partcv, params);
// compiled op node returning opresult10285 (depth = 5)
  Object if10272 = done;
  if (istrue(opresult10285)) {
// Begin line 3199
  setline(3199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10286 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10287 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_comments (depth = 7)
  Object call10288 = callmethodflags(*var_comments, "last", 0, partcv, params, 0);
  gc_frame_end(callframe10287);
// compiled member node returning call10288 (depth = 6)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10289 = callmethodflags(call10288, "extendCommentUsing(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10286);
// compiled call node returning call10289 (depth = 5)
    gc_frame_newslot(call10289);
    if10272 = call10289;
  } else {
// Begin line 3201
  setline(3201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10290 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_comments (depth = 6)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10291 = callmethodflags(*var_comments, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10290);
// compiled call node returning call10291 (depth = 5)
// Begin line 3202
  setline(3202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num10295 = alloc_Float64(1);
// compiled num node returning num10295 (depth = 8)
  int op_slot_right_10294 = gc_frame_newslot(num10295);
// starting to compile member node (depth = 8)
  int callframe10297 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call10298 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10297);
// compiled member node returning call10298 (depth = 8)
  int op_slot_left_10294 = gc_frame_newslot(call10298);
  params[0] = num10295;
  partcv[0] = 1;
  Object diff10299 = callmethod(call10298, "-(1)", 1, partcv, params);
// compiled op node returning diff10299 (depth = 7)
  int op_slot_right_10293 = gc_frame_newslot(diff10299);
// starting to compile member node (depth = 7)
  int callframe10301 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call10302 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10301);
// compiled member node returning call10302 (depth = 7)
  int op_slot_left_10293 = gc_frame_newslot(call10302);
  params[0] = diff10299;
  partcv[0] = 1;
  Object opresult10303 = callmethod(call10302, "<(1)", 1, partcv, params);
// compiled op node returning opresult10303 (depth = 6)
  Object if10292 = done;
  if (istrue(opresult10303)) {
// Begin line 3203
  setline(3203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10304 = gc_frame_new();
// starting to compile identifier node (depth = 7)
  Object bool10305 = alloc_Boolean(1);
// compiled identifier node returning bool10305 (depth = 7)
  gc_frame_newslot(bool10305);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  params[0] = bool10305;
  partcv[0] = 1;
  Object call10306 = callmethodflags(*var_o, "isPreceededByBlankLine:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10304);
// compiled call node returning call10306 (depth = 6)
    gc_frame_newslot(call10306);
    if10292 = call10306;
  } else {
  }
// compiled if node returning if10292 (depth = 5)
    gc_frame_newslot(if10292);
    if10272 = if10292;
  }
// compiled if node returning if10272 (depth = 4)
  gc_frame_end(frame);
  return if10272;
}
Object meth_parser_pushComments10176(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 73, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushComments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_done = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_comments = getfromclosure(closure, 5);
  Object *var_previousCommentToken = getfromclosure(closure, 6);
  Object *var_tokens = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 3181
  setline(3181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10178 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe10179 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10180 == NULL) {
    strlit10180 = alloc_String("comment");
    gc_root(strlit10180);
  }
// compiled string node returning strlit10180 (depth = 5)
  gc_frame_newslot(strlit10180);
// call case 4: self request
  params[0] = strlit10180;
  partcv[0] = 1;
  Object call10181 = callmethodflags(self, "accept(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10179);
// compiled call node returning call10181 (depth = 4)
  partcv[0] = 0;
  Object call10182 = callmethodflags(call10181, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe10178);
// compiled call node returning call10182 (depth = 3)
  Object if10177 = done;
  if (istrue(call10182)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if10177 = undefined;
  } else {
  }
// compiled if node returning if10177 (depth = 2)
// Begin line 3182
  setline(3182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10183 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe10184 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call10185 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10184);
// compiled member node returning call10185 (depth = 3)
  gc_frame_newslot(call10185);
// starting to compile member node (depth = 3)
  int callframe10186 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  Object call10187 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10186);
// compiled member node returning call10187 (depth = 3)
  gc_frame_newslot(call10187);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call10185;
  params[1] = call10187;
  partcv[0] = 2;
  Object call10188 = callmethodflags(*var_util, "setPosition(2)", 1, partcv, params, 0);
  gc_frame_end(callframe10183);
// compiled call node returning call10188 (depth = 2)
// Begin line 3183
  setline(3183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10189 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10190 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10191 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe10190);
// compiled member node returning call10191 (depth = 4)
  gc_frame_newslot(call10191);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10192 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call10193 = callmethodflags(*var_ast, "commentNode", 0, partcv, params, 0);
  gc_frame_end(callframe10192);
// compiled member node returning call10193 (depth = 4)
  params[0] = call10191;
  partcv[0] = 1;
  Object call10194 = callmethodflags(call10193, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10189);
// compiled call node returning call10194 (depth = 3)
  *var_o = call10194;
  if (call10194 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3184
  setline(3184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10198 == NULL) {
    strlit10198 = alloc_String("comment");
    gc_root(strlit10198);
  }
// compiled string node returning strlit10198 (depth = 5)
  int op_slot_right_10197 = gc_frame_newslot(strlit10198);
// starting to compile member node (depth = 5)
  int callframe10200 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call10201 = callmethodflags(*var_lastToken, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe10200);
// compiled member node returning call10201 (depth = 5)
  int op_slot_left_10197 = gc_frame_newslot(call10201);
  params[0] = strlit10198;
  partcv[0] = 1;
  Object opresult10202 = callmethod(call10201, "≠(1)", 1, partcv, params);
// compiled op node returning opresult10202 (depth = 4)
  int op_slot_right_10196 = gc_frame_newslot(opresult10202);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10205 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call10206 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10205);
// compiled member node returning call10206 (depth = 5)
  int op_slot_right_10204 = gc_frame_newslot(call10206);
// starting to compile member node (depth = 5)
  int callframe10208 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call10209 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10208);
// compiled member node returning call10209 (depth = 5)
  int op_slot_left_10204 = gc_frame_newslot(call10209);
  params[0] = call10206;
  partcv[0] = 1;
  Object opresult10210 = callmethod(call10209, "==(1)", 1, partcv, params);
// compiled op node returning opresult10210 (depth = 4)
  int op_slot_left_10196 = gc_frame_newslot(opresult10210);
  params[0] = opresult10202;
  partcv[0] = 1;
  Object opresult10211 = callmethod(opresult10210, "&&(1)", 1, partcv, params);
// compiled op node returning opresult10211 (depth = 3)
  Object if10195 = done;
  if (istrue(opresult10211)) {
// Begin line 3185
  setline(3185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10212 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool10213 = alloc_Boolean(1);
// compiled identifier node returning bool10213 (depth = 4)
  gc_frame_newslot(bool10213);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = bool10213;
  partcv[0] = 1;
  Object call10214 = callmethodflags(*var_o, "isPartialLine:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10212);
// compiled call node returning call10214 (depth = 3)
    gc_frame_newslot(call10214);
    if10195 = call10214;
  } else {
// Begin line 3189
  setline(3189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3186
  setline(3186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10218 = alloc_Float64(1);
// compiled num node returning num10218 (depth = 6)
  int op_slot_right_10217 = gc_frame_newslot(num10218);
// starting to compile member node (depth = 6)
  int callframe10220 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call10221 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10220);
// compiled member node returning call10221 (depth = 6)
  int op_slot_left_10217 = gc_frame_newslot(call10221);
  params[0] = num10218;
  partcv[0] = 1;
  Object diff10222 = callmethod(call10221, "-(1)", 1, partcv, params);
// compiled op node returning diff10222 (depth = 5)
  int op_slot_right_10216 = gc_frame_newslot(diff10222);
// starting to compile member node (depth = 5)
  int callframe10224 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  Object call10225 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10224);
// compiled member node returning call10225 (depth = 5)
  int op_slot_left_10216 = gc_frame_newslot(call10225);
  params[0] = diff10222;
  partcv[0] = 1;
  Object opresult10226 = callmethod(call10225, "<(1)", 1, partcv, params);
// compiled op node returning opresult10226 (depth = 4)
  Object if10215 = done;
  if (istrue(opresult10226)) {
// Begin line 3187
  setline(3187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10227 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool10228 = alloc_Boolean(1);
// compiled identifier node returning bool10228 (depth = 5)
  gc_frame_newslot(bool10228);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = bool10228;
  partcv[0] = 1;
  Object call10229 = callmethodflags(*var_o, "isPreceededByBlankLine:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10227);
// compiled call node returning call10229 (depth = 4)
    gc_frame_newslot(call10229);
    if10215 = call10229;
  } else {
  }
// compiled if node returning if10215 (depth = 3)
    gc_frame_newslot(if10215);
    if10195 = if10215;
  }
// compiled if node returning if10195 (depth = 2)
// Begin line 3189
  setline(3189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10230 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_comments (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10231 = callmethodflags(*var_comments, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10230);
// compiled call node returning call10231 (depth = 2)
// Begin line 3190
  setline(3190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10232 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block10233 = alloc_Block(NULL, NULL, "parser", 3190);
  gc_frame_newslot(block10233);
// method "_apply"
  block_savedest(block10233);
  Object closure10234 = createclosure(4, "_apply");
  setclosureframe(closure10234, stackframe);
  addtoclosure(closure10234, var_sym);
  addtoclosure(closure10234, var_previousCommentToken);
  addtoclosure(closure10234, var_tokens);
  addtoclosure(closure10234, selfslot);
  struct UserObject *uo10234 = (struct UserObject*)block10233;
  uo10234->data[0] = (Object)closure10234;
  Method *meth_meth_parser__apply10234 = addmethod2pos(block10233, "_apply", &meth_parser__apply10234, 0);
  int argcv_meth_parser__apply10234[] = {0};
  meth_meth_parser__apply10234->type = alloc_MethodType(1, argcv_meth_parser__apply10234);
  meth_meth_parser__apply10234->definitionModule = modulename;
  meth_meth_parser__apply10234->definitionLine = 3399;
// compiled block node returning block10233 (depth = 3)
  gc_frame_newslot(block10233);
// Begin line 3195
  setline(3195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block10257 = alloc_Block(NULL, NULL, "parser", 3195);
  gc_frame_newslot(block10257);
// method "_apply"
  block_savedest(block10257);
  Object closure10258 = createclosure(7, "_apply");
  setclosureframe(closure10258, stackframe);
  addtoclosure(closure10258, var_sym);
  addtoclosure(closure10258, var_util);
  addtoclosure(closure10258, var_ast);
  addtoclosure(closure10258, var_o);
  addtoclosure(closure10258, var_comments);
  addtoclosure(closure10258, var_lastToken);
  addtoclosure(closure10258, selfslot);
  struct UserObject *uo10258 = (struct UserObject*)block10257;
  uo10258->data[0] = (Object)closure10258;
  Method *meth_meth_parser__apply10258 = addmethod2pos(block10257, "_apply", &meth_parser__apply10258, 0);
  int argcv_meth_parser__apply10258[] = {0};
  meth_meth_parser__apply10258->type = alloc_MethodType(1, argcv_meth_parser__apply10258);
  meth_meth_parser__apply10258->definitionModule = modulename;
  meth_meth_parser__apply10258->definitionLine = 3399;
// compiled block node returning block10257 (depth = 3)
  gc_frame_newslot(block10257);
// call case 5: prelude request
  params[0] = block10233;
  params[1] = block10257;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10308 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10232);
// compiled call node returning call10308 (depth = 2)
  gc_frame_end(frame);
  return call10308;
}
Object meth_parser__apply10334(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10336 = alloc_Float64(0);
// compiled num node returning num10336 (depth = 5)
  int op_slot_right_10335 = gc_frame_newslot(num10336);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_10335 = gc_frame_newslot(*var_ix);
  params[0] = num10336;
  partcv[0] = 1;
  Object opresult10338 = callmethod(*var_ix, ">(1)", 1, partcv, params);
// compiled op node returning opresult10338 (depth = 4)
  gc_frame_end(frame);
  return opresult10338;
}
Object meth_parser__apply10341(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_comments = getfromclosure(closure, 1);
  Object *var_oLine = getfromclosure(closure, 2);
  Object *var_postComments = getfromclosure(closure, 3);
  Object *var_preComments = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_each = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "each");
  Object *var_isPostComment = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "isPostComment");
  Object *var_isPreComment = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "isPreComment");
// Begin line 3232
  setline(3232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10342 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_comments (depth = 6)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call10343 = callmethodflags(*var_comments, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10342);
// compiled call node returning call10343 (depth = 5)
  *var_each = call10343;
  if (call10343 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3233
  setline(3233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num10347 = alloc_Float64(1);
// compiled num node returning num10347 (depth = 8)
  int op_slot_right_10346 = gc_frame_newslot(num10347);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oLine (depth = 8)
  int op_slot_left_10346 = gc_frame_newslot(*var_oLine);
  params[0] = num10347;
  partcv[0] = 1;
  Object sum10349 = callmethod(*var_oLine, "+(1)", 1, partcv, params);
// compiled op node returning sum10349 (depth = 7)
  int op_slot_right_10345 = gc_frame_newslot(sum10349);
// starting to compile member node (depth = 7)
  int callframe10351 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  Object call10352 = callmethodflags(*var_each, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10351);
// compiled member node returning call10352 (depth = 7)
  int op_slot_left_10345 = gc_frame_newslot(call10352);
  params[0] = sum10349;
  partcv[0] = 1;
  Object opresult10353 = callmethod(call10352, "==(1)", 1, partcv, params);
// compiled op node returning opresult10353 (depth = 6)
  int op_slot_right_10344 = gc_frame_newslot(opresult10353);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_oLine (depth = 7)
  int op_slot_right_10355 = gc_frame_newslot(*var_oLine);
// starting to compile member node (depth = 7)
  int callframe10357 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  Object call10358 = callmethodflags(*var_each, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10357);
// compiled member node returning call10358 (depth = 7)
  int op_slot_left_10355 = gc_frame_newslot(call10358);
  params[0] = *var_oLine;
  partcv[0] = 1;
  Object opresult10359 = callmethod(call10358, "==(1)", 1, partcv, params);
// compiled op node returning opresult10359 (depth = 6)
  int op_slot_left_10344 = gc_frame_newslot(opresult10359);
  params[0] = opresult10353;
  partcv[0] = 1;
  Object opresult10360 = callmethod(opresult10359, "||(1)", 1, partcv, params);
// compiled op node returning opresult10360 (depth = 5)
  *var_isPostComment = opresult10360;
  if (opresult10360 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3234
  setline(3234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num10364 = alloc_Float64(1);
// compiled num node returning num10364 (depth = 8)
  int op_slot_right_10363 = gc_frame_newslot(num10364);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oLine (depth = 8)
  int op_slot_left_10363 = gc_frame_newslot(*var_oLine);
  params[0] = num10364;
  partcv[0] = 1;
  Object diff10366 = callmethod(*var_oLine, "-(1)", 1, partcv, params);
// compiled op node returning diff10366 (depth = 7)
  int op_slot_right_10362 = gc_frame_newslot(diff10366);
// starting to compile member node (depth = 7)
  int callframe10368 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  Object call10369 = callmethodflags(*var_each, "endLine", 0, partcv, params, 0);
  gc_frame_end(callframe10368);
// compiled member node returning call10369 (depth = 7)
  int op_slot_left_10362 = gc_frame_newslot(call10369);
  params[0] = diff10366;
  partcv[0] = 1;
  Object opresult10370 = callmethod(call10369, "==(1)", 1, partcv, params);
// compiled op node returning opresult10370 (depth = 6)
  int op_slot_right_10361 = gc_frame_newslot(opresult10370);
// starting to compile member node (depth = 6)
  int callframe10372 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  Object call10373 = callmethodflags(*var_each, "isPreceededByBlankLine", 0, partcv, params, 0);
  gc_frame_end(callframe10372);
// compiled member node returning call10373 (depth = 6)
  int op_slot_left_10361 = gc_frame_newslot(call10373);
  params[0] = opresult10370;
  partcv[0] = 1;
  Object opresult10374 = callmethod(call10373, "&&(1)", 1, partcv, params);
// compiled op node returning opresult10374 (depth = 5)
  *var_isPreComment = opresult10374;
  if (opresult10374 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3235
  setline(3235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_isPostComment (depth = 5)
  Object if10375 = done;
  if (istrue(*var_isPostComment)) {
// Begin line 3236
  setline(3236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10376 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe10377 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_comments (depth = 7)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call10378 = callmethodflags(*var_comments, "removeAt(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10377);
// compiled call node returning call10378 (depth = 6)
  gc_frame_newslot(call10378);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_postComments (depth = 6)
  params[0] = call10378;
  partcv[0] = 1;
  Object call10379 = callmethodflags(*var_postComments, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10376);
// compiled call node returning call10379 (depth = 5)
    gc_frame_newslot(call10379);
    if10375 = call10379;
  } else {
// Begin line 3239
  setline(3239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3237
  setline(3237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_isPreComment (depth = 6)
  Object if10380 = done;
  if (istrue(*var_isPreComment)) {
// Begin line 3238
  setline(3238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10381 = gc_frame_new();
// starting to compile call node (depth = 7)
  int callframe10382 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_comments (depth = 8)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call10383 = callmethodflags(*var_comments, "removeAt(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10382);
// compiled call node returning call10383 (depth = 7)
  gc_frame_newslot(call10383);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_preComments (depth = 7)
  params[0] = call10383;
  partcv[0] = 1;
  Object call10384 = callmethodflags(*var_preComments, "addFirst(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10381);
// compiled call node returning call10384 (depth = 6)
    gc_frame_newslot(call10384);
    if10380 = call10384;
  } else {
// Begin line 3242
  setline(3242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3239
  setline(3239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num10388 = alloc_Float64(1);
// compiled num node returning num10388 (depth = 9)
  int op_slot_right_10387 = gc_frame_newslot(num10388);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_oLine (depth = 9)
  int op_slot_left_10387 = gc_frame_newslot(*var_oLine);
  params[0] = num10388;
  partcv[0] = 1;
  Object diff10390 = callmethod(*var_oLine, "-(1)", 1, partcv, params);
// compiled op node returning diff10390 (depth = 8)
  int op_slot_right_10386 = gc_frame_newslot(diff10390);
// starting to compile member node (depth = 8)
  int callframe10392 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  Object call10393 = callmethodflags(*var_each, "endLine", 0, partcv, params, 0);
  gc_frame_end(callframe10392);
// compiled member node returning call10393 (depth = 8)
  int op_slot_left_10386 = gc_frame_newslot(call10393);
  params[0] = diff10390;
  partcv[0] = 1;
  Object opresult10394 = callmethod(call10393, "<(1)", 1, partcv, params);
// compiled op node returning opresult10394 (depth = 7)
  Object if10385 = done;
  if (istrue(opresult10394)) {
// Begin line 3240
  setline(3240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile num node (depth = 8)
  Object num10395 = alloc_Float64(0);
// compiled num node returning num10395 (depth = 8)
  *var_ix = num10395;
  if (num10395 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if10385 = done;
  } else {
  }
// compiled if node returning if10385 (depth = 6)
    gc_frame_newslot(if10385);
    if10380 = if10385;
  }
// compiled if node returning if10380 (depth = 5)
    gc_frame_newslot(if10380);
    if10375 = if10380;
  }
// compiled if node returning if10375 (depth = 4)
// Begin line 3242
  setline(3242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10398 = alloc_Float64(1);
// compiled num node returning num10398 (depth = 6)
  int op_slot_right_10397 = gc_frame_newslot(num10398);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_left_10397 = gc_frame_newslot(*var_ix);
  params[0] = num10398;
  partcv[0] = 1;
  Object diff10400 = callmethod(*var_ix, "-(1)", 1, partcv, params);
// compiled op node returning diff10400 (depth = 5)
  *var_ix = diff10400;
  if (diff10400 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_reconcileComments10309(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 74, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reconcileComments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_moduleObject = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_comments = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_node = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "node");
  Object *var_oLine = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "oLine");
  Object *var_preComments = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "preComments");
  Object *var_postComments = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "postComments");
  Object *var_ix = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "ix");
  Object *var_postSz = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "postSz");
  Object *var_preSz = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "preSz");
// Begin line 3215
  setline(3215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe10310 = gc_frame_new();
// call case 4: self request
  Object call10311 = callmethodflags(self, "pushComments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10310);
// compiled member node returning call10311 (depth = 2)
// Begin line 3216
  setline(3216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10313 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call10314 = callmethodflags(*var_values, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe10313);
// compiled member node returning call10314 (depth = 4)
  Object if10312 = done;
struct StackFrameObject *iftmpstackframe10312 = stackframe;
  if (istrue(call10314)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10312);
gc_frame_newslot((Object)stackframe);
// Begin line 3217
  setline(3217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_moduleObject (depth = 4)
    gc_frame_newslot(*var_moduleObject);
    if10312 = *var_moduleObject;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe10312);
  gc_frame_newslot((Object)stackframe);
// Begin line 3219
  setline(3219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10315 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  Object call10316 = callmethodflags(*var_values, "last", 0, partcv, params, 0);
  gc_frame_end(callframe10315);
// compiled member node returning call10316 (depth = 4)
    gc_frame_newslot(call10316);
    if10312 = call10316;
  }
stackframe = iftmpstackframe10312;
// compiled if node returning if10312 (depth = 3)
  *var_node = if10312;
  if (if10312 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3221
  setline(3221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10319 == NULL) {
    strlit10319 = alloc_String("lbrace");
    gc_root(strlit10319);
  }
// compiled string node returning strlit10319 (depth = 4)
  int op_slot_right_10318 = gc_frame_newslot(strlit10319);
// starting to compile member node (depth = 4)
  int callframe10321 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  Object call10322 = callmethodflags(*var_node, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe10321);
// compiled member node returning call10322 (depth = 4)
  int op_slot_left_10318 = gc_frame_newslot(call10322);
  params[0] = strlit10319;
  partcv[0] = 1;
  Object opresult10323 = callmethod(call10322, "==(1)", 1, partcv, params);
// compiled op node returning opresult10323 (depth = 3)
  Object if10317 = done;
  if (istrue(opresult10323)) {
// Begin line 3224
  setline(3224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 3225
  setline(3225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if10317 = undefined;
  } else {
  }
// compiled if node returning if10317 (depth = 2)
// Begin line 3226
  setline(3226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe10324 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_node (depth = 4)
  Object call10325 = callmethodflags(*var_node, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10324);
// compiled member node returning call10325 (depth = 3)
  *var_oLine = call10325;
  if (call10325 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3227
  setline(3227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe10326 = gc_frame_new();
// call case 5: prelude request
  Object call10327 = callmethodflags(prelude, "emptyList", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10326);
// compiled member node returning call10327 (depth = 3)
  *var_preComments = call10327;
  if (call10327 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3228
  setline(3228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe10328 = gc_frame_new();
// call case 5: prelude request
  Object call10329 = callmethodflags(prelude, "emptyList", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10328);
// compiled member node returning call10329 (depth = 3)
  *var_postComments = call10329;
  if (call10329 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3230
  setline(3230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe10330 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_comments (depth = 4)
  Object call10331 = callmethodflags(*var_comments, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10330);
// compiled member node returning call10331 (depth = 3)
  *var_ix = call10331;
  if (call10331 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3231
  setline(3231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10332 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block10333 = alloc_Block(NULL, NULL, "parser", 3231);
  gc_frame_newslot(block10333);
// method "_apply"
  block_savedest(block10333);
  Object closure10334 = createclosure(2, "_apply");
  setclosureframe(closure10334, stackframe);
  addtoclosure(closure10334, var_ix);
  addtoclosure(closure10334, selfslot);
  struct UserObject *uo10334 = (struct UserObject*)block10333;
  uo10334->data[0] = (Object)closure10334;
  Method *meth_meth_parser__apply10334 = addmethod2pos(block10333, "_apply", &meth_parser__apply10334, 0);
  int argcv_meth_parser__apply10334[] = {0};
  meth_meth_parser__apply10334->type = alloc_MethodType(1, argcv_meth_parser__apply10334);
  meth_meth_parser__apply10334->definitionModule = modulename;
  meth_meth_parser__apply10334->definitionLine = 3399;
// compiled block node returning block10333 (depth = 3)
  gc_frame_newslot(block10333);
// starting to compile block node (depth = 3)
  Object block10340 = alloc_Block(NULL, NULL, "parser", 3231);
  gc_frame_newslot(block10340);
// method "_apply"
  block_savedest(block10340);
  Object closure10341 = createclosure(6, "_apply");
  setclosureframe(closure10341, stackframe);
  addtoclosure(closure10341, var_ix);
  addtoclosure(closure10341, var_comments);
  addtoclosure(closure10341, var_oLine);
  addtoclosure(closure10341, var_postComments);
  addtoclosure(closure10341, var_preComments);
  addtoclosure(closure10341, selfslot);
  struct UserObject *uo10341 = (struct UserObject*)block10340;
  uo10341->data[0] = (Object)closure10341;
  Method *meth_meth_parser__apply10341 = addmethod2pos(block10340, "_apply", &meth_parser__apply10341, 0);
  int argcv_meth_parser__apply10341[] = {0};
  meth_meth_parser__apply10341->type = alloc_MethodType(1, argcv_meth_parser__apply10341);
  meth_meth_parser__apply10341->definitionModule = modulename;
  meth_meth_parser__apply10341->definitionLine = 3399;
// compiled block node returning block10340 (depth = 3)
  gc_frame_newslot(block10340);
// call case 5: prelude request
  params[0] = block10333;
  params[1] = block10340;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10403 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10332);
// compiled call node returning call10403 (depth = 2)
// Begin line 3245
  setline(3245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe10404 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_postComments (depth = 4)
  Object call10405 = callmethodflags(*var_postComments, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10404);
// compiled member node returning call10405 (depth = 3)
  *var_postSz = call10405;
  if (call10405 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3246
  setline(3246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe10406 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_preComments (depth = 4)
  Object call10407 = callmethodflags(*var_preComments, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10406);
// compiled member node returning call10407 (depth = 3)
  *var_preSz = call10407;
  if (call10407 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 3248
  setline(3248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10411 = alloc_Float64(1);
// compiled num node returning num10411 (depth = 5)
  int op_slot_right_10410 = gc_frame_newslot(num10411);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_preSz (depth = 5)
  int op_slot_left_10410 = gc_frame_newslot(*var_preSz);
  params[0] = num10411;
  partcv[0] = 1;
  Object opresult10413 = callmethod(*var_preSz, ">(1)", 1, partcv, params);
// compiled op node returning opresult10413 (depth = 4)
  int op_slot_right_10409 = gc_frame_newslot(opresult10413);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10416 = alloc_Float64(1);
// compiled num node returning num10416 (depth = 5)
  int op_slot_right_10415 = gc_frame_newslot(num10416);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_postSz (depth = 5)
  int op_slot_left_10415 = gc_frame_newslot(*var_postSz);
  params[0] = num10416;
  partcv[0] = 1;
  Object opresult10418 = callmethod(*var_postSz, ">(1)", 1, partcv, params);
// compiled op node returning opresult10418 (depth = 4)
  int op_slot_left_10409 = gc_frame_newslot(opresult10418);
  params[0] = opresult10413;
  partcv[0] = 1;
  Object opresult10419 = callmethod(opresult10418, "&&(1)", 1, partcv, params);
// compiled op node returning opresult10419 (depth = 3)
  Object if10408 = done;
  if (istrue(opresult10419)) {
// Begin line 3249
  setline(3249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10420 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10422 == NULL) {
    strlit10422 = alloc_String("""\x0a""");
    gc_root(strlit10422);
  }
// compiled string node returning strlit10422 (depth = 5)
  int op_slot_right_10421 = gc_frame_newslot(strlit10422);
// starting to compile member node (depth = 5)
  int callframe10424 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10425 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_preComments (depth = 7)
  Object call10426 = callmethodflags(*var_preComments, "last", 0, partcv, params, 0);
  gc_frame_end(callframe10425);
// compiled member node returning call10426 (depth = 6)
  Object call10427 = callmethodflags(call10426, "value", 0, partcv, params, 0);
  gc_frame_end(callframe10424);
// compiled member node returning call10427 (depth = 5)
  int op_slot_left_10421 = gc_frame_newslot(call10427);
  params[0] = strlit10422;
  partcv[0] = 1;
  Object opresult10428 = callmethod(call10427, "++(1)", 1, partcv, params);
// compiled op node returning opresult10428 (depth = 4)
  gc_frame_newslot(opresult10428);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10429 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_preComments (depth = 5)
  Object call10430 = callmethodflags(*var_preComments, "last", 0, partcv, params, 0);
  gc_frame_end(callframe10429);
// compiled member node returning call10430 (depth = 4)
  params[0] = opresult10428;
  partcv[0] = 1;
  Object call10431 = callmethodflags(call10430, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10420);
// compiled call node returning call10431 (depth = 3)
    gc_frame_newslot(call10431);
    if10408 = call10431;
  } else {
  }
// compiled if node returning if10408 (depth = 2)
// Begin line 3251
  setline(3251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10432 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_preComments (depth = 3)
  gc_frame_newslot(*var_preComments);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_node (depth = 3)
  params[0] = *var_preComments;
  partcv[0] = 1;
  Object call10433 = callmethodflags(*var_node, "addComments(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10432);
// compiled call node returning call10433 (depth = 2)
// Begin line 3252
  setline(3252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10434 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_postComments (depth = 3)
  gc_frame_newslot(*var_postComments);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_node (depth = 3)
  params[0] = *var_postComments;
  partcv[0] = 1;
  Object call10435 = callmethodflags(*var_node, "addComments(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10434);
// compiled call node returning call10435 (depth = 2)
  gc_frame_end(frame);
  return call10435;
}
Object meth_parser_checkBadOperators10436(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 75, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkBadOperators");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
// Begin line 3256
  setline(3256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10439 == NULL) {
    strlit10439 = alloc_String("=");
    gc_root(strlit10439);
  }
// compiled string node returning strlit10439 (depth = 4)
  int op_slot_right_10438 = gc_frame_newslot(strlit10439);
// starting to compile member node (depth = 4)
  int callframe10441 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10442 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe10441);
// compiled member node returning call10442 (depth = 4)
  int op_slot_left_10438 = gc_frame_newslot(call10442);
  params[0] = strlit10439;
  partcv[0] = 1;
  Object opresult10443 = callmethod(call10442, "==(1)", 1, partcv, params);
// compiled op node returning opresult10443 (depth = 3)
  Object if10437 = done;
  if (istrue(opresult10443)) {
// Begin line 3257
  setline(3257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10444 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10445 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call10446 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe10445);
// compiled member node returning call10446 (depth = 5)
  Object call10447 = callmethodflags(call10446, "new", 0, partcv, params, 0);
  gc_frame_end(callframe10444);
// compiled member node returning call10447 (depth = 4)
  *var_sugg = call10447;
  if (call10447 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 3258
  setline(3258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10448 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10449 == NULL) {
    strlit10449 = alloc_String("=");
    gc_root(strlit10449);
  }
// compiled string node returning strlit10449 (depth = 4)
  gc_frame_newslot(strlit10449);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = strlit10449;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10450 = callmethodflags(*var_sugg, "insert(1)afterToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10448);
// compiled call node returning call10450 (depth = 3)
// Begin line 3259
  setline(3259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10451 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10452 == NULL) {
    strlit10452 = alloc_String("use '==' to test equality, not '='.");
    gc_root(strlit10452);
  }
// compiled string node returning strlit10452 (depth = 4)
  gc_frame_newslot(strlit10452);
// Begin line 3260
  setline(3260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10453 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10454 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10453);
// compiled member node returning call10454 (depth = 4)
  gc_frame_newslot(call10454);
// starting to compile member node (depth = 4)
  int callframe10455 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10456 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10455);
// compiled member node returning call10456 (depth = 4)
  gc_frame_newslot(call10456);
// starting to compile member node (depth = 4)
  int callframe10457 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10458 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10457);
// compiled member node returning call10458 (depth = 4)
  gc_frame_newslot(call10458);
// Begin line 3261
  setline(3261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other requests
// Begin line 3259
  setline(3259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit10452;
  params[1] = call10454;
  params[2] = call10456;
  params[3] = call10458;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call10459 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe10451);
// compiled call node returning call10459 (depth = 3)
    gc_frame_newslot(call10459);
    if10437 = call10459;
  } else {
  }
// compiled if node returning if10437 (depth = 2)
// Begin line 3263
  setline(3263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10462 == NULL) {
    strlit10462 = alloc_String("rgeneric");
    gc_root(strlit10462);
  }
// compiled string node returning strlit10462 (depth = 4)
  int op_slot_right_10461 = gc_frame_newslot(strlit10462);
// starting to compile member node (depth = 4)
  int callframe10464 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10465 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe10464);
// compiled member node returning call10465 (depth = 4)
  int op_slot_left_10461 = gc_frame_newslot(call10465);
  params[0] = strlit10462;
  partcv[0] = 1;
  Object opresult10466 = callmethod(call10465, "==(1)", 1, partcv, params);
// compiled op node returning opresult10466 (depth = 3)
  Object if10460 = done;
  if (istrue(opresult10466)) {
// Begin line 3264
  setline(3264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10467 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10468 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call10469 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe10468);
// compiled member node returning call10469 (depth = 5)
  Object call10470 = callmethodflags(call10469, "new", 0, partcv, params, 0);
  gc_frame_end(callframe10467);
// compiled member node returning call10470 (depth = 4)
  *var_sugg = call10470;
  if (call10470 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 3265
  setline(3265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10471 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10472 == NULL) {
    strlit10472 = alloc_String(" ");
    gc_root(strlit10472);
  }
// compiled string node returning strlit10472 (depth = 4)
  gc_frame_newslot(strlit10472);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = strlit10472;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10473 = callmethodflags(*var_sugg, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10471);
// compiled call node returning call10473 (depth = 3)
// Begin line 3266
  setline(3266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10474 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10475 == NULL) {
    strlit10475 = alloc_String("the '>' operator must be preceded by a space.");
    gc_root(strlit10475);
  }
// compiled string node returning strlit10475 (depth = 4)
  gc_frame_newslot(strlit10475);
// Begin line 3267
  setline(3267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10476 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10477 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10476);
// compiled member node returning call10477 (depth = 4)
  gc_frame_newslot(call10477);
// starting to compile member node (depth = 4)
  int callframe10478 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10479 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10478);
// compiled member node returning call10479 (depth = 4)
  gc_frame_newslot(call10479);
// starting to compile member node (depth = 4)
  int callframe10480 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10481 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10480);
// compiled member node returning call10481 (depth = 4)
  gc_frame_newslot(call10481);
// Begin line 3268
  setline(3268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other requests
// Begin line 3266
  setline(3266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit10475;
  params[1] = call10477;
  params[2] = call10479;
  params[3] = call10481;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call10482 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe10474);
// compiled call node returning call10482 (depth = 3)
    gc_frame_newslot(call10482);
    if10460 = call10482;
  } else {
  }
// compiled if node returning if10460 (depth = 2)
  gc_frame_end(frame);
  return if10460;
}
Object meth_parser_checkBadTypeLiteral10483(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 76, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkBadTypeLiteral");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
// Begin line 3273
  setline(3273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10486 == NULL) {
    strlit10486 = alloc_String("lbrace");
    gc_root(strlit10486);
  }
// compiled string node returning strlit10486 (depth = 4)
  int op_slot_right_10485 = gc_frame_newslot(strlit10486);
// starting to compile member node (depth = 4)
  int callframe10488 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10489 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe10488);
// compiled member node returning call10489 (depth = 4)
  int op_slot_left_10485 = gc_frame_newslot(call10489);
  params[0] = strlit10486;
  partcv[0] = 1;
  Object opresult10490 = callmethod(call10489, "==(1)", 1, partcv, params);
// compiled op node returning opresult10490 (depth = 3)
  Object if10484 = done;
  if (istrue(opresult10490)) {
// Begin line 3274
  setline(3274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10491 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10492 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call10493 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe10492);
// compiled member node returning call10493 (depth = 5)
  Object call10494 = callmethodflags(call10493, "new", 0, partcv, params, 0);
  gc_frame_end(callframe10491);
// compiled member node returning call10494 (depth = 4)
  *var_sugg = call10494;
  if (call10494 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 3275
  setline(3275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10495 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10496 == NULL) {
    strlit10496 = alloc_String("type ");
    gc_root(strlit10496);
  }
// compiled string node returning strlit10496 (depth = 4)
  gc_frame_newslot(strlit10496);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = strlit10496;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10497 = callmethodflags(*var_sugg, "insert(1)beforeToken(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10495);
// compiled call node returning call10497 (depth = 3)
// Begin line 3276
  setline(3276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10498 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10499 == NULL) {
    strlit10499 = alloc_String("type literals must start with the keyword 'type'.");
    gc_root(strlit10499);
  }
// compiled string node returning strlit10499 (depth = 4)
  gc_frame_newslot(strlit10499);
// Begin line 3277
  setline(3277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10500 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10501 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10500);
// compiled member node returning call10501 (depth = 4)
  gc_frame_newslot(call10501);
// starting to compile member node (depth = 4)
  int callframe10502 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10503 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10502);
// compiled member node returning call10503 (depth = 4)
  gc_frame_newslot(call10503);
// starting to compile member node (depth = 4)
  int callframe10504 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10505 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10504);
// compiled member node returning call10505 (depth = 4)
  gc_frame_newslot(call10505);
// Begin line 3278
  setline(3278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other requests
// Begin line 3276
  setline(3276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit10499;
  params[1] = call10501;
  params[2] = call10503;
  params[3] = call10505;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call10506 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe10498);
// compiled call node returning call10506 (depth = 3)
    gc_frame_newslot(call10506);
    if10484 = call10506;
  } else {
  }
// compiled if node returning if10484 (depth = 2)
  gc_frame_end(frame);
  return if10484;
}
Object meth_parser__apply10611(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10613 == NULL) {
    strlit10613 = alloc_String("identifier");
    gc_root(strlit10613);
  }
// compiled string node returning strlit10613 (depth = 8)
  int op_slot_right_10612 = gc_frame_newslot(strlit10613);
// starting to compile member node (depth = 8)
  int callframe10615 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call10616 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe10615);
// compiled member node returning call10616 (depth = 8)
  int op_slot_left_10612 = gc_frame_newslot(call10616);
  params[0] = strlit10613;
  partcv[0] = 1;
  Object opresult10617 = callmethod(call10616, "==(1)", 1, partcv, params);
// compiled op node returning opresult10617 (depth = 7)
  gc_frame_end(frame);
  return opresult10617;
}
Object meth_parser__apply10625(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit10627 == NULL) {
    strlit10627 = alloc_String("member");
    gc_root(strlit10627);
  }
// compiled string node returning strlit10627 (depth = 11)
  int op_slot_right_10626 = gc_frame_newslot(strlit10627);
// starting to compile member node (depth = 11)
  int callframe10629 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe10630 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_values (depth = 13)
  Object call10631 = callmethodflags(*var_values, "last", 0, partcv, params, 0);
  gc_frame_end(callframe10630);
// compiled member node returning call10631 (depth = 12)
  Object call10632 = callmethodflags(call10631, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe10629);
// compiled member node returning call10632 (depth = 11)
  int op_slot_left_10626 = gc_frame_newslot(call10632);
  params[0] = strlit10627;
  partcv[0] = 1;
  Object opresult10633 = callmethod(call10632, "==(1)", 1, partcv, params);
// compiled op node returning opresult10633 (depth = 10)
  gc_frame_end(frame);
  return opresult10633;
}
Object meth_parser__apply10622(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile block node (depth = 9)
  Object block10624 = alloc_Block(NULL, NULL, "parser", 3308);
  gc_frame_newslot(block10624);
// method "_apply"
  block_savedest(block10624);
  Object closure10625 = createclosure(2, "_apply");
  setclosureframe(closure10625, stackframe);
  addtoclosure(closure10625, var_values);
  addtoclosure(closure10625, selfslot);
  struct UserObject *uo10625 = (struct UserObject*)block10624;
  uo10625->data[0] = (Object)closure10625;
  Method *meth_meth_parser__apply10625 = addmethod2pos(block10624, "_apply", &meth_parser__apply10625, 0);
  int argcv_meth_parser__apply10625[] = {0};
  meth_meth_parser__apply10625->type = alloc_MethodType(1, argcv_meth_parser__apply10625);
  meth_meth_parser__apply10625->definitionModule = modulename;
  meth_meth_parser__apply10625->definitionLine = 3399;
// compiled block node returning block10624 (depth = 9)
  int op_slot_right_10623 = gc_frame_newslot(block10624);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10637 == NULL) {
    strlit10637 = alloc_String("identifier");
    gc_root(strlit10637);
  }
// compiled string node returning strlit10637 (depth = 10)
  int op_slot_right_10636 = gc_frame_newslot(strlit10637);
// starting to compile member node (depth = 10)
  int callframe10639 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe10640 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_values (depth = 12)
  Object call10641 = callmethodflags(*var_values, "last", 0, partcv, params, 0);
  gc_frame_end(callframe10640);
// compiled member node returning call10641 (depth = 11)
  Object call10642 = callmethodflags(call10641, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe10639);
// compiled member node returning call10642 (depth = 10)
  int op_slot_left_10636 = gc_frame_newslot(call10642);
  params[0] = strlit10637;
  partcv[0] = 1;
  Object opresult10643 = callmethod(call10642, "==(1)", 1, partcv, params);
// compiled op node returning opresult10643 (depth = 9)
  int op_slot_left_10623 = gc_frame_newslot(opresult10643);
  params[0] = block10624;
  partcv[0] = 1;
  Object opresult10644 = callmethod(opresult10643, "||(1)", 1, partcv, params);
// compiled op node returning opresult10644 (depth = 8)
  gc_frame_end(frame);
  return opresult10644;
}
Object meth_parser_checkUnexpectedTokenAfterStatement10507(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 77, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkUnexpectedTokenAfterStatement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_util = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_sugg2 = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "sugg2");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_n = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "n");
  Object *var_nextTok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nextTok");
  Object *var_newLine = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "newLine");
// Begin line 3283
  setline(3283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10510 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  Object call10511 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10510);
// compiled member node returning call10511 (depth = 4)
  int op_slot_right_10509 = gc_frame_newslot(call10511);
// starting to compile member node (depth = 4)
  int callframe10513 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10514 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10513);
// compiled member node returning call10514 (depth = 4)
  int op_slot_left_10509 = gc_frame_newslot(call10514);
  params[0] = call10511;
  partcv[0] = 1;
  Object opresult10515 = callmethod(call10514, "==(1)", 1, partcv, params);
// compiled op node returning opresult10515 (depth = 3)
  Object if10508 = done;
  if (istrue(opresult10515)) {
// Begin line 3284
  setline(3284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 3285
  setline(3285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10519 == NULL) {
    strlit10519 = alloc_String("identifier");
    gc_root(strlit10519);
  }
// compiled string node returning strlit10519 (depth = 6)
  int op_slot_right_10518 = gc_frame_newslot(strlit10519);
// starting to compile member node (depth = 6)
  int callframe10521 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call10522 = callmethodflags(*var_lastToken, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe10521);
// compiled member node returning call10522 (depth = 6)
  int op_slot_left_10518 = gc_frame_newslot(call10522);
  params[0] = strlit10519;
  partcv[0] = 1;
  Object opresult10523 = callmethod(call10522, "==(1)", 1, partcv, params);
// compiled op node returning opresult10523 (depth = 5)
  int op_slot_right_10517 = gc_frame_newslot(opresult10523);
// Begin line 3284
  setline(3284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10527 == NULL) {
    strlit10527 = alloc_String("=");
    gc_root(strlit10527);
  }
// compiled string node returning strlit10527 (depth = 7)
  int op_slot_right_10526 = gc_frame_newslot(strlit10527);
// starting to compile member node (depth = 7)
  int callframe10529 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call10530 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe10529);
// compiled member node returning call10530 (depth = 7)
  int op_slot_left_10526 = gc_frame_newslot(call10530);
  params[0] = strlit10527;
  partcv[0] = 1;
  Object opresult10531 = callmethod(call10530, "==(1)", 1, partcv, params);
// compiled op node returning opresult10531 (depth = 6)
  int op_slot_right_10525 = gc_frame_newslot(opresult10531);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10534 == NULL) {
    strlit10534 = alloc_String("op");
    gc_root(strlit10534);
  }
// compiled string node returning strlit10534 (depth = 7)
  int op_slot_right_10533 = gc_frame_newslot(strlit10534);
// starting to compile member node (depth = 7)
  int callframe10536 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call10537 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe10536);
// compiled member node returning call10537 (depth = 7)
  int op_slot_left_10533 = gc_frame_newslot(call10537);
  params[0] = strlit10534;
  partcv[0] = 1;
  Object opresult10538 = callmethod(call10537, "==(1)", 1, partcv, params);
// compiled op node returning opresult10538 (depth = 6)
  int op_slot_left_10525 = gc_frame_newslot(opresult10538);
  params[0] = opresult10531;
  partcv[0] = 1;
  Object opresult10539 = callmethod(opresult10538, "&&(1)", 1, partcv, params);
// compiled op node returning opresult10539 (depth = 5)
  int op_slot_left_10517 = gc_frame_newslot(opresult10539);
  params[0] = opresult10523;
  partcv[0] = 1;
  Object opresult10540 = callmethod(opresult10539, "&&(1)", 1, partcv, params);
// compiled op node returning opresult10540 (depth = 4)
  Object if10516 = done;
  if (istrue(opresult10540)) {
// Begin line 3286
  setline(3286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10541 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10542 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call10543 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe10542);
// compiled member node returning call10543 (depth = 6)
  Object call10544 = callmethodflags(call10543, "new", 0, partcv, params, 0);
  gc_frame_end(callframe10541);
// compiled member node returning call10544 (depth = 5)
  *var_sugg = call10544;
  if (call10544 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3287
  setline(3287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array10545 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10545 (depth = 5)
  *var_suggestions = array10545;
  if (array10545 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3288
  setline(3288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10546 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
  Object bool10547 = alloc_Boolean(0);
// compiled identifier node returning bool10547 (depth = 5)
  gc_frame_newslot(bool10547);
// starting to compile identifier node (depth = 5)
  Object bool10548 = alloc_Boolean(0);
// compiled identifier node returning bool10548 (depth = 5)
  gc_frame_newslot(bool10548);
// starting to compile string node (depth = 5)
  if (strlit10549 == NULL) {
    strlit10549 = alloc_String(":=");
    gc_root(strlit10549);
  }
// compiled string node returning strlit10549 (depth = 5)
  gc_frame_newslot(strlit10549);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  params[0] = *var_sym;
  params[1] = bool10547;
  params[2] = bool10548;
  params[3] = strlit10549;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call10550 = callmethodflags(*var_sugg, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe10546);
// compiled call node returning call10550 (depth = 4)
// Begin line 3289
  setline(3289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10551 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  gc_frame_newslot(*var_sugg);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_sugg;
  partcv[0] = 1;
  Object call10552 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10551);
// compiled call node returning call10552 (depth = 4)
// Begin line 3290
  setline(3290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10553 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10554 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call10555 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe10554);
// compiled member node returning call10555 (depth = 6)
  Object call10556 = callmethodflags(call10555, "new", 0, partcv, params, 0);
  gc_frame_end(callframe10553);
// compiled member node returning call10556 (depth = 5)
  *var_sugg2 = call10556;
  if (call10556 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3291
  setline(3291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10557 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
  Object bool10558 = alloc_Boolean(0);
// compiled identifier node returning bool10558 (depth = 5)
  gc_frame_newslot(bool10558);
// starting to compile identifier node (depth = 5)
  Object bool10559 = alloc_Boolean(0);
// compiled identifier node returning bool10559 (depth = 5)
  gc_frame_newslot(bool10559);
// starting to compile string node (depth = 5)
  if (strlit10560 == NULL) {
    strlit10560 = alloc_String("==");
    gc_root(strlit10560);
  }
// compiled string node returning strlit10560 (depth = 5)
  gc_frame_newslot(strlit10560);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg2 (depth = 5)
  params[0] = *var_sym;
  params[1] = bool10558;
  params[2] = bool10559;
  params[3] = strlit10560;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call10561 = callmethodflags(*var_sugg2, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe10557);
// compiled call node returning call10561 (depth = 4)
// Begin line 3292
  setline(3292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10562 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg2 (depth = 5)
  gc_frame_newslot(*var_sugg2);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_sugg2;
  partcv[0] = 1;
  Object call10563 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10562);
// compiled call node returning call10563 (depth = 4)
// Begin line 3293
  setline(3293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10564 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10565 == NULL) {
    strlit10565 = alloc_String("assignment uses ':=', not '='.");
    gc_root(strlit10565);
  }
// compiled string node returning strlit10565 (depth = 5)
  gc_frame_newslot(strlit10565);
// Begin line 3294
  setline(3294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe10566 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call10567 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10566);
// compiled member node returning call10567 (depth = 5)
  gc_frame_newslot(call10567);
// starting to compile member node (depth = 5)
  int callframe10568 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call10569 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10568);
// compiled member node returning call10569 (depth = 5)
  gc_frame_newslot(call10569);
// starting to compile member node (depth = 5)
  int callframe10570 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call10571 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10570);
// compiled member node returning call10571 (depth = 5)
  gc_frame_newslot(call10571);
// Begin line 3295
  setline(3295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 3293
  setline(3293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10565;
  params[1] = call10567;
  params[2] = call10569;
  params[3] = call10571;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call10572 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe10564);
// compiled call node returning call10572 (depth = 4)
    gc_frame_newslot(call10572);
    if10516 = call10572;
  } else {
  }
// compiled if node returning if10516 (depth = 3)
// Begin line 3297
  setline(3297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10575 == NULL) {
    strlit10575 = alloc_String("rgeneric");
    gc_root(strlit10575);
  }
// compiled string node returning strlit10575 (depth = 5)
  int op_slot_right_10574 = gc_frame_newslot(strlit10575);
// starting to compile member node (depth = 5)
  int callframe10577 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call10578 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe10577);
// compiled member node returning call10578 (depth = 5)
  int op_slot_left_10574 = gc_frame_newslot(call10578);
  params[0] = strlit10575;
  partcv[0] = 1;
  Object opresult10579 = callmethod(call10578, "==(1)", 1, partcv, params);
// compiled op node returning opresult10579 (depth = 4)
  Object if10573 = done;
  if (istrue(opresult10579)) {
// Begin line 3298
  setline(3298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10580 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10581 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  Object call10582 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe10581);
// compiled member node returning call10582 (depth = 6)
  Object call10583 = callmethodflags(call10582, "new", 0, partcv, params, 0);
  gc_frame_end(callframe10580);
// compiled member node returning call10583 (depth = 5)
  *var_sugg = call10583;
  if (call10583 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3299
  setline(3299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10584 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10585 == NULL) {
    strlit10585 = alloc_String(" ");
    gc_root(strlit10585);
  }
// compiled string node returning strlit10585 (depth = 5)
  gc_frame_newslot(strlit10585);
// starting to compile member node (depth = 5)
  int callframe10586 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call10587 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10586);
// compiled member node returning call10587 (depth = 5)
  gc_frame_newslot(call10587);
// starting to compile member node (depth = 5)
  int callframe10588 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call10589 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10588);
// compiled member node returning call10589 (depth = 5)
  gc_frame_newslot(call10589);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  params[0] = strlit10585;
  params[1] = call10587;
  params[2] = call10589;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10590 = callmethodflags(*var_sugg, "insert(1)atPosition(1)onLine(1)", 3, partcv, params, 0);
  gc_frame_end(callframe10584);
// compiled call node returning call10590 (depth = 4)
// Begin line 3300
  setline(3300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10591 = gc_frame_new();
// Begin line 3301
  setline(3301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit10592 == NULL) {
    strlit10592 = alloc_String("The '>' operator must have a space before it.");
    gc_root(strlit10592);
  }
// compiled string node returning strlit10592 (depth = 5)
  gc_frame_newslot(strlit10592);
// Begin line 3302
  setline(3302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe10593 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call10594 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10593);
// compiled member node returning call10594 (depth = 5)
  gc_frame_newslot(call10594);
// starting to compile member node (depth = 5)
  int callframe10595 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call10596 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10595);
// compiled member node returning call10596 (depth = 5)
  gc_frame_newslot(call10596);
// starting to compile member node (depth = 5)
  int callframe10597 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call10598 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10597);
// compiled member node returning call10598 (depth = 5)
  gc_frame_newslot(call10598);
// Begin line 3303
  setline(3303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  gc_frame_newslot(*var_sugg);
// call case 6: other requests
// Begin line 3300
  setline(3300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10592;
  params[1] = call10594;
  params[2] = call10596;
  params[3] = call10598;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call10599 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe10591);
// compiled call node returning call10599 (depth = 4)
    gc_frame_newslot(call10599);
    if10573 = call10599;
  } else {
  }
// compiled if node returning if10573 (depth = 3)
// Begin line 3305
  setline(3305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10602 == NULL) {
    strlit10602 = alloc_String("rbrace");
    gc_root(strlit10602);
  }
// compiled string node returning strlit10602 (depth = 5)
  int op_slot_right_10601 = gc_frame_newslot(strlit10602);
// starting to compile member node (depth = 5)
  int callframe10604 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call10605 = callmethodflags(*var_sym, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe10604);
// compiled member node returning call10605 (depth = 5)
  int op_slot_left_10601 = gc_frame_newslot(call10605);
  params[0] = strlit10602;
  partcv[0] = 1;
  Object opresult10606 = callmethod(call10605, "≠(1)", 1, partcv, params);
// compiled op node returning opresult10606 (depth = 4)
  Object if10600 = done;
  if (istrue(opresult10606)) {
// Begin line 3306
  setline(3306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array10607 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10607 (depth = 5)
  *var_suggestions = array10607;
  if (array10607 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3307
  setline(3307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_suggestion = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 3308
  setline(3308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block10610 = alloc_Block(NULL, NULL, "parser", 3308);
  gc_frame_newslot(block10610);
// method "_apply"
  block_savedest(block10610);
  Object closure10611 = createclosure(2, "_apply");
  setclosureframe(closure10611, stackframe);
  addtoclosure(closure10611, var_sym);
  addtoclosure(closure10611, selfslot);
  struct UserObject *uo10611 = (struct UserObject*)block10610;
  uo10611->data[0] = (Object)closure10611;
  Method *meth_meth_parser__apply10611 = addmethod2pos(block10610, "_apply", &meth_parser__apply10611, 0);
  int argcv_meth_parser__apply10611[] = {0};
  meth_meth_parser__apply10611->type = alloc_MethodType(1, argcv_meth_parser__apply10611);
  meth_meth_parser__apply10611->definitionModule = modulename;
  meth_meth_parser__apply10611->definitionLine = 3399;
// compiled block node returning block10610 (depth = 6)
  int op_slot_right_10609 = gc_frame_newslot(block10610);
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block10621 = alloc_Block(NULL, NULL, "parser", 3308);
  gc_frame_newslot(block10621);
// method "_apply"
  block_savedest(block10621);
  Object closure10622 = createclosure(2, "_apply");
  setclosureframe(closure10622, stackframe);
  addtoclosure(closure10622, var_values);
  addtoclosure(closure10622, selfslot);
  struct UserObject *uo10622 = (struct UserObject*)block10621;
  uo10622->data[0] = (Object)closure10622;
  Method *meth_meth_parser__apply10622 = addmethod2pos(block10621, "_apply", &meth_parser__apply10622, 0);
  int argcv_meth_parser__apply10622[] = {0};
  meth_meth_parser__apply10622->type = alloc_MethodType(1, argcv_meth_parser__apply10622);
  meth_meth_parser__apply10622->definitionModule = modulename;
  meth_meth_parser__apply10622->definitionLine = 3399;
// compiled block node returning block10621 (depth = 7)
  int op_slot_right_10620 = gc_frame_newslot(block10621);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num10648 = alloc_Float64(0);
// compiled num node returning num10648 (depth = 8)
  int op_slot_right_10647 = gc_frame_newslot(num10648);
// starting to compile member node (depth = 8)
  int callframe10650 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  Object call10651 = callmethodflags(*var_values, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10650);
// compiled member node returning call10651 (depth = 8)
  int op_slot_left_10647 = gc_frame_newslot(call10651);
  params[0] = num10648;
  partcv[0] = 1;
  Object opresult10652 = callmethod(call10651, ">(1)", 1, partcv, params);
// compiled op node returning opresult10652 (depth = 7)
  int op_slot_left_10620 = gc_frame_newslot(opresult10652);
  params[0] = block10621;
  partcv[0] = 1;
  Object opresult10653 = callmethod(opresult10652, "&&(1)", 1, partcv, params);
// compiled op node returning opresult10653 (depth = 6)
  int op_slot_left_10609 = gc_frame_newslot(opresult10653);
  params[0] = block10610;
  partcv[0] = 1;
  Object opresult10654 = callmethod(opresult10653, "&&(1)", 1, partcv, params);
// compiled op node returning opresult10654 (depth = 5)
  Object if10608 = done;
  if (istrue(opresult10654)) {
// Begin line 3309
  setline(3309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe10655 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe10656 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call10657 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe10656);
// compiled member node returning call10657 (depth = 7)
  Object call10658 = callmethodflags(call10657, "new", 0, partcv, params, 0);
  gc_frame_end(callframe10655);
// compiled member node returning call10658 (depth = 6)
  *var_suggestion = call10658;
  if (call10658 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 3310
  setline(3310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10660 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
  Object bool10661 = alloc_Boolean(1);
// compiled identifier node returning bool10661 (depth = 6)
  gc_frame_newslot(bool10661);
// starting to compile identifier node (depth = 6)
  Object bool10662 = alloc_Boolean(0);
// compiled identifier node returning bool10662 (depth = 6)
  gc_frame_newslot(bool10662);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10664 == NULL) {
    strlit10664 = alloc_String(")");
    gc_root(strlit10664);
  }
// compiled string node returning strlit10664 (depth = 7)
  int op_slot_right_10663 = gc_frame_newslot(strlit10664);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe10667 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call10668 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe10667);
// compiled member node returning call10668 (depth = 8)
  int op_slot_right_10666 = gc_frame_newslot(call10668);
// starting to compile string node (depth = 8)
  if (strlit10670 == NULL) {
    strlit10670 = alloc_String("(");
    gc_root(strlit10670);
  }
// compiled string node returning strlit10670 (depth = 8)
  int op_slot_left_10666 = gc_frame_newslot(strlit10670);
  params[0] = call10668;
  partcv[0] = 1;
  Object opresult10671 = callmethod(strlit10670, "++(1)", 1, partcv, params);
// compiled op node returning opresult10671 (depth = 7)
  int op_slot_left_10663 = gc_frame_newslot(opresult10671);
  params[0] = strlit10664;
  partcv[0] = 1;
  Object opresult10672 = callmethod(opresult10671, "++(1)", 1, partcv, params);
// compiled op node returning opresult10672 (depth = 6)
  gc_frame_newslot(opresult10672);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = bool10661;
  params[2] = bool10662;
  params[3] = opresult10672;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call10673 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe10660);
// compiled call node returning call10673 (depth = 5)
// Begin line 3311
  setline(3311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10674 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10675 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10674);
// compiled call node returning call10675 (depth = 5)
// Begin line 3312
  setline(3312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe10678 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call10679 = callmethodflags(*var_sym, "next", 0, partcv, params, 0);
  gc_frame_end(callframe10678);
// compiled member node returning call10679 (depth = 7)
  int op_slot_right_10677 = gc_frame_newslot(call10679);
// starting to compile identifier node (depth = 7)
  Object bool10681 = alloc_Boolean(0);
// compiled identifier node returning bool10681 (depth = 7)
  int op_slot_left_10677 = gc_frame_newslot(bool10681);
  params[0] = call10679;
  partcv[0] = 1;
  Object opresult10682 = callmethod(bool10681, "≠(1)", 1, partcv, params);
// compiled op node returning opresult10682 (depth = 6)
  Object if10676 = done;
  if (istrue(opresult10682)) {
// Begin line 3313
  setline(3313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe10683 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call10684 = callmethodflags(*var_sym, "next", 0, partcv, params, 0);
  gc_frame_end(callframe10683);
// compiled member node returning call10684 (depth = 7)
  *var_n = call10684;
  if (call10684 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 3314
  setline(3314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe10687 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call10688 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10687);
// compiled member node returning call10688 (depth = 8)
  int op_slot_right_10686 = gc_frame_newslot(call10688);
// starting to compile member node (depth = 8)
  int callframe10690 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  Object call10691 = callmethodflags(*var_n, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10690);
// compiled member node returning call10691 (depth = 8)
  int op_slot_left_10686 = gc_frame_newslot(call10691);
  params[0] = call10688;
  partcv[0] = 1;
  Object opresult10692 = callmethod(call10691, "==(1)", 1, partcv, params);
// compiled op node returning opresult10692 (depth = 7)
  Object if10685 = done;
  if (istrue(opresult10692)) {
// Begin line 3315
  setline(3315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe10693 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe10694 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  Object call10695 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe10694);
// compiled member node returning call10695 (depth = 9)
  Object call10696 = callmethodflags(call10695, "new", 0, partcv, params, 0);
  gc_frame_end(callframe10693);
// compiled member node returning call10696 (depth = 8)
  *var_suggestion = call10696;
  if (call10696 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
// Begin line 3316
  setline(3316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10698 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool10699 = alloc_Boolean(1);
// compiled identifier node returning bool10699 (depth = 8)
  gc_frame_newslot(bool10699);
// starting to compile identifier node (depth = 8)
  Object bool10700 = alloc_Boolean(0);
// compiled identifier node returning bool10700 (depth = 8)
  gc_frame_newslot(bool10700);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10702 == NULL) {
    strlit10702 = alloc_String("");
    gc_root(strlit10702);
  }
// compiled string node returning strlit10702 (depth = 9)
  int op_slot_right_10701 = gc_frame_newslot(strlit10702);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe10705 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  Object call10706 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe10705);
// compiled member node returning call10706 (depth = 10)
  int op_slot_right_10704 = gc_frame_newslot(call10706);
// starting to compile string node (depth = 10)
  if (strlit10708 == NULL) {
    strlit10708 = alloc_String("(");
    gc_root(strlit10708);
  }
// compiled string node returning strlit10708 (depth = 10)
  int op_slot_left_10704 = gc_frame_newslot(strlit10708);
  params[0] = call10706;
  partcv[0] = 1;
  Object opresult10709 = callmethod(strlit10708, "++(1)", 1, partcv, params);
// compiled op node returning opresult10709 (depth = 9)
  int op_slot_left_10701 = gc_frame_newslot(opresult10709);
  params[0] = strlit10702;
  partcv[0] = 1;
  Object opresult10710 = callmethod(opresult10709, "++(1)", 1, partcv, params);
// compiled op node returning opresult10710 (depth = 8)
  gc_frame_newslot(opresult10710);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool10699;
  params[2] = bool10700;
  params[3] = opresult10710;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call10711 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe10698);
// compiled call node returning call10711 (depth = 7)
// Begin line 3317
  setline(3317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10712 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit10713 == NULL) {
    strlit10713 = alloc_String(")");
    gc_root(strlit10713);
  }
// compiled string node returning strlit10713 (depth = 8)
  gc_frame_newslot(strlit10713);
// starting to compile member node (depth = 8)
  int callframe10714 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call10715 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10714);
// compiled member node returning call10715 (depth = 8)
  gc_frame_newslot(call10715);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit10713;
  params[1] = call10715;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10716 = callmethodflags(*var_suggestion, "append(1)onLine(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10712);
// compiled call node returning call10716 (depth = 7)
// Begin line 3318
  setline(3318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10717 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10718 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10717);
// compiled call node returning call10718 (depth = 7)
    gc_frame_newslot(call10718);
    if10685 = call10718;
  } else {
  }
// compiled if node returning if10685 (depth = 6)
    gc_frame_newslot(if10685);
    if10676 = if10685;
  } else {
  }
// compiled if node returning if10676 (depth = 5)
// Begin line 3321
  setline(3321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10721 == NULL) {
    strlit10721 = alloc_String("identifier");
    gc_root(strlit10721);
  }
// compiled string node returning strlit10721 (depth = 7)
  int op_slot_right_10720 = gc_frame_newslot(strlit10721);
// starting to compile member node (depth = 7)
  int callframe10723 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe10724 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  Object call10725 = callmethodflags(*var_values, "last", 0, partcv, params, 0);
  gc_frame_end(callframe10724);
// compiled member node returning call10725 (depth = 8)
  Object call10726 = callmethodflags(call10725, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe10723);
// compiled member node returning call10726 (depth = 7)
  int op_slot_left_10720 = gc_frame_newslot(call10726);
  params[0] = strlit10721;
  partcv[0] = 1;
  Object opresult10727 = callmethod(call10726, "==(1)", 1, partcv, params);
// compiled op node returning opresult10727 (depth = 6)
  Object if10719 = done;
  if (istrue(opresult10727)) {
// Begin line 3322
  setline(3322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe10728 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe10729 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  Object call10730 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe10729);
// compiled member node returning call10730 (depth = 8)
  Object call10731 = callmethodflags(call10730, "new", 0, partcv, params, 0);
  gc_frame_end(callframe10728);
// compiled member node returning call10731 (depth = 7)
  *var_suggestion = call10731;
  if (call10731 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 3323
  setline(3323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10733 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool10734 = alloc_Boolean(0);
// compiled identifier node returning bool10734 (depth = 7)
  gc_frame_newslot(bool10734);
// starting to compile identifier node (depth = 7)
  Object bool10735 = alloc_Boolean(0);
// compiled identifier node returning bool10735 (depth = 7)
  gc_frame_newslot(bool10735);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10737 == NULL) {
    strlit10737 = alloc_String("""\x22""");
    gc_root(strlit10737);
  }
// compiled string node returning strlit10737 (depth = 8)
  int op_slot_right_10736 = gc_frame_newslot(strlit10737);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe10740 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call10741 = callmethodflags(*var_sym, "value", 0, partcv, params, 0);
  gc_frame_end(callframe10740);
// compiled member node returning call10741 (depth = 9)
  int op_slot_right_10739 = gc_frame_newslot(call10741);
// starting to compile string node (depth = 9)
  if (strlit10743 == NULL) {
    strlit10743 = alloc_String("""\x22""");
    gc_root(strlit10743);
  }
// compiled string node returning strlit10743 (depth = 9)
  int op_slot_left_10739 = gc_frame_newslot(strlit10743);
  params[0] = call10741;
  partcv[0] = 1;
  Object opresult10744 = callmethod(strlit10743, "++(1)", 1, partcv, params);
// compiled op node returning opresult10744 (depth = 8)
  int op_slot_left_10736 = gc_frame_newslot(opresult10744);
  params[0] = strlit10737;
  partcv[0] = 1;
  Object opresult10745 = callmethod(opresult10744, "++(1)", 1, partcv, params);
// compiled op node returning opresult10745 (depth = 7)
  gc_frame_newslot(opresult10745);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool10734;
  params[2] = bool10735;
  params[3] = opresult10745;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call10746 = callmethodflags(*var_suggestion, "replaceToken(1)leading(1)trailing(1)with(1)", 4, partcv, params, 0);
  gc_frame_end(callframe10733);
// compiled call node returning call10746 (depth = 6)
// Begin line 3324
  setline(3324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10747 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10748 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10747);
// compiled call node returning call10748 (depth = 6)
    gc_frame_newslot(call10748);
    if10719 = call10748;
  } else {
  }
// compiled if node returning if10719 (depth = 5)
    gc_frame_newslot(if10719);
    if10608 = if10719;
  } else {
  }
// compiled if node returning if10608 (depth = 4)
// Begin line 3327
  setline(3327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10749 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array10750 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit10751 == NULL) {
    strlit10751 = alloc_String("rbrace");
    gc_root(strlit10751);
  }
// compiled string node returning strlit10751 (depth = 7)
  params[0] = strlit10751;
  partcv[0] = 1;
  callmethodflags(array10750, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array10750 (depth = 6)
  gc_frame_newslot(array10750);
// call case 4: self request
  params[0] = array10750;
  partcv[0] = 1;
  Object call10752 = callmethodflags(self, "findNextValidToken(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10749);
// compiled call node returning call10752 (depth = 5)
  *var_nextTok = call10752;
  if (call10752 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 3328
  setline(3328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_10754 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_10754 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult10756 = callmethod(*var_nextTok, "==(1)", 1, partcv, params);
// compiled op node returning opresult10756 (depth = 5)
  Object if10753 = done;
  if (istrue(opresult10756)) {
// Begin line 3329
  setline(3329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe10757 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe10758 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call10759 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe10758);
// compiled member node returning call10759 (depth = 7)
  Object call10760 = callmethodflags(call10759, "new", 0, partcv, params, 0);
  gc_frame_end(callframe10757);
// compiled member node returning call10760 (depth = 6)
  *var_suggestion = call10760;
  if (call10760 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 3330
  setline(3330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10762 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe10763 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  Object call10764 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10763);
// compiled member node returning call10764 (depth = 6)
  gc_frame_newslot(call10764);
// starting to compile call node (depth = 6)
  int callframe10765 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num10766 = alloc_Float64(1);
// compiled num node returning num10766 (depth = 7)
  gc_frame_newslot(num10766);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num10768 = alloc_Float64(1);
// compiled num node returning num10768 (depth = 8)
  int op_slot_right_10767 = gc_frame_newslot(num10768);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe10771 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call10772 = callmethodflags(*var_lastToken, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10771);
// compiled member node returning call10772 (depth = 9)
  int op_slot_right_10770 = gc_frame_newslot(call10772);
// starting to compile member node (depth = 9)
  int callframe10774 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  Object call10775 = callmethodflags(*var_lastToken, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10774);
// compiled member node returning call10775 (depth = 9)
  int op_slot_left_10770 = gc_frame_newslot(call10775);
  params[0] = call10772;
  partcv[0] = 1;
  Object sum10776 = callmethod(call10775, "+(1)", 1, partcv, params);
// compiled op node returning sum10776 (depth = 8)
  int op_slot_left_10767 = gc_frame_newslot(sum10776);
  params[0] = num10768;
  partcv[0] = 1;
  Object diff10777 = callmethod(sum10776, "-(1)", 1, partcv, params);
// compiled op node returning diff10777 (depth = 7)
  gc_frame_newslot(diff10777);
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe10778 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe10779 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  Object call10780 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10779);
// compiled member node returning call10780 (depth = 8)
  gc_frame_newslot(call10780);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe10781 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_util (depth = 9)
  Object call10782 = callmethodflags(*var_util, "lines", 0, partcv, params, 0);
  gc_frame_end(callframe10781);
// compiled member node returning call10782 (depth = 8)
  params[0] = call10780;
  partcv[0] = 1;
  Object call10783 = callmethodflags(call10782, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10778);
// compiled call node returning call10783 (depth = 7)
  params[0] = num10766;
  params[1] = diff10777;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10784 = callmethodflags(call10783, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10765);
// compiled call node returning call10784 (depth = 6)
  gc_frame_newslot(call10784);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = call10764;
  params[1] = call10784;
  partcv[0] = 2;
  Object call10785 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe10762);
// compiled call node returning call10785 (depth = 5)
// Begin line 3331
  setline(3331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10786 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe10787 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  Object call10788 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10787);
// compiled member node returning call10788 (depth = 7)
  gc_frame_newslot(call10788);
// starting to compile member node (depth = 7)
  int callframe10789 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe10790 = gc_frame_new();
// starting to compile member node (depth = 9)
  int callframe10791 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  Object call10792 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10791);
// compiled member node returning call10792 (depth = 9)
  gc_frame_newslot(call10792);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe10793 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  Object call10794 = callmethodflags(*var_util, "lines", 0, partcv, params, 0);
  gc_frame_end(callframe10793);
// compiled member node returning call10794 (depth = 9)
  params[0] = call10792;
  partcv[0] = 1;
  Object call10795 = callmethodflags(call10794, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10790);
// compiled call node returning call10795 (depth = 8)
  Object call10796 = callmethodflags(call10795, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10789);
// compiled member node returning call10796 (depth = 7)
  gc_frame_newslot(call10796);
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe10797 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe10798 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call10799 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10798);
// compiled member node returning call10799 (depth = 8)
  gc_frame_newslot(call10799);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe10800 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_util (depth = 9)
  Object call10801 = callmethodflags(*var_util, "lines", 0, partcv, params, 0);
  gc_frame_end(callframe10800);
// compiled member node returning call10801 (depth = 8)
  params[0] = call10799;
  partcv[0] = 1;
  Object call10802 = callmethodflags(call10801, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10797);
// compiled call node returning call10802 (depth = 7)
  params[0] = call10788;
  params[1] = call10796;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10803 = callmethodflags(call10802, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10786);
// compiled call node returning call10803 (depth = 6)
  *var_newLine = call10803;
  if (call10803 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 3332
  setline(3332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10804 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10806 = alloc_Float64(0.1);
// compiled num node returning num10806 (depth = 7)
  int op_slot_right_10805 = gc_frame_newslot(num10806);
// starting to compile member node (depth = 7)
  int callframe10808 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  Object call10809 = callmethodflags(*var_lastToken, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10808);
// compiled member node returning call10809 (depth = 7)
  int op_slot_left_10805 = gc_frame_newslot(call10809);
  params[0] = num10806;
  partcv[0] = 1;
  Object sum10810 = callmethod(call10809, "+(1)", 1, partcv, params);
// compiled op node returning sum10810 (depth = 6)
  gc_frame_newslot(sum10810);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newLine (depth = 6)
  gc_frame_newslot(*var_newLine);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = sum10810;
  params[1] = *var_newLine;
  partcv[0] = 2;
  Object call10811 = callmethodflags(*var_suggestion, "addLine(2)", 1, partcv, params, 0);
  gc_frame_end(callframe10804);
// compiled call node returning call10811 (depth = 5)
// Begin line 3333
  setline(3333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10812 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10813 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10812);
// compiled call node returning call10813 (depth = 5)
    gc_frame_newslot(call10813);
    if10753 = call10813;
  } else {
// Begin line 3335
  setline(3335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe10814 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe10815 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call10816 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe10815);
// compiled member node returning call10816 (depth = 7)
  Object call10817 = callmethodflags(call10816, "new", 0, partcv, params, 0);
  gc_frame_end(callframe10814);
// compiled member node returning call10817 (depth = 6)
  *var_suggestion = call10817;
  if (call10817 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 3336
  setline(3336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10819 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
  int callframe10820 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  Object call10821 = callmethodflags(*var_nextTok, "prev", 0, partcv, params, 0);
  gc_frame_end(callframe10820);
// compiled member node returning call10821 (depth = 6)
  gc_frame_newslot(call10821);
// starting to compile identifier node (depth = 6)
  Object bool10822 = alloc_Boolean(1);
// compiled identifier node returning bool10822 (depth = 6)
  gc_frame_newslot(bool10822);
// starting to compile identifier node (depth = 6)
  Object bool10823 = alloc_Boolean(0);
// compiled identifier node returning bool10823 (depth = 6)
  gc_frame_newslot(bool10823);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call10821;
  params[2] = bool10822;
  params[3] = bool10823;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10824 = callmethodflags(*var_suggestion, "deleteTokenRange(2)leading(1)trailing(1)", 3, partcv, params, 0);
  gc_frame_end(callframe10819);
// compiled call node returning call10824 (depth = 5)
// Begin line 3337
  setline(3337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10825 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10826 = callmethodflags(*var_suggestions, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10825);
// compiled call node returning call10826 (depth = 5)
    gc_frame_newslot(call10826);
    if10753 = call10826;
  }
// compiled if node returning if10753 (depth = 4)
// Begin line 3339
  setline(3339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10827 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10828 == NULL) {
    strlit10828 = alloc_String("multiple statements must be separated by a newline or a semicolon. This is often caused by missing parentheses.");
    gc_root(strlit10828);
  }
// compiled string node returning strlit10828 (depth = 5)
  gc_frame_newslot(strlit10828);
// Begin line 3340
  setline(3340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe10829 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call10830 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10829);
// compiled member node returning call10830 (depth = 5)
  gc_frame_newslot(call10830);
// starting to compile member node (depth = 5)
  int callframe10831 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  Object call10832 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10831);
// compiled member node returning call10832 (depth = 5)
  gc_frame_newslot(call10832);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other requests
// Begin line 3339
  setline(3339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10828;
  params[1] = call10830;
  params[2] = call10832;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10833 = callmethodflags(*var_errormessages, "syntaxError(1)atPosition(2)withSuggestions(1)", 3, partcv, params, 0);
  gc_frame_end(callframe10827);
// compiled call node returning call10833 (depth = 4)
    gc_frame_newslot(call10833);
    if10600 = call10833;
  } else {
  }
// compiled if node returning if10600 (depth = 3)
    gc_frame_newslot(if10600);
    if10508 = if10600;
  } else {
  }
// compiled if node returning if10508 (depth = 2)
  gc_frame_end(frame);
  return if10508;
}
Object meth_parser__apply10885(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10887 = alloc_Float64(0);
// compiled num node returning num10887 (depth = 5)
  int op_slot_right_10886 = gc_frame_newslot(num10887);
// starting to compile member node (depth = 5)
  int callframe10889 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  Object call10890 = callmethodflags(*var_tokens, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10889);
// compiled member node returning call10890 (depth = 5)
  int op_slot_left_10886 = gc_frame_newslot(call10890);
  params[0] = num10887;
  partcv[0] = 1;
  Object opresult10891 = callmethod(call10890, ">(1)", 1, partcv, params);
// compiled op node returning opresult10891 (depth = 4)
  gc_frame_end(frame);
  return opresult10891;
}
Object meth_parser__apply10903(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
  int callframe10904 = gc_frame_new();
// call case 4: self request
  Object call10905 = callmethodflags(self, "inheritsOrUses", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10904);
// compiled member node returning call10905 (depth = 6)
  gc_frame_end(frame);
  return call10905;
}
Object meth_parser__apply10908(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_moduleObject = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_parentNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "parentNode");
// Begin line 3371
  setline(3371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe10909 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  Object call10910 = callmethodflags(*var_values, "pop", 0, partcv, params, 0);
  gc_frame_end(callframe10909);
// compiled member node returning call10910 (depth = 7)
  *var_parentNode = call10910;
  if (call10910 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 3372
  setline(3372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe10912 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  Object call10913 = callmethodflags(*var_parentNode, "isUse", 0, partcv, params, 0);
  gc_frame_end(callframe10912);
// compiled member node returning call10913 (depth = 7)
  Object if10911 = done;
  if (istrue(call10913)) {
// Begin line 3373
  setline(3373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10914 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  gc_frame_newslot(*var_parentNode);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe10915 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_moduleObject (depth = 9)
  Object call10916 = callmethodflags(*var_moduleObject, "usedTraits", 0, partcv, params, 0);
  gc_frame_end(callframe10915);
// compiled member node returning call10916 (depth = 8)
  params[0] = *var_parentNode;
  partcv[0] = 1;
  Object call10917 = callmethodflags(call10916, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10914);
// compiled call node returning call10917 (depth = 7)
    gc_frame_newslot(call10917);
    if10911 = call10917;
  } else {
// Begin line 3376
  setline(3376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 3374
  setline(3374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
  int callframe10919 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe10920 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_moduleObject (depth = 10)
  Object call10921 = callmethodflags(*var_moduleObject, "usedTraits", 0, partcv, params, 0);
  gc_frame_end(callframe10920);
// compiled member node returning call10921 (depth = 9)
  Object call10922 = callmethodflags(call10921, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe10919);
// compiled member node returning call10922 (depth = 8)
  Object if10918 = done;
  if (istrue(call10922)) {
// Begin line 3375
  setline(3375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10923 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  gc_frame_newslot(*var_parentNode);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_moduleObject (depth = 9)
  params[0] = *var_parentNode;
  partcv[0] = 1;
  Object call10924 = callmethodflags(*var_moduleObject, "superclass:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10923);
// compiled call node returning call10924 (depth = 8)
    gc_frame_newslot(call10924);
    if10918 = call10924;
  } else {
// Begin line 3377
  setline(3377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10925 = gc_frame_new();
// starting to compile op node (depth = 9)
// Begin line 3378
  setline(3378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit10927 == NULL) {
    strlit10927 = alloc_String("before 'use' in a module.");
    gc_root(strlit10927);
  }
// compiled string node returning strlit10927 (depth = 10)
  int op_slot_right_10926 = gc_frame_newslot(strlit10927);
// Begin line 3377
  setline(3377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit10929 == NULL) {
    strlit10929 = alloc_String("'inherit' must come ");
    gc_root(strlit10929);
  }
// compiled string node returning strlit10929 (depth = 10)
  int op_slot_left_10926 = gc_frame_newslot(strlit10929);
  params[0] = strlit10927;
  partcv[0] = 1;
  Object opresult10930 = callmethod(strlit10929, "++(1)", 1, partcv, params);
// compiled op node returning opresult10930 (depth = 9)
  gc_frame_newslot(opresult10930);
// Begin line 3379
  setline(3379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe10931 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_parentNode (depth = 10)
  Object call10932 = callmethodflags(*var_parentNode, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10931);
// compiled member node returning call10932 (depth = 9)
  gc_frame_newslot(call10932);
// starting to compile member node (depth = 9)
  int callframe10933 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_parentNode (depth = 10)
  Object call10934 = callmethodflags(*var_parentNode, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10933);
// compiled member node returning call10934 (depth = 9)
  gc_frame_newslot(call10934);
// Begin line 3380
  setline(3380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10936 = alloc_Float64(7);
// compiled num node returning num10936 (depth = 10)
  int op_slot_right_10935 = gc_frame_newslot(num10936);
// starting to compile member node (depth = 10)
  int callframe10938 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_parentNode (depth = 11)
  Object call10939 = callmethodflags(*var_parentNode, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10938);
// compiled member node returning call10939 (depth = 10)
  int op_slot_left_10935 = gc_frame_newslot(call10939);
  params[0] = num10936;
  partcv[0] = 1;
  Object sum10940 = callmethod(call10939, "+(1)", 1, partcv, params);
// compiled op node returning sum10940 (depth = 9)
  gc_frame_newslot(sum10940);
// call case 6: other requests
// Begin line 3377
  setline(3377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult10930;
  params[1] = call10932;
  params[2] = call10934;
  params[3] = sum10940;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call10941 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)", 2, partcv, params, 0);
  gc_frame_end(callframe10925);
// compiled call node returning call10941 (depth = 8)
    gc_frame_newslot(call10941);
    if10918 = call10941;
  }
// compiled if node returning if10918 (depth = 7)
    gc_frame_newslot(if10918);
    if10911 = if10918;
  }
// compiled if node returning if10911 (depth = 6)
  gc_frame_end(frame);
  return if10911;
}
Object meth_parser__apply10894(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_moduleObject = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_oldlength = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// Begin line 3367
  setline(3367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10895 = gc_frame_new();
// call case 4: self request
  Object call10896 = callmethodflags(self, "blank", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10895);
// compiled member node returning call10896 (depth = 4)
// Begin line 3368
  setline(3368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10897 = gc_frame_new();
// call case 4: self request
  Object call10898 = callmethodflags(self, "methoddec", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10897);
// compiled member node returning call10898 (depth = 4)
// Begin line 3369
  setline(3369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10899 = gc_frame_new();
// call case 4: self request
  Object call10900 = callmethodflags(self, "blank", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10899);
// compiled member node returning call10900 (depth = 4)
// Begin line 3370
  setline(3370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10901 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block10902 = alloc_Block(NULL, NULL, "parser", 3370);
  gc_frame_newslot(block10902);
// method "_apply"
  block_savedest(block10902);
  Object closure10903 = createclosure(1, "_apply");
  setclosureframe(closure10903, stackframe);
  addtoclosure(closure10903, selfslot);
  struct UserObject *uo10903 = (struct UserObject*)block10902;
  uo10903->data[0] = (Object)closure10903;
  Method *meth_meth_parser__apply10903 = addmethod2pos(block10902, "_apply", &meth_parser__apply10903, 0);
  int argcv_meth_parser__apply10903[] = {0};
  meth_meth_parser__apply10903->type = alloc_MethodType(1, argcv_meth_parser__apply10903);
  meth_meth_parser__apply10903->definitionModule = modulename;
  meth_meth_parser__apply10903->definitionLine = 3399;
// compiled block node returning block10902 (depth = 5)
  gc_frame_newslot(block10902);
// starting to compile block node (depth = 5)
  Object block10907 = alloc_Block(NULL, NULL, "parser", 3370);
  gc_frame_newslot(block10907);
// method "_apply"
  block_savedest(block10907);
  Object closure10908 = createclosure(4, "_apply");
  setclosureframe(closure10908, stackframe);
  addtoclosure(closure10908, var_values);
  addtoclosure(closure10908, var_moduleObject);
  addtoclosure(closure10908, var_errormessages);
  addtoclosure(closure10908, selfslot);
  struct UserObject *uo10908 = (struct UserObject*)block10907;
  uo10908->data[0] = (Object)closure10908;
  Method *meth_meth_parser__apply10908 = addmethod2pos(block10907, "_apply", &meth_parser__apply10908, 0);
  int argcv_meth_parser__apply10908[] = {0};
  meth_meth_parser__apply10908->type = alloc_MethodType(1, argcv_meth_parser__apply10908);
  meth_meth_parser__apply10908->definitionModule = modulename;
  meth_meth_parser__apply10908->definitionLine = 3399;
// compiled block node returning block10907 (depth = 5)
  gc_frame_newslot(block10907);
// call case 4: self request
  params[0] = block10902;
  params[1] = block10907;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10943 = callmethodflags(self, "ifConsume(1)then(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10901);
// compiled call node returning call10943 (depth = 4)
// Begin line 3383
  setline(3383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10944 = gc_frame_new();
// call case 4: self request
  Object call10945 = callmethodflags(self, "blank", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10944);
// compiled member node returning call10945 (depth = 4)
// Begin line 3384
  setline(3384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10946 = gc_frame_new();
// call case 4: self request
  Object call10947 = callmethodflags(self, "statement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10946);
// compiled member node returning call10947 (depth = 4)
// Begin line 3385
  setline(3385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10948 = gc_frame_new();
// call case 4: self request
  Object call10949 = callmethodflags(self, "blank", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10948);
// compiled member node returning call10949 (depth = 4)
// Begin line 3386
  setline(3386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldlength (depth = 6)
  int op_slot_right_10951 = gc_frame_newslot(*var_oldlength);
// starting to compile member node (depth = 6)
  int callframe10953 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  Object call10954 = callmethodflags(*var_tokens, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10953);
// compiled member node returning call10954 (depth = 6)
  int op_slot_left_10951 = gc_frame_newslot(call10954);
  params[0] = *var_oldlength;
  partcv[0] = 1;
  Object opresult10955 = callmethod(call10954, "==(1)", 1, partcv, params);
// compiled op node returning opresult10955 (depth = 5)
  Object if10950 = done;
  if (istrue(opresult10955)) {
// Begin line 3387
  setline(3387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe10956 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe10957 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  Object call10958 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe10957);
// compiled member node returning call10958 (depth = 7)
  Object call10959 = callmethodflags(call10958, "new", 0, partcv, params, 0);
  gc_frame_end(callframe10956);
// compiled member node returning call10959 (depth = 6)
  *var_suggestion = call10959;
  if (call10959 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 3388
  setline(3388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10960 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call10961 = callmethodflags(*var_suggestion, "deleteToken(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10960);
// compiled call node returning call10961 (depth = 5)
// Begin line 3389
  setline(3389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10962 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 3390
  setline(3390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit10964 == NULL) {
    strlit10964 = alloc_String("caused by an extra '}', ')', or ']'.");
    gc_root(strlit10964);
  }
// compiled string node returning strlit10964 (depth = 7)
  int op_slot_right_10963 = gc_frame_newslot(strlit10964);
// Begin line 3389
  setline(3389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit10966 == NULL) {
    strlit10966 = alloc_String("invalid statement. This is often ");
    gc_root(strlit10966);
  }
// compiled string node returning strlit10966 (depth = 7)
  int op_slot_left_10963 = gc_frame_newslot(strlit10966);
  params[0] = strlit10964;
  partcv[0] = 1;
  Object opresult10967 = callmethod(strlit10966, "++(1)", 1, partcv, params);
// compiled op node returning opresult10967 (depth = 6)
  gc_frame_newslot(opresult10967);
// Begin line 3391
  setline(3391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe10968 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call10969 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10968);
// compiled member node returning call10969 (depth = 6)
  gc_frame_newslot(call10969);
// starting to compile member node (depth = 6)
  int callframe10970 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  Object call10971 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10970);
// compiled member node returning call10971 (depth = 6)
  gc_frame_newslot(call10971);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10973 = alloc_Float64(1);
// compiled num node returning num10973 (depth = 7)
  int op_slot_right_10972 = gc_frame_newslot(num10973);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe10976 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call10977 = callmethodflags(*var_sym, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10976);
// compiled member node returning call10977 (depth = 8)
  int op_slot_right_10975 = gc_frame_newslot(call10977);
// starting to compile member node (depth = 8)
  int callframe10979 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  Object call10980 = callmethodflags(*var_sym, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe10979);
// compiled member node returning call10980 (depth = 8)
  int op_slot_left_10975 = gc_frame_newslot(call10980);
  params[0] = call10977;
  partcv[0] = 1;
  Object sum10981 = callmethod(call10980, "+(1)", 1, partcv, params);
// compiled op node returning sum10981 (depth = 7)
  int op_slot_left_10972 = gc_frame_newslot(sum10981);
  params[0] = num10973;
  partcv[0] = 1;
  Object diff10982 = callmethod(sum10981, "-(1)", 1, partcv, params);
// compiled op node returning diff10982 (depth = 6)
  gc_frame_newslot(diff10982);
// Begin line 3392
  setline(3392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other requests
// Begin line 3389
  setline(3389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult10967;
  params[1] = call10969;
  params[2] = call10971;
  params[3] = diff10982;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call10983 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe10962);
// compiled call node returning call10983 (depth = 5)
    gc_frame_newslot(call10983);
    if10950 = call10983;
  } else {
  }
// compiled if node returning if10950 (depth = 4)
// Begin line 3394
  setline(3394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10984 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  Object call10985 = callmethodflags(*var_tokens, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10984);
// compiled member node returning call10985 (depth = 5)
  *var_oldlength = call10985;
  if (call10985 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_parse_40_1_41_10834(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 78, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parse(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parse(_)");
  Object params[5];
  int partcv[3];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_moduleObject = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parse(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_toks = &(stackframe->slots[0]);
  *var_toks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parse(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sugg");
  Object *var_oldlength = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldlength");
// Begin line 3350
  setline(3350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10835 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit10836 == NULL) {
    strlit10836 = alloc_String("parsing.");
    gc_root(strlit10836);
  }
// compiled string node returning strlit10836 (depth = 3)
  gc_frame_newslot(strlit10836);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = strlit10836;
  partcv[0] = 1;
  Object call10837 = callmethodflags(*var_util, "log_verbose(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10835);
// compiled call node returning call10837 (depth = 2)
// Begin line 3351
  setline(3351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10838 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  gc_frame_newslot(*var_values);
// starting to compile member node (depth = 4)
  int callframe10839 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  Object call10840 = callmethodflags(*var_util, "modname", 0, partcv, params, 0);
  gc_frame_end(callframe10839);
// compiled member node returning call10840 (depth = 4)
  gc_frame_newslot(call10840);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10841 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  Object call10842 = callmethodflags(*var_ast, "moduleNode", 0, partcv, params, 0);
  gc_frame_end(callframe10841);
// compiled member node returning call10842 (depth = 4)
  params[0] = *var_values;
  params[1] = call10840;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10843 = callmethodflags(call10842, "body(1)named(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10838);
// compiled call node returning call10843 (depth = 3)
  *var_moduleObject = call10843;
  if (call10843 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 3353
  setline(3353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num10847 = alloc_Float64(0);
// compiled num node returning num10847 (depth = 4)
  int op_slot_right_10846 = gc_frame_newslot(num10847);
// starting to compile member node (depth = 4)
  int callframe10849 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_toks (depth = 5)
  Object call10850 = callmethodflags(*var_toks, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10849);
// compiled member node returning call10850 (depth = 4)
  int op_slot_left_10846 = gc_frame_newslot(call10850);
  params[0] = num10847;
  partcv[0] = 1;
  Object opresult10851 = callmethod(call10850, "==(1)", 1, partcv, params);
// compiled op node returning opresult10851 (depth = 3)
  Object if10845 = done;
  if (istrue(opresult10851)) {
// Begin line 3354
  setline(3354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_moduleObject (depth = 4)
  return *var_moduleObject;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if10845 = undefined;
  } else {
  }
// compiled if node returning if10845 (depth = 2)
// Begin line 3356
  setline(3356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_toks (depth = 3)
  *var_tokens = *var_toks;
  if (*var_toks == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 2)
// Begin line 3357
  setline(3357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe10853 = gc_frame_new();
// call case 4: self request
  Object call10854 = callmethodflags(self, "next", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10853);
// compiled member node returning call10854 (depth = 2)
// Begin line 3358
  setline(3358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num10857 = alloc_Float64(0);
// compiled num node returning num10857 (depth = 4)
  int op_slot_right_10856 = gc_frame_newslot(num10857);
// starting to compile member node (depth = 4)
  int callframe10859 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10860 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe10859);
// compiled member node returning call10860 (depth = 4)
  int op_slot_left_10856 = gc_frame_newslot(call10860);
  params[0] = num10857;
  partcv[0] = 1;
  Object opresult10861 = callmethod(call10860, ">(1)", 1, partcv, params);
// compiled op node returning opresult10861 (depth = 3)
  Object if10855 = done;
  if (istrue(opresult10861)) {
// Begin line 3359
  setline(3359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10862 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10863 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  Object call10864 = callmethodflags(*var_errormessages, "suggestion", 0, partcv, params, 0);
  gc_frame_end(callframe10863);
// compiled member node returning call10864 (depth = 5)
  Object call10865 = callmethodflags(call10864, "new", 0, partcv, params, 0);
  gc_frame_end(callframe10862);
// compiled member node returning call10865 (depth = 4)
  *var_sugg = call10865;
  if (call10865 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 3360
  setline(3360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10866 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num10867 = alloc_Float64(1);
// compiled num node returning num10867 (depth = 4)
  gc_frame_newslot(num10867);
// starting to compile member node (depth = 4)
  int callframe10868 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10869 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe10868);
// compiled member node returning call10869 (depth = 4)
  gc_frame_newslot(call10869);
// starting to compile member node (depth = 4)
  int callframe10870 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10871 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10870);
// compiled member node returning call10871 (depth = 4)
  gc_frame_newslot(call10871);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = num10867;
  params[1] = call10869;
  params[2] = call10871;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call10872 = callmethodflags(*var_sugg, "deleteRange(2)onLine(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10866);
// compiled call node returning call10872 (depth = 3)
// Begin line 3361
  setline(3361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10873 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10874 == NULL) {
    strlit10874 = alloc_String("the first line must not be indented.");
    gc_root(strlit10874);
  }
// compiled string node returning strlit10874 (depth = 4)
  gc_frame_newslot(strlit10874);
// Begin line 3362
  setline(3362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10875 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10876 = callmethodflags(*var_sym, "line", 0, partcv, params, 0);
  gc_frame_end(callframe10875);
// compiled member node returning call10876 (depth = 4)
  gc_frame_newslot(call10876);
// starting to compile num node (depth = 4)
  Object num10877 = alloc_Float64(1);
// compiled num node returning num10877 (depth = 4)
  gc_frame_newslot(num10877);
// starting to compile member node (depth = 4)
  int callframe10878 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  Object call10879 = callmethodflags(*var_sym, "indent", 0, partcv, params, 0);
  gc_frame_end(callframe10878);
// compiled member node returning call10879 (depth = 4)
  gc_frame_newslot(call10879);
// Begin line 3363
  setline(3363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other requests
// Begin line 3361
  setline(3361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit10874;
  params[1] = call10876;
  params[2] = num10877;
  params[3] = call10879;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call10880 = callmethodflags(*var_errormessages, "syntaxError(1)atRange(3)withSuggestion(1)", 3, partcv, params, 0);
  gc_frame_end(callframe10873);
// compiled call node returning call10880 (depth = 3)
    gc_frame_newslot(call10880);
    if10855 = call10880;
  } else {
  }
// compiled if node returning if10855 (depth = 2)
// Begin line 3365
  setline(3365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe10881 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokens (depth = 4)
  Object call10882 = callmethodflags(*var_tokens, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10881);
// compiled member node returning call10882 (depth = 3)
  *var_oldlength = call10882;
  if (call10882 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3366
  setline(3366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10883 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block10884 = alloc_Block(NULL, NULL, "parser", 3366);
  gc_frame_newslot(block10884);
// method "_apply"
  block_savedest(block10884);
  Object closure10885 = createclosure(2, "_apply");
  setclosureframe(closure10885, stackframe);
  addtoclosure(closure10885, var_tokens);
  addtoclosure(closure10885, selfslot);
  struct UserObject *uo10885 = (struct UserObject*)block10884;
  uo10885->data[0] = (Object)closure10885;
  Method *meth_meth_parser__apply10885 = addmethod2pos(block10884, "_apply", &meth_parser__apply10885, 0);
  int argcv_meth_parser__apply10885[] = {0};
  meth_meth_parser__apply10885->type = alloc_MethodType(1, argcv_meth_parser__apply10885);
  meth_meth_parser__apply10885->definitionModule = modulename;
  meth_meth_parser__apply10885->definitionLine = 3399;
// compiled block node returning block10884 (depth = 3)
  gc_frame_newslot(block10884);
// starting to compile block node (depth = 3)
  Object block10893 = alloc_Block(NULL, NULL, "parser", 3366);
  gc_frame_newslot(block10893);
// method "_apply"
  block_savedest(block10893);
  Object closure10894 = createclosure(7, "_apply");
  setclosureframe(closure10894, stackframe);
  addtoclosure(closure10894, var_values);
  addtoclosure(closure10894, var_moduleObject);
  addtoclosure(closure10894, var_errormessages);
  addtoclosure(closure10894, var_oldlength);
  addtoclosure(closure10894, var_tokens);
  addtoclosure(closure10894, var_sym);
  addtoclosure(closure10894, selfslot);
  struct UserObject *uo10894 = (struct UserObject*)block10893;
  uo10894->data[0] = (Object)closure10894;
  Method *meth_meth_parser__apply10894 = addmethod2pos(block10893, "_apply", &meth_parser__apply10894, 0);
  int argcv_meth_parser__apply10894[] = {0};
  meth_meth_parser__apply10894->type = alloc_MethodType(1, argcv_meth_parser__apply10894);
  meth_meth_parser__apply10894->definitionModule = modulename;
  meth_meth_parser__apply10894->definitionLine = 3399;
// compiled block node returning block10893 (depth = 3)
  gc_frame_newslot(block10893);
// call case 5: prelude request
  params[0] = block10884;
  params[1] = block10893;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10988 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10883);
// compiled call node returning call10988 (depth = 2)
// Begin line 3396
  setline(3396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe10989 = gc_frame_new();
// call case 4: self request
  Object call10990 = callmethodflags(self, "blank", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10989);
// compiled member node returning call10990 (depth = 2)
// Begin line 3397
  setline(3397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe10991 = gc_frame_new();
// call case 4: self request
  Object call10992 = callmethodflags(self, "statement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10991);
// compiled member node returning call10992 (depth = 2)
// Begin line 3398
  setline(3398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe10993 = gc_frame_new();
// call case 4: self request
  Object call10994 = callmethodflags(self, "blank", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10993);
// compiled member node returning call10994 (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_moduleObject (depth = 3)
  return *var_moduleObject;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_blankLocation10996(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 79, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blankLocation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blankLocation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blankLocation (depth = 3)
  gc_frame_end(frame);
  return *var_blankLocation;
}
Object meth_parser_blankLocation_58__61__40_1_41_10997(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 80, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blankLocation:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method blankLocation:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_blankLocation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for blankLocation:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part blankLocation:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_blankLocation = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_lastLine11000(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 81, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastLine = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastLine (depth = 3)
  gc_frame_end(frame);
  return *var_lastLine;
}
Object meth_parser_lastLine_58__61__40_1_41_11001(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 82, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastLine:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lastLine:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastLine = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastLine:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lastLine:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastLine = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_lastIndent11004(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 83, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastIndent (depth = 3)
  gc_frame_end(frame);
  return *var_lastIndent;
}
Object meth_parser_lastIndent_58__61__40_1_41_11005(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 84, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastIndent:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lastIndent:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastIndent:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lastIndent:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastIndent = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_indentFreePass11008(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 85, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indentFreePass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indentFreePass (depth = 3)
  gc_frame_end(frame);
  return *var_indentFreePass;
}
Object meth_parser_indentFreePass_58__61__40_1_41_11009(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 86, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indentFreePass:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method indentFreePass:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for indentFreePass:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part indentFreePass:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_indentFreePass = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_minIndentLevel11012(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 87, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "minIndentLevel");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  gc_frame_end(frame);
  return *var_minIndentLevel;
}
Object meth_parser_minIndentLevel_58__61__40_1_41_11013(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 88, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "minIndentLevel:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method minIndentLevel:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for minIndentLevel:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part minIndentLevel:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_minIndentLevel = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_statementIndent11016(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 89, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_statementIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_statementIndent (depth = 3)
  gc_frame_end(frame);
  return *var_statementIndent;
}
Object meth_parser_statementIndent_58__61__40_1_41_11017(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 90, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementIndent:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method statementIndent:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_statementIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementIndent:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part statementIndent:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_statementIndent = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_tokens11020(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 91, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokens");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tokens (depth = 3)
  gc_frame_end(frame);
  return *var_tokens;
}
Object meth_parser_tokens_58__61__40_1_41_11021(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 92, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokens:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method tokens:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for tokens:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part tokens:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_tokens = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_values11024(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 93, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  gc_frame_end(frame);
  return *var_values;
}
Object meth_parser_values_58__61__40_1_41_11025(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 94, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method values:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for values:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part values:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_values = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_moduleObject11027(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 95, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "moduleObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_moduleObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_moduleObject (depth = 3)
  gc_frame_end(frame);
  return *var_moduleObject;
}
Object meth_parser_moduleObject_58__61__40_1_41_11028(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 96, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "moduleObject:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method moduleObject:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_moduleObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for moduleObject:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part moduleObject:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_moduleObject = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_comments11032(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 97, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_comments = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_comments (depth = 3)
  gc_frame_end(frame);
  return *var_comments;
}
Object meth_parser_comments_58__61__40_1_41_11033(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 98, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comments:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method comments:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_comments = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for comments:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part comments:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_comments = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_auto_count11036(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 99, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "auto_count");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_auto_count = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_auto_count (depth = 3)
  gc_frame_end(frame);
  return *var_auto_count;
}
Object meth_parser_auto_count_58__61__40_1_41_11037(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 100, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "auto_count:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method auto_count:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_auto_count = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for auto_count:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part auto_count:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_auto_count = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_noBlocks11040(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 101, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "noBlocks");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_noBlocks (depth = 3)
  gc_frame_end(frame);
  return *var_noBlocks;
}
Object meth_parser_blocksOK11042(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 102, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blocksOK");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blocksOK (depth = 3)
  gc_frame_end(frame);
  return *var_blocksOK;
}
Object meth_parser_braceIsType11044(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 103, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "braceIsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_braceIsType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_braceIsType (depth = 3)
  gc_frame_end(frame);
  return *var_braceIsType;
}
Object meth_parser_braceIsType_58__61__40_1_41_11045(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 104, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "braceIsType:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method braceIsType:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_braceIsType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for braceIsType:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part braceIsType:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_braceIsType = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_sym11061(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 105, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sym");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  gc_frame_end(frame);
  return *var_sym;
}
Object meth_parser_sym_58__61__40_1_41_11062(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 106, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sym:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sym:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sym:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sym:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_sym = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_lastToken11064(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 107, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  gc_frame_end(frame);
  return *var_lastToken;
}
Object meth_parser_lastToken_58__61__40_1_41_11065(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 108, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastToken:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lastToken:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastToken:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lastToken:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_previousCommentToken11067(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 109, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "previousCommentToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_previousCommentToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_previousCommentToken (depth = 3)
  gc_frame_end(frame);
  return *var_previousCommentToken;
}
Object meth_parser_previousCommentToken_58__61__40_1_41_11068(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 110, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "previousCommentToken:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method previousCommentToken:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_previousCommentToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for previousCommentToken:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part previousCommentToken:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_previousCommentToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_statementToken11070(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 111, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_statementToken (depth = 3)
  gc_frame_end(frame);
  return *var_statementToken;
}
Object meth_parser_statementToken_58__61__40_1_41_11071(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 112, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementToken:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method statementToken:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementToken:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part statementToken:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_statementToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_comment11074(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 113, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_comment = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_comment (depth = 3)
  gc_frame_end(frame);
  return *var_comment;
}
Object meth_parser_comment_58__61__40_1_41_11075(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 114, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comment:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method comment:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_comment = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for comment:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part comment:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_comment = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_firstCallOfNext11078(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 115, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "firstCallOfNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_firstCallOfNext = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_firstCallOfNext (depth = 3)
  gc_frame_end(frame);
  return *var_firstCallOfNext;
}
Object meth_parser_firstCallOfNext_58__61__40_1_41_11079(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 116, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "firstCallOfNext:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method firstCallOfNext:=(_)");
  Object params[1];
  int partcv[1];
  Object *var_firstCallOfNext = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for firstCallOfNext:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part firstCallOfNext:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_firstCallOfNext = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object module_parser_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(118, 118);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_standardGrace_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<parser>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(118, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[1];
  int partcv[1];
  Object *var_io = alloc_var();
  Object *var_ast = alloc_var();
  Object *var_util = alloc_var();
  Object *var_errormessages = alloc_var();
  Object *var_blankLocation = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "blankLocation");
  Object *var_lastLine = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "lastLine");
  Object *var_lastIndent = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "lastIndent");
  Object *var_indentFreePass = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "indentFreePass");
  Object *var_minIndentLevel = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "minIndentLevel");
  Object *var_statementIndent = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "statementIndent");
  Object *var_tokens = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "tokens");
  Object *var_values = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "values");
  Object *var_moduleObject = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "moduleObject");
  Object *var_comments = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "comments");
  Object *var_auto_count = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "auto_count");
  Object *var_noBlocks = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "noBlocks");
  Object *var_blocksOK = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "blocksOK");
  Object *var_braceIsType = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "braceIsType");
  Object *var_sym = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "sym");
  Object *var_lastToken = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "lastToken");
  Object *var_previousCommentToken = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "previousCommentToken");
  Object *var_statementToken = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "statementToken");
  Object *var_comment = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "comment");
  Object *var_firstCallOfNext = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "firstCallOfNext");
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "noteBlank"
  block_savedest(self);
  Object closure1 = createclosure(2, "noteBlank");
  setclosureframe(closure1, stackframe);
  addtoclosure(closure1, var_sym);
  addtoclosure(closure1, var_blankLocation);
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = (Object)closure1;
  Method *meth_meth_parser_noteBlank1 = addmethod2pos(self, "noteBlank", &meth_parser_noteBlank1, 1);
  int argcv_meth_parser_noteBlank1[] = {0};
  meth_meth_parser_noteBlank1->type = alloc_MethodType(1, argcv_meth_parser_noteBlank1);
  meth_meth_parser_noteBlank1->definitionModule = modulename;
  meth_meth_parser_noteBlank1->definitionLine = 37;
// compiled method node returning  (depth = 1)
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "next"
  block_savedest(self);
  Object closure9 = createclosure(7, "next");
  setclosureframe(closure9, stackframe);
  addtoclosure(closure9, var_tokens);
  addtoclosure(closure9, var_sym);
  addtoclosure(closure9, var_lastToken);
  addtoclosure(closure9, var_lastLine);
  addtoclosure(closure9, var_lastIndent);
  addtoclosure(closure9, var_util);
  addtoclosure(closure9, var_errormessages);
  struct UserObject *uo9 = (struct UserObject*)self;
  uo9->data[2] = (Object)closure9;
  Method *meth_meth_parser_next9 = addmethod2pos(self, "next", &meth_parser_next9, 2);
  int argcv_meth_parser_next9[] = {0};
  meth_meth_parser_next9->type = alloc_MethodType(1, argcv_meth_parser_next9);
  meth_meth_parser_next9->definitionModule = modulename;
  meth_meth_parser_next9->definitionLine = 43;
// compiled method node returning  (depth = 1)
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findNextToken(_)"
  block_savedest(self);
  Object closure60 = createclosure(2, "findNextToken(1)");
  setclosureframe(closure60, stackframe);
  addtoclosure(closure60, var_sym);
  addtoclosure(closure60, var_lastToken);
  struct UserObject *uo60 = (struct UserObject*)self;
  uo60->data[3] = (Object)closure60;
  Method *meth_meth_parser_findNextToken_40_1_41_60 = addmethod2pos(self, "findNextToken(1)", &meth_parser_findNextToken_40_1_41_60, 3);
  int argcv_meth_parser_findNextToken_40_1_41_60[] = {1};
  meth_meth_parser_findNextToken_40_1_41_60->type = alloc_MethodType(1, argcv_meth_parser_findNextToken_40_1_41_60);
  meth_meth_parser_findNextToken_40_1_41_60->definitionModule = modulename;
  meth_meth_parser_findNextToken_40_1_41_60->definitionLine = 63;
// compiled method node returning  (depth = 1)
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findNextTokenIndentedAt(_)"
  block_savedest(self);
  Object closure107 = createclosure(1, "findNextTokenIndentedAt(1)");
  setclosureframe(closure107, stackframe);
  addtoclosure(closure107, var_sym);
  struct UserObject *uo107 = (struct UserObject*)self;
  uo107->data[4] = (Object)closure107;
  Method *meth_meth_parser_findNextTokenIndentedAt_40_1_41_107 = addmethod2pos(self, "findNextTokenIndentedAt(1)", &meth_parser_findNextTokenIndentedAt_40_1_41_107, 4);
  int argcv_meth_parser_findNextTokenIndentedAt_40_1_41_107[] = {1};
  meth_meth_parser_findNextTokenIndentedAt_40_1_41_107->type = alloc_MethodType(1, argcv_meth_parser_findNextTokenIndentedAt_40_1_41_107);
  meth_meth_parser_findNextTokenIndentedAt_40_1_41_107->definitionModule = modulename;
  meth_meth_parser_findNextTokenIndentedAt_40_1_41_107->definitionLine = 81;
// compiled method node returning  (depth = 1)
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findNextValidToken(_)"
  block_savedest(self);
  Object closure189 = createclosure(1, "findNextValidToken(1)");
  setclosureframe(closure189, stackframe);
  addtoclosure(closure189, var_sym);
  struct UserObject *uo189 = (struct UserObject*)self;
  uo189->data[5] = (Object)closure189;
  Method *meth_meth_parser_findNextValidToken_40_1_41_189 = addmethod2pos(self, "findNextValidToken(1)", &meth_parser_findNextValidToken_40_1_41_189, 5);
  int argcv_meth_parser_findNextValidToken_40_1_41_189[] = {1};
  meth_meth_parser_findNextValidToken_40_1_41_189->type = alloc_MethodType(1, argcv_meth_parser_findNextValidToken_40_1_41_189);
  meth_meth_parser_findNextValidToken_40_1_41_189->definitionModule = modulename;
  meth_meth_parser_findNextValidToken_40_1_41_189->definitionLine = 96;
// compiled method node returning  (depth = 1)
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findClosingBrace(_,_)"
  block_savedest(self);
  Object closure230 = createclosure(1, "findClosingBrace(2)");
  setclosureframe(closure230, stackframe);
  addtoclosure(closure230, var_sym);
  struct UserObject *uo230 = (struct UserObject*)self;
  uo230->data[6] = (Object)closure230;
  Method *meth_meth_parser_findClosingBrace_40_2_41_230 = addmethod2pos(self, "findClosingBrace(2)", &meth_parser_findClosingBrace_40_2_41_230, 6);
  int argcv_meth_parser_findClosingBrace_40_2_41_230[] = {2};
  meth_meth_parser_findClosingBrace_40_2_41_230->type = alloc_MethodType(1, argcv_meth_parser_findClosingBrace_40_2_41_230);
  meth_meth_parser_findClosingBrace_40_2_41_230->definitionModule = modulename;
  meth_meth_parser_findClosingBrace_40_2_41_230->definitionLine = 121;
// compiled method node returning  (depth = 1)
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "accept(_)"
  block_savedest(self);
  Object closure382 = createclosure(1, "accept(1)");
  setclosureframe(closure382, stackframe);
  addtoclosure(closure382, var_sym);
  struct UserObject *uo382 = (struct UserObject*)self;
  uo382->data[7] = (Object)closure382;
  Method *meth_meth_parser_accept_40_1_41_382 = addmethod2pos(self, "accept(1)", &meth_parser_accept_40_1_41_382, 7);
  int argcv_meth_parser_accept_40_1_41_382[] = {1};
  meth_meth_parser_accept_40_1_41_382->type = alloc_MethodType(1, argcv_meth_parser_accept_40_1_41_382);
  meth_meth_parser_accept_40_1_41_382->definitionModule = modulename;
  meth_meth_parser_accept_40_1_41_382->definitionLine = 159;
// compiled method node returning  (depth = 1)
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptKeyword(_)"
  block_savedest(self);
  Object closure388 = createclosure(1, "acceptKeyword(1)");
  setclosureframe(closure388, stackframe);
  addtoclosure(closure388, var_sym);
  struct UserObject *uo388 = (struct UserObject*)self;
  uo388->data[8] = (Object)closure388;
  Method *meth_meth_parser_acceptKeyword_40_1_41_388 = addmethod2pos(self, "acceptKeyword(1)", &meth_parser_acceptKeyword_40_1_41_388, 8);
  int argcv_meth_parser_acceptKeyword_40_1_41_388[] = {1};
  meth_meth_parser_acceptKeyword_40_1_41_388->type = alloc_MethodType(1, argcv_meth_parser_acceptKeyword_40_1_41_388);
  meth_meth_parser_acceptKeyword_40_1_41_388->definitionModule = modulename;
  meth_meth_parser_acceptKeyword_40_1_41_388->definitionLine = 165;
// compiled method node returning  (depth = 1)
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptSameLine(_)"
  block_savedest(self);
  Object closure402 = createclosure(3, "acceptSameLine(1)");
  setclosureframe(closure402, stackframe);
  addtoclosure(closure402, var_lastIndent);
  addtoclosure(closure402, var_sym);
  addtoclosure(closure402, var_lastLine);
  struct UserObject *uo402 = (struct UserObject*)self;
  uo402->data[9] = (Object)closure402;
  Method *meth_meth_parser_acceptSameLine_40_1_41_402 = addmethod2pos(self, "acceptSameLine(1)", &meth_parser_acceptSameLine_40_1_41_402, 9);
  int argcv_meth_parser_acceptSameLine_40_1_41_402[] = {1};
  meth_meth_parser_acceptSameLine_40_1_41_402->type = alloc_MethodType(1, argcv_meth_parser_acceptSameLine_40_1_41_402);
  meth_meth_parser_acceptSameLine_40_1_41_402->definitionModule = modulename;
  meth_meth_parser_acceptSameLine_40_1_41_402->definitionLine = 170;
// compiled method node returning  (depth = 1)
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptWithoutSpaces(_)"
  block_savedest(self);
  Object closure424 = createclosure(3, "acceptWithoutSpaces(1)");
  setclosureframe(closure424, stackframe);
  addtoclosure(closure424, var_lastToken);
  addtoclosure(closure424, var_sym);
  addtoclosure(closure424, var_lastLine);
  struct UserObject *uo424 = (struct UserObject*)self;
  uo424->data[10] = (Object)closure424;
  Method *meth_meth_parser_acceptWithoutSpaces_40_1_41_424 = addmethod2pos(self, "acceptWithoutSpaces(1)", &meth_parser_acceptWithoutSpaces_40_1_41_424, 10);
  int argcv_meth_parser_acceptWithoutSpaces_40_1_41_424[] = {1};
  meth_meth_parser_acceptWithoutSpaces_40_1_41_424->type = alloc_MethodType(1, argcv_meth_parser_acceptWithoutSpaces_40_1_41_424);
  meth_meth_parser_acceptWithoutSpaces_40_1_41_424->definitionModule = modulename;
  meth_meth_parser_acceptWithoutSpaces_40_1_41_424->definitionLine = 178;
// compiled method node returning  (depth = 1)
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptAfterSpaces(_)"
  block_savedest(self);
  Object closure453 = createclosure(3, "acceptAfterSpaces(1)");
  setclosureframe(closure453, stackframe);
  addtoclosure(closure453, var_sym);
  addtoclosure(closure453, var_lastLine);
  addtoclosure(closure453, var_lastToken);
  struct UserObject *uo453 = (struct UserObject*)self;
  uo453->data[11] = (Object)closure453;
  Method *meth_meth_parser_acceptAfterSpaces_40_1_41_453 = addmethod2pos(self, "acceptAfterSpaces(1)", &meth_parser_acceptAfterSpaces_40_1_41_453, 11);
  int argcv_meth_parser_acceptAfterSpaces_40_1_41_453[] = {1};
  meth_meth_parser_acceptAfterSpaces_40_1_41_453->type = alloc_MethodType(1, argcv_meth_parser_acceptAfterSpaces_40_1_41_453);
  meth_meth_parser_acceptAfterSpaces_40_1_41_453->definitionModule = modulename;
  meth_meth_parser_acceptAfterSpaces_40_1_41_453->definitionLine = 185;
// compiled method node returning  (depth = 1)
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "accept(_)onLineOf(_)"
  block_savedest(self);
  Object closure490 = createclosure(1, "accept(1)onLineOf(1)");
  setclosureframe(closure490, stackframe);
  addtoclosure(closure490, var_sym);
  struct UserObject *uo490 = (struct UserObject*)self;
  uo490->data[12] = (Object)closure490;
  Method *meth_meth_parser_accept_40_1_41_onLineOf_40_1_41_490 = addmethod2pos(self, "accept(1)onLineOf(1)", &meth_parser_accept_40_1_41_onLineOf_40_1_41_490, 12);
  int argcv_meth_parser_accept_40_1_41_onLineOf_40_1_41_490[] = {1, 1};
  meth_meth_parser_accept_40_1_41_onLineOf_40_1_41_490->type = alloc_MethodType(2, argcv_meth_parser_accept_40_1_41_onLineOf_40_1_41_490);
  meth_meth_parser_accept_40_1_41_onLineOf_40_1_41_490->definitionModule = modulename;
  meth_meth_parser_accept_40_1_41_onLineOf_40_1_41_490->definitionLine = 195;
// compiled method node returning  (depth = 1)
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptAfterSpaces(_)onLineOf(_)"
  block_savedest(self);
  Object closure516 = createclosure(2, "acceptAfterSpaces(1)onLineOf(1)");
  setclosureframe(closure516, stackframe);
  addtoclosure(closure516, var_sym);
  addtoclosure(closure516, var_lastToken);
  struct UserObject *uo516 = (struct UserObject*)self;
  uo516->data[13] = (Object)closure516;
  Method *meth_meth_parser_acceptAfterSpaces_40_1_41_onLineOf_40_1_41_516 = addmethod2pos(self, "acceptAfterSpaces(1)onLineOf(1)", &meth_parser_acceptAfterSpaces_40_1_41_onLineOf_40_1_41_516, 13);
  int argcv_meth_parser_acceptAfterSpaces_40_1_41_onLineOf_40_1_41_516[] = {1, 1};
  meth_meth_parser_acceptAfterSpaces_40_1_41_onLineOf_40_1_41_516->type = alloc_MethodType(2, argcv_meth_parser_acceptAfterSpaces_40_1_41_onLineOf_40_1_41_516);
  meth_meth_parser_acceptAfterSpaces_40_1_41_onLineOf_40_1_41_516->definitionModule = modulename;
  meth_meth_parser_acceptAfterSpaces_40_1_41_onLineOf_40_1_41_516->definitionLine = 202;
// compiled method node returning  (depth = 1)
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "accept(_)onLineOfLastOr(_)"
  block_savedest(self);
  Object closure555 = createclosure(2, "accept(1)onLineOfLastOr(1)");
  setclosureframe(closure555, stackframe);
  addtoclosure(closure555, var_sym);
  addtoclosure(closure555, var_lastToken);
  struct UserObject *uo555 = (struct UserObject*)self;
  uo555->data[14] = (Object)closure555;
  Method *meth_meth_parser_accept_40_1_41_onLineOfLastOr_40_1_41_555 = addmethod2pos(self, "accept(1)onLineOfLastOr(1)", &meth_parser_accept_40_1_41_onLineOfLastOr_40_1_41_555, 14);
  int argcv_meth_parser_accept_40_1_41_onLineOfLastOr_40_1_41_555[] = {1, 1};
  meth_meth_parser_accept_40_1_41_onLineOfLastOr_40_1_41_555->type = alloc_MethodType(2, argcv_meth_parser_accept_40_1_41_onLineOfLastOr_40_1_41_555);
  meth_meth_parser_accept_40_1_41_onLineOfLastOr_40_1_41_555->definitionModule = modulename;
  meth_meth_parser_accept_40_1_41_onLineOfLastOr_40_1_41_555->definitionLine = 214;
// compiled method node returning  (depth = 1)
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptArgumentOnLineOf(_)"
  block_savedest(self);
  Object closure591 = createclosure(1, "acceptArgumentOnLineOf(1)");
  setclosureframe(closure591, stackframe);
  addtoclosure(closure591, var_sym);
  struct UserObject *uo591 = (struct UserObject*)self;
  uo591->data[15] = (Object)closure591;
  Method *meth_meth_parser_acceptArgumentOnLineOf_40_1_41_591 = addmethod2pos(self, "acceptArgumentOnLineOf(1)", &meth_parser_acceptArgumentOnLineOf_40_1_41_591, 15);
  int argcv_meth_parser_acceptArgumentOnLineOf_40_1_41_591[] = {1};
  meth_meth_parser_acceptArgumentOnLineOf_40_1_41_591->type = alloc_MethodType(1, argcv_meth_parser_acceptArgumentOnLineOf_40_1_41_591);
  meth_meth_parser_acceptArgumentOnLineOf_40_1_41_591->definitionModule = modulename;
  meth_meth_parser_acceptArgumentOnLineOf_40_1_41_591->definitionLine = 220;
// compiled method node returning  (depth = 1)
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "tokenOnSameLine"
  block_savedest(self);
  Object closure632 = createclosure(3, "tokenOnSameLine");
  setclosureframe(closure632, stackframe);
  addtoclosure(closure632, var_lastIndent);
  addtoclosure(closure632, var_sym);
  addtoclosure(closure632, var_lastLine);
  struct UserObject *uo632 = (struct UserObject*)self;
  uo632->data[16] = (Object)closure632;
  Method *meth_meth_parser_tokenOnSameLine632 = addmethod2pos(self, "tokenOnSameLine", &meth_parser_tokenOnSameLine632, 16);
  int argcv_meth_parser_tokenOnSameLine632[] = {0};
  meth_meth_parser_tokenOnSameLine632->type = alloc_MethodType(1, argcv_meth_parser_tokenOnSameLine632);
  meth_meth_parser_tokenOnSameLine632->definitionModule = modulename;
  meth_meth_parser_tokenOnSameLine632->definitionLine = 231;
// compiled method node returning  (depth = 1)
// Begin line 235
  setline(235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "didConsume(_)"
  block_savedest(self);
  Object closure646 = createclosure(1, "didConsume(1)");
  setclosureframe(closure646, stackframe);
  addtoclosure(closure646, var_tokens);
  struct UserObject *uo646 = (struct UserObject*)self;
  uo646->data[17] = (Object)closure646;
  Method *meth_meth_parser_didConsume_40_1_41_646 = addmethod2pos(self, "didConsume(1)", &meth_parser_didConsume_40_1_41_646, 17);
  int argcv_meth_parser_didConsume_40_1_41_646[] = {1};
  meth_meth_parser_didConsume_40_1_41_646->type = alloc_MethodType(1, argcv_meth_parser_didConsume_40_1_41_646);
  meth_meth_parser_didConsume_40_1_41_646->definitionModule = modulename;
  meth_meth_parser_didConsume_40_1_41_646->definitionLine = 235;
// compiled method node returning  (depth = 1)
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "ifConsume(_)then(_)"
  block_savedest(self);
  Object closure656 = createclosure(1, "ifConsume(1)then(1)");
  setclosureframe(closure656, stackframe);
  addtoclosure(closure656, var_tokens);
  struct UserObject *uo656 = (struct UserObject*)self;
  uo656->data[18] = (Object)closure656;
  Method *meth_meth_parser_ifConsume_40_1_41_then_40_1_41_656 = addmethod2pos(self, "ifConsume(1)then(1)", &meth_parser_ifConsume_40_1_41_then_40_1_41_656, 18);
  int argcv_meth_parser_ifConsume_40_1_41_then_40_1_41_656[] = {1, 1};
  meth_meth_parser_ifConsume_40_1_41_then_40_1_41_656->type = alloc_MethodType(2, argcv_meth_parser_ifConsume_40_1_41_then_40_1_41_656);
  meth_meth_parser_ifConsume_40_1_41_then_40_1_41_656->definitionModule = modulename;
  meth_meth_parser_ifConsume_40_1_41_then_40_1_41_656->definitionLine = 241;
// compiled method node returning  (depth = 1)
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushnum"
  block_savedest(self);
  Object closure669 = createclosure(3, "pushnum");
  setclosureframe(closure669, stackframe);
  addtoclosure(closure669, var_sym);
  addtoclosure(closure669, var_ast);
  addtoclosure(closure669, var_values);
  struct UserObject *uo669 = (struct UserObject*)self;
  uo669->data[19] = (Object)closure669;
  Method *meth_meth_parser_pushnum669 = addmethod2pos(self, "pushnum", &meth_parser_pushnum669, 19);
  int argcv_meth_parser_pushnum669[] = {0};
  meth_meth_parser_pushnum669->type = alloc_MethodType(1, argcv_meth_parser_pushnum669);
  meth_meth_parser_pushnum669->definitionModule = modulename;
  meth_meth_parser_pushnum669->definitionLine = 251;
// compiled method node returning  (depth = 1)
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushstring"
  block_savedest(self);
  Object closure680 = createclosure(3, "pushstring");
  setclosureframe(closure680, stackframe);
  addtoclosure(closure680, var_sym);
  addtoclosure(closure680, var_ast);
  addtoclosure(closure680, var_values);
  struct UserObject *uo680 = (struct UserObject*)self;
  uo680->data[20] = (Object)closure680;
  Method *meth_meth_parser_pushstring680 = addmethod2pos(self, "pushstring", &meth_parser_pushstring680, 20);
  int argcv_meth_parser_pushstring680[] = {0};
  meth_meth_parser_pushstring680->type = alloc_MethodType(1, argcv_meth_parser_pushstring680);
  meth_meth_parser_pushstring680->definitionModule = modulename;
  meth_meth_parser_pushstring680->definitionLine = 258;
// compiled method node returning  (depth = 1)
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushidentifier"
  block_savedest(self);
  Object closure691 = createclosure(5, "pushidentifier");
  setclosureframe(closure691, stackframe);
  addtoclosure(closure691, var_sym);
  addtoclosure(closure691, var_util);
  addtoclosure(closure691, var_ast);
  addtoclosure(closure691, var_auto_count);
  addtoclosure(closure691, var_values);
  struct UserObject *uo691 = (struct UserObject*)self;
  uo691->data[21] = (Object)closure691;
  Method *meth_meth_parser_pushidentifier691 = addmethod2pos(self, "pushidentifier", &meth_parser_pushidentifier691, 21);
  int argcv_meth_parser_pushidentifier691[] = {0};
  meth_meth_parser_pushidentifier691->type = alloc_MethodType(1, argcv_meth_parser_pushidentifier691);
  meth_meth_parser_pushidentifier691->definitionModule = modulename;
  meth_meth_parser_pushidentifier691->definitionLine = 266;
// compiled method node returning  (depth = 1)
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkAnnotation(_)"
  block_savedest(self);
  Object closure730 = createclosure(2, "checkAnnotation(1)");
  setclosureframe(closure730, stackframe);
  addtoclosure(closure730, var_sym);
  addtoclosure(closure730, var_errormessages);
  struct UserObject *uo730 = (struct UserObject*)self;
  uo730->data[22] = (Object)closure730;
  Method *meth_meth_parser_checkAnnotation_40_1_41_730 = addmethod2pos(self, "checkAnnotation(1)", &meth_parser_checkAnnotation_40_1_41_730, 22);
  int argcv_meth_parser_checkAnnotation_40_1_41_730[] = {1};
  meth_meth_parser_checkAnnotation_40_1_41_730->type = alloc_MethodType(1, argcv_meth_parser_checkAnnotation_40_1_41_730);
  meth_meth_parser_checkAnnotation_40_1_41_730->definitionModule = modulename;
  meth_meth_parser_checkAnnotation_40_1_41_730->definitionLine = 278;
// compiled method node returning  (depth = 1)
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doannotation"
  block_savedest(self);
  Object closure820 = createclosure(5, "doannotation");
  setclosureframe(closure820, stackframe);
  addtoclosure(closure820, var_noBlocks);
  addtoclosure(closure820, var_errormessages);
  addtoclosure(closure820, var_sym);
  addtoclosure(closure820, var_lastToken);
  addtoclosure(closure820, var_values);
  struct UserObject *uo820 = (struct UserObject*)self;
  uo820->data[23] = (Object)closure820;
  Method *meth_meth_parser_doannotation820 = addmethod2pos(self, "doannotation", &meth_parser_doannotation820, 23);
  int argcv_meth_parser_doannotation820[] = {0};
  meth_meth_parser_doannotation820->type = alloc_MethodType(1, argcv_meth_parser_doannotation820);
  meth_meth_parser_doannotation820->definitionModule = modulename;
  meth_meth_parser_doannotation820->definitionLine = 296;
// compiled method node returning  (depth = 1)
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "blank"
  block_savedest(self);
  Object closure984 = createclosure(8, "blank");
  setclosureframe(closure984, stackframe);
  addtoclosure(closure984, var_blankLocation);
  addtoclosure(closure984, var_lastToken);
  addtoclosure(closure984, var_sym);
  addtoclosure(closure984, var_done);
  addtoclosure(closure984, var_previousCommentToken);
  addtoclosure(closure984, var_values);
  addtoclosure(closure984, var_util);
  addtoclosure(closure984, var_ast);
  struct UserObject *uo984 = (struct UserObject*)self;
  uo984->data[24] = (Object)closure984;
  Method *meth_meth_parser_blank984 = addmethod2pos(self, "blank", &meth_parser_blank984, 24);
  int argcv_meth_parser_blank984[] = {0};
  meth_meth_parser_blank984->type = alloc_MethodType(1, argcv_meth_parser_blank984);
  meth_meth_parser_blank984->definitionModule = modulename;
  meth_meth_parser_blank984->definitionLine = 344;
// compiled method node returning  (depth = 1)
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dotypeterm"
  block_savedest(self);
  Object closure1071 = createclosure(1, "dotypeterm");
  setclosureframe(closure1071, stackframe);
  addtoclosure(closure1071, var_noBlocks);
  struct UserObject *uo1071 = (struct UserObject*)self;
  uo1071->data[25] = (Object)closure1071;
  Method *meth_meth_parser_dotypeterm1071 = addmethod2pos(self, "dotypeterm", &meth_parser_dotypeterm1071, 25);
  int argcv_meth_parser_dotypeterm1071[] = {0};
  meth_meth_parser_dotypeterm1071->type = alloc_MethodType(1, argcv_meth_parser_dotypeterm1071);
  meth_meth_parser_dotypeterm1071->definitionModule = modulename;
  meth_meth_parser_dotypeterm1071->definitionLine = 362;
// compiled method node returning  (depth = 1)
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeexpression"
  block_savedest(self);
  Object closure1088 = createclosure(6, "typeexpression");
  setclosureframe(closure1088, stackframe);
  addtoclosure(closure1088, var_values);
  addtoclosure(closure1088, var_statementToken);
  addtoclosure(closure1088, var_sym);
  addtoclosure(closure1088, var_errormessages);
  addtoclosure(closure1088, var_lastToken);
  addtoclosure(closure1088, var_noBlocks);
  struct UserObject *uo1088 = (struct UserObject*)self;
  uo1088->data[26] = (Object)closure1088;
  Method *meth_meth_parser_typeexpression1088 = addmethod2pos(self, "typeexpression", &meth_parser_typeexpression1088, 26);
  int argcv_meth_parser_typeexpression1088[] = {0};
  meth_meth_parser_typeexpression1088->type = alloc_MethodType(1, argcv_meth_parser_typeexpression1088);
  meth_meth_parser_typeexpression1088->definitionModule = modulename;
  meth_meth_parser_typeexpression1088->definitionLine = 374;
// compiled method node returning  (depth = 1)
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "newIf(_,_,_)"
  block_savedest(self);
  Object closure1180 = createclosure(1, "newIf(3)");
  setclosureframe(closure1180, stackframe);
  addtoclosure(closure1180, var_ast);
  struct UserObject *uo1180 = (struct UserObject*)self;
  uo1180->data[27] = (Object)closure1180;
  Method *meth_meth_parser_newIf_40_3_41_1180 = addmethod2pos(self, "newIf(3)", &meth_parser_newIf_40_3_41_1180, 27);
  int argcv_meth_parser_newIf_40_3_41_1180[] = {3};
  meth_meth_parser_newIf_40_3_41_1180->type = alloc_MethodType(1, argcv_meth_parser_newIf_40_3_41_1180);
  meth_meth_parser_newIf_40_3_41_1180->definitionModule = modulename;
  meth_meth_parser_newIf_40_3_41_1180->definitionLine = 413;
// compiled method node returning  (depth = 1)
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "block"
  block_savedest(self);
  Object closure1197 = createclosure(12, "block");
  setclosureframe(closure1197, stackframe);
  addtoclosure(closure1197, var_sym);
  addtoclosure(closure1197, var_statementIndent);
  addtoclosure(closure1197, var_statementToken);
  addtoclosure(closure1197, var_blocksOK);
  addtoclosure(closure1197, var_values);
  addtoclosure(closure1197, var_braceIsType);
  addtoclosure(closure1197, var_errormessages);
  addtoclosure(closure1197, var_lastToken);
  addtoclosure(closure1197, var_indentFreePass);
  addtoclosure(closure1197, var_util);
  addtoclosure(closure1197, var_ast);
  addtoclosure(closure1197, var_minIndentLevel);
  struct UserObject *uo1197 = (struct UserObject*)self;
  uo1197->data[28] = (Object)closure1197;
  Method *meth_meth_parser_block1197 = addmethod2pos(self, "block", &meth_parser_block1197, 28);
  int argcv_meth_parser_block1197[] = {0};
  meth_meth_parser_block1197->type = alloc_MethodType(1, argcv_meth_parser_block1197);
  meth_meth_parser_block1197->definitionModule = modulename;
  meth_meth_parser_block1197->definitionLine = 419;
// compiled method node returning  (depth = 1)
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doif"
  block_savedest(self);
  Object closure1719 = createclosure(9, "doif");
  setclosureframe(closure1719, stackframe);
  addtoclosure(closure1719, var_sym);
  addtoclosure(closure1719, var_errormessages);
  addtoclosure(closure1719, var_blocksOK);
  addtoclosure(closure1719, var_lastToken);
  addtoclosure(closure1719, var_values);
  addtoclosure(closure1719, var_minIndentLevel);
  addtoclosure(closure1719, var_statementIndent);
  addtoclosure(closure1719, var_statementToken);
  addtoclosure(closure1719, var_util);
  struct UserObject *uo1719 = (struct UserObject*)self;
  uo1719->data[29] = (Object)closure1719;
  Method *meth_meth_parser_doif1719 = addmethod2pos(self, "doif", &meth_parser_doif1719, 29);
  int argcv_meth_parser_doif1719[] = {0};
  meth_meth_parser_doif1719->type = alloc_MethodType(1, argcv_meth_parser_doif1719);
  meth_meth_parser_doif1719->definitionModule = modulename;
  meth_meth_parser_doif1719->definitionLine = 592;
// compiled method node returning  (depth = 1)
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "identifier"
  block_savedest(self);
  Object closure3101 = createclosure(1, "identifier");
  setclosureframe(closure3101, stackframe);
  addtoclosure(closure3101, var_sym);
  struct UserObject *uo3101 = (struct UserObject*)self;
  uo3101->data[30] = (Object)closure3101;
  Method *meth_meth_parser_identifier3101 = addmethod2pos(self, "identifier", &meth_parser_identifier3101, 30);
  int argcv_meth_parser_identifier3101[] = {0};
  meth_meth_parser_identifier3101->type = alloc_MethodType(1, argcv_meth_parser_identifier3101);
  meth_meth_parser_identifier3101->definitionModule = modulename;
  meth_meth_parser_identifier3101->definitionLine = 990;
// compiled method node returning  (depth = 1)
// Begin line 1000
  setline(1000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "prefixop"
  block_savedest(self);
  Object closure3117 = createclosure(6, "prefixop");
  setclosureframe(closure3117, stackframe);
  addtoclosure(closure3117, var_sym);
  addtoclosure(closure3117, var_blocksOK);
  addtoclosure(closure3117, var_errormessages);
  addtoclosure(closure3117, var_lastToken);
  addtoclosure(closure3117, var_values);
  addtoclosure(closure3117, var_ast);
  struct UserObject *uo3117 = (struct UserObject*)self;
  uo3117->data[31] = (Object)closure3117;
  Method *meth_meth_parser_prefixop3117 = addmethod2pos(self, "prefixop", &meth_parser_prefixop3117, 31);
  int argcv_meth_parser_prefixop3117[] = {0};
  meth_meth_parser_prefixop3117->type = alloc_MethodType(1, argcv_meth_parser_prefixop3117);
  meth_meth_parser_prefixop3117->definitionModule = modulename;
  meth_meth_parser_prefixop3117->definitionLine = 1000;
// compiled method node returning  (depth = 1)
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "generic"
  block_savedest(self);
  Object closure3300 = createclosure(5, "generic");
  setclosureframe(closure3300, stackframe);
  addtoclosure(closure3300, var_values);
  addtoclosure(closure3300, var_sym);
  addtoclosure(closure3300, var_errormessages);
  addtoclosure(closure3300, var_lastToken);
  addtoclosure(closure3300, var_ast);
  struct UserObject *uo3300 = (struct UserObject*)self;
  uo3300->data[32] = (Object)closure3300;
  Method *meth_meth_parser_generic3300 = addmethod2pos(self, "generic", &meth_parser_generic3300, 32);
  int argcv_meth_parser_generic3300[] = {0};
  meth_meth_parser_generic3300->type = alloc_MethodType(1, argcv_meth_parser_generic3300);
  meth_meth_parser_generic3300->definitionModule = modulename;
  meth_meth_parser_generic3300->definitionLine = 1056;
// compiled method node returning  (depth = 1)
// Begin line 1116
  setline(1116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "trycatch"
  block_savedest(self);
  Object closure3483 = createclosure(9, "trycatch");
  setclosureframe(closure3483, stackframe);
  addtoclosure(closure3483, var_sym);
  addtoclosure(closure3483, var_minIndentLevel);
  addtoclosure(closure3483, var_errormessages);
  addtoclosure(closure3483, var_lastToken);
  addtoclosure(closure3483, var_blocksOK);
  addtoclosure(closure3483, var_values);
  addtoclosure(closure3483, var_tokens);
  addtoclosure(closure3483, var_util);
  addtoclosure(closure3483, var_ast);
  struct UserObject *uo3483 = (struct UserObject*)self;
  uo3483->data[33] = (Object)closure3483;
  Method *meth_meth_parser_trycatch3483 = addmethod2pos(self, "trycatch", &meth_parser_trycatch3483, 33);
  int argcv_meth_parser_trycatch3483[] = {0};
  meth_meth_parser_trycatch3483->type = alloc_MethodType(1, argcv_meth_parser_trycatch3483);
  meth_meth_parser_trycatch3483->definitionModule = modulename;
  meth_meth_parser_trycatch3483->definitionLine = 1116;
// compiled method node returning  (depth = 1)
// Begin line 1284
  setline(1284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "matchcase"
  block_savedest(self);
  Object closure4084 = createclosure(9, "matchcase");
  setclosureframe(closure4084, stackframe);
  addtoclosure(closure4084, var_sym);
  addtoclosure(closure4084, var_minIndentLevel);
  addtoclosure(closure4084, var_errormessages);
  addtoclosure(closure4084, var_blocksOK);
  addtoclosure(closure4084, var_lastToken);
  addtoclosure(closure4084, var_values);
  addtoclosure(closure4084, var_tokens);
  addtoclosure(closure4084, var_util);
  addtoclosure(closure4084, var_ast);
  struct UserObject *uo4084 = (struct UserObject*)self;
  uo4084->data[34] = (Object)closure4084;
  Method *meth_meth_parser_matchcase4084 = addmethod2pos(self, "matchcase", &meth_parser_matchcase4084, 34);
  int argcv_meth_parser_matchcase4084[] = {0};
  meth_meth_parser_matchcase4084->type = alloc_MethodType(1, argcv_meth_parser_matchcase4084);
  meth_meth_parser_matchcase4084->definitionModule = modulename;
  meth_meth_parser_matchcase4084->definitionLine = 1284;
// compiled method node returning  (depth = 1)
// Begin line 1389
  setline(1389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "term"
  block_savedest(self);
  Object closure4459 = createclosure(3, "term");
  setclosureframe(closure4459, stackframe);
  addtoclosure(closure4459, var_sym);
  addtoclosure(closure4459, var_util);
  addtoclosure(closure4459, var_lastToken);
  struct UserObject *uo4459 = (struct UserObject*)self;
  uo4459->data[35] = (Object)closure4459;
  Method *meth_meth_parser_term4459 = addmethod2pos(self, "term", &meth_parser_term4459, 35);
  int argcv_meth_parser_term4459[] = {0};
  meth_meth_parser_term4459->type = alloc_MethodType(1, argcv_meth_parser_term4459);
  meth_meth_parser_term4459->definitionModule = modulename;
  meth_meth_parser_term4459->definitionLine = 1389;
// compiled method node returning  (depth = 1)
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "expression(_)"
  block_savedest(self);
  Object closure4559 = createclosure(6, "expression(1)");
  setclosureframe(closure4559, stackframe);
  addtoclosure(closure4559, var_values);
  addtoclosure(closure4559, var_sym);
  addtoclosure(closure4559, var_util);
  addtoclosure(closure4559, var_statementToken);
  addtoclosure(closure4559, var_errormessages);
  addtoclosure(closure4559, var_lastToken);
  struct UserObject *uo4559 = (struct UserObject*)self;
  uo4559->data[36] = (Object)closure4559;
  Method *meth_meth_parser_expression_40_1_41_4559 = addmethod2pos(self, "expression(1)", &meth_parser_expression_40_1_41_4559, 36);
  int argcv_meth_parser_expression_40_1_41_4559[] = {1};
  meth_meth_parser_expression_40_1_41_4559->type = alloc_MethodType(1, argcv_meth_parser_expression_40_1_41_4559);
  meth_meth_parser_expression_40_1_41_4559->definitionModule = modulename;
  meth_meth_parser_expression_40_1_41_4559->definitionLine = 1421;
// compiled method node returning  (depth = 1)
// Begin line 1464
  setline(1464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "postfixsquare"
  block_savedest(self);
  Object closure4667 = createclosure(5, "postfixsquare");
  setclosureframe(closure4667, stackframe);
  addtoclosure(closure4667, var_sym);
  addtoclosure(closure4667, var_values);
  addtoclosure(closure4667, var_blocksOK);
  addtoclosure(closure4667, var_errormessages);
  addtoclosure(closure4667, var_lastToken);
  struct UserObject *uo4667 = (struct UserObject*)self;
  uo4667->data[37] = (Object)closure4667;
  Method *meth_meth_parser_postfixsquare4667 = addmethod2pos(self, "postfixsquare", &meth_parser_postfixsquare4667, 37);
  int argcv_meth_parser_postfixsquare4667[] = {0};
  meth_meth_parser_postfixsquare4667->type = alloc_MethodType(1, argcv_meth_parser_postfixsquare4667);
  meth_meth_parser_postfixsquare4667->definitionModule = modulename;
  meth_meth_parser_postfixsquare4667->definitionLine = 1464;
// compiled method node returning  (depth = 1)
// Begin line 1502
  setline(1502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "oprec(_)"
  struct UserObject *uo4773 = (struct UserObject*)self;
  uo4773->data[38] = emptyclosure;
  Method *meth_meth_parser_oprec_40_1_41_4773 = addmethod2pos(self, "oprec(1)", &meth_parser_oprec_40_1_41_4773, 38);
  int argcv_meth_parser_oprec_40_1_41_4773[] = {1};
  meth_meth_parser_oprec_40_1_41_4773->type = alloc_MethodType(1, argcv_meth_parser_oprec_40_1_41_4773);
  meth_meth_parser_oprec_40_1_41_4773->definitionModule = modulename;
  meth_meth_parser_oprec_40_1_41_4773->definitionLine = 1502;
// compiled method node returning  (depth = 1)
// Begin line 1512
  setline(1512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "toprec(_)"
  struct UserObject *uo4787 = (struct UserObject*)self;
  uo4787->data[39] = emptyclosure;
  Method *meth_meth_parser_toprec_40_1_41_4787 = addmethod2pos(self, "toprec(1)", &meth_parser_toprec_40_1_41_4787, 39);
  int argcv_meth_parser_toprec_40_1_41_4787[] = {1};
  meth_meth_parser_toprec_40_1_41_4787->type = alloc_MethodType(1, argcv_meth_parser_toprec_40_1_41_4787);
  meth_meth_parser_toprec_40_1_41_4787->definitionModule = modulename;
  meth_meth_parser_toprec_40_1_41_4787->definitionLine = 1512;
// compiled method node returning  (depth = 1)
// Begin line 1521
  setline(1521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeexpressionrest"
  block_savedest(self);
  Object closure4800 = createclosure(1, "typeexpressionrest");
  setclosureframe(closure4800, stackframe);
  addtoclosure(closure4800, var_noBlocks);
  struct UserObject *uo4800 = (struct UserObject*)self;
  uo4800->data[40] = (Object)closure4800;
  Method *meth_meth_parser_typeexpressionrest4800 = addmethod2pos(self, "typeexpressionrest", &meth_parser_typeexpressionrest4800, 40);
  int argcv_meth_parser_typeexpressionrest4800[] = {0};
  meth_meth_parser_typeexpressionrest4800->type = alloc_MethodType(1, argcv_meth_parser_typeexpressionrest4800);
  meth_meth_parser_typeexpressionrest4800->definitionModule = modulename;
  meth_meth_parser_typeexpressionrest4800->definitionLine = 1521;
// compiled method node returning  (depth = 1)
// Begin line 1527
  setline(1527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "valueexpressionrest"
  block_savedest(self);
  Object closure4813 = createclosure(1, "valueexpressionrest");
  setclosureframe(closure4813, stackframe);
  addtoclosure(closure4813, var_blocksOK);
  struct UserObject *uo4813 = (struct UserObject*)self;
  uo4813->data[41] = (Object)closure4813;
  Method *meth_meth_parser_valueexpressionrest4813 = addmethod2pos(self, "valueexpressionrest", &meth_parser_valueexpressionrest4813, 41);
  int argcv_meth_parser_valueexpressionrest4813[] = {0};
  meth_meth_parser_valueexpressionrest4813->type = alloc_MethodType(1, argcv_meth_parser_valueexpressionrest4813);
  meth_meth_parser_valueexpressionrest4813->definitionModule = modulename;
  meth_meth_parser_valueexpressionrest4813->definitionLine = 1527;
// compiled method node returning  (depth = 1)
// Begin line 1533
  setline(1533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "expressionrest(_)recursingWith(_)blocks(_)"
  block_savedest(self);
  Object closure4826 = createclosure(7, "expressionrest(1)recursingWith(1)blocks(1)");
  setclosureframe(closure4826, stackframe);
  addtoclosure(closure4826, var_values);
  addtoclosure(closure4826, var_sym);
  addtoclosure(closure4826, var_statementToken);
  addtoclosure(closure4826, var_errormessages);
  addtoclosure(closure4826, var_lastToken);
  addtoclosure(closure4826, var_util);
  addtoclosure(closure4826, var_ast);
  struct UserObject *uo4826 = (struct UserObject*)self;
  uo4826->data[42] = (Object)closure4826;
  Method *meth_meth_parser_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_4826 = addmethod2pos(self, "expressionrest(1)recursingWith(1)blocks(1)", &meth_parser_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_4826, 42);
  int argcv_meth_parser_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_4826[] = {1, 1, 1};
  meth_meth_parser_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_4826->type = alloc_MethodType(3, argcv_meth_parser_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_4826);
  meth_meth_parser_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_4826->definitionModule = modulename;
  meth_meth_parser_expressionrest_40_1_41_recursingWith_40_1_41_blocks_40_1_41_4826->definitionLine = 1533;
// compiled method node returning  (depth = 1)
// Begin line 1680
  setline(1680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dotrest(_)"
  block_savedest(self);
  Object closure5337 = createclosure(6, "dotrest(1)");
  setclosureframe(closure5337, stackframe);
  addtoclosure(closure5337, var_sym);
  addtoclosure(closure5337, var_util);
  addtoclosure(closure5337, var_values);
  addtoclosure(closure5337, var_ast);
  addtoclosure(closure5337, var_errormessages);
  addtoclosure(closure5337, var_lastToken);
  struct UserObject *uo5337 = (struct UserObject*)self;
  uo5337->data[43] = (Object)closure5337;
  Method *meth_meth_parser_dotrest_40_1_41_5337 = addmethod2pos(self, "dotrest(1)", &meth_parser_dotrest_40_1_41_5337, 43);
  int argcv_meth_parser_dotrest_40_1_41_5337[] = {1};
  meth_meth_parser_dotrest_40_1_41_5337->type = alloc_MethodType(1, argcv_meth_parser_dotrest_40_1_41_5337);
  meth_meth_parser_dotrest_40_1_41_5337->definitionModule = modulename;
  meth_meth_parser_dotrest_40_1_41_5337->definitionLine = 1680;
// compiled method node returning  (depth = 1)
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "callrest(_)"
  block_savedest(self);
  Object closure5443 = createclosure(6, "callrest(1)");
  setclosureframe(closure5443, stackframe);
  addtoclosure(closure5443, var_values);
  addtoclosure(closure5443, var_sym);
  addtoclosure(closure5443, var_util);
  addtoclosure(closure5443, var_ast);
  addtoclosure(closure5443, var_lastToken);
  addtoclosure(closure5443, var_minIndentLevel);
  struct UserObject *uo5443 = (struct UserObject*)self;
  uo5443->data[44] = (Object)closure5443;
  Method *meth_meth_parser_callrest_40_1_41_5443 = addmethod2pos(self, "callrest(1)", &meth_parser_callrest_40_1_41_5443, 44);
  int argcv_meth_parser_callrest_40_1_41_5443[] = {1};
  meth_meth_parser_callrest_40_1_41_5443->type = alloc_MethodType(1, argcv_meth_parser_callrest_40_1_41_5443);
  meth_meth_parser_callrest_40_1_41_5443->definitionModule = modulename;
  meth_meth_parser_callrest_40_1_41_5443->definitionLine = 1714;
// compiled method node returning  (depth = 1)
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parenthesizedArg(_)"
  block_savedest(self);
  Object closure5668 = createclosure(5, "parenthesizedArg(1)");
  setclosureframe(closure5668, stackframe);
  addtoclosure(closure5668, var_blocksOK);
  addtoclosure(closure5668, var_values);
  addtoclosure(closure5668, var_errormessages);
  addtoclosure(closure5668, var_sym);
  addtoclosure(closure5668, var_lastToken);
  struct UserObject *uo5668 = (struct UserObject*)self;
  uo5668->data[45] = (Object)closure5668;
  Method *meth_meth_parser_parenthesizedArg_40_1_41_5668 = addmethod2pos(self, "parenthesizedArg(1)", &meth_parser_parenthesizedArg_40_1_41_5668, 45);
  int argcv_meth_parser_parenthesizedArg_40_1_41_5668[] = {1};
  meth_meth_parser_parenthesizedArg_40_1_41_5668->type = alloc_MethodType(1, argcv_meth_parser_parenthesizedArg_40_1_41_5668);
  meth_meth_parser_parenthesizedArg_40_1_41_5668->definitionModule = modulename;
  meth_meth_parser_parenthesizedArg_40_1_41_5668->definitionLine = 1807;
// compiled method node returning  (depth = 1)
// Begin line 1917
  setline(1917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeArgs"
  block_savedest(self);
  Object closure6070 = createclosure(4, "typeArgs");
  setclosureframe(closure6070, stackframe);
  addtoclosure(closure6070, var_sym);
  addtoclosure(closure6070, var_values);
  addtoclosure(closure6070, var_errormessages);
  addtoclosure(closure6070, var_lastToken);
  struct UserObject *uo6070 = (struct UserObject*)self;
  uo6070->data[46] = (Object)closure6070;
  Method *meth_meth_parser_typeArgs6070 = addmethod2pos(self, "typeArgs", &meth_parser_typeArgs6070, 46);
  int argcv_meth_parser_typeArgs6070[] = {0};
  meth_meth_parser_typeArgs6070->type = alloc_MethodType(1, argcv_meth_parser_typeArgs6070);
  meth_meth_parser_typeArgs6070->definitionModule = modulename;
  meth_meth_parser_typeArgs6070->definitionLine = 1917;
// compiled method node returning  (depth = 1)
// Begin line 1942
  setline(1942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeArg"
  block_savedest(self);
  Object closure6149 = createclosure(3, "typeArg");
  setclosureframe(closure6149, stackframe);
  addtoclosure(closure6149, var_sym);
  addtoclosure(closure6149, var_values);
  addtoclosure(closure6149, var_ast);
  struct UserObject *uo6149 = (struct UserObject*)self;
  uo6149->data[47] = (Object)closure6149;
  Method *meth_meth_parser_typeArg6149 = addmethod2pos(self, "typeArg", &meth_parser_typeArg6149, 47);
  int argcv_meth_parser_typeArg6149[] = {0};
  meth_meth_parser_typeArg6149->type = alloc_MethodType(1, argcv_meth_parser_typeArg6149);
  meth_meth_parser_typeArg6149->definitionModule = modulename;
  meth_meth_parser_typeArg6149->definitionLine = 1942;
// compiled method node returning  (depth = 1)
// Begin line 1958
  setline(1958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "callmprest(_,_,_)"
  block_savedest(self);
  Object closure6181 = createclosure(6, "callmprest(3)");
  setclosureframe(closure6181, stackframe);
  addtoclosure(closure6181, var_lastToken);
  addtoclosure(closure6181, var_ast);
  addtoclosure(closure6181, var_values);
  addtoclosure(closure6181, var_errormessages);
  addtoclosure(closure6181, var_sym);
  addtoclosure(closure6181, var_blocksOK);
  struct UserObject *uo6181 = (struct UserObject*)self;
  uo6181->data[48] = (Object)closure6181;
  Method *meth_meth_parser_callmprest_40_3_41_6181 = addmethod2pos(self, "callmprest(3)", &meth_parser_callmprest_40_3_41_6181, 48);
  int argcv_meth_parser_callmprest_40_3_41_6181[] = {3};
  meth_meth_parser_callmprest_40_3_41_6181->type = alloc_MethodType(1, argcv_meth_parser_callmprest_40_3_41_6181);
  meth_meth_parser_callmprest_40_3_41_6181->definitionModule = modulename;
  meth_meth_parser_callmprest_40_3_41_6181->definitionLine = 1958;
// compiled method node returning  (depth = 1)
// Begin line 2080
  setline(2080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "defdec"
  block_savedest(self);
  Object closure6546 = createclosure(7, "defdec");
  setclosureframe(closure6546, stackframe);
  addtoclosure(closure6546, var_sym);
  addtoclosure(closure6546, var_errormessages);
  addtoclosure(closure6546, var_lastToken);
  addtoclosure(closure6546, var_values);
  addtoclosure(closure6546, var_blocksOK);
  addtoclosure(closure6546, var_util);
  addtoclosure(closure6546, var_ast);
  struct UserObject *uo6546 = (struct UserObject*)self;
  uo6546->data[49] = (Object)closure6546;
  Method *meth_meth_parser_defdec6546 = addmethod2pos(self, "defdec", &meth_parser_defdec6546, 49);
  int argcv_meth_parser_defdec6546[] = {0};
  meth_meth_parser_defdec6546->type = alloc_MethodType(1, argcv_meth_parser_defdec6546);
  meth_meth_parser_defdec6546->definitionModule = modulename;
  meth_meth_parser_defdec6546->definitionLine = 2080;
// compiled method node returning  (depth = 1)
// Begin line 2157
  setline(2157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "vardec"
  block_savedest(self);
  Object closure6801 = createclosure(7, "vardec");
  setclosureframe(closure6801, stackframe);
  addtoclosure(closure6801, var_sym);
  addtoclosure(closure6801, var_errormessages);
  addtoclosure(closure6801, var_lastToken);
  addtoclosure(closure6801, var_values);
  addtoclosure(closure6801, var_blocksOK);
  addtoclosure(closure6801, var_util);
  addtoclosure(closure6801, var_ast);
  struct UserObject *uo6801 = (struct UserObject*)self;
  uo6801->data[50] = (Object)closure6801;
  Method *meth_meth_parser_vardec6801 = addmethod2pos(self, "vardec", &meth_parser_vardec6801, 50);
  int argcv_meth_parser_vardec6801[] = {0};
  meth_meth_parser_vardec6801->type = alloc_MethodType(1, argcv_meth_parser_vardec6801);
  meth_meth_parser_vardec6801->definitionModule = modulename;
  meth_meth_parser_vardec6801->definitionLine = 2157;
// compiled method node returning  (depth = 1)
// Begin line 2226
  setline(2226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doarray"
  block_savedest(self);
  Object closure7020 = createclosure(6, "doarray");
  setclosureframe(closure7020, stackframe);
  addtoclosure(closure7020, var_blocksOK);
  addtoclosure(closure7020, var_values);
  addtoclosure(closure7020, var_errormessages);
  addtoclosure(closure7020, var_sym);
  addtoclosure(closure7020, var_lastToken);
  addtoclosure(closure7020, var_ast);
  struct UserObject *uo7020 = (struct UserObject*)self;
  uo7020->data[51] = (Object)closure7020;
  Method *meth_meth_parser_doarray7020 = addmethod2pos(self, "doarray", &meth_parser_doarray7020, 51);
  int argcv_meth_parser_doarray7020[] = {0};
  meth_meth_parser_doarray7020->type = alloc_MethodType(1, argcv_meth_parser_doarray7020);
  meth_meth_parser_doarray7020->definitionModule = modulename;
  meth_meth_parser_doarray7020->definitionLine = 2226;
// compiled method node returning  (depth = 1)
// Begin line 2269
  setline(2269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dodialect"
  block_savedest(self);
  Object closure7150 = createclosure(5, "dodialect");
  setclosureframe(closure7150, stackframe);
  addtoclosure(closure7150, var_sym);
  addtoclosure(closure7150, var_errormessages);
  addtoclosure(closure7150, var_lastToken);
  addtoclosure(closure7150, var_ast);
  addtoclosure(closure7150, var_values);
  struct UserObject *uo7150 = (struct UserObject*)self;
  uo7150->data[52] = (Object)closure7150;
  Method *meth_meth_parser_dodialect7150 = addmethod2pos(self, "dodialect", &meth_parser_dodialect7150, 52);
  int argcv_meth_parser_dodialect7150[] = {0};
  meth_meth_parser_dodialect7150->type = alloc_MethodType(1, argcv_meth_parser_dodialect7150);
  meth_meth_parser_dodialect7150->definitionModule = modulename;
  meth_meth_parser_dodialect7150->definitionLine = 2269;
// compiled method node returning  (depth = 1)
// Begin line 2290
  setline(2290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "inheritsOrUses"
  block_savedest(self);
  Object closure7230 = createclosure(8, "inheritsOrUses");
  setclosureframe(closure7230, stackframe);
  addtoclosure(closure7230, var_done);
  addtoclosure(closure7230, var_sym);
  addtoclosure(closure7230, var_noBlocks);
  addtoclosure(closure7230, var_errormessages);
  addtoclosure(closure7230, var_lastToken);
  addtoclosure(closure7230, var_util);
  addtoclosure(closure7230, var_values);
  addtoclosure(closure7230, var_ast);
  struct UserObject *uo7230 = (struct UserObject*)self;
  uo7230->data[53] = (Object)closure7230;
  Method *meth_meth_parser_inheritsOrUses7230 = addmethod2pos(self, "inheritsOrUses", &meth_parser_inheritsOrUses7230, 53);
  int argcv_meth_parser_inheritsOrUses7230[] = {0};
  meth_meth_parser_inheritsOrUses7230->type = alloc_MethodType(1, argcv_meth_parser_inheritsOrUses7230);
  meth_meth_parser_inheritsOrUses7230->definitionModule = modulename;
  meth_meth_parser_inheritsOrUses7230->definitionLine = 2290;
// compiled method node returning  (depth = 1)
// Begin line 2331
  setline(2331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "inheritsModifier(_)onLineOf(_)"
  block_savedest(self);
  Object closure7390 = createclosure(1, "inheritsModifier(1)onLineOf(1)");
  setclosureframe(closure7390, stackframe);
  addtoclosure(closure7390, var_sym);
  struct UserObject *uo7390 = (struct UserObject*)self;
  uo7390->data[54] = (Object)closure7390;
  Method *meth_meth_parser_inheritsModifier_40_1_41_onLineOf_40_1_41_7390 = addmethod2pos(self, "inheritsModifier(1)onLineOf(1)", &meth_parser_inheritsModifier_40_1_41_onLineOf_40_1_41_7390, 54);
  int argcv_meth_parser_inheritsModifier_40_1_41_onLineOf_40_1_41_7390[] = {1, 1};
  meth_meth_parser_inheritsModifier_40_1_41_onLineOf_40_1_41_7390->type = alloc_MethodType(2, argcv_meth_parser_inheritsModifier_40_1_41_onLineOf_40_1_41_7390);
  meth_meth_parser_inheritsModifier_40_1_41_onLineOf_40_1_41_7390->definitionModule = modulename;
  meth_meth_parser_inheritsModifier_40_1_41_onLineOf_40_1_41_7390->definitionLine = 2331;
// compiled method node returning  (depth = 1)
// Begin line 2345
  setline(2345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parseAlias(_)"
  block_savedest(self);
  Object closure7417 = createclosure(3, "parseAlias(1)");
  setclosureframe(closure7417, stackframe);
  addtoclosure(closure7417, var_sym);
  addtoclosure(closure7417, var_errormessages);
  addtoclosure(closure7417, var_lastToken);
  struct UserObject *uo7417 = (struct UserObject*)self;
  uo7417->data[55] = (Object)closure7417;
  Method *meth_meth_parser_parseAlias_40_1_41_7417 = addmethod2pos(self, "parseAlias(1)", &meth_parser_parseAlias_40_1_41_7417, 55);
  int argcv_meth_parser_parseAlias_40_1_41_7417[] = {1};
  meth_meth_parser_parseAlias_40_1_41_7417->type = alloc_MethodType(1, argcv_meth_parser_parseAlias_40_1_41_7417);
  meth_meth_parser_parseAlias_40_1_41_7417->definitionModule = modulename;
  meth_meth_parser_parseAlias_40_1_41_7417->definitionLine = 2345;
// compiled method node returning  (depth = 1)
// Begin line 2363
  setline(2363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parseExclude(_)"
  struct UserObject *uo7483 = (struct UserObject*)self;
  uo7483->data[56] = emptyclosure;
  Method *meth_meth_parser_parseExclude_40_1_41_7483 = addmethod2pos(self, "parseExclude(1)", &meth_parser_parseExclude_40_1_41_7483, 56);
  int argcv_meth_parser_parseExclude_40_1_41_7483[] = {1};
  meth_meth_parser_parseExclude_40_1_41_7483->type = alloc_MethodType(1, argcv_meth_parser_parseExclude_40_1_41_7483);
  meth_meth_parser_parseExclude_40_1_41_7483->definitionModule = modulename;
  meth_meth_parser_parseExclude_40_1_41_7483->definitionLine = 2363;
// compiled method node returning  (depth = 1)
// Begin line 2370
  setline(2370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doobject"
  block_savedest(self);
  Object closure7496 = createclosure(1, "doobject");
  setclosureframe(closure7496, stackframe);
  addtoclosure(closure7496, var_lastToken);
  struct UserObject *uo7496 = (struct UserObject*)self;
  uo7496->data[57] = (Object)closure7496;
  Method *meth_meth_parser_doobject7496 = addmethod2pos(self, "doobject", &meth_parser_doobject7496, 57);
  int argcv_meth_parser_doobject7496[] = {0};
  meth_meth_parser_doobject7496->type = alloc_MethodType(1, argcv_meth_parser_doobject7496);
  meth_meth_parser_doobject7496->definitionModule = modulename;
  meth_meth_parser_doobject7496->definitionLine = 2370;
// compiled method node returning  (depth = 1)
// Begin line 2381
  setline(2381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parseObjectConstructorBody(_)startingWith(_)after(_)"
  block_savedest(self);
  Object closure7507 = createclosure(8, "parseObjectConstructorBody(1)startingWith(1)after(1)");
  setclosureframe(closure7507, stackframe);
  addtoclosure(closure7507, var_minIndentLevel);
  addtoclosure(closure7507, var_sym);
  addtoclosure(closure7507, var_errormessages);
  addtoclosure(closure7507, var_lastToken);
  addtoclosure(closure7507, var_statementToken);
  addtoclosure(closure7507, var_values);
  addtoclosure(closure7507, var_util);
  addtoclosure(closure7507, var_ast);
  struct UserObject *uo7507 = (struct UserObject*)self;
  uo7507->data[58] = (Object)closure7507;
  Method *meth_meth_parser_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_7507 = addmethod2pos(self, "parseObjectConstructorBody(1)startingWith(1)after(1)", &meth_parser_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_7507, 58);
  int argcv_meth_parser_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_7507[] = {1, 1, 1};
  meth_meth_parser_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_7507->type = alloc_MethodType(3, argcv_meth_parser_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_7507);
  meth_meth_parser_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_7507->definitionModule = modulename;
  meth_meth_parser_parseObjectConstructorBody_40_1_41_startingWith_40_1_41_after_40_1_41_7507->definitionLine = 2381;
// compiled method node returning  (depth = 1)
// Begin line 2451
  setline(2451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doclass"
  block_savedest(self);
  Object closure7796 = createclosure(7, "doclass");
  setclosureframe(closure7796, stackframe);
  addtoclosure(closure7796, var_sym);
  addtoclosure(closure7796, var_minIndentLevel);
  addtoclosure(closure7796, var_errormessages);
  addtoclosure(closure7796, var_lastToken);
  addtoclosure(closure7796, var_tokens);
  addtoclosure(closure7796, var_values);
  addtoclosure(closure7796, var_ast);
  struct UserObject *uo7796 = (struct UserObject*)self;
  uo7796->data[59] = (Object)closure7796;
  Method *meth_meth_parser_doclass7796 = addmethod2pos(self, "doclass", &meth_parser_doclass7796, 59);
  int argcv_meth_parser_doclass7796[] = {0};
  meth_meth_parser_doclass7796->type = alloc_MethodType(1, argcv_meth_parser_doclass7796);
  meth_meth_parser_doclass7796->definitionModule = modulename;
  meth_meth_parser_doclass7796->definitionLine = 2451;
// compiled method node returning  (depth = 1)
// Begin line 2539
  setline(2539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dofactoryMethod"
  block_savedest(self);
  Object closure8009 = createclosure(7, "dofactoryMethod");
  setclosureframe(closure8009, stackframe);
  addtoclosure(closure8009, var_tokens);
  addtoclosure(closure8009, var_sym);
  addtoclosure(closure8009, var_minIndentLevel);
  addtoclosure(closure8009, var_errormessages);
  addtoclosure(closure8009, var_lastToken);
  addtoclosure(closure8009, var_values);
  addtoclosure(closure8009, var_util);
  struct UserObject *uo8009 = (struct UserObject*)self;
  uo8009->data[60] = (Object)closure8009;
  Method *meth_meth_parser_dofactoryMethod8009 = addmethod2pos(self, "dofactoryMethod", &meth_parser_dofactoryMethod8009, 60);
  int argcv_meth_parser_dofactoryMethod8009[] = {0};
  meth_meth_parser_dofactoryMethod8009->type = alloc_MethodType(1, argcv_meth_parser_dofactoryMethod8009);
  meth_meth_parser_dofactoryMethod8009->definitionModule = modulename;
  meth_meth_parser_dofactoryMethod8009->definitionLine = 2539;
// compiled method node returning  (depth = 1)
// Begin line 2582
  setline(2582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "methoddec"
  block_savedest(self);
  Object closure8138 = createclosure(7, "methoddec");
  setclosureframe(closure8138, stackframe);
  addtoclosure(closure8138, var_sym);
  addtoclosure(closure8138, var_statementToken);
  addtoclosure(closure8138, var_minIndentLevel);
  addtoclosure(closure8138, var_values);
  addtoclosure(closure8138, var_errormessages);
  addtoclosure(closure8138, var_lastToken);
  addtoclosure(closure8138, var_util);
  struct UserObject *uo8138 = (struct UserObject*)self;
  uo8138->data[61] = (Object)closure8138;
  Method *meth_meth_parser_methoddec8138 = addmethod2pos(self, "methoddec", &meth_parser_methoddec8138, 61);
  int argcv_meth_parser_methoddec8138[] = {0};
  meth_meth_parser_methoddec8138->type = alloc_MethodType(1, argcv_meth_parser_methoddec8138);
  meth_meth_parser_methoddec8138->definitionModule = modulename;
  meth_meth_parser_methoddec8138->definitionLine = 2582;
// compiled method node returning  (depth = 1)
// Begin line 2658
  setline(2658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "methodDecRest(_,_)"
  block_savedest(self);
  Object closure8341 = createclosure(5, "methodDecRest(2)");
  setclosureframe(closure8341, stackframe);
  addtoclosure(closure8341, var_values);
  addtoclosure(closure8341, var_ast);
  addtoclosure(closure8341, var_errormessages);
  addtoclosure(closure8341, var_lastToken);
  addtoclosure(closure8341, var_sym);
  struct UserObject *uo8341 = (struct UserObject*)self;
  uo8341->data[62] = (Object)closure8341;
  Method *meth_meth_parser_methodDecRest_40_2_41_8341 = addmethod2pos(self, "methodDecRest(2)", &meth_parser_methodDecRest_40_2_41_8341, 62);
  int argcv_meth_parser_methodDecRest_40_2_41_8341[] = {2};
  meth_meth_parser_methodDecRest_40_2_41_8341->type = alloc_MethodType(1, argcv_meth_parser_methodDecRest_40_2_41_8341);
  meth_meth_parser_methodDecRest_40_2_41_8341->definitionModule = modulename;
  meth_meth_parser_methodDecRest_40_2_41_8341->definitionLine = 2658;
// compiled method node returning  (depth = 1)
// Begin line 2706
  setline(2706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "optionalTypeAnnotation"
  block_savedest(self);
  Object closure8503 = createclosure(4, "optionalTypeAnnotation");
  setclosureframe(closure8503, stackframe);
  addtoclosure(closure8503, var_values);
  addtoclosure(closure8503, var_errormessages);
  addtoclosure(closure8503, var_lastToken);
  addtoclosure(closure8503, var_sym);
  struct UserObject *uo8503 = (struct UserObject*)self;
  uo8503->data[63] = (Object)closure8503;
  Method *meth_meth_parser_optionalTypeAnnotation8503 = addmethod2pos(self, "optionalTypeAnnotation", &meth_parser_optionalTypeAnnotation8503, 63);
  int argcv_meth_parser_optionalTypeAnnotation8503[] = {0};
  meth_meth_parser_optionalTypeAnnotation8503->type = alloc_MethodType(1, argcv_meth_parser_optionalTypeAnnotation8503);
  meth_meth_parser_optionalTypeAnnotation8503->definitionModule = modulename;
  meth_meth_parser_optionalTypeAnnotation8503->definitionLine = 2706;
// compiled method node returning  (depth = 1)
// Begin line 2730
  setline(2730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "methodsignature(_)"
  block_savedest(self);
  Object closure8551 = createclosure(5, "methodsignature(1)");
  setclosureframe(closure8551, stackframe);
  addtoclosure(closure8551, var_sym);
  addtoclosure(closure8551, var_errormessages);
  addtoclosure(closure8551, var_lastToken);
  addtoclosure(closure8551, var_ast);
  addtoclosure(closure8551, var_values);
  struct UserObject *uo8551 = (struct UserObject*)self;
  uo8551->data[64] = (Object)closure8551;
  Method *meth_meth_parser_methodsignature_40_1_41_8551 = addmethod2pos(self, "methodsignature(1)", &meth_parser_methodsignature_40_1_41_8551, 64);
  int argcv_meth_parser_methodsignature_40_1_41_8551[] = {1};
  meth_meth_parser_methodsignature_40_1_41_8551->type = alloc_MethodType(1, argcv_meth_parser_methodsignature_40_1_41_8551);
  meth_meth_parser_methodsignature_40_1_41_8551->definitionModule = modulename;
  meth_meth_parser_methodsignature_40_1_41_8551->definitionLine = 2730;
// compiled method node returning  (depth = 1)
// Begin line 2817
  setline(2817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeparameters"
  block_savedest(self);
  Object closure8899 = createclosure(5, "typeparameters");
  setclosureframe(closure8899, stackframe);
  addtoclosure(closure8899, var_values);
  addtoclosure(closure8899, var_ast);
  addtoclosure(closure8899, var_sym);
  addtoclosure(closure8899, var_errormessages);
  addtoclosure(closure8899, var_lastToken);
  struct UserObject *uo8899 = (struct UserObject*)self;
  uo8899->data[65] = (Object)closure8899;
  Method *meth_meth_parser_typeparameters8899 = addmethod2pos(self, "typeparameters", &meth_parser_typeparameters8899, 65);
  int argcv_meth_parser_typeparameters8899[] = {0};
  meth_meth_parser_typeparameters8899->type = alloc_MethodType(1, argcv_meth_parser_typeparameters8899);
  meth_meth_parser_typeparameters8899->definitionModule = modulename;
  meth_meth_parser_typeparameters8899->definitionLine = 2817;
// compiled method node returning  (depth = 1)
// Begin line 2841
  setline(2841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doimport"
  block_savedest(self);
  Object closure8969 = createclosure(6, "doimport");
  setclosureframe(closure8969, stackframe);
  addtoclosure(closure8969, var_sym);
  addtoclosure(closure8969, var_errormessages);
  addtoclosure(closure8969, var_lastToken);
  addtoclosure(closure8969, var_values);
  addtoclosure(closure8969, var_util);
  addtoclosure(closure8969, var_ast);
  struct UserObject *uo8969 = (struct UserObject*)self;
  uo8969->data[66] = (Object)closure8969;
  Method *meth_meth_parser_doimport8969 = addmethod2pos(self, "doimport", &meth_parser_doimport8969, 66);
  int argcv_meth_parser_doimport8969[] = {0};
  meth_meth_parser_doimport8969->type = alloc_MethodType(1, argcv_meth_parser_doimport8969);
  meth_meth_parser_doimport8969->definitionModule = modulename;
  meth_meth_parser_doimport8969->definitionLine = 2841;
// compiled method node returning  (depth = 1)
// Begin line 2899
  setline(2899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doreturn"
  block_savedest(self);
  Object closure9219 = createclosure(7, "doreturn");
  setclosureframe(closure9219, stackframe);
  addtoclosure(closure9219, var_sym);
  addtoclosure(closure9219, var_blocksOK);
  addtoclosure(closure9219, var_errormessages);
  addtoclosure(closure9219, var_lastToken);
  addtoclosure(closure9219, var_values);
  addtoclosure(closure9219, var_ast);
  addtoclosure(closure9219, var_util);
  struct UserObject *uo9219 = (struct UserObject*)self;
  uo9219->data[67] = (Object)closure9219;
  Method *meth_meth_parser_doreturn9219 = addmethod2pos(self, "doreturn", &meth_parser_doreturn9219, 67);
  int argcv_meth_parser_doreturn9219[] = {0};
  meth_meth_parser_doreturn9219->type = alloc_MethodType(1, argcv_meth_parser_doreturn9219);
  meth_meth_parser_doreturn9219->definitionModule = modulename;
  meth_meth_parser_doreturn9219->definitionLine = 2899;
// compiled method node returning  (depth = 1)
// Begin line 2935
  setline(2935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "domethodtype"
  block_savedest(self);
  Object closure9339 = createclosure(6, "domethodtype");
  setclosureframe(closure9339, stackframe);
  addtoclosure(closure9339, var_sym);
  addtoclosure(closure9339, var_ast);
  addtoclosure(closure9339, var_values);
  addtoclosure(closure9339, var_lastToken);
  addtoclosure(closure9339, var_errormessages);
  addtoclosure(closure9339, var_util);
  struct UserObject *uo9339 = (struct UserObject*)self;
  uo9339->data[68] = (Object)closure9339;
  Method *meth_meth_parser_domethodtype9339 = addmethod2pos(self, "domethodtype", &meth_parser_domethodtype9339, 68);
  int argcv_meth_parser_domethodtype9339[] = {0};
  meth_meth_parser_domethodtype9339->type = alloc_MethodType(1, argcv_meth_parser_domethodtype9339);
  meth_meth_parser_domethodtype9339->definitionModule = modulename;
  meth_meth_parser_domethodtype9339->definitionLine = 2935;
// compiled method node returning  (depth = 1)
// Begin line 2964
  setline(2964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dotypeLiteral"
  block_savedest(self);
  Object closure9438 = createclosure(7, "dotypeLiteral");
  setclosureframe(closure9438, stackframe);
  addtoclosure(closure9438, var_sym);
  addtoclosure(closure9438, var_errormessages);
  addtoclosure(closure9438, var_done);
  addtoclosure(closure9438, var_auto_count);
  addtoclosure(closure9438, var_values);
  addtoclosure(closure9438, var_util);
  addtoclosure(closure9438, var_ast);
  struct UserObject *uo9438 = (struct UserObject*)self;
  uo9438->data[69] = (Object)closure9438;
  Method *meth_meth_parser_dotypeLiteral9438 = addmethod2pos(self, "dotypeLiteral", &meth_parser_dotypeLiteral9438, 69);
  int argcv_meth_parser_dotypeLiteral9438[] = {0};
  meth_meth_parser_dotypeLiteral9438->type = alloc_MethodType(1, argcv_meth_parser_dotypeLiteral9438);
  meth_meth_parser_dotypeLiteral9438->definitionModule = modulename;
  meth_meth_parser_dotypeLiteral9438->definitionLine = 2964;
// compiled method node returning  (depth = 1)
// Begin line 2999
  setline(2999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typedec"
  block_savedest(self);
  Object closure9521 = createclosure(7, "typedec");
  setclosureframe(closure9521, stackframe);
  addtoclosure(closure9521, var_sym);
  addtoclosure(closure9521, var_errormessages);
  addtoclosure(closure9521, var_lastToken);
  addtoclosure(closure9521, var_util);
  addtoclosure(closure9521, var_values);
  addtoclosure(closure9521, var_ast);
  addtoclosure(closure9521, var_noBlocks);
  struct UserObject *uo9521 = (struct UserObject*)self;
  uo9521->data[70] = (Object)closure9521;
  Method *meth_meth_parser_typedec9521 = addmethod2pos(self, "typedec", &meth_parser_typedec9521, 70);
  int argcv_meth_parser_typedec9521[] = {0};
  meth_meth_parser_typedec9521->type = alloc_MethodType(1, argcv_meth_parser_typedec9521);
  meth_meth_parser_typedec9521->definitionModule = modulename;
  meth_meth_parser_typedec9521->definitionLine = 2999;
// compiled method node returning  (depth = 1)
// Begin line 3045
  setline(3045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkIndent"
  block_savedest(self);
  Object closure9684 = createclosure(6, "checkIndent");
  setclosureframe(closure9684, stackframe);
  addtoclosure(closure9684, var_indentFreePass);
  addtoclosure(closure9684, var_sym);
  addtoclosure(closure9684, var_minIndentLevel);
  addtoclosure(closure9684, var_errormessages);
  addtoclosure(closure9684, var_lastToken);
  addtoclosure(closure9684, var_lastIndent);
  struct UserObject *uo9684 = (struct UserObject*)self;
  uo9684->data[71] = (Object)closure9684;
  Method *meth_meth_parser_checkIndent9684 = addmethod2pos(self, "checkIndent", &meth_parser_checkIndent9684, 71);
  int argcv_meth_parser_checkIndent9684[] = {0};
  meth_meth_parser_checkIndent9684->type = alloc_MethodType(1, argcv_meth_parser_checkIndent9684);
  meth_meth_parser_checkIndent9684->definitionModule = modulename;
  meth_meth_parser_checkIndent9684->definitionLine = 3045;
// compiled method node returning  (depth = 1)
// Begin line 3092
  setline(3092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "statement"
  block_savedest(self);
  Object closure9907 = createclosure(10, "statement");
  setclosureframe(closure9907, stackframe);
  addtoclosure(closure9907, var_sym);
  addtoclosure(closure9907, var_statementIndent);
  addtoclosure(closure9907, var_statementToken);
  addtoclosure(closure9907, var_blocksOK);
  addtoclosure(closure9907, var_values);
  addtoclosure(closure9907, var_errormessages);
  addtoclosure(closure9907, var_lastToken);
  addtoclosure(closure9907, var_util);
  addtoclosure(closure9907, var_ast);
  addtoclosure(closure9907, var_indentFreePass);
  struct UserObject *uo9907 = (struct UserObject*)self;
  uo9907->data[72] = (Object)closure9907;
  Method *meth_meth_parser_statement9907 = addmethod2pos(self, "statement", &meth_parser_statement9907, 72);
  int argcv_meth_parser_statement9907[] = {0};
  meth_meth_parser_statement9907->type = alloc_MethodType(1, argcv_meth_parser_statement9907);
  meth_meth_parser_statement9907->definitionModule = modulename;
  meth_meth_parser_statement9907->definitionLine = 3092;
// compiled method node returning  (depth = 1)
// Begin line 3175
  setline(3175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushComments"
  block_savedest(self);
  Object closure10176 = createclosure(8, "pushComments");
  setclosureframe(closure10176, stackframe);
  addtoclosure(closure10176, var_done);
  addtoclosure(closure10176, var_sym);
  addtoclosure(closure10176, var_util);
  addtoclosure(closure10176, var_ast);
  addtoclosure(closure10176, var_lastToken);
  addtoclosure(closure10176, var_comments);
  addtoclosure(closure10176, var_previousCommentToken);
  addtoclosure(closure10176, var_tokens);
  struct UserObject *uo10176 = (struct UserObject*)self;
  uo10176->data[73] = (Object)closure10176;
  Method *meth_meth_parser_pushComments10176 = addmethod2pos(self, "pushComments", &meth_parser_pushComments10176, 73);
  int argcv_meth_parser_pushComments10176[] = {0};
  meth_meth_parser_pushComments10176->type = alloc_MethodType(1, argcv_meth_parser_pushComments10176);
  meth_meth_parser_pushComments10176->definitionModule = modulename;
  meth_meth_parser_pushComments10176->definitionLine = 3175;
// compiled method node returning  (depth = 1)
// Begin line 3209
  setline(3209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "reconcileComments"
  block_savedest(self);
  Object closure10309 = createclosure(4, "reconcileComments");
  setclosureframe(closure10309, stackframe);
  addtoclosure(closure10309, var_values);
  addtoclosure(closure10309, var_moduleObject);
  addtoclosure(closure10309, var_done);
  addtoclosure(closure10309, var_comments);
  struct UserObject *uo10309 = (struct UserObject*)self;
  uo10309->data[74] = (Object)closure10309;
  Method *meth_meth_parser_reconcileComments10309 = addmethod2pos(self, "reconcileComments", &meth_parser_reconcileComments10309, 74);
  int argcv_meth_parser_reconcileComments10309[] = {0};
  meth_meth_parser_reconcileComments10309->type = alloc_MethodType(1, argcv_meth_parser_reconcileComments10309);
  meth_meth_parser_reconcileComments10309->definitionModule = modulename;
  meth_meth_parser_reconcileComments10309->definitionLine = 3209;
// compiled method node returning  (depth = 1)
// Begin line 3255
  setline(3255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkBadOperators"
  block_savedest(self);
  Object closure10436 = createclosure(2, "checkBadOperators");
  setclosureframe(closure10436, stackframe);
  addtoclosure(closure10436, var_sym);
  addtoclosure(closure10436, var_errormessages);
  struct UserObject *uo10436 = (struct UserObject*)self;
  uo10436->data[75] = (Object)closure10436;
  Method *meth_meth_parser_checkBadOperators10436 = addmethod2pos(self, "checkBadOperators", &meth_parser_checkBadOperators10436, 75);
  int argcv_meth_parser_checkBadOperators10436[] = {0};
  meth_meth_parser_checkBadOperators10436->type = alloc_MethodType(1, argcv_meth_parser_checkBadOperators10436);
  meth_meth_parser_checkBadOperators10436->definitionModule = modulename;
  meth_meth_parser_checkBadOperators10436->definitionLine = 3255;
// compiled method node returning  (depth = 1)
// Begin line 3272
  setline(3272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkBadTypeLiteral"
  block_savedest(self);
  Object closure10483 = createclosure(2, "checkBadTypeLiteral");
  setclosureframe(closure10483, stackframe);
  addtoclosure(closure10483, var_sym);
  addtoclosure(closure10483, var_errormessages);
  struct UserObject *uo10483 = (struct UserObject*)self;
  uo10483->data[76] = (Object)closure10483;
  Method *meth_meth_parser_checkBadTypeLiteral10483 = addmethod2pos(self, "checkBadTypeLiteral", &meth_parser_checkBadTypeLiteral10483, 76);
  int argcv_meth_parser_checkBadTypeLiteral10483[] = {0};
  meth_meth_parser_checkBadTypeLiteral10483->type = alloc_MethodType(1, argcv_meth_parser_checkBadTypeLiteral10483);
  meth_meth_parser_checkBadTypeLiteral10483->definitionModule = modulename;
  meth_meth_parser_checkBadTypeLiteral10483->definitionLine = 3272;
// compiled method node returning  (depth = 1)
// Begin line 3282
  setline(3282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkUnexpectedTokenAfterStatement"
  block_savedest(self);
  Object closure10507 = createclosure(5, "checkUnexpectedTokenAfterStatement");
  setclosureframe(closure10507, stackframe);
  addtoclosure(closure10507, var_lastToken);
  addtoclosure(closure10507, var_sym);
  addtoclosure(closure10507, var_errormessages);
  addtoclosure(closure10507, var_values);
  addtoclosure(closure10507, var_util);
  struct UserObject *uo10507 = (struct UserObject*)self;
  uo10507->data[77] = (Object)closure10507;
  Method *meth_meth_parser_checkUnexpectedTokenAfterStatement10507 = addmethod2pos(self, "checkUnexpectedTokenAfterStatement", &meth_parser_checkUnexpectedTokenAfterStatement10507, 77);
  int argcv_meth_parser_checkUnexpectedTokenAfterStatement10507[] = {0};
  meth_meth_parser_checkUnexpectedTokenAfterStatement10507->type = alloc_MethodType(1, argcv_meth_parser_checkUnexpectedTokenAfterStatement10507);
  meth_meth_parser_checkUnexpectedTokenAfterStatement10507->definitionModule = modulename;
  meth_meth_parser_checkUnexpectedTokenAfterStatement10507->definitionLine = 3282;
// compiled method node returning  (depth = 1)
// Begin line 3346
  setline(3346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parse(_)"
  block_savedest(self);
  Object closure10834 = createclosure(7, "parse(1)");
  setclosureframe(closure10834, stackframe);
  addtoclosure(closure10834, var_util);
  addtoclosure(closure10834, var_values);
  addtoclosure(closure10834, var_ast);
  addtoclosure(closure10834, var_moduleObject);
  addtoclosure(closure10834, var_tokens);
  addtoclosure(closure10834, var_sym);
  addtoclosure(closure10834, var_errormessages);
  struct UserObject *uo10834 = (struct UserObject*)self;
  uo10834->data[78] = (Object)closure10834;
  Method *meth_meth_parser_parse_40_1_41_10834 = addmethod2pos(self, "parse(1)", &meth_parser_parse_40_1_41_10834, 78);
  int argcv_meth_parser_parse_40_1_41_10834[] = {1};
  meth_meth_parser_parse_40_1_41_10834->type = alloc_MethodType(1, argcv_meth_parser_parse_40_1_41_10834);
  meth_meth_parser_parse_40_1_41_10834->definitionModule = modulename;
  meth_meth_parser_parse_40_1_41_10834->definitionLine = 3346;
// compiled method node returning  (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of io as io
  if (module_io == NULL)
    module_io = module_io_init();
  *var_io = module_io;
// compiled import node returning done (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of ast as ast
  if (module_ast == NULL)
    module_ast = LOAD_MODULE(ast);
  *var_ast = module_ast;
// compiled import node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = LOAD_MODULE(util);
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of errormessages as errormessages
  if (module_errormessages == NULL)
    module_errormessages = LOAD_MODULE(errormessages);
  *var_errormessages = module_errormessages;
// compiled import node returning done (depth = 1)
// Begin line 1
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num10995 = alloc_Float64(0);
// compiled num node returning num10995 (depth = 2)
  *var_blankLocation = num10995;
  if (num10995 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blankLocation"
  block_savedest(self);
  Object closure10996 = createclosure(1, "blankLocation");
  setclosureframe(closure10996, stackframe);
  addtoclosure(closure10996, var_blankLocation);
  struct UserObject *uo10996 = (struct UserObject*)self;
  uo10996->data[79] = (Object)closure10996;
  Method *meth_meth_parser_blankLocation10996 = addmethod2pos(self, "blankLocation", &meth_parser_blankLocation10996, 79);
  int argcv_meth_parser_blankLocation10996[] = {0};
  meth_meth_parser_blankLocation10996->type = alloc_MethodType(1, argcv_meth_parser_blankLocation10996);
  meth_meth_parser_blankLocation10996->definitionModule = modulename;
  meth_meth_parser_blankLocation10996->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blankLocation:=(_)"
  block_savedest(self);
  Object closure10997 = createclosure(1, "blankLocation:=(1)");
  setclosureframe(closure10997, stackframe);
  addtoclosure(closure10997, var_blankLocation);
  struct UserObject *uo10997 = (struct UserObject*)self;
  uo10997->data[80] = (Object)closure10997;
  Method *meth_meth_parser_blankLocation_58__61__40_1_41_10997 = addmethod2pos(self, "blankLocation:=(1)", &meth_parser_blankLocation_58__61__40_1_41_10997, 80);
  int argcv_meth_parser_blankLocation_58__61__40_1_41_10997[] = {1};
  meth_meth_parser_blankLocation_58__61__40_1_41_10997->type = alloc_MethodType(1, argcv_meth_parser_blankLocation_58__61__40_1_41_10997);
  meth_meth_parser_blankLocation_58__61__40_1_41_10997->definitionModule = modulename;
  meth_meth_parser_blankLocation_58__61__40_1_41_10997->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num10999 = alloc_Float64(0);
// compiled num node returning num10999 (depth = 2)
  *var_lastLine = num10999;
  if (num10999 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastLine"
  block_savedest(self);
  Object closure11000 = createclosure(1, "lastLine");
  setclosureframe(closure11000, stackframe);
  addtoclosure(closure11000, var_lastLine);
  struct UserObject *uo11000 = (struct UserObject*)self;
  uo11000->data[81] = (Object)closure11000;
  Method *meth_meth_parser_lastLine11000 = addmethod2pos(self, "lastLine", &meth_parser_lastLine11000, 81);
  int argcv_meth_parser_lastLine11000[] = {0};
  meth_meth_parser_lastLine11000->type = alloc_MethodType(1, argcv_meth_parser_lastLine11000);
  meth_meth_parser_lastLine11000->definitionModule = modulename;
  meth_meth_parser_lastLine11000->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastLine:=(_)"
  block_savedest(self);
  Object closure11001 = createclosure(1, "lastLine:=(1)");
  setclosureframe(closure11001, stackframe);
  addtoclosure(closure11001, var_lastLine);
  struct UserObject *uo11001 = (struct UserObject*)self;
  uo11001->data[82] = (Object)closure11001;
  Method *meth_meth_parser_lastLine_58__61__40_1_41_11001 = addmethod2pos(self, "lastLine:=(1)", &meth_parser_lastLine_58__61__40_1_41_11001, 82);
  int argcv_meth_parser_lastLine_58__61__40_1_41_11001[] = {1};
  meth_meth_parser_lastLine_58__61__40_1_41_11001->type = alloc_MethodType(1, argcv_meth_parser_lastLine_58__61__40_1_41_11001);
  meth_meth_parser_lastLine_58__61__40_1_41_11001->definitionModule = modulename;
  meth_meth_parser_lastLine_58__61__40_1_41_11001->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num11003 = alloc_Float64(0);
// compiled num node returning num11003 (depth = 2)
  *var_lastIndent = num11003;
  if (num11003 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastIndent"
  block_savedest(self);
  Object closure11004 = createclosure(1, "lastIndent");
  setclosureframe(closure11004, stackframe);
  addtoclosure(closure11004, var_lastIndent);
  struct UserObject *uo11004 = (struct UserObject*)self;
  uo11004->data[83] = (Object)closure11004;
  Method *meth_meth_parser_lastIndent11004 = addmethod2pos(self, "lastIndent", &meth_parser_lastIndent11004, 83);
  int argcv_meth_parser_lastIndent11004[] = {0};
  meth_meth_parser_lastIndent11004->type = alloc_MethodType(1, argcv_meth_parser_lastIndent11004);
  meth_meth_parser_lastIndent11004->definitionModule = modulename;
  meth_meth_parser_lastIndent11004->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastIndent:=(_)"
  block_savedest(self);
  Object closure11005 = createclosure(1, "lastIndent:=(1)");
  setclosureframe(closure11005, stackframe);
  addtoclosure(closure11005, var_lastIndent);
  struct UserObject *uo11005 = (struct UserObject*)self;
  uo11005->data[84] = (Object)closure11005;
  Method *meth_meth_parser_lastIndent_58__61__40_1_41_11005 = addmethod2pos(self, "lastIndent:=(1)", &meth_parser_lastIndent_58__61__40_1_41_11005, 84);
  int argcv_meth_parser_lastIndent_58__61__40_1_41_11005[] = {1};
  meth_meth_parser_lastIndent_58__61__40_1_41_11005->type = alloc_MethodType(1, argcv_meth_parser_lastIndent_58__61__40_1_41_11005);
  meth_meth_parser_lastIndent_58__61__40_1_41_11005->definitionModule = modulename;
  meth_meth_parser_lastIndent_58__61__40_1_41_11005->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11007 = alloc_Boolean(0);
// compiled identifier node returning bool11007 (depth = 2)
  *var_indentFreePass = bool11007;
  if (bool11007 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "indentFreePass"
  block_savedest(self);
  Object closure11008 = createclosure(1, "indentFreePass");
  setclosureframe(closure11008, stackframe);
  addtoclosure(closure11008, var_indentFreePass);
  struct UserObject *uo11008 = (struct UserObject*)self;
  uo11008->data[85] = (Object)closure11008;
  Method *meth_meth_parser_indentFreePass11008 = addmethod2pos(self, "indentFreePass", &meth_parser_indentFreePass11008, 85);
  int argcv_meth_parser_indentFreePass11008[] = {0};
  meth_meth_parser_indentFreePass11008->type = alloc_MethodType(1, argcv_meth_parser_indentFreePass11008);
  meth_meth_parser_indentFreePass11008->definitionModule = modulename;
  meth_meth_parser_indentFreePass11008->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "indentFreePass:=(_)"
  block_savedest(self);
  Object closure11009 = createclosure(1, "indentFreePass:=(1)");
  setclosureframe(closure11009, stackframe);
  addtoclosure(closure11009, var_indentFreePass);
  struct UserObject *uo11009 = (struct UserObject*)self;
  uo11009->data[86] = (Object)closure11009;
  Method *meth_meth_parser_indentFreePass_58__61__40_1_41_11009 = addmethod2pos(self, "indentFreePass:=(1)", &meth_parser_indentFreePass_58__61__40_1_41_11009, 86);
  int argcv_meth_parser_indentFreePass_58__61__40_1_41_11009[] = {1};
  meth_meth_parser_indentFreePass_58__61__40_1_41_11009->type = alloc_MethodType(1, argcv_meth_parser_indentFreePass_58__61__40_1_41_11009);
  meth_meth_parser_indentFreePass_58__61__40_1_41_11009->definitionModule = modulename;
  meth_meth_parser_indentFreePass_58__61__40_1_41_11009->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num11011 = alloc_Float64(0);
// compiled num node returning num11011 (depth = 2)
  *var_minIndentLevel = num11011;
  if (num11011 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "minIndentLevel"
  block_savedest(self);
  Object closure11012 = createclosure(1, "minIndentLevel");
  setclosureframe(closure11012, stackframe);
  addtoclosure(closure11012, var_minIndentLevel);
  struct UserObject *uo11012 = (struct UserObject*)self;
  uo11012->data[87] = (Object)closure11012;
  Method *meth_meth_parser_minIndentLevel11012 = addmethod2pos(self, "minIndentLevel", &meth_parser_minIndentLevel11012, 87);
  int argcv_meth_parser_minIndentLevel11012[] = {0};
  meth_meth_parser_minIndentLevel11012->type = alloc_MethodType(1, argcv_meth_parser_minIndentLevel11012);
  meth_meth_parser_minIndentLevel11012->definitionModule = modulename;
  meth_meth_parser_minIndentLevel11012->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "minIndentLevel:=(_)"
  block_savedest(self);
  Object closure11013 = createclosure(1, "minIndentLevel:=(1)");
  setclosureframe(closure11013, stackframe);
  addtoclosure(closure11013, var_minIndentLevel);
  struct UserObject *uo11013 = (struct UserObject*)self;
  uo11013->data[88] = (Object)closure11013;
  Method *meth_meth_parser_minIndentLevel_58__61__40_1_41_11013 = addmethod2pos(self, "minIndentLevel:=(1)", &meth_parser_minIndentLevel_58__61__40_1_41_11013, 88);
  int argcv_meth_parser_minIndentLevel_58__61__40_1_41_11013[] = {1};
  meth_meth_parser_minIndentLevel_58__61__40_1_41_11013->type = alloc_MethodType(1, argcv_meth_parser_minIndentLevel_58__61__40_1_41_11013);
  meth_meth_parser_minIndentLevel_58__61__40_1_41_11013->definitionModule = modulename;
  meth_meth_parser_minIndentLevel_58__61__40_1_41_11013->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num11015 = alloc_Float64(0);
// compiled num node returning num11015 (depth = 2)
  *var_statementIndent = num11015;
  if (num11015 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementIndent"
  block_savedest(self);
  Object closure11016 = createclosure(1, "statementIndent");
  setclosureframe(closure11016, stackframe);
  addtoclosure(closure11016, var_statementIndent);
  struct UserObject *uo11016 = (struct UserObject*)self;
  uo11016->data[89] = (Object)closure11016;
  Method *meth_meth_parser_statementIndent11016 = addmethod2pos(self, "statementIndent", &meth_parser_statementIndent11016, 89);
  int argcv_meth_parser_statementIndent11016[] = {0};
  meth_meth_parser_statementIndent11016->type = alloc_MethodType(1, argcv_meth_parser_statementIndent11016);
  meth_meth_parser_statementIndent11016->definitionModule = modulename;
  meth_meth_parser_statementIndent11016->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementIndent:=(_)"
  block_savedest(self);
  Object closure11017 = createclosure(1, "statementIndent:=(1)");
  setclosureframe(closure11017, stackframe);
  addtoclosure(closure11017, var_statementIndent);
  struct UserObject *uo11017 = (struct UserObject*)self;
  uo11017->data[90] = (Object)closure11017;
  Method *meth_meth_parser_statementIndent_58__61__40_1_41_11017 = addmethod2pos(self, "statementIndent:=(1)", &meth_parser_statementIndent_58__61__40_1_41_11017, 90);
  int argcv_meth_parser_statementIndent_58__61__40_1_41_11017[] = {1};
  meth_meth_parser_statementIndent_58__61__40_1_41_11017->type = alloc_MethodType(1, argcv_meth_parser_statementIndent_58__61__40_1_41_11017);
  meth_meth_parser_statementIndent_58__61__40_1_41_11017->definitionModule = modulename;
  meth_meth_parser_statementIndent_58__61__40_1_41_11017->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11019 = alloc_Boolean(0);
// compiled identifier node returning bool11019 (depth = 2)
  *var_tokens = bool11019;
  if (bool11019 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "tokens"
  block_savedest(self);
  Object closure11020 = createclosure(1, "tokens");
  setclosureframe(closure11020, stackframe);
  addtoclosure(closure11020, var_tokens);
  struct UserObject *uo11020 = (struct UserObject*)self;
  uo11020->data[91] = (Object)closure11020;
  Method *meth_meth_parser_tokens11020 = addmethod2pos(self, "tokens", &meth_parser_tokens11020, 91);
  int argcv_meth_parser_tokens11020[] = {0};
  meth_meth_parser_tokens11020->type = alloc_MethodType(1, argcv_meth_parser_tokens11020);
  meth_meth_parser_tokens11020->definitionModule = modulename;
  meth_meth_parser_tokens11020->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "tokens:=(_)"
  block_savedest(self);
  Object closure11021 = createclosure(1, "tokens:=(1)");
  setclosureframe(closure11021, stackframe);
  addtoclosure(closure11021, var_tokens);
  struct UserObject *uo11021 = (struct UserObject*)self;
  uo11021->data[92] = (Object)closure11021;
  Method *meth_meth_parser_tokens_58__61__40_1_41_11021 = addmethod2pos(self, "tokens:=(1)", &meth_parser_tokens_58__61__40_1_41_11021, 92);
  int argcv_meth_parser_tokens_58__61__40_1_41_11021[] = {1};
  meth_meth_parser_tokens_58__61__40_1_41_11021->type = alloc_MethodType(1, argcv_meth_parser_tokens_58__61__40_1_41_11021);
  meth_meth_parser_tokens_58__61__40_1_41_11021->definitionModule = modulename;
  meth_meth_parser_tokens_58__61__40_1_41_11021->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile array node (depth = 2)
  Object array11023 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array11023 (depth = 2)
  *var_values = array11023;
  if (array11023 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "values"
  block_savedest(self);
  Object closure11024 = createclosure(1, "values");
  setclosureframe(closure11024, stackframe);
  addtoclosure(closure11024, var_values);
  struct UserObject *uo11024 = (struct UserObject*)self;
  uo11024->data[93] = (Object)closure11024;
  Method *meth_meth_parser_values11024 = addmethod2pos(self, "values", &meth_parser_values11024, 93);
  int argcv_meth_parser_values11024[] = {0};
  meth_meth_parser_values11024->type = alloc_MethodType(1, argcv_meth_parser_values11024);
  meth_meth_parser_values11024->definitionModule = modulename;
  meth_meth_parser_values11024->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "values:=(_)"
  block_savedest(self);
  Object closure11025 = createclosure(1, "values:=(1)");
  setclosureframe(closure11025, stackframe);
  addtoclosure(closure11025, var_values);
  struct UserObject *uo11025 = (struct UserObject*)self;
  uo11025->data[94] = (Object)closure11025;
  Method *meth_meth_parser_values_58__61__40_1_41_11025 = addmethod2pos(self, "values:=(1)", &meth_parser_values_58__61__40_1_41_11025, 94);
  int argcv_meth_parser_values_58__61__40_1_41_11025[] = {1};
  meth_meth_parser_values_58__61__40_1_41_11025->type = alloc_MethodType(1, argcv_meth_parser_values_58__61__40_1_41_11025);
  meth_meth_parser_values_58__61__40_1_41_11025->definitionModule = modulename;
  meth_meth_parser_values_58__61__40_1_41_11025->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
  *var_moduleObject = undefined;
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "moduleObject"
  block_savedest(self);
  Object closure11027 = createclosure(1, "moduleObject");
  setclosureframe(closure11027, stackframe);
  addtoclosure(closure11027, var_moduleObject);
  struct UserObject *uo11027 = (struct UserObject*)self;
  uo11027->data[95] = (Object)closure11027;
  Method *meth_meth_parser_moduleObject11027 = addmethod2pos(self, "moduleObject", &meth_parser_moduleObject11027, 95);
  int argcv_meth_parser_moduleObject11027[] = {0};
  meth_meth_parser_moduleObject11027->type = alloc_MethodType(1, argcv_meth_parser_moduleObject11027);
  meth_meth_parser_moduleObject11027->definitionModule = modulename;
  meth_meth_parser_moduleObject11027->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "moduleObject:=(_)"
  block_savedest(self);
  Object closure11028 = createclosure(1, "moduleObject:=(1)");
  setclosureframe(closure11028, stackframe);
  addtoclosure(closure11028, var_moduleObject);
  struct UserObject *uo11028 = (struct UserObject*)self;
  uo11028->data[96] = (Object)closure11028;
  Method *meth_meth_parser_moduleObject_58__61__40_1_41_11028 = addmethod2pos(self, "moduleObject:=(1)", &meth_parser_moduleObject_58__61__40_1_41_11028, 96);
  int argcv_meth_parser_moduleObject_58__61__40_1_41_11028[] = {1};
  meth_meth_parser_moduleObject_58__61__40_1_41_11028->type = alloc_MethodType(1, argcv_meth_parser_moduleObject_58__61__40_1_41_11028);
  meth_meth_parser_moduleObject_58__61__40_1_41_11028->definitionModule = modulename;
  meth_meth_parser_moduleObject_58__61__40_1_41_11028->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile member node (depth = 2)
  int callframe11030 = gc_frame_new();
// call case 5: prelude request
  Object call11031 = callmethodflags(prelude, "emptyList", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11030);
// compiled member node returning call11031 (depth = 2)
  *var_comments = call11031;
  if (call11031 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "comments"
  block_savedest(self);
  Object closure11032 = createclosure(1, "comments");
  setclosureframe(closure11032, stackframe);
  addtoclosure(closure11032, var_comments);
  struct UserObject *uo11032 = (struct UserObject*)self;
  uo11032->data[97] = (Object)closure11032;
  Method *meth_meth_parser_comments11032 = addmethod2pos(self, "comments", &meth_parser_comments11032, 97);
  int argcv_meth_parser_comments11032[] = {0};
  meth_meth_parser_comments11032->type = alloc_MethodType(1, argcv_meth_parser_comments11032);
  meth_meth_parser_comments11032->definitionModule = modulename;
  meth_meth_parser_comments11032->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "comments:=(_)"
  block_savedest(self);
  Object closure11033 = createclosure(1, "comments:=(1)");
  setclosureframe(closure11033, stackframe);
  addtoclosure(closure11033, var_comments);
  struct UserObject *uo11033 = (struct UserObject*)self;
  uo11033->data[98] = (Object)closure11033;
  Method *meth_meth_parser_comments_58__61__40_1_41_11033 = addmethod2pos(self, "comments:=(1)", &meth_parser_comments_58__61__40_1_41_11033, 98);
  int argcv_meth_parser_comments_58__61__40_1_41_11033[] = {1};
  meth_meth_parser_comments_58__61__40_1_41_11033->type = alloc_MethodType(1, argcv_meth_parser_comments_58__61__40_1_41_11033);
  meth_meth_parser_comments_58__61__40_1_41_11033->definitionModule = modulename;
  meth_meth_parser_comments_58__61__40_1_41_11033->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num11035 = alloc_Float64(0);
// compiled num node returning num11035 (depth = 2)
  *var_auto_count = num11035;
  if (num11035 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "auto_count"
  block_savedest(self);
  Object closure11036 = createclosure(1, "auto_count");
  setclosureframe(closure11036, stackframe);
  addtoclosure(closure11036, var_auto_count);
  struct UserObject *uo11036 = (struct UserObject*)self;
  uo11036->data[99] = (Object)closure11036;
  Method *meth_meth_parser_auto_count11036 = addmethod2pos(self, "auto_count", &meth_parser_auto_count11036, 99);
  int argcv_meth_parser_auto_count11036[] = {0};
  meth_meth_parser_auto_count11036->type = alloc_MethodType(1, argcv_meth_parser_auto_count11036);
  meth_meth_parser_auto_count11036->definitionModule = modulename;
  meth_meth_parser_auto_count11036->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "auto_count:=(_)"
  block_savedest(self);
  Object closure11037 = createclosure(1, "auto_count:=(1)");
  setclosureframe(closure11037, stackframe);
  addtoclosure(closure11037, var_auto_count);
  struct UserObject *uo11037 = (struct UserObject*)self;
  uo11037->data[100] = (Object)closure11037;
  Method *meth_meth_parser_auto_count_58__61__40_1_41_11037 = addmethod2pos(self, "auto_count:=(1)", &meth_parser_auto_count_58__61__40_1_41_11037, 100);
  int argcv_meth_parser_auto_count_58__61__40_1_41_11037[] = {1};
  meth_meth_parser_auto_count_58__61__40_1_41_11037->type = alloc_MethodType(1, argcv_meth_parser_auto_count_58__61__40_1_41_11037);
  meth_meth_parser_auto_count_58__61__40_1_41_11037->definitionModule = modulename;
  meth_meth_parser_auto_count_58__61__40_1_41_11037->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11039 = alloc_Boolean(0);
// compiled identifier node returning bool11039 (depth = 2)
  *var_noBlocks = bool11039;
  if (bool11039 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "noBlocks"
  block_savedest(self);
  Object closure11040 = createclosure(1, "noBlocks");
  setclosureframe(closure11040, stackframe);
  addtoclosure(closure11040, var_noBlocks);
  struct UserObject *uo11040 = (struct UserObject*)self;
  uo11040->data[101] = (Object)closure11040;
  Method *meth_meth_parser_noBlocks11040 = addmethod2pos(self, "noBlocks", &meth_parser_noBlocks11040, 101);
  int argcv_meth_parser_noBlocks11040[] = {0};
  meth_meth_parser_noBlocks11040->type = alloc_MethodType(1, argcv_meth_parser_noBlocks11040);
  meth_meth_parser_noBlocks11040->definitionModule = modulename;
  meth_meth_parser_noBlocks11040->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11041 = alloc_Boolean(1);
// compiled identifier node returning bool11041 (depth = 2)
  *var_blocksOK = bool11041;
  if (bool11041 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blocksOK"
  block_savedest(self);
  Object closure11042 = createclosure(1, "blocksOK");
  setclosureframe(closure11042, stackframe);
  addtoclosure(closure11042, var_blocksOK);
  struct UserObject *uo11042 = (struct UserObject*)self;
  uo11042->data[102] = (Object)closure11042;
  Method *meth_meth_parser_blocksOK11042 = addmethod2pos(self, "blocksOK", &meth_parser_blocksOK11042, 102);
  int argcv_meth_parser_blocksOK11042[] = {0};
  meth_meth_parser_blocksOK11042->type = alloc_MethodType(1, argcv_meth_parser_blocksOK11042);
  meth_meth_parser_blocksOK11042->definitionModule = modulename;
  meth_meth_parser_blocksOK11042->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11043 = alloc_Boolean(0);
// compiled identifier node returning bool11043 (depth = 2)
  *var_braceIsType = bool11043;
  if (bool11043 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "braceIsType"
  block_savedest(self);
  Object closure11044 = createclosure(1, "braceIsType");
  setclosureframe(closure11044, stackframe);
  addtoclosure(closure11044, var_braceIsType);
  struct UserObject *uo11044 = (struct UserObject*)self;
  uo11044->data[103] = (Object)closure11044;
  Method *meth_meth_parser_braceIsType11044 = addmethod2pos(self, "braceIsType", &meth_parser_braceIsType11044, 103);
  int argcv_meth_parser_braceIsType11044[] = {0};
  meth_meth_parser_braceIsType11044->type = alloc_MethodType(1, argcv_meth_parser_braceIsType11044);
  meth_meth_parser_braceIsType11044->definitionModule = modulename;
  meth_meth_parser_braceIsType11044->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "braceIsType:=(_)"
  block_savedest(self);
  Object closure11045 = createclosure(1, "braceIsType:=(1)");
  setclosureframe(closure11045, stackframe);
  addtoclosure(closure11045, var_braceIsType);
  struct UserObject *uo11045 = (struct UserObject*)self;
  uo11045->data[104] = (Object)closure11045;
  Method *meth_meth_parser_braceIsType_58__61__40_1_41_11045 = addmethod2pos(self, "braceIsType:=(1)", &meth_parser_braceIsType_58__61__40_1_41_11045, 104);
  int argcv_meth_parser_braceIsType_58__61__40_1_41_11045[] = {1};
  meth_meth_parser_braceIsType_58__61__40_1_41_11045->type = alloc_MethodType(1, argcv_meth_parser_braceIsType_58__61__40_1_41_11045);
  meth_meth_parser_braceIsType_58__61__40_1_41_11045->definitionModule = modulename;
  meth_meth_parser_braceIsType_58__61__40_1_41_11045->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject11047 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj11047 = alloc_userobj2(6,7, objclass11047);
  gc_frame_newslot(obj11047);
// OBJECT OUTER DEC outer
  adddatum2(obj11047, self, 0);
  addmethodreal(obj11047,"outer", &reader_parser_outer_11048);
  Object oldself11047 = self;
  struct StackFrameObject *oldstackframe11047 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe11047);
  gc_frame_newslot((Object)stackframe);
  self = obj11047;
  Object *oldselfslot11047 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter11047 = (*(struct UserObject *)self).data[0], lowerouter11047 = thisouter11047;
  if (inheritingObject11047) {
    struct UserObject *inho11047 = (struct UserObject *)inheritingObject11047;
    while (inho11047->super != GraceDefaultObject) inho11047 = (struct UserObject *)inho11047->super;
    inho11047->super = obj11047;
    self = inheritingObject11047;
    *selfslot = self;
    lowerouter11047 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter11047;
  }
if (objclass11047 == NULL) {
  Method *reader11049 = addmethodrealflags(obj11047, "kind",&reader_parser_kind_11049, MFLAG_DEF);
  reader11049->definitionModule = modulename;
  reader11049->definitionLine = 24;
}
adddatum2(obj11047, alloc_Undefined(), 1);
if (objclass11047 == NULL) {
  Method *reader11050 = addmethodrealflags(obj11047, "line",&reader_parser_line_11050, MFLAG_DEF);
  reader11050->definitionModule = modulename;
  reader11050->definitionLine = 25;
}
adddatum2(obj11047, alloc_Undefined(), 2);
if (objclass11047 == NULL) {
  Method *reader11051 = addmethodrealflags(obj11047, "linePos",&reader_parser_linePos_11051, MFLAG_DEF);
  reader11051->definitionModule = modulename;
  reader11051->definitionLine = 26;
}
adddatum2(obj11047, alloc_Undefined(), 3);
if (objclass11047 == NULL) {
  Method *reader11052 = addmethodrealflags(obj11047, "indent",&reader_parser_indent_11052, MFLAG_DEF);
  reader11052->definitionModule = modulename;
  reader11052->definitionLine = 27;
}
adddatum2(obj11047, alloc_Undefined(), 4);
if (objclass11047 == NULL) {
  Method *reader11053 = addmethodrealflags(obj11047, "value",&reader_parser_value_11053, MFLAG_DEF);
  reader11053->definitionModule = modulename;
  reader11053->definitionLine = 28;
}
adddatum2(obj11047, alloc_Undefined(), 5);
if (objclass11047 == NULL) {
  Method *reader11054 = addmethodrealflags(obj11047, "size",&reader_parser_size_11054, MFLAG_DEF);
  reader11054->definitionModule = modulename;
  reader11054->definitionLine = 29;
}
adddatum2(obj11047, alloc_Undefined(), 6);
  sourceObject = obj11047;
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit11055 == NULL) {
    strlit11055 = alloc_String("start");
    gc_root(strlit11055);
  }
// compiled string node returning strlit11055 (depth = 3)
  adddatum2(obj11047, strlit11055, 1);
  sourceObject = obj11047;
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num11056 = alloc_Float64(0);
// compiled num node returning num11056 (depth = 3)
  adddatum2(obj11047, num11056, 2);
  sourceObject = obj11047;
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num11057 = alloc_Float64(0);
// compiled num node returning num11057 (depth = 3)
  adddatum2(obj11047, num11057, 3);
  sourceObject = obj11047;
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num11058 = alloc_Float64(0);
// compiled num node returning num11058 (depth = 3)
  adddatum2(obj11047, num11058, 4);
  sourceObject = obj11047;
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit11059 == NULL) {
    strlit11059 = alloc_String("");
    gc_root(strlit11059);
  }
// compiled string node returning strlit11059 (depth = 3)
  adddatum2(obj11047, strlit11059, 5);
  sourceObject = obj11047;
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num11060 = alloc_Float64(0);
// compiled num node returning num11060 (depth = 3)
  adddatum2(obj11047, num11060, 6);
  objclass11047 = obj11047->class;
  objclass11047->definitionModule = modulename;
  objclass11047->definitionLine = 23;
  (*(struct UserObject *)self).data[0] = lowerouter11047;
  self = oldself11047;
  selfslot = oldselfslot11047;
  stackframe = oldstackframe11047;
// compiled object node returning obj11047 (depth = 2)
  *var_sym = obj11047;
  if (obj11047 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "sym"
  block_savedest(self);
  Object closure11061 = createclosure(1, "sym");
  setclosureframe(closure11061, stackframe);
  addtoclosure(closure11061, var_sym);
  struct UserObject *uo11061 = (struct UserObject*)self;
  uo11061->data[105] = (Object)closure11061;
  Method *meth_meth_parser_sym11061 = addmethod2pos(self, "sym", &meth_parser_sym11061, 105);
  int argcv_meth_parser_sym11061[] = {0};
  meth_meth_parser_sym11061->type = alloc_MethodType(1, argcv_meth_parser_sym11061);
  meth_meth_parser_sym11061->definitionModule = modulename;
  meth_meth_parser_sym11061->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "sym:=(_)"
  block_savedest(self);
  Object closure11062 = createclosure(1, "sym:=(1)");
  setclosureframe(closure11062, stackframe);
  addtoclosure(closure11062, var_sym);
  struct UserObject *uo11062 = (struct UserObject*)self;
  uo11062->data[106] = (Object)closure11062;
  Method *meth_meth_parser_sym_58__61__40_1_41_11062 = addmethod2pos(self, "sym:=(1)", &meth_parser_sym_58__61__40_1_41_11062, 106);
  int argcv_meth_parser_sym_58__61__40_1_41_11062[] = {1};
  meth_meth_parser_sym_58__61__40_1_41_11062->type = alloc_MethodType(1, argcv_meth_parser_sym_58__61__40_1_41_11062);
  meth_meth_parser_sym_58__61__40_1_41_11062->definitionModule = modulename;
  meth_meth_parser_sym_58__61__40_1_41_11062->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_sym (depth = 2)
  *var_lastToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastToken"
  block_savedest(self);
  Object closure11064 = createclosure(1, "lastToken");
  setclosureframe(closure11064, stackframe);
  addtoclosure(closure11064, var_lastToken);
  struct UserObject *uo11064 = (struct UserObject*)self;
  uo11064->data[107] = (Object)closure11064;
  Method *meth_meth_parser_lastToken11064 = addmethod2pos(self, "lastToken", &meth_parser_lastToken11064, 107);
  int argcv_meth_parser_lastToken11064[] = {0};
  meth_meth_parser_lastToken11064->type = alloc_MethodType(1, argcv_meth_parser_lastToken11064);
  meth_meth_parser_lastToken11064->definitionModule = modulename;
  meth_meth_parser_lastToken11064->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastToken:=(_)"
  block_savedest(self);
  Object closure11065 = createclosure(1, "lastToken:=(1)");
  setclosureframe(closure11065, stackframe);
  addtoclosure(closure11065, var_lastToken);
  struct UserObject *uo11065 = (struct UserObject*)self;
  uo11065->data[108] = (Object)closure11065;
  Method *meth_meth_parser_lastToken_58__61__40_1_41_11065 = addmethod2pos(self, "lastToken:=(1)", &meth_parser_lastToken_58__61__40_1_41_11065, 108);
  int argcv_meth_parser_lastToken_58__61__40_1_41_11065[] = {1};
  meth_meth_parser_lastToken_58__61__40_1_41_11065->type = alloc_MethodType(1, argcv_meth_parser_lastToken_58__61__40_1_41_11065);
  meth_meth_parser_lastToken_58__61__40_1_41_11065->definitionModule = modulename;
  meth_meth_parser_lastToken_58__61__40_1_41_11065->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lastToken (depth = 2)
  *var_previousCommentToken = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "previousCommentToken"
  block_savedest(self);
  Object closure11067 = createclosure(1, "previousCommentToken");
  setclosureframe(closure11067, stackframe);
  addtoclosure(closure11067, var_previousCommentToken);
  struct UserObject *uo11067 = (struct UserObject*)self;
  uo11067->data[109] = (Object)closure11067;
  Method *meth_meth_parser_previousCommentToken11067 = addmethod2pos(self, "previousCommentToken", &meth_parser_previousCommentToken11067, 109);
  int argcv_meth_parser_previousCommentToken11067[] = {0};
  meth_meth_parser_previousCommentToken11067->type = alloc_MethodType(1, argcv_meth_parser_previousCommentToken11067);
  meth_meth_parser_previousCommentToken11067->definitionModule = modulename;
  meth_meth_parser_previousCommentToken11067->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "previousCommentToken:=(_)"
  block_savedest(self);
  Object closure11068 = createclosure(1, "previousCommentToken:=(1)");
  setclosureframe(closure11068, stackframe);
  addtoclosure(closure11068, var_previousCommentToken);
  struct UserObject *uo11068 = (struct UserObject*)self;
  uo11068->data[110] = (Object)closure11068;
  Method *meth_meth_parser_previousCommentToken_58__61__40_1_41_11068 = addmethod2pos(self, "previousCommentToken:=(1)", &meth_parser_previousCommentToken_58__61__40_1_41_11068, 110);
  int argcv_meth_parser_previousCommentToken_58__61__40_1_41_11068[] = {1};
  meth_meth_parser_previousCommentToken_58__61__40_1_41_11068->type = alloc_MethodType(1, argcv_meth_parser_previousCommentToken_58__61__40_1_41_11068);
  meth_meth_parser_previousCommentToken_58__61__40_1_41_11068->definitionModule = modulename;
  meth_meth_parser_previousCommentToken_58__61__40_1_41_11068->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lastToken (depth = 2)
  *var_statementToken = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementToken"
  block_savedest(self);
  Object closure11070 = createclosure(1, "statementToken");
  setclosureframe(closure11070, stackframe);
  addtoclosure(closure11070, var_statementToken);
  struct UserObject *uo11070 = (struct UserObject*)self;
  uo11070->data[111] = (Object)closure11070;
  Method *meth_meth_parser_statementToken11070 = addmethod2pos(self, "statementToken", &meth_parser_statementToken11070, 111);
  int argcv_meth_parser_statementToken11070[] = {0};
  meth_meth_parser_statementToken11070->type = alloc_MethodType(1, argcv_meth_parser_statementToken11070);
  meth_meth_parser_statementToken11070->definitionModule = modulename;
  meth_meth_parser_statementToken11070->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementToken:=(_)"
  block_savedest(self);
  Object closure11071 = createclosure(1, "statementToken:=(1)");
  setclosureframe(closure11071, stackframe);
  addtoclosure(closure11071, var_statementToken);
  struct UserObject *uo11071 = (struct UserObject*)self;
  uo11071->data[112] = (Object)closure11071;
  Method *meth_meth_parser_statementToken_58__61__40_1_41_11071 = addmethod2pos(self, "statementToken:=(1)", &meth_parser_statementToken_58__61__40_1_41_11071, 112);
  int argcv_meth_parser_statementToken_58__61__40_1_41_11071[] = {1};
  meth_meth_parser_statementToken_58__61__40_1_41_11071->type = alloc_MethodType(1, argcv_meth_parser_statementToken_58__61__40_1_41_11071);
  meth_meth_parser_statementToken_58__61__40_1_41_11071->definitionModule = modulename;
  meth_meth_parser_statementToken_58__61__40_1_41_11071->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11073 = alloc_Boolean(0);
// compiled identifier node returning bool11073 (depth = 2)
  *var_comment = bool11073;
  if (bool11073 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "comment"
  block_savedest(self);
  Object closure11074 = createclosure(1, "comment");
  setclosureframe(closure11074, stackframe);
  addtoclosure(closure11074, var_comment);
  struct UserObject *uo11074 = (struct UserObject*)self;
  uo11074->data[113] = (Object)closure11074;
  Method *meth_meth_parser_comment11074 = addmethod2pos(self, "comment", &meth_parser_comment11074, 113);
  int argcv_meth_parser_comment11074[] = {0};
  meth_meth_parser_comment11074->type = alloc_MethodType(1, argcv_meth_parser_comment11074);
  meth_meth_parser_comment11074->definitionModule = modulename;
  meth_meth_parser_comment11074->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "comment:=(_)"
  block_savedest(self);
  Object closure11075 = createclosure(1, "comment:=(1)");
  setclosureframe(closure11075, stackframe);
  addtoclosure(closure11075, var_comment);
  struct UserObject *uo11075 = (struct UserObject*)self;
  uo11075->data[114] = (Object)closure11075;
  Method *meth_meth_parser_comment_58__61__40_1_41_11075 = addmethod2pos(self, "comment:=(1)", &meth_parser_comment_58__61__40_1_41_11075, 114);
  int argcv_meth_parser_comment_58__61__40_1_41_11075[] = {1};
  meth_meth_parser_comment_58__61__40_1_41_11075->type = alloc_MethodType(1, argcv_meth_parser_comment_58__61__40_1_41_11075);
  meth_meth_parser_comment_58__61__40_1_41_11075->definitionModule = modulename;
  meth_meth_parser_comment_58__61__40_1_41_11075->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11077 = alloc_Boolean(1);
// compiled identifier node returning bool11077 (depth = 2)
  *var_firstCallOfNext = bool11077;
  if (bool11077 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "firstCallOfNext"
  block_savedest(self);
  Object closure11078 = createclosure(1, "firstCallOfNext");
  setclosureframe(closure11078, stackframe);
  addtoclosure(closure11078, var_firstCallOfNext);
  struct UserObject *uo11078 = (struct UserObject*)self;
  uo11078->data[115] = (Object)closure11078;
  Method *meth_meth_parser_firstCallOfNext11078 = addmethod2pos(self, "firstCallOfNext", &meth_parser_firstCallOfNext11078, 115);
  int argcv_meth_parser_firstCallOfNext11078[] = {0};
  meth_meth_parser_firstCallOfNext11078->type = alloc_MethodType(1, argcv_meth_parser_firstCallOfNext11078);
  meth_meth_parser_firstCallOfNext11078->definitionModule = modulename;
  meth_meth_parser_firstCallOfNext11078->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "firstCallOfNext:=(_)"
  block_savedest(self);
  Object closure11079 = createclosure(1, "firstCallOfNext:=(1)");
  setclosureframe(closure11079, stackframe);
  addtoclosure(closure11079, var_firstCallOfNext);
  struct UserObject *uo11079 = (struct UserObject*)self;
  uo11079->data[116] = (Object)closure11079;
  Method *meth_meth_parser_firstCallOfNext_58__61__40_1_41_11079 = addmethod2pos(self, "firstCallOfNext:=(1)", &meth_parser_firstCallOfNext_58__61__40_1_41_11079, 116);
  int argcv_meth_parser_firstCallOfNext_58__61__40_1_41_11079[] = {1};
  meth_meth_parser_firstCallOfNext_58__61__40_1_41_11079->type = alloc_MethodType(1, argcv_meth_parser_firstCallOfNext_58__61__40_1_41_11079);
  meth_meth_parser_firstCallOfNext_58__61__40_1_41_11079->definitionModule = modulename;
  meth_meth_parser_firstCallOfNext_58__61__40_1_41_11079->definitionLine = 3399;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 80
  setline(80);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 999
  setline(999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1510
  setline(1510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1520
  setline(1520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1526
  setline(1526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1532
  setline(1532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1676
  setline(1676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1710
  setline(1710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1916
  setline(1916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1941
  setline(1941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1957
  setline(1957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2078
  setline(2078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2155
  setline(2155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2224
  setline(2224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2267
  setline(2267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2289
  setline(2289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2330
  setline(2330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2344
  setline(2344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2369
  setline(2369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2380
  setline(2380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2450
  setline(2450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2538
  setline(2538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2581
  setline(2581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2657
  setline(2657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2705
  setline(2705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2729
  setline(2729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2816
  setline(2816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2840
  setline(2840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2898
  setline(2898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2934
  setline(2934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2963
  setline(2963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2998
  setline(2998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3044
  setline(3044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3091
  setline(3091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3174
  setline(3174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3254
  setline(3254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3271
  setline(3271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3281
  setline(3281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3345
  setline(3345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3352
  setline(3352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
